	Code to create non-Gaussian simulations of the CMB
        --------------------------------------------------

Included in this distribution is:

makefile - you will need to edit this with the location of
your HEALPIX directory, f90 compiler etc

sky_ng_sim.f90 - code to simulate full-sky non-Gaussian maps
sky_ng_sim_bin.f90 - as above, but using disjoint bins in multipole
space with a different non-Gaussian being used in each bin.
sky_sub.f90 - module used by the above programs
sub_ngpdf_sho.f90 - module containing subroutines to draw
pixel values from non-Gaussian pdf based on the eigenstates
of a harmonic oscillator
sub_ngpdf_powergauss.f90 - module containing subroutines to
draw pixel values from Gaussian pdf raised to some power
(has a much greater skewness than SHO)

sky.par - example parameter file for sky_ng_sim
sky_bin.par - example parameter file for sky_ng_sim_bin


Integration in Healpix
----------------------
- in progress, sky_ng_sim and sky_ng_sin_bin will eventually be merged into a single code
- replacement of idum parameter with iseed, to be consistent with synfast.
- No pgplot, unless the preprocessing directive PGPLOT is given during compilation
examples: my_ng_sim.par   and   my_ng_sim_bin.par

module healpix_sharp_f90
use, intrinsic :: iso_c_binding
implicit none
public

interface

subroutine sharp_hp_alm2map_x_s(nside, lmax, mmax, alm, map, zbounds) bind(C, name="sharps_alm2map")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  complex(c_float), intent(in) :: alm(*)
  real(c_float), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_alm2map_x_d(nside, lmax, mmax, alm, map, zbounds) bind(C, name="sharpd_alm2map")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  complex(c_double), intent(in) :: alm(*)
  real(c_double), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_map2alm_x_s(nside, lmax, mmax, map, alm, zbounds, wgt) bind(C, name="sharps_map2alm")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  real(c_float), intent(in) :: map(*)
  complex(c_float), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

subroutine sharp_hp_map2alm_x_d(nside, lmax, mmax, map, alm, zbounds, wgt) bind(C, name="sharpd_map2alm")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  real(c_double), intent(in) :: map(*)
  complex(c_double), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

subroutine sharp_hp_alm2map_spin_x_s(nside, lmax, mmax, spin, alm, map, zbounds) bind(C, name="sharps_alm2map_spin")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax, spin
  complex(c_float), intent(in) :: alm(*)
  real(c_float), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_alm2map_spin_x_d(nside, lmax, mmax, spin, alm, map, zbounds) bind(C, name="sharpd_alm2map_spin")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax, spin
  complex(c_double), intent(in) :: alm(*)
  real(c_double), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_map2alm_spin_x_s(nside, lmax, mmax, spin, map, alm, zbounds, wgt) bind(C, name="sharps_map2alm_spin")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax, spin
  real(c_float), intent(in) :: map(*)
  complex(c_float), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

subroutine sharp_hp_map2alm_spin_x_d(nside, lmax, mmax, spin, map, alm, zbounds, wgt) bind(C, name="sharpd_map2alm_spin")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax, spin
  real(c_double), intent(in) :: map(*)
  complex(c_double), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

subroutine sharp_hp_alm2map_pol_x_s(nside, lmax, mmax, alm, map, zbounds) bind(C, name="sharps_alm2map_pol")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  complex(c_float), intent(in) :: alm(*)
  real(c_float), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_alm2map_pol_x_d(nside, lmax, mmax, alm, map, zbounds) bind(C, name="sharpd_alm2map_pol")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  complex(c_double), intent(in) :: alm(*)
  real(c_double), intent(out) :: map(*)
  real(c_double), intent(in) :: zbounds(*)
end subroutine

subroutine sharp_hp_map2alm_pol_x_s(nside, lmax, mmax, map, alm, zbounds, wgt) bind(C, name="sharps_map2alm_pol")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  real(c_float), intent(in) :: map(*)
  complex(c_float), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

subroutine sharp_hp_map2alm_pol_x_d(nside, lmax, mmax, map, alm, zbounds, wgt) bind(C, name="sharpd_map2alm_pol")
  use iso_c_binding
  integer(c_int), intent(in), value :: nside, lmax, mmax
  real(c_double), intent(in) :: map(*)
  complex(c_double), intent(out) :: alm(*)
  real(c_double), intent(in) :: zbounds(*)
  real(c_double), intent(in) :: wgt(*)
end subroutine

end interface

end module

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
! template for routine SP/DP overloading for module mpi_alm_tools

! K M A P   : map kind                 either SP or DP
! K A L M C : alm kind (complex)       either SPC or DPC
! K A L M   : alm related and cl kind  either SP or DP
!
! K L O A D : suffix of routine name, to be replaced by either s (SP) or d (DP)
!
!


  subroutine mpi_map2alm_simple_KLOAD(comm_in, map, alms, zbounds_in, w8ring)
    implicit none
    
    integer(i4b),                        intent(in)           :: comm_in
    real(KMAP),     dimension(0:,1:),    intent(in)           :: map
    complex(KALMC), dimension(1:,0:,0:), intent(out)          :: alms
    real(dp),       dimension(2),        intent(in), optional :: zbounds_in
    real(dp),       dimension(1:,1:),    intent(in), optional :: w8ring

    integer(i4b) :: myid_int, nmaps_int, npix_int, nsmax_in, nlmax_in, nmmax_in
    integer(i4b) :: precompute_plms_in
    logical(lgt) :: polarization_in
    real(dp),              dimension(2)   :: zbounds_int
    real(dp), allocatable, dimension(:,:) :: w8ring_int

    call mpi_comm_rank(comm_in, myid_int, ierr)

    if (myid_int == root) then

       npix_int   = size(map(:,1))
       nmaps_int  = size(map(0,:))
       nsmax_in   = nint(sqrt(real(npix_int,sp)/12.))
       nlmax_in   = size(alms(1,:,0))-1
       nmmax_in   = nlmax_in
       if (nmaps_int == 3) then
          polarization_in = .true.
       else
          polarization_in = .false.
       end if
       precompute_plms_in = 0
       
       allocate(w8ring_int(1:2*nsmax_in,nmaps_int))
       if (present(w8ring)) then
          w8ring_int = w8ring
       else
          w8ring_int = 1.d0
       end if
       
       if (present(zbounds_in)) then
          zbounds_int = zbounds_in
       else
          zbounds_int = 0.d0
       end if

       call mpi_initialize_alm_tools(comm_in, nsmax_in, nlmax_in, &
            & nmmax_in, zbounds_int, polarization_in, precompute_plms_in, &
            & w8ring_int)

       call mpi_map2alm(map, alms)

       deallocate(w8ring_int)

    else

       call mpi_initialize_alm_tools(comm_in)

       call mpi_map2alm_slave

    end if

    call mpi_cleanup_alm_tools

  end subroutine mpi_map2alm_simple_KLOAD


  subroutine mpi_alm2map_simple_KLOAD(comm_in, alms, map)
    implicit none
    
    integer(i4b),                        intent(in)  :: comm_in
    complex(KALMC), dimension(1:,0:,0:), intent(in)  :: alms
    real(KMAP),     dimension(0:,1:),    intent(out) :: map

    integer(i4b) :: myid_int, npix_int, nmaps_int, nsmax_in, nlmax_in, nmmax_in
    integer(i4b) :: precompute_plms_in
    logical(lgt) :: polarization_in
    real(dp),     allocatable, dimension(:,:)  :: w8ring_int
    real(dp),     dimension(2)                 :: zbounds_int

    call mpi_comm_rank(comm_in, myid_int, ierr)

    if (myid_int == root) then

       nmaps_int   = size(map(0,:))
       npix_int    = size(map(:,1))
       nsmax_in    = nint(sqrt(real(npix_int,sp)/12.))
       nlmax_in    = size(alms(1,:,0))-1
       nmmax_in    = nlmax_in
       zbounds_int = 0.d0
       if (nmaps_int == 3) then
          polarization_in = .true.
       else
          polarization_in = .false.
       end if
       precompute_plms_in = 0
       
       allocate(w8ring_int(1:2*nsmax_in,nmaps_int))
       w8ring_int = 1.d0

       call mpi_initialize_alm_tools(comm_in, nsmax_in, nlmax_in, &
            & nmmax_in, zbounds_int, polarization_in, precompute_plms_in, &
            & w8ring_int)

       call mpi_alm2map(alms, map)

       deallocate(w8ring_int)

    else

       call mpi_initialize_alm_tools(comm_in)

       call mpi_alm2map_slave

    end if

    call mpi_cleanup_alm_tools

  end subroutine mpi_alm2map_simple_KLOAD



  ! ***************************************************************
  !            Wrappers for the computational routines
  ! ***************************************************************

  subroutine mpi_map2alm_KLOAD(map, alms)
    implicit none

    real(KMAP),     dimension(0:,1:),    intent(in)  :: map
    complex(KALMC), dimension(1:,0:,0:), intent(out) :: alms

    call distribute_map(map)

    local_alms = cmplx(0.d0,0.d0)
    alms_work  = cmplx(0.d0,0.d0)
    
    if (polarization) then
       ! Polarization routines
       if (precompute_plms == 1) then
          call mpi_map2alm_pol_pre1
       else if (precompute_plms == 2) then
          call mpi_map2alm_pol_pre2
       else
          call mpi_map2alm_pol
       end if
    else
       ! Temperature routines
       if (precompute_plms == 1 .or. precompute_plms == 2) then
          call mpi_map2alm_sc_pre
       else
          call mpi_map2alm_sc
       end if
    end if

    call mpi_reduce(local_alms, alms_work, size(local_alms), &
         & MPI_DOUBLE_COMPLEX, MPI_SUM, root, comm, ierr) 

    alms = alms_work

  end subroutine mpi_map2alm_KLOAD


  subroutine mpi_alm2map_KLOAD(alms, map)
    implicit none

    complex(KALMC), dimension(1:,0:,0:), intent(in)  :: alms
    real(KMAP),     dimension(0:,1:),    intent(out) :: map

    local_alms = alms

    call mpi_bcast(local_alms, size(local_alms), MPI_DOUBLE_COMPLEX, root, comm, ierr)

    if (polarization) then
       ! Polarization routines
       if (precompute_plms == 1) then
          call mpi_alm2map_pol_pre1
       else if (precompute_plms == 2) then
          call mpi_alm2map_pol_pre2
       else
          call mpi_alm2map_pol
       end if
    else
       ! Temperature routines
       if (precompute_plms == 1 .or. precompute_plms == 2) then
          call mpi_alm2map_sc_pre
       else
          call mpi_alm2map_sc
       end if
    end if

    call gather_map(map)

  end subroutine mpi_alm2map_KLOAD



  ! ***************************************************************
  !                Internal distribution routines
  ! ***************************************************************


  subroutine distribute_map_KLOAD(map)
    ! Distributes the map data
    implicit none

    real(KMAP), dimension(0:,1:), intent(in)  :: map

    integer(i4b) :: i, seg_size, ierr
    integer(i4b), dimension(MPI_STATUS_SIZE) :: status
 
    !Process 0 distributes the map data to the other proc's
    do i = 1, numprocs-1
       
       if (num_segments(i) == 2) then
          
          seg_size = segments(0,1,i)-segments(0,0,i)+1

          buffer(0:seg_size-1,1:nmaps) = &
               & real(map(segments(0,0,i):segments(0,1,i),1:nmaps),dp)
          buffer(seg_size:2*seg_size-1,1:nmaps) = &
               & real(map(segments(1,0,i):segments(1,1,i),1:nmaps),dp)
          call mpi_send(buffer(0:2*seg_size-1,1:nmaps), &
               & 2*seg_size*nmaps, MPI_DOUBLE_PRECISION, i, 90, comm, ierr)
          
       else !Equatorial section -> only 1 segment
          
          seg_size = segments(0,1,i)-segments(0,0,i)+1

          buffer(0:seg_size-1,1:nmaps) = real(map(segments(0,0,i):segments(0,1,i),1:nmaps),dp)
          call mpi_send(buffer(0:seg_size-1,1:nmaps), &
               & seg_size*nmaps, MPI_DOUBLE_PRECISION, i, 90, comm, ierr)
          
       end if
       
    end do
    
    if (num_segments(0) == 2) then

       seg_size = segments(0,1,0)-segments(0,0,0)+1

       local_map(0:seg_size-1,1:nmaps) = &
            & real(map(segments(0,0,0):segments(0,1,0),1:nmaps),dp)
       local_map(seg_size:2*seg_size-1,1:nmaps) = &
            & real(map(segments(1,0,0):segments(1,1,0),1:nmaps),dp)

    else

       seg_size = segments(0,1,0)-segments(0,0,0)+1
       local_map(0:seg_size-1,1:nmaps) = &
            & real(map(segments(0,0,0):segments(0,1,0),1:nmaps),dp)

    end if

  end subroutine distribute_map_KLOAD


  subroutine gather_map_KLOAD(map)
    ! Gathers the map data
    implicit none

    real(KMAP), dimension(0:,1:), intent(out) :: map

    integer(i4b) :: i, seg_size, ierr, maxsize
    integer(i4b), dimension(MPI_STATUS_SIZE)  :: status

    !Process 0 recieves data from the other proc's
    do i=1,numprocs-1
          
       if (num_segments(i) == 2) then
          
          seg_size = segments(0,1,i)-segments(0,0,i)+1

          call mpi_recv(buffer(0:2*seg_size-1,1:nmaps), &
               & 2*seg_size*nmaps, MPI_DOUBLE_PRECISION, i, 91, comm, status, ierr)
          map(segments(0,0,i):segments(0,1,i),1:nmaps) = &
               & real(buffer(0:seg_size-1,1:nmaps),KMAP)
          map(segments(1,0,i):segments(1,1,i),1:nmaps) = &
               & real(buffer(seg_size:2*seg_size-1,1:nmaps),KMAP)
          
       else !Equatorial section -> only 1 segment
          
          seg_size = segments(0,1,i)-segments(0,0,i)+1

          call mpi_recv(buffer(0:seg_size-1,1:nmaps), &
               & seg_size*nmaps, MPI_DOUBLE_PRECISION, i, 91, comm, status, ierr)
          map(segments(0,0,i):segments(0,1,i),1:nmaps) = real(buffer(0:seg_size-1,1:nmaps),KMAP)
          
       end if
       
    end do
    
    if (num_segments(0) == 2) then
       
       seg_size = segments(0,1,0)-segments(0,0,0)+1

       map(segments(0,0,0):segments(0,1,0),1:nmaps) = &
            & real(local_map(0:seg_size-1,1:nmaps),KMAP)       
       map(segments(1,0,0):segments(1,1,0),1:nmaps) = &         
            & real(local_map(seg_size:2*seg_size-1,1:nmaps),KMAP)
       
    else
       
       seg_size = segment(0,1)-segment(0,0)+1
       map(segment(0,0):segment(0,1),1:nmaps) = real(local_map(0:seg_size-1,1:nmaps),KMAP)
       
    end if

  end subroutine gather_map_KLOAD

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module pix_tools
!==================================================================
!    Various subroutines for converting angles and unit vectors
!    to pixel numbers in both the NESTED and RING schemes,
!    as well as looking for neighbours and making pixel queries
!
!    last update : Oct 4, 2002, EH, computation of pixel vertex in
!        pix2vec_ring and pix2vec_nest
!    2004-05-28, EH: edition of next_in_line_nest for nside=1
!                    addition of optional 'mask' in remove_dipole
!    2004-06-01      correction of bug at low phi in in_ring
!    2004-08-25      added multi-D convert_inplace_* and convert_nest2ring, convert_ring2nest
!    2004-10-07      added template_pixel_*, same_shape_pixels_*
!    2004-12-15      generic forms for convert_inplace (I,R,D with 1 or N dimensions), 
!                     remove_dipole (R,D)
!    2005-01-25      ensure backward compatibility of remove_dipole
!    2005-08-03      edit same_shape_pixels_nest to comply with GFORTRAN
!    2006-06-28      edit to neighbours_nest to correct error in Nside=1 case
!    2008-02-03:     addition of weights in remove dipole
!    2008-02-04:     check ordering in [1,2] in remove dipole ; check nest in [0,1] in query_*
!    2008-03-28:     edit ring_num and query_strip to improve inclusive query_strip
!                    bug fix on query_disc
!    2009-03-04:     starts supporting 64-bit npix
!              largest supported Nside is now 2^28 instead of 2^13
!             Note: the theoretical limit Nside=2^29 is not implemented to avoid
!               dealing with too many 64 bit integer variables that slow down execution
!    2011-08-25 : 2011-08-*: improves accuracy of pixel routines close to Poles
!    2011-10-13: improved query_triangle, introduced process_intervals
!    2012-07-17: Parallel OpenMP implementation of medfiltmap
!    2012-08-27: correction of a bug affecting neighbours_nest and next_in_line_nest at Nside>8192
!    2013-04-02: bug correction in query_disc in inclusive mode
!    2013-05-07: G95-compatible
!    2015-09-02: added nest2uniq, uniq2nest
!    2018-05-22: added nside2npweights
!    2018-10-22: added apply_mask
!==================================================================
  ! subroutine query_strip                          Done (To be Tested) depends on in_ring
  ! subroutine query_polygon                        Done (To be Tested) depends on isort
  ! subroutine query_triangle                       Done (To be Tested)
  ! subroutine getdisc_ring                         Done depends on query_disc
  ! subroutine query_disc                           Done (To be Tested)
  ! function ring_num                                     OK
  ! function ring2z                                 Done  
  ! subroutine in_ring                              Done (To be Tested) depends in next_in_line_nest
  ! subroutine intrs_intrv                                OK
  ! subroutine process_intervals               ok
  ! function fudge_query_radius                ok
  !!!!!! subroutine correct_ring_phi                           OK
  !                                         
  ! subroutine pix2ang_ring                          Done  
  ! subroutine pix2vec_ring                          Done  
  ! subroutine ang2pix_ring                          Done  
  ! subroutine vec2pix_ring                          Done  
  ! subroutine ang2pix_nest                          Done  
  ! subroutine vec2pix_nest                          Done  
  ! subroutine nest2ring                             Done  
  ! subroutine ring2nest                             Done  
  ! function npix2nside                              Done  
  !                                         
  ! subroutine warning_oldbounds                           OK
  ! subroutine remove_dipole_real                    Done depends on query_strip
  ! subroutine remove_dipole_double                  Done
  ! subroutine remove_dipole_real_old                Done
  ! subroutine remove_dipole_double_old              Done
  ! subroutine remove_dipole_real_v12                Done
  ! subroutine remove_dipole_double_v12              Done
  ! subroutine add_dipole_real                      Done  
  ! subroutine add_dipole_double                    Done  
  ! subroutine medfiltmap_S                         Done (To be tested)
  ! subroutine medfiltmap_D                         Done (To be tested)

  ! subroutine convert_nest2ring_int_1d             Done
  ! subroutine convert_nest2ring_int8_1d            Done
  ! subroutine convert_nest2ring_real_1d            Done
  ! subroutine convert_nest2ring_double_1d          Done      
  ! subroutine convert_ring2nest_int_1d             Done
  ! subroutine convert_ring2nest_int8_1d            Done
  ! subroutine convert_ring2nest_real_1d            Done
  ! subroutine convert_ring2nest_double_1d          Done
  ! subroutine convert_nest2ring_int_nd             Done
  ! subroutine convert_nest2ring_int8_nd            Done
  ! subroutine convert_nest2ring_real_nd            Done
  ! subroutine convert_nest2ring_double_nd          Done      
  ! subroutine convert_ring2nest_int_nd             Done
  ! subroutine convert_ring2nest_int8_nd            Done
  ! subroutine convert_ring2nest_real_nd            Done
  ! subroutine convert_ring2nest_double_nd          Done
  !
  ! subroutine convert_inplace_int_1d               Done (to be tested)
  ! subroutine convert_inplace_real_1d              Done (to be tested)
  ! subroutine convert_inplace_double_1d            Done (to be tested)
  ! subroutine convert_inplace_int_nd               Done (to be tested)
  ! subroutine convert_inplace_real_nd              Done (to be tested)
  ! subroutine convert_inplace_double_nd            Done (to be tested)
  !
  ! subroutine xy2pix_nest                          Done (to be tested)               
  ! subroutine pix2xy_nest                          Done (to be tested)
  ! subroutine mk_pix2xy                                  OK
  ! subroutine mk_xy2pix                                  OK
  ! subroutine mk_xy2pix1                                 OK
  ! subroutine neighbours_nest                      Done (to be tested)               
  ! subroutine next_in_line_nest                          Done  depends on xy2pix_nest pix2xy_nest             
  ! subroutine ang2vec                                    OK
  ! subroutine vec2ang                                    OK
  ! function nside2npix                            Done  
  ! subroutine surface_triangle                           OK
  ! subroutine angdist                                    OK
  ! subroutine vect_prod                                  OK
  ! function nside2ntemplates                       Done
  ! subroutine template_pixel_ring                  Done (to be tested)               
  ! subroutine same_shape_pixels_ring               Done (to be tested)               
  ! subroutine template_pixel_nest                  Done (to be tested)               
  ! subroutine same_shape_pixels_nest               Done (to be tested)
! 
! 2011-08-*: improves accuracy close to Poles
! ang2pix_nest  small
! ang2pix_ring  small
! ang2vec     OK      
! angdist     Done  
! pix2ang_nest  small, kshift
! pix2ang_ring  isqrt, small 
! pix2vec_nest  small,  [kshift TODO]
! pix2vec_ring  isqrt, small
! cheap_isqrt Added     
! vec2ang     Done
! vec2pix_nest  small
! vec2pix_ring  small
! ring2nest     isqrt

  USE healpix_types
  USE misc_utils
  USE long_intrinsic, only: long_size
  IMPLICIT none

  INTEGER(KIND=i4b), private, PARAMETER :: ns_max4=8192     ! 2^13
  INTEGER(KIND=i4b), private, PARAMETER :: ns_max8=268435456! 2^28
#ifdef NO64BITS
  INTEGER(KIND=i4b), private, PARAMETER :: ns_max=ns_max4 ! largest nside available
#else
  INTEGER(KIND=i4b), private, PARAMETER :: ns_max=ns_max8 ! largest nside available
#endif

  !initialise array x2pix, y2pix and pix2x, pix2y used in several routines
!  integer(KIND=i4b), private, save, dimension(128) :: x2pix=0,y2pix=0
  integer(KIND=i4b), private, save, dimension(0:127) :: x2pix1=-1,y2pix1=-1

  integer(KIND=i4b), private, save, dimension(0:1023) :: pix2x=-1, pix2y=-1

  ! coordinate of the lowest corner of each face
  INTEGER(KIND=I4B), private, save, dimension(0:11) :: jrll1 = (/ 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4 /) ! in unit of nside
  INTEGER(KIND=I4B), private, save, dimension(0:11) :: jpll1 = (/ 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7 /) ! in unit of nside/2

  ! obsolete
  interface convert_inplace_real
     module procedure convert_inplace_real_1d, convert_inplace_real_nd
  end interface 
  interface convert_inplace_int
     module procedure convert_inplace_int_1d, convert_inplace_int_nd
  end interface 

  ! generic form
  interface convert_inplace
     module procedure convert_inplace_real_1d, convert_inplace_real_nd, &
          &           convert_inplace_int_1d, convert_inplace_int_nd, &
          &           convert_inplace_double_1d, convert_inplace_double_nd
  end interface 

  interface remove_dipole
     module procedure remove_dipole_real, remove_dipole_double, &
          &           remove_dipole_real_old, remove_dipole_double_old, &
          &           remove_dipole_real_v12, remove_dipole_double_v12
  end interface

  interface add_dipole
     module procedure add_dipole_real, add_dipole_double
  end interface

  interface apply_mask
     module procedure apply_mask_real, apply_mask_double
  end interface

  interface convert_nest2ring
     module procedure convert_nest2ring_int_1d, &
          &           convert_nest2ring_real_1d, &
          &           convert_nest2ring_double_1d, &
          &           convert_nest2ring_int_nd, &
          &           convert_nest2ring_real_nd, &
          &           convert_nest2ring_double_nd
#ifndef NO64BITS
     module procedure convert_nest2ring_int8_1d, &
          convert_nest2ring_int8_nd
#endif
  end interface 

  interface convert_ring2nest
     module procedure convert_ring2nest_int_1d, &
          &           convert_ring2nest_real_1d, &
          &           convert_ring2nest_double_1d, &
          &           convert_ring2nest_int_nd, &
          &           convert_ring2nest_real_nd, &
          &           convert_ring2nest_double_nd
#ifndef NO64BITS
     module procedure convert_ring2nest_int8_1d, &
          convert_ring2nest_int8_nd
#endif
  end interface 

  interface medfiltmap
     module procedure medfiltmap_s, medfiltmap_d
  end interface 

#ifdef NO64BITS
  interface npix2nside
     module procedure npix2nside
  end interface
  interface ang2pix_nest
     module procedure ang2pix_nest
  end interface
  interface vec2pix_nest
     module procedure vec2pix_nest
  end interface
  interface ang2pix_ring
     module procedure ang2pix_ring
  end interface
  interface vec2pix_ring
     module procedure vec2pix_ring
  end interface
  interface ring2nest
     module procedure ring2nest
  end interface
  interface nest2ring
     module procedure nest2ring
  end interface
  interface pix2ang_ring
     module procedure pix2ang_ring
  end interface
  interface pix2vec_ring
     module procedure pix2vec_ring
  end interface
  interface pix2ang_nest
     module procedure pix2ang_nest
  end interface
  interface pix2vec_nest
     module procedure pix2vec_nest
  end interface
  interface in_ring
     module procedure in_ring
  end interface
  interface getdisc_ring
     module procedure getdisc_ring
  end interface
  interface query_strip
     module procedure query_strip
  end interface
  interface query_disc_old ! <<<<<<<<<<<<<<<<<<<<<<
     module procedure query_disc_old
  end interface
  interface query_disc
     module procedure query_disc
  end interface
  interface query_polygon
     module procedure query_polygon
  end interface
  interface query_triangle
     module procedure query_triangle
  end interface
  interface xy2pix_nest
     module procedure xy2pix_nest
  end interface
  interface pix2xy_nest
     module procedure pix2xy_nest
  end interface
  interface neighbours_nest
     module procedure neighbours_nest
  end interface
  interface next_in_line_nest
     module procedure next_in_line_nest
  end interface
  interface template_pixel_ring
     module procedure template_pixel_ring
  end interface
  interface same_shape_pixels_ring
     module procedure same_shape_pixels_ring
  end interface
  interface template_pixel_nest
     module procedure template_pixel_nest
  end interface
  interface same_shape_pixels_nest
     module procedure same_shape_pixels_nest
  end interface
  interface cheap_isqrt
     module procedure cheap_isqrt_4
  end interface
  interface discedge2fulldisc
     module procedure discedge2fulldisc
  end interface
  interface nest2uniq
     module procedure nest2uniq
  end interface
  interface uniq2nest
     module procedure uniq2nest
  end interface
#else
  interface npix2nside
     module procedure npix2nside, npix2nside_8
  end interface
  interface ang2pix_nest
     module procedure ang2pix_nest, ang2pix_nest_8
  end interface
  interface vec2pix_nest
     module procedure vec2pix_nest, vec2pix_nest_8
  end interface
  interface ang2pix_ring
     module procedure ang2pix_ring, ang2pix_ring_8
  end interface
  interface vec2pix_ring
     module procedure vec2pix_ring, vec2pix_ring_8
  end interface
  interface ring2nest
     module procedure ring2nest, ring2nest_8
  end interface
  interface nest2ring
     module procedure nest2ring, nest2ring_8
  end interface
  interface pix2ang_ring
     module procedure pix2ang_ring, pix2ang_ring_8
  end interface
  interface pix2vec_ring
     module procedure pix2vec_ring, pix2vec_ring_8
  end interface
  interface pix2ang_nest
     module procedure pix2ang_nest, pix2ang_nest_8
  end interface
  interface pix2vec_nest
     module procedure pix2vec_nest, pix2vec_nest_8
  end interface
  interface in_ring
     module procedure in_ring, in_ring_8
  end interface
  interface getdisc_ring
     module procedure getdisc_ring, getdisc_ring_8
  end interface
  interface query_strip
     module procedure query_strip, query_strip_8
  end interface
  interface query_disc_old ! <<<<<<<<<<<<<<<<<<<<<<
     module procedure query_disc_old, query_disc_old_8
  end interface
  interface query_disc
     module procedure query_disc, query_disc_8
  end interface
  interface query_polygon
     module procedure query_polygon, query_polygon_8
  end interface
  interface query_triangle
     module procedure query_triangle, query_triangle_8
  end interface
  interface xy2pix_nest
     module procedure xy2pix_nest, xy2pix_nest_8
  end interface
  interface pix2xy_nest
     module procedure pix2xy_nest, pix2xy_nest_8
  end interface
  interface neighbours_nest
     module procedure neighbours_nest, neighbours_nest_8
  end interface
  interface next_in_line_nest
     module procedure next_in_line_nest, next_in_line_nest_8
  end interface
  interface template_pixel_ring
     module procedure template_pixel_ring, template_pixel_ring_8
  end interface
  interface same_shape_pixels_ring
     module procedure same_shape_pixels_ring, same_shape_pixels_ring_8
  end interface
  interface template_pixel_nest
     module procedure template_pixel_nest, template_pixel_nest_8
  end interface
  interface same_shape_pixels_nest
     module procedure same_shape_pixels_nest, same_shape_pixels_nest_8
  end interface
  interface cheap_isqrt
     module procedure cheap_isqrt_4, cheap_isqrt_8
  end interface
  interface discedge2fulldisc
     module procedure discedge2fulldisc, discedge2fulldisc_8
  end interface
  interface nest2uniq
     module procedure nest2uniq, nest2uniq_8
  end interface
  interface uniq2nest
     module procedure uniq2nest, uniq2nest_8
  end interface
#endif

  private

  public :: remove_dipole, add_dipole, &
       & query_strip, &
       & query_polygon, &
       & query_triangle, &
       & query_disc, &
       & pix2ang_ring, pix2vec_ring, ang2pix_ring, vec2pix_ring, &
       & pix2ang_nest, pix2vec_nest, ang2pix_nest, vec2pix_nest, &
       & convert_nest2ring, convert_ring2nest, &
       & convert_inplace, convert_inplace_real, convert_inplace_int, &
       & nest2ring, ring2nest, xy2pix_nest, pix2xy_nest, &
!!!       & mk_pix2xy, mk_xy2pix, &
       & neighbours_nest, &
       & next_in_line_nest, &
       & ang2vec, vec2ang, &
       & npix2nside, nside2npix, &
       & surface_triangle, angdist, vect_prod

!   public :: ang2pix_nest_old, vec2pix_nest_old, &
!        ang2pix_ring_old, vec2pix_ring_old, &
!        ring2nest_old, nest2ring_old, &
!        pix2ang_ring_old, pix2vec_ring_old, &
!        pix2ang_nest_old, pix2vec_nest_old, &
!        template_pixel_ring_old, same_shape_pixels_ring_old, &
!        template_pixel_nest_old, same_shape_pixels_nest_old

  public :: query_disc_old

  public :: nside2ntemplates, &
       & template_pixel_ring, same_shape_pixels_ring, &
       & template_pixel_nest, same_shape_pixels_nest

  public :: medfiltmap

  public :: intrs_intrv, in_ring, ring_num, ring2z ! arcane usage
  public :: cheap_isqrt
  public :: process_intervals, fudge_query_radius, discphirange_at_z

  public :: getdisc_ring  ! obsolete

  public :: nest2uniq, uniq2nest

  public :: nside2npweights

  public :: apply_mask


contains


!   !=======================================================================
!   function discphirange_at_z (vcenter, radius, z, phi0) result(dphi)
!     !=======================================================================
!     !  for a disc centered on  vcenter and given radius,
!     !  and for location z=cos(theta)
!     !  returns dphi such that the disc has   abs(phi-phi0) <= dphi
!     !
!     ! solving disc equation on sphere:
!     !  sin(theta) sin(theta0) cos(phi-phi0) + cos(theta) cos(theta0) >= cos(radius)
!     !
!     ! 2011-06-21: adapted from IDL routine of same name
!     !=======================================================================
!     real(DP), dimension(1:), intent(in)      :: vcenter
!     real(DP),                intent(in)      :: radius, z
!     real(DP),                intent(out)     :: phi0
!     real(DP) :: dphi 
!     !
!     real(DP) :: cosang, cosdphi, norm, x0, y0, z0, st0, diff, st
!     real(DP), parameter :: zero=0.0_dp, one=1.0_dp

!     cosang = cos(radius)
!     norm = sqrt(sum(vcenter(1:3)**2))
!     x0 = vcenter(1) / norm
!     y0 = vcenter(2) / norm
!     z0 = vcenter(3) / norm

!     phi0 = zero
!     if ((x0 /= zero) .or. (y0 /= zero)) phi0 = atan2(y0, x0)

!     st0 = x0*x0 + y0*y0 ! sin(theta0)^2
!     diff = cosang - z*z0 ! cos(rad) - cos(theta)cos(theta0)
    
!     dphi = -1000.0_dp ! out of disc
!     if (st0 == zero) then ! polar cap
!        if (diff <= zero) dphi = PI ! fully in cap
!     else
!        st = max(one - z*z, 1.0e-12_dp)! sin(theta)^2
!        cosdphi = diff/sqrt(st0*st)
!        if (cosdphi < -one) dphi = PI ! fully in disc
!        if (abs(cosdphi) <= one) dphi = acos(cosdphi)
!     endif

!   end function discphirange_at_z
  !=======================================================================
  function ring_num (nside, z, shift) result(ring_num_result)
    !=======================================================================
    ! ring = ring_num(nside, z [, shift=])
    !     returns the ring number in {1, 4*nside-1}
    !     from the z coordinate
    ! usually returns the ring closest to the z provided
    ! if shift < 0, returns the ring immediatly north (of smaller index) of z
    ! if shift > 0, returns the ring immediatly south (of smaller index) of z
    !
    !=======================================================================
    INTEGER(KIND=I4B)             :: ring_num_result
    REAL(KIND=DP),     INTENT(IN) :: z
    INTEGER(KIND=I4B), INTENT(IN) :: nside
    integer(i4b),      intent(in), optional :: shift

    INTEGER(KIND=I4B) :: iring
    real(DP) :: my_shift
    !=======================================================================


    my_shift = 0.0_dp
    if (present(shift)) my_shift = shift * 0.5_dp

    !     ----- equatorial regime ---------
    iring = NINT( nside*(2.0_dp-1.500_dp*z)   + my_shift )

    !     ----- north cap ------
    if (z > twothird) then
       iring = NINT( nside* SQRT(3.0_dp*(1.0_dp-z))  + my_shift )
       if (iring == 0) iring = 1
    endif

    !     ----- south cap -----
    if (z < -twothird   ) then
       ! beware that we do a -shift in the south cap
       iring = NINT( nside* SQRT(3.0_dp*(1.0_dp+z))   - my_shift )
       if (iring == 0) iring = 1
       iring = 4*nside - iring
    endif

    ring_num_result = iring

    return
  end function ring_num
  !=======================================================================
  function ring2z (nside, ir) result(z)
    !=======================================================================
    !     returns the z coordinate of ring ir for Nside
    ! 2009-03-25: accepts Nside > 8192
    !=======================================================================
    integer(kind=I4B), intent(in) :: ir
    integer(kind=I4B), intent(in) :: nside
    real(kind=DP)                 :: z

    real(DP)     :: fn, tmp
    !=======================================================================

    fn = real(nside,kind=DP)

    if (ir < nside) then  ! polar cap (north)
       tmp = real(ir, DP)
       z = 1.0_dp - (tmp * tmp) / (3.0_dp * fn * fn)
    else if (ir < 3*nside) then ! tropical band
       z = real( 2*nside-ir, kind=DP) * 2.0_dp / (3.0_dp * fn)
    else                  ! polar cap (south)
       tmp = real(4*nside - ir, DP)
       z = -1.0_dp + (tmp * tmp) / (3.0_dp * fn * fn)
    endif
    
    return
  end function ring2z
  !=======================================================================
  subroutine intrs_intrv( d1, d2, di, ni)
    !=======================================================================
    ! computes the intersection di
    ! of 2 intervals d1 (= [a1,b1]) and d2 (= [a2,b2])
    ! on the periodic domain ( = [A,B], where A and B are arbitrary)
    ! ni is the resulting number of intervals (0,1, or 2)
    !
    ! if a1<b1 then d1 = {x | a1 <= x <= b1}
    ! if a1>b1 then d1 = {x | a1 <= x <= B  U  A <= x <= b1}
    !=======================================================================
    real(kind=DP), dimension(1:), INTENT(IN)  :: d1, d2
    real(kind=DP), dimension(1:), INTENT(OUT) :: di
    integer(kind=I4B), INTENT(OUT) :: ni

    real(kind=DP), dimension(1:4) :: dk
    integer(kind=I4B) :: ik
    logical(kind=LGT) :: tr12, tr21, tr34, tr43, tr13, tr31, tr24, tr42, tr14, tr32
    !=======================================================================

    tr12 = (d1(1) < d1(2))
    tr21 = .NOT. tr12
    tr34 = (d2(1) < d2(2))
    tr43 = .NOT. tr34
    tr13 = (d1(1) < d2(1))
    tr31 = .NOT. tr13
    tr24 = (d1(2) < d2(2))
    tr42 = .NOT. tr24
    tr14 = (d1(1) < d2(2))
    tr32 = (d2(1) < d1(2))

    ik = 0
    dk(1:4) = -1.0e9_dp


    if ((tr31.AND.tr14) .OR. (tr43.AND.(tr31.OR.tr14))) then
       ik = ik + 1
       dk(ik) = d1(1)  ! a1
    endif
    if ((tr13.AND.tr32) .OR. (tr21.AND.(tr13.OR.tr32))) then
       ik = ik + 1
       dk(ik) = d2(1)  ! a2
    endif
    if ((tr32.AND.tr24) .OR. (tr43.AND.(tr32.OR.tr24))) then
       ik = ik + 1
       dk(ik) = d1(2)  ! b1
    endif
    if ((tr14.AND.tr42) .OR. (tr21.AND.(tr14.OR.tr42))) then
       ik = ik + 1
       dk(ik) =  d2(2)  ! b2
    endif

    di(1:4) = 0.0_dp
    select case (ik)
    case (0)
       ni = 0
    case (2)
       ni = 1
       di(1:2) = (/ dk(1), dk(2) /) ! [a1,b1] or [a1,b2] or [a2,b1] or [a2,b2]
    case (4)
       ni = 2
       di(1:4) = (/ dk(1), dk(4), dk(2), dk(3) /) ! [a1,b2] U [a2,b1]
    case default
       print*,"error in intrs_intrv", ik
       print*,dk
       print*,d1,d2
    end select

    return
  end subroutine intrs_intrv

  !=======================================================================
  subroutine process_intervals(interval1, interval_list, interval_out, n_out)
  !=======================================================================
    ! intersection of 1 interval (defined by its 2 boundaries)
    ! with an arbitrary list of intervals (defined as n*2 boundaries)
    !=======================================================================
    real(dp), dimension(1:), intent(in) :: interval1
    real(dp), dimension(1:), intent(in) :: interval_list
    real(dp), dimension(1:), intent(out):: interval_out
    integer(i4b),          intent(out) :: n_out
    !
    integer(i4b) :: n_in, i_in, n_tmp_out
    real(dp), dimension(1:4) :: w4
    real(dp), dimension(1:30) :: work
    !=======================================================================

    n_out = 0
    interval_out = 0.d0
    n_in = size(interval_list)/2
    work(1:2*n_in) = interval_list(1:2*n_in) ! copy input array to avoid overwritting it

    if (n_in > 0) then
       do i_in=0, n_in-1
          ! intersection of 2 intervals -> 0,1,2 intervals
          call intrs_intrv(interval1, work(1+2*i_in:2+2*i_in), w4, n_tmp_out)
          if (n_tmp_out > 0) then ! n_tmp_out = 1 or 2
             interval_out(2*n_out+1: 2*(n_out+n_tmp_out)) = w4(1:2*n_tmp_out)
             n_out = n_out + n_tmp_out
          endif
       enddo
    endif
    
    return
  end subroutine process_intervals
  !=======================================================================
  function fudge_query_radius(nside, radius_in, quadratic) result(radius_out)
  !=======================================================================
    !  radius_out = fudge_query_radius( nside, radius_in, QUADRATIC=)
    ! 
    !  with 
    !    radius_out = radius_in + fudge            (default)
    !  or
    !    radius_out = sqrt(radius_in^2 + fudge^2)  (quadratic)
    ! 
    !  if absent, radius_in = 0
    ! where
    !    fudge = factor(nside) * Pi / (4 *Nside)
    !  with factor = sqrt( 5/9 + (8/Pi)^2 / 5 * (1-1/(2*Nside)) )
    ! 
    !  an upper bound of the actual largest radius 
    !  (determined by pixel located at z=2/3 and its North corner).
    !  
    ! 
    !  2011-10-14, EH, v1.0
    !=======================================================================
    integer(i4b), intent(in)           :: nside
    real(dp),     intent(in), optional :: radius_in
    logical(lgt), intent(in), optional :: quadratic
    real(dp)                           :: radius_out
    logical(LGT)                       :: do_quad
    real(dp)                           :: factor, fudge
    !=======================================================================
    radius_out = 0.0_dp
    if (present(radius_in)) radius_out = radius_in
    do_quad = .false.
    if (present(quadratic)) do_quad = quadratic

    factor = sqrt( 0.55555555555555555555_dp + 1.29691115062192347448165712908_dp*(1.0_dp-0.5_dp/nside) )
    fudge  = factor * PI / (4.0_dp * nside) ! increase effective radius

    if (do_quad) then 
       radius_out = sqrt(radius_out**2 + fudge**2)
    else
       radius_out = radius_out + fudge
    endif
    radius_out = min(radius_out, PI)

    return
  end function fudge_query_radius
  !=======================================================================
  subroutine discphirange_at_z(vector0, radius, z, nz, dphi, phi0)
    !=======================================================================
    !  for a disc centered on  vcenter and given radius,
    !  and for location z=cos(theta)
    !  returns dphi such that the disc has   abs(phi-phi0) <= dphi
    !
    ! solving disc equation on sphere:
    !  sin(theta) sin(theta0) cos(phi-phi0) + cos(theta) cos(theta0) >= cos(radius)
    !
    !=======================================================================
    real(dp), dimension(1:3), intent(in) :: vector0
    real(dp),                 intent(in) :: radius
    real(dp), dimension(1:),  intent(in) :: z
    integer(i4b),             intent(in) :: nz
    real(dp), dimension(1:),  intent(out) :: dphi
    real(dp),                 intent(out) :: phi0
    !
    real(dp) :: cosang, cosphi0, x0, y0, z0, a, b, c, cosdphi, norm
    integer(i4b) ::  i
    real(DP), parameter :: zero=0.0_dp, one=1.0_dp
    
    cosang = cos(radius)
    norm =  sqrt(sum(vector0(1:3)**2))
    x0 = vector0(1) / norm
    y0 = vector0(2) / norm
    z0 = vector0(3) / norm

    phi0 = zero
    if ((x0 /= zero).or.(y0 /= zero)) phi0 = atan2(y0, x0)  ! in ]-Pi, Pi]
    !cosphi0 = cos(phi0)
    a = x0*x0 + y0*y0   ! sin(theta0)^2  

    do i=1, nz
       dphi(i) = -1000.0_dp ! default value for out of disc

       b = cosang - z(i)*z0   ! cos(rad) - cos(theta)cos(theta0)
       if (a == zero) then ! poles
          if (b <= zero) dphi(i) = PI
       else
          c = max(one - z(i)*z(i), 1.0e-12_dp) ! sin(theta)^2
          cosdphi = b / sqrt(a*c)
          if (cosdphi      < -one) dphi(i) = PI ! all the pixels at this elevation are in the disc
          if (abs(cosdphi) <= one) dphi(i) = acos(cosdphi) ! in [0,Pi]
       endif

    enddo

    return
  end subroutine discphirange_at_z
  !=======================================================================
  subroutine pixels_on_edge(nside, irmin, irmax, phi0, dphi, ringphi, ngr)
  !=======================================================================
  !=======================================================================
    integer(i4b),                intent(in) :: nside, irmin, irmax
    real(dp),                    intent(in) :: phi0
    real(dp),     dimension(1:), intent(in) :: dphi
    integer(i4b), dimension(1:,1:), intent(out) :: ringphi
    integer(i4b),                   intent(out) :: ngr
    integer(i4b), parameter :: badvalue = -9999
    integer(i4b) :: nrings, ir, k, thisring, npr
    real(dp)    , parameter :: zero = 0.0_dp
    integer(i4b) :: iphi_low, iphi_hi, kshift
    real(dp) :: shift

    nrings = irmax - irmin + 1

    ngr = 0
    do thisring = irmin, irmax
       ir = thisring - irmin + 1
       call pixels_per_ring(nside, thisring, npr, kshift)
       if (dphi(ir) >= PI) then ! full ring
          ngr = ngr + 1
          ringphi(1, ngr) = thisring
          ringphi(2, ngr) = 0
          ringphi(3, ngr) = npr-1
       elseif (dphi(ir) >= zero) then ! partial ring
          shift = kshift * 0.5_dp
          iphi_low = ceiling (npr * (phi0 - dphi(ir)) / TWOPI - shift)
          iphi_hi  = floor   (npr * (phi0 + dphi(ir)) / TWOPI - shift)
          if (iphi_hi >= iphi_low) then ! pixel center in range
             ngr = ngr + 1
             ringphi(1, ngr) = thisring
             ringphi(2, ngr) = modulo(iphi_low, npr)
             ringphi(3, ngr) = modulo(iphi_hi,  npr)
          endif
       endif
    enddo

  end subroutine pixels_on_edge
  !=======================================================================
  subroutine pixels_per_ring(nside, ring, npr, kshift, npnorth)
  !=======================================================================
    ! for a given Nside and ring index in [1,4*Nside-1], 
    ! returns the number of pixels in ring, their shift (0 or 1) in azimuth
    ! and the number of pixels in current ring and above (=North)
    !
    ! NB: 'rings' 0 and 4*Nside respectively are North and South Poles
    !=======================================================================
    integer(i4b), intent(in) :: nside, ring
    integer(i4b), intent(out) :: npr, kshift
    integer(i8b), intent(out), optional :: npnorth
    integer(i8b) :: ncap, npix, ir
    
    ! number of pixels in current ring
    npr = min(nside, ring, 4*nside-ring) * 4
    ! shift
    kshift = mod(ring + 1, 2) ! 1 for even, 0 for odd
    if (nside == 1) kshift = 1 - kshift ! except for Nside=1
    if (npr < 4*nside) kshift = 1 ! 1 on polar cap
    ! Number of pixels in current ring and above
    if (present(npnorth)) then
       if (ring <= nside) then ! in North cap
          npnorth = ring*(ring+1_i8b)*2_i8b
       elseif (ring <= 3*nside) then ! in Equatorial region
          ncap = nside*(nside+1_i8b)*2_i8b
          ir = ring-nside
          npnorth = ncap + 4_i8b*nside*ir
       else ! in South cap
          npix = nside2npix(nside)
          ir = 4_i8b*nside-ring - 1 ! count ring from south
          npnorth = npix - ir*(ir+1_i8b)*2_i8b
       endif
    endif
    return
  end subroutine pixels_per_ring
  !=======================================================================
  subroutine check_edge_pixels(nside, nsboost, irmin, irmax, phi0, dphi, ringphi, ngr)
  !=======================================================================
    integer(i4b), intent(in) :: nside, nsboost, irmin, irmax
    real(dp),                       intent(in) :: phi0
    real(dp),     dimension(1:),    intent(in) :: dphi
    integer(i4b), dimension(1:,1:), intent(inout) :: ringphi
    integer(i4b),                   intent(inout) :: ngr

    integer(i4b) :: i, j, k, kk, ngr_out, diff, iphi, i0, nrh
    real(dp), dimension(1:2*nsboost+1) :: phiw, phie
    real(dp) :: dd, dph, phic

  !=======================================================================
    if (nsboost <= 1) return

    nrh = irmax-irmin+1
    do i=1, ngr ! loop on low-res rings
       i0 = ringphi(1,i) * nsboost - nsboost - irmin
       do k=-1,1,2 ! West and East side of disc
          kk = (k+5)/2 ! 2 or 3
222       continue
          iphi = ringphi(kk, i)
          if (ringphi(2,i) <= ringphi(3,i) .and. iphi >= 0) then
             call find_pixel_bounds(nside, nsboost, ringphi(1,i), iphi, phiw, phie)
             do j=1, 2*nsboost+1
                if (i0+j >= 1 .and. i0+j <= nrh) then
                   phic = (phie(j)+phiw(j))*0.5_dp ! pixel center
                   dph  = (phie(j)-phiw(j))*0.5_dp + dphi(i0+j) ! pixel size + circle radius
                   dd = abs(phi0 - phic)    ! distance from disc center to pixel border sample
                   dd = min(dd, twopi - dd) ! in [0,Pi]
                   if (dd <= dph) goto 1000 ! pixel touched by disc, move to next one
                endif
             enddo
             ringphi(kk, i)= iphi - k ! pixel not in disc, move edge pixel inwards
             goto 222 ! try next pixel inward
1000         continue
          endif
       enddo ! loop on side
    enddo ! loop on low-res rings

    ! remove empty rings
    ngr_out = 0
    do i=1,ngr
       diff = ringphi(3,i) - ringphi(2,i)
       if (ringphi(2,i) >=0 .and. ringphi(3,i) >=0 .and. diff /= -2 .and. diff /= -1) then
          ngr_out = ngr_out + 1
          ringphi(1:3, ngr_out) = ringphi(1:3, i)
       endif
    enddo
    ! set empty rings to -1
    do i=ngr_out+1, ngr
       ringphi(2:3, i) = -1
    enddo

    ngr = ngr_out
    return
  end subroutine check_edge_pixels
  !=======================================================================
  subroutine find_pixel_bounds (nside, nsboost, iring, iphi, phiw, phie)
    !=======================================================================
    integer(i4b),               intent(in)  :: nside, nsboost, iring, iphi
    real(dp),     dimension(1:2*nsboost+1), intent(out) :: phiw, phie
    
    real(dp),     dimension(1:2*nsboost+1) :: f, f1, phiw_t, phie_t
    real(dp) :: c0, quad, phie1, phie2, phiw1, phiw2, cv
    integer(i4b) :: npr, kshift, nq, ip, i
    logical(lgt) :: transition
  !=======================================================================

    call pixels_per_ring(nside, iring, npr, kshift)
    !f = ((/ (i,i=0,2*nsboost) /) - nsboost) / nsboost
    f = ((/ (i*1.d0,i=0,2*nsboost) /) - nsboost*1.d0) / nsboost

    nq = npr/4 ! number of pixels on current ring in [0,Pi/2] (quadrant)
    transition = (iring == nside .or. iring == nside*3)

    if (nq == nside .or. transition) then ! equatorial region (and transition rings)

       f1 = (1.0_dp-abs(f))*0.5_dp    ! triangle of height 1/2
       f1 = halfpi * f1 / nq
       c0 = halfpi * (iphi + kshift*0.5_dp) / nq
       phiw = c0 - f1
       phie = c0 + f1
       if (transition) then ! store for future use
          phiw_t = phiw
          phie_t = phie
       endif
    endif

    if (nq < nside .or. transition) then ! polar regions and transition rings
       ip = mod(iphi,nq) ! in [0,nq-1]
       quad = iphi / nq ! quadrant in [0,3]
       if (iring <= nside*2) then
          f1 = halfpi / (nq + f) 
       else
          f1 = halfpi / (nq - f)! swap sign for South pole
       endif
       do i=1, 2*nsboost+1
          cv = f1(i)
          phiw1 = min(cv *     ip,    halfpi)
          phie1 = min(cv * (   ip+1), halfpi)
          phiw2 = min(cv * (nq-ip-1), halfpi)
          phie2 = min(cv * (nq-ip),   halfpi)
          phiw(i) = max(phiw1, halfpi - phie2) + (quad * halfpi)
          phie(i) = min(phie1, halfpi - phiw2) + (quad * halfpi)
       enddo
    endif

    if (transition) then 
       if (iring == nside) then ! transition in N hemisphere
          phiw(nsboost+2:2*nsboost+1) = phiw_t(nsboost+2:2*nsboost+1) 
          phie(nsboost+2:2*nsboost+1) = phie_t(nsboost+2:2*nsboost+1)
       else ! transition in S hemisphere
          phiw(1:nsboost+1) = phiw_t(1:nsboost+1)
          phie(1:nsboost+1) = phie_t(1:nsboost+1)
       endif
    endif

    return
  end subroutine find_pixel_bounds
  
!   !=======================================================================
!   subroutine correct_ring_phi(location, iring, iphi)
!     !=======================================================================
!     ! returns ring and phi indexes corrected from round-off errors
!     ! appearing at large Nside
!     ! if phi <0 :      move 1 ring North
!     ! if phi >4*iring: move 1 ring South
!     ! rings are counted from the closest pole starting at 1.
!     integer(i4b), intent(in)    :: location !+1:North, -1:South
!     integer(i4b), intent(inout) :: iring, iphi
!     integer(i4b) :: delta
!     !-----------------------------------------------------------------------
!     delta = 0
!     if (iphi < 0)        delta =  -1
!     if (iphi >= 4*iring) delta =  +1
!     if (delta /= 0) then
!        if (abs(location) /= 1) then 
!           stop 'wrong location'
!        endif
!        if (delta > 0) then ! too large iphi
!           iphi  = iphi  - 4*iring  ! use old iring
!           iring = iring + location ! move south
!        else ! too small iphi
!           iring = iring - location ! move north
!           iphi  = iphi  +  4*iring ! use new iring
!        endif
!     endif
!     return
!   end subroutine correct_ring_phi
  !=======================================================================
  ! CHEAP_ISQRT
  !       Returns exact Floor(sqrt(x)) where x is a (64 bit) integer.
  !             y^2 <= x < (y+1)^2         (1)
  !       The double precision floating point operation is not accurate enough
  !       when dealing with 64 bit integers, especially in the vicinity of 
  !       perfect squares. 
  !=======================================================================
#ifndef NO64BITS
  function cheap_isqrt_8(lin) result (lout)
    integer(i8b), intent(in) :: lin
    integer(i8b) :: lout, diff
    real(DP) :: dout, din
    lout = floor(sqrt(dble(lin)), kind=I8B) ! round-off error may offset result
    diff = lin - lout*lout ! test Eq (1)
    if (diff <0)      lout = lout - 1
    if (diff >2*lout) lout = lout + 1
    return
  end function cheap_isqrt_8
#endif
  function cheap_isqrt_4(lin) result (lout)
    integer(i4b), intent(in) :: lin
    integer(i4b) :: lout
    lout = floor(sqrt(dble(lin)), kind=I4B)
    return
  end function cheap_isqrt_4
  !=======================================================================

  ! perform 2 compilations of the same source file
#undef DOI8Bi
#include "pixel_routines.F90"
#ifndef NO64BITS
#define DOI8B
#include "pixel_routines.F90"
#endif
!
! pix2ang_ring
! pix2vec_ring
! ang2pix_ring
! vec2pix_ring
! pix2ang_nest
! pix2vec_nest
! ang2pix_nest
! vec2pix_nest
! nest2ring
! npix2nside

  !*************************************************************
  !
  !                    MAP Manipulations
  !
  !*************************************************************
  subroutine warning_oldbounds(code, cos_theta_cut, zbounds)
    character(len=*), intent(in)          :: code
    real(DP), intent(in)                  :: cos_theta_cut
    real(DP), intent(out), dimension(1:2) :: zbounds

    if (cos_theta_cut <= 0.0_dp) then ! no cut
       zbounds(1) =  -1.0_dp
       zbounds(2) =   1.0_dp
    else
       zbounds(1) =   cos_theta_cut
       zbounds(2) = - cos_theta_cut
    endif
    print*,' -------------------------------------'
    print*,'WARNING: obsolete interface to '//code
    print*,'    cos_theta_cut currently a DP scalar with value'
    write(*,9000) '    ',cos_theta_cut
    print*,'    shoud now be replaced with a 2-element vector with values:'
    write(*,9001) '    ',zbounds(1),zbounds(2)
    print*,'    See documentation for details.'
    print*,' -------------------------------------'
9000 format (a,g13.6)
9001 format (a,g13.6,g13.6)

    return
  end subroutine warning_oldbounds
  !==============================================================
  ! REMOVE_DIPOLE( nside, map, ordering, degree, multipoles, zbounds, fmissval, mask, weights)
  !
  ! removes monopole (and dipole) from a map
  !
  ! Nside:     I4,       IN   : Healpix resolution parameter
  ! map:       KMAP, array,INOUT: Heapix map (see Notes below)
  ! ordering:  I4,       IN:   Healpix scheme 1:RING, 2: NESTED
  ! degree:    I4,       IN:   multipole to remove, 1: monopole, 2: monopole and dipole
  ! multipoles:R8, array,OUT:  value of monopole and dipole
  ! zbounds   :R8,      IN:  2-el vector
  ! range of z in [-1,1] on which to estimate monopole and dipole
  ! fmissval:  KMAP, Option, IN: value used to flag bad pixel on input, default=-1.6375e30
  !                            Pixels with map = fmissval are not used for fit
  ! mask    :  KMAP, Option, IN: Pixels with |mask|<1.e-10 are not used for fit
  !                              others are kept as is
  !                               note : the mask in NOT applied to the map
  ! weights  : KMAP, Option, IN: pixel weight to be applied to the map
  !
  ! KMAP: either R4 or R8
  !
  ! note : if degree= 1, or 2, the map is modified on output
  !     * the monopole (and dipole) is/are removed
  !     * pixels within the symmetric cut parameterized
  !       by cos_theta_cut are set to fmissval (or its default value)
  !  if degree = 0, nothing is done
  !  all other values of degree are invalid
  !
  ! v1.0, EH, Caltech, Jan-2002, based on homonyme IDL routine
  ! 2008-02-03: addition of weights
  !
  !==============================================================
  subroutine remove_dipole_real( nside, map, ordering, degree, multipoles, zbounds, &
       & fmissval, mask, weights)
    !============================================================
    use num_rec, only : dsvdcmp, dsvbksb
    ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_REAL"
    integer(kind=I4B),     parameter :: KMAP = SP
    real   (kind=KMAP),    parameter :: fbad_value = -1.6375e30_KMAP
    !
    include 'remove_dipole_inc.f90'
  end subroutine remove_dipole_real
  !==============================================================
  subroutine remove_dipole_double( nside, map, ordering, degree, multipoles, zbounds, &
       & fmissval, mask, weights)
    !============================================================
    use num_rec, only : dsvdcmp, dsvbksb
    ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_DOUBLE"
    integer(kind=I4B),     parameter :: KMAP = DP
    real   (kind=KMAP),    parameter :: fbad_value = -1.6375e30_KMAP
    !
    include 'remove_dipole_inc.f90'
  end subroutine remove_dipole_double

  !==============================================================
  subroutine remove_dipole_real_old( nside, map, ordering, degree, multipoles, cos_theta_cut, fmissval, mask)
    !============================================================
    ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_REAL"
    integer(kind=I4B),     parameter :: KMAP = SP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree
    real   (kind=DP),   dimension(0:),  intent(out)   :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=DP),                   intent(in)    :: cos_theta_cut
    real   (kind=KMAP),                 intent(in), optional :: fmissval
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: mask
    ! local
    real(DP),                          dimension(1:2) :: zbounds

    call warning_oldbounds(code, cos_theta_cut, zbounds)
    call remove_dipole(nside, map, ordering, degree, multipoles, zbounds, fmissval, mask)
  end subroutine remove_dipole_real_old
  !==============================================================
  subroutine remove_dipole_double_old( nside, map, ordering, degree, multipoles, cos_theta_cut, fmissval, mask)
    !============================================================
     ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_DOUBLE"
    integer(kind=I4B),     parameter :: KMAP = DP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree
    real   (kind=DP),   dimension(0:),  intent(out)   :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=DP),                   intent(in)    :: cos_theta_cut
    real   (kind=KMAP),                 intent(in), optional :: fmissval
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: mask
    ! local
    real(DP),                          dimension(1:2) :: zbounds

    call warning_oldbounds(code, cos_theta_cut, zbounds)
    call remove_dipole(nside, map, ordering, degree, multipoles, zbounds, fmissval, mask) 
  end subroutine remove_dipole_double_old

  !==============================================================
  subroutine remove_dipole_real_v12( nside, map, nmaps, ordering, degree, multipoles, cos_theta_cut, fmissval, mask)
    !============================================================
    ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_REAL"
    integer(kind=I4B),     parameter :: KMAP = SP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree, nmaps
    real   (kind=DP),   dimension(0:),  intent(out)   :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=DP),                   intent(in)    :: cos_theta_cut
    real   (kind=KMAP),                 intent(in), optional :: fmissval
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: mask
    ! local
    real(DP),                          dimension(1:2) :: zbounds

    print*,'=========================================================='
    print*,'WARNING: Interface to remove_dipole has changed'
    print*,' from'
    print*,'call remove_dipole(nside, map, NMAPS, ordering, degree, multipoles, COS_THETA_CUT, fmissval, mask)'
    print*,' to'
    print*,'call remove_dipole(nside, map,        ordering, degree, multipoles, ZBOUNDS,       fmissval, mask)'
    print*,'=========================================================='
    
    call warning_oldbounds(code, cos_theta_cut, zbounds)
    call remove_dipole(nside, map, ordering, degree, multipoles, zbounds, fmissval, mask)
  end subroutine remove_dipole_real_v12
  !==============================================================
  subroutine remove_dipole_double_v12( nside, map, nmaps, ordering, degree, multipoles, cos_theta_cut, fmissval, mask)
    !============================================================
     ! parameters
    character(len=*),      parameter :: code = "REMOVE_DIPOLE_DOUBLE"
    integer(kind=I4B),     parameter :: KMAP = DP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree, nmaps
    real   (kind=DP),   dimension(0:),  intent(out)   :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=DP),                   intent(in)    :: cos_theta_cut
    real   (kind=KMAP),                 intent(in), optional :: fmissval
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: mask
    ! local
    real(DP),                          dimension(1:2) :: zbounds

    print*,'=========================================================='
    print*,'WARNING: Interface to remove_dipole has changed'
    print*,' from'
    print*,'call remove_dipole(nside, map, NMAPS, ordering, degree, multipoles, COS_THETA_CUT, fmissval, mask)'
    print*,' to'
    print*,'call remove_dipole(nside, map,        ordering, degree, multipoles, ZBOUNDS,       fmissval, mask)'
    print*,'=========================================================='

    call warning_oldbounds(code, cos_theta_cut, zbounds)
    call remove_dipole(nside, map, ordering, degree, multipoles, zbounds, fmissval, mask) 
  end subroutine remove_dipole_double_v12

  !=======================================================================
  ! ADD_DIPOLE( nside, map, ordering, degree, multipoles, fmissval)
  !
  ! removes monopole (and dipole) from a map
  !
  ! Nside:     I4,       IN   : Healpix resolution parameter
  ! map:       KMAP, array,INOUT: Heapix map (see Notes below)
  ! ordering:  I4,       IN:   Healpix scheme 1:RING, 2: NESTED
  ! degree:    I4,       IN:   multipole to remove, 1: monopole, 2: monopole and dipole
  ! multipoles:R8, array,IN:  value of monopole and dipole
  ! fmissval:  KMAP, Option, IN: value used to flag bad pixel on input, default=-1.6375e30
  !                            Pixels with map = fmissval are left unchanged
  ! 2009-03-25: accepts Nside > 8192
  !=======================================================================
  subroutine add_dipole_real(nside, map, ordering, degree, multipoles, fmissval)
    !=======================================================================
    ! single precision
    !=======================================================================
    character(len=*),      parameter :: code = "ADD_DIPOLE_REAL"
    integer(kind=I4B),     parameter :: KMAP = SP
    real   (kind=KMAP),    parameter :: fbad_value = -1.6375e30_KMAP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree
    real   (kind=DP),   dimension(0:),  intent(in)    :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=KMAP),                 intent(in), optional :: fmissval

    real   (kind=KMAP)                :: fmiss_effct
    integer(kind=i8b)                 :: ipix, npix
    logical(lgt)                      :: dodipole !, do_mask
    real(kind=dp), dimension(1:3)     :: vec
    !=======================================================================
    
    npix = nside2npix(nside)
    fmiss_effct = fbad_value
    if (present(fmissval)) fmiss_effct = fmissval

    if (degree == 0) then
       print*," No monopole nor dipole to add"
       return
    elseif (degree == 1) then
       dodipole = .false.
    else if (degree == 2) then
       dodipole = .true.
    else
       print*,code//"> degree can only be "
       print*,"      1: monopole (l=0) addition or "
       print*,"      2: monopole and dipole (l=0,1) addition"
       print*,code//"> ABORT ! "
       call fatal_error
    endif

    do ipix = 0, npix-1
       if ( abs(map(ipix) - fmiss_effct) <= abs(1.e-5*fmiss_effct) ) goto 20
!        if (do_mask) then
!           if (abs(mask(ipix)) <= 1.e-10) goto 20
!        endif
       map(ipix) = map(ipix) + multipoles(0)
       if (dodipole) then
          ! computes dipole basis functions
          ! pixel -> vector
          if (ordering == 1) call pix2vec_ring( nside, ipix, vec)
          if (ordering == 2) call pix2vec_nest( nside, ipix, vec)
          map(ipix) = map(ipix) + sum(multipoles(1:3) * vec(1:3))
       endif

20     continue
    enddo

    return
  end subroutine add_dipole_real
  !=======================================================================
  subroutine add_dipole_double(nside, map, ordering, degree, multipoles, fmissval)
    !=======================================================================
    ! single precision
    !=======================================================================
    character(len=*),      parameter :: code = "ADD_DIPOLE_DOUBLE"
    integer(kind=I4B),     parameter :: KMAP = DP
    real   (kind=KMAP),    parameter :: fbad_value = -1.6375e30_KMAP
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree
    real   (kind=DP),   dimension(0:),  intent(in)    :: multipoles
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=KMAP),                 intent(in), optional :: fmissval

    real   (kind=KMAP)                :: fmiss_effct
    integer(kind=i8b)                 :: ipix, npix
    logical(lgt)                      :: dodipole !, do_mask
    real(kind=dp), dimension(1:3)     :: vec
    !=======================================================================
    
    npix = nside2npix(nside)
    fmiss_effct = fbad_value
    if (present(fmissval)) fmiss_effct = fmissval

    if (degree == 0) then
       print*," No monopole nor dipole to add"
       return
    elseif (degree == 1) then
       dodipole = .false.
    else if (degree == 2) then
       dodipole = .true.
    else
       print*,code//"> degree can only be "
       print*,"      1: monopole (l=0) addition or "
       print*,"      2: monopole and dipole (l=0,1) addition"
       print*,code//"> ABORT ! "
       call fatal_error
    endif

    do ipix = 0, npix-1
       if ( abs(map(ipix) - fmiss_effct) <= abs(1.e-5*fmiss_effct) ) goto 20
!        if (do_mask) then
!           if (abs(mask(ipix)) <= 1.e-10) goto 20
!        endif
       map(ipix) = map(ipix) + multipoles(0)
       if (dodipole) then
          ! computes dipole basis functions
          ! pixel -> vector
          if (ordering == 1) call pix2vec_ring( nside, ipix, vec)
          if (ordering == 2) call pix2vec_nest( nside, ipix, vec)
          map(ipix) = map(ipix) + sum(multipoles(1:3) * vec(1:3))
       endif

20     continue
    enddo

    return
  end subroutine add_dipole_double

  !====================================================
  ! apply_mask (map, order, mask=mask, zbounds=zbounds)
  !   applies a mask and/or a zbounds to a TQU maps,
  !   map and mask should have the same ordering
  !  map :  SP/DP, INOUT,   (0:,1:)
  !  order: I4B,   IN,  1=RING, 2=NESTED
  !  mask:  SP/DP  IN, (0:,1:) optional
  !  zbounds: DP   IN, (1:2)   optional
  !=====================================================================
  subroutine apply_mask_real(map, order, mask, zbounds)
    !=====================================================================
    integer(I4B), parameter :: KMAP = SP
    include 'apply_mask_inc.f90'
  end subroutine apply_mask_real
  !=====================================================================
  subroutine apply_mask_double(map, order, mask, zbounds)
    !=====================================================================
    integer(I4B), parameter :: KMAP = DP
    include 'apply_mask_inc.f90'
  end subroutine apply_mask_double
  !====================================================
  ! medfiltmap
  !   compute the median filtered map of a given Healpix map
  !   in_map: SP/DP  input Healpix full sky map
  !   radius: DP     radius in Radians
  !   med_map: SP/DP output Healpix full sky map
  !   nest:    I4B, OPT   either 0 (ring scheme) or 1 (nested scheme)
  !   fmissval:SP/DP, OPT sentinel value given to missing pixels
  !   fill_holes: LGT, OPT 
  ! 2012-07-17: Parallel OpenMP implementation
  !=================================================================
  subroutine medfiltmap_S( in_map, radius, med_map, nest, fmissval, fill_holes)
  !=================================================================
    use statistics, only: median
    integer(I4B), parameter :: KMAP = SP
    !
    real(KMAP), dimension(0:),intent(in), target       :: in_map
    real(DP),                 intent(in)               :: radius
    real(KMAP), dimension(0:),intent(out)              :: med_map
    integer(I4B),             intent(in),  optional    :: nest
    real(KMAP),               intent(in),  optional    :: fmissval
    logical(LGT),             intent(in),  optional    :: fill_holes
    !
    integer(I8B) :: npix, np
    integer(I4B) :: nside, p, nlist, status
    logical(LGT) :: do_nest, do_fill
    real(DP)     :: fraction
    real(KMAP)   :: fmissval_in
    integer(I4B), dimension(:),  allocatable :: listpix
    real(DP),     dimension(1:3)             :: vector
    character(len=*), parameter :: code = 'medfiltmap'
    !-----------------------------------------------
    npix = long_size(in_map)
    nside = npix2nside(npix)
    call assert(nside > 0, code//": invalid map size")

    fraction = 0.5_DP * (1.0_dp - cos(radius))
    np = npix * fraction * 1.2 + 50
    call assert(np < MAX_I4B, code//": too many pixels to compute median")

    do_nest = .false.
    if (present(nest)) then
       call assert(nest>=0 .and. nest <=1,code//': invalid NEST flag')
       do_nest = (nest == 1)
    endif

    do_fill = .false.
    if (present(fill_holes)) do_fill = fill_holes

    fmissval_in = hpx_Sbadval
    if (present(fmissval)) fmissval_in = fmissval

    ! make sure common arrays are initiated
    call mk_pix2xy()
!!!    print*,'************* Parallel Median **************'
!$OMP parallel default(none) &
!$OMP   shared(in_map, med_map, pix2x, pix2y, &
!$OMP          nside, npix, radius, np, do_nest, do_fill, nest, fmissval_in) &
!$OMP  private(listpix, vector, p, nlist, status)
    allocate(listpix(0:np-1),stat=status)
    call assert_alloc(status,code,'listpix')
!$OMP do schedule(dynamic, 64)
    do p = 0, npix-1
       ! find pixel location
       if (do_nest) then
          call pix2vec_nest( nside, p, vector)
       else
          call pix2vec_ring( nside, p, vector)
       endif

       ! find disc centered on pixel
       call query_disc(nside, vector, radius, listpix, nlist, nest=nest)

       if (do_fill .or. abs(in_map(p)-fmissval_in) > abs(fmissval_in*1.e-7)) then
          med_map(p) = median(in_map(listpix(0:nlist-1)), badval = fmissval_in, even=(nlist<100))
       else
          med_map(p) = in_map(p)
       endif
    enddo
!$OMP end do
    deallocate(listpix)
!$OMP end parallel
    return
  end subroutine medfiltmap_S
  !=================================================================
  subroutine medfiltmap_D( in_map, radius, med_map, nest, fmissval, fill_holes)
  !=================================================================
    use statistics, only: median
    integer(I4B), parameter :: KMAP = DP
    !
    real(KMAP), dimension(0:),intent(in), target       :: in_map
    real(DP),                 intent(in)               :: radius
    real(KMAP), dimension(0:),intent(out)              :: med_map
    integer(I4B),             intent(in),  optional    :: nest
    real(KMAP),               intent(in),  optional    :: fmissval
    logical(LGT),             intent(in),  optional    :: fill_holes
    !
    integer(I8B) :: npix, np
    integer(I4B) :: nside, p, nlist, status
    logical(LGT) :: do_nest, do_fill
    real(DP)     :: fraction
    real(KMAP)   :: fmissval_in
    integer(I4B), dimension(:),  allocatable :: listpix
    real(DP),     dimension(1:3)             :: vector
    character(len=*), parameter :: code = 'medfiltmap'
    !-----------------------------------------------
    npix = long_size(in_map)
    nside = npix2nside(npix)
    call assert(nside > 0, code//": invalid map size")

    fraction = 0.5_DP * (1.0_dp - cos(radius))
    np = npix * fraction * 1.2 + 50
    call assert(np < MAX_I4B, code//": too many pixels to compute median")

    do_nest = .false.
    if (present(nest)) then
       call assert(nest>=0 .and. nest <=1,code//': invalid NEST flag')
       do_nest = (nest == 1)
    endif

    do_fill = .false.
    if (present(fill_holes)) do_fill = fill_holes

    fmissval_in = hpx_Dbadval
    if (present(fmissval)) fmissval_in = fmissval

    ! make sure common arrays are initiated
    call mk_pix2xy()
!!!    print*,'************* Parallel Median **************'
!$OMP parallel default(none) &
!$OMP   shared(in_map, med_map, pix2x, pix2y, &
!$OMP          nside, npix, radius, np, do_nest, do_fill, nest, fmissval_in) &
!$OMP  private(listpix, vector, p, nlist, status)
    allocate(listpix(0:np-1),stat=status)
    call assert_alloc(status,code,'listpix')
!$OMP do schedule(dynamic, 64)
    do p = 0, npix-1
       ! find pixel location
       if (do_nest) then
          call pix2vec_nest( nside, p, vector)
       else
          call pix2vec_ring( nside, p, vector)
       endif

       ! find disc centered on pixel
       call query_disc(nside, vector, radius, listpix, nlist, nest=nest)

       if (do_fill .or. abs(in_map(p)-fmissval_in) > abs(fmissval_in*1.e-7)) then
          med_map(p) = median(in_map(listpix(0:nlist-1)), badval = fmissval_in, even=(nlist<100))
       else
          med_map(p) = in_map(p)
       endif
    enddo
!$OMP end do
    deallocate(listpix)
!$OMP end parallel
    return
  end subroutine medfiltmap_D
  !**************************************************************
  ! following 2x3 routines: out of place conversions for 1D maps
  ! if size(map) = Npix, peak memory = 2*Npix
  ! These routines are parallelized for shared memory architecture 
  !   (using OpenMP directives)
  !**************************************************************
  !=======================================================================
  !     makes the conversion NEST to RING
  !=======================================================================
  subroutine convert_nest2ring_int_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_nest2ring_int_1d'
    integer(kind=I4B),   parameter :: KMAP = I4B
    integer(kind=KMAP),  dimension(0:), intent(inout) ::  map
    integer(kind=KMAP),  dimension(:),  allocatable :: map_tmp
    include 'convert_nest2ring_1d_inc.f90'
  end subroutine convert_nest2ring_int_1d
#ifndef NO64BITS
  !=======================================================================
  subroutine convert_nest2ring_int8_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_nest2ring_int8_1d'
    integer(kind=I4B),   parameter :: KMAP = I8B
    integer(kind=KMAP),  dimension(0:), intent(inout) ::  map
    integer(kind=KMAP),  dimension(:),  allocatable :: map_tmp
    include 'convert_nest2ring_1d_inc.f90'
  end subroutine convert_nest2ring_int8_1d
#endif
  !=======================================================================
  subroutine convert_nest2ring_real_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_nest2ring_real_1d'
    integer(kind=I4B),   parameter :: KMAP = SP
    real   (kind=KMAP),  dimension(0:), intent(inout) ::  map
    real   (kind=KMAP),  dimension(:),  allocatable :: map_tmp
    include 'convert_nest2ring_1d_inc.f90'
  end subroutine convert_nest2ring_real_1d
  !=======================================================================
  subroutine convert_nest2ring_double_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_nest2ring_double_1d'
    integer(kind=I4B),   parameter :: KMAP = DP
    real   (kind=KMAP),  dimension(0:), intent(inout) ::  map
    real   (kind=KMAP),  dimension(:),  allocatable :: map_tmp
    include 'convert_nest2ring_1d_inc.f90'
  end subroutine convert_nest2ring_double_1d
  !=======================================================================
  !     makes the conversion RING to NEST
  !=======================================================================
  subroutine convert_ring2nest_int_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_ring2nest_int_1d'
    integer(kind=I4B),   parameter :: KMAP = I4B
    integer(kind=KMAP),  dimension(0:), intent(inout) ::  map
    integer(kind=KMAP),  dimension(:), allocatable :: map_tmp
    include 'convert_ring2nest_1d_inc.f90'
  end subroutine convert_ring2nest_int_1d
#ifndef NO64BITS
  !=======================================================================
  subroutine convert_ring2nest_int8_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_ring2nest_int8_1d'
    integer(kind=I4B),   parameter :: KMAP = I8B
    integer(kind=KMAP),  dimension(0:), intent(inout) ::  map
    integer(kind=KMAP),  dimension(:), allocatable :: map_tmp
    include 'convert_ring2nest_1d_inc.f90'
  end subroutine convert_ring2nest_int8_1d
#endif
  !=======================================================================
  subroutine convert_ring2nest_real_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_ring2nest_real_1d'
    integer(kind=I4B),   parameter :: KMAP = SP
    real   (kind=KMAP),  dimension(0:), intent(inout) ::  map
    real   (kind=KMAP),  dimension(:), allocatable :: map_tmp
    include 'convert_ring2nest_1d_inc.f90'
  end subroutine convert_ring2nest_real_1d
  !=======================================================================
  subroutine convert_ring2nest_double_1d(nside, map)
    !=======================================================================
    character(len=*), parameter :: code = 'convert_ring2nest_double_1d'
    integer(kind=I4B),   parameter :: KMAP = DP
    real   (kind=KMAP),  dimension(0:), intent(inout) ::  map
    real   (kind=KMAP),  dimension(:), allocatable :: map_tmp
    include 'convert_ring2nest_1d_inc.f90'
  end subroutine convert_ring2nest_double_1d

  !**************************************************************
  ! following 6 routines: out of place conversions for N-Dim maps
  ! if size(map) = Npix*Nd, peak memory = (Nd+2)*Npix
  ! 2004-08-25, EH
  !**************************************************************
  !=======================================================================
  subroutine convert_nest2ring_int_nd(nside, map)
    !=======================================================================
    !   NEST to RING conversion: 1D, integer
    !=======================================================================
    character(len=*),  parameter :: code = "convert_nest2ring_int_nd"
    integer(kind=I4B), parameter :: KMAP = I4B
    integer(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    integer(kind=KMAP), dimension(:),               allocatable :: map_tmp
    integer(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_nest2ring_nd_inc.f90'
  end subroutine convert_nest2ring_int_nd
#ifndef NO64BITS
  !=======================================================================
  subroutine convert_nest2ring_int8_nd(nside, map)
    !=======================================================================
    !   NEST to RING conversion: 1D, integer*8
    !=======================================================================
    character(len=*),  parameter :: code = "convert_nest2ring_int_nd"
    integer(kind=I4B), parameter :: KMAP = I8B
    integer(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    integer(kind=KMAP), dimension(:),               allocatable :: map_tmp
    integer(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_nest2ring_nd_inc.f90'
  end subroutine convert_nest2ring_int8_nd
#endif
  !=======================================================================
  subroutine convert_nest2ring_real_nd(nside, map)
    !=======================================================================
    !   NEST to RING conversion: 1D, real
    !=======================================================================
    character(len=*),  parameter :: code = "convert_nest2ring_real_nd"
    integer(kind=I4B), parameter :: KMAP = SP
    real(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    real(kind=KMAP), dimension(:),               allocatable :: map_tmp
    real(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_nest2ring_nd_inc.f90'
  end subroutine convert_nest2ring_real_nd
  !=======================================================================
  subroutine convert_nest2ring_double_nd(nside, map)
    !=======================================================================
    !   NEST to RING conversion: 1D, double
    !=======================================================================
    character(len=*),  parameter :: code = "convert_nest2ring_double_nd"
    integer(kind=I4B), parameter :: KMAP = DP
    real(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    real(kind=KMAP), dimension(:),               allocatable :: map_tmp
    real(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_nest2ring_nd_inc.f90'
  end subroutine convert_nest2ring_double_nd
  !=======================================================================
  subroutine convert_ring2nest_int_nd(nside, map)
    !=======================================================================
    !   RING to NEST conversion: 1D, integer
    !=======================================================================
    character(len=*),  parameter :: code = "convert_ring2nest_int_nd"
    integer(kind=I4B), parameter :: KMAP = I4B
    integer(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    integer(kind=KMAP), dimension(:),               allocatable :: map_tmp
    integer(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_ring2nest_nd_inc.f90'
  end subroutine convert_ring2nest_int_nd
#ifndef NO64BITS
  !=======================================================================
  subroutine convert_ring2nest_int8_nd(nside, map)
    !=======================================================================
    !   RING to NEST conversion: 1D, integer
    !=======================================================================
    character(len=*),  parameter :: code = "convert_ring2nest_int8_nd"
    integer(kind=I4B), parameter :: KMAP = I8B
    integer(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    integer(kind=KMAP), dimension(:),               allocatable :: map_tmp
    integer(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_ring2nest_nd_inc.f90'
  end subroutine convert_ring2nest_int8_nd
#endif
  !=======================================================================
  subroutine convert_ring2nest_real_nd(nside, map)
    !=======================================================================
    !   RING to NEST conversion: 1D, real
    !=======================================================================
    character(len=*),  parameter :: code = "convert_ring2nest_real_nd"
    integer(kind=I4B), parameter :: KMAP = SP
    real(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    real(kind=KMAP), dimension(:),               allocatable :: map_tmp
    real(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_ring2nest_nd_inc.f90'
  end subroutine convert_ring2nest_real_nd
  !=======================================================================
  subroutine convert_ring2nest_double_nd(nside, map)
    !=======================================================================
    !   RING to NEST conversion: 1D, double
    !=======================================================================
    character(len=*),  parameter :: code = "convert_ring2nest_double_nd"
    integer(kind=I4B), parameter :: KMAP = DP
    real(kind=KMAP), dimension(0:,1:), intent(inout), target ::  map
    real(kind=KMAP), dimension(:),               allocatable :: map_tmp
    real(kind=KMAP), dimension(:),                   pointer :: map1
    include 'convert_ring2nest_nd_inc.f90'
  end subroutine convert_ring2nest_double_nd
  !====================================================================
  ! The following 6 routines convert in place integer, real, and double
  ! arrays between the NESTED and RING schemes.
  !
  ! in place: without allocating a temporary map. This routine is more general,
  ! but slower than convert_nest2ring.
  !
  !     This is a wrapper for the toolbox functions "ring2nest" and
  !     "nest2ring". Their names are supplied in the "subcall"
  !     argument.
  !
  ! Author: Benjamin D. Wandelt October 1997
  ! Added to pix_tools for version 1.00 in March 1999.
  ! 2004-08-25: EH, added N-Dim facility and double precision IO
  !====================================================================
  !====================================================================
  subroutine convert_inplace_int_1d(subcall,map)
    !==================================================================
    ! 1D, integer implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_int_1d"
    integer(kind=I4B), parameter :: KMAP = I4B
    integer(kind=KMAP), dimension(0:)    :: map
    integer(kind=KMAP)                   :: pixbuf1,pixbuf2
    include 'convert_inplace_1d_inc.f90'
  end subroutine convert_inplace_int_1d
  !====================================================================
  subroutine convert_inplace_real_1d(subcall,map)
    !====================================================================
    ! 1D, real implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_real_1d"
    integer(kind=I4B), parameter :: KMAP = SP
    real   (kind=KMAP), dimension(0:)    :: map
    real   (kind=KMAP)                   :: pixbuf1,pixbuf2
    include 'convert_inplace_1d_inc.f90'
  end subroutine convert_inplace_real_1d
  !====================================================================
  subroutine convert_inplace_double_1d(subcall,map)
    !====================================================================
    ! 1D, double precision implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_double_1d"
    integer(kind=I4B), parameter :: KMAP = DP
    real   (kind=KMAP), dimension(0:)    :: map
    real   (kind=KMAP)                   :: pixbuf1,pixbuf2
    include 'convert_inplace_1d_inc.f90'
  end subroutine convert_inplace_double_1d
  !====================================================================
  subroutine convert_inplace_int_nd(subcall,map)
    !==================================================================
    ! ND, integer implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_int_nd"
    integer(kind=i4b), parameter :: ND_MAX = 10
    integer(kind=I4B), parameter :: KMAP = I4B
    integer(kind=KMAP), dimension(0:,1:)    :: map
    integer(kind=KMAP), dimension(1:ND_MAX) :: pixbuf1,pixbuf2
    include 'convert_inplace_nd_inc.f90'
  end subroutine convert_inplace_int_nd
  !====================================================================
  subroutine convert_inplace_real_nd(subcall,map)
    !====================================================================
    ! ND, real implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_real_nd"
    integer(kind=i4b), parameter :: ND_MAX = 10
    integer(kind=I4B), parameter :: KMAP = SP
    real   (kind=KMAP), dimension(0:,1:)    :: map
    real   (kind=KMAP), dimension(1:ND_MAX) :: pixbuf1,pixbuf2
    include 'convert_inplace_nd_inc.f90'
  end subroutine convert_inplace_real_nd
  !====================================================================
  subroutine convert_inplace_double_nd(subcall,map)
    !====================================================================
    ! ND, double precision implementation
    !==================================================================
    character(len=*),  parameter :: code = "convert_inplace_double_nd"
    integer(kind=i4b), parameter :: ND_MAX = 10
    integer(kind=I4B), parameter :: KMAP = DP
    real   (kind=KMAP), dimension(0:,1:)    :: map
    real   (kind=KMAP), dimension(1:ND_MAX) :: pixbuf1,pixbuf2
    include 'convert_inplace_nd_inc.f90'
  end subroutine convert_inplace_double_nd
  !=======================================================================
  subroutine mk_pix2xy()
    !=======================================================================
    !     constructs the array giving x and y in the face from pixel number
    !     for the nested (quad-cube like) ordering of pixels
    !
    !     the bits corresponding to x and y are interleaved in the pixel number
    !     one breaks up the pixel number by even and odd bits
    !=======================================================================
    INTEGER(KIND=I4B) ::  kpix, jpix, ix, iy, ip, id

    !cc cf block data      data      pix2x(1023) /0/
    !-----------------------------------------------------------------------
    !      print *, 'initiate pix2xy'
    do kpix=0,1023          ! pixel number
       jpix = kpix
       IX = 0
       IY = 0
       IP = 1               ! bit position (in x and y)
!        do while (jpix/=0) ! go through all the bits
       do
          if (jpix == 0) exit ! go through all the bits
          ID = MODULO(jpix,2)  ! bit value (in kpix), goes in ix
          jpix = jpix/2
          IX = ID*IP+IX

          ID = MODULO(jpix,2)  ! bit value (in kpix), goes in iy
          jpix = jpix/2
          IY = ID*IP+IY

          IP = 2*IP         ! next bit (in x and y)
       enddo
       pix2x(kpix) = IX     ! in 0,31
       pix2y(kpix) = IY     ! in 0,31
    enddo

    return
  end subroutine mk_pix2xy
!   !=======================================================================
!   subroutine mk_xy2pix()
!     !=======================================================================
!     !     sets the array giving the number of the pixel lying in (x,y)
!     !     x and y are in {1,128}
!     !     the pixel number is in {0,128**2-1}
!     !
!     !     if  i-1 = sum_p=0  b_p * 2^p
!     !     then ix = sum_p=0  b_p * 4^p
!     !          iy = 2*ix
!     !     ix + iy in {0, 128**2 -1}
!     !=======================================================================
!     INTEGER(KIND=I4B):: k,ip,i,j,id
!     !=======================================================================

!     do i = 1,128           !for converting x,y into
!        j  = i-1            !pixel numbers
!        k  = 0
!        ip = 1

!        do
!           if (j==0) then
!              x2pix(i) = k
!              y2pix(i) = 2*k
!              exit
!           else
!              id = MODULO(J,2)
!              j  = j/2
!              k  = ip*id+k
!              ip = ip*4
!           endif
!        enddo

!     enddo

!     return
!   end subroutine mk_xy2pix
  !=======================================================================
  subroutine mk_xy2pix1()
    !=======================================================================
    !     sets the array giving the number of the pixel lying in (x,y)
    !     x and y are in {1,128}
    !     the pixel number is in {0,128**2-1}
    !
    !     if  i-1 = sum_p=0  b_p * 2^p
    !     then ix = sum_p=0  b_p * 4^p
    !          iy = 2*ix
    !     ix + iy in {0, 128**2 -1}
    !=======================================================================
    INTEGER(KIND=I4B):: k,ip,i,j,id
    !=======================================================================

    do i = 0,127           !for converting x,y into
       j  = i           !pixel numbers
       k  = 0
       ip = 1

       do
          if (j==0) then
             x2pix1(i) = k
             y2pix1(i) = 2*k
             exit
          else
             id = MODULO(J,2)
             j  = j/2
             k  = ip*id+k
             ip = ip*4
          endif
       enddo

    enddo

    return
  end subroutine mk_xy2pix1
  !=======================================================================

  !=======================================================================
  subroutine ang2vec(theta, phi, vector)
    !=======================================================================
    !     renders the vector (x,y,z) corresponding to angles
    !     theta (co-latitude measured from North pole, in [0,Pi] radians)
    !     and phi (longitude measured eastward, in radians)
    !     North pole is (x,y,z)=(0,0,1)
    !     added by EH, Feb 2000
    !=======================================================================
    REAL(KIND=DP), INTENT(IN) :: theta, phi
    REAL(KIND=DP), INTENT(OUT), dimension(1:) :: vector

    REAL(KIND=DP) :: sintheta
    !=======================================================================

    if (theta<0.0_dp .or. theta>pi)  then
       print*,"ANG2VEC: theta : ",theta," is out of range [0, Pi]"
       call fatal_error
    endif
    sintheta = SIN(theta)

    vector(1) = sintheta * COS(phi)
    vector(2) = sintheta * SIN(phi)
    vector(3) = COS(theta)

    return
  end subroutine ang2vec
  !=======================================================================
  subroutine vec2ang(vector, theta, phi)
    !=======================================================================
    !     renders the angles theta, phi corresponding to vector (x,y,z)
    !     theta (co-latitude measured from North pole, in [0,Pi] radians)
    !     and phi (longitude measured eastward, in [0,2Pi[ radians)
    !     North pole is (x,y,z)=(0,0,1)
    !     added by EH, Feb 2000
    ! 2011-08: replaced ACOS(z) by more accurate ATAN2(r,z)
    !=======================================================================
    REAL(KIND=DP), INTENT(IN), dimension(1:) :: vector
    REAL(KIND=DP), INTENT(OUT) :: theta, phi

    !=======================================================================

    theta = atan2(sqrt(vector(1)**2 + vector(2)**2), vector(3))

    phi = 0.0_dp
    if (vector(1) /= 0.0_dp .or. vector(2) /= 0.0_dp) &
         &     phi = ATAN2(vector(2),vector(1)) ! phi in ]-pi,pi]
    if (phi < 0.0)     phi = phi + twopi ! phi in [0,2pi[

    return
  end subroutine vec2ang
  !=======================================================================
  function nside2npix(nside) result(npix_result)
    !=======================================================================
    ! given nside, returns npix such that npix = 12*nside^2
    !  nside should be a power of 2 smaller than ns_max
    !  if not, -1 is returned
    ! EH, Feb-2000
    ! 2009-03-04: returns i8b result, faster
    !=======================================================================
    INTEGER(KIND=I8B)             :: npix_result
    INTEGER(KIND=I4B), INTENT(IN) :: nside

    INTEGER(KIND=I8B) :: npix
    CHARACTER(LEN=*), PARAMETER :: code = "nside2npix"
    !=======================================================================

    npix = (12_i8b*nside)*nside
    if (nside < 1 .or. nside > ns_max .or. iand(nside-1,nside) /= 0) then
       print*,code//": Nside="//trim(string(nside))//" is not a power of 2."
       npix = -1
    endif
    npix_result = npix

    return
  end function nside2npix
  !=======================================================================
  subroutine surface_triangle(vec1, vec2, vec3, surface)
    !=======================================================================
    ! returns the surface in steradians
    !  of the spherical triangle with vertices vec1, vec2, vec3
    !
    ! algorithm : finds triangle sides and uses l'Huilier formula to compute
    ! "spherical excess" = surface area of triangle on a sphere of radius one
    ! see, eg Bronshtein, Semendyayev Eq 2.86
    !=======================================================================
    real(kind=dp), dimension(1:), intent(in) :: vec1, vec2, vec3
    real(kind=dp), intent(out) :: surface

    !   real(kind=dp), dimension(1:3) :: v1, v2, v3
    real(kind=dp), dimension(1:3) :: side
    !  real(kind=dp) :: hp
    real(kind=dp) :: x0, x1, x2, x3
    !=======================================================================

    ! half perimeter
!   hp = 0.5_dp * (side1 + side2 + side3)

!   ! l'Huilier formula
!   x0 = tan( hp          * 0.5_dp)
!   x1 = tan((hp - side1) * 0.5_dp)
!   x2 = tan((hp - side2) * 0.5_dp)
!   x3 = tan((hp - side3) * 0.5_dp)

    ! find triangle sides
    call angdist(vec2, vec3, side(1))
    call angdist(vec3, vec1, side(2))
    call angdist(vec1, vec2, side(3))
    ! divide by 4
    side(1:3) = side(1:3) * 0.25_dp

    ! l'Huilier formula
    x0 = tan( side(1) + side(2) + side(3) )
    x1 = tan(-side(1) + side(2) + side(3) )
    x2 = tan( side(1) - side(2) + side(3) )
    x3 = tan( side(1) + side(2) - side(3) )
    surface = 4.0_dp * atan( sqrt(x0 * x1 * x2 * x3) )

    return
  end subroutine surface_triangle
  !=======================================================================
  subroutine angdist(v1, v2, dist)
    !=======================================================================
    ! call angdist(v1, v2, dist)
    ! computes the angular distance dist (in rad) between 2 vectors v1 and v2
    ! dist = atan2 ( |v1 x v2| / (v1 . v2) )
    ! (more accurate than acos(v1. v2) when dist close to 0 or Pi.
    ! 2011-08-25: replaced ACOS with ATAN2
    !=======================================================================
    real(kind=DP), intent(IN), dimension(1:) :: v1, v2
    real(kind=DP), intent(OUT) :: dist

    real(kind=DP), dimension(1:3) :: v3
    real(kind=DP) :: sprod, vprod
    !=======================================================================

    ! scalar product     s = A. cos(theta)
    sprod = dot_product(v1, v2)
    ! vectorial product  v = A. sin(theta)
    call vect_prod(v1, v2, v3)
    vprod = sqrt(dot_product(v3,v3))
    ! theta = atan( |v|/s) in [0,Pi]
    dist = atan2( vprod, sprod)

    return
  end subroutine angdist
  !=======================================================================
  subroutine vect_prod(v1, v2, v3) !
    !=======================================================================
    !     returns in v3 the vectorial product of the 2 3-dimensional
    !     vectors v1 and v2
    !=======================================================================
    real(kind=DP), dimension(1:), INTENT(IN)  :: v1, v2
    real(kind=DP), dimension(1:), INTENT(OUT) :: v3
    !=======================================================================

    v3(1) = v1(2) * v2(3) - v1(3) * v2(2)
    v3(2) = v1(3) * v2(1) - v1(1) * v2(3)
    v3(3) = v1(1) * v2(2) - v1(2) * v2(1)

    return
  end subroutine vect_prod

  !****************************************************************************

  !=======================================================================
  function nside2ntemplates(nside) result(ntemplates)
    !=======================================================================
    ! returns the number of template pixels
    ! 2009-03-24: accepts Nside > 8192, and returns I8B result
    !

    integer(kind=i8b) :: ntemplates
    integer(kind=i4b), intent(IN) :: nside

    ntemplates = 1_I8B + nside * (nside + 6_I8B)
    ntemplates = ntemplates / 4_I8B

    return
  end function nside2ntemplates

!******************************************************************************
  function nside2npweights(nside) result(npweights)
!---------------------------------------
!  returns the number of full sky weights (in compressed form) for a given Nside.
! Given the symmetries of the Healpix lay out, the number of non-redundant weights
! is  nf = ((3*Nside+1)*(Nside+1))/4 ~ Npix/16
!
! adapted from nside2npweights.pro
! 2018-05-18
!---------------------------------------
  
    integer(i8b) :: npweights
    integer(i4b), intent(in) :: nside
    integer(i8b), parameter  :: one  = 1_i8b
    integer(i8b), parameter  :: four = 4_i8b

    npweights = ((3*Nside + one)*(Nside + one)) / four

    return
  end function nside2npweights


end module pix_tools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!--------------------------------------------------------------
!
! generic body of the subroutines convert_inplace_*_1d 
! to be inserted as is in pix_tools.f90
!
! 2009-06-16: adapted for Nside > 8192
!--------------------------------------------------------------
    integer(kind=I1B), parameter :: TODO = 0_I1B, DONE = 1_I1B
    !
    external  subcall ! required by some compilers (DEC, Portland, ...)
    integer(kind=i4b)            :: nside
    integer(kind=i8b)            :: npix
    integer(kind=i8b)            :: ilast_8, i1_8, i2_8, npix_8
    integer(kind=i4b)            :: ilast_4, i1_4, i2_4, npix_4
    integer(kind=I1B), dimension(:), allocatable::check
    !------------------------------------------------------------------
    npix = long_size(map)
    nside = npix2nside(npix)
    call assert (nside<=NS_MAX, code//": map too big")
    call assert (nside>0,       code//": invalid Nside")

    print*, "Convert: Converting map pixelisation scheme"
    allocate(check(0:npix-1))
    check = TODO

    if (nside <= ns_max4) then 

       npix_4 = npix
       ilast_4 = 0                   !start at first pixel
       do
          pixbuf2 = map(ilast_4)      !initialise
          i1_4 = ilast_4
          call subcall(nside, i1_4, i2_4)
          do
             if (check(i2_4) == DONE) exit
             pixbuf1 = map(i2_4)
             map(i2_4) = pixbuf2
             check(i2_4) = DONE
             pixbuf2 = pixbuf1
             i1_4 = i2_4
             call subcall(nside, i1_4, i2_4)
          enddo
          do
             if (.not. (check(ilast_4)==DONE .and. ilast_4<npix_4-1)) exit ! npix-1 or npix
             ilast_4 = ilast_4 + 1
          enddo
          if(ilast_4 == npix_4-1) exit ! npix-1 or npix
       enddo

    else

       npix_8 = npix
       ilast_8 = 0                   !start at first pixel
       do
          pixbuf2 = map(ilast_8)      !initialise
          i1_8 = ilast_8
          call subcall(nside, i1_8, i2_8)
          do
             if (check(i2_8) == DONE) exit
             pixbuf1 = map(i2_8)
             map(i2_8) = pixbuf2
             check(i2_8) = DONE
             pixbuf2 = pixbuf1
             i1_8 = i2_8
             call subcall(nside, i1_8, i2_8)
          enddo
          do
             if (.not. (check(ilast_8)==DONE .and. ilast_8<npix_8-1)) exit ! npix-1 or npix
             ilast_8 = ilast_8 + 1
          enddo
          if(ilast_8 == npix_8-1) exit ! npix-1 or npix
       enddo

    endif

    deallocate(check)
    return

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!
! generic source for ipsort, xpsort, ipsort_8, ....
! the array to sort is gen_xx and can be integer, long integer, float, double ...
!
      IER = IZERO
      NN = N
      IF (NN .LT. IONE) THEN
         IER = IONE
         RETURN
      ENDIF
      KK = ABS(KFLAG)
      IF (KK.NE.IONE .AND. KK.NE.2) THEN
         IER = ITWO
         RETURN
      ENDIF
!
!     Initialize permutation vector
!
      DO 10 I=IONE,NN
         IPERM(I) = I
   10 CONTINUE
!
!     Return if only one value is to be sorted
!
      IF (NN .EQ. IONE) RETURN
!
!     Alter array GEN_XX to get decreasing order if needed
!
      IF (KFLAG .LE. -IONE) THEN
         DO 20 I=IONE,NN
            GEN_XX(I) = -GEN_XX(I)
   20    CONTINUE
      ENDIF
!
!     Sort GEN_XX only
!
      M = IONE
      I = IONE
      J = NN
      R = .375_DP  ! 15/40
!
   30 IF (I .EQ. J) GO TO 80
      IF (R .LE. 0.5898437_DP) THEN
         R = R+3.90625E-2  ! R = R + 5/128
      ELSE
         R = R-0.21875_DP  ! R = R - 7/32
      ENDIF
!
   40 K = I
!
!     Select a central element of the array and save it in location L
!
      IJ = I + INT((J-I)*R, kind=MKD)
      LM = IPERM(IJ)
!
!     If first element of array is greater than LM, interchange with LM
!
      IF (GEN_XX(IPERM(I)) .GT. GEN_XX(LM)) THEN
         IPERM(IJ) = IPERM(I)
         IPERM(I) = LM
         LM = IPERM(IJ)
      ENDIF
      L = J
!
!     If last element of array is less than LM, interchange with LM
!
      IF (GEN_XX(IPERM(J)) .LT. GEN_XX(LM)) THEN
         IPERM(IJ) = IPERM(J)
         IPERM(J) = LM
         LM = IPERM(IJ)
!
!        If first element of array is greater than LM, interchange
!        with LM
!
         IF (GEN_XX(IPERM(I)) .GT. GEN_XX(LM)) THEN
            IPERM(IJ) = IPERM(I)
            IPERM(I) = LM
            LM = IPERM(IJ)
         ENDIF
      ENDIF
      GO TO 60
   50 LMT = IPERM(L)
      IPERM(L) = IPERM(K)
      IPERM(K) = LMT
!
!     Find an element in the second half of the array which is smaller
!     than LM
!
   60 L = L-IONE
      IF (GEN_XX(IPERM(L)) .GT. GEN_XX(LM)) GO TO 60
!
!     Find an element in the first half of the array which is greater
!     than LM
!
   70 K = K+IONE
      IF (GEN_XX(IPERM(K)) .LT. GEN_XX(LM)) GO TO 70
!
!     Interchange these elements
!
      IF (K .LE. L) GO TO 50
!
!     Save upper and lower subscripts of the array yet to be sorted
!
      IF (L-I .GT. J-K) THEN
         IL(M) = I
         IU(M) = L
         I = K
         M = M+IONE
      ELSE
         IL(M) = K
         IU(M) = J
         J = L
         M = M+IONE
      ENDIF
      GO TO 90
!
!     Begin again on another portion of the unsorted array
!
   80 M = M-IONE
      IF (M .EQ. IZERO) GO TO 120
      I = IL(M)
      J = IU(M)
!
   90 IF (J-I .GE. IONE) GO TO 40
      IF (I .EQ. IONE) GO TO 30
      I = I-IONE
!
  100 I = I+IONE
      IF (I .EQ. J) GO TO 80
      LM = IPERM(I+IONE)
      IF (GEN_XX(IPERM(I)) .LE. GEN_XX(LM)) GO TO 100
      K = I
!
  110 IPERM(K+IONE) = IPERM(K)
      K = K-IONE
!
      IF (GEN_XX(LM) .LT. GEN_XX(IPERM(K))) GO TO 110
      IPERM(K+IONE) = LM
      GO TO 100
!
!     Clean up
!
  120 IF (KFLAG .LE. -IONE) THEN
         DO 130 I=IONE,NN
            GEN_XX(I) = -GEN_XX(I)
  130    CONTINUE
      ENDIF
!
!     Rearrange the values of GEN_XX if desired
!
      IF (KK .EQ. ITWO) THEN
!
!        Use the IPERM vector as a flag.
!        If IPERM(I) < 0, then the I-th value is in correct location
!
         DO 150 ISTRT=IONE,NN
            IF (IPERM(ISTRT) .GE. IZERO)  THEN
               INDX = ISTRT
               INDX0 = INDX
               GEN_TEMP = GEN_XX(ISTRT)
  140          IF (IPERM(INDX) .GT. IZERO)  THEN
                  GEN_XX(INDX) = GEN_XX(IPERM(INDX))
                  INDX0 = INDX
                  IPERM(INDX) = -IPERM(INDX)
                  INDX = ABS(IPERM(INDX))
                  GO TO 140
               ENDIF
               GEN_XX(INDX0) = GEN_TEMP
            ENDIF
  150    CONTINUE
!
!        Revert the signs of the IPERM values
!
         DO 160 I=IONE,NN
            IPERM(I) = -IPERM(I)
  160    CONTINUE
!
      ENDIF
!

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
Module sky_sub

  !Subroutines used by sky_ng_sim and sky_ng_sim_bin

Contains
  
  !--------------------------------------------------------
  
  Subroutine add_subscript(text, number)

    Implicit none

    Character(len = 20), Intent(InOut) :: text
    Integer, Intent(In) :: number

    Integer i
    Character(len = 10) :: form

    i = Ceiling(log10(number + 0.5))
    If (i .ge. 10) Stop "A ridiculously large number of bins!"

    Write (form, "(a,i1,a)") "(a,a,i",i,")"

    Write (text, form) TRIM(text), "_", number

  End Subroutine add_subscript

  !--------------------------------------------------------

  Subroutine read_powerspec(infile, nsmax, nlmax, cls, header_PS, fwhm, units_power, winfile, beam_file)

    Use healpix_types
    USE fitstools, ONLY : fits2cl
    Use alm_tools, Only : generate_beam, pixel_window
    use utilities, only : die_alloc
    Use head_fits, only : add_card, get_card, merge_headers

    Implicit none

    Character(len = *), Intent(In) :: infile
    Integer(I4B), Intent(In)       :: nsmax
    Integer(I4B), Intent(InOut)    :: nlmax
    Real(SP), dimension(0:nlmax,1:1), Intent(Out) :: cls
    Character(Len=80), dimension(1:), Intent(Out) :: header_PS
    Real(DP) :: fwhm
    Character(len=80), dimension(1:1), Intent(Out) :: units_power
    Character(len=*), Intent(In), optional :: winfile
    Character(len=*), Intent(In), optional :: beam_file


    Logical fitscl
    Integer(I4B) :: nlheader
    Integer(I4B) :: l_max, npw
    Real(DP) :: lbeam
    Integer i 
    Integer(I4B) :: status, count_tt = 0
    Real(SP) :: quadrupole
    REAL(DP), DIMENSION(:,:), ALLOCATABLE :: pixlw, beamw
    CHARACTER(LEN=*), PARAMETER :: code = 'READ_POWERSPEC'
    CHARACTER(LEN=80), DIMENSION(1:180)          :: header_file
    CHARACTER(LEN=20)                            ::  string_quad
    !  CHARACTER(LEN=80), DIMENSION(:), allocatable :: units_power
    CHARACTER(LEN=80) :: temptype, com_tt

    ! set maximum multipole (depends on user choice and pixel window function)
    ! if using pixel window function l_max can't be greater than 4*nsmax
    l_max = nlmax
    npw = 4*nsmax + 1
    if (present(winfile)) then
       l_max = min(l_max, npw - 1)
    else
       npw = l_max + 1
    endif
    if (l_max < nlmax) then
       print*,'C_l are only non-zero for 0 < l <= ',l_max
    endif
    nlmax = l_max

    !-----------------------------------------------------------------------

    cls = 0.0
    nlheader = SIZE(header_file)
    header_file = ''
    ! Find out whether input cl file is a fits file
    fitscl = (index(infile, '.fits') /= 0)
    If (fitscl) Then
!!!       call read_asctab(infile, cls, nlmax, 1, header_file, nlheader, units=units_power)
       call fits2cl(infile, cls, nlmax, 1, header_file, units=units_power)
       call get_card(header_file,"TEMPTYPE",temptype,com_tt,count=count_tt)
    Else
       call read_camb(infile, cls, nlmax)
       units_power = 'microKelvin^2'
       !Check to see if enough values were present in file
       If (nlmax .LT. l_max) then
          Write (*,*) "Maximum l-value in cl file is ",nlmax
          Write (*,*) "Power spectrum above this value set to zero"
          l_max = nlmax
       end if
    End If

    if (count_tt < 1) then
       temptype = "THERMO"
       com_tt = " temperature : either THERMO or ANTENNA"
       print*,'   Will assume '//temptype
    endif

    quadrupole = cls(2,1)
    !     --- creates the header relative to power spectrum ---
    header_PS = ''
    call add_card(header_PS)
    call add_card(header_PS,'HISTORY',' alm generated from following power spectrum')
    call add_card(header_PS)
    call add_card(header_PS,'COMMENT','----------------------------------------------------')
    call add_card(header_PS,'COMMENT','Planck Power Spectrum Description Specific Keywords')
    call add_card(header_PS,'COMMENT','----------------------------------------------------')
    call add_card(header_PS,'COMMENT','Input power spectrum in : ')
    call add_card(header_PS,'COMMENT',TRIM(infile))
    call add_card(header_PS)
    call add_card(header_PS,'COMMENT','Quadrupole')
    write(string_quad,'(1pe15.6)') quadrupole
    call add_card(header_PS,'COMMENT','  C(2) = '//string_quad//' '//trim(units_power(1)))
    call add_card(header_PS)
    call add_card(header_PS,"TEMPTYPE",temptype,com_tt)
    call add_card(header_PS)
    ! ------- insert header read in power spectrum file -------
    call merge_headers(header_file, header_PS)
    !    deallocate(units_power)

    ! define beam
    allocate(beamw(0:l_max,1:1), stat = status)
    if (status /= 0) call die_alloc(code,'beamw')
    If ((fwhm .NE. 0d0) .OR. present(beam_file)) Then
       call generate_beam(real(fwhm,kind=dp), l_max, beamw, beam_file)
    Else
       beamw(:,:) = 1.0_dp
    End If

    ! get the pixel window function 
    allocate(pixlw(0:npw-1,1:1), stat = status)
    if (status /= 0) call die_alloc(code,'pixlw')
    if(present(winfile)) then
       call pixel_window(pixlw, windowfile=winfile)
    else
       pixlw(:,:)  = 1.0_dp
    endif

    ! Multiply by beam and pixel window functions
!    cls(0:l_max, 1) = cls(0:l_max,1)*beamw(0:l_max,1)*pixlw(0:l_max,1) !EH-2008-03-05
    cls(0:l_max, 1) = cls(0:l_max,1)* (beamw(0:l_max,1)*pixlw(0:l_max,1))**2

    deallocate(beamw)
    deallocate(pixlw)

  End Subroutine read_powerspec

  !--------------------------------------------------------

  Subroutine read_camb(infile, cl_array, lmax)

    Use healpix_types

    Implicit none

    Character (len = *), intent(IN) :: infile
    Integer(I4B), intent(INOUT) :: lmax
    Real(SP), Intent(OUT), Dimension(0:lmax,1:1) :: cl_array

    Real(DP) :: clval
    Integer :: lval = 0
    Real(DP) :: cmbT = 2.726d0

    ! Read in the cl values and convert to units of uK^2
    Open (Unit = 23, file = infile, status = 'old', action = 'read', err = 9980)
    Do while (lval .LT. lmax)
       Read (23, *, end = 800) lval, clval
       cl_array(lval, 1) = TWOPI*clval/(lval*(lval+1))*cmbT*cmbT*1.d12
    End Do
800 lmax = lval

    Close (23)
    Return

9980 Stop 'Error opening cl file to read'

  End Subroutine read_camb


End Module sky_sub

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module long_intrinsic
  ! If correctly compiled this module redefines 
  ! - the intrisic function SIZE  (renamed long_size)
  ! - the intrisic function COUNT (renamed long_count)
  ! to return 8-byte = 64-bit integer (I8B) results instead of default type integer.
  !
  ! It must be compiled with the option
  ! Intel ifort:    -i8   or   -integer-size 64
  ! GNU gfortran: -fdefault-integer-8
  ! IBM xlf:      -qintsize=8
  ! NAG f95:      -double
  ! Pathscale pathf90:     -i8  or -default64
  ! g95:                   -i8
  !
  ! 2009-02-25: version 1.0, EH/IAP
  ! 2013-05-07: G95-compatible
    !---------------------------------------------------------------------

  use healpix_types, only: i4b, i8b, sp, dp, lgt
  implicit none

  private
  public:: long_size, long_count

  interface long_size
     module procedure size_i_1, size_i_2, &
#ifndef NO64BITS
          &           size_j_1, size_j_2, &
#endif
          &           size_r_1, size_r_2, &
          &           size_d_1, size_d_2
  end interface

  interface long_count
     module procedure count_l_1
  end interface


contains
  !============================================
  !  integer I4B arrays
  !============================================
  function size_i_1(array, dim) result (mysize)
    integer(i4b), dimension(:), intent(in)   :: array
    integer(i4b), optional,     intent(in)   :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_i_1

  function size_i_2(array, dim) result (mysize)
    integer(i4b), dimension(:,:), intent(in) :: array
    integer(i4b), optional ,      intent(in) :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_i_2

#ifndef NO64BITS
  !============================================
  !  integer I8B arrays
  !============================================
  function size_j_1(array, dim) result (mysize)
    integer(i8b), dimension(:), intent(in)   :: array
    integer(i4b), optional,     intent(in)   :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_j_1

  function size_j_2(array, dim) result (mysize)
    integer(i8b), dimension(:,:), intent(in) :: array
    integer(i4b), optional ,      intent(in) :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_j_2
#endif
  !============================================
  !  real SP arrays
  !============================================
  function size_r_1(array, dim) result (mysize)
    real(sp),     dimension(:), intent(in)   :: array
    integer(i4b), optional,     intent(in)   :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_r_1

  function size_r_2(array, dim) result (mysize)
    real(sp),     dimension(:,:), intent(in) :: array
    integer(i4b), optional ,      intent(in) :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_r_2

  !============================================
  !  real DP arrays
  !============================================
  function size_d_1(array, dim) result (mysize)
    real(dp),     dimension(:), intent(in)   :: array
    integer(i4b), optional,     intent(in)   :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_d_1

  function size_d_2(array, dim) result (mysize)
    real(dp),     dimension(:,:), intent(in) :: array
    integer(i4b), optional ,      intent(in) :: dim
    integer(i8b)                             :: mysize
    integer                                  :: dim8
    if (present(dim)) then
#ifdef G95
       dim8=dim ; mysize = size(array, dim8)
#else
       mysize = size(array, dim=dim)
#endif
    else
       mysize = size(array) ! required for xlf
    endif
    return
  end function size_d_2

  !*************** COUNT ***********************
  !============================================
  !  logical array
  !============================================
  function count_l_1(array) result (mycount)
    logical(lgt), dimension(:), intent(in)   :: array
    integer(i8b)                             :: mycount
    mycount = count(array)
    return
  end function count_l_1


end module long_intrinsic

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module maxima_tools
   ! This module contains
   !    find_maxima     : performs optimised search of maxima and minima
   !                      inside a face and uses neighbours_nest
   !                      to find the neighbours of a pixel on the border
   !                      of the face.
   ! Benjamin D. Wandelt October 1997
   ! 2010-11-23, E. Hivon: accept maps with Nside > 8192
   !
   use healpix_types
   use pix_tools, only : npix2nside, xy2pix_nest, neighbours_nest
   implicit none
contains
   !====================================================================
   subroutine find_maxima(map,face_num,peak)
      !====================================================================
      !     Finds all maxima in the face face_num
      !     INPUTS:
      !     map:      REAL array, length NPIX which contains the map
      !     face_num: INTEGER Number of the face in which extremum search is to be
      !               performed
      !     OUTPUTS:  
      !     peak:     INTEGER array, length NPIX which contains 1 in the pixels
      !               where maxima were found and -1 in the pixels where minima
      !               were found.
      !
      !     Benjamin D. Wandelt October 1997
      ! 2010-11-23, E. Hivon: accept maps with Nside > 8192
      !====================================================================
      use bit_manipulation
      implicit none

      real(sp), intent(in) :: map(0:)
      integer(i4b), intent(in):: face_num
      integer(i4b), intent(out)::peak(0:)

      integer(i8b) :: npix, nsidesq, origin
      integer(i8b) :: ipix0m,ipix00,ipix0p,ipixpm,ipixp0,ipixpp
      integer(i8b) :: neighb(8)

      integer(i4b) :: nside, nn
      integer(i4b) :: ix,iy,ixp,iyp,iym
      real(sp) :: pixval0m,pixval00,pixval0p, &
           &     pixvalpm,pixvalp0,pixvalpp, &
           &     pixvalmm,pixvalm0,pixvalmp
      real(sp) :: comp
!      real(sp), intrinsic :: sqrt

      !-----------------------------------------------------------------
      if (face_num<0.or.face_num>11) &
           &     stop 'find_maxima: face_num out of range'
      npix=size(map)
      ! if(npix>12*ns_max*ns_max) stop "find_maxima: map too big"
      nside   = npix2nside(npix)
      nsidesq = nside * nside

      !     First do interior
      !     Reduce number of calls to xy2pix_nest
      !     by reusing values from previous step. This brings 9 calls
      !     down to 3. What about parallelisation of inner loop?

      do iy=0+1,nside-1-1
         ix=0
         ixp=ix+1
         iyp=iy+1
         iym=iy-1
         call xy2pix_nest(nside, ix , iym, face_num, ipix0m)
         call xy2pix_nest(nside, ix , iy , face_num, ipix00)
         call xy2pix_nest(nside, ix , iyp, face_num, ipix0p)
         call xy2pix_nest(nside, ixp, iym, face_num, ipixpm)
         call xy2pix_nest(nside, ixp, iy , face_num, ipixp0)
         call xy2pix_nest(nside, ixp, iyp, face_num, ipixpp)
         pixval0m = map(ipix0m)
         pixval00 = map(ipix00)
         pixval0p = map(ipix0p)
         pixvalpm = map(ipixpm)
         pixvalp0 = map(ipixp0)
         pixvalpp = map(ipixpp)
         do ix=0+1,nside-1-1
            ipix00=ipixp0
            pixvalmm=pixval0m
            pixvalm0=pixval00
            pixvalmp=pixval0p
            pixval0m=pixvalpm
            pixval00=pixvalp0
            pixval0p=pixvalpp
            ixp=ix+1
            call xy2pix_nest(nside, ixp, iym, face_num, ipixpm)
            call xy2pix_nest(nside, ixp, iy , face_num, ipixp0)
            call xy2pix_nest(nside, ixp, iyp, face_num, ipixpp)
            pixvalpm = map(ipixpm)
            pixvalp0 = map(ipixp0)
            pixvalpp = map(ipixpp)
            comp=max(pixvalmm,pixvalm0,pixvalmp, &
                 &           pixval0m,pixval0p,pixvalpm,pixvalp0,pixvalpp)
            if(pixval00.gt.comp)then
               peak(ipix00)=+1 ! Maximum
            endif
            comp=min(pixvalmm,pixvalm0,pixvalmp, &
                 &           pixval0m,pixval0p,pixvalpm,pixvalp0,pixvalpp)
            if(pixval00.lt.comp)then
               peak(ipix00)=-1 ! Minimum
            endif
         enddo
      enddo

      !----------------------
      !     Now do boundaries
      !----------------------

      origin=face_num*nsidesq
      iy=0
      !*$*assert concurrent call
      !c$doacross local(ipix00,pixval00,neighb,nn,comp),
      !c$& share(origin,face_num,peak,map,nside)
      do ix=0, nside-1
         call xy2pix_nest(nside,ix,iy,face_num, ipix00)
         pixval00=map(ipix00)
         call neighbours_nest(nside,ipix00,neighb,nn)
         comp=maxval(map(neighb(1:nn)))
         if(pixval00.gt.comp)then
            peak(ipix00)=+1 !Maximum
         endif
         comp=minval(map(neighb(1:nn)))
         if(pixval00.lt.comp)then
            peak(ipix00)=-1 !Minimum
         endif
         if(ix.gt.0)then
            ipix00=origin+mod(swapLSBMSB(ipix00),nsidesq) !E-W flip
            pixval00=map(ipix00)
            call neighbours_nest(nside,ipix00,neighb,nn)
            comp=maxval(map(neighb(1:nn)))
            if(pixval00.gt.comp)then
               peak(ipix00)=+1 !Maximum
            endif
            comp=minval(map(neighb(1:nn)))
            if(pixval00.lt.comp)then
               peak(ipix00)=-1 !Minimum
            endif
         endif
      enddo

      ix=nside-1
      !*$*assert concurrent call
      !c$doacross
      !c local(ipix00,pixval00,neighb,nn,comp), share(peak)
      do iy=1, nside-1
         call xy2pix_nest(nside,ix,iy,face_num, ipix00)
         pixval00=map(ipix00)
         call neighbours_nest(nside,ipix00,neighb,nn)
         comp=maxval(map(neighb(1:nn)))
         if(pixval00.gt.comp)then
            peak(ipix00)=+1 !Maximum
         endif
         comp=minval(map(neighb(1:nn)))
         if(pixval00.lt.comp)then
            peak(ipix00)=-1 !Minimum
         endif
         if(iy.lt.(nside-1))then
            ipix00=origin+mod(swapLSBMSB(ipix00),nsidesq) !E-W flip
            pixval00=map(ipix00)
            call neighbours_nest(nside,ipix00,neighb,nn)
            comp=maxval(map(neighb(1:nn)))
            if(pixval00.gt.comp)then
               peak(ipix00)=+1 !Maximum
            endif
            comp=minval(map(neighb(1:nn)))
            if(pixval00.lt.comp)then
               peak(ipix00)=-1 !Minimum
            endif
         endif
      enddo

      return
   end subroutine find_maxima

end module maxima_tools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
! facility to modify a set of a_lm (spherical harmonics coefficients)
!
! Copyright 1997 by Eric Hivon and Krzysztof M. Gorski.
!  All rights reserved.
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!=======================================================================
  !=======================================================================
  !  EXTERNAL LIBRARY:
  !     this code uses the FITSIO library that can be found at
  !     http://heasarc.gsfc.nasa.gov/docs/software/fitsio/fitsio.html
  !
  !  RELATED LITTERATURE:
  !     about HEALPIX   : see Gorski et al, 2004
  !     about this code : see Hivon & Gorski, 1997, in preparation
  !
  !  HISTORY:
  !     Dec 2004, Eric Hivon, IPAC
  !
  !  FEEDBACK:
  !     for any questions : hivon@iap.fr
  !
  !=======================================================================
  !     version 2.2
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file smoothing.f90 by the command  include
  !
  integer(I4B),             parameter :: KALM  = KMAP ! precision of alm arrays
  integer(I4B),             parameter :: KALMC = KIND((1.0_KMAP, 1.0_KMAP)) ! precision of alm arrays
  !-------------------------------------------------------------------------
  integer(I4B) :: nsmax_in, nlmax_in, nmmax_in, nalms
  integer(I4B) :: nsmax_out, nlmax_out, nmmax_out, nalms_out, nlmin_out
  integer(I4B) :: npol, ncl, nlheader, junk
  integer(I4B) :: i, k, l, m, status, cnt, lmm

  complex(KALMC), dimension(:,:,:), allocatable, target :: alm_sig, alm_err
  complex(KALMC), dimension(:,:),   pointer             :: palms
  real   (KALM),  dimension(:,:,:), allocatable         :: alms_in, alms_out
  real   (DP),    dimension(:,:),   allocatable         :: pixel_in, pixel_out
  real   (DP),    dimension(:,:),   allocatable         :: beam_in, beam_out
  real   (DP),    dimension(:,:),   allocatable         :: window_out

  real   (KALM)                       :: fwhm_deg
  real     (DP)                       :: fwhm_arcmin_in, fwhm_arcmin_out, fwhm_arcmin_def
  character(len=FILENAMELEN)          :: infile_alms,    outfile_alms
  character(len=FILENAMELEN)          :: beam_file_in,   beam_file_out, beam_file_def
  character(len=80), dimension(:,:), allocatable :: header
 !  character(len=*),         parameter :: CODE = 'ALTERALM'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  character(len=10)                   :: sstr
  real     (SP) :: clock_time, time0, time1
  real     (SP) :: ptime, ptime0, ptime1

  character(len=20) :: coord_in, coord_out
  character(len=1), allocatable, dimension(:) :: coord_options
  real(dp) :: phi1, phi2, theta
  real(dp) :: epoch_in, epoch_out

  logical(LGT) :: do_alm_err, do_rot

  integer(I4B)      :: ktype, nsmax
  character(len=20) :: suffix, tag
  character(len=FILENAMELEN) :: def_dir, def_file, usr_dir, usr_file, final_file
  character(len=FILENAMELEN) :: windowname, windowfile, windowfile_in, windowfile_out
  logical(LGT) :: ok

  type(paramfile_handle)              :: handle
!  character(len=FILENAMELEN)          :: parafile = ''
  character(len=FILENAMELEN)          :: description
  !======================================================================

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  print *, " "
  print *,"                    "//CODE//" "//version
  write(*,'(a)') &
       & " *** Modification of a set of alm (spherical harmonics coefficients) ***"
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  print *, " "
  handle = parse_init(parafile)

  description = concatnl(&
       & "", &
       & " Enter the FITS file containing the input a_lm coefficients")
  infile_alms = parse_string(handle, 'infile_alms', descr=description,filestatus='old')
  call read_par(infile_alms, nsmax_in, nlmax_in, ncl, mmax=nmmax_in)
  if (nmmax_in < 0) nmmax_in = nlmax_in
  nalms = number_of_alms(infile_alms, extnum = npol)
  junk = getsize_fits(infile_alms, fwhm_arcmin = fwhm_arcmin_def, beam_leg = beam_file_def,&
       &             coordsys = coord_in, extno=0)
  do_alm_err = (ncl == 5)

  !     *********** FWHM or beam file ************
  !           ---------   IN   ---------
  if (fwhm_arcmin_def < 0) then
     description = concatnl(&
          & "", &
          & " The beam FWHM could not be found in the input a_lm file, ", &
          & " Enter the Gaussian beam FWHM to correct the a_lm from, ", &
          & "  in arcmin  >= 0 (eg: 0.) ")
     fwhm_arcmin_def = 0.0_dp
  else
     description = concatnl(&
          & "", &
          & " Enter the Gaussian beam FWHM to correct the a_lm from, ", &
          & "  in arcmin  >= 0 (eg: 0.) ")
  endif
  fwhm_arcmin_in = parse_double(handle, 'fwhm_arcmin_in', default=fwhm_arcmin_def, vmin=0.0_dp,descr=description)

  beam_file_in = ''
  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " the window function to correct the alm from (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used instead.")
  beam_file_in = parse_string(handle, 'beam_file_in', default=beam_file_def, &
       &                 descr=description, filestatus='old')
  if (trim(beam_file_in) /= '') then
     fwhm_arcmin_in = 0.
     print*,'fwhm_arcmin_in is now : 0.'
     print*,'The beam file '//trim(beam_file_in)//' will be used instead.'
  endif

  if (fwhm_arcmin_in < 0.0 .and. trim(beam_file_in) == '') then
     call fatal_error(CODE//"> no information found on input alms beam")
  endif

  !           ---------   OUT   ---------
  description = concatnl(&
       & "", &
       & " Enter the Gaussian beam FWHM to apply to the alm, ", &
       & "  in arcmin  >= 0 (eg: 0.) ")
  fwhm_arcmin_out = parse_double(handle, 'fwhm_arcmin_out', default=fwhm_arcmin_in, vmin=0.0_dp,descr=description)

  beam_file_out = ''
  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " the window function to apply to the alm (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used.")
  beam_file_out = parse_string(handle, 'beam_file_out', default="''", &
       &                 descr=description, filestatus='old')
  if (trim(beam_file_out) /= '') then
     fwhm_arcmin_out = 0.
     print*,'fwhm_arcmin_out is now : 0.'
     print*,'The beam file '//trim(beam_file_out)//' will be used instead.'
  endif
  fwhm_deg = fwhm_arcmin_out / 60.0_dp

  !     *********** coordinate system ************
  !           ---------   IN   ---------
  epoch_in = 2000.0_dp
  epoch_out = 2000.0_dp
  allocate(coord_options(1:9))
  coord_options = (/ 'C', 'E', 'Q', 'G', 'c', 'e', 'q', 'g', ' ' /)
  coord_in=''
  if (.not. any(coord_options(1:8)==trim(adjustl(coord_in)))) then
     description = concatnl(&
       & "", &
       & " The astronomical coordinate system of the input file was not found, ", &
       & "  or is not valid: "//trim(coord_in), &
       & " If you want to ROTATE the alm, you will have to provide one as below,", &
       & " if not, leave it blank", &
       & " G = Galactic, E = Ecliptic, C/Q = Celestial = eQuatorial")
     coord_in = parse_string(handle,'coord_in',default='',descr=description,options=coord_options)
  else
     description = concatnl(&
       & "", &
       & " If you want to ROTATE the alm, provide the input astro. coordinates as below,", &
       & " if not, leave it blank", &
       & " G = Galactic, E = Ecliptic, C/Q = Celestial = eQuatorial")
     coord_in = parse_string(handle, 'coord_in',default=coord_in,descr=description, options=coord_options)
  endif
  description = concatnl(&
       & "", &
       & " Provide the coordinate epoch used for Ecliptic precession")
  epoch_in = parse_double(handle, 'epoch_in',default=2000.0_dp,descr=description)

  !           ---------   OUT   ---------
  coord_out=''
  if (trim(coord_in) /= '' .or. handle%interactive) then
     description = concatnl(&
          & "", &
          & " Provide the output astronomical coordinate system")
     coord_out = parse_string(handle, 'coord_out',default=coord_in,descr=description, options=coord_options)
  endif
  description = concatnl(&
       & "", &
       & " Provide the coordinate epoch used for Ecliptic precession")
  epoch_out = parse_double(handle, 'epoch_out',default=epoch_in,descr=description)
  do_rot = (trim(coord_in) /= '' .and. trim(coord_in) /= trim(coord_out))
  do_rot = (do_rot .or. (epoch_in /= epoch_out))

  !     *********** pixel size ************
  !           ---------   IN   ---------
  if (nsmax_in < 0) then
     description = concatnl(&
          & "", &
          & " The resolution parameter (Nside) of the input file was not found ", &
          & " Enter the correct one (or 0 if the alm were free of pixel window)")
     nsmax_in = parse_int(handle, 'nsmax_in', vmin=0, descr=description)
  endif

  !           ---------   OUT   ---------
  sstr = trim(string(nsmax_in,'(i6)'))
  description = concatnl(&
       & "", &
       & " The resolution parameter (Nside) for the alm was "//sstr, &
       & " Enter the Nside whose pixel window function will be applied to the a_lm, ",&
       & " after correcting for the input one ",&
       & " (Nside HAS to be a power of 2, eg: 32, 512, ..., or 0 for no pixel)" )
  nsmax_out = parse_int(handle, 'nsmax_out', default=nsmax_in, vmin=0, descr=description)


  !     --- check for pixel-window-files ---
  do ktype=1,2
     if (ktype == 1) then
        nsmax = nsmax_in
        suffix = '_in'
        tag = ' (INPUT alm) '
     endif
     if (ktype == 2) then
        nsmax = nsmax_out
        suffix = '_out'
        tag = ' (OUTPUT alm) '
     endif

     if (nsmax > 0) then
        windowname = get_healpix_pixel_window_file(nsmax)
        def_file = trim(windowname)
        def_dir  = get_healpix_data_dir()

22      continue
        final_file = ''
        ok = .false.
        ! if interactive, try default name in default directories first
        if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
        if (.not. ok) then
           ! not found, ask the user
           description = concatnl("",&
                &        " Could not find "//trim(tag)//" window file", &
                &        " Enter the directory where this file can be found:")
           usr_dir = parse_string(handle,'winfiledir'//trim(suffix),default="''",descr=description)
           if (trim(usr_dir) == '') usr_dir = trim(def_dir)
           description = concatnl("",&
                &        " Enter the name of the "//trim(tag)//" window file:")
           usr_file = parse_string(handle,'windowfile'//trim(suffix),default=def_file,descr=description)
           ! look for new name in user provided or default directories
           ok   = scan_directories(usr_dir, usr_file, final_file)
           ! if still fails, crash or ask again if interactive
           if (.not. ok) then
              print*,' File not found'
              if (handle%interactive) goto 22
              call fatal_error(code)
           endif
        endif
        windowfile = final_file
     else
        windowfile = ''
     endif
     if (ktype == 1) windowfile_in  = windowfile
     if (ktype == 2) windowfile_out = windowfile
  enddo

  !     *********** multipole range ************
  !           ---------   IN   ---------
  nlmin_out = 0
  sstr = trim(string(nlmax_in,'(i6)'))
!   lmm = min(3*nsmax_out-1, nlmax_in)
  lmm = nlmax_in
  description = concatnl(&
       & "", &
       & " The maximum multipole for the alm was "//sstr, &
       & " Enter the maximum multipole for the output." )
  nlmax_out = parse_int(handle, 'nlmax_out', default=nlmax_in, vmin=0, vmax=lmm, descr=description)
  nmmax_out = min(nlmax_out, nmmax_in)

  !           ---------   OUT   ---------
  description = concatnl(&
       & "", &
       & " Enter the FITS file to contain the output a_lm coefficients")
  outfile_alms = parse_string(handle, 'outfile_alms', descr=description,filestatus='new')

  print *," "
!  call parse_summarize(handle)
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
  call brag_openmp()

  !------------------------------------
  ! allocate arrays
  !------------------------------------
  nlheader = 120
  allocate(header(1:nlheader, 1:npol))
  allocate(alm_sig(1:npol, 0:nlmax_in, 0:nmmax_in), stat = status)
  call assert_alloc(status,CODE,"alms_sig")
  if (do_alm_err) then
     allocate(alm_err(1:npol, 0:nlmax_in, 0:nmmax_in), stat = status)
     call assert_alloc(status,CODE,"alms_err")
  endif

  !------------------------------------
  ! input alm's
  !------------------------------------
  allocate(alms_in(0:nalms-1,1:ncl+1,1:npol),stat = status)
  call assert_alloc(status,CODE,"alms_in")

  print *,"      "//CODE//"> Inputting alms "
  !!  print*,trim(infile_alms),nalms,ncl,nlheader,npol
  call fits2alms(infile_alms, nalms, alms_in, ncl, header, nlheader, npol)
  !!  print*,'alms read'
  do k = 1, npol ! loop on T, [E, B]
     do i = 0, nalms-1
        l = nint(alms_in(i,1,k))
        m = nint(alms_in(i,2,k))
        if (m < 0) then
           write(*,'(a,i6,a,i6)') '     the a_lm with m<0 are ignored, l=',l,', m=',m
        else if (l > nlmax_in .or. m> nmmax_in .or. m>l) then
           print*,'Error on l,m',l,m
           print*,'larger than ',nlmax_in, nmmax_in
           call fatal_error(CODE)
        else
           alm_sig(k,l,m) = CMPLX(alms_in(i,3,k), alms_in(i,4,k), kind=KALM)
           if (do_alm_err) then 
              alm_err(k,l,m) = CMPLX(alms_in(i,5,k), alms_in(i,6,k), kind=KALM)
           endif
        endif
     enddo
  enddo
  deallocate(alms_in)

  !------------------------------------
  ! alter alm's
  !------------------------------------
  print *,"      "//CODE//"> Altering alms "

  ! generate input window function (pixel & beam)
  allocate(pixel_in(0:nlmax_in, 1:npol), beam_in(0:nlmax_in, 1:npol), stat=status)
  call assert_alloc(status, CODE, "pixel_in, beam_in")
  if (nsmax_in == 0) then
     call pixel_window(pixel_in, nside=nsmax_in)
  else
     call pixel_window(pixel_in, windowfile=windowfile_in)
  endif
  call generate_beam(fwhm_arcmin_in, nlmax_in, beam_in, beam_file=beam_file_in)

  ! generate output window function (pixel & beam)
  allocate(pixel_out(0:nlmax_out, 1:npol), beam_out(0:nlmax_out, 1:npol), stat=status)
  call assert_alloc(status, CODE, "pixel_out, beam_out")
  if (nsmax_out == 0) then
     call pixel_window(pixel_out, nside=nsmax_out)
  else
     call pixel_window(pixel_out, windowfile=windowfile_out)
  endif
  call generate_beam(fwhm_arcmin_out, nlmax_out, beam_out, beam_file=beam_file_out)

  ! generate effective window function
  allocate(window_out(0:nlmax_out, 1:npol), stat=status)
  call assert_alloc(status, CODE, "window_out")

  window_out = pixel_in(0:nlmax_out, 1:npol) * beam_in(0:nlmax_out, 1:npol)
  where(window_out == 0.0) window_out = 1.e-15
  window_out = (pixel_out * beam_out) / window_out

  call alter_alm(0_i4b, nlmax_out, nmmax_out, 0.0_KALM, alm_sig, &
       &            window=real(window_out,kind=KALM))
  if (do_alm_err) then
     call alter_alm(0_i4b, nlmax_out, nmmax_out, 0.0_KALM, alm_err, &
          &            window=real(window_out,kind=KALM))
  endif

  ! rotate alm's
  if (do_rot) then
     call brag_openmp()
     coord_in  = trim(strupcase(coord_in))
     coord_out = trim(strupcase(coord_out))
9700 format(7x,a,a," (",f6.1,")",a,a," (",f6.1,")")
     write(*,9700) CODE//'> Rotating alms:   ', &
          & trim(coord_in),epoch_in,' -> ',trim(coord_out),epoch_out
     ! figure out Euler angles corresponding to coordinate changes
     call coordsys2euler_zyz(epoch_in, epoch_out, coord_in, coord_out, phi1, theta, phi2)
!     print*,phi1,theta,phi2
     ! perform the rotation
     call rotate_alm(nlmax_out, alm_sig, phi1, theta, phi2)
     if (do_alm_err) then
        call rotate_alm(nlmax_out, alm_err, phi1, theta, phi2)
     endif
  endif
  !------------------------------------
  ! output alm's
  !------------------------------------
  print *,"      "//CODE//"> Outputting alms "

  ! update header read from input file
  do k = 1, npol
     if (trim(beam_file_out) == "") then
        call add_card(header(1:,k),"FWHM"    ,fwhm_deg   ," [deg] FWHM of gaussian symmetric beam")
     else
        call add_card(header(1:,k),"BEAM_LEG",trim(beam_file_out),"File containing Legendre transform of symmetric beam")
     endif
     call add_card(header(1:,k),"NSIDE", nsmax_out, "Resolution parameter for HEALPIX")
     call add_card(header(1:,k),"MAX-LPOL",nlmax_out  ,"Maximum multipole l ") ! updated by FITS writting routines
     call add_card(header(1:,k),"MIN-LPOL",nlmin_out  ,"Minimum multipole l ") ! updated by FITS writting routines
     call add_card(header(1:,k),"MAX-MPOL",nmmax_out  ,"Maximum m ")           ! updated by FITS writting routines
     call add_card(header(1:,k),"COORDSYS",coord_out  ,"Coordinates system ")
     call add_card(header(1:,k),"EPOCH",   epoch_out  ,"Coordinates system epoch")
     call add_card(header(1:,k),"HISTORY"," file "//trim(infile_alms))
     call add_card(header(1:,k),"HISTORY"," modified by "//CODE//" "//VERSION)
     if (fwhm_arcmin_out /= fwhm_arcmin_in) call add_card(header(1:,k),"HISTORY"," changed FWHM")
     if (beam_file_out /= beam_file_in) call add_card(header(1:,k),"HISTORY"," changed BEAM_LEG")
     if (nsmax_out /= nsmax_in) call add_card(header(1:,k),"HISTORY"," changed NSIDE")
     if (nlmax_out /= nlmax_in) call add_card(header(1:,k),"HISTORY"," changed MAX-LPOL")
     if (coord_out /= coord_in) call add_card(header(1:,k),"HISTORY"," changed COORDSYS")
     if (epoch_out /= epoch_in) call add_card(header(1:,k),"HISTORY"," changed EPOCH")
  enddo

  if (do_alm_err) then
     nalms_out = ((nmmax_out+1)*(2*nlmax_out+2-nmmax_out))/2
     allocate(alms_out(0:nalms_out-1, 1:ncl+1, 1:npol), stat=status)
     call assert_alloc(status, CODE, "alms_out")
     do k = 1, npol
        cnt = 0
        do l = 0, nlmax_out
           do m = 0, min(l, nmmax_out)
              alms_out(cnt, 1, k) = l
              alms_out(cnt, 2, k) = m
              alms_out(cnt, 3, k) = real (alm_sig(k,l,m), kind=KALM) !       ---> col 2
              alms_out(cnt, 4, k) = aimag(alm_sig(k,l,m))            !       ---> col 3
              alms_out(cnt, 5, k) = real (alm_err(k,l,m), kind=KALM) !       ---> col 4
              alms_out(cnt, 6, k) = aimag(alm_err(k,l,m))            !       ---> col 5
              cnt = cnt + 1
           enddo
        enddo
        call assert(cnt <= nalms_out, CODE//' Error on index')
     enddo
     call alms2fits(outfile_alms, nalms_out, alms_out, ncl, header, nlheader, npol)
     deallocate(alms_out)
  else
     do k = 1, npol
        palms => alm_sig(k,0:nlmax_out,0:nmmax_out)
        call dump_alms (outfile_alms, palms, nlmax_out, header(:,k), nlheader, k-1_i4b)
     enddo
  endif
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" run"
  write(*,9000) "------------------------------------"
  write(*,9000) " "
  write(*,9000) " Input a_lms           : "//TRIM(infile_alms)
  write(*,9005) " Input Nside           : ",nsmax_in
  write(*,9005) " Input multipole range : 0 < l <= ", nlmax_in
  write(*,9300) " Input coordinates     : ",trim(coord_in),epoch_in
  if (trim(beam_file_in) == '') then
     write(*,9020) " Input Gauss. FWHM ['] : ", fwhm_arcmin_in
  else
     write(*,9000) " Input beam file       : "//trim(beam_file_in)
  endif
  write(*,9000) " Output a_lms          : "//TRIM(outfile_alms)
  if (nsmax_in /= nsmax_out) &
       & write(*,9005)       " Output Nside          : ",nsmax_out
  if (nlmax_in /= nlmax_out) &
       & write(*,9005) " Output multipole range: 0 < l <= ", nlmax_out
  if (do_rot) write(*,9300) " Output coordinates    : ",trim(coord_out),epoch_out
  if (trim(beam_file_out) == '') then
     write(*,9020) " Output Gauss. FWHM [']: ", fwhm_arcmin_out
  else
     write(*,9000) " Output beam file      : "//trim(beam_file_out)
  endif
  write(*,9030) " Clock and CPU time [s]: ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)
9300 format(a,a," (",f6.1,")")

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module misc_utils
!   subroutine fatal_error
!   function file_present
!   subroutine assert_present
!   subroutine assert_directory_present
!   subroutine assert_not_present
!   subroutine assert_alloc
!   subroutine assert
!   function strupcase
!   function strlowcase
!   function expand_env_var
!   function string
!   subroutine wall_clock_time
!   subroutine brag_openmp
!--------------------------------------------------------------------------------------
  ! edited 2006-10-31: fatal_error for gfortran gcc4.1.1 bug workaround (V. Stolyarov)
  ! 2007-06-06: string() now accepts LGT variables
  ! 2008-03-25: added expand_env_var, string() accepts 64-bit integer variables (on systems that can deal with them)
  ! 2012-10-29: edited file_present to accept virtual files and CFITSIO 'extended filenames'
  !    the NOCFITSIO flag must be set to return to standard UNIX 'inquire' behavior
  !--------------------------------------------------------------------------------------
  use healpix_types
  use extension, only : exit_with_status, getEnvironment
  implicit none
  private

  integer, parameter, private :: LCH=48
  interface string
#ifdef NO64BITS
     module procedure string_l, string_i,           string_s, string_d
#else
     module procedure string_l, string_i, string_j, string_s, string_d
#endif
  end interface

  interface fatal_error
  	module procedure fatal_error_womsg, fatal_error_msg
  end interface


  public :: fatal_error, assert, assert_present, assert_not_present, &
       & assert_alloc, file_present, assert_directory_present
  public :: upcase, lowcase
  public :: wall_clock_time
  public :: brag_openmp
  public :: strupcase, strlowcase, string
  public :: expand_env_var

contains
  !-----------------------------------------------------
!  subroutine fatal_error (msg)
!    character(len=*), intent(in), optional :: msg
!
!    if (present(msg)) then
!       print *,'Fatal error: ', trim(msg)
!    else
!       print *,'Fatal error'
!    endif
!    call exit_with_status(1)
!  end subroutine fatal_error

  subroutine fatal_error_msg (msg)
    character(len=*), intent(in) :: msg
       print *,'Fatal error: ', trim(msg)
    call exit_with_status(1)
  end subroutine fatal_error_msg

  subroutine fatal_error_womsg
      print *,'Fatal error'
    call exit_with_status(1)
  end subroutine fatal_error_womsg


  !-----------------------------------------------------
  function file_present (filename)
    character(len=*), intent(in) :: filename
    logical :: file_present
    integer :: ft_flag, ft_status
    real(sp) :: version
    real(sp) :: reqversion

#ifdef NOCFITSIO
    inquire(file=trim(filename),exist=file_present)
#else
    ft_status = 0
    reqversion = 3.20
    call ftvers(version)
    if (version  < (reqversion-0.001)) then
       print *,'******************************************************'
       print *,'CFITSIO library (version ' &
            & //trim(string(version,format='(f6.3)')) &
            & //') is too old.'
       print *,'Version ' &
            & //trim(string(reqversion,format='(f6.3)')) &
            & //' or more is required.'
       print *,'******************************************************'
    endif
    call ftexist(filename, ft_flag, ft_status)
    ! accept disk files (+1) and remote/virtual files (-1)
    file_present = (ft_flag == 1  .or. ft_flag == -1)
#endif

  end function file_present

  !-----------------------------------------------------
  subroutine assert_present (filename)
    character(len=*), intent(in) :: filename

    if (.not. file_present(trim(filename))) then
       print *, 'Error:  file ' // trim(filename) // ' does not exist!'
       call exit_with_status(1)
    end if
  end subroutine assert_present

  !-----------------------------------------------------
  subroutine assert_directory_present (filename)
    character(len=*), intent(in) :: filename
    integer pos

    pos = scan(filename,'/',back=.true.)
    if (pos<=0) return

    if (.not. file_present(filename(:pos-1))) then
       print *, 'Error:  directory ' // filename(:pos-1) // ' does not exist!'
       call exit_with_status(1)
    end if
  end subroutine assert_directory_present

  !-----------------------------------------------------
  subroutine assert_not_present (filename)
    character(len=*), intent(in) :: filename

    if (file_present(trim(filename))) then
       print *, 'Error:  file ' // trim(filename) // ' already exists!'
       call exit_with_status(1)
    end if
  end subroutine assert_not_present

  !-----------------------------------------------------
  subroutine assert_alloc (stat,code,arr)
!!    integer, intent(in) :: stat
    integer(i4b), intent(in) :: stat
    character(len=*), intent(in) :: code, arr

    if (stat==0) return

    print *, trim(code)//'> cannot allocate memory for array: '//trim(arr)
    call exit_with_status(1)
  end subroutine assert_alloc

  !-----------------------------------------------------
  subroutine assert (testval,msg,errcode)
    logical, intent(in) :: testval
    character(len=*), intent(in), optional :: msg
    integer(i4b), intent(in), optional :: errcode

    if (testval) return

    print *,"Assertion failed: "
    if (present(msg)) print *, trim(msg)
    if (present(errcode)) call exit_with_status (errcode)
    call exit_with_status(1)
  end subroutine assert

  !-----------------------------------------------------
  subroutine upcase(instr, outstr)
    ! turns a string to upper case
    ! instr and outstr can be the same variable
    character(len=*), intent(in)  :: instr
    character(len=*), intent(out) :: outstr

    integer(i4b) :: i, j, ascii, ll, la, ua

    la = iachar('a')
    ua = iachar('A')

    ll = len_trim(outstr)
    do i = 1, min(len_trim(instr),ll)
       ascii = iachar( instr(i:i) )
       if (ascii >= la .and. ascii < la+26) then ! in [a,z]
          outstr(i:i) = achar( ascii - la + ua )
       else
          outstr(i:i) = instr(i:i)
       endif
    enddo
    do j = i, ll ! pad with blanks
       outstr(j:j) = ' '
    enddo
    return
  end subroutine upcase

  !-----------------------------------------------------
  subroutine lowcase(instr, outstr)
    ! turns a string to lower case
    ! instr and outstr can be the same variable
    character(len=*), intent(in)  :: instr
    character(len=*), intent(out) :: outstr

    integer(i4b) :: i, j, ascii, ll, la, ua

    la = iachar('a')
    ua = iachar('A')

    ll = len_trim(outstr)
    do i = 1, min(len_trim(instr),ll)
       ascii = iachar( instr(i:i) )
       if (ascii >= ua .and. ascii < ua+26) then ! in [A,Z]
          outstr(i:i) = achar( ascii - ua + la )
       else
          outstr(i:i) = instr(i:i)
       endif
    enddo
    do j = i, ll ! pad with blanks
       outstr(j:j) = ' '
    enddo
    return
  end subroutine lowcase
  !-----------------------------------------------------
  function strupcase(instr) result(outstr)
    ! turns a character string to upper case
    character(len=*), intent(in)  :: instr
    character(len=FILENAMELEN)    :: outstr

    integer(i4b) :: i, ascii, la, ua

    la = iachar('a')
    ua = iachar('A')

    outstr = instr
    do i = 1, min(len_trim(instr),len_trim(outstr))
       ascii = iachar( instr(i:i) )
       if (ascii >= la .and. ascii < la+26) then ! in [a,z]
          outstr(i:i) = achar( ascii - la + ua )
       endif
    enddo

    return
  end function strupcase

  !-----------------------------------------------------
  function strlowcase(instr) result(outstr)
    ! turns a string to lower case
    character(len=*), intent(in)  :: instr
    character(len=FILENAMELEN)    :: outstr

    integer(i4b) :: i, ascii, la, ua

    la = iachar('a')
    ua = iachar('A')

    outstr = instr
    do i = 1, min(len_trim(instr),len_trim(outstr))
       ascii = iachar( instr(i:i) )
       if (ascii >= ua .and. ascii < ua+26) then ! in [A,Z]
          outstr(i:i) = achar( ascii - ua + la )
       endif
    enddo

    return
  end function strlowcase

  !-----------------------------------------------------
  function expand_env_var(instr) result(outstr)
    ! substitute an evironment variable invocation ${VAR} 
    ! with its value in a string
    character(len=*), intent(in) :: instr
    character(len=FILENAMELEN)   :: outstr, tmp, varname, varvalue
    integer  :: i1, i2, ln
    character(len=*), parameter :: code = 'expand_env_var'

    outstr = trim(adjustl(instr))

    ! replace leading ~/ with the value of $HOME
    i1 = index(outstr,'~/')
    if (i1 == 1) then
       ln = len_trim(outstr)
       call getEnvironment('HOME',varvalue)
       tmp = trim(adjustl(varvalue))//outstr(2:ln)
       outstr = trim(adjustl(tmp))
    endif

    ! replace ${XXX} with the value of $XXX
    do
       ln = len_trim(outstr)
       i1 = index(outstr,'${')
       if (i1 <= 0) exit
       i2 = index(outstr,'}')
       
       if (i2 <=  i1 + 1) then
          print*,'WARNING: '//code//' can not process string: '//trim(instr)
          print*,'         Unmatched  { or } .'
          outstr = instr
          return
       endif
       varname = outstr(i1+2:i2-1)
       call getEnvironment(varname, varvalue)
       tmp = outstr(1:i1-1)//trim(adjustl(varvalue))//outstr(i2+1:ln)
       outstr = trim(adjustl(tmp))
    enddo
    
    return
  end function expand_env_var
  !========================================
  ! function string(arg, format)
  ! accepts: logical, i8, I4, SP and DP
  !=======================================
  function string_l(arg, format) result(str)
    logical(lgt) :: arg
    character(len=*),   optional :: format
    character(len=LCH)           :: str
    if (present(format)) then
       write(str,format) arg
    else
       write(str,*) arg
    endif
    return
  end function string_l
  !--------------------------------
  function string_i(arg, format) result(str)
    integer(i4b) :: arg
    character(len=*),   optional :: format
    character(len=LCH)           :: str
    if (present(format)) then
       write(str,format) arg
    else
       write(str,*) arg
    endif
    return
  end function string_i
  !--------------------------------
#ifndef NO64BITS
  ! only on systems supporting 64-bit integers
  function string_j(arg, format) result(str)
    integer(i8b) :: arg
    character(len=*),   optional :: format
    character(len=LCH)           :: str
    if (present(format)) then
       write(str,format) arg
    else
       write(str,*) arg
    endif
    return
  end function string_j
#endif
  !--------------------------------
  function string_s(arg, format) result(str)
    real(sp) :: arg
    character(len=*),   optional :: format
    character(len=LCH)           :: str
    if (present(format)) then
       write(str,format) arg
    else
       write(str,*) arg
    endif
    return
  end function string_s
  !--------------------------------
  function string_d(arg, format) result(str)
    real(dp) :: arg
    character(len=*),   optional :: format
    character(len=LCH)           :: str
    if (present(format)) then
       write(str,format) arg
    else
       write(str,*) arg
    endif
    return
  end function string_d
  !--------------------------------

  !-----------------------------------------------------
  subroutine wall_clock_time(time_sec)
    real(sp), intent(out) :: time_sec

    integer :: clock, clock_rate, clock_max
    integer, dimension(8) :: values_time

    time_sec = 0.

    call system_clock(count=clock, count_rate=clock_rate, count_max=clock_max)

    if (clock < 0 .or. clock_rate <= 0 .or. clock_max <= 0) then
       call date_and_time(values = values_time) ! y, m, d, x, h, m, s, ms
       if (minval(values_time) >= 0) then
          time_sec = ((values_time(3)*24. &
               &     + values_time(5)    )*60. &
               &     + values_time(6)        )*60. &
               &     + values_time(7) + values_time(8)/1000.
       endif
    else
       time_sec = clock/real(clock_rate)
    endif

    return
  end subroutine wall_clock_time
  !================================================
  subroutine brag_openmp()
  !================================================
    ! OpenMP bragging
    !================================================
    ! OpenMP variables
    !$     integer :: omp_get_thread_num, omp_get_num_threads, omp_get_num_procs
    !IBMP  integer :: omp_get_thread_num, omp_get_num_threads, omp_get_num_procs

!$OMP parallel
!
!$   if (omp_get_thread_num() == 0) then
!$       write(*,9000) ' --------------------------------------'
!$       write(*,9010) ' Number of OpenMP threads in use: ', omp_get_num_threads()
!$       write(*,9010) ' Number of CPUs available:        ', omp_get_num_procs()
!$       write(*,9000) ' --------------------------------------'
!$   end if
!
!IBMP   if (omp_get_thread_num() == 0) then
!IBMP       write(*,9000) ' --------------------------------------'
!IBMP       write(*,9010) ' Number of OpenMP threads in use: ', omp_get_num_threads()
!IBMP       write(*,9010) ' Number of CPUs available:        ', omp_get_num_procs()
!IBMP       write(*,9000) ' --------------------------------------'
!IBMP   end if
!
!$OMP end parallel
9000 format(a)
9010 format(a,i4)

    return
  end subroutine brag_openmp

end module misc_utils

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module head_fits

  !-------------------------------------------------------------------------
  ! this module (head_fits) introduced in Healpix 1.2
  ! merges the module wrap_fits present in version 1.1
  ! and the modules strip_fits that appeared in some intermediate versions
  !
  ! It is designed to read and write header information in FITS files
  !
  ! EH, 2002-08-09
  ! 2007-09-20 added write_minimal_header
  ! 2009-01-08 corrected typo in FITS header written by write_minimal_header (DY_Y -> DY_T)
  ! 2013-05-07: G95-compatible
  ! 2014-05-02: fixed problem with keywords having a long string value
  ! 2018-05-28: write_minimal_header: in agreement with IDL, healpy, C++?
  !    IQU maps are now column names TEMPERATURE, Q_POLARISATION, U_POLARISATION,
  !            
  !-------------------------------------------------------------------------

  ! subroutine add_card   [interface]
  ! subroutine write_hl
  ! subroutine merge_headers
  !
  ! subroutine get_card   [interface]
  !
  ! subroutine del_card
  !
  ! write_minimal_header

  USE healpix_types
  USE misc_utils
  interface add_card
     ! add_card generic routine
     ! ------------------------
     ! adds a card to a fits header
     ! syntax = call add_card(header, keyword, value [, comment])
     !   header  = character string array
     !   keyword = character string (NON BLANK)
     !   value   = can be either logical, integer, real, double, character
     !   comment = (optional) character string scalar
     !
#ifdef NO64BITS
     ! if 64 bit (=8 bytes) integer is NOT supported
     module procedure d_add_card, f_add_card, a_add_card, i_add_card,              l_add_card, v_add_card
#else
     ! if 64 bit (=8 bytes) integer is supported
     module procedure d_add_card, f_add_card, a_add_card, i_add_card, ii_add_card, l_add_card, v_add_card
#endif

  end interface

  interface get_card
     ! get_card generic routine
     ! ------------------------
     ! read a keyword (case UNsensitive) from a FITS header
     ! syntax = call get_card(header, keyword, value [, comment, count])
     !   header  = (input) character string array
     !   keyword = (input) character string scalar
     !   value   = (output) can be either logical, integer, real, double, character
     !              contains on output value of keyword
     !   comment = (output, optional) character string scalar
     !              contains on output value of comment field
     !   count   = (output, optional) integer scalar,
     !       is set to 1 if the keyword is found and 0 otherwise
     !
     ! except if value is declared as a character string,
     ! its type should match that in the fits file
     !
#ifdef NO64BITS
     ! if 64 bit (=8 bytes) integer is NOT supported
     module procedure d_get_card, f_get_card, a_get_card, i_get_card,              l_get_card
#else
     ! if 64 bit (=8 bytes) integer is supported
     module procedure d_get_card, f_get_card, a_get_card, i_get_card, ii_get_card, l_get_card
#endif
  end interface

  interface del_card
     ! del_card generic routine
     ! ------------------------
     ! deletes a card from a fits header
     ! syntax = call del_card(header, keywords) or
     !          call del_card(header, keyword)
     !   header   = character string array
     !   keywords = character string vector (NON BLANK)
     !   keywords = character string  (NON BLANK)
     !
     module procedure del_card1, del_cardn
  end interface

  private

  character (LEN=1 ), private :: dtype
  character (LEN=20), private :: stval
  character (LEN=80), private :: card, stcom
! work arond G95 bug that does not accept SAVEd variables with value 0 or .false. (2013-05-07)
!   integer(kind=I4B) , private :: nlh, statusfits, count_in = 0
!   logical(kind=LGT) , private :: match, exact, casesen = .false., verbose = .true.
  integer(kind=I4B), private :: nlh, statusfits, count_in
  logical(kind=LGT), private :: match, exact
  logical(kind=LGT), private, parameter :: casesen = .false., verbose = .true.

  public :: add_card, merge_headers

  public :: get_card

  public :: del_card

  public :: write_minimal_header
contains

  !=====================================================================
  subroutine d_add_card(header, kwd, value, comment, update) ! double precision
    real(kind=DP), intent(IN) :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update

    write(stval,'(1pe20.12)') value
    call write_hl(header, kwd, stval, comment, update)
    RETURN
  END subroutine d_add_card
  !=====================================================================
  subroutine f_add_card(header, kwd, value, comment, update) ! single precision
    real(kind=SP), intent(IN) :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update

    write(stval,'(1pe20.8)') value
    call write_hl(header, kwd, stval, comment, update)
    RETURN
  END subroutine f_add_card
  !=====================================================================
  subroutine a_add_card(header, kwd, value, comment, update) ! character
    character (LEN=*), intent(IN), OPTIONAL :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update
    character (LEN=240) :: st_value, st_comment
    logical(LGT) :: long_strn, actual

    st_value   = ''
    st_comment = ''
    long_strn=.false.
    actual = (trim(kwd) /= "COMMENT" .and. trim(kwd) /= "HISTORY" .and. trim(kwd) /= "CONTINUE")
    if (present(value)  ) then
       write(st_value,'(a)')   value
       st_value = adjustl(st_value)
       long_strn = (actual .and. len_trim(st_value) > 68)
       if (st_value(1:1) /= "'" .and. actual) st_value = "'"//trim(st_value)//"'"
    endif
    if (present(comment)) write(st_comment,'(a)') comment
    call write_hl(header, kwd, st_value, st_comment, update, long_strn=long_strn)
    RETURN
  END subroutine a_add_card
  !=====================================================================
  subroutine i_add_card(header, kwd, value, comment, update) ! integer (i*4)
    integer(kind=I4B), intent(IN) :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update

    write(stval,'(i20)') value
    call write_hl(header, kwd, stval, comment, update)
    RETURN
  END subroutine i_add_card
  !=====================================================================
#ifndef NO64BITS
  ! compile 8 byte integer flavor only if possible
  subroutine ii_add_card(header, kwd, value, comment, update) ! integer (i*8)
    integer(kind=I8B), intent(IN) :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update

    write(stval,'(i20)') value
    call write_hl(header, kwd, stval, comment, update)
    RETURN
  END subroutine ii_add_card
#endif
  !=====================================================================
  subroutine l_add_card(header, kwd, value, comment, update) ! logical
    logical(kind=LGT), intent(IN) :: value
    character (LEN=80), dimension(:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update

    write(stval,'(l7)') value
    call write_hl(header, kwd, stval, comment, update)
    RETURN
  END subroutine l_add_card
  !=====================================================================
  subroutine v_add_card(header) ! blank line
    character (LEN=80), dimension(:), intent(INOUT) :: header

    call write_hl(header, 'COMMENT', ' ', ' ')
!    call write_hl(header, ' ', ' ', ' ')
  END subroutine v_add_card
  !=====================================================================
  subroutine write_hl(header, kwd, st_value, comment, update, long_strn)
    IMPLICIT none
    character (LEN=80), dimension(1:), intent(INOUT) :: header
    character (LEN=*), intent(IN) :: kwd
    character (LEN=*), intent(IN), OPTIONAL  :: st_value
    character (LEN=*), intent(IN), OPTIONAL  :: comment
    logical(LGT),      intent(IN), OPTIONAL  :: update, long_strn
    integer(kind=I4B) :: iblank, iwrite, hdtype, kmatch, iwlong

    character (LEN=480) :: fullcard
    character (LEN=80)  :: oldline
    character (LEN=20)  :: kwd2, this_kwd
    logical(LGT)        :: do_update, do_long_strn
    !=====================================================================

    fullcard=''
    oldline=''

    do_update = .false.
    if (present(update)) do_update = update

    do_long_strn = .false.
    if (present(long_strn)) do_long_strn = long_strn

    nlh = size(header)
    ! iblank = first blank line
    iblank = nlh + 1
    do
       if (iblank == 1) exit
       if (trim(header(iblank-1)) /= '') exit
       iblank = iblank - 1
    enddo


    kwd2 = adjustl(strupcase(kwd))
    fullcard = kwd2
    if (present(st_value)) fullcard = fullcard(1:max( 8,len_trim(fullcard)))//' '//trim(adjustl(st_value))
    if (present(comment)) then
       if (len_trim(adjustl(comment)) > 0) then
          if (do_long_strn) then ! put a slash between value and comment for easier idenfication later on
             fullcard = fullcard(1:max(32,len_trim(fullcard)))//' / '//trim(adjustl(comment))
          else
             fullcard = fullcard(1:max(32,len_trim(fullcard)))//' '//trim(adjustl(comment))
          endif
       endif
    endif

    if (iblank > nlh) then
       print*,'WARNING: Header is too short ('//trim(string(nlh))//' lines); card not written:'
       print*,trim(fullcard)
       return
    endif

    if (trim(fullcard) == 'COMMENT') then ! COMMENT alone
       header(iblank) = 'COMMENT'
!       iblank = iblank + 1
       return
    endif

    hdtype = 0
    statusfits = 0
    CALL ftgthd(fullcard(1:79), oldline, hdtype, statusfits)
    if (statusfits == 205) statusfits = 0 ! ignore unmatched quotes due to long strings
    ! hdtype: -1: delete, 0: append or replace, 1: append, 2: END
    select case (hdtype)
    case (-1)! delete keyword
       header(iblank) = fullcard(1:79)
    case (0)
       if (do_update) then ! update (possibly) existing keyword, removing other matches
          kmatch = 0
          do iwrite = 1, iblank ! scan the header
             oldline = header(iwrite)
             this_kwd = strupcase(oldline(1:len_trim(kwd2)))
             if (trim(this_kwd) == trim(kwd2) .or. iwrite == iblank) then ! find first matching line or reach first blank line
                kmatch = kmatch + 1
                if (kmatch == 1) then ! first match: insert or add line
                   call insert_line_in_header(header, iwrite, fullcard, overwrite=do_update, long_strn = do_long_strn)
                else ! other matches : remove header line
                   header(iwrite) = ' '
                   iwlong = iwrite + 1  ! take care of long-string keywords
                   do
                      oldline = adjustl(header(iwlong))
                      if (strupcase(oldline(1:8)) == 'CONTINUE' ) then
                         header(iwlong) = ' '
                         iwlong = iwlong + 1
                      else
                         exit
                      endif
                   enddo

                endif
             endif
          enddo
       else ! append, removing previous matches
          do iwrite = 1, iblank-1
             oldline = header(iwrite)
             this_kwd = strupcase(oldline(1:len_trim(kwd2)))
             if (trim(this_kwd) == trim(kwd2)) then
                header(iwrite) = ' ' ! warning, this does not take care of long-string keywords
                iwlong = iwrite + 1  ! take care of long-string keywords
                do
                   oldline = adjustl(header(iwlong))
                   if (strupcase(oldline(1:8)) == 'CONTINUE' ) then
                      header(iwlong) = ' '
                      iwlong = iwlong + 1
                   else
                      exit
                   endif
                enddo
             endif
          enddo
          call insert_line_in_header(header, iblank, fullcard, overwrite=.false., long_strn = do_long_strn)
       endif
    case (1:2) ! append, no question asked (COMMENT, HISTORY, END)
       call insert_line_in_header(header, iblank, fullcard, overwrite=.false., long_strn = do_long_strn)
    end select
          
    RETURN
  END subroutine write_hl


  !=====================================================================
  subroutine insert_line_in_header(header, idx, card, overwrite, long_strn)
    IMPLICIT none
    character (LEN=80), dimension(1:), intent(INOUT) :: header
    character (LEN=*),                 intent(IN)    :: card
    integer(kind=I4B),                 intent(IN)    :: idx
    logical(LGT),                      intent(IN)    :: overwrite
    logical(LGT),     optional,        intent(IN)    :: long_strn

    integer(i4b) :: i2, j_low, j_hi, iw, hdtype, k, step0, step
    integer(i4b) :: lencard, nlh, lenkv
    character(len=80) :: tmpline
    character (LEN=10)  :: pad10 = '    '
    logical(LGT)        :: do_long_strn
    logical(LGT), parameter :: WAC = .false. ! wrap-around long comments
    !=====================================================================
    tmpline=''
    do_long_strn = .false.
    if (present(long_strn)) do_long_strn = long_strn

    nlh = size(header)
    lencard = len_trim(card) ! total length of input card "kwd = value / comment"
    if (do_long_strn) then
       lenkv = index(card,"' / ",back=.true.) ! length of "kwd = 'value'"
       step0 = 75
    else
       lenkv = lencard
       step0 = 80
    endif

    step = step0
    j_low = 1  ! character along the card
    j_hi  = step
    k = 1
    iw = idx ! line down the header


    do ! deal with long cards
       if (j_low > lencard) exit

       if (iw > nlh) then
          print*,'WARNING: Header is too short, card not written'
          print*,trim(card)
          return
       endif

       ! leave some room for new line, unless one wants to overwrite
       if (.not.overwrite .or. k>1) then
          do i2 = nlh, iw+1, -1
             header(i2) = header(i2-1)
          enddo
       endif

       ! write line
       if (do_long_strn) then
          if (k == 1) then
             header(iw) = trim(card(j_low:j_hi))
          else
             if (j_low <= lenkv) then
                ! (long) keyword substring
                if (j_hi >= lenkv .and. WAC) then
                   header(iw) = "CONTINUE  '"//&
                        & trim(card(j_low:lenkv-1))//&
                        & "&'"//trim(card(lenkv+1:j_hi))
                else
                   header(iw) = "CONTINUE  '"//trim(card(j_low:j_hi))
                endif
             else
                ! (long) comment substring
                if (WAC) header(iw) = "CONTINUE  '&' /"//trim(card(j_low:j_hi))
             endif
          endif
          if (j_hi < lenkv) header(iw) = trim(header(iw))//"&'"
          if (j_hi < lenkv) then
             step = step0 - 10
          else
             step = step0 - 15
          endif
       else
          hdtype = 0
          statusfits = 0
          if (k == 1) then
             CALL ftgthd(card(j_low:j_hi), tmpline, hdtype, statusfits)
             header(iw) = tmpline
          else
             if (WAC) then ! wrap around long comment
                CALL ftgthd(pad10//card(j_low:j_hi), tmpline, hdtype, statusfits)
                header(iw) = tmpline
             endif
          endif
       endif

       ! select next characters from card to put in header
       j_low = j_hi + 1
       j_hi  = min(j_low + step, lencard)

       ! next header line
       k = k + 1
       iw = iw + 1

    enddo

  end subroutine insert_line_in_header
  !=====================================================================
  subroutine merge_headers( header1, header2)
    IMPLICIT none
    character (LEN=80), dimension(1:), intent(IN)    :: header1
    character (LEN=80), dimension(1:), intent(INOUT) :: header2
    integer(kind=I4B) :: iw1, iw2, s1, s2, ss

    s2 = size(header2)
    iw2 = s2
    do while(header2(iw2) == '' .and. iw2 > 1)
       iw2 = iw2 - 1
    enddo
    iw2 = iw2 + 1

    s1 = size(header1)
    iw1 = s1
    do while(header1(iw1) == '' .and. iw1 > 1)
       iw1 = iw1 - 1
    enddo
    iw1 = iw1 + 1

    ss = MIN(iw1, s2-iw2+1)

    if (ss < iw1) then
       print*,' Second header in merge_headers is not long enough'
       print*,' Should be ',iw1+iw2-2,' instead of ',s2
       print*,' Output will be truncated'
    endif

    header2(iw2:iw2+ss-1) = header1(1:ss)

    RETURN
  END subroutine merge_headers



  !===================================================================
  subroutine d_get_card(header, kwd, value, comment, count) ! double precision
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN)  :: kwd
    real(kind=DP),                    intent(OUT) :: value
    character (LEN=*),                intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),                intent(OUT), OPTIONAL :: count
    integer :: i

    count_in = 0
    value = 0.0d0
    nlh = size(header)
    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          !                        extract value as a string
          call ftpsvc(card, stval, stcom, statusfits)
          call ftdtyp(stval, dtype, statusfits) ! find its type
          if (dtype == 'F' .or. dtype == 'I') then    ! if right type
             read(stval,*) value     ! convert string to numerical value
             count_in = 1
             if (present(comment)) comment = stcom
             if (present(count))   count = count_in
             return
          else
             print*,'Uncompatible type for keyword: '//card(1:30)
             print*,'expected DOUBLE (F), found: '//dtype
             call fatal_error
          endif
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine d_get_card

  !===================================================================
  subroutine f_get_card(header, kwd, value, comment, count) ! single precision
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN)  :: kwd
    REAL(kind=SP),                    intent(OUT) :: value
    character (LEN=*),         intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),         intent(OUT), OPTIONAL :: count
    integer :: i

    count_in = 0
    value = 0.
    nlh = size(header)
    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          !                        extract value as a string
          call ftpsvc(card, stval, stcom, statusfits)
          call ftdtyp(stval, dtype, statusfits) ! find its type
          if (dtype == 'F' .or. dtype == 'I') then    ! if right type
             read(stval,*) value     ! convert string to numerical value
             if (present(comment)) comment = stcom
             count_in = 1
             if (present(count))   count = count_in
             return
          else
             print*,'Uncompatible type for keyword: '//card(1:30)
             print*,'expected REAL (F), found: '//dtype
             call fatal_error
          endif
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine f_get_card


  !===================================================================
  function trim_quotes(card) result(c2)
    ! remove first and last quotes
    implicit none
    character(len=*), intent(IN) :: card
    character(len=FILENAMELEN)   :: c2
    !
    character(len=FILENAMELEN)   :: c1
    integer :: ifor, ibac

    c1 = trim(adjustl(card))
    ifor = index(c1,"'")
    ibac = index(c1,"'",back=.true.)
    if (ifor >= 1                        ) c1(ifor:ifor) = " "
    if (ibac <= len(c1) .and. ibac > ifor) c1(ibac:ibac) = " "
    c2 = trim(adjustl(c1))

    return
  end function trim_quotes
  !===================================================================
  function trim_taa(card) result(c2)
    ! remove trailing Ampersand (&)
    implicit none
    character(len=*), intent(IN) :: card
    character(len=FILENAMELEN)   :: c2
    !
    character(len=FILENAMELEN)   :: c1
    integer :: ibac

    c1 = trim(adjustl(card))
    ibac = index(c1,"&",back=.true.)
    if (ibac <= len(c1)) c1(ibac:ibac) = " "
    c2 = trim(adjustl(c1))

    return
  end function trim_taa

  !===================================================================
  subroutine a_get_card(header, kwd, value, comment, count) ! ascii string
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN) :: kwd
    character (LEN=*),                intent(OUT) :: value
    character (LEN=*),         intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),         intent(OUT), OPTIONAL :: count

    character(len=80) :: stval1, stcom1, card1
    integer :: ifor, ibac, i, kaa, kq1, kq2, ip1
    logical(LGT) :: long_strn

    count_in = 0
    value = ' '
    stcom = ''
    stval1= ''
    stcom1= ''
    nlh = size(header)
    statusfits = 0
    long_strn = .false.

    ! test for possible long string keywords
    do i=1, nlh 
       card = header(i)
       call ftcmps('CONTINUE',card(1:8), casesen, long_strn, exact)
       if (long_strn) exit
    enddo


    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          if (long_strn) then ! test if current keyword is long string
             long_strn = long_strn .and. (index(card,"&'",back=.true.) > 0)
             call ftpsvc(card, stval1, stcom1, statusfits)
             value = trim(trim_taa(trim_quotes(stval1)))
             stcom = trim(stcom1)
          endif
          if (long_strn) then
             ip1 = i
             do 
                ip1 = ip1+1
                card1 = header(ip1)
                if (card1(1:10) == 'CONTINUE  ') then
                   card1(1:10)   = 'JUNK    = ' ! trick to get ftpsvc to work
                   call ftpsvc(card1, stval1, stcom1, statusfits)
                   value = trim(value)//trim(trim_taa(trim_quotes(stval1)))
                   stcom = trim(stcom)//trim(stcom1)
                else
                   exit
                endif
             enddo
          else
             !                        extract value as a string
             call ftpsvc(card, stval1, stcom1, statusfits)
             value = trim(trim_quotes(stval1))
             stcom = trim(stcom1)
          endif
          count_in = 1
          if (present(comment)) comment = stcom
          if (present(count))   count = count_in
          return
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine a_get_card

  !===================================================================
  subroutine i_get_card(header, kwd, value, comment, count) ! integer (4Bytes)
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN) :: kwd
    integer(kind=I4B),                          intent(OUT) :: value
    character (LEN=*),         intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),         intent(OUT), OPTIONAL :: count
    integer(kind=I4B) :: i

    count_in = 0
    value = 0
    nlh = size(header)
    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          !                        extract value as a string
          call ftpsvc(card, stval, stcom, statusfits)
          call ftdtyp(stval, dtype, statusfits) ! find its type
          if (dtype == 'I') then    ! if right type
             read(stval,*) value     ! convert string to numerical value
             if (present(comment)) comment = stcom
             count_in = 1
             if (present(count))   count = count_in
             return
          else
             print*,'Uncompatible type for keyword: '//card(1:30)
             print*,'expected integer (I), found: '//dtype
             call fatal_error
          endif
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine i_get_card

  !===================================================================
#ifndef NO64BITS
  ! compile 8 byte integer flavor only if possible
  subroutine ii_get_card(header, kwd, value, comment, count) ! integer (8Bytes)
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN) :: kwd
    integer(kind=I8B),                          intent(OUT) :: value
    character (LEN=*),         intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),         intent(OUT), OPTIONAL :: count
    integer(kind=I4B) :: i

    count_in = 0
    value = 0
    nlh = size(header)
    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          !                        extract value as a string
          call ftpsvc(card, stval, stcom, statusfits)
          call ftdtyp(stval, dtype, statusfits) ! find its type
          if (dtype == 'I') then    ! if right type
             read(stval,*) value     ! convert string to numerical value
             if (present(comment)) comment = stcom
             count_in = 1
             if (present(count))   count = count_in
             return
          else
             print*,'Uncompatible type for keyword: '//card(1:30)
             print*,'expected integer (I), found: '//dtype
             call fatal_error
          endif
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine ii_get_card
#endif
  !===================================================================
  subroutine l_get_card(header, kwd, value, comment, count) ! logical
    implicit none
    character (LEN=80), dimension(:), intent(IN)  :: header
    character (LEN=*),                intent(IN)  :: kwd
    logical(kind=LGT),                intent(OUT) :: value
    character (LEN=*),         intent(OUT), OPTIONAL :: comment
    integer(kind=I4B),         intent(OUT), OPTIONAL :: count
    integer(kind=I4B) :: i

    count_in = 0
    value = .false.
    nlh = size(header)
    do i=1, nlh ! scan header for keyword
       card = header(i)
       call ftcmps(kwd,card(1:8), casesen, match, exact)
       if (match) then
          !                        extract value as a string
          call ftpsvc(card, stval, stcom, statusfits)
          call ftdtyp(stval, dtype, statusfits) ! find its type
          if (dtype == 'L') then    ! if right type
             read(stval,*) value     ! convert string to numerical value
             if (present(comment)) comment = stcom
             count_in = 1
             if (present(count))   count = count_in
             return
          else
             print*,'Uncompatible type for keyword: '//card(1:30)
             print*,'expected logical (L), found: '//dtype
             call fatal_error
          endif
       endif
    enddo
    if (verbose) print*,' >>>>> keyword '//kwd//' not found <<<<< '
    if (present(comment)) comment = ' '
    if (present(count))   count = count_in
    return
  end subroutine l_get_card

  !===================================================================
  subroutine del_cardn(header, kwds) ! remove cards
    !===================================================================
    ! remove for header the card corresponding to keyword kwds
    ! kwds can be a vector
    !===================================================================
    implicit none
    character(len=80), dimension(1:), intent(INOUT) :: header
    character(len=*),  dimension(1:), intent(IN)    :: kwds
    integer(kind=I4B) :: i
    character(len=20) :: kwd
    !===================================================================
    nlh = size(kwds)
    do i = 1, nlh
       kwd = adjustl(kwds(i))
       if (trim(kwd) /= "") then
          kwd = "- "//kwd
          call write_hl(header, kwd)
       endif
    enddo
  end subroutine del_cardn
  !===================================================================
  subroutine del_card1(header, kwds) ! remove cards
    !===================================================================
    ! remove for header the card corresponding to keyword kwds
    ! kwds can be a vector
    !===================================================================
    implicit none
    character(len=80), dimension(1:), intent(INOUT) :: header
    character(len=*),                 intent(IN)    :: kwds
    character(len=20) :: kwd
    !===================================================================
       kwd = adjustl(kwds)
       if (trim(kwd) /= "") then
          kwd = "- "//kwd
          call write_hl(header, kwd)
       endif
  end subroutine del_card1


  !===================================================================
  subroutine write_minimal_header(header &
       &, dtype & ! 'alm', 'cl', 'cutmap', 'map'
       &, append &
       &, nside &            ! required for 'map', 'cutmap'
       &, order, ordering &  ! required for 'map', 'cutmap'
       &, coordsys &         ! required for 'map', 'cutmap'
       &, creator &
       &, version &
       &, randseed &
       &, beam_leg &
       &, fwhm_degree &
       &, units &
       &, nlmax &
       &, polar &
       &, nmmax &            ! relevant for 'alm'
       &, bcross &           ! relevant for 'cl'
       &, deriv &            ! relevant for 'map'
       &, asym_cl &          ! relevant for 'cl'
)
  !===================================================================
    
    implicit none
    character(len=*), intent(inout), dimension(:) :: header
    character(len=*), intent(in)           :: dtype
    integer(i4b),     intent(in), optional :: order, randseed, deriv
!    integer(i4b), intent(in), optional :: extension
    integer(i4b),     intent(in), optional :: nside, nlmax, nmmax
    logical(LGT),     intent(in), optional :: append, polar, bcross, asym_cl
    character(len=*), intent(in), optional :: creator, version, coordsys, ordering
    character(len=*), intent(in), optional :: beam_leg
!     character(len=*), intent(in), dimension(1:), optional :: units
    character(len=*), intent(in), optional :: units
    real(dp),         intent(in), optional :: fwhm_degree

    integer(i4b) :: ext, it, iq, iu, my_deriv
    character(len=80) :: my_coordsys
    character(len=80), dimension(1:20) :: my_units
    character(len=8) :: my_ordering
    character(len=FILENAMELEN) :: udtype, my_beam_leg
    logical(LGT) :: do_full, do_alm, do_cl, do_cut, do_polar, &
         & do_bcross, do_reset, do_asym

    character(len=*), parameter :: code = 'write_minimal_header'
    !--------------------------------------------------------------------------------
    ! find out type of data to be contained in FITS file
    udtype = strupcase(dtype)
    do_alm = .false. ; do_cl  = .false. ; do_full = .false. ; do_cut = .false.
    select case (trim(udtype))
    case ('ALM')
       do_alm = .true.
    case ('CL')
       do_cl = .true.
    case ('MAP')
       do_full = .true.
    case ('CUTMAP')
       do_cut = .true.
    case default
       print*,'Invalid choice of datatype:'//trim(dtype)
       print*,'Should be one of: ALM, alm, CL, cl, CUTMAP, cutmap, MAP, map'
       call fatal_error(code)
    end select

    !
    if (present(order) .and. present(ordering)) then
       print*,'Choose either ORDER (1/2) or ORDERING (RING/NESTED)'
       call fatal_error(code)
    endif

    ! check for required keywords for map
    if (do_cut .or. do_full) then
       if (.not. present(nside)) then
          print*,'NSIDE required for maps in '//code
          call fatal_error(code)
       endif
       if (.not.present(order) .and. .not.present(ordering)) then
          print*,'ORDERING required for maps in '//code
          call fatal_error(code)
       endif
    endif

       
    ! set default values
    do_reset = .true.
    if (present(append)) do_reset = .not. append
    my_coordsys = 'unknown'
    if (present(coordsys)) then
       if (trim(coordsys) /= '') my_coordsys = coordsys
    endif
    my_units(:) = 'unknown'
    if (present(order)) then
       my_ordering = "RING"
       if (order /=1 .and. order /=2) then
          print*,'ORDER should be 1 or 2, it is: ',order
          call fatal_error(code)
       endif
       if (order == 2)  my_ordering = "NESTED"
    endif
    if (present(ordering)) then
       my_ordering = strupcase(ordering)
       if (trim(my_ordering) /= 'RING' .and. trim(my_ordering) /= 'NESTED') then
          print*,'ORDERING should be RING or NESTED, it is: ',trim(ordering)
          call fatal_error(code)
       endif
    endif
    do_bcross = .false.
    if (present(bcross)) then
       do_bcross = bcross
    endif
    do_asym = .false.
    if (present(asym_cl)) then
       do_asym = asym_cl
    endif
    my_deriv = 0
    if (present(deriv)) my_deriv = deriv
    if (my_deriv <0 .or. my_deriv >2) then
       print*,'DERIV out of range [0,2]: ',my_deriv
       call fatal_error(code)
    endif
    my_beam_leg = ''
    if (present(beam_leg)) my_beam_leg = beam_leg

    ! reset header if requested
    if (do_reset) header(:) = " "

    do_polar = .false.
    if (present(polar)) do_polar = polar
    
    ext = 0
!     if (present(extension)) ext = extension

    if (do_alm) then
       !--------------------------------------------------------------------------------------------
       !                            minimal header for ALM
       !--------------------------------------------------------------------------------------------
       ! missing : CUT-SKY, NITERALM, LREGRESS
!        select case (ext)
!        case (0)
!           call add_card(header,"EXTNAME","'a_lms (TEMPERATURE)'")
!        case (1)
!           call add_card(header,"EXTNAME","'a_lms (GRAD / ELECTRIC component)'")
!        case (2)
!           call add_card(header,"EXTNAME","'a_lms (CURL / MAGNETIC component)'")
!        end select
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"COMMENT","     Map Analysis Specific Keywords      ")
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"EXTNAME","'a_lms coefficients'") ! place holder
       call add_card(header)
       if (present(creator)) call add_card(header,"CREATOR",creator, "Software creating the FITS file")
       if (present(version)) call add_card(header,"VERSION",version, "Version of the simulation software")
       call add_card(header)
       if (present(nlmax)) call add_card(header,"MAX-LPOL",nlmax  ,"Maximum Legendre order L")
       if (present(nmmax)) call add_card(header,"MAX-MPOL",nmmax  ,"Maximum Legendre degree M")
       if (present(randseed))  call add_card(header,"RANDSEED",randseed,"Random generator seed")
       if (trim(my_beam_leg)/='') then
          call add_card(header,"BEAM_LEG",trim(my_beam_leg),"File containing Legendre transform of symmetric beam")
       else if (present(fwhm_degree)) then
          call add_card(header,"FWHM"    ,fwhm_degree   ," [deg] FWHM of gaussian symmetric beam")
       endif
       call add_card(header)

       
       if (present(units)) then
!           iu = min(ext+1, size(units))
!           my_units(1) = "'" // trim(units(iu)) // "'"
          my_units(1) = "'" // trim(units) // "'"
       endif
       call add_card(header,"COMMENT"," The real and imaginary part of the a_lm with m>=0")
       call add_card(header)
       call add_card(header,"TTYPE1", "INDEX"," i = l^2 + l + m + 1")
       call add_card(header,"TUNIT1", "   "," index")
       call add_card(header)
       call add_card(header,"TTYPE2", "REAL"," REAL a_lm")
       call add_card(header,"TUNIT2", my_units(1)," alm units")
       call add_card(header)
       !
       call add_card(header,"TTYPE3", "IMAG"," IMAGINARY a_lm")
       call add_card(header,"TUNIT3", my_units(1)," alm units")
       call add_card(header)

       if (present(nside)) call add_card(header,"NSIDE"   ,nside,   "Resolution parameter for HEALPIX")
       call add_card(header,"COORDSYS",trim(my_coordsys),"Input map coordinate system")
       call add_card(header,"COMMENT","G = Galactic, E = ecliptic, C = celestial = equatorial")
       call add_card(header,"POLAR",do_polar," Polarisation included (True/False)")
    endif

    if (do_cl) then
       !--------------------------------------------------------------------------------------------
       !                            minimal header for CL
       !--------------------------------------------------------------------------------------------
       ! missing: CUT-SKY, NITERALM, LREGRESS, NMAPS_IN
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"COMMENT","     Map Analysis Specific Keywords      ")
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"EXTNAME","'POWER SPECTRUM'")
       call add_card(header)
       if (present(creator)) call add_card(header,"CREATOR",creator, "Software creating the FITS file")
       if (present(version)) call add_card(header,"VERSION",version, "Version of the simulation software")
       call add_card(header)
       if (present(nlmax)) call add_card(header,"MAX-LPOL",nlmax  ,"Maximum Legendre order L")
       if (present(nmmax)) call add_card(header,"MAX-MPOL",nmmax  ,"Maximum Legendre degree M")
       if (present(randseed))  call add_card(header,"RANDSEED",randseed,"Random generator seed")
       call add_card(header)
       call add_card(header,"POLAR",do_polar," Polarisation included (True/False)")
       call add_card(header,"BCROSS",do_bcross," Magnetic cross terms included (True/False)")
       call add_card(header,"ASYMCL",do_asym," Asymmetric pol cross terms (XY vs YX) included")
       call add_card(header)
       if (present(nside)) call add_card(header,"NSIDE",nside," Resolution Parameter of Input Map")
       call add_card(header,"COORDSYS",my_coordsys," Input Map Coordinate system")
       call add_card(header,"COMMENT","G = Galactic, E = ecliptic, C = celestial = equatorial")
       call add_card(header)
       call add_card(header,"TTYPE1", "TEMPERATURE","Temperature C(l)")
!        if (present(units)) my_units(1) = "'"//trim(units(1))//"'" ! add quotes to keep words together
       if (present(units)) my_units(1) = "'"//trim(units)//"'" ! add quotes to keep words together
       call add_card(header,"TUNIT1", my_units(1),"square of map units")
       call add_card(header)
       !
       if (do_polar) then
          call add_card(header,"TTYPE2", "GRADIENT","Gradient (=ELECTRIC) polarisation C(l)")
          call add_card(header,"TUNIT2", my_units(1),"power spectrum units")
          call add_card(header)
          !
          call add_card(header,"TTYPE3", "CURL","Curl (=MAGNETIC) polarisation C(l)")
          call add_card(header,"TUNIT3", my_units(1),"power spectrum units")
          call add_card(header)
          !
          !call add_card(header,"TTYPE4", "G-T","Gradient-Temperature (=CROSS) terms")
          call add_card(header,"TTYPE4", "TG","Temperature X Gradient cross terms")
          call add_card(header,"TUNIT4", my_units(1),"power spectrum units")
          call add_card(header)
          !
          if (do_bcross) then
             !call add_card(header,"TTYPE5", "C-T","Curl-Temperature terms")
             call add_card(header,"TTYPE5", "TC","Temperature X Curl cross terms")
             call add_card(header,"TUNIT5", my_units(1),"power spectrum units")
             call add_card(header)
           !
             !call add_card(header,"TTYPE6", "C-G","Curl-Gradient terms")
             call add_card(header,"TTYPE6", "GC","Gradient x Curl cross terms")
             call add_card(header,"TUNIT6", my_units(1),"power spectrum units")
             call add_card(header)
           !
             if (do_asym) then
                call add_card(header,"TTYPE7", "GT","Gradient1 x Temperature2 cross terms")
                call add_card(header,"TUNIT7", my_units(1),"power spectrum units")
                call add_card(header)

                call add_card(header,"TTYPE8", "CT","Curl1 x Temperature2 cross terms")
                call add_card(header,"TUNIT8", my_units(1),"power spectrum units")
                call add_card(header)

                call add_card(header,"TTYPE9", "CG","Curl1 x Gradient2 cross terms")
                call add_card(header,"TUNIT9", my_units(1),"power spectrum units")
                call add_card(header)
             endif
          else
             if (do_asym) then
                call add_card(header,"TTYPE5", "GT","Gradient1 x Temperature2 cross terms")
                call add_card(header,"TUNIT5", my_units(1),"power spectrum units")
                call add_card(header)
             endif
          endif
          !
          call add_card(header,"COMMENT","The polarisation power spectra have the same definition as in CMBFAST")
          call add_card(header)
       endif

    endif ! cl

    if (do_full .or. do_cut) then
       !--------------------------------------------------------------------------------------------
       !                            minimal header for FULL SKY MAP and CUT SKY MAP
       !--------------------------------------------------------------------------------------------
       call add_card(header)
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"COMMENT","     Sky Map Pixelisation Specific Keywords    ")
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"PIXTYPE","HEALPIX","HEALPIX Pixelisation")
       call add_card(header,"ORDERING",my_ordering,  "Pixel ordering scheme, either RING or NESTED")
       
       call add_card(header,"NSIDE"   ,nside,   "Resolution parameter for HEALPIX")
       if (do_full) then
          call add_card(header,"FIRSTPIX",0,"First pixel # (0 based)")
          call add_card(header,"LASTPIX",(12_i8b*nside)*nside-1,"Last pixel # (0 based)")
       endif
       call add_card(header,"COORDSYS",trim(my_coordsys),"Pixelisation coordinate system")
       call add_card(header,"COMMENT","G = Galactic, E = ecliptic, C = celestial = equatorial")
       call add_card(header,"BAD_DATA",  HPX_DBADVAL ,"Sentinel value given to bad pixels")
       call add_card(header) ! blank line


       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"COMMENT","     Planck Simulation Specific Keywords      ")
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"EXTNAME","MAP") ! place holder, to be updated
       if (present(creator)) call add_card(header,"CREATOR",creator, "Software creating the FITS file")
       if (present(version)) call add_card(header,"VERSION",version, "Version of the simulation software")
       call add_card(header)
       if (present(nlmax)) call add_card(header,"MAX-LPOL",nlmax  ,"Maximum Legendre order L")
       if (present(nmmax)) call add_card(header,"MAX-MPOL",nmmax  ,"Maximum Legendre degree M")
       if (present(randseed))  call add_card(header,"RANDSEED",randseed,"Random generator seed")
       call add_card(header,"POLCCONV","COSMO","Coord. convention for polarisation (COSMO/IAU)")
       if (trim(my_beam_leg)/='') then
          call add_card(header,"BEAM_LEG",trim(my_beam_leg),"File containing Legendre transform of symmetric beam")
       else if (present(fwhm_degree)) then
          call add_card(header,"FWHM"    ,fwhm_degree   ," [deg] FWHM of gaussian symmetric beam")
       endif

       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header,"COMMENT","     Data Description Specific Keywords       ")
       call add_card(header,"COMMENT","-----------------------------------------------")
       call add_card(header)
       if (do_full) then
          call add_card(header,"EXTNAME","'FULL SKY MAP'",update=.true.)
          call add_card(header,"COMMENT","Full sky data")
          call add_card(header,"OBJECT","FULLSKY")
          call add_card(header,"INDXSCHM","IMPLICIT"," Indexing : IMPLICIT or EXPLICIT")
          call add_card(header,"GRAIN", 0, " Grain of pixel indexing")
       endif
       if (do_cut)  then
          call add_card(header,"EXTNAME","'CUT SKY MAP'",update=.true.)
          call add_card(header,"COMMENT","Cut sky data")
          call add_card(header,"OBJECT","PARTIAL")
          call add_card(header,"INDXSCHM","EXPLICIT"," Indexing : IMPLICIT or EXPLICIT")
          call add_card(header,"GRAIN", 1, " Grain of pixel indexing")
       endif
       call add_card(header,"COMMENT","GRAIN=0 : no indexing of pixel data                         (IMPLICIT)")
       call add_card(header,"COMMENT","GRAIN=1 : 1 pixel index -> 1 pixel data                     (EXPLICIT)")
       call add_card(header,"COMMENT","GRAIN>1 : 1 pixel index -> data of GRAIN consecutive pixels (EXPLICIT)")
       call add_card(header) ! blank line
       call add_card(header,"POLAR",do_polar," Polarisation included (True/False)")
       if (do_cut) then
          if (present(units)) then
             my_units = units
             call add_card(header,"TUNIT2", my_units(1),"physical unit of signal map")
             call add_card(header,"TUNIT4", my_units(1),"physical unit of error map")
          endif
       endif
       if (do_full) then
          call add_card(header,"DERIV",my_deriv," Derivative included (0, 1 or 2)")

          if (present(units)) then
!              do it=1, size(units)
!                 my_units(it) = "'" // trim(units(it)) // "'"
!              enddo
!              it = min(1, size(units))
!              iq = min(2, size(units))
!              iu = min(3, size(units))
             my_units = units
             it = 1 ; iq = 1 ; iu = 1
          else
             it = 1 ; iq = 1 ; iu = 1
          endif
          
          call add_card(header) ! blank line
          call add_card(header,"TTYPE1", "TEMPERATURE","Temperature map")
          call add_card(header,"TUNIT1", my_units(it),"map unit")
          call add_card(header)

          if (do_polar) then
             !call add_card(header,"TTYPE2", "Q-POLARISATION","Q Polarisation map")
             call add_card(header,"TTYPE2", "Q_POLARISATION","Q Polarisation map")
             call add_card(header,"TUNIT2", my_units(iq),"map unit")
             call add_card(header)

             !call add_card(header,"TTYPE3", "U-POLARISATION","U Polarisation map")
             call add_card(header,"TTYPE3", "U_POLARISATION","U Polarisation map")
             call add_card(header,"TUNIT3", my_units(iu),"map unit")
             call add_card(header)

             if (my_deriv>=1) then
                call add_card(header,"TTYPE4", "DX_T","1st derivative of T wrt theta")
                call add_card(header,"TUNIT4", my_units(it),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE5", "DX_Q","1st derivative of Q wrt theta")
                call add_card(header,"TUNIT5", my_units(iq),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE6", "DX_U","1st derivative of U wrt theta")
                call add_card(header,"TUNIT6", my_units(iu),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE7", "DY_T","(1st derivative of T wrt phi)/sin(theta)")
                call add_card(header,"TUNIT7", my_units(it),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE8", "DY_Q","(1st derivative of Q wrt phi)/sin(theta)")
                call add_card(header,"TUNIT8", my_units(iq),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE9", "DY_U","(1st derivative of U wrt phi)/sin(theta)")
                call add_card(header,"TUNIT9", my_units(iu),"map unit")
                call add_card(header)
             endif

             if (my_deriv>=2) then
                call add_card(header,"TTYPE10", "DXX_T","2nd derivative of T wrt theta, theta")
                call add_card(header,"TUNIT10", my_units(it),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE11", "DXX_Q","2nd derivative of Q wrt theta, theta")
                call add_card(header,"TUNIT11", my_units(iq),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE12", "DXX_U","2nd derivative of U wrt theta, theta")
                call add_card(header,"TUNIT12", my_units(iu),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE13", "DXY_T","(2nd deriv of T wrt theta, phi)/sin(theta)")
                call add_card(header,"TUNIT13", my_units(it),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE14", "DXY_Q","(2nd deriv of Q wrt theta, phi)/sin(theta)")
                call add_card(header,"TUNIT14", my_units(iq),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE15", "DXY_U","(2nd deriv of U wrt theta, phi)/sin(theta)")
                call add_card(header,"TUNIT15", my_units(iu),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE16", "DYY_T","(2nd deriv of T wrt phi, phi)/sin(theta)^2")
                call add_card(header,"TUNIT16", my_units(it),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE17", "DYY_Q","(2nd deriv of Q wrt phi, phi)/sin(theta)^2")
                call add_card(header,"TUNIT17", my_units(iq),"map unit")
                call add_card(header)
                call add_card(header,"TTYPE18", "DYY_U","(2nd deriv of U wrt phi, phi)/sin(theta)^2")
                call add_card(header,"TUNIT18", my_units(iu),"map unit")
                call add_card(header)
             endif
          else ! not polarized
             if (my_deriv>=1) then
                call add_card(header,"TTYPE2", "DX_T","1st derivative of T wrt theta")
                call add_card(header,"TUNIT2", my_units(it),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE3", "DY_T","(1st derivative of T wrt phi)/sin(theta)") ! corrected 2009-01-08
                call add_card(header,"TUNIT3", my_units(it),"map unit")
                call add_card(header)
             endif

             if (my_deriv>=2) then
                call add_card(header,"TTYPE4", "DXX_T","2nd derivative of T wrt theta, theta")
                call add_card(header,"TUNIT4", my_units(it),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE5", "DXY_T","(2nd deriv wrt of T theta, phi)/sin(theta)")
                call add_card(header,"TUNIT5", my_units(it),"map unit")
                call add_card(header)

                call add_card(header,"TTYPE6", "DYY_T","(2nd deriv wrt of T phi, phi)/sin(theta)^2")
                call add_card(header,"TUNIT6", my_units(it),"map unit")
                call add_card(header)
             endif
          endif ! polarized
       endif ! full sky map
    endif ! map
    

  end subroutine write_minimal_header

end module head_fits

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!! Upgrade / Degrade a Healpix map
!! Written and developed by E. Hivon (efh@ipac.caltech.edu) and K. Gorski
!! (krzysztof.m.gorski@jpl.nasa.gov) based on HEALPIX pixelisation developed
!! by K. Gorski
!!
!! Copyright 1997 by Eric Hivon and Krzysztof M. Gorski.
!!  All rights reserved.
!!
!! author Eric Hivon (hivon@iap.fr)
!!
!  RELATED LITTERATURE:
!     about HEALPIX   : see Gorski et al, 2005, ApJ, 622, 759
!-----------------------------------------------------------------------
  !=======================================================================
  !     version 2.2
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file ud_grade.f90 by the command  include
  !
  INTEGER(I4B) :: nside_in, nside_out

  REAL(KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_in
  REAL(KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_out
  INTEGER(I4B)  status

  INTEGER(I8B) npix_in, npix_out
  INTEGER(I4B) nmaps, type
  INTEGER(I4B) j, polar_fits

  CHARACTER(LEN=filenamelen)          ::  outfile, infile
  CHARACTER(LEN=80), DIMENSION(1:120) :: header, header_in
  CHARACTER(LEN=80) :: char
  INTEGER(I4B) :: nlheader
  INTEGER(I4B) :: ordering, order_type
!  REAL(KMAP)   :: fmissval = real(HPX_DBADVAL,kind=KMAP)
  REAL(KMAP)   :: fmissval = HPX_DBADVAL
  real(SP)                 :: clock_time, time0, time1
  real(SP)                 :: ptime, ptime0, ptime1
!  real(SP)                 :: ct1,ct2,ct,pt1,pt2,pt

  integer(i4b), parameter :: nm_max = 5
  CHARACTER(len=80), dimension(1:nm_max) :: ttype, com_ttype, tunit, com_tunit
  INTEGER(I4B), dimension(1:nm_max) :: ct_ttype, ct_tunit
  character(len=1), dimension(1:nm_max) :: sn = (/ '1', '2', '3', '4', '5' /)
  character(len=20) :: coordsys

!   CHARACTER(LEN=*), PARAMETER :: code = 'UD_GRADE'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION

  type(paramfile_handle) :: handle
  character(len=20) :: polcconv
  character(len=80) :: com_polcconv
  integer(i4b)      :: n_polcconv

  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  PRINT *, " "
  PRINT *, "                "//code//" "//version
  write(*,'(a)') '          *** Upgrading / Degrading of a map ***    '
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  PRINT *, " "
  handle = parse_init(parafile)

  !     --- gets the file name for the map ---
  infile=parse_string(handle,'infile',default='map.fits', &
    descr='Input file name (Map FITS file, eg: map_CDM.fits):', &
    filestatus='old')
  PRINT *," "

  !     --- finds out the pixel number of the map and its ordering ---

  npix_in = getsize_fits(infile, nmaps=nmaps, ordering=ordering, nside=nside_in, &
       type=type, polarisation = polar_fits, coordsys = coordsys)
  if (nside_in.eq.0) then
     print*,'Keyword NSIDE not found in FITS header!'
     stop 1
  endif
  if (type /= 2) then  ! accept only full sky map
     print*,'> '//code//version//' only accepts full sky maps'
     print*,'> '//trim(infile)//' is not a full sky map'
     stop 1
  endif
  if (nside_in.ne.npix2nside(npix_in)) then ! accept only full sky map
     print*,'FITS header keyword NSIDE = ',nside_in,' does not correspond'
     print*,'to the size of the map!'
     stop 1
  endif


  !     --- gets the resolution of the output map ---
  WRITE(*,'(a,i5)') ' The input map has Nside = ',nside_in
  nside_out=parse_int(handle,'nside_out',default=64_i4b, &
    descr='Resolution parameter (Nside) for the output skymap:', &
    vmin=1)

  npix_out = nside2npix(nside_out)

  !     --- check ordering scheme ---

  if ((ordering.ne.1).and.(ordering.ne.2)) then
     PRINT*,'The ordering scheme of the map must be RING or NESTED.'
     PRINT*,'No ordering specification is given in the FITS-header!'
     stop 1
  endif

  order_type = ordering

  !     --- gets the output sky map filename ---
  outfile=parse_string(handle,'outfile',default='outmap.fits', &
    descr='Output map file name (eg. map_up.fits):', &
    filestatus='new')
  PRINT *," "
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
  call brag_openmp()

  !-----------------------------------------------------------------------
  !              allocate space for arrays
  !-----------------------------------------------------------------------

  ALLOCATE(map_in(0:npix_in-1,1:nmaps),stat = status)
  call assert_alloc(status,code,'map_in')

  ALLOCATE(map_out(0:npix_out-1,1:nmaps),stat = status)
  call assert_alloc(status,code,'map_out')

  !-----------------------------------------------------------------------
  !                      reads the map
  !-----------------------------------------------------------------------
  PRINT *,'      '//code//'> Input original map '
  call input_map(infile, map_in(0:,1:nmaps), npix_in, nmaps, &
       &   fmissval=fmissval, header=header_in, ignore_polcconv=.true.)
  ! get input type and unit
  do j=1,nmaps
     call get_card(header_in, 'TTYPE'//sn(j), ttype(j), com_ttype(j), count=ct_ttype(j))
     call get_card(header_in, 'TUNIT'//sn(j), tunit(j), com_tunit(j), count=ct_tunit(j))
  enddo

  !-----------------------------------------------------------------------
  !                 makes the UP/DE-GRADATION
  !-----------------------------------------------------------------------
  if (nside_out .gt. nside_in) then
     PRINT *,'      '//code//'> UPgrade the map '
  else
     PRINT *,'      '//code//'> DEgrade the map '
  endif

!   call wall_clock_time(pt1)
!   call cpu_time(ct1)
  if (order_type == 1) then
     call udgrade_ring(map_in , nside_in, map_out, nside_out)
  else
     call udgrade_nest(map_in , nside_in, map_out, nside_out)
  endif
!   call wall_clock_time(pt2)
!   call cpu_time(ct2)
!   print*,pt2-pt1,ct2-ct1

  !-----------------------------------------------------------------------
  !                        generates header
  !-----------------------------------------------------------------------
  PRINT *,'      '//code//'> Writing up/de-graded map to FITS file '
  call write_minimal_header(header, 'map', &
       order = order_type, nside = nside_out, coordsys = coordsys, &
       creator = code, version = version, polar = (polar_fits == 1))
  if (nside_out .gt. nside_in) then
     call add_card(header,'EXTNAME','''UPGRADED DATA''', update = .true.)
  else
     call add_card(header,'EXTNAME','''DEGRADED DATA''', update = .true.)
  endif
  call add_card(header,'HISTORY','Input Map in '//TRIM(infile))
  write(char,'(i6)') nside_in
  call add_card(header,'HISTORY','Input Map resolution NSIDE =  '//TRIM(char))

  ! replicate in output file the POLCCONV found in input file (added 2017-02-27)
  call get_card(header_in, 'POLCCONV', polcconv, com_polcconv, count=n_polcconv)
  if (n_polcconv == 0) then ! delete what write_minimal_header wrote
     call del_card(header,'POLCCONV')
  else ! overwrite what write_minimal_header wrote
     call add_card(header,'POLCCONV', polcconv, update=.true.)
  endif

  ! copy input type and units
  do j=1,nmaps
     if (ct_ttype(j) > 0) then
        call add_card(header,'TTYPE'//sn(j), ttype(j), com_ttype(j), update = .true.)
     else
        call add_card(header,'TTYPE'//sn(j), 'unknown','unidentified type', update = .true.)
     endif
     if (ct_tunit(j) > 0) then
        call add_card(header,'TUNIT'//sn(j), tunit(j), com_tunit(j), update = .true.)
     else
        call add_card(header,'TUNIT'//sn(j), 'unknown','unknown units', update = .true.)
     endif
  enddo
  call add_card(header) ! blank line
  nlheader = SIZE(header)
  !-----------------------------------------------------------------------
  !                      write the map to FITS file
  !-----------------------------------------------------------------------
  call write_bintab(map_out, npix_out, nmaps, header, nlheader, outfile)

  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------
  DEALLOCATE(map_in)
  DEALLOCATE(map_out)

  !-----------------------------------------------------------------------
  !                      output and report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  WRITE(*,9000) " "
  WRITE(*,9000) " Report Card for "//code//" run"
  WRITE(*,9000) " -----------------------------"
  WRITE(*,9000) " "

  WRITE(*,9000) " Input map              : "//TRIM(infile)
  WRITE(*,9005) " Number of maps         : ", nmaps
  WRITE(*,9010) " Number of pixels (IN)  : ", npix_in
  WRITE(*,9000) " Output map             : "//TRIM(outfile)
  WRITE(*,9010) " Number of pixels (OUT) : ", npix_out
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime
  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------
  WRITE(*,9000) " "
  WRITE(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)

! to be included in indmed.f90 (part 2/2)
     XMED7 = XDATT (IMED7)
!
!  Count how many values are not higher than (and how many equal to) XMED7
!  This number is at least 4 * 1/2 * (N/7) : 4 values in each of the
!  subsets where the median is lower than the median of medians. For similar
!  reasons, we also have at least 2N/7 values not lower than XMED7. At the
!  same time, we find in each subset the index of the last value < XMED7,
!  and that of the first > XMED7. These indices will be used to restrict the
!  search for the median as the Kth element in the subset (> or <) where
!  we know it to be.
!
     IDON1 = 1
     NLEQ = 0
     NEQU = 0
     Do IDON = 1, NTRI, 7
        IMED = IDON+3
        If (XDATT (IWRKT (IMED)) > XMED7) Then
           IMED = IMED - 2
           If (XDATT (IWRKT (IMED)) > XMED7) Then
              IMED = IMED - 1
           Else If (XDATT (IWRKT (IMED)) < XMED7) Then
              IMED = IMED + 1
           Endif
        Else If (XDATT (IWRKT (IMED)) < XMED7) Then
           IMED = IMED + 2
           If (XDATT (IWRKT (IMED)) > XMED7) Then
              IMED = IMED - 1
           Else If (XDATT (IWRKT (IMED)) < XMED7) Then
              IMED = IMED + 1
           Endif
        Endif
        If (XDATT (IWRKT (IMED)) > XMED7) Then
           NLEQ = NLEQ + IMED - IDON
           IENDT (IDON1) = IMED - 1
           ISTRT (IDON1) = IMED
        Else If (XDATT (IWRKT (IMED)) < XMED7) Then
           NLEQ = NLEQ + IMED - IDON + 1
           IENDT (IDON1) = IMED
           ISTRT (IDON1) = IMED + 1
        Else                    !       If (XDATT (IWRKT (IMED)) == XMED7)
           NLEQ = NLEQ + IMED - IDON + 1
           NEQU = NEQU + 1
           IENDT (IDON1) = IMED - 1
           Do IMED1 = IMED - 1, IDON, -1
              If (XDATT (IWRKT (IMED1)) == XMED7) Then
                 NEQU = NEQU + 1
                 IENDT (IDON1) = IMED1 - 1
              Else
                 Exit
              End If
           End Do
           ISTRT (IDON1) = IMED + 1
           Do IMED1 = IMED + 1, IDON + 6
              If (XDATT (IWRKT (IMED1)) == XMED7) Then
                 NEQU = NEQU + 1
                 NLEQ = NLEQ + 1
                 ISTRT (IDON1) = IMED1 + 1
              Else
                 Exit
              End If
           End Do
        Endif
        IDON1 = IDON1 + 1
     End Do
!
!  Carry out a partial insertion sort to find the Kth smallest of the
!  large values, or the Kth largest of the small values, according to
!  what is needed.
!
!
     If (NLEQ - NEQU + 1 <= NMED) Then
        If (NLEQ < NMED) Then   !      Not enough low values
           IWRK1 = IMAX
           XWRK1 = XDATT (IWRK1)
           NORD = NMED - NLEQ
           IDON1 = 0
           ICRS1 = 1
           ICRS2 = 0
           IDCR = 0
           Do IDON = 1, NTRI, 7
              IDON1 = IDON1 + 1
              If (ICRS2 < NORD) Then
                 Do ICRS = ISTRT (IDON1), IDON + 6
                    If (XDATT (IWRKT (ICRS)) < XWRK1) Then
                       IWRK = IWRKT (ICRS)
                       XWRK = XDATT (IWRK)
                       Do IDCR = ICRS1 - 1, 1, - 1
                          If (XWRK >= XDATT (IWRKT (IDCR))) Exit
                          IWRKT  (IDCR+1) = IWRKT (IDCR)
                       End Do
                       IWRKT (IDCR+1) = IWRK
                       IWRK1 = IWRKT (ICRS1)
                       XWRK1 = XDATT (IWRK1)
                    Else
                       If (ICRS2 < NORD) Then
                          IWRKT (ICRS1) = IWRKT (ICRS)
                          IWRK1 = IWRKT (ICRS1)
                          XWRK1 = XDATT (IWRK1)
                       Endif
                    End If
                    ICRS1 = MIN (NORD, ICRS1 + 1)
                    ICRS2 = MIN (NORD, ICRS2 + 1)
                 End Do
              Else
                 Do ICRS = ISTRT (IDON1), IDON + 6
                    If (XDATT (IWRKT (ICRS)) >= XWRK1) Exit
                    IWRK = IWRKT (ICRS)
                    XWRK = XDATT (IWRK)
                    Do IDCR = ICRS1 - 1, 1, - 1
                       If (XWRK >= XDATT (IWRKT (IDCR))) Exit
                       IWRKT  (IDCR+1) = IWRKT (IDCR)
                    End Do
                    IWRKT (IDCR+1) = IWRK
                    IWRK1 = IWRKT (ICRS1)
                    XWRK1 = XDATT (IWRK1)
                 End Do
              End If
           End Do
           ires_med = IWRK1
           Return
        Else
           ires_med = IMED7
           Return
        End If
     Else                       !      If (NLEQ > NMED)
!                                          Not enough high values
        XWRK1 = -XHUGE
        NORD = NLEQ - NEQU - NMED + 1
        IDON1 = 0
        ICRS1 = 1
        ICRS2 = 0
        Do IDON = 1, NTRI, 7
           IDON1 = IDON1 + 1
           If (ICRS2 < NORD) Then
!
              Do ICRS = IDON, IENDT (IDON1)
                 If (XDATT(IWRKT (ICRS)) > XWRK1) Then
                    IWRK = IWRKT (ICRS)
                    XWRK = XDATT (IWRK)
                    IDCR = ICRS1 - 1
                    Do IDCR = ICRS1 - 1, 1, - 1
                       If (XWRK <= XDATT(IWRKT (IDCR))) Exit
                       IWRKT (IDCR+1) = IWRKT (IDCR)
                    End Do
                    IWRKT (IDCR+1) = IWRK
                    IWRK1 = IWRKT(ICRS1)
                    XWRK1 = XDATT(IWRK1)
                 Else
                    If (ICRS2 < NORD) Then
                       IWRKT (ICRS1) = IWRKT (ICRS)
                       IWRK1 = IWRKT(ICRS1)
                       XWRK1 = XDATT(IWRK1)
                    End If
                 End If
                 ICRS1 = MIN (NORD, ICRS1 + 1)
                 ICRS2 = MIN (NORD, ICRS2 + 1)
              End Do
           Else
              Do ICRS = IENDT (IDON1), IDON, -1
                 If (XDATT(IWRKT (ICRS)) <= XWRK1) Exit
                 IWRK = IWRKT (ICRS)
                 XWRK = XDATT (IWRK)
                 IDCR = ICRS1 - 1
                 Do IDCR = ICRS1 - 1, 1, - 1
                    If (XWRK <= XDATT(IWRKT (IDCR))) Exit
                    IWRKT (IDCR+1) = IWRKT (IDCR)
                 End Do
                 IWRKT (IDCR+1) = IWRK
                 IWRK1 = IWRKT(ICRS1)
                 XWRK1 = XDATT(IWRK1)
              End Do
           Endif
        End Do
!
        ires_med = IWRK1
        Return
     End If

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday,
!                          Matthias Bartelmann, Hans K. Eriksen,
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module extension
  !
  ! defines in F90 some C commands
  ! These extensions are not completely standard in all F90/95 compilers
  !
  ! getEnvironment   : emulates getenv
  ! getArgument      : emulates getarg
  ! nArguments       : emulates iargc
  !
  ! written by Eric Hivon, Nov 2001
  !
  ! exit_with_status : verbose and clean exit, added by M.R.
  ! 2005-08: edited for Gfortran
  ! 2013-05-07: G95-compatible
  ! 2015-07-31: G95-compatible
  ! 2016-05: edited for __GFORTRAN__
  ! 2019-02: M.R. replaced C with Fortran2003 commands

  USE healpix_types, ONLY : I4B, I8B
  IMPLICIT none

  private
  public :: getEnvironment, getArgument, nArguments, exit_with_status

  ! interface for the exit() method, which is part of the C library and
  ! should be linked automatically to Fortran programs
  interface
    subroutine exit(status) bind(C, name="exit")
    use iso_c_binding
    integer(c_int), value :: status
    end subroutine
  end interface

  contains

    ! ===========================================================
    function nArguments() result(narg)
      ! ===========================================================
      integer(kind=I4B) :: narg
      ! ===========================================================
      narg = command_argument_count()
    end function nArguments
    ! ===========================================================
    subroutine getEnvironment(name, value)
      ! ===========================================================
      character(len=*), intent(in) :: name
      character(len=*), intent(out) :: value
      value=""
      CALL get_environment_variable(name, value)
    end subroutine getEnvironment
    ! ===========================================================
    subroutine getArgument(index, argument)
      ! ===========================================================
      integer(kind=I4B), intent(in) :: index
      character(len=*), intent(out) :: argument
      ! ===========================================================
      argument=""
      call get_command_argument(index, argument)
    end subroutine getArgument

    ! ===========================================================
    subroutine exit_with_status (code, msg)
      ! ===========================================================
      integer(i4b), intent(in) :: code
      character (len=*), intent(in), optional :: msg
      ! ===========================================================
      if (present(msg)) print *,trim(msg)
      print *,'program exits with exit code ', code
      call exit (code)
    end subroutine exit_with_status

end module extension

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module sub_ngpdf_powergauss

  private
  public :: powergauss_driver
contains

!-----*-----------------------------------------------------------------

  SUBROUTINE powergauss_driver(handle, ns, sigma0, x, mu, bins)

    ! Draws a white noise map realisation from the 2nth power of a Gaussian
    ! variable with standard deviation sigma0. Its centred moments are mu
    ! (returns mu_1 ... mu_3). These are not the same as the cumulants for
    ! mu_4 and above.
    
    Use healpix_types
    Use paramfile_io, ONLY : paramfile_handle, parse_int, concatnl, parse_lgt
    use rngmod,    only: rand_init, planck_rng
    Use sky_sub
    
    implicit none
    integer(I4B), parameter :: KMAP = SP
    type(paramfile_handle), Intent(InOut)    :: handle
    integer(I4B), Intent(In)           :: ns !,npixmax 
    Real(DP),   Intent(Out)                  :: sigma0
    Real(KMAP), Intent(Out), dimension(0:ns-1) :: x
    real(DP),   Intent(Out), dimension(1:3)   :: mu
    Integer(I4B), Intent(In), Optional :: bins

    integer(I4B)                      ::  i,iseed,npower
    real(DP)                          ::  skewrel
    real(DP)                          ::  term2,term4,term6
    real(KMAP)                        ::  xmin,xmax
    character(len=filenamelen)        :: description
    character(len=20)                 :: chline
    logical(LGT)                      :: plot, do_bin = .false.
#ifdef PGPLOT
    integer, parameter                ::  npts=200  
    real(SP), dimension(1:npts)       ::  xline,yline
    real(DP)                          ::  xstep,xval
    integer :: pgdev, pgopen
#endif
    character(len=*), parameter :: code = 'shodev_driver'
    type(planck_rng) :: rng_handle

    If (present(bins)) do_bin = .True.

    !      initialize variables
!    chline = 'idum'
    chline = 'iseed'
    If (do_bin) call add_subscript(chline, bins)
    description = concatnl( "", &
         & " Input seed integer iseed:")
    iseed = parse_int(handle, chline, default=1, descr=description)
    !     --- If necessary use current system time to set seed  ---
    IF (iseed .eq. 0) THEN
       CALL SYSTEM_CLOCK(COUNT = iseed)
       !-- Seed should initially be set to a large, odd integer --
       IF (MOD(iseed,2) .EQ. 0) iseed = iseed + 1
       PRINT *,"      "//code//"> Generating random number seed ", iseed
    END IF

!    idum=-iabs(idum)
    call rand_init(rng_handle, iseed)    

    sigma0=1.d0

    chline = 'npower'
    If (do_bin) call add_subscript(chline, bins)
    description = concatnl(&
         & "", &
         & " Input n (variate is then x^2n):")
    npower = parse_int(handle, chline, default=1, vmin =1, vmax = 4, descr=description)
    ! NB using a value greater than 4 seems to crash due to numerical overflow

    ! Calculate centred moments of distribution

    ! term2=(2n-1)!!, term4=(4n-1)!!, term6=(6n-1)!!

    term2=1.0_dp
    do i=1,2*npower-1,2
       term2=term2*real(i, DP)
    end do
    !      Write (*,*) 'Term 2 is ', term2

    term4=1.0_dp
    do i=1,4*npower-1,2
       term4=term4*real(i, DP)
    end do
    !      Write (*,*) 'Term 4 is ', term4

    term6=1.0_dp
    do i=1,6*npower-1,2
       term6=term6*real(i, DP)
    end do
    !      Write (*,*) 'Term 6 is ', term6

    mu(1)=0.0_dp
    mu(2)=(term4 - term2**2)*sigma0**(4*npower)
    mu(3)=(term6 - 3.0_dp*term2*term4 + 2.0_dp*term2**3)*sigma0**(6*npower)

    skewrel=mu(3)/mu(2)**(3.0_dp/2.0_dp)

    write(*,*) 'mu1=', mu(1)
    write(*,*) 'mu2=', mu(2)
    write(*,*) 'mu3=', mu(3)
    write(*,*) 'Relative skewness=', skewrel

    ! Generate the map of non-Gaussian white noise

    xmin=0_KMAP
    xmax=0_KMAP
    do i = 0, ns-1
!       x(i)=powergauss(idum,npower,sigma0,term2)
       x(i) = powergauss(rng_handle, npower, sigma0, term2)
       if (x(i).lt.xmin) xmin=x(i)
       if (x(i).gt.xmax) xmax=x(i)
    end do
    xmax=min(xmax, real(sqrt(mu(2)), kind=KMAP)  )

#ifdef PGPLOT
    ! Find out if plotting is required
    description = concatnl( "", &
         & " Plot histogram of pixel values? (True or False)")
    plot = parse_lgt(handle, 'plot', default=.false., descr=description)
    If (plot) then 
       !     Write (*,*) 'Plot histogram of pixel values...'
!        call pgbegin(0,'?',1,1)
111    pgdev = pgopen('?')
       if (pgdev < 0) goto 111
       call pghist(ns,x,xmin,xmax,200,0)
       call pglab('Value','Number of pixels','Non-Gaussian PowGauss White Noise Map')

       xstep=(xmax-xmin)/real(npts-1, DP)
       do i=1,npts
          xval=xmin+real(i-1, DP)*xstep+1.e-5
          xline(i)=xval
          yline(i)=pdf(xval,sigma0,npower,term2)
       end do
       yline=yline*real(ns)*(xmax-xmin)/200.0
       call pgsci(12)
       call pgline(npts,xline,yline)

       call pgend

    End If !plot
#endif

  END SUBROUTINE powergauss_driver

  !-----*-----------------------------------------------------------------

  ! Returns the non-Gaussian pdf, for plotting only

  REAL FUNCTION pdf(x,sigma0,npower,term2)

    use healpix_types
    implicit none
    integer(i4b)            :: npower
    real(DP)               :: x,sigma0,term2

    real(DP)               :: xp,xg

    ! Add in mean again
    xp = x + term2*sigma0**(2*npower)

    ! Get Gaussian variable
    xg=xp**(0.5d0/real(npower, DP))

    ! Gaussian PDF
    pdf = exp(-0.5d0*(xg/sigma0)**2) / ( sqrt(2.d0*pi)*sigma0 )

    ! Apply Jacobian
    pdf = pdf /(real(npower, DP)*xg**(2.d0*npower-1.d0)) 

    return
  END FUNCTION pdf


  !-----*-----------------------------------------------------------------

  ! Draws a single sample from a Gaussian with standard deviation sigma0,
  ! raises to the power 2*npower and returns this as the function value

!  REAL FUNCTION powergauss(idum,npower,sigma0,term2)
  FUNCTION powergauss(rng_handle, npower, sigma0, term2) result (pgauss)

    use healpix_types
    use rngmod, only: planck_rng, rand_gauss

    implicit none
    real(DP) :: pgauss
    type(planck_rng), intent(inout) :: rng_handle
!    integer(i4b), intent(in)  :: idum
    integer(i4b), intent(in)  :: npower
    real(DP), intent(in)      :: sigma0,term2

    real(DP)               :: normal, cvar

    ! Get a Gaussian variate with unit variance

    normal = rand_gauss(rng_handle)

    ! Raise to 2*npower and centre
    cvar = normal**(2*npower)-term2

    ! Normalise
    pgauss = cvar*sigma0**(2*npower)

    return
  END FUNCTION powergauss


  !-----*-----------------------------------------------------------------

end module sub_ngpdf_powergauss

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------

module mask_tools
  ! module for mask processing
  !
  ! All input mask are assumed to be in NESTED ordering
  !
  ! HISTORY:
  !  E. Hivon 2006-2010 firt developments (mask_processing.f90)
  !  2011-11-22: inclusion in Healpix 

  use healpix_types
  use long_intrinsic, only: long_size
  implicit none

  private

  public :: fill_holes_nest
  public :: maskborder_nest
  public :: dist2holes_nest
  public :: size_holes_nest

  integer(i4b), parameter, private :: PIXBAD = 0  ! invalid pixels
  integer(i4b), parameter, private :: PIXGOOD = 1 ! valid pixels
  integer(i4b), parameter, private :: DEFBTAG = 2 ! default border value, must not be 0 nor 1


contains
  !======================================================================
  subroutine fill_holes_nest(nside, newminsize, mask_in, mask_out)
    !======================================================================
    ! fill_holes_nest(nside, newminsize, mask_in, mask_out)
    !
    ! nside      IN, Healpix resolution parameter
    ! newminsize IN, minimal size of hole (in pixels) on output
    ! mask_in    IN, Integer*4, full sky map, in NESTED scheme
    !       mask of good pixels (mask=1) and bad pixels (mask=0)
    ! mask_out   OUT, Integer*4, full sky map, in NESTED scheme
    !       bad pixels located in a 'hole' with fewer than newminsize pixels
    !      take value 1 (ie become valid)
    !
    ! A hole is the set of all adjacent pixels initially set to 0.
    ! 2 pixels are adjacent if they have at least one point in common.
    !
    !======================================================================
    use pix_tools,  only: nside2npix
    use misc_utils, only: fatal_error
    ! dummy variables
    integer(I4B),                intent(IN)  :: nside
    integer(I4B),                intent(IN)  :: newminsize
    integer(I4B), dimension(0:), intent(IN)  :: mask_in
    integer(I4B), dimension(0:), intent(OUT) :: mask_out
    ! local variables
    integer(I4B) :: out
    integer(I4B), parameter :: MKD = I4B
    integer(MKD) :: p, nholes, npholes
    integer(MKD), dimension(:), pointer :: sizeholes, listpix
    !-------------------------------------------------------------------

    mask_out = mask_in
    if (newminsize > 0) then
       call size_holes_nest(nside, mask_out, nholes, npholes, sizeholes=sizeholes, listpix=listpix)
       do p=0,nholes-1
          out = PIXBAD ! leave that hole to hole value
          if (sizeholes(p) < newminsize) out = PIXGOOD ! fill that hole
          mask_out(listpix(listpix(p):listpix(p+1)-1)) = out
       enddo
    endif

    return
  end subroutine fill_holes_nest

  !======================================================================
  subroutine maskborder_nest(nside, mask_in, mask_out, nbordpix, border_value)
  !======================================================================
    ! maskborder_nest(nside, mask_in, mask_out, nbordpix [, border_value])
    !
    ! mask_in IN, Integer*4, full sky map, in NESTED scheme
    !    on input: mask of good pixels (mask=1) and bad pixels (mask=0)

    ! mask_out OUT, Integer*4, full sky map, in NESTED scheme
    !    on output: inner border of bad regions takesmask=border_value
    !
    ! nbordpix OUT, Integer*4
    !    number of pixels in border
    !
    ! border_value IN, OPTIONAL, Integer*4
    !    value given to border pixels = 2 by default
    !======================================================================
    use pix_tools,  only: nside2npix, neighbours_nest
    use misc_utils, only: fatal_error

    ! dummy variables
    integer(I4B),                intent(IN) :: nside
    integer(I4B), dimension(0:), intent(in) :: mask_in
    integer(I4B), dimension(0:), intent(out) :: mask_out
    integer(I4B),                intent(out) :: nbordpix
    integer(I4B), optional,      intent(in) :: border_value
    
    ! local variables
    integer(I8B) :: npix, sz1, sz2, p
    integer(I8B), dimension(0:7) :: list
    integer(I4B) :: minmask, maxmask, i, nn
    integer(I4B), dimension(0:7) :: values
    character(len=*), parameter  :: code = 'maskborder_nest'
    integer(i4b) :: mytag ! user-defined border value
    integer(i4b) :: minallowed, maxallowed
    !----------------------------------------------------------------------

    sz1  = long_size(mask_in)
    sz2  = long_size(mask_out)
    npix = nside2npix(nside)
    if (sz1 /= npix .or. sz2 /= npix) then
       write(*,'(a,a,i11,a)')    code,' found ',   sz1,  ' pixels in mask_in'
       write(*,'(a,a,i11,a)')    code,' found ',   sz2,  ' pixels in mask_out'
       write(*,'(a,a,i11,a,i5)') code,' expected ',npix,' pixels for Nside = ',nside
       call fatal_error('Aborting '//code)
    endif
    minmask = minval(mask_in)
    maxmask = maxval(mask_in)
    minallowed = min(PIXGOOD, PIXBAD)
    maxallowed = max(PIXGOOD, PIXBAD)
    if (maxmask > maxallowed .or. minmask < minallowed) then
       print*,'>>>>> Range of input mask: ',minmask,maxmask
       print*,'>>>>> Allowed range: ',minallowed, maxallowed
       call fatal_error('Aborting '//code)
    endif

    ! test particular cases with no border
    nbordpix = 0
    if (maxmask == minallowed) return !all pixels are bad
    if (minmask == maxallowed) return !all pixels are good

    mask_out = mask_in
    ! start actual calculation
    do p = 0, npix - 1
       if (mask_out(p) == PIXBAD) then
          ! test neighbours of bad pixels
          call neighbours_nest(nside, p, list, nn)
          values(0:nn-1) = mask_out(list(0:nn-1))
          do i=0,nn-1
             ! if any neighbour is valid, then bad pixel belongs to border
             if (values(i) == PIXGOOD) then
                nbordpix = nbordpix + 1
                mask_out(p) = DEFBTAG
                goto 1234
             endif
          enddo
1234      continue

       endif
    enddo

    ! change border value from default to user-defined (if applicable)
    mytag = DEFBTAG
    if (present(border_value)) then
       mytag = border_value
    endif
    if (mytag /= DEFBTAG) then
       do p = 0, npix - 1
          if (mask_out(p) == DEFBTAG) mask_out(p) = mytag
       enddo
    endif

    return
  end subroutine maskborder_nest

  ! ==========================================================================
  subroutine dist2holes_nest(nside, mask, distance)
    ! ==========================================================================
    ! for each valid pixel, returns distance (in radians) from pixel center to 
    ! center of closest invalid pixel.
    ! The input mask must be NESTED ordered
    !
    ! Algorithm:
    !  To begin with, the inner border (=invalid pixels in touch with valid ones) 
    !  of each invalid region is identified
    ! Then a small Nside is used to select the closest border pixels, and finally
    ! the distance of each valid pixel to the selected border pixels is computed
    ! to find its minimum.
    !
    ! Note: final distances are computed with  2 ASIN (|v1-v2|/2) which is more
    ! accurate than the usual ACOS(v1.v2) at small separations.
    ! ==========================================================================

    use pix_tools, only: nside2npix, npix2nside, pix2vec_nest
    use misc_utils, only: fatal_error, wall_clock_time
    use num_rec, only: indexx

    integer(I4B),                intent(IN)  :: nside
    integer(I4B), dimension(0:), intent(IN)  :: mask
    real(DP),     dimension(0:), intent(OUT) :: distance
!    integer(i4b), parameter :: algo = 1
    integer(i4b), parameter :: nslow = 64 ! 64 or 128
!    integer(i4b), parameter :: dimtest = 1
    logical(LGT), parameter :: brute_force = .false.
    logical(LGT), parameter :: do_clock = .false. !.true.
    

    integer(I8B) :: npix1, npix2, npix, p, iratio
    integer(I4B) :: nside1, nside2
    integer(I4B) :: pb, pv, q, qq
    integer(I4B) :: cache, nstride, nl, il, i1, i2
    integer(I4B) :: n_invalid
    integer(I4B), dimension(:), allocatable   :: mask1
    integer(I4B)                              :: nbordpix
    real(DP),     dimension(:,:), allocatable :: bordpos
    real(DP),     dimension(:,:), allocatable :: bv
    real(DP),     dimension(:  ), allocatable :: dd
    integer(I4B), dimension(:  ), allocatable :: bordpix
    real(DP),     dimension(1:3)              :: vv, v1
    real(DP)                                  :: ddmin
    integer(I4B) :: nslow_in, nplow, nploweff, n2test, n_in_list
    integer(I4B) :: nlactive
    real(DP),    dimension(:,:,:), allocatable :: vertlow
    integer(I4B), dimension(:), allocatable :: nb_in_lp, p2test, start_list
    integer(I4B), dimension(:,:), allocatable :: non_empty_low
    real(DP) :: ddmax, dtotop
    real(DP), dimension(1:3,1:4) :: tmpvertex

    real(DP), dimension(:), allocatable :: drange
    real(DP)                              :: distmin, distmax

    real(DP),    dimension(:,:), allocatable :: centlow, centpix

    character(len=*), parameter :: code = 'dist2holes_nest'
    integer(i4b) ::  algo_in, q1, pp, pstart, np, nb
    real(DP),     dimension(:,:), allocatable :: bordpospack
    real(sp) :: t0, t1, t2, t3, ts1, ts2, ts3, tstart, tend, ta1, tsa1, tinit
    real(DP) :: fudge, cfudge, sfudge, threshold, mean_nbord
    !----------------------------------------------------------------------

    ! test inputs
    npix1 = long_size(mask)
    nside1 = npix2nside(npix1)
    if (nside1 < 0) call fatal_error('Invalid size of input mask in '//code)

    npix2 = long_size(distance)
    nside2 = npix2nside(npix2)
    if (nside2 < 0) call fatal_error('Invalid size of distance in '//code)

    npix = nside2npix(nside)
    if (npix1 /= npix .or. npix2 /= npix) then
       call fatal_error('Arrays too small in '//code)
    endif

    ! find pixels lying on holes border
    allocate(mask1(0:npix-1))
    call maskborder_nest(nside, mask, mask1, nbordpix)

    ! treat particular case of no border
    if (nbordpix == 0) then
       distance = 0.0_DP
       return
    endif
    n_invalid = 0

    !algo_in = algo

    if (do_clock) call wall_clock_time(tstart)
    pb = 0
    distance = 1.e6 ! set all pixels to large values
    ! find 3D location of those border pixels
    allocate(bordpos(0:nbordpix-1,1:3))
    allocate(bordpix(0:nbordpix-1))
    do p=0, npix-1
       if (mask1(p) == DEFBTAG) then 
          call pix2vec_nest(nside, p, vv)
          bordpos(pb,1:3) = vv
          bordpix(pb) = p
          pb = pb + 1
          distance(p) = 0.0_dp
       endif
       if (mask1(p) == PIXBAD) distance(p) = 0.0_dp
    enddo

    !if (algo_in == 1) then
       ! define low resolution grid
       nslow_in = min(nslow, nside)
       nplow = nside2npix(nslow_in)
       iratio = nside / nslow_in
       iratio = iratio * iratio ! ratio of number of pixels
       fudge = 4.276_dp / real(nslow_in, kind=DP) ! 2.0 x diagonal of longest pixel, at large Nside
       fudge = min(fudge, PI)
       sfudge = sin(fudge)
       cfudge = cos(fudge) ! cosine of fudge

       ! find low resolution pixels containing border pixels (=non_empty)
       allocate(nb_in_lp(0:nplow-1))
       nb_in_lp = 0
       do p=0, nbordpix-1
          q = bordpix(p) / iratio
          nb_in_lp(q) = nb_in_lp(q) + 1 ! number of border pixels in each low-res pixel
       enddo
       if (sum(nb_in_lp) /= nbordpix) then
          print*,sum(nb_in_lp),nbordpix
          call fatal_error('Error 1 with low res pixels')
       endif
       if (maxval(nb_in_lp) > iratio) then
          print*,maxval(nb_in_lp),iratio
          call fatal_error('Error 1a with low res pixels')
       endif
       nploweff = count(nb_in_lp > 0)
       allocate(non_empty_low(0:nploweff-1,1:2))
       qq = 0
       do q=0, nplow-1
          if (nb_in_lp(q) > 0) then
             non_empty_low(qq,1) = q ! list of non-empty low-res pixels
             non_empty_low(qq,2) = nb_in_lp(q) ! number of border pixels
             qq = qq + 1
          endif
       enddo
       allocate(start_list(0:nploweff))
       start_list(0) = 0
       do qq=1, nploweff
          start_list(qq) = start_list(qq-1) + non_empty_low(qq-1,2)
       enddo
       if (start_list(nploweff) /= nbordpix) then
          print*,start_list(nploweff),nbordpix
          call fatal_error('Error 2 with low res pixels')
       endif
       deallocate(nb_in_lp)

       ! build location of center for non-empty low resolution "border" pixels
       allocate(centlow(1:3,    0:nploweff-1))
       do qq=0, nploweff-1
          q = non_empty_low(qq,1)
          call pix2vec_nest(nslow_in, q, vv)
          centlow(1:3, qq)      = vv(1:3)
       enddo
       allocate(drange(0:nploweff-1))
       allocate(p2test(    0:nploweff-1))
       allocate(centpix(1:3, 0:iratio-1))
       allocate(dd(0:iratio-1))
       allocate(bordpospack(0:nbordpix-1, 1:3 ))

       if (do_clock) then
          call wall_clock_time(t0)
          tinit = t0-tstart
       endif

       ts1 = 0. ; tsa1 = 0. ; ts2 = 0. ; ts3 = 0.
       nlactive = 0
       ! loop on low-resolution pixels
       do q1=0, nplow-1
          ! keep only those containing valid small pixel
          if (any(mask1(q1*iratio:(q1+1)*iratio-1) == PIXGOOD) ) then
             nlactive = nlactive + 1
             if (do_clock) call wall_clock_time(t0)
             ! center location of current low-res pixel
             call pix2vec_nest(nslow_in, q1, vv)

             ! distance of low-res pixel center with each center of low-res "border" pixels
! !$OMP PARALLEL DEFAULT(NONE) &
! !$OMP SHARED(nploweff, drange, centlow, vv) &
! !$OMP PRIVATE(qq)
! !$OMP DO schedule(static, 4)
             do qq=0, nploweff - 1
                drange(qq) = centlow(1, qq) * vv(1) &
                     &     + centlow(2, qq) * vv(2) &
                     &     + centlow(3, qq) * vv(3) 
             enddo
! !$OMP END DO
! !$OMP END PARALLEL
             ! min distance (=max scalar product)
             distmin = maxval(drange)
             distmin = min(distmin, 1.0_dp)
             
             ! find out list of low-res "border" pixels close enough to be checked-out at higher-res
             ! radius = smallest distance found above + fudge
             if ((distmin + cfudge) > 0.0_dp) then ! new radius is less than Pi
                threshold = distmin*cfudge - sfudge*sqrt((1.d0-distmin)*(1.d0+distmin))
             else! new radius can not exceed Pi
                threshold = -1.0_dp
             endif
             n2test = 0
             do qq=0, nploweff - 1
                if (drange(qq) >= threshold) then ! for scalar product
                   p2test(n2test) = qq
                   n2test = n2test + 1
                endif
             enddo
                
             ! store location of border pixels contained in relevant low-res pixels
             pstart = 0
             do q=0, n2test-1
                qq = p2test(q)
                i1 = start_list(qq)
                i2 = start_list(qq+1)-1
                n_in_list = i2 - i1 + 1
                bordpospack(pstart:pstart+n_in_list-1,1:3) = bordpos(i1:i2,1:3)
                pstart = pstart + n_in_list
             enddo
             nb = pstart ! number of border pixels close enough to be considered
             mean_nbord = mean_nbord + nb

             if (do_clock) then
                call wall_clock_time(t1)
                ts1 = ts1 + (t1 - t0)
             endif
             ! center location for small pixels
             pp = 0
             do p=q1*iratio, (q1+1)*iratio - 1
                if (mask1(p) == PIXGOOD) then
                   call pix2vec_nest(nside, p, v1)
                   centpix(1:3, pp) = v1
                   pp = pp + 1
                endif
             enddo
             np = pp ! number of valid small pixels in current low-res pixels
             
             if (do_clock) then
                call wall_clock_time(ta1)
                tsa1 = tsa1 + (ta1 - t1)
             endif
             ! scalar product: small pixels * border pixels

!$OMP PARALLEL DEFAULT(NONE) &
!$OMP SHARED(np, nb, dd, bordpospack, centpix) &
!$OMP PRIVATE(pp)
!$OMP DO schedule(guided, 4)
             do pp = 0, np-1
                ! compute (v1-v2)^2 in [0,4]
                dd(pp) = minval(  (bordpospack(0:nb-1,1)-centpix(1,pp))**2 &
                     &          + (bordpospack(0:nb-1,2)-centpix(2,pp))**2 &
                     &          + (bordpospack(0:nb-1,3)-centpix(3,pp))**2)
             enddo
!$OMP END DO
!$OMP END PARALLEL

             if (do_clock) then
                call wall_clock_time(t2)
                ts2 = ts2 + (t2 - ta1)
             endif

             ! norm2 -> angular distance (radians)
             pp = 0
             do p=q1*iratio, (q1+1)*iratio - 1
                if (mask1(p) == PIXGOOD) then
                   if (dd(pp) < 0.0_dp .or. dd(pp) > 4.0_dp) then
                      n_invalid = n_invalid + 1
                   endif
                   distance(p) = 2.d0 * asin( sqrt(dd(pp)) * 0.5d0 )
                   pp = pp + 1
                endif
             enddo
             if (do_clock) then
                call wall_clock_time(t3)
                ts3 = ts3 + (t3 - t2)
             endif
          endif
       enddo ! loop on low res pixels
       deallocate(drange, p2test, dd)
       deallocate(bordpix)
       deallocate(non_empty_low)
       if (n_invalid > 0) then
          write(*,'(a,i7,a)') 'WARNING: Found ',n_invalid,' invalid distances: '
       endif
       if (do_clock) then
          call wall_clock_time(tend)
          print*,nside, nslow, nbordpix, mean_nbord/nlactive
          write(*,'(7(a12))')     'init', 'prep', 'pix2vec', 'product','acos', 'total',          'actual'
          write(*,'(4x,7(g12.4))') tinit, ts1,     tsa1,      ts2,    ts3,    ts1+tsa1+ts2+ts3, tend-tstart
       endif

    !endif ! algo_in
       
    deallocate(mask1)

  end subroutine dist2holes_nest

  !=========================================================================
   subroutine size_holes_nest(nside, mask, nholes, nph, &
        &                     tags, sizeholes, listpix)
     !=========================================================================
     ! SIZE_HOLES_NEST: subroutine to determine size (=number of pixels) of holes
     ! A hole is the set of all adjacent pixels initially set to 0.
     ! 2 pixels are adjacent if they have at least one point in common.
     !
     ! Nside: integer, IN, resolution parameter
     ! Mask(0:): integer 1D array, IN, each pixel must be either 1 (=valid) or 0 (=invalid)
     ! Nholes: integer, OUT, number of holes
     ! Nph:    integer, OUT, total number of pixels in holes
     ! Tags(0:npix-1): integer 1D array, OPTIONAL, OUT:
     !                   invalid pixels belonging to largest hole have value -1,
     !                   invalid pixels belonging to second largest hole: -2,
     !                   and so on, while valid pixels have value 1
     ! Sizeholes(0:Nholes-1): integer pointer, OPTIONAL, OUT: respective size of each hole
     ! Listpix(0:Nph+Nholes): integer pointer, OPTIONAL, OUT: list of pixels in each hole
     !
     !========================================================================
    use healpix_types
    use pix_tools,  only: nside2npix, neighbours_nest
    use misc_utils, only: fatal_error, assert_alloc
    use num_rec,    only: iindexx

    integer(I4B),                intent(IN) :: nside
    integer(I4B), dimension(0:), intent(IN) :: mask
    integer(I4B),                intent(OUT)   :: nholes, nph
    integer(I4B), dimension(:),  optional, pointer :: tags
    integer(I4B), dimension(:),  optional, pointer :: sizeholes
    integer(I4B), dimension(:),  optional, pointer :: listpix

    integer(I4B) :: i, p, q, nnb, nvalid, nbad, status
    integer(I4B) :: minmask, maxmask, nlist
    integer(I4B) :: h, k, k2, np, shift
    integer(I4B), dimension(0:7) :: lnb
    integer(I4B) :: ninstack, stackmax, hole_id
    integer(I4B), dimension(:), allocatable :: stack, list, mytags
    integer(I4B), dimension(:), allocatable :: tally
    integer(I4B), dimension(:), allocatable :: indx, cumulu, cumuls, revert
    integer(I4B), parameter :: unprocessed = 0
    integer(I8B) :: npix, sz
    character(len=*), parameter  :: code = 'size_holes_nest'
    logical(LGT), parameter :: sorted = .true.
    logical(LGT) :: do_size, do_list, do_tags
    !----------------------------------------------------------------------

    sz = size(mask,1)
    npix = nside2npix(nside)
    if (sz /= npix) then
       write(*,'(a,a,i11,a)')    code,' found ',   sz,  ' pixels in mask'
       write(*,'(a,a,i11,a,i5)') code,' expected ',npix,' pixels for Nside = ',nside
       call fatal_error('Aborting '//code)
    endif
    minmask = minval(mask)
    maxmask = maxval(mask)
    if (maxmask > 1 .or. minmask < 0) then
       print*,'>>>>> Range: ',minmask,maxmask
       call fatal_error('input mask should be in [0,1] in '//code)
    endif

    do_size = (present(sizeholes))
    do_list = (present(listpix))
    do_tags = (present(tags))

    nvalid = sum(mask)
    nbad = npix - nvalid
    stackmax = max(8*nbad,100)

    allocate(stack(0:stackmax), stat=status)
    call assert_alloc(status, code, 'stack')
    allocate(tally(0:npix/2), stat=status)
    call assert_alloc(status, code, 'tally')
    allocate(list(0:nbad+1), stat=status)
    call assert_alloc(status, code, 'list')
    allocate(mytags(0:npix-1), stat=status)
    call assert_alloc(status, code, 'mytags')
    stack(:) = -1
    tally(:) = 0
    list(:)  = -1
    k        = 0
    hole_id  = 0
    mytags   = mask

    !print*,npix, nvalid, nbad


    ! loop over all pixels
    do p=0, npix-1

       if (mytags(p) == unprocessed) then
          ! start a new hole and a new stack
          hole_id = hole_id + 1
          ninstack = 1
          q = p

          do

             ! mark current pixel as processed
             ! add it to current hole tally and hole list
             if (mytags(q) == unprocessed) then
                mytags(q) = -hole_id
                tally(hole_id-1) = tally(hole_id-1) + 1
                list(k) = q
                k = k + 1
             endif

             ! remove it from stack
             ninstack = ninstack - 1

             ! put unprocessed neighbouring pixels 
             !    belonging to hole into stack
             call neighbours_nest(nside, q, lnb, nnb)
             do i=0,nnb-1
                if (mytags(lnb(i)) == unprocessed) then
                   stack(ninstack) = lnb(i)
                   ninstack = ninstack + 1
                endif
             enddo

             ! move on to pixel on top of stack, and repeat
             !    unless stack is empty
             if (ninstack == 0) exit
             q = stack(ninstack-1)
          enddo

       endif

    enddo
    deallocate(stack)

    ! create OPTIONAL Tags output
    if (do_tags) then 
       allocate(tags(0:npix-1),stat=status)
       call assert_alloc(status, code, 'tags')
       tags(0:npix-1) = mytags(0:npix-1)
    endif
    deallocate(mytags)


!     print*,'number of holes:',hole_id
!     if (hole_id > 0) then
!        print*,'Hole,    size'
!        do p=0, hole_id-1
!           print*,p,tally(p)
!        enddo
!     endif
!     print*,'total',nbad,sum(tally)

    nholes = hole_id
    nph = sum(tally)
    nlist = nholes + nph + 1


    if (do_size .or. do_list .or. (do_tags.and.sorted)) then
       if (.not. sorted) then
          ! ----- unsorted lists --------
          if (do_size) then
             allocate(sizeholes(0:nholes-1), stat=status)
             call assert_alloc(status, code, 'sizeholes')
             sizeholes = tally
          endif
          
          if (do_list) then
             allocate(listpix(0:nlist-1), stat=status)
             call assert_alloc(status, code, 'listpix')

             allocate(cumulu(0:nholes), stat=status)
             call assert_alloc(status, code, 'cumulu')
             cumulu(0) = 0
             do h=1,nholes
                cumulu(h) = cumulu(h-1) + tally(h-1)
             enddo

             listpix(0:nholes) = cumulu+nholes+1
             listpix(nholes+1:nlist-1) = list
             deallocate(cumulu)
          endif

       else
          ! ----- sorted lists -------

          allocate(indx(0:nholes-1), stat=status)
          call assert_alloc(status, code, 'indx')
          ! find indexing for size sorting (decreasing order)
          tally = -tally
          call iindexx(nholes, tally, indx)
          tally = -tally
          shift = minval(indx) - lbound(tally,1)
          indx = indx - shift ! make sure INDX is consistent with TALLY indexing

          if (do_size) then
             allocate(sizeholes(0:nholes-1), stat=status)
             call assert_alloc(status, code, 'sizeholes')
             sizeholes = tally(indx)
          endif

          if (do_tags) then
             allocate(revert(0:nholes-1), stat=status)
             call assert_alloc(status, code, 'revert')
             do h=0, nholes-1
                revert(indx(h)) = h ! in 0,1,2, ..
             enddo
             do p=0,npix-1
                q = tags(p) ! in -1, -2, -3, ..
                if (q < 0) then
                   tags(p) = -1 - revert(-1-q)
                endif
             enddo
             deallocate(revert)
          endif

          if (do_list) then
             allocate(listpix(0:nlist-1), stat=status)
             call assert_alloc(status, code, 'listpix')

             ! cumul of unsorted tallies
             allocate(cumulu(0:nholes), stat=status)
             call assert_alloc(status, code, 'cumulu')
             cumulu(0) = 0
             do h=1,nholes
                cumulu(h) = cumulu(h-1) + tally(h-1)
             enddo
             ! cumul of sorted tallies
             allocate(cumuls(0:nholes), stat=status)
             call assert_alloc(status, code, 'cumuls')
             cumuls(0) = 0
             do h=1,nholes
                cumuls(h) = cumuls(h-1) + tally(indx(h-1))
             enddo

             do h=0,nholes-1
                ! define list boundaries
                k2 = cumuls(h)+nholes+1
                listpix(h) = k2

                ! fill list between boundaries
                np = cumuls(h+1) - cumuls(h)
                k = indx(h)
                listpix(k2:k2+np-1) = list(cumulu(k):cumulu(k+1)-1)
             enddo
             ! make sure upper boundary is correct
             listpix(nholes) = nph+nholes+1

             deallocate(cumuls, cumulu)
          endif
          deallocate(indx)
       endif
    endif

    deallocate(tally)
    deallocate(list)

!     ! revert Mask to its initial values
!     where( mask < 0) mask = 0

    return

  end subroutine size_holes_nest

end module mask_tools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
! template for routine SP/DP overloading for module udgrade_nr
! 2010-06-25: support large maps (Nside > 8192)

! K M A P   : map kind                 either SP or DP
!
! K L O A D : suffixe of routine name, to be replaced by either s (SP) or d (DP)
  !=======================================================================
  subroutine sub_udgrade_nest_KLOAD(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    !=======================================================================
    !
    !     SUB_UDGRADE_NEST(map_in, nside_in, map_out, nside_out)
    !
    !     map_in    : input map (REAL)
    !     nside_in  : resolution parameter of the input map (npix =12*nside**2)
    !                 must be a power of 2 (INTEGER)
    !     map_out   : output map (REAL)
    !     nside_out : resolution parameter of the output map (npix =12*nside**2)
    !                 must be a power of 2 (INTEGER)
    !
    !     upgrades or degrades a map in the NESTED numbering
    !
    !     if nside_out > nside_in : upgrades
    !     value(each new sub-pixel) = value(old big pixel)
    !
    !     if nside_in < nside_out : degrades
    !     value(new big pixel) = sum values(old small pixels) / number_of_small_pixels
    !
    !     version 1.0 : Eric Hivon, TAC, September 1997
    !     version 1.1 : Dec 1997, correction of a bug in the map indices
    !     version 1.2 : Dec 2001, addition of pessimistic and non-pessimistic behaviors
    !     version 1.3:  Jun 2010: more realistic detection of bad_pixels, replace sum() and count()
    !            by explicit loop to better control accuracy and deal with large array
    !=======================================================================
    USE pix_tools, only : nside2npix
    INTEGER(I4B), INTENT(IN) :: nside_in, nside_out
    REAL(KMAP),     INTENT(IN),  DIMENSION(0:), target :: map_in
    REAL(KMAP),     INTENT(OUT), DIMENSION(0:) :: map_out
    REAL(KMAP),     INTENT(IN), OPTIONAL :: fmissval
    LOGICAL(LGT), INTENT(IN), OPTIONAL :: pessimistic

    INTEGER(I8B) :: npix_in, npix_out, npratio, nobs
    INTEGER(I8B) :: iu, ip, id
    LOGICAL(LGT) :: do_pessimistic
    REAL(KMAP)   :: bad_value, threshold, value
    real(DP)     :: total
    !-----------------------------------------------------------------------

    do_pessimistic = .false.
    npix_out = nside2npix(nside_out)
    npix_in  = nside2npix(nside_in)

    if (KMAP == SP) bad_value = HPX_SBADVAL
    if (KMAP == DP) bad_value = HPX_DBADVAL
    if (present(fmissval)) bad_value = fmissval
    threshold = abs(1.e-6_KMAP * bad_value)

    do ip=0, npix_out-1
       map_out(ip) = bad_value
    enddo

    if (nside_out < nside_in) then ! degrade
       if (present(pessimistic)) then
          do_pessimistic = pessimistic
       endif

       npratio = npix_in  / npix_out

!$OMP parallel default(none) &
!$OMP   shared(map_in, map_out, npix_out, npratio, do_pessimistic, bad_value, threshold) &
!$OMP   private(id, nobs, total, ip, value)
!$OMP do schedule(dynamic,64)
       do id=0,npix_out-1
          nobs  = 0
          total = 0.0_DP ! always DP
          do ip=0, npratio-1
             value = map_in(id*npratio + ip)
             if (abs(value-bad_value) > threshold) then
                nobs  = nobs  + 1
                total = total + value
             endif
          enddo
          if (do_pessimistic) then
             if (nobs == npratio) map_out(id) = total/nobs
          else
             if (nobs > 0) map_out(id) = total/nobs
          endif
       enddo
!$OMP end do
!$OMP end parallel

    else ! upgrade
       npratio = npix_out  / npix_in
!$OMP parallel default(none) &
!$OMP   shared(map_in, map_out, npix_out, npratio) private(iu, ip)
!$OMP do schedule(dynamic,64)
       do iu = 0, npix_out - 1
          ip = iu/npratio
          map_out(iu) = map_in(ip)
       enddo
!$OMP end do
!$OMP end parallel
    endif

    return
  end subroutine sub_udgrade_nest_KLOAD
!=======================================================================
  !
  !     UDGRADE_RING(map_in, nside_in, map_out, nside_out)
  !
  !     map_in    : input map (REAL)
  !                 This map will be converted to nested format on output.
  !     nside_in  : resolution parameter of the input map (npix =12*nside**2)
  !                 must be a power of 2 (INTEGER)
  !     map_out   : output map (REAL)
  !     nside_out : resolution parameter of the output map (npix =12*nside**2)
  !                 must be a power of 2 (INTEGER)
  !
  !     upgrades or degrades a map in the RING numbering
  !
  !     if nside_out > nside_in : upgrades
  !     value(each new sub-pixel) = value(old big pixel)
  !
  !     if nside_in < nside_out : degrades
  !     value(new big pixel) = sum values(old small pixels) / number_of_small_pixels
  !
  !
  !     calls the ring2nest and nest2ring routines available in pix_tools module
  !
  !
  !
  !     NB : the speed is not the main concern of this routine,
  !     which not supposed to be used intensively for big maps
  !
  !     version 1.0 : Eric Hivon, TAC, September 1997
  !     version 1.1 : Dec 1997, correction of a bug in the map indices
  !     version 2.0 : Dec 2004-March 2005: SP/DP and 1D/ND overload
  !=======================================================================
  subroutine udgrade_ring_1d_KLOAD(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    !=======================================================================
    !    1 dim implementation
    !=======================================================================
    USE pix_tools, only : nside2npix, ring2nest, convert_ring2nest, convert_nest2ring
    INTEGER(I4B), INTENT(IN) :: nside_in, nside_out
    REAL(KMAP), INTENT(INOUT), dimension(0:), target :: map_in
    REAL(KMAP), INTENT(OUT), dimension(0:),   target :: map_out
    REAL(KMAP), INTENT(IN), OPTIONAL :: fmissval
    LOGICAL(LGT) , INTENT(IN), OPTIONAL :: pessimistic

    INTEGER(I8B) :: npix_in, npix_out
    !-----------------------------------------------------------------------

    !     checks that the 2 nside are valid
    npix_out = nside2npix(nside_out)
    npix_in  = nside2npix(nside_in)
    if (npix_out < 0) then
       print*,"wrong nside_out in udgrade_ring : ", nside_out
       call fatal_error
    endif
    if (npix_in  < 0) then
       print*,"wrong nside_in  in udgrade_ring : ", nside_in
       call fatal_error
    endif

    call convert_ring2nest(nside_in, map_in)
    call sub_udgrade_nest(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    call convert_nest2ring(nside_out, map_out)

    return
  end subroutine udgrade_ring_1d_KLOAD

  !=======================================================================
  subroutine udgrade_ring_nd_KLOAD(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    !=======================================================================
    !    N dim implementation
    !=======================================================================
    use long_intrinsic, only: long_size
    USE pix_tools, only : nside2npix, ring2nest, convert_ring2nest, convert_nest2ring
    INTEGER(I4B), INTENT(IN) :: nside_in, nside_out
    REAL(KMAP), INTENT(INOUT), dimension(0:,1:), target :: map_in
    REAL(KMAP), INTENT(OUT),   dimension(0:,1:), target :: map_out
    REAL(KMAP), INTENT(IN), OPTIONAL :: fmissval
    LOGICAL(LGT) , INTENT(IN), OPTIONAL :: pessimistic

    INTEGER(I8B) :: npix_in, npix_out
    INTEGER(I4B) :: nd_in, nd_out, id
    real(KMAP), dimension(:), pointer :: p_in, p_out
    !-----------------------------------------------------------------------

    !    checks that the 2nd dimensions match
    nd_in  = long_size(map_in, 2)
    nd_out = long_size(map_out,2)
    if (nd_in /= nd_out) then
       print*,"UDGRADE_NEST: unconsistent dimension of input and output maps",nd_in,nd_out
       call fatal_error
    endif
       
    !     checks that the 2 nside are valid
    npix_out = nside2npix(nside_out)
    npix_in  = nside2npix(nside_in)
    if (npix_out < 0) then
       print*,"wrong nside_out in udgrade_ring : ", nside_out
       call fatal_error
    endif
    if (npix_in  < 0) then
       print*,"wrong nside_in  in udgrade_ring : ", nside_in
       call fatal_error
    endif

    call convert_ring2nest(nside_in, map_in)
    do id = 1, nd_in
       p_in  => map_in (0:npix_in -1, id) ! avoid actual replication in memory
       p_out => map_out(0:npix_out-1, id)
       call sub_udgrade_nest(p_in, nside_in, p_out, nside_out, fmissval, pessimistic)
    enddo
    call convert_nest2ring(nside_out, map_out)

    return
  end subroutine udgrade_ring_nd_KLOAD


  !=======================================================================
  !
  !     UDGRADE_NEST(map_in, nside_in, map_out, nside_out)
  !
  !     map_in    : input map (REAL)
  !     nside_in  : resolution parameter of the input map (npix =12*nside**2)
  !                 must be a power of 2 (INTEGER)
  !     map_out   : output map (REAL)
  !     nside_out : resolution parameter of the output map (npix =12*nside**2)
  !                 must be a power of 2 (INTEGER)
  !
  !     upgrades or degrades a map in the NESTED numbering
  !
  !     if nside_out > nside_in : upgrades
  !     value(each new sub-pixel) = value(old big pixel)
  !
  !     if nside_in < nside_out : degrades
  !     value(new big pixel) = sum values(old small pixels) / number_of_small_pixels
  !
  !     version 1.0 : Eric Hivon, TAC, September 1997
  !     version 1.1 : Dec 1997, correction of a bug in the map indices
  !     version 2.0 : Dec 2004-March 2005: SP/DP and 1D/ND overload
  !=======================================================================
  subroutine udgrade_nest_1d_KLOAD(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    !=======================================================================
    !  1 dim. implementation
    !=======================================================================
    USE pix_tools, only : nside2npix
    INTEGER(I4B), INTENT(IN) :: nside_in, nside_out
    REAL(KMAP), INTENT(IN), dimension(0:)  :: map_in
    REAL(KMAP), INTENT(OUT), dimension(0:) :: map_out
    REAL(KMAP), INTENT(IN), OPTIONAL :: fmissval
    LOGICAL(LGT) , INTENT(IN), OPTIONAL :: pessimistic

    INTEGER(I8B) :: npix_in, npix_out
    !-----------------------------------------------------------------------

    !     checks that the 2 nside are valid
    npix_out = nside2npix(nside_out)
    npix_in  = nside2npix(nside_in)
    if (npix_out < 0) then
       print*,"wrong nside_out in udgrade_nest : ", nside_out
       call fatal_error
    endif
    if (npix_in  < 0) then
       print*,"wrong nside_in  in udgrade_nest : ", nside_in
       call fatal_error
    endif

    call sub_udgrade_nest(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)

    return
  end subroutine udgrade_nest_1d_KLOAD
  !=======================================================================
  subroutine udgrade_nest_nd_KLOAD(map_in, nside_in, map_out, nside_out, fmissval, pessimistic)
    !=======================================================================
    !  N dim. implementation
    !=======================================================================
    use long_intrinsic, only: long_size
    USE pix_tools, only : nside2npix
    INTEGER(I4B), INTENT(IN) :: nside_in, nside_out
    REAL(KMAP), INTENT(IN),  dimension(0:,1:), target :: map_in
    REAL(KMAP), INTENT(OUT), dimension(0:,1:), target :: map_out
    REAL(KMAP), INTENT(IN), OPTIONAL :: fmissval
    LOGICAL(LGT) , INTENT(IN), OPTIONAL :: pessimistic

    INTEGER(I8B) :: npix_in, npix_out
    INTEGER(I4B) :: nd_in, nd_out, id
    real(KMAP), dimension(:), pointer :: p_in, p_out
    !-----------------------------------------------------------------------

    !    checks that the 2nd dimensions match
    nd_in  = long_size(map_in, 2)
    nd_out = long_size(map_out,2)
    if (nd_in /= nd_out) then
       print*,"UDGRADE_NEST: unconsistent dimension of input and output maps",nd_in,nd_out
       call fatal_error
    endif
       
    !     checks that the 2 nside are valid
    npix_out = nside2npix(nside_out)
    npix_in  = nside2npix(nside_in)
    if (npix_out < 0) then
       print*,"UDGRADE_NEST: wrong nside_out: ", nside_out
       call fatal_error
    endif
    if (npix_in  < 0) then
       print*,"UDGRADE_NEST: wrong nside_in: ", nside_in
       call fatal_error
    endif

    do id = 1, nd_in
       p_in  => map_in (0:npix_in -1, id) ! avoid actual replication in memory
       p_out => map_out(0:npix_out-1, id)
       call sub_udgrade_nest(p_in, nside_in, p_out, nside_out, fmissval, pessimistic)
    enddo


    return
  end subroutine udgrade_nest_nd_KLOAD

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module udgrade_nr

  ! --- in udgrade_template.f90 ---
  ! subroutine sub_udgrade_nest
  ! subroutine udgrade_ring
  ! subroutine udgrade_nest

  use healpix_types
  use misc_utils

  IMPLICIT none

  private

  public :: sub_udgrade_nest, udgrade_ring, udgrade_nest

  ! SP and DP interface
  interface sub_udgrade_nest
     module procedure sub_udgrade_nest_s, sub_udgrade_nest_d
  end interface

  ! SP and DP, 1-dim and N-dim interface
  interface udgrade_ring
     module procedure udgrade_ring_1d_s, udgrade_ring_1d_d, udgrade_ring_nd_s, udgrade_ring_nd_d
  end interface

  interface udgrade_nest
     module procedure udgrade_nest_1d_s, udgrade_nest_1d_d, udgrade_nest_nd_s, udgrade_nest_nd_d
  end interface
  !---------------------

contains

  ! include SP implementation of routines
  include 'udgrade_s_inc.f90'
  
  ! include DP implementation of routines
  include 'udgrade_d_inc.f90'


end module udgrade_nr

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module coord_v_convert

! module provided by C.Burigana & D.Maino (U. Milano)
! edited by E.Hivon

  use healpix_types
  use misc_utils, only : strupcase

  Implicit NONE

  private
  real(DP), parameter, private :: DTOR = PI/180.0_dp

  public :: coordsys2euler_zyz ! produce Euler angles (ZYZ) for coordinate conversion
  public :: xcc_v_convert ! front end routine
  public :: xcc_DP_E_TO_Q ! Ecl -> Eq
  public :: xcc_DP_E_TO_G ! Ecl -> Gal
  public :: xcc_DP_G_TO_E ! Gal -> Ecl
  public :: xcc_DP_Q_TO_E ! Eq  -> Ecl
  public :: XCC_DP_PRECESS ! precess ecliptic coord

contains
  subroutine coordsys2euler_zyz(iepoch, oepoch, isys, osys, psi, theta, phi)
    !
    ! routine producing Euler angles psi, theta, phi 
    !  (for rotation around the unrotated Z, Y, Z axes respectively)
    ! corresponding to changes of coordinates from ISYS to OSYS
    ! for respective epochs IEPOCH and OEPOCH
    ! the angles definition match the one required for rotate_alm.
    ! EH, March 2005
    !     April 06 2005, corrected psi calculation
    !
    !use pix_tools, only: angdist
    use num_rec, only: pythag
    real(dp),         intent(in)  :: iepoch, oepoch
    character(len=*), intent(in)  :: isys, osys
    real(dp),         intent(out) :: psi, theta, phi

    real(dp), dimension(1:3) :: v1, v2, v3, v1p, v2p, v3p
    real(dp) :: st, ct
    !-----------------------
 
    ! generate basis vector
    v1 = (/ 1.0_dp, 0.0_dp, 0.0_dp /)
    v2 = (/ 0.0_dp, 1.0_dp, 0.0_dp /)
    v3 = (/ 0.0_dp, 0.0_dp, 1.0_dp /)

    ! rotate them
    call xcc_V_CONVERT(v1,iepoch,oepoch,isys,osys,v1p)
    call xcc_V_CONVERT(v2,iepoch,oepoch,isys,osys,v2p)
    call xcc_V_CONVERT(v3,iepoch,oepoch,isys,osys,v3p)

    ! normalize vectors
    v1p = v1p / sqrt(dot_product(v1p,v1p))
    v2p = v2p / sqrt(dot_product(v2p,v2p))
    v3p = v3p / sqrt(dot_product(v3p,v3p))

    ! figure out Euler angles

!     call angdist(v3,v3p, theta)
!     psi = atan2(v2p(3),-v1p(3))
!     phi = atan2(v3p(2), v3p(1))

    st = pythag(v3p(1),v3p(2)) ! |sin(theta)| in [0,1]
    ct =        v3p(3)         !  cos(theta)  in [-1,1]
    theta = atan2(st, ct) ! theta in [0,Pi]
    if (st >= 1.d-7) then
       psi = atan2(v2p(3),-v1p(3))
       phi = atan2(v3p(2), v3p(1))
    else ! theta=0 or theta=Pi, phi and +/-psi degenerate
       if (ct >= 0) then ! theta=0
          ! only phi+psi is known
          psi = atan2(-v2p(1)+v1p(2), v2p(2)+v1p(1)) ! returns psi+phi for any theta /= 180
       else ! theta=pi, only  psi-phi in known
          psi = atan2(-v2p(1)-v1p(2), v2p(2)-v1p(1)) ! return psi-phi for any theta /= 0
       endif
       phi = 0.0_dp
    endif

    return
  end subroutine coordsys2euler_zyz

!
  Subroutine xcc_V_CONVERT(ivector,iepoch,oepoch,isys,osys,ovector)

!
!    Function to convert between standard coordinate systems, including
!  precession.
!  
!
!      Q,C:  Equatorial coordinates
!      E  :  Ecliptic coordinates
!      G  :  Galactic coordinates
!      SG :  Super Galactic coordinates  (TB implemented)
!      U  :  Universal Rest-frame coordinates (TB implemented)
!
!  03/14/88, a.c.raugh, STX.
!  11/15/01, C.Burigana & D.Maino, OAT
!
!
!  Arguments:
!
    real(dp) ::      IVECTOR(1:3)   ! Input coordinate vector
    real(dp) ::      IEPOCH         ! Input epoch
    real(dp) ::      OEPOCH         ! Output epoch        
    real(dp) ::      OVECTOR(1:3)   ! Output coordinate vector
    Character(len=*) ::    ISYS           ! Input system
    Character(len=*) ::    OSYS           ! Output system
!
!  Program variables:
!                 
    real(dp) ::      XVECTOR(1:3)     ! Temporary coordinate holder
    real(dp) ::      YVECTOR(1:3)     ! Temporary coordinate holder
    Character(len=20) ::    isysu     ! Input system, uppercase
    Character(len=20) ::    osysu     ! Output system, uppercase
!

    isysu = trim(strupcase(isys))
    osysu = trim(strupcase(osys))

!  If the input coordinate system was not ecliptic, convert to ecliptic
!  as intermediate form:
!
    if (trim(isysu) /= 'E') then
       if (trim(isysu) == 'Q' .or. trim(isysu) == 'C') then
          call xcc_dp_q_to_e(ivector,iepoch,xvector)
       elseif (trim(isysu) == 'G') then
          call xcc_dp_g_to_e(ivector,iepoch,xvector)
!            elseif (isys == 'SG') then
!              to be implemented
!            elseif (isys == 'U') then
!               to be implemented
       else
          print*,' unknown input coordinate system: '//trim(isysu)
       endif
    else
       xvector(1:3)=ivector(1:3)
    endif
!
!  If the begin and end epoch are different, precess:
!
    if (iepoch /= oepoch) then
       call xcc_dp_precess(xvector,iepoch,oepoch,yvector)
    else
       yvector(1:3)=xvector(1:3)
    endif
!
!  If output system is not ecliptic, convert from ecliptic to desired
!  system:
!
    if (trim(osysu) /= 'E') then 
       if (trim(osysu) == 'Q' .or. trim(osysu) == 'C') then
          call xcc_dp_e_to_q(yvector,oepoch,ovector)
       elseif (trim(osysu) == 'G') then
          call xcc_dp_e_to_g(yvector,oepoch,ovector)
       else
          print*,' unknown output coordinate system: '//trim(osysu)          
       endif
    else
       ovector(1:3)=yvector(1:3)
    endif
    return
  end subroutine xcc_v_convert
!===============================================================

  Subroutine xcc_DP_E_TO_Q(ivector,epoch,ovector)
!
!    Routine to convert from ecliptic coordinates to equatorial (celestial)
!  coordinates at the given epoch.  Adapted from the COBLIB routine by Dr.
!  E. Wright.
!
!  02/01/88, a.c.raugh, STX.
!  11/16/01, C.Burigana,D.Maino, OAT
!
!
!  Arguments:
!
    real(dp) ::     IVECTOR(3)     ! Input coordinate vector
    real(dp) ::     EPOCH          ! Equatorial coordinate epoch
    real(dp) ::     OVECTOR(3)     ! Output coordinate vector
!
!  Program variables:
!
    real(dp) ::     T              ! Julian centuries since 1900.0
    real(dp) ::     EPSILON        ! Obliquity of the ecliptic
    real(dp) ::     HVECTOR(3)     ! Temporary holding place for output vector
    real(dp) :: dc, ds
!
!  Set-up:
!
    T = (epoch - 1900.d0) / 100.d0 
    epsilon = 23.452294d0 - 0.0130125d0*T - 1.63889d-6*T**2 &
         &  + 5.02778d-7*T**3
!
!  Conversion:
!
    dc = cos(DTOR * epsilon)
    ds = sin(DTOR * epsilon)
    hvector(1) = ivector(1)
    hvector(2) = dc*ivector(2) - ds*ivector(3)
    hvector(3) = dc*ivector(3) + ds*ivector(2)
!
!  Move to output vector:
!
    ovector(1:3) = hvector(1:3)
!
    return
  end Subroutine xcc_DP_E_TO_Q
!===============================================================

  Subroutine xcc_DP_E_TO_G(ivector,epoch,ovector)
!
!    Routine to convert ecliptic (celestial) coordinates at the given
!  epoch to galactic coordinates.  The ecliptic coordinates are first
!  precessed to 2000.0, then converted. 
!
!                          --------------
!
!  Galactic Coordinate System Definition (from Zombeck, "Handbook of
!  Space Astronomy and Astrophysics", page 71):
!
!         North Pole:  12:49       hours right ascension (1950.0)
!                     +27.4        degrees declination   (1950.0)
!
!    Reference Point:  17:42.6     hours right ascension (1950.0)
!                     -28 55'      degrees declination   (1950.0)
!
!                          --------------
!
!  03/08/88, a.c.raugh, STX.
!  11/16/01, C.Burigana, D.Maino, OAT
!
!
!  Arguments:
!
    real(dp) ::    IVECTOR(3)      ! Input coordinate vector
    real(dp) ::    EPOCH           ! Input coordinate epoch
    real(dp) ::    OVECTOR(3)      ! Output coordinate vector
!
!  Program variables:
!
    real(dp) ::    HVECTOR(3)      ! Temporary holding place for coordinates
    real(dp) ::    T(3,3)          ! Galactic coordinate transformation matrix
    integer(i4b) ::  I             ! Loop variables
! 
    Data T / -0.054882486d0, -0.993821033d0, -0.096476249d0, & ! 1st column
         &    0.494116468d0, -0.110993846d0,  0.862281440d0, & ! 2nd column
         &   -0.867661702d0, -0.000346354d0,  0.497154957d0/ ! 3rd column
!
!     Precess coordinates to 2000.0 if necesssary:
!
    if (epoch /= 2000.d0) then
       call xcc_dp_precess(ivector,epoch,2000.d0,hvector)
    else
       hvector(1:3)=ivector(1:3)
    endif
!
!     Multiply vector by transpose of transformation matrix:
!
    DO I = 1,3
       ovector(i) = sum(hvector(1:3)*T(1:3,i))
    ENDDO
!
    RETURN
  END Subroutine xcc_DP_E_TO_G
!===============================================================

  Subroutine xcc_DP_G_TO_E(ivector,epoch,ovector)
!
!    Routine to convert galactic coordinates to ecliptic (celestial) 
!  coordinates at the given epoch.  First the conversion to ecliptic 
!  2000 is done, then if necessary the results are precessed.
!
!  03/08/88, a.c.raugh, STX.
!  11/16/01, C.Burigana, D.Maino, OAT
!
!
!  Arguments:
!
    real(dp) ::    IVECTOR(3)      ! Input coordinate vector
    real(dp) ::    EPOCH           ! Input coordinate epoch
    real(dp) ::    OVECTOR(3)      ! Output coordinate vector
!
!  Program variables:
!
    real(dp) ::    HVECTOR(3)      ! Temporary holding place for coordinates
    real(dp) ::    T(3,3)          ! Galactic coordinate transformation matrix
    integer(i4b) ::  I,J             ! Loop variables
!
    Data T / -0.054882486d0, -0.993821033d0, -0.096476249d0, &! 1st column
         &    0.494116468d0, -0.110993846d0,  0.862281440d0, &! 2nd column
         &   -0.867661702d0, -0.000346354d0,  0.497154957d0/ ! 3rd column
!
!     Multiply by transformation matrix:
!
    DO I = 1,3
       hvector(i) = sum(ivector(1:3)*T(i,1:3))
    ENDDO
!
!     Precess coordinates to epoch if necesssary:
!
    if (epoch /= 2000.d0) then
       call xcc_dp_precess(hvector,2000.d0,epoch,ovector)
    else
       ovector(1:3)=hvector(1:3)
    endif
!
    return
  end Subroutine xcc_DP_G_TO_E
!===============================================================

  Subroutine xcc_DP_Q_TO_E(ivector,epoch,ovector)
!
!    Routine to convert equatorial (celestial) coordinates at the given
!  epoch to ecliptic coordinates.  Adapted from the COBLIB routine by Dr.
!  E. Wright.
!
!  02/01/88, a.c.raugh, STX.
!  11/16/01, C.Burigana, D.Maino, OAT
!
!
!  Arguments:
!
    real(dp) ::    IVECTOR(3)     ! Input coordinate vector
    real(dp) ::    EPOCH          ! Epoch of equatorial coordinates
    real(dp) ::    OVECTOR(3)     ! Output coordinate vector
!
!  Program variables:
!
    real(dp) ::    T              ! Centuries since 1900.0
    real(dp) ::    EPSILON        ! Obliquity of the ecliptic, in degrees
    real(dp) ::    HVECTOR(3)     ! Temporary holding place for output vector
    real(dp) ::  dc, ds
!
!  Set-up:
!
    T = (epoch - 1900.d0) / 100.d0
    epsilon = 23.452294d0 - 0.0130125d0*T - 1.63889d-6*T**2 &
         &  + 5.02778d-7*T**3
!
!  Conversion:
!
    dc = cos(DTOR * epsilon)
    ds = sin(DTOR * epsilon)
    hvector(1) = ivector(1)
    hvector(2) = dc*ivector(2) + ds*ivector(3)
    hvector(3) = dc*ivector(3) - ds*ivector(2)
!
!  Move to output vector:
!
    ovector(1:3) = hvector(1:3)
!
    return
  end Subroutine xcc_DP_Q_TO_E
!===============================================================

  Subroutine XCC_DP_PRECESS(ivector,iepoch,oepoch,ovector)
!
!    Subroutine to precess the input ecliptic rectangluar coordinates from
!  the initial epoch to the final epoch.  First the precession around the
!  Z-axis is done by a simple rotation.  A second rotation about the 
!  X-axis is then performed to account for the changing obliquity of the
!  ecliptic.
!
!  02/25/88, a.c.raugh, STX.
!  03/22/88, acr: modified to include changing epsilon
!  11/16/01, Carlo Burigana & Davide Maino, OAT
!
!
!  Parameters:
!
    real(dp) ::   IVECTOR(3)  ! Input coordinates
    real(dp) ::   IEPOCH      ! Initial epoch, years (input)
    real(dp) ::   OEPOCH      ! Final epoch, years (input)
    real(dp) ::   OVECTOR(3)  ! Output coordinates
!
!  Routine variables:
!
    real(dp) ::   TEMP        ! Holding place for rotation results
    real(dp) ::   GP_LONG     ! General precession in longitude
    real(dp) ::   dE          ! Change in the obliquity of the ecliptic
    real(dp) ::   OBL_LONG    ! -Longitude about which the obliquity is changing
    real(dp) ::   dL          ! Longitude difference
    real(dp) ::   TM          ! Mid-epoch, in tropical centuries since 1900
    real(dp) ::   TVECTOR(3)  ! Temporary holding vector
    real(dp) :: dco, dso, dce, dse, dcl, dsl
!
    Tm = ((oepoch+iepoch)/2.d0 - 1900.d0) / 100.d0
    gp_long  = (oepoch-iepoch) * (50.2564d0+0.0222d0*Tm) / 3600.d0
    dE       = (oepoch-iepoch) * (0.4711d0-0.0007d0*Tm) / 3600.d0
    obl_long = 180.d0 - (173.d0 + (57.06d0+54.77d0*Tm) / 60.d0) &
         &   + gp_long / 2.d0
    dL       = gp_long - obl_long
!
!     Z-axis rotation by OBL_LONG:
!
    dco = cos(DTOR * obl_long)
    dso = sin(DTOR * obl_long)
    tvector(1) = ivector(1)*dco - ivector(2)*dso
    tvector(2) = ivector(1)*dso + ivector(2)*dco
    tvector(3) = ivector(3)
!
!     X-axis rotation by dE:
!
    dce = cos(DTOR * dE)
    dse = sin(DTOR * dE)
    temp       = tvector(2)*dce - tvector(3)*dse
    tvector(3) = tvector(2)*dse + tvector(3)*dce
    tvector(2) = temp
!
!     Z-axis rotation by GP_LONG - OBL_LONG:
!
    dcl = cos(DTOR * dL)
    dsl = sin(DTOR * dL)
    temp       = tvector(1)*dcl - tvector(2)*dsl
    tvector(2) = tvector(1)*dsl + tvector(2)*dcl
    tvector(1) = temp
!
!     Transfer results to output vector:
!
    ovector(1:3) = tvector(1:3)

    return
  end Subroutine XCC_DP_PRECESS
!

end module coord_v_convert

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!******************************************************
! Sarah Smith (sjm84@mrao.cam.ac.uk)
! and Graca Rocha (graca@mrao.cam.ac.uk)
! June 2004
! Module sub_ngpdf_sho based on code by Michael
! Hobson and Graca Rocha
! Module sub_ngpdf_powergauss based on code by
! Anthony Challinor
! Please include an appropriate acknowledgement 
! in any publications based on work that has
! made use of this package - 'NGsims'
!******************************************************
Program sky_ng_sim_bin
  ! Makes a full-sky non-Gaussian simulation using
  ! values drawn from pdf made from eigenstates of
  ! a simple harmonic oscillator or powers of Gaussian
  ! Uses disjoint bins 
  ! Uses Healpix pixelisation and subroutines

  USE healpix_types
  USE alm_tools, ONLY : map2alm_iterative, alm2map, pow2alm_units
  USE fitstools, ONLY : read_asctab, write_bintab
  USE pix_tools, ONLY : nside2npix
  USE head_fits, ONLY : add_card, merge_headers, get_card, write_minimal_header, del_card
!  USE utilities, ONLY : die_alloc
  use misc_utils, only : wall_clock_time, assert_alloc
  USE extension, ONLY : getArgument, nArguments
  USE paramfile_io, ONLY : paramfile_handle, parse_int, parse_init, parse_string, &
       & parse_lgt, parse_double, concatnl, scan_directories, parse_summarize, &
       & get_healpix_data_dir, get_healpix_test_dir,get_healpix_pixel_window_file 
  Use sky_sub
  USE sub_ngpdf_sho
  USE sub_ngpdf_powergauss

  Implicit none

  INTEGER(I4B) :: nsmax ! The value of N_{side} in the pixelisation scheme
  INTEGER(I4B) :: nlmax, lmax ! The maximum l-value used
  INTEGER(I4B) :: nlmin, lmin ! The minimum l-value used (for the case of more then 1 bin only)
  INTEGER(I4B) :: nlmax_global ! The upper l-value of highest bin
  INTEGER(I4B) :: nmmax ! The maximum m-value used (set equal to nlmax)
  INTEGER(I4B) :: nmmax_global ! The maximum m-vlaue of highest bin (ser equal to nlmax_global)
  INTEGER(I4B) :: nbinmax

  COMPLEX(SPC), DIMENSION(:,:,:), ALLOCATABLE :: alm_T !The a_{lm} values
  COMPLEX(SPC), DIMENSION(:,:,:), ALLOCATABLE :: sum_alm_T ! The total a_{lm} values from all bins
  REAL(SP),     DIMENSION(:, :),     ALLOCATABLE :: map_T !The pixel values in real space
  REAL(SP), DIMENSION(:,:), ALLOCATABLE :: cl_T !The Cl values
  REAL(KIND=DP),     DIMENSION(:,:),   ALLOCATABLE :: w8ring_T
  REAL(SP),     DIMENSION(:,:),     ALLOCATABLE :: tmp_2d

!   INTEGER(I4B), DIMENSION(8,2) :: values_time
!   REAL(SP) :: clock_time
  real(SP) :: time0, time1, clock_time, ptime0, ptime1, ptime
  INTEGER(I4B) :: status

  INTEGER(I4B) :: nbins !The total number of bins
  INTEGER(I4B) :: ibin,lval
  INTEGER(I4B) npixtot !The total number of pixels
  CHARACTER(LEN=filenamelen)          :: parafile = ''
  CHARACTER(LEN=filenamelen)          :: infile
  CHARACTER(LEN=filenamelen)          :: outfile
  CHARACTER(LEN=filenamelen)          :: windowfile
  CHARACTER(LEN=filenamelen)          :: windowname
  CHARACTER(LEN=filenamelen)          :: def_dir, def_file
  CHARACTER(LEN=filenamelen)          :: usr_dir, usr_file
  CHARACTER(LEN=filenamelen)          :: final_file
  CHARACTER(LEN=filenamelen)          :: healpixtestdir
  Character(LEN=filenamelen)          :: beam_file
  character(len=filenamelen)          :: description
  character(len=100)                  :: chline,chline1,chline2
  LOGICAL(LGT) :: ok, fitscl, polarisation = .FALSE.
  CHARACTER(LEN=80), DIMENSION(1:180) :: header, header_PS
  CHARACTER(LEN=*), PARAMETER :: code = "sky_ng_sim_bin"
  character(len=*), parameter :: VERSION = HEALPIX_VERSION

  character(len=80), dimension(1:1) :: units_power, units_map
  CHARACTER(LEN=20)                            ::  string_quad
  REAL(SP) ::  quadrupole
  INTEGER(I4B) nlheader
  Integer :: i,m
  Real(DP) :: sigma0, factor
  Real(DP),dimension(1:3) :: nu !Added to match with f90 version of shodev_driver
  !nu(i) is the ith moment of the distribution. 
  !The size of nu is fixed to 3 to prevent problems with passing unallocated arrays
  Real(DP) :: power, rms_alm, mean
  Integer :: count, iter_order
  Integer(I4B) :: pdf_choice !Used to chose type of pdf required
  Real(SP) :: Tmin, Tmax, convert
  Integer, parameter :: npts = 1000
  Real(SP) :: xline(npts), yline(npts), xstep, xval
  logical :: plot
  Character(len=20) :: variable
  type(paramfile_handle) :: handle
  Real(DP) :: fwhm_arcmin
  Real(SP) :: fwhm_deg
  Character(len=30) :: xlabel
  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:
  if (nArguments() == 0) then
     parafile=''
  else
     if (nArguments() /= 1) then
        print "(' Usage: "//code//" [parameter file name]')"
        stop 1
     end if
     call getArgument(1,parafile)
  end if
  handle = parse_init(parafile)

  Write(*, '(a)')  "*** Simulation of a non-Gaussian full-sky temperature map ***"

  write(*, '(a)')  "*** for binned PS and Bispectrum ***"

  !     --- gets the effective resolution of the sky map ---
3 continue
  description = concatnl( &
       & "", &
       & " Enter the resolution parameter (Nside) for the simulated skymap: ",&
       & " (Npix = 12*Nside**2, where Nside HAS to be a power of 2, eg: 32, 512, ...)" )
  nsmax = parse_int(handle, 'nsmax', default=32, descr=description)
  if (nside2npix(nsmax) < 0) then
     print *, " Error: nsmax is not a power of two."
     if (handle%interactive) goto 3
     stop 1
  endif

  !     --- gets the number of bins for PS and BIspec---

  description = concatnl( &
       & "", &
       & 'Enter number of bins')
  nbins = parse_int(handle, 'nbins', default = 1, vmin = 1, descr=description)
!  read(*,*) nbins

  !  write(*,*) 'enter l_max for highest bin'
  !  read(*,*) nlmax_global

  WRITE(chline,"(a,i5,a)") "We recommend: (l_max <= ",3*nsmax-1,")"
  description = concatnl(&
       & "", &
       & " Enter the maximum l range (l_max) for the simulation. ", &
       & chline )
  nlmax_global = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)

  !     --- gets the output sky map filename ---
  description = concatnl(&
       & "", &
       & " Enter Output map file name (eg, test.fits) :", &
       & "  (or !test.fits to overwrite an existing file)" )
  outfile = parse_string(handle, "outfile", &
       default="!test.fits", descr=description, filestatus="new")

  !     --- gets the fwhm of beam ---
  description = concatnl(&
       & "", &
       & " Enter FWMH of beam in arcminutes (0 for no beam):")
  fwhm_arcmin = parse_double(handle, "fwhm_arcmin", &
       default=0d0, descr=description, vmin = 0d0)

  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " a symmetric beam Legendre transform (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used.")
  beam_file = parse_string(handle, 'beam_file', default="''", &
       &                 descr=description, filestatus='old')
  if (beam_file /= '') then
     fwhm_arcmin = 0.
     print*,'fwhm_arcmin is now : 0.'
     print*,'The beam file '//trim(beam_file)//' will be used instead.'
  endif

  ! including pixel window function, EH-2008-03-05
 !     --- check for pixel-window-files ---
  windowname = get_healpix_pixel_window_file(nsmax)

  def_file = trim(windowname)
  def_dir  = get_healpix_data_dir()

22 continue
  final_file = ''
  ok = .false.
  ! if interactive, try default name in default directories first
  if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
  if (.not. ok) then 
     ! not found, ask the user
     description = concatnl("",&
          &        " Could not find window file", &
          &        " Enter the directory where this file can be found:")
     usr_dir = parse_string(handle,'winfiledir',default='',descr=description)
     if (trim(usr_dir) == '') usr_dir = trim(def_dir)
     description = concatnl("",&
          &        " Enter the name of the window file:")
     usr_file = parse_string(handle,'windowfile',default=def_file,descr=description)
     ! look for new name in user provided or default directories
     ok   = scan_directories(usr_dir, usr_file, final_file)
     ! if still fails, crash or ask again if interactive
     if (.not. ok) then
        print*,' File not found'
        if (handle%interactive) goto 22
        stop 1
     endif
  endif
  windowfile = final_file

  PRINT *," "

  !-----------------------------------------------------------------------

  nmmax_global=nlmax_global
  npixtot = nside2npix(nsmax)

  !---allocate space for arrays---

  ALLOCATE(map_T(0:npixtot-1, 1:1),stat = status)
  call assert_alloc(status, code,"map_T")

  ALLOCATE(sum_alm_T(1:1,0:nlmax_global, 0:nmmax_global),stat = status)
  call assert_alloc(status, code,"sum_alm_T")

  ALLOCATE(w8ring_T(1:2*nsmax,1:1),stat = status)
  call assert_alloc(status, code,"w8ring_T")

  ! For now, not using ring weights for quadrature correction
  w8ring_T = 1.d0


  !---end allocate space for array---


  !---start bins loop---


  nlmax=0
  do ibin=1,nbins
    nbinmax=nlmax
     ! get lrange for each bin

     !     --- gets the L range for the simulation for bin=ibin ---

     WRITE(chline,"(a,i5)") "Enter maximum value of l for bin", ibin
     description = concatnl(&
          & "", &
          & chline )
     variable = 'nlmax'
     call add_subscript(variable, ibin)
     nlmax = parse_int(handle, variable, default=2*nsmax, vmax=nlmax_global, descr=description)

     if (ibin == 1) then
        WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l_min for lowest bin=1)"
     else
        WRITE(chline,"(a,i5,a,i5,a)") "We recommend: (",nbinmax," + 1 <= l_min for bin=",ibin,")"
     endif
     WRITE(chline1,"(a)") "(Note: non overlapping bins are assumed!!)"
     description = concatnl(&
          & "", &
          & " Enter the minimum  l (l_min) for this bin. ", &
          & chline, chline1)
     variable = 'nlmin'
     call add_subscript(variable, ibin)
     if(ibin.eq.1) then 
        nlmin = parse_int(handle, variable, default=0, vmin=0,vmax=nlmax_global, descr=description)
     else
        nlmin = parse_int(handle, variable, default=nbinmax+1,vmin=nbinmax+1,vmax=nlmax_global, descr=description)
        if(nlmin < nbinmax+1) then
           write(*,*) 'stop --- the bins are not disjoint'
           stop
        endif
     endif
     !  end do

     !nlmax_global=max(0,nlmax)

     ! get PS for each bin

     !     --- get filename for input power spectrum ---
     chline = ''
     healpixtestdir = get_healpix_test_dir()
     if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/cl.fits'
     description = concatnl( "", &
          & " Enter input Power Spectrum filename", &
          & " Can be either in FITS format or in the format produced by CAMB.")
     infile = parse_string(handle, 'infile', default=chline, descr=description, filestatus='old')
     ! Find out whether input cl file is a fits file
     fitscl = (index(infile, '.fits') /= 0) 


     !-----------------------------------------------------------------------

     nmmax   = nlmax

     !-----------------------------------------------------------------------
     !                  allocates space for arrays
     !-----------------------------------------------------------------------

     ALLOCATE(alm_T(1:1,0:nlmax, 0:nmmax),stat = status)
     call assert_alloc(status, code,"alm_T")


     ! single analysis
     iter_order = 0 

     ALLOCATE(cl_T(0:nlmax,1:1),stat = status)
     call assert_alloc(status, code,"cl_T")

     !------------------------------------------------------------------------
     ! Read in the input power spectrum
     !------------------------------------------------------------------------


     cl_T = 0.0
     !New lines added 8th June 2004
     lmax = nlmax
     ! each line should be less than 132 characters in length (2009-08-03)
     call read_powerspec(infile, nsmax, lmax, cl_T, header_PS, fwhm_arcmin, units_power, &
          & beam_file = beam_file, winfile = windowfile) 
     call pow2alm_units(units_power, units_map)
     call del_card(header_PS, (/ "TUNIT#","TTYPE#"/)) ! remove TUNIT* and TTYPE* from header to avoid confusion later on

     quadrupole = cl_T(2,1)
     do lval=0,nlmax
        if (lval.lt.nlmin) then
           !   Write (*,*) 'Setting cl(',lval,')to zero'
           cl_T(lval,1)=0.0
        endif
     end do
     write(*,*)  "Power spectrum out of the range (",nlmin,nlmax,") is set to zero"

     !------------------------------------------------------------------------
     ! Draw pixel values in real space from non-Gaussian distribution
     !------------------------------------------------------------------------

     Write (*,*) "Creating non-Gaussian map with flat power spectrum"

     !     --- Chose the type of pdf to use ---
     description = concatnl(&
          & "", &
          & " Select non-Gaussian pdf to use: Simple harmonic osciallator (1)", &
          & "or powers of a Gaussian (2)" )
     pdf_choice = parse_int(handle, 'pdf_choice', default=1, vmin = 1, vmax = 2, descr=description)  

     If (pdf_choice .eq. 1) Then
        call shodev_driver(handle, npixtot, sigma0, map_T(:,1), nu, bins = ibin)
     Else
        call powergauss_driver(handle, npixtot, sigma0, map_T(:,1), nu, bins = ibin)
     End If

     !Normalise the map
     Write (*,*) "nu is", nu
     If (nu(1) .ge. 0) Then !nu (1) is set to -1 if highest non-zero alpha > 3
     map_T = map_T / sqrt(nu(2))

     !Compute the rms value of the pixels
     power = 0
     Do i = 0, npixtot-1
        power = power + map_T(i,1)**2
     End Do
     power = Sqrt(power/npixtot)
     Write (*,*) "rms value of the pixels is ", power
     Else
        Write (*,*) "Can't calculate theoretical value of nu(2) to normalise"
        Write (*,*) "Normalising using rms pixel value instead"
        Write (*,*) "note - this method may change the statistical properties of the map"
        !Compute the mean value of the pixels
        mean = SUM(map_T)/npixtot
        Write (*,*) 'Mean pixel value is ',mean,' - adjusting to zero'
        map_T = map_T - mean     !Compute the rms value of the pixels
        power = 0
        Do i = 0, npixtot-1
           power = power + map_T(i,1)**2
        End Do
        power = Sqrt(power/npixtot)
        Write (*,*) "rms value of the pixels is ", power ," - setting to 1.0"
        map_T = map_T / power    
        !Check
        power = 0
        Do i = 0, npixtot-1
           power = power + map_T(i,1)**2
        End Do
        power = Sqrt(power/npixtot)
        Write (*,*) "Now rms value of the pixels is ", power
     End If
     !------------------------------------------------------------------------
     ! Now compute the a_{lm} values from this distribution
     !------------------------------------------------------------------------


     Write (*,*) "Computing the values of the a_{lm}"
!     call map2alm(nsmax, nlmax, nmmax, map_T, alm_T, -1000.d0, w8ring_T)
!     call map2alm(nsmax, nlmax, nmmax, map_T, alm_T, (/ 0.d0, 0.d0/), w8ring_T)
     call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_T, alm_T, w8ring=w8ring_T)

     !Compute the rms value of the a_{lm}
     power = 0.0
     count = 0
     Do i = 1, nlmax
        power = power + abs(alm_T(1,i,0))**2.
        count = count + 1
        Do m = 1, i
           power = power + 2.0*abs(alm_T(1,i,m))**2.
           count = count + 2
        End Do
     End Do
     rms_alm = sqrt(power/count)
     Write (*,*) "rms value of the a_{lm} is ",rms_alm
     factor = sqrt(FOURPI/npixtot)
     Write (*,*) "Expected rms value is ", factor

     !------------------------------------------------------------------------
     ! Multiply the a_{lm} by the correct power spectrum
     !------------------------------------------------------------------------

     Do i = 1, nlmax
        !Write (*,*) 'cl(',i,') is ', cl_T(i,1)
        alm_T(1,i,0:i) = alm_T(1,i,0:i)*sqrt(cl_T(i,1))/factor
     End Do


     !  store alm in a global array sum_alm_T(ibin,l,m)
     ! by summing up alm from sequential bins ! what about bins that overlap?

     Do i = nlmin, nlmax
        sum_alm_T(1,i,0:i) = sum_alm_T(1,i,0:i) + alm_T(1,i,0:i)
     End Do


     if (allocated(alm_T)) DEALLOCATE( alm_T )
     !  DEALLOCATE( units_alm, units_map )
     if (allocated(cl_t)) DEALLOCATE( cl_T)

  end do ! bins loop


  !------------------------------------------------------------------------
  ! Now transform back to a real space map
  !------------------------------------------------------------------------

  !  call alm2map(nsmax,nlmax,nmmax,alm_T,map_T)
  call alm2map(nsmax,nlmax,nmmax,sum_alm_T,map_T(:,1))

  !------------------------------------------------------------------------
  ! Plot histogram of pixel distribution (if required)
  !------------------------------------------------------------------------

#ifdef PGPLOT
  ! Plot histogram of pixel distribution (if required)
  description = concatnl( "", &
       & " Plot histogram of pixel values? (True or False)")
  plot = parse_lgt(handle, 'plot', default=.false., descr=description) 
! Write (*,*) 'Plot histrogram of pixel values (0) or not (1)?'
!  Read (*,*) m
!  If (m .EQ. 0) Then
  If (plot) Then
     Tmin = 0.0
     Tmax = 0.0
     do i=1,npixtot
        if (map_T(i,1) .lt. Tmin) Tmin=map_T(i,1)
        if (map_T(i,1) .gt. Tmax) Tmax=map_T(i,1)
     end do
     call pgbegin(0,'?',1,1)
     if (.not. fitscl) then
        ! If reading in from .dat file Cls are already converted to uK
        convert = 1.0
        xlabel = 'Temperature / \gmK'
     else if (ABS(quadrupole - 1.0) .lt. 0.05) then
        ! If values in fits file are normalised to Cl(2) = 1.0
        ! convert to uK for plot, assuming COBE normalisation
        ! of Qrms = 18uK
        convert = sqrt(4.0*PI/5.0)*18.0
        xlabel = 'Temperature / \gmK'
     else
        ! Otherwise, units unknown
        convert = 1.0
        xlabel = 'Pixel value'
     end if
     Tmin = Tmin * convert
     Tmax = Tmax * convert
     call pghist(npixtot,map_T*convert,Tmin,Tmax,200,0)
     !Pixel values scaled to convert to uK if input fits file of cl values
     !which are normalised to C_2 = 1.0
     call pglab(TRIM(xlabel),'Number of pixels','')
     !Calculate 2*mean square value of T (ie 2 sigma^2)
     power = 0
     Do i = 1, npixtot
        power = power + map_T(i,1)**2
     End Do
     power = 2 * power*(convert**2) / npixtot
        xstep=(Tmax-Tmin)/real(npts-1)
     do i=1,npts
        xval=Tmin+real(i)*xstep
        xline(i)=xval
        yline(i)=exp(-xval**2/power)/sqrt(PI*power)
        yline(i)=yline(i)*real(npixtot)*(Tmax-Tmin)/200.
      end do
     call pgline(npts, xline, yline)
     call pgend
  End If   
#endif

  call parse_summarize(handle,code=code)

  !-----------------------------------------------------------------------
  !                      write the map to FITS file
  !-----------------------------------------------------------------------

  nlheader = SIZE(header)
  do i=1,nlheader
     header(i) = ""
  enddo
  !  fwhm_deg = fwhm_arcmin/60.
  PRINT *,"      "//code//"> Writing sky map to FITS file "
  ! put inherited information immediatly, so that keyword values can be updated later on
  ! by current code values
  call add_card(header,"COMMENT","****************************************************************")
  call merge_headers(header_PS, header) ! insert header_PS in header at this point
  call add_card(header,"COMMENT","****************************************************************")
  ! start putting information relative to this code and run
  call write_minimal_header(header, 'map', append=.true., &
       nside = nsmax, ordering = 'RING', &   !, coordsys = coordsys, &
       fwhm_degree = fwhm_arcmin / 60.d0, &
       beam_leg = trim(beam_file), &
       polar = polarisation, &
       !deriv = deriv, &
       creator = CODE, version = VERSION, &
       nlmax = nlmax, &
       !randseed = ioriginseed, &
       units = units_map(1) )

  call add_card(header,"PDF_TYPE",pdf_choice,"1: Harmon. Oscill. ;2: Power of Gauss.")
  call add_card(header,"EXTNAME","'SIMULATED MAP'", update=.true.)
  call add_card(header,"COMMENT","*************************************")

!   allocate(tmp_2d(0:npixtot-1,1:1))
!   tmp_2d(:,1) = map_T
!   call write_bintab(tmp_2d, npixtot, 1, header, nlheader, outfile)
!   deallocate(tmp_2d)
  call write_bintab(map_T, npixtot, 1, header, nlheader, outfile)
!!$  endif

  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------

  DEALLOCATE( map_T )
  DEALLOCATE( sum_alm_T )
  !  DEALLOCATE( units_alm, units_map )

  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0


  WRITE(*,9000) " "
  WRITE(*,9000) " Report Card for "//code//" simulation run"
  WRITE(*,9000) "----------------------------------------"
  WRITE(*,9000) " "
  WRITE(*,9000) " Input power spectrum : "//TRIM(infile)
  WRITE(*,9010) " Multipole range      : 0 < l <= ", nlmax
  WRITE(*,9010) " Number of pixels     : ", npixtot
  !  WRITE(*,9020) " Pixel size in arcmin : ", pix_size_arcmin
  !  WRITE(*,9010) " Initial random # seed: ", ioriginseed
  !  WRITE(*,9020) " Gauss. FWHM in arcmin: ", fwhm_arcmin
  if (trim(beam_file) == '') then
     write(*,9020) " Gauss. FWHM in arcmin: ", fwhm_arcmin
  else
     write(*,9000) " Beam file: "//trim(beam_file)
  endif
  WRITE(*,9000) " Output map           : "//TRIM(outfile)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  WRITE(*,9000) " "
  WRITE(*,9000) " "//code//"> normal completion"

9000 format(a)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)


  Stop

!Contains

!!$  Subroutine read_camb(infile, cl_array, lmin, lmax)
!!$    Character (len = *), intent(IN) :: infile
!!$    Integer(I4B), intent(INOUT) :: lmax,lmin
!!$    Real(SP), Intent(OUT), Dimension(0:lmax,1:1) :: cl_array
!!$
!!$    Real(SP) :: clval
!!$    Integer :: lval = 0
!!$
!!$    !Crude first version to read in the cl values
!!$    Open (Unit = 23, file = infile, status = 'old', action = 'read', err = 9980)
!!$    Do while (lval .LT. lmax)
!!$       Read (23, *, end = 800) lval, clval
!!$       cl_array(lval, 1) = TWOPI*clval/(lval*(lval+1))
!!$    End Do
!!$800 lmax = lval

!!$    lval = 0
!!$    Do while (lval.lt.lmin)
!!$       if(lval.ne.2) then
!!$          cl_array(lval,1)=0.0
!!$          lval = lval + 1
!!$       endif
!!$    End Do

!!$    Close (23)
!!$    Return
!!$
!!$9980 Stop 'Error opening cl file to read'
!!$
!!$  End Subroutine read_camb
!!$


End Program sky_ng_sim_bin

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!======================================================================
program HotSpots
  !======================================================================
  !     Finds extrema in the 2-D field on the sphere.
  !     Uses file "param.dat" for inputs
  !
  ! Benjamin D. Wandelt October 1997
  ! 2010-11-23, E. Hivon: accept maps with Nside > 8192
  !======================================================================
  use healpix_types
  use maxima_tools, ONLY : find_maxima
  use fitstools,  ONLY : getsize_fits, input_map, write_bintab
#ifdef G95
  use pix_tools,  ONLY : convert_ring2nest, convert_nest2ring, npix2nside
#else
  use pix_tools,  ONLY : convert_inplace, ring2nest, nest2ring, npix2nside
#endif
  USE head_fits,  ONLY : add_card, write_minimal_header
  use misc_utils, ONLY : assert_alloc, fatal_error
  USE extension,  ONLY : getArgument, nArguments
  use paramfile_io, ONLY : paramfile_handle, parse_init, parse_string
  use long_intrinsic, only: long_count

  implicit none
  integer(i4b) :: npix, nmin, nmax, i
  integer(i4b) :: nside
  integer(i4b) :: face_num

  real(sp), pointer ::  map(:)
  real(sp), allocatable :: inmap(:,:)
  real(sp), allocatable :: realpeak(:,:)
  integer(i4b),pointer :: peak(:)

  integer(i4b) :: ordering,order_type
  integer(i4b) :: nlheader
  integer(i4b) :: nmaps = 1

  character(len=80), dimension(1:120) :: header
  character(len=filenamelen) :: parafile,infile,outfile_extrema, &
                                outfile_max,outfile_min
  character(len=20) :: coordsys
  integer(i4b) :: status

  type(paramfile_handle) :: handle

  CHARACTER(LEN=*), PARAMETER :: code    = 'HOTSPOTS'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION

  !--------------------------------------------------------------------------
100 FORMAT(A)

  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------

  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:
  if (nArguments() == 0) then
     parafile=''
  else
     if (nArguments() /= 1) then
        print '(" Usage: hotspots [parameter file name]")'
        call fatal_error(code)
     end if
     call getArgument(1,parafile)
  end if

  handle=parse_init (parafile)

  !     --- announces program, default banner ***
  PRINT *,'                    '//code//' '//version
  PRINT *,' ***  Finding Maxima and Minima of a HEALPIX Map  ***'
  PRINT *,' *** (Application of the Neighbour-finding Tools) ***'
  PRINT *,''

  !     --- gets the file name for the map ---
  infile=parse_string(handle,'infile',default='map.fits', &
       descr='Input file name (Map FITS file, e.g. map_CDM.fits):', &
       filestatus='old')
  PRINT *,''

  !     --- finds out the pixel number of the map and its ordering ---
  npix = getsize_fits(infile ,ordering=ordering, nside=nside, coordsys = coordsys)

  if (nside.eq.0) then
     print*,'Keyword NSIDE not found in FITS header!'
     call fatal_error(code)
  endif
  if (nside.ne.npix2nside(npix)) then
     print*,'FITS header keyword NSIDE does not correspond'
     print*,'to the size of the map!'
     call fatal_error(code)
  endif

  if(nside<=1) then
     PRINT*,' '//code//'> Nside needs to be at least 2 for extrema calculations.'
     call fatal_error(code)
  end if

  !     --- check ordering scheme ---

  if ((ordering.ne.1).and.(ordering.ne.2)) then
     PRINT*,'The ordering scheme of the map must be RING or NESTED.'
     PRINT*,'No ordering specification is given in the FITS-header!'
     call fatal_error()
  endif

  order_type = ordering

!     --- gets the output extrema map filename ---
  outfile_extrema=parse_string(handle,'extrema_outfile', &
       default='pixlminmax.fits', &
       descr='Extrema map file name (eg, pixlminmax.fits) :', &
       filestatus='new')
  PRINT *,''

!     --- gets the output filename for ascii file with MAXIMA ---
  outfile_max=parse_string(handle,'maxima_outfile', &
       default='maxima.dat', &
       descr='Maxima file name (eg, maxima.dat) :')
!       filestatus='new')
  PRINT *,''

!     --- gets the output filename for ascii file with MINIMA ---
  outfile_min=parse_string(handle,'minima_outfile', &
       default='minima.dat', &
       descr='Maxima file name (eg, minima.dat) :')
!       filestatus='new')
  PRINT *,''

  allocate(map(0:npix-1),stat=status)
  call assert_alloc(status,code,'map')

  allocate(inmap(0:npix-1,1),stat=status)
  call assert_alloc(status,code,'inmap')

  PRINT*, ' '//code//'> Reading '//TRIM(infile)//'...'

  call input_map(infile,inmap,npix,nmaps)

  map(0:npix-1) = inmap(0:npix-1,1)
  deallocate(inmap)

  if(order_type==1) then
     write(*,*) code//'> Converting to NESTED numbering scheme.'
#ifdef G95
     call convert_ring2nest(nside, map)
#else
     call convert_inplace(ring2nest,map)
#endif
  endif

  allocate(peak(0:npix-1))
  call assert_alloc(status,code,'peak')
  peak=0

  write(*,*) code//'> Starting extrema search in pixel space.'

  ! This is fully parallelisable. All 12 faces can be searched synchronously
  !*$*assert concurrent call
  ! peak = +1 for maximum, -1 for minimum, 0 otherwise
  do face_num=0,11
     call find_maxima(map,face_num,peak)
  end do

  write(*,*) 'Done.'

  if(order_type==1) then
#ifdef G95
     write(*,*) code//'> Converting map back to RING numbering.'
     call convert_nest2ring(nside,map)
     write(*,*) code//'> Converting peaks to RING numbering.'
     call convert_nest2ring(nside,peak)
#else
     write(*,*) code//'> Converting map back to RING numbering.'
     call convert_inplace(nest2ring,map)
     write(*,*) code//'> Converting peaks to RING numbering.'
     call convert_inplace(nest2ring,peak)
#endif
  endif

  write (*,*) code//' Writing '//trim(outfile_extrema)//' FITS file...'
  call write_minimal_header(header, 'map', &
       nside = nside, order = ordering, coordsys = coordsys, &
       polar = .false., creator = code, version = version)

  call add_card(header,'EXTNAME','PEAK MAP', update = .true.)
  call add_card(header,'COMMENT', 'Input Map ='//TRIM(infile))
  call add_card(header,'COMMENT', 'Local Min and Max keep their original value, the rest is set to 0')
  call add_card(header,'TTYPE1', 'PEAKS','Maxima and Minima', update = .true.)

  ! ------
  ! outputs a FITS map set to 0 but for extrema that keep their original value
  allocate(realpeak(0:npix-1,1))
  realpeak=0
  where(peak/=0) realpeak(:,1)=map

  nlheader = SIZE(header)
  call write_bintab(realpeak, npix, 1_i4b, header, nlheader, outfile_extrema)

  deallocate(realpeak)

  ! outputs the set of maxima (pixel number and value)
  ! and the set of minima (pixel number and value) in 2 ascii files
  open(14,file=outfile_max,status="unknown")
  open(15,file=outfile_min,status="unknown")
  write(*,*) 'Output: Writing '//trim(outfile_max)//' and '//trim(outfile_min)//'.'

  nmax=long_count(peak>0)
  write(*,*) "Found ",nmax," Maxima"
  nmin=long_count(peak<0)
  write(*,*) "Found ",nmin," Minima"

  do i=0,npix-1
     if(peak(i)>0) then     !Maximum
        write(14,'(i10,f12.6)') i,map(i)
     elseif(peak(i)<0) then !Minimum
        write(15,'(i10,f12.6)') i,map(i)
     endif
  enddo

  close(14)
  close(15)

  deallocate(peak)
  deallocate(map)
  stop
end program HotSpots

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------

module obsolete

  ! ==============================================================
  ! contains routines that were initially in
  ! module fitstools (routines ask_*)
  !     and
  ! module utilities (*_parser, *_setpar, *_getpar ... and related)
  !
  ! and have become obsolete in version 1.2
  !
  ! They won't be supported any more
  ! See module paramfile_io for substitutes
  !===============================================================

  ! Authors: Banday and Bartelmann
  ! CHANGES:
  ! Changed 9/MAR/1999 by B.D.Wandelt
  !     Incorporated non-interactive functionality for anafast.
  !     Added: type anapar, subroutines anafast_parser, anafast_setpar and anafast_getpar.
  !     Incorporated non-interactive functionality for HotSpots.
  !     Added: type hotpar, subroutines hotspot_parser, hotspots_setpar and hotspots_getpar.
  !     Incorporated non-interactive functionality for ud_grade.
  !     Added: type udgpar, subroutines udgrade_parser, udgrade_setpar and udgrade_getpar.
  ! Changed 9/MAY/1999 by B.D.Wandelt
  ! Changed all routines to new, more user-friendly parser,
  ! provided by Bartelmann and Banday.
  ! Added parser for smoothing routine, E. Hivon, 2001-11
  !     Incorporated non-interactive functionality for smoothing.
  !     Added: type udgpar, subroutines smoothing_parser, smoothing_setpar and smoothing_getpar.
  !

  use healpix_types
  implicit none

  type synpar
     integer(i4b) :: simtp
     integer(i4b) :: nsmax
     integer(i4b) :: nlmax
     integer(i4b) :: iseed
     real(sp) :: fwhma
     character(len=filenamelen) :: inpfl
     character(len=filenamelen) :: outfl
     character(len=filenamelen) :: almsfile
     character(len=filenamelen) :: plmfile
     character(len=filenamelen) :: windowfile
     character(len=filenamelen) :: winfiledir
  end type synpar

  type(synpar) :: par

  type anapar
     integer(i4b) :: simtp
     integer(i4b) :: nlmax
     real(dp) :: theta_cut_deg
     integer(i4b) :: iter_order
     integer(i4b) :: regression
     character(len=filenamelen) :: w8file
     character(len=filenamelen) :: inpfl
     character(len=filenamelen) :: outfl
     character(len=filenamelen) :: plmfile
     character(len=filenamelen) :: outfl_alms
     character(len=filenamelen) :: w8filedir
     integer(i4b) :: won
  end type anapar

  type(anapar) :: anafast_par

  type hotpar
     character(len=filenamelen) :: inpfl
     character(len=filenamelen) :: outfl_extrema
     character(len=filenamelen) :: outfl_max
     character(len=filenamelen) :: outfl_min
  end type hotpar

  type(hotpar) :: hotspots_par

  type udgpar
     integer(i4b) :: nside_out
     character(len=filenamelen) :: inpfl
     character(len=filenamelen) :: outfl
  end type udgpar

  type(udgpar) :: udgrade_par

  type smopar
     integer(i4b) :: simtp
     integer(i4b) :: iter_order
     integer(i4b) :: nlmax
     real(sp)     :: fwhma
     integer(i4b) :: won
     character(len=filenamelen) :: plmfile
     character(len=filenamelen) :: w8file
     character(len=filenamelen) :: w8filedir
     character(len=filenamelen) :: inpfl
     character(len=filenamelen) :: outfl
  end type smopar

  type(smopar) :: smoothing_par

  private

  public :: ask_inputmap, ask_outputmap, ask_lrange

  public :: synpar, par
  public :: parser, setpar, getpar
  public :: anapar, anafast_par
  public :: anafast_parser, anafast_setpar, anafast_getpar
  public :: hotpar, hotspots_par
  public :: hotspots_parser, hotspots_setpar, hotspots_getpar
  public :: udgpar, udgrade_par
  public :: udgrade_parser, udgrade_setpar, udgrade_getpar
  public :: smopar, smoothing_par
  public :: smoothing_parser, smoothing_setpar, smoothing_getpar


contains
  !========================================================================
  ! subroutine ask_inputmap
  ! subroutine ask_outputmap
  ! subroutine ask_lrange
  !========================================================================
  subroutine ask_inputmap(code, inputfile)
    !========================================================================
    use healpix_types
    CHARACTER(LEN=*), intent(in) :: code
    CHARACTER(LEN=*), intent(out) :: inputfile
    LOGICAL(LGT) :: ok
    !========================================================================

3   PRINT *,' Enter input file name (map, eg: map.fits): '
    READ 9000, inputfile

    inquire(file=inputfile, exist=ok)
    if (.not.ok) then
       PRINT *,' '//code//'> '//TRIM(inputfile)//' not found'
       goto 3
    endif

9000 FORMAT(A)

    return
  end subroutine ask_inputmap
  !========================================================================
  subroutine ask_outputmap(code, outputfile)
    !========================================================================
    use healpix_types
    CHARACTER(LEN=*), intent(in) :: code
    CHARACTER(LEN=*), intent(out) :: outputfile
    LOGICAL(LGT) :: bad
    !========================================================================

2   PRINT *,' Enter Output map file name (eg, map_smoothed.fits) :'
    READ 9000, outputfile

    inquire(file=outputfile, exist=bad)
    if ( bad ) then
       PRINT *,' '//code//'> '//TRIM(outputfile)//' already exists'
       PRINT *,' '//code//'> choose a new output file name.'
       goto 2
    endif
    PRINT *,''

9000 FORMAT(A)

    return
  end subroutine ask_outputmap
  !========================================================================
  subroutine ask_lrange(code, nsmax, nlmax)
    !========================================================================
    use healpix_types
    CHARACTER(LEN=*), INTENT(IN) :: code
    INTEGER(I4B), INTENT(IN) :: nsmax
    INTEGER(I4B), INTENT(OUT) :: nlmax
    !========================================================================

    PRINT *,' Enter the maximum l range for the analysis: '
    WRITE(*,'(a,i5)') '  The map has Nside = ',nsmax
    WRITE(*,'(a,i5,a)') '  (0 <= l <= l_max <= ',2*nsmax,') l_max = '
    READ *, nlmax

    return
  end subroutine ask_lrange


!=======================================================================
!=======================================================================
!=======================================================================
!   subroutine setpar
!   subroutine getpar
!   subroutine anafast_parser
!   subroutine anafast_setpar
!   subroutine anafast_getpar
!   subroutine hotspots_parser
!   subroutine hotspots_setpar
!   subroutine hotspots_getpar
!   subroutine udgrade_parser
!   subroutine udgrade_setpar
!   subroutine udgrade_getpar
!   subroutine smoothing_parser
!   subroutine smoothing_setpar
!   subroutine smoothing_getpar
!=======================================================================
!=======================================================================
!=======================================================================


  subroutine parser(filename)
    implicit none
    character(len=*), intent(in) :: filename
    logical(lgt) :: exist
    character(len=filenamelen) :: line,name,value
    integer(i4b) :: i


    inquire(file=filename, exist=exist)
    if (.not. exist) then
       print 1, trim(filename)
1      format(/,&
            & " Error in parser:",/,&
            & " File ",a," does not exist.")
       stop 1
    end if

    ! --- set defaults:
    call setpar()

    open  (1,file=filename)
    do

       read (1,'(a)',end=11) line
       i=scan(line,'=')
       if (i==0 .or. line(1:1)=='#') cycle
       name=trim(adjustl(line(:i-1)))
       value=trim(adjustl(line(i+1:)))

       select case (trim(name))
       case ('simul_type')
          read (value,*) par%simtp
       case ('nsmax')
          read (value,*) par%nsmax
       case ('nlmax')
          read (value,*) par%nlmax
       case ('iseed')
          read (value,*) par%iseed
       case ('fwhm_arcmin')
          read (value,*) par%fwhma
       case ('infile')
          par%inpfl = trim(value)
       case ('outfile')
          par%outfl = trim(value)
       case ('almsfile')
          par%almsfile = trim(value)
       case ('plmfile')
          par%plmfile = trim(value)
       case ('windowfile')
          par%windowfile = trim(value)
       case ('winfiledir')
          par%winfiledir = trim(value)
       end select
    end do
11  close (1)

  end subroutine parser


  subroutine setpar()
    implicit none

    par%simtp =   1
    par%nsmax =  32
    par%nlmax =  64
    par%iseed =  -1
    par%fwhma = 420.0
    par%inpfl = "cl.fits"
    par%outfl = "map.fits"
    par%almsfile = ""
    par%plmfile = ""
    par%windowfile = ""
    par%winfiledir = ""

  end subroutine setpar

  subroutine getpar(all)
    implicit none
    logical(lgt), optional :: all

    print *,'Non-interactive operation. The input file and defaults imply:'
    if (present(all)) then
       print 1, par%simtp,  &
            &   par%nsmax,  &
            &   par%nlmax,  &
            &   par%iseed,  &
            &   par%fwhma, &
            &   trim(par%inpfl),  &
            &   trim(par%outfl),  &
            &   trim(par%almsfile), &
            &   trim(par%plmfile),  &
            &   trim(par%windowfile),  &
            &   trim(par%winfiledir)
    else
       print 2, par%simtp, &
            &   par%nsmax, &
            &   par%nlmax, &
            &   par%iseed, &
            &   par%fwhma
    end if

1   format(/,&
         & " simulation type    = ",i5,/,&
         & " N_side             = ",i5,/,&
         & " l_max              = ",i5,/,&
         & " random number seed = ",i10,/,&
         & " FWHM (arc min.)    = ",f8.2,/,&
         & " input file         = ",a,/,&
         & " output file        = ",a,/,&
         & " alm file           = ",a,/,&
         & " precomputed P_lm   = ",a,/,&
         & " pixel window       = ",a,/,&
         & " pixel window dir.  = ",a,/)

2   format(/,&
         & " simulation type    = ",i5,/,&
         & " N_side             = ",i5,/,&
         & " l_max              = ",i5,/,&
         & " random number seed = ",i10,/,&
         & " FWHM (arc min.)    = ",f8.2,/)

  end subroutine getpar
!======================================================================================
  subroutine anafast_parser(filename)
    implicit none
    character(len=*) :: filename
    logical(lgt) :: exist
    character(len=filenamelen) :: line,name,value
    integer(i4b) :: i

    inquire(file=filename, exist=exist)
    if (.not. exist) then
       print 1, trim(filename)
1      format(/,&
            & " Error in anafast_parser:",/,&
            & " File ",a," does not exist.")
       stop 1
    end if

    ! --- set defaults:
    call anafast_setpar()

    open  (1,file=filename)
    do
       read (1,'(a)',end=11) line
       i=scan(line,'=')
       if (i==0 .or. line(1:1)=='#') cycle
       name=trim(adjustl(line(:i-1)))
       value=trim(adjustl(line(i+1:)))

       select case (trim(name))
       case ('simul_type')
          read (value,*) anafast_par%simtp
       case ('nlmax')
          read (value,*) anafast_par%nlmax
       case ('theta_cut_deg')
          read (value,*) anafast_par%theta_cut_deg
       case ('regression')
          read (value,*) anafast_par%regression
       case ('iter_order')
          read (value,*) anafast_par%iter_order
       case ('w8file')
          anafast_par%w8file = trim(value)
       case ('infile')
          anafast_par%inpfl = trim(value)
       case ('outfile')
          anafast_par%outfl = trim(value)
       case ('plmfile')
          anafast_par%plmfile = trim(value)
       case ('outfile_alms')
          anafast_par%outfl_alms = trim(value)
       case ('w8filedir')
          anafast_par%w8filedir=trim(value)
       case ('won')
          read (value,*) anafast_par%won
       end select
    end do
11  close (1)

  end subroutine anafast_parser

  subroutine anafast_setpar()
    implicit none

    anafast_par%simtp =   1
    anafast_par%nlmax =  64
    anafast_par%theta_cut_deg = 0.0
    anafast_par%regression = 0
    anafast_par%iter_order = 0
    anafast_par%w8file = ''
    anafast_par%inpfl = "map.fits"
    anafast_par%outfl = "cl_out.fits"
    anafast_par%plmfile = ""
    anafast_par%outfl_alms = ""
    anafast_par%w8filedir = ''
    anafast_par%won = 2

  end subroutine anafast_setpar

  subroutine anafast_getpar(all)
    implicit none
    logical(lgt), optional :: all

    print *,'Non-interactive operation. The input file and defaults imply:'

    if (present(all)) then
       print 1, anafast_par%simtp,  &
            &   anafast_par%nlmax,  &
            &   anafast_par%regression,  &
            &   anafast_par%theta_cut_deg,  &
            &   anafast_par%iter_order, &
            &   trim(anafast_par%w8file),  &
            &   trim(anafast_par%inpfl),  &
            &   trim(anafast_par%outfl), &
            &   trim(anafast_par%plmfile),  &
            &   trim(anafast_par%outfl_alms),  &
            &   trim(anafast_par%w8filedir), &
            &   anafast_par%won
    else
       print 2, anafast_par%simtp, &
            &   anafast_par%nlmax, &
            &   anafast_par%theta_cut_deg, &
            &   anafast_par%iter_order
    end if

1   format(/,&
         & " simulation type     = ",i5,/,&
         & " l_max               = ",i5,/,&
         & " regres. low multipol= ",i2,/,&
         & " symmetric cut (deg) = ",f8.2,/,&
         & " iteration order     = ",i5,/,&
         & " weight file         = ",a,/,&
         & " input file          = ",a,/,&
         & " output file         = ",a,/,&
         & " precomputed Plm     = ",a,/,&
         & " alm output file     = ",a,/,&
         & " weight file dir.    = ",a,/,&
         & " weight parameter    = ",i1,/)

2   format(/,&
         & " simulation type     = ",i5,/,&
         & " l_max               = ",i5,/,&
         & " symmetric cut (deg) = ",f8.2,/,&
         & " iteration order     = ",i5,/)

  end subroutine anafast_getpar
!======================================================================================
  subroutine hotspots_parser(filename)
    implicit none
    character(len=*) :: filename
    logical(lgt) :: exist
    character(len=filenamelen) :: line,name,value
    integer(i4b) :: i

    inquire(file=filename, exist=exist)
    if (.not. exist) then
       print 1, trim(filename)
1      format(/,&
            & " Error in hotspots_parser:",/,&
            & " File ",a," does not exist.")
       stop 1
    end if

    ! --- set defaults:
    call hotspots_setpar()

    open  (1,file=filename)
    do
       read (1,'(a)',end=11) line
       i=scan(line,'=')
       if (i==0 .or. line(1:1)=='#') cycle
       name=trim(adjustl(line(:i-1)))
       value=trim(adjustl(line(i+1:)))

       select case (trim(name))
       case ('infile')
          hotspots_par%inpfl = trim(value)
       case ('extrema_outfile')
          hotspots_par%outfl_extrema = trim(value)
       case ('maxima_outfile')
          hotspots_par%outfl_max = trim(value)
       case ('minima_outfile')
          hotspots_par%outfl_min = trim(value)
       end select
    end do
11  close (1)

  end subroutine hotspots_parser

  subroutine hotspots_setpar()
    implicit none

    hotspots_par%inpfl = "map.fits"
    hotspots_par%outfl_extrema = "pixlminmax.fits"
    hotspots_par%outfl_max = "maxima.dat"
    hotspots_par%outfl_min = "minima.dat"

  end subroutine hotspots_setpar

  subroutine hotspots_getpar(all)
    implicit none
    logical(lgt), optional :: all

    print *,'Non-interactive operation. The input file and defaults imply:'
    print 1, trim(hotspots_par%inpfl), &
         &   trim(hotspots_par%outfl_extrema), &
         &   trim(hotspots_par%outfl_max), &
         &   trim(hotspots_par%outfl_min)

1   format(/,&
         & " input file          = ",a,/,&
         & " extrema output file = ",a,/,&
         & " maxima output file  = ",a,/,&
         & " minima output file  = ",a,/)

  end subroutine hotspots_getpar
!======================================================================================
  subroutine udgrade_parser(filename)
    implicit none
    character(len=*) :: filename
    logical(lgt) :: exist
    character(len=filenamelen) :: line,name,value
    integer(i4b) :: i

    inquire(file=filename, exist=exist)
    if (.not. exist) then
       print 1, trim(filename)
1      format(/,&
            & " Error in udgrade_parser:",/,&
            & " File ",a," does not exist.")
       stop 1
    end if

    ! --- set defaults:
    call udgrade_setpar()

    open  (1,file=filename)
    do
       read (1,'(a)',end=11) line
       i=scan(line,'=')
       if (i==0 .or. line(1:1)=='#') cycle
       name=trim(adjustl(line(:i-1)))
       value=trim(adjustl(line(i+1:)))

       select case (trim(name))
       case ('nside_out')
          read (value,*) udgrade_par%nside_out
       case ('infile')
          udgrade_par%inpfl = trim(value)
       case ('outfile')
          udgrade_par%outfl = trim(value)
       end select
    end do
11  close (1)

  end subroutine udgrade_parser

  subroutine udgrade_setpar()
    implicit none

    udgrade_par%nside_out = 64
    udgrade_par%inpfl = "map.fits"
    udgrade_par%outfl = "outmap.fits"

  end subroutine udgrade_setpar

  subroutine udgrade_getpar(all)
    implicit none
    logical(lgt), optional :: all

    print *,'Non-interactive operation. The input file and defaults imply:'

    print 1, udgrade_par%nside_out, trim(udgrade_par%inpfl), trim(udgrade_par%outfl)

1   format(/,&
         & " final nsmax         = ",i5,/,&
         & " input file          = ",a,/,&
         & " output file         = ",a,/)

  end subroutine udgrade_getpar

!======================================================================================
  subroutine smoothing_parser(filename)
    implicit none
    character(len=*) :: filename
    logical(lgt) :: exist
    character(len=filenamelen) :: line,name,value
    integer(i4b) :: i

    inquire(file=filename, exist=exist)
    if (.not. exist) then
       print 1, trim(filename)
1      format(/,&
            & " Error in smoothing_parser:",/,&
            & " File ",a," does not exist.")
       stop 1
    end if

    ! --- set defaults:
    call smoothing_setpar()

    open  (1,file=filename)
    do
       read (1,'(a)',end=11) line
       i=scan(line,'=')
       if (i==0 .or. line(1:1)=='#') cycle
       name=trim(adjustl(line(:i-1)))
       value=trim(adjustl(line(i+1:)))

       select case (trim(name))
       case ('simul_type')
          read (value,*) smoothing_par%simtp
       case ('iter_order')
          read (value,*) smoothing_par%iter_order
       case ('nlmax')
          read (value,*) smoothing_par%nlmax
       case ('fwhm_arcmin')
          read (value,*) smoothing_par%fwhma
       case ('won')
          read (value,*) smoothing_par%won
       case ('plmfile')
          smoothing_par%plmfile = trim(value)
       case ('w8file')
          smoothing_par%w8file = trim(value)
       case ('w8filedir')
          smoothing_par%w8filedir=trim(value)
       case ('infile')
          smoothing_par%inpfl = trim(value)
       case ('outfile')
          smoothing_par%outfl = trim(value)
       end select
    end do
11  close (1)

  end subroutine smoothing_parser

  subroutine smoothing_setpar()
    implicit none

    smoothing_par%simtp = 1
    smoothing_par%nlmax = 64
    smoothing_par%fwhma = 420.0
    smoothing_par%iter_order = 0
    smoothing_par%inpfl = "map.fits"
    smoothing_par%outfl = "map_smoothed.fits"
    smoothing_par%w8file = ''
    smoothing_par%w8filedir = ''
    smoothing_par%plmfile = ""
    smoothing_par%won = 2

  end subroutine smoothing_setpar

  subroutine smoothing_getpar(all)
    implicit none
    logical(lgt), optional :: all

    print *,'Non-interactive operation. The input file and defaults imply:'

    print 1, &
         &   smoothing_par%simtp, &
         &   trim(smoothing_par%inpfl), &
         &   smoothing_par%fwhma, &
         &   smoothing_par%nlmax, &
         &   smoothing_par%iter_order, &
         &   trim(smoothing_par%outfl), &
         &   trim(smoothing_par%plmfile), &
         &   trim(smoothing_par%w8file), &
         &   trim(smoothing_par%w8filedir), &
         &   smoothing_par%won

1   format(/,&
         & " analysis type       = ",i5,/,&
         & " input file          = ",a,/,&
         & " FWHM (arc. min.)    = ",f8.2,/,&
         & " analysis l_max      = ",i5,/,&
         & " iteration order     = ",i5,/,&
         & " output file         = ",a,/,&
         & " precomputed Plm     = ",a,/,&
         & " weight file         = ",a,/,&
         & " weight file dir.    = ",a,/,&
         & " weight parameter    = ",i1,/)

  end subroutine smoothing_getpar

end module obsolete

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!--------------------------------------------------------------
!
! generic body of the subroutines convert_ring2nest_*_1d 
! to be inserted as is in pix_tools.f90
!
!--------------------------------------------------------------
    !=======================================================================
    !     makes the conversion RING to NEST
    !=======================================================================
    integer(kind=I4B), intent(in) :: nside
    integer(kind=I4B) :: ipn4, ipr4
    integer(kind=I8B) :: ipn8, ipr8, npix
    !=======================================================================

    npix = nside2npix(nside)
    call assert (npix>0,       code//": invalid Nside")

    allocate(map_tmp(0:npix-1)) ! bug correction, 2010-12-06

    if (nside <= ns_max4) then
!$OMP parallel default(none) &
!$OMP   shared(map, map_tmp, npix, nside) private(ipr4, ipn4)
!$OMP do schedule(dynamic,64)
       do ipr4 = 0_i4b, npix-1
          call ring2nest(nside, ipr4, ipn4)
          map_tmp(ipn4) = map(ipr4)
       enddo
!$OMP end do
!$OMP end parallel

    else

!$OMP parallel default(none) &
!$OMP   shared(map, map_tmp, npix, nside) private(ipr8, ipn8)
!$OMP do schedule(dynamic,64)
       do ipr8 = 0_i8b, npix-1
          call ring2nest(nside, ipr8, ipn8)
          map_tmp(ipn8) = map(ipr8)
       enddo
!$OMP end do
!$OMP end parallel
       
    endif

    map = map_tmp

    deallocate(map_tmp)
    return

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!--------------------------------------------------------------
!
! generic body of the subroutines apply_mask_*
! to be inserted as is in pix_tools.F90
!
! 2018-10-22: creation
! 2018-11-09: same behavior as remove_dipole, select_rings 
!             and libsharp's hpsharp_make_healpix_geom_info_2
!
!--------------------------------------------------------------

  real(KMAP), dimension(0:,1:), intent(inout) :: map
  integer(I4B),                 intent(in)    :: order
  real(KMAP), dimension(0:,1:), intent(in), optional    :: mask
  real(DP),   dimension(1:2),   intent(in), optional    :: zbounds

  real(DP) :: theta1, theta2, frac
  integer(I8B) :: npix_map, n_maps, i, p, k
  integer(I8B) :: npix_mask, n_masks, ncpix, ncp8
  integer(I8B),   dimension(:), allocatable :: cut_pixel8
  integer(I4B) :: nside
  character(len=*), parameter :: code = 'apply_mask'
  logical(LGT) :: verbose = .false.
!=====================================================================

  npix_map  = long_size(map,  1)
  n_maps    = long_size(map,  2)


  ! apply mask
  if (present(mask)) then
     npix_mask = long_size(mask, 1)
     n_masks   = long_size(mask, 2)
     if (npix_map == npix_mask) then 
        do i=1,n_maps
           k = min(i, n_masks) ! if single mask, apply it to TQU
           do p=0,npix_map-1
              map(p,i) = map(p,i) * mask(p,k)
           enddo
        enddo
     else
        if (verbose) then
           print*,npix_map, npix_mask
           print*,code//': mask is not applied'
        endif
     endif
  endif

  ! apply zbounds
  if (present(zbounds)) then
     !!!!if (abs(zbounds(1)+1.0_dp) + abs(zbounds(2)-1.0_dp) > 1.d-15) then ! not (-1,1)
     if ((zbounds(1)+1.0_dp)> EPSILON(1.0_DP) .or. (zbounds(2)-1.0_dp) < -EPSILON(1.0_DP)) then ! not (-1,1)
        nside = npix2nside(npix_map)
        if (zbounds(2) <= zbounds(1)) then ! remove one strip
           frac = (zbounds(1)-zbounds(2)) * 0.5_dp
        else ! remove 2 strips
           frac = (2.0_dp + zbounds(1)-zbounds(2)) * 0.5_dp
        endif
        ncpix  = min(nint(npix_map * frac * 1.1_dp + 10*nside,I8B), npix_map)
        theta1 = acos(zbounds(1)) 
        theta2 = acos(zbounds(2))
        allocate(cut_pixel8(0:ncpix))
        call query_strip(nside, theta1, theta2, cut_pixel8, ncp8, nest=order-1, inclusive=0)
        do i=1,n_maps
           map(cut_pixel8(0:ncp8-1),i) = 0.0_KMAP
        enddo
        deallocate(cut_pixel8)
     else
        if (verbose) then
           print*,code//': zbounds is ignored'
        endif
     endif
  endif

  return

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------

!******************************************************
! Sarah Smith (sjm84@mrao.cam.ac.uk)
! and Graca Rocha (graca@mrao.cam.ac.uk)
! June 2004
! Module sub_ngpdf_sho based on code by Michael
! Hobson and Graca Rocha
! Module sub_ngpdf_powergauss based on code by
! Anthony Challinor
! Please include an appropriate acknowledgement 
! in any publications based on work that has
! made use of this package - 'NGsims'
!******************************************************
Program sky_ng_sim
  ! Makes a full-sky non-Gaussian simulation using
  ! values drawn from pdf made from eigenstates of
  ! a simple harmonic oscillator or powers of a Gaussian
  ! Uses Healpix pixelisation and subroutines
  ! Some of the program is based on the Healpix synfast program

  USE healpix_types
  USE alm_tools, ONLY : map2alm_iterative, alm2map, alm2map_der, pow2alm_units
  USE fitstools, ONLY : read_asctab, write_bintab, dump_alms
  USE pix_tools, ONLY : nside2npix
  USE head_fits, ONLY : add_card, merge_headers, get_card, write_minimal_header, del_card
!  USE utilities, ONLY : die_alloc
  use misc_utils, only : wall_clock_time, assert_alloc, brag_openmp, fatal_error
  USE extension, ONLY : getArgument, nArguments
  USE paramfile_io, ONLY : paramfile_handle, parse_int, parse_init, &
       & parse_string, parse_lgt, parse_double, parse_check_unused, &
       & concatnl, scan_directories, parse_summarize, parse_finish, &
       & get_healpix_data_dir, get_healpix_test_dir,get_healpix_pixel_window_file 

  USE sub_ngpdf_sho
  USE sub_ngpdf_powergauss
  USE sky_sub

  Implicit none

  INTEGER(I4B) :: nsmax ! The value of N_{side} in the pixelisation scheme
  INTEGER(I4B) :: nlmax, lmax ! The maximum l-value used
  INTEGER(I4B) :: nmmax ! The maximum m-value used (set equal to nlmax)

  COMPLEX(SPC), DIMENSION(:,:,:), ALLOCATABLE :: alm_T !The a_{lm} values
  REAL(SP),     DIMENSION(:, :),  ALLOCATABLE :: map_T !The pixel values in real space
  REAL(SP), DIMENSION(:,:), ALLOCATABLE :: cl_T !The Cl values
  REAL(KIND=DP),     DIMENSION(:,:),   ALLOCATABLE :: w8ring_T
  REAL(SP),     DIMENSION(:,:),     ALLOCATABLE :: tmp_2d

!  INTEGER(I4B), DIMENSION(8,2) :: values_time
!  REAL(SP) :: clock_time
  real(SP) :: time0, time1, clock_time, ptime0, ptime1, ptime
  INTEGER(I4B) :: status

  INTEGER(I4B) npixtot !The total number of pixels
  CHARACTER(LEN=filenamelen)          :: parafile = ''
  CHARACTER(LEN=filenamelen)          :: infile
  character(len=FILENAMELEN)          :: outfile_alms
  CHARACTER(LEN=filenamelen)          :: outfile
  CHARACTER(LEN=filenamelen)          :: windowfile
  CHARACTER(LEN=filenamelen)          :: windowname
  CHARACTER(LEN=filenamelen)          :: def_dir, def_file
  CHARACTER(LEN=filenamelen)          :: usr_dir, usr_file
  CHARACTER(LEN=filenamelen)          :: final_file
  CHARACTER(LEN=filenamelen)          :: healpixtestdir
  Character(LEN=filenamelen)          :: beam_file
  character(len=filenamelen)          :: description
  character(len=100)                  :: chline
  LOGICAL(LGT) :: ok, fitscl, polarisation = .FALSE.
  logical(LGT) :: do_map, output_alms
  CHARACTER(LEN=80), DIMENSION(1:180) :: header, header_PS !, header_file
  CHARACTER(LEN=*), PARAMETER :: code = "sky_ng_sim"
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  character(len=80), dimension(1:1) :: units_power, units_map
  CHARACTER(LEN=20)                            ::  string_quad
!  CHARACTER(LEN=80) :: temptype, com_tt
!  REAL(SP) ::  quadrupole
!  INTEGER(I4B) :: count_tt
  INTEGER(I4B) nlheader
  Integer :: i,m, n_pols, n_maps, simul_type, deriv
  Real(DP) :: sigma0, factor
  Real(DP),dimension(1:3) :: nu !Added to match with f90 version of shodev_driver
  !nu(i) is the ith moment of the distribution. 
  !The size of nu is fixed to 3 to prevent problems with passing unallocated arrays
  Real(DP) :: power, rms_alm, mean
  Integer :: count, iter_order
  Integer(I4B) :: pdf_choice !Used to chose type of pdf required
  logical :: plot
  !  External shodev_driver
  Real(SP) :: Tmin, Tmax, convert
  Integer, parameter :: npts = 1000
  Real(SP) :: xline(npts), yline(npts), xstep, xval
  type(paramfile_handle) :: handle
  Real(DP) :: fwhm_arcmin
  Real(SP) :: fwhm_deg
  Character(len=30) :: xlabel
  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:
  if (nArguments() == 0) then
     parafile=''
  else
     if (nArguments() /= 1) then
        print *, " Usage: "//code//" [parameter file name]"
        call fatal_error()
     end if
     call getArgument(1,parafile)
  end if
  handle = parse_init(parafile)

  PRINT *, " "
  PRINT *,"                    "//code//" "//version
  Write(*, '(a)')  "*** Simulation of a non-Gaussian full-sky temperature map ***"

  !     --- choose temp. only or  temp. + deriv. ---
  description = concatnl( &
       & " Do you want to simulate", &
       & " 1) Temperature only", &
       !& " 2) Temperature + polarisation", &
       & " 3) Temperature + 1st derivatives", &
       & " 4) Temperature + 1st & 2nd derivatives")
  simul_type = parse_int(handle, 'simul_type', default=1, valid=(/1,3,4/), descr=description)
  deriv = 0 ! no derivatives
  if (simul_type == 3) deriv = 1
  if (simul_type == 4) deriv = 2
  n_pols = 1
  n_maps = max(1, 3*deriv)

  !     --- gets the effective resolution of the sky map ---
3 continue
  description = concatnl( &
       & "", &
       & " Enter the resolution parameter (Nside) for the simulated skymap: ",&
       & " (Npix = 12*Nside**2, where Nside HAS to be a power of 2, eg: 32, 512, ...)" )
  nsmax = parse_int(handle, 'nsmax', default=32, descr=description)
  if (nside2npix(nsmax) < 0) then
     print *, " Error: nsmax is not a power of two."
     if (handle%interactive) goto 3
     call fatal_error(code)
  endif

  !     --- gets the L range for the simulation ---
  WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",3*nsmax-1,")"
  description = concatnl(&
       & "", &
       & " Enter the maximum l range (l_max) for the simulation. ", &
       & chline )
  nlmax = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)


  !     --- get filename for input power spectrum ---
  chline = ''
  healpixtestdir = get_healpix_test_dir()
  if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/cl.fits'
  description = concatnl( "", &
       & " Enter input Power Spectrum filename", &
       & " Can be either in FITS format or in the .dat format produced by CAMB.")
  infile = parse_string(handle, 'infile', default=chline, descr=description, filestatus='old')
  ! Find out whether input cl file is a fits file
  fitscl = (index(infile, '.fits') /= 0) 

  !     --- gets the output sky map filename ---
  description = concatnl(&
       & "", &
       & " Enter Output map file name (eg, test.fits) :", &
       & "  (or !test.fits to overwrite an existing file)" )
  outfile = parse_string(handle, "outfile", &
       default="!test.fits", descr=description, filestatus="new")
  do_map = (trim(outfile) /= '')

  !     --- gets the output alm-filename ---
  description = concatnl(&
       & "", &
       & " Enter file name in which to write a_lm used to synthesize the map : ", &
       & " (eg alm.fits or !alms.fits to overwrite an existing file): ", &
       & " (If '', the alms are not written to a file) ")
  outfile_alms = parse_string(handle, 'outfile_alms', &
       & default="''", descr=description, filestatus='new')
  output_alms = (trim(outfile_alms) /= '')

  !     --- gets the fwhm of beam ---
  description = concatnl(&
       & "", &
       & " Enter FWMH of beam in arcminutes (0 for no beam):")
  fwhm_arcmin = parse_double(handle, "fwhm_arcmin", &
       default=0d0, descr=description, vmin = 0d0)

  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " a symmetric beam Legendre transform (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used.")
  beam_file = parse_string(handle, 'beam_file', default="''", &
       &                 descr=description, filestatus='old')
  if (beam_file /= '') then
     fwhm_arcmin = 0.
     print*,'fwhm_arcmin is now : 0.'
     print*,'The beam file '//trim(beam_file)//' will be used instead.'
  endif

  ! including pixel window function, EH-2008-03-05
 !     --- check for pixel-window-files ---
  windowname = get_healpix_pixel_window_file(nsmax)

  def_file = trim(windowname)
  def_dir  = get_healpix_data_dir()

22 continue
  final_file = ''
  ok = .false.
  ! if interactive, try default name in default directories first
  if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
  if (.not. ok) then 
     ! not found, ask the user
     description = concatnl("",&
          &        " Could not find window file", &
          &        " Enter the directory where this file can be found:")
     usr_dir = parse_string(handle,'winfiledir',default='',descr=description)
     if (trim(usr_dir) == '') usr_dir = trim(def_dir)
     description = concatnl("",&
          &        " Enter the name of the window file:")
     usr_file = parse_string(handle,'windowfile',default=def_file,descr=description)
     ! look for new name in user provided or default directories
     ok   = scan_directories(usr_dir, usr_file, final_file)
     ! if still fails, crash or ask again if interactive
     if (.not. ok) then
        print*,' File not found'
        if (handle%interactive) goto 22
        call fatal_error(code)
     endif
  endif
  windowfile = final_file

  PRINT *," "

  !-----------------------------------------------------------------------

  nmmax   = nlmax
  npixtot = nside2npix(nsmax)

  !-----------------------------------------------------------------------
  !                  allocates space for arrays
  !-----------------------------------------------------------------------

  !  ALLOCATE(units_alm(1:1),units_map(1:1+2*polar),stat = status)
  !  call assert_alloc(status, code,"units_alm & units_map") 

  ALLOCATE(alm_T(1:1,0:nlmax, 0:nmmax),stat = status)
  call assert_alloc(status, code,"alm_T")

  ALLOCATE(map_T(0:npixtot-1, 1:n_maps),stat = status)
  call assert_alloc(status, code,"map_T")

  ALLOCATE(w8ring_T(1:2*nsmax,1:1),stat = status)
  call assert_alloc(status, code,"w8ring_T")

  ! For now, not using ring weights for quadrature correction
  w8ring_T = 1.d0

  ! single analysis
  iter_order = 0 

  ALLOCATE(cl_T(0:nlmax,1:1),stat = status)
  call assert_alloc(status, code,"cl_T")

  !------------------------------------------------------------------------
  ! Read in the input power spectrum
  !-----------------------------------------------------------------------

  cl_T = 0.0
  !New lines added 8th June 2004
  lmax = nlmax
  call read_powerspec(infile, nsmax, lmax, cl_T, header_PS, fwhm_arcmin, units_power, beam_file = beam_file, winfile = windowfile) 
  call pow2alm_units(units_power, units_map)
  call del_card(header_PS, (/ "TUNIT#","TTYPE#"/)) ! remove TUNIT* and TTYPE* from header to avoid confusion later on

  !------------------------------------------------------------------------
  ! Draw pixel values in real space from non-Gaussian distribution
  !------------------------------------------------------------------------

  Write (*,*) "Creating non-Gaussian map with flat power spectrum"

  !     --- Chose the type of pdf to use ---
  description = concatnl(&
       & "", &
       & " Select non-Gaussian pdf to use: Simple harmonic oscillator (1)", &
       & "or powers of a Gaussian (2)" )
  pdf_choice = parse_int(handle, 'pdf_choice', default=1, vmin = 1, vmax = 2, descr=description)  

  !Write (*,*) "Use SHO pdf (0) or powers of a Gaussian pdf (1) ?"
  !Read (*,*) m
  If (pdf_choice .eq. 1) Then
     call shodev_driver(handle, npixtot, sigma0, map_T(:,1), nu)
  Else
     !     call powergauss_driver(npixtot, npixtot, sigma0, map_T, nu)
     call powergauss_driver(handle, npixtot, sigma0, map_T(:,1), nu)
  End If
  print*,'NG map MIN and MAX:',minval(map_T(:,1)),maxval(map_T(:,1))
  !Normalise the map
  If (nu(1) .ge. 0) Then !nu (1) is set to -1 if highest non-zero alpha > 3
     ! ie if we can't calculate moments analytically
     map_T = map_T / sqrt(nu(2))

     !Compute the rms value of the pixels
     power = 0
     Do i = 0, npixtot-1
        power = power + map_T(i,1)**2
     End Do
     power = Sqrt(power/npixtot)
     Write (*,*) "rms value of the pixels is ", power
  Else
     Write (*,*) "Can't calculate theoretical value of nu(2) to normalise"
     Write (*,*) "Normalising using rms pixel value instead"
     Write (*,*) "note - this method may change the statistical properties of the map"
     !Compute the mean value of the pixels
     mean = SUM(map_T(:,1)*1.d0)/npixtot
     Write (*,*) 'Mean pixel value is ',mean,' - adjusting to zero'
     map_T(:,1) = map_T(:,1) - mean
     !Compute the rms value of the pixels
     power = 0
     Do i = 0, npixtot-1
        power = power + map_T(i,1)**2
     End Do
     power = Sqrt(power/npixtot)
     Write (*,*) "rms value of the pixels is ", power ," - setting to 1.0"
     map_T(:,1) = map_T(:,1) / power    
     !Check
     power = 0
     Do i = 0, npixtot-1
        power = power + map_T(i,1)**2
     End Do
     power = Sqrt(power/npixtot)
     Write (*,*) "Now rms value of the pixels is ", power
  End If
  !------------------------------------------------------------------------
  ! Now compute the a_{lm} values from this distribution
  !------------------------------------------------------------------------

  Write (*,*) "Computing the values of the a_{lm}"
!  call map2alm(nsmax, nlmax, nmmax, map_T, alm_T, -1000.d0, w8ring_T)
!  call map2alm(nsmax, nlmax, nmmax, map_T, alm_T, (/ 0.d0, 0.d0 /), w8ring_T)
  call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_T(:,1:1), alm_T, w8ring=w8ring_T)


  !Compute the rms value of the a_{lm}
  power = 0.0
  count = 0
  Do i = 1, nlmax
     power = power + abs(alm_T(1,i,0))**2.
     count = count + 1
     Do m = 1, i
        power = power + 2.0*abs(alm_T(1,i,m))**2.
        count = count + 2
     End Do
  End Do
  rms_alm = sqrt(power/count)
  Write (*,*) "rms value of the a_{lm} is ",rms_alm
  factor = sqrt(FOURPI/npixtot)
  Write (*,*) "Expected rms value is ", factor

  !------------------------------------------------------------------------
  ! Multiply the a_{lm} by the correct power spectrum
  !------------------------------------------------------------------------

  Do i = 1, nlmax
     !Write (*,*) 'cl(',i,') is ', cl_T(i,1)
     alm_T(1,i,0:i) = alm_T(1,i,0:i)*sqrt(cl_T(i,1))/factor
  End Do

  !------------------------------------------------------------------------
  ! Now transform back to a real space map
  !------------------------------------------------------------------------

  select case (deriv)
  case(0) ! temperature only
     call alm2map(    nsmax,nlmax,nmmax,alm_T,map_T(:,1))
  case(1)
     call alm2map_der(nsmax,nlmax,nmmax,alm_T,map_T(:,1),map_T(:,2:3))
  case(2)
     call alm2map_der(nsmax,nlmax,nmmax,alm_T,map_T(:,1),map_T(:,2:3),map_T(:,4:6))
  case default
     print*,'Not valid case'
     print*,'Derivatives: ', deriv
     call fatal_error(code)
  end select

  !------------------------------------------------------------------------
  ! Plot histogram of pixel distribution (if required)
  !------------------------------------------------------------------------
  
#ifdef PGPLOT
  description = concatnl( "", &
       & " Plot histogram of pixel values? (True or False)")
  plot = parse_lgt(handle, 'plot', default=.false., descr=description)
!  Write (*,*) 'Plot histrogram of pixel values (0) or not (1)?'
!  Read (*,*) m
  If (plot) Then
     Tmin = 0.0
     Tmax = 0.0
     do i=1,npixtot
        if (map_T(i,1) .lt. Tmin) Tmin=map_T(i,1)
        if (map_T(i,1) .gt. Tmax) Tmax=map_T(i,1)
     end do
     call pgbegin(0,'?',1,1)
     if (.not. fitscl) then
        ! If reading in from .dat file Cls are already converted to uK
        convert = 1.0
        xlabel = 'Temperature / \gmK'
     else if (ABS(cl_T(2,1) - 1.0) .lt. 0.05) then
        ! If values in fits file are normalised to Cl(2) = 1.0
        ! convert to uK for plot, assuming COBE normalisation
        ! of Qrms = 18uK
        convert = sqrt(4.0*PI/5.0)*18.0
        xlabel = 'Temperature / \gmK'
     else
        ! Otherwise, units unknown
        convert = 1.0
        xlabel = 'Pixel value'
     end if
     Tmin = Tmin * convert
     Tmax = Tmax * convert
     call pghist(npixtot,map_T*convert,Tmin,Tmax,200,0)
     !Pixel values scaled to convert to uK if input fits file of cl values
     !which are normalised to C_2 = 1.0
     call pglab(xlabel,'Number of pixels','')
     !Calculate 2*mean square value of T (ie 2 sigma^2)
     power = 0
     Do i = 1, npixtot
        power = power + map_T(i,1)**2
     End Do
     power = 2 * power*(convert**2) / npixtot
     xstep=(Tmax-Tmin)/real(npts-1)
     do i=1,npts
        xval=Tmin+real(i)*xstep
        xline(i)=xval
        yline(i)=exp(-xval**2/power)/sqrt(PI*power)
        yline(i)=yline(i)*real(npixtot)*(Tmax-Tmin)/200.
     end do
     call pgsci(13)
     call pgline(npts, xline, yline)
     call pgend
  End If   
#endif

  call parse_check_unused(handle, code=code)
  call parse_summarize(handle, code=code)
  call parse_finish(handle)
  call brag_openmp()

  !-----------------------------------------------------------------------
  !                      write the alm to FITS file
  !-----------------------------------------------------------------------
  if (output_alms) then

     PRINT *,"      "//code//"> outputting alms "

     do i = 1, n_pols
        header = ""
        ! put inherited information immediatly, so that keyword values can be updated later on
        ! by current code values
        call add_card(header,"COMMENT","****************************************************************")
        call merge_headers(header_PS, header) ! insert header_PS in header at this point
        call add_card(header,"COMMENT","****************************************************************")

        ! start putting information relative to this code and run
        call write_minimal_header(header, 'alm', append=.true., &
             creator = CODE, version = VERSION, &
             nlmax = nlmax, nmmax = nmmax, &
             !randseed = ioriginseed, &
             units = units_map(i), polar = polarisation)
        if (i == 1) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (TEMPERATURE)'", update = .true.)
        elseif (i == 2) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (GRAD / ELECTRIC component)'", update = .true.)
        elseif (i == 3) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (CURL / MAGNETIC component)'", update = .true.)
        endif
        !if (input_cl) then
           call add_card(header,"HISTORY","File with input C(l):")
           call add_card(header,"HISTORY",trim(infile))
           call add_card(header,"HISTORY","These alms are multiplied by pixel and beam window functions")
           call add_card(header,"NSIDE"   ,nsmax,   "Resolution parameter for HEALPIX")
           if (trim(beam_file) == '') then
              call add_card(header,"FWHM"    ,fwhm_deg   ," [deg] FWHM of gaussian symmetric beam")
           else
              call add_card(header,"BEAM_LEG",trim(beam_file), &
                   & "File containing Legendre transform of symmetric beam")
           endif
           call add_card(header,"PDF_TYPE",pdf_choice,"1: Harmon. Oscill. ;2: Power of Gauss.")
        !endif
        call add_card(header,"HISTORY")
        nlheader = SIZE(header)
        call dump_alms (outfile_alms,alm_T(i,0:nlmax,0:nmmax),nlmax,header,nlheader,i-1_i4b)
     enddo
  endif
  !-----------------------------------------------------------------------
  !                      write the map to FITS file
  !-----------------------------------------------------------------------

  nlheader = SIZE(header)
  header = ""
  PRINT *,"      "//code//"> Writing sky map to FITS file "
  ! put inherited information immediatly, so that keyword values can be updated later on
  ! by current code values
  call add_card(header,"COMMENT","****************************************************************")
  call merge_headers(header_PS, header) ! insert header_PS in header at this point
  call add_card(header,"COMMENT","****************************************************************")
  ! start putting information relative to this code and run
  call write_minimal_header(header, 'map', append=.true., &
       nside = nsmax, ordering = 'RING', &   !, coordsys = coordsys, &
       fwhm_degree = fwhm_arcmin / 60.d0, &
       beam_leg = trim(beam_file), &
       polar = polarisation, &
       deriv = deriv, &
       creator = CODE, version = VERSION, &
       nlmax = lmax, &
       !randseed = ioriginseed, &
       units = units_map(1) )
  !Note using lmax rather than nlmax - lmax will be smaller than nlmax if not enough values
  ! in input power spectrum file

  call add_card(header,"PDF_TYPE",pdf_choice,"1: Harmon. Oscill. ;2: Power of Gauss.")
  call add_card(header,"EXTNAME","'SIMULATED MAP'", update=.true.)
  call add_card(header,"COMMENT","*************************************")

!   allocate(tmp_2d(0:npixtot-1,1:1))
!   tmp_2d(:,1) = map_T
!   call write_bintab(tmp_2d, npixtot, 1, header, nlheader, outfile)
!   deallocate(tmp_2d)
  call write_bintab(map_T, npixtot, n_maps, header, nlheader, outfile)
!!$  endif

  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------

  DEALLOCATE( map_T )
  DEALLOCATE( alm_T )
  !  DEALLOCATE( units_alm, units_map )

  !-----------------------------------------------------------------------
  !                      output and report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  WRITE(*,9000) " "
  WRITE(*,9000) " Report Card for "//code//" simulation run"
  WRITE(*,9000) "----------------------------------------"
  WRITE(*,9000) " "
  WRITE(*,9000) " Input power spectrum : "//TRIM(infile)
  WRITE(*,9010) " Multipole range      : 0 < l <= ", nlmax
  WRITE(*,9010) " Number of pixels     : ", npixtot
  !  WRITE(*,9020) " Pixel size in arcmin : ", pix_size_arcmin
  !  WRITE(*,9010) " Initial random # seed: ", ioriginseed
  if (trim(beam_file) == '') then
     write(*,9020) " Gauss. FWHM in arcmin: ", fwhm_arcmin
  else
     write(*,9000) " Beam file: "//trim(beam_file)
  endif
  WRITE(*,9000) " Output map           : "//TRIM(outfile)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  WRITE(*,9000) " "
  WRITE(*,9000) " "//code//"> normal completion"

9000 format(a)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)


  Stop

End Program sky_ng_sim

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module statistics
  !---------------------------------
  ! subroutine compute_statistics
  ! subroutine print_statistics
  ! function   median
  ! type       tstats
  !
  ! EH, IPAC, 2005-04-25
  ! EH, IAP, 2008-11-05: initialize eps and absdev to 0 in comp_stats_*
  ! EH, IAP, 2010-06-25: tstats, compute_statistics and print_statistics now
  !        support I8B variables, but median does not
  ! EH, IAP, 2015-07-31: replaced 2 with 2_i4b
  ! EH, IAP, 2016-10-06: median edited to treat properly 
  !                 empty (or totally flagged-out) data set
  !---------------------------------
  use healpix_types
  use misc_utils, only: assert
  use m_indmed, only: indmed
  use long_intrinsic, only: long_size
  implicit none

  private
  public :: median
  public :: tstats
  public :: compute_statistics, print_statistics

  interface median
     module procedure median_s, median_d
  end interface

  interface compute_statistics
     module procedure comp_stats_s, comp_stats_d
  end interface

  type tstats
     integer(i8b) :: ntot, nvalid
     real(dp)     :: mind, maxd
     real(dp)     :: average, absdev
     real(dp)     :: rms, var
     real(dp)     :: skew, kurt
  end type tstats


contains
  !
  ! compute_statistics(data, stats [, badval])
  !
  !===================================================================
  subroutine comp_stats_s(data, stats, badval)
  !===================================================================
    integer(i4b),     parameter :: KMAP = SP
    real(KMAP),       parameter :: ONE  = 1.0_KMAP
    character(len=*), parameter :: code = 'compute_statistics'
    !
    real(KMAP), dimension(0:), intent(in)  :: data
    type(tstats),              intent(out) :: stats
    real(KMAP),     optional,  intent(in)  :: badval
    !
    real(KMAP)   :: sentinel, precis
    integer(i8b) :: nvalid, i, n
    real(dp)     :: mind, maxd
    real(dp)     :: average, absdev
    real(dp)     :: rms, var
    real(dp)     :: skew, kurt
    real(dp)     :: x, dx, eps, p
    !-----------------------------------------------------------------
    precis = 10*epsilon(ONE)
    sentinel = -huge(ONE)
    if (present(badval)) then
       sentinel = badval
       call assert(sentinel /= 0, code//': BadValue should not be set to 0.0')
    endif

    n       = long_size(data)
    nvalid  = 0
    mind    =   huge(ONE)
    maxd    = - huge(ONE)
    average = 0.0_dp
    var     = 0.0_dp
    rms     = 0.0_dp
    skew    = 0.0_dp
    kurt    = 0.0_dp
    absdev  = 0.0_dp
    eps     = 0.0_dp

    do i=0, n-1
       x = data(i)
       if (abs(x/sentinel-ONE) > precis) then
          mind = min(mind, x)
          maxd = max(maxd, x)
          average = average + x
          nvalid = nvalid + 1
       endif
    enddo

    if (nvalid == 0) goto 100
    average = average / nvalid

    do i=0, n-1
       x = data(i)
       if (abs(x/sentinel-ONE) > precis) then
          dx = x - average
          eps = eps + dx
          absdev = absdev + abs(dx)
          p = dx * dx
          var = var + p
          p = p * dx
          skew = skew + p
          p = p * dx
          kurt = kurt + p
       endif
    enddo

100 continue
    if (nvalid > 0) then
       absdev = absdev / nvalid
    else
       print*,'=================================='
       print*,'No valid data point for statistics'
       print*,'=================================='
    endif

    if (nvalid > 1) then
       var    = (var - eps * eps / nvalid) / (nvalid - 1)
       rms = sqrt(var)
    else
       print*,'============================================'
       print*,'Needs at least 2 valid points for statistics'
       print*,'============================================'
    endif

    if (var /= 0.0_DP) then
       skew = skew / (nvalid * rms**3)
       kurt = kurt / (nvalid * var**2) - 3.0_dp
    else
       print*,'=========================================='
       print*,'No skewness or kurtosis when zero variance'
       print*,'=========================================='
    endif

    stats%ntot    = n 
    stats%nvalid  = nvalid  
    stats%mind    = mind    
    stats%maxd    = maxd    
    stats%average = average 
    stats%absdev  = absdev
    stats%var     = var     
    stats%rms     = rms     
    stats%skew    = skew    
    stats%kurt    = kurt    

    return
  end subroutine comp_stats_s
  !===================================================================
  subroutine comp_stats_d(data, stats, badval)
  !===================================================================
    integer(i4b),     parameter :: KMAP = DP
    real(KMAP),       parameter :: ONE  = 1.0_KMAP
    character(len=*), parameter :: code = 'compute_statistics'
    !
    real(KMAP), dimension(0:), intent(in)  :: data
    type(tstats),              intent(out) :: stats
    real(KMAP),     optional,  intent(in)  :: badval
    !
    real(KMAP)   :: sentinel, precis
    integer(i8b) :: nvalid, i, n
    real(dp)     :: mind, maxd
    real(dp)     :: average, absdev
    real(dp)     :: rms, var
    real(dp)     :: skew, kurt
    real(dp)     :: x, dx, eps, p
    !-----------------------------------------------------------------
    precis = 10*epsilon(ONE)
    sentinel = -huge(ONE)
    if (present(badval)) then
       sentinel = badval
       call assert(sentinel /= 0, code//': BadValue should not be set to 0.0')
    endif

    n       = long_size(data)
    nvalid  = 0
    mind    =   huge(ONE)
    maxd    = - huge(ONE)
    average = 0.0_dp
    var     = 0.0_dp
    rms     = 0.0_dp
    skew    = 0.0_dp
    kurt    = 0.0_dp
    absdev  = 0.0_dp
    eps     = 0.0_dp

    do i=0, n-1
       x = data(i)
       if (abs(x/sentinel-ONE) > precis) then
          mind = min(mind, x)
          maxd = max(maxd, x)
          average = average + x
          nvalid = nvalid + 1
       endif
    enddo

    if (nvalid == 0) goto 100
    average = average / nvalid

    do i=0, n-1
       x = data(i)
       if (abs(x/sentinel-ONE) > precis) then
          dx = x - average
          eps = eps + dx
          absdev = absdev + abs(dx)
          p = dx * dx
          var = var + p
          p = p * dx
          skew = skew + p
          p = p * dx
          kurt = kurt + p
       endif
    enddo

100 continue
    if (nvalid > 0) then
       absdev = absdev / nvalid
    else
       print*,'=================================='
       print*,'No valid data point for statistics'
       print*,'=================================='
    endif

    if (nvalid > 1) then
       var    = (var - eps * eps / nvalid) / (nvalid - 1)
       rms = sqrt(var)
    else
       print*,'============================================'
       print*,'Needs at least 2 valid points for statistics'
       print*,'============================================'
    endif

    if (var /= 0.0_DP) then
       skew = skew / (nvalid * rms**3)
       kurt = kurt / (nvalid * var**2) - 3.0_dp
    else
       print*,'=========================================='
       print*,'No skewness or kurtosis when zero variance'
       print*,'=========================================='
    endif

    stats%ntot    = n 
    stats%nvalid  = nvalid  
    stats%mind    = mind    
    stats%maxd    = maxd    
    stats%average = average 
    stats%absdev  = absdev
    stats%var     = var     
    stats%rms     = rms     
    stats%skew    = skew    
    stats%kurt    = kurt    

    return
  end subroutine comp_stats_d


  !--------------------------------------------------

  subroutine print_statistics(stats)

    type(tstats),        intent(in) :: stats
    integer(i8b) :: nmiss

    nmiss = stats%ntot-stats%nvalid
    print*,'Pixels  = ', stats%nvalid,' / ',stats%ntot
    write(*,9000) 'Missing = ',nmiss,(nmiss*100.)/stats%ntot
    write(*,9010) 'Average = ',stats%average
    write(*,9010) 'Abs dev = ',stats%absdev
    write(*,9010) 'Rms     = ',stats%rms
    write(*,9010) 'Min     = ',stats%mind
    write(*,9010) 'Max     = ',stats%maxd
    write(*,9010) 'Variance= ',stats%var
    write(*,9010) 'Skewness= ',stats%skew
    write(*,9010) 'Kurtosis= ',stats%kurt
    print*,'   '

9000 format(1x,a,i15,', (',f8.4,'  %)')
9010 format(1x,a,1pe14.6)
  end subroutine print_statistics

  !======================================================
  ! MEDIAN
  ! med = median(data, [badval, even]) 
  !======================================================

  function median_s(data, badval, even) result (med)
    integer(I4B), parameter :: KMAP = SP
    real(KMAP),   parameter :: ONE  = 1.0_KMAP
    character(len=*), parameter :: code = 'median'
    ! dummy variables
    real(KMAP)                                      :: med
    real(KMAP), dimension(:),  intent(in), target   :: data
    real(KMAP),                intent(in), optional :: badval
    logical(LGT),              intent(in), optional :: even
    ! local variables
    real(KMAP), dimension(:), pointer :: gdata
    real(KMAP)                        :: precis
    logical(LGT)                      :: do_even, do_bad
    integer(I8B)                      :: ndata
    integer(I4B)                      :: ngood, j, k, i, count
    !---------------------------------------------------------------------------
    precis = 10*epsilon(ONE)

    do_bad = present(badval)
    if (do_bad) call assert(badval /= 0, code//': BadValue should not be set to 0.0')
    do_even = .false.
    if (present(even)) do_even = even
    
    ! select valid data
    ndata = long_size(data)
    call assert(ndata < MAX_I4B, code//': data set too large')
    if (do_bad) then
    ! MR 2006-02-08: use explicit loops to work around a pgf90 problem
!       ngood = count(abs(data/badval-ONE) > precis)
       ngood=0
       do i=1,ndata ! flagged data (and NaNs) will not be counted
          if(abs(data(i)/badval-ONE) > precis) ngood=ngood+1
       enddo
       allocate(gdata(1:ngood))
!       gdata = pack(data, mask= (abs(data/badval-ONE) > precis))
       count=0
       do i=1,ndata
          if(abs(data(i)/badval-ONE) > precis) then
             count=count+1
             gdata(count)=data(i)             
          endif
       enddo       
    else
       ngood = ndata
       gdata => data
    endif
    
    ! find median value
    if (ngood > 0) then
       if (do_even .and. mod(ngood,2_i4b) == 0) then
          call indmed( gdata, j)
          call indmed(-gdata, k)
          med = 0.5_KMAP * (gdata(j) + gdata(k))
       else
          call indmed(gdata, j)
          med = gdata(j)
       endif
    else
       med = 0.0_KMAP
       if (do_bad) med = badval
    endif

    ! MR 2006-02-08: avoid memory leak
    if (do_bad) deallocate(gdata)

    return
  end function median_s
  !=================================================================
  function median_d(data, badval, even) result (med)
    integer(I4B), parameter :: KMAP = DP
    real(KMAP),   parameter :: ONE  = 1.0_KMAP
    character(len=*), parameter :: code = 'median'
    ! dummy variables
    real(KMAP)                                      :: med
    real(KMAP), dimension(:),  intent(in), target   :: data
    real(KMAP),                intent(in), optional :: badval
    logical(LGT),              intent(in), optional :: even
    ! local variables
    real(KMAP), dimension(:), pointer :: gdata
    real(KMAP)                        :: precis
    logical(LGT)                      :: do_even, do_bad
    integer(I8B)                      :: ndata
    integer(I4B)                      :: ngood, j, k, i, count
    !---------------------------------------------------------------------------
    precis = 10*epsilon(ONE)

    do_bad = present(badval)
    if (do_bad) call assert(badval /= 0, code//': BadValue should not be set to 0.0')
    do_even = .false.
    if (present(even)) do_even = even
    
    ! select valid data
    ndata = long_size(data)
    call assert(ndata < MAX_I4B, code//': data set too large')
    if (do_bad) then
    ! MR 2006-02-08: use explicit loops to work around a pgf90 problem
!       ngood = count(abs(data/badval-ONE) > precis)
       ngood=0
       do i=1,ndata ! flagged data (and NaNs) will not be counted
          if(abs(data(i)/badval-ONE) > precis) ngood=ngood+1
       enddo
       allocate(gdata(1:ngood))
!       gdata = pack(data, mask= (abs(data/badval-ONE) > precis))
       count=0
       do i=1,ndata
          if(abs(data(i)/badval-ONE) > precis) then
             count=count+1
             gdata(count)=data(i)             
          endif
       enddo       
    else
       ngood = ndata
       gdata => data
    endif
    
    ! find median value
    if (ngood > 0) then
       if (do_even .and. mod(ngood,2_i4b) == 0) then
          call indmed( gdata, j)
          call indmed(-gdata, k)
          med = 0.5_KMAP * (gdata(j) + gdata(k))
       else
          call indmed(gdata, j)
          med = gdata(j)
       endif
    else
       med = 0.0_KMAP
       if (do_bad) med = badval
    endif

    ! MR 2006-02-08: avoid memory leak
    if (do_bad) deallocate(gdata)

    return
  end function median_d
  !=================================================================

end module statistics

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! Fast Smoothing of a full sky map in HEALPIX pixelisation.
! Written and developed by E. Hivon (hivon@iap.fr) and K. Gorski
! (krzysztof.m.gorski@jpl.nasa.gov) based on HEALPIX pixelisation developed
! by K. Gorski
!
! Copyright 1997 by Eric Hivon and Krzysztof M. Gorski.
!  All rights reserved.
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!=======================================================================
  !=======================================================================
  !  EXTERNAL LIBRARY:
  !     this code uses the FITSIO library that can be found at
  !     http://heasarc.gsfc.nasa.gov/docs/software/fitsio/fitsio.html
  !
  !  RELATED LITTERATURE:
  !     about HEALPIX   : see Gorski et al, 2005, ApJ, 622, 759
  !     about this code : see Hivon & Gorski, 1997, in preparation
  !
  !  HISTORY:
  !     April-October 1997, Eric Hivon, TAC (f77)
  !               Jan 1998 : translation in Fortran 90
  !               Dec 2001 : version 1.2, EH, IPAC
  !                 implementation of non-interactive input
  !                 extension to polarised maps
  !               Sep 2002 : implement new parser
  !               Feb 2003 : output correct ORDERING keyword
  !               May 2007 : calls map2alm_iterative
  !               Jun 2010 : supports large maps
  !
  !  FEEDBACK:
  !     for any questions : hivon@iap.fr
  !
  !=======================================================================
  !     version 2.2
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file smoothing.f90 by the command  include
  !
  integer(I4B),             parameter :: KALMC = KIND((1.0_KMAP, 1.0_KMAP)) ! precision of alm arrays
  !-------------------------------------------------------------------------

  integer(I4B) :: nsmax, nlmax, nmmax

  complex(kind=KALMC), DIMENSION(:,:,:), ALLOCATABLE :: alm_TGC
  complex(kind=KALMC), DIMENSION(:,:,:), ALLOCATABLE :: alm_TGC2
  real(kind=KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_TQU
  real(kind=KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_TQU2
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: w8ring_TQU
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: dw8
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: plm
!  real(kind=KMAP),     dimension(:,:),   ALLOCATABLE :: pw8list
  real(kind=KMAP),     dimension(:,:), target, ALLOCATABLE :: pw8map
  real(kind=KMAP),     dimension(:,:), pointer       :: pmask
  integer(kind=I4B) :: status

  integer(kind=I8B) :: npixtot, n_plm, ipix, npixtot_tmp !, n_pw8_read
  integer(kind=I4B) :: mlpol
  integer(kind=I4B) :: plm_nside, plm_lmax, plm_pol, plm_mmax
  !integer(kind=I4B) :: nmaps, type, polar_fits
  integer(kind=I4B) :: i, j
  integer(kind=I4B) :: nlheader
  integer(kind=I4B) :: ordering, order_type
  integer(kind=I4B) :: iter, iter_order, polar, n_pols
  integer(kind=I4B) :: simul_type
  integer(kind=I4B) :: n_rings, n_rings_read, won, nmw8

  real(kind=KMAP)               :: fwhm_arcmin, fwhm_deg
  real(kind=KMAP)               :: fmissval
  real(kind=SP),      parameter :: fbad_value = -1.6375e30_sp
  real(kind=SP)                 :: pix_size_arcmin
  real(kind=DP)                 :: theta_cut_deg, cos_theta_cut
  real(kind=DP)                 :: nullval
  real(kind=DP), dimension(1:2) :: zbounds
  real(kind=DP)                 :: fsky
  real(kind=SP)                 :: clock_time, time0, time1
  real(kind=SP)                 :: ptime, ptime0, ptime1

  character(LEN=filenamelen)          :: infile
  character(LEN=filenamelen)          :: outfile
!  character(LEN=filenamelen)          :: parafile = ''
  character(LEN=filenamelen)          :: infile_plm
  character(LEN=filenamelen)          :: infile_w8
  character(LEN=filenamelen)          :: w8name
  character(LEN=filenamelen)          :: def_dir, def_file
  character(LEN=filenamelen)          :: usr_dir, usr_file
  character(LEN=filenamelen)          :: final_file
  character(LEN=filenamelen)          :: healpixtestdir
  character(LEN=filenamelen)          :: beam_file
  character(len=filenamelen)          :: description
  character(len=100)                  :: chline, chline1, strw8file
  character(LEN=80), DIMENSION(1:180) :: header
  LOGICAL(kind=LGT) :: bad, ok, polarisation
!   character(LEN=*), PARAMETER :: code = 'SMOOTHING'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  integer(kind=i4b), parameter :: nm_max = 5
  character(len=80), dimension(1:nm_max)   :: units_map
  character(len=20)                        :: coordsys

  type(paramfile_handle) :: handle

  real(kind=DP), dimension(0:3) :: mono_dip
  real(kind=DP)                 :: theta_dip, phi_dip, long_dip, lat_dip
  integer(kind=I4B)             :: lowlreg

  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  print *, " "
  print *,'                        '//code//' '//version
  write(*,'(a)') '         *** Smoothing of a Temperature (+Polarisation) map ***    '
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  print *, ''
  handle = parse_init(parafile)

  !     --- choose temp. only or  temp. + pol. ---
  description = concatnl( &
       & " Do you want to analyse", &
       & " 1) a Temperature only map", &
       & " 2) Temperature + polarisation maps")
  simul_type = parse_int(handle, 'simul_type', default=1, vmin=1, vmax=2, descr=description)
  if (simul_type .eq. 1) polarisation = .false.
  if (simul_type .eq. 2) polarisation = .true.

  !     --- gets the file name for the map ---
  chline = "''"
  healpixtestdir = get_healpix_test_dir()
  if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/map.fits'
  description = concatnl( &
       & "", &
       & " Enter input file name (Map FITS file): ")
  infile = parse_string(handle, 'infile',default=chline, descr=description, filestatus='old')

  !     --- check that this map is usable for this analysis
  call check_input_map(code, infile, polarisation) ! this may change polarisation from T to F

  !     --- finds out the pixel number of the map and its ordering ---
  ! npixtot = getsize_fits(infile, nmaps = nmaps, ordering=ordering, nside=nsmax, &
  ! &    mlpol=mlpol, type = type, polarisation = polar_fits, coordsys = coordsys)

  !    --- get other relevant information ---
  npixtot_tmp = getsize_fits(infile, ordering=ordering, nside=nsmax, &
       mlpol=mlpol, coordsys = coordsys)

!   if (nsmax<=0) then
!      print*,'Keyword NSIDE not found in FITS header!'
!      call fatal_error(code)
!   endif
!   if (type == 3) npixtot = nside2npix(nsmax) ! cut sky input data set
!   if (nsmax/=npix2nside(npixtot)) then
!      print*,"FITS header keyword NSIDE does not correspond"
!      print*,"to the size of the map!"
!      call fatal_error(code)
!   endif

!   if (polarisation .and. (nmaps >=3) .and. polar_fits == -1) then
!      print*,"The input fits file MAY NOT contain polarisation data."
!      print*,"Proceed at your own risk"
!   endif

!   if (polarisation .and. (nmaps<3 .or. polar_fits ==0)) then
!      print *,"The file does NOT contain polarisation maps"
!      print *,"only the temperature field will be smoothed"
!      polarisation = .false.
!   endif

!   !     --- check ordering scheme ---
!   if ((ordering/=1).and.(ordering/=2)) then
!      print*,'The ordering scheme of the map must be RING or NESTED.'
!      print*,'No ordering specification is given in the FITS-header!'
!      call fatal_error(code)
!   endif

  order_type = ordering

  !     --- gets the L range for the analysis ---
  WRITE(chline1,"(a,i5)") " The map has Nside = ",nsmax
  if (mlpol<=0) WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",3*nsmax-1,")"
  if (mlpol> 0) WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",mlpol,")"
  description = concatnl(&
       & "", &
       & chline1, &
       & " Enter the maximum l range (l_max) for the simulation. ", &
       & chline )
  nlmax = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)

  ! ----------  default parameters ----------------
  nmmax   = nlmax
  npixtot = nside2npix(nsmax)
  pix_size_arcmin = 360.*60./SQRT(npixtot*PI)

  !     --- ask about monopole/dipole removal ---
  description = concatnl(&
       & "", &
       & " To improve the temperature map analysis (specially on a cut sky) ", &
       & " you have the option of first regressing out the best fit monopole and dipole", &
       & "   NOTE : the regression is made on valid (unflagged) pixels, ", &
       & " out of the symmetric cut (if any)", &
       & "  Do you want to : ", &
       & " 0) Do the analysis on the raw map", &
       & " 1) Remove the monopole (l=0) first ", &
       & " 2) Remove the monopole and dipole (l=1) first")
  lowlreg = parse_int(handle, 'regression', vmin=0, vmax=2, default=0, descr=description)


  !     --- gets the cut applied to the map ---
  description = concatnl(&
       & "", &
       & " Enter the symmetric cut around the equator in DEGREES : ", &
       & " (One ignores data within |b| < b_cut)     0 <= b_cut = ")
  theta_cut_deg = parse_double(handle, 'theta_cut_deg', &
       &                       vmin=0.0_dp, default=0.0_dp, descr=description)
  cos_theta_cut = SIN(theta_cut_deg/180.d0*PI) !counted from equator instead of from pole

  zbounds = (/ cos_theta_cut , -cos_theta_cut /)
  if (theta_cut_deg<1e-4) zbounds = (/ -1.0_dp, 1.0_dp /) !keep all sphere if cut not set
  fsky = (zbounds(2)-zbounds(1))/2.0_dp
  if (fsky <= 0.0_dp) fsky = 1.0_dp + fsky
  write(*,"(a,f6.1,a)") "One keeps ",100.*fsky," % of the original map"

  !     --- gets the order of iteration ---
  description = concatnl(&
       & "", &
       & " Do you want : ", &
       & " 0) a standard analysis", &
       & " 1,2,3,4....) an iterative analysis", &
       & " (enter order of iteration, 3rd order is usually optimal)")
  iter_order=parse_int(handle, 'iter_order', vmin=0, default=0, descr=description)
  if (.not. handle%interactive) then
     select case (iter_order)
     case (0)
        print*," Standard analysis"
     case default
        print*," Iterative analysis"
     end select
  end if

  ! ------------------- precomputed plms  ---------------------
40 continue
  n_plm   = 0
  plm_pol = 0
  description = concatnl(&
       & "", &
       & " Enter name of file with precomputed p_lms :", &
       & "(eg, plm.fits) (if '' is typed, no file is read)" )
  infile_plm = parse_string(handle, 'plmfile', default="''", descr=description, filestatus='old')

  if (trim(infile_plm) /= "") then
     ! check that the plm file matches the current simulation (for nside,lmax,mmax)
     call read_par(infile_plm, plm_nside, plm_lmax, plm_pol, mmax=plm_mmax)

     if ((plm_pol /= 1).and.(.not.polarisation)) plm_pol=1

     if (plm_nside /= nsmax .or. plm_lmax /= nlmax .or. plm_mmax /= nmmax) then
        print *," "//code//"> Plm file does not match map to smooth in Nside, Lmax or Mmax ! "
        print*,'nside (plm file, map) = ',plm_nside,nsmax
        print*,'lmax                  = ',plm_lmax, nlmax
        print*,'mmax                  = ',plm_mmax, nmmax
        if (handle%interactive) goto 40
        call fatal_error(code)
     endif
     n_plm = (nmmax + 1_i8b)*(2*nlmax + 2_i8b -nmmax)*nsmax
     print *," "
  endif

  !     --- inputs the FWHM or beam file ---
  beam_file = ''
  description = concatnl(&
       & "", &
       & " Enter the Gaussian beam FWHM in arcmin >= 0 (eg: 420.) : ")
  fwhm_arcmin = parse_double(handle, 'fwhm_arcmin', default=420.0_dp, vmin=0.0_dp,descr=description)

  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " a symmetric beam Legendre transform (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used.")
  beam_file = parse_string(handle, 'beam_file', default="''", &
       &                 descr=description, filestatus='old')
  if (beam_file /= '') then
     fwhm_arcmin = 0.
     print*,'fwhm_arcmin is now : 0.'
  endif

  !     --- gets the output sky map filename ---
  description = concatnl(&
       & "", &
       & " Enter Output map file name (eg, test_smooth.fits) :", &
       & "  (or !test_smooth.fits to overwrite an existing file)" )
  outfile = parse_string(handle, "outfile", &
       default="!test_smooth.fits", descr=description, filestatus="new")

  !-----------------------------------------------------------------------
  !                      ask for weights
  !-----------------------------------------------------------------------
  description = concatnl(&
       & "", &
       & " Do you want to use quadrature weights in the analysis: ", &
       & " 0: no weight            ", &
       & " 1: ring-based weights   ", &
       & " 2: pixel-based weights ?")
  won = parse_int(handle, 'won', vmin=0, vmax=2, default=0, descr=description)

  infile_w8=""
  strw8file = ""

  if (won == 1 .or. won == 2) then

     ! default weight file name
     w8name = get_healpix_weight_file(nsmax, won)

     def_file = trim(w8name)
     def_dir  = get_healpix_data_dir()

     if (won == 1) strw8file = "ring-based  quadrature weight file"
     if (won == 2) strw8file = "pixel-based quadrature weight file"

22   continue
     final_file = ''
     ok = .false.
     ! if interactive, try default name in default directories first
     if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
     if (.not. ok) then
        ! not found, ask the user
        description = concatnl("",&
             &        " Could not find "//trim(strw8file), &
             &        " Enter the directory where this file can be found:")
        usr_dir = parse_string(handle,'w8filedir',default='',descr=description)
        if (trim(usr_dir) == '') usr_dir = trim(def_dir)
        description = concatnl("",&
             &        " Enter the name of the "//trim(strw8file)//":")
        usr_file = parse_string(handle,'w8file',default=def_file,descr=description)
        ! look for new name in user provided or default directories
        ok   = scan_directories(usr_dir, usr_file, final_file)
        ! if still fails, crash or ask again if interactive
        if (.not. ok) then
           print*,' File not found:'//trim(usr_file)
           if (handle%interactive) goto 22
           call fatal_error(code)
        endif
     endif
     infile_w8 = final_file
  endif

  print *," "
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
!  call parse_summarize(handle)
  call brag_openmp()

  !-----------------------------------------------------------------------
  !              allocate space for arrays
  !-----------------------------------------------------------------------
  polar = 0
  if (polarisation) polar = 1
  n_pols = 1 + 2*polar ! either 1 or 3

  ALLOCATE(map_TQU(0:12*nsmax**2-1,1:n_pols),stat = status)
  call assert_alloc(status,code,"map_TQU")

  ALLOCATE(w8ring_TQU(1:2*nsmax,1:n_pols),stat = status)
  call assert_alloc(status,code,"w8ring_TQU")

  ALLOCATE(dw8(1:2*nsmax,1:n_pols),stat = status)
  call assert_alloc(status,code,"dw8")

  if (n_plm/=0) then
     ALLOCATE(plm(0:n_plm-1,1:plm_pol),stat = status)
     call assert_alloc(status,code,"plm")
  endif
  !-----------------------------------------------------------------------
  !                      reads the map
  !-----------------------------------------------------------------------
  print *,"      "//code//"> Inputting original map "

  fmissval = 0.0
  if (lowlreg > 0) fmissval = fbad_value
  call input_map(infile, map_TQU(0:,1:n_pols), &
       &  npixtot, n_pols, fmissval=fmissval, units=units_map(1:n_pols))
  do i=1,n_pols
     units_map(i) = adjustl(units_map(i))
     if (trim(units_map(i)) == '') units_map(i) = 'unknown'
  enddo
 
  !-----------------------------------------------------------------------
  !                      remove dipole
  !-----------------------------------------------------------------------

  if (lowlreg > 0) then
     PRINT *,"      "//code//"> Remove monopole (and dipole) from Temperature map"
     call remove_dipole(nsmax, map_TQU(0:npixtot-1,1), ordering, lowlreg, &
          & mono_dip(0:), zbounds, fmissval=fmissval)

     if (fmissval /= 0.0) then
        do j=1,n_pols
           do ipix=0, npixtot-1
!               if (abs(map_TQU(i,j)/fmissval-1.0) < 1.e-6*fmissval) then
              if (abs(map_TQU(ipix,j)-fmissval) <= abs(1.e-6*fmissval)) then
                 map_TQU(ipix,j) = 0.0_sp
              endif
           enddo
        enddo
     endif

     write(unit=*,fmt="(a,g13.3,a)")  " Monopole = ",&
          & mono_dip(0)," "//trim(units_map(1))
     if (lowlreg > 1) then
        call vec2ang( mono_dip(1:3), theta_dip, phi_dip)
        write(unit=*,fmt="(a,g13.3,a)")  " Dipole   = ",&
             & sqrt(sum(mono_dip(1:3)**2))," "//trim(units_map(1))
        long_dip =      phi_dip  /PI*180.0
        lat_dip  = 90.0-theta_dip/PI*180.0
        write(unit=*,fmt="(a,g10.3,', ',g10.3,a)")  &
             & "(long.,lat.) = (",long_dip,lat_dip,") Deg"
     endif

  endif
  !-----------------------------------------------------------------------
  !                      input weights
  !-----------------------------------------------------------------------

  dw8=0.0_dp ! read as DP, even in SP in FITS file
  if (trim(infile_w8)/="") then
     if (won == 1) then
        ! ring based weights: treated as such in map2alm
        n_rings = 2 * nsmax
        n_rings_read = getsize_fits(infile_w8, nmaps=nmw8)

        if (n_rings_read /= n_rings) then
           print *," "
           print *,"wrong ring weight file:"//trim(infile_w8)
           call fatal_error(code)
        endif
        nmw8 = min(nmw8, n_pols)

        PRINT *,"      "//code//"> Inputting "//trim(strw8file)
        call input_map(infile_w8, dw8, n_rings, nmw8, fmissval=0.0_dp)
     endif

     if (won == 2) then 
        ! pixel based weights: turned into full sky map and treat as mask
        allocate(pw8map (0:npixtot-1,   1:1), stat=status)
        call assert_alloc(status,code,"pw8map")

        PRINT *,"      "//code//"> Inputting and unfolding "//trim(strw8file)

!         n_pw8_read = getsize_fits(infile_w8)
!         allocate(pw8list(0:n_pw8_read-1,1:1), stat=status)
!         call assert_alloc(status,code,"pw8list")
!         call input_map(infile_w8, pw8list, n_pw8_read, 1)
!         call unfold_weightslist(nsmax, won, pw8list(:,1), pw8map(:,1))
!         deallocate(pw8list)

        call unfold_weightsfile(infile_w8, pw8map(:,1))

        pmask => pw8map(:,1:1)
        !print*,pmask(1:12,1)
        !print*,pmask(npixtot-11:npixtot,1)
     endif
  endif
  w8ring_TQU = 1.d0 + dw8
  if (won /= 2) allocate(pmask(0:1,1))

  !-----------------------------------------------------------------------
  !                 reorder maps to RING if necessary
  !-----------------------------------------------------------------------
  if (order_type == 2) then
     print *,"      "//code//"> Convert Nest -> Ring "
     call convert_nest2ring (nsmax, map_TQU)
  endif

  !-----------------------------------------------------------------------
  !                    precomputed plms
  !-----------------------------------------------------------------------

  if (n_plm/=0) then
     if (plm_pol.eq.1) then
        print*,"      "//code//"> Reading precomputed scalar P_lms "
     else
        print*,"      "//code//"> Reading precomputed tensor P_lms "
     endif
     !call read_dbintab(infile_plm,plm,n_plm,plm_pol,nullval,anynull=bad) ! replaced 2010-11-24
     call read_bintab(infile_plm, plm, n_plm, plm_pol, nullval, anynull=bad)
     if (bad) call fatal_error ("Missing points in P_lm-file!")
  endif

  !-----------------------------------------------------------------------
  !                        map to alm
  !-----------------------------------------------------------------------

  ALLOCATE(alm_TGC(1:n_pols, 0:nlmax, 0:nmmax),stat = status)
  call assert_alloc(status,code,"alm_TGC")

  PRINT *,"      "//code//"> Analyse map "

  if (n_plm/=0) then
     call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU, alm_TGC, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, plm=plm, mask=pmask)
  else
     call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU, alm_TGC, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, mask=pmask)
  endif

  !-----------------------------------------------------------------------
  !                    smoothing of the alm
  !-----------------------------------------------------------------------
  print *,'      '//code//'> Alter alm '
  call alter_alm(nsmax, nlmax, nmmax, fwhm_arcmin, alm_TGC(1:1+2*polar,0:nlmax,0:nmmax), beam_file)

  !-----------------------------------------------------------------------
  !                           a_lm to map
  !-----------------------------------------------------------------------

  print *,'      '//code//'> Generating sky map(s) '

  select case (plm_pol+polar*10)
  case(0)
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1))
  case(1)
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1),plm=plm(:,1))
  case(10)
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU)
  case(11)
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU,plm=plm(:,1))
  case(13)
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU,plm=plm)
  end select

  !-----------------------------------------------------------------------
  !                 convert back to NEST if necessary
  !-----------------------------------------------------------------------
  if (order_type == 2) then
     print *,"      "//code//"> Convert Ring -> Nest "
     call convert_ring2nest (nsmax, map_TQU)
  endif

  !-----------------------------------------------------------------------
  !                        generates header
  !-----------------------------------------------------------------------
  nlheader = SIZE(header)
  fwhm_deg = fwhm_arcmin/60.
  print *,'      '//code//'> Writing smoothed map to FITS file '

  call write_minimal_header(header, 'map', &
       order = order_type, nside = nsmax, coordsys = coordsys, &
       creator = CODE, version = VERSION, nlmax = nlmax, &
       beam_leg = trim(beam_file), fwhm_degree = fwhm_deg * 1.d0, &
       polar = polarisation, units = units_map(1) )

  call add_card(header,'EXTNAME','SMOOTHED DATA', update = .true.)
  call add_card(header)
  call add_card(header,'COMMENT','************************* Input data ************************* ')
  call add_card(header,'COMMENT','Input Map in '//TRIM(infile))
  call add_card(header,'COMMENT','*************************************************************** ')
  call add_card(header,"NITERALM",iter_order,   " Number of iterations for a_lms extraction")
  call add_card(header,"LREGRESS",lowlreg,      " Regression of low multipoles (0/1/2)")
  call add_card(header,"QUADSCHM",won,          " Quadrature scheme (0/1/2)")
  call add_card(header) ! blank line
  !-----------------------------------------------------------------------
  !                      write the map to FITS file
  !-----------------------------------------------------------------------
  !call output_map(map_TQU(0:npixtot-1,1:n_pols), header, outfile) !not on Sun
  call write_bintab(map_TQU, npixtot, n_pols, header, nlheader, outfile)

  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------
  DEALLOCATE(map_TQU)
  DEALLOCATE(w8ring_TQU)
  DEALLOCATE(dw8)

  !-----------------------------------------------------------------------
  !                      output and report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" run"
  write(*,9000) " -----------------------------"
  write(*,9000) " "
  if (.not. polarisation) then
     write(*,9000) "      Temperature alone"
  else
     write(*,9000) "    Temperature + Polarisation"
  endif
  write(*,9000) " "

  write(*,9000) " Input map              : "//TRIM(infile)
  write(*,9006) " Multipole range        : ",lowlreg ," <= l <= ", nlmax
  write(*,9010) " Number of pixels       : ", npixtot
  write(*,9020) " Pixel size in arcmin   : ", pix_size_arcmin
  if (trim(beam_file) == '') then
     write(*,9020) " Gauss. FWHM in arcmin  : ", fwhm_arcmin
  else
     write(*,9000) " Beam file  : "//trim(beam_file)
  endif
  write(*,9000) " Output map             : "//TRIM(outfile)
  if (won >0) write(*,9000) " Quadrature weight file : "//trim(infile_w8)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------
  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9006 format(a,i2,a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!
!  This file contains the random number generator
!  used by the Planck LevelS package.
!  The generator is an F90 port of an xorshift generator described
!  in Marsaglia, Journal of Statistical Software 2003, vol 8.
!  It has a period of 2^128 - 1.
!
!  Copyright (C) 2003, 2004 Max-Planck-Society
!  Author: Martin Reinecke & Eric Hivon
!
module rngmod
  use healpix_types
  implicit none
  private

  public planck_rng, rand_init, rand_uni, rand_gauss

  type planck_rng
     integer(i4b) :: x,y,z,w
     real(dp)     :: gset
     logical(lgt) :: empty
  end type planck_rng

  real(dp) :: small = 1.0_dp/4294967296._dp

contains

  subroutine twiddle (v)
    ! users generally choose small numbers as seed
    ! this function will spread the seed (!) on a wider range
    integer(i4b), intent(inout) :: v
    integer i

    do i=1,9
      v=ieor(v,ishft(v,13))
      v=ieor(v,ishft(v,-17))
      v=ieor(v,ishft(v,5))
    end do
  end subroutine

  subroutine rand_init(handle, seed1, seed2, seed3, seed4)
    type(planck_rng), intent(out) :: handle
    integer(i4b), intent(in), optional :: seed1, seed2, seed3, seed4
    integer(i4b) :: i
    real(dp) :: junk

    handle%empty = .true.

    ! default values
    handle%x = 123456789
    handle%y = 362436069
    handle%z = 521288629
    handle%w = 88675123

    if (present(seed1)) then
      if (seed1/=0) handle%x = seed1
      !!!seed1 = abs(seed1)
    endif
    call twiddle(handle%x)
    if (present(seed2)) then
      if (seed2/=0) handle%y = seed2
    endif
    call twiddle(handle%y)
    if (present(seed3)) then
      if (seed3/=0) handle%z = seed3
    endif
    call twiddle(handle%z)
    if (present(seed4)) then
      if (seed4/=0) handle%w = seed4
    endif
    call twiddle(handle%w)

    ! do some burn in so that user provided seed(s)
    ! interact with default ones
    do i=1, 16
       junk = rand_uni(handle)
    enddo

  end subroutine

  function rand_uni(handle)
    type(planck_rng), intent(inout) :: handle
    real(dp) :: rand_uni

    integer(i4b) tmp
    tmp = ieor(handle%x,ishft(handle%x,11))
    handle%x = handle%y
    handle%y = handle%z
    handle%z = handle%w
    handle%w = ieor(ieor(handle%w,ishft(handle%w,-19)),ieor(tmp,ishft(tmp,-8)))
    rand_uni = small*handle%w
    if (rand_uni<0.0_dp) rand_uni=rand_uni+1.0_dp
  end function rand_uni

  function rand_gauss(handle)
    type(planck_rng), intent(inout) :: handle
    real(dp) :: rand_gauss
    real(dp) :: fac,rsq,v1,v2

    if (handle%empty) then
1      v1 = 2.0_dp * rand_uni(handle) - 1.0_dp
       v2 = 2.0_dp * rand_uni(handle) - 1.0_dp
       rsq = v1**2 + v2**2
       if(rsq>=1.0_dp .or. rsq==0.0_dp) goto 1
       fac = sqrt(-2.0_dp * log(rsq)/rsq)
       handle%gset = v1*fac
       rand_gauss  = v2*fac
       handle%empty= .false.
    else
       rand_gauss   = handle%gset
       handle%empty = .true.
    endif
  end function rand_gauss

end module rngmod

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
! template for routine SP/DP overloading for module fitstools
!
!    subroutine input_map_KLOAD            (4/8)
!    subroutine read_bintab_KLOAD          (4/8)
!    subroutine read_conbintab_KLOAD           NotYet
!    subroutine write_bintab_KLOAD         (4/8)
!    subroutine write_asctab_KLOAD          NA
!    subroutine dump_alms_KLOAD                NotYet
!    subroutine write_alms_KLOAD               NotYet
!    subroutine read_alms_KLOAD                NotYet
!    subroutine read_bintod_KLOAD           (8)
!    subroutine write_bintabh_KLOAD         (8)
!    subroutine unfold_weights_KLOAD
!    subroutine unfold_weightslist_KLOAD
!
!
! K M A P   : map kind                 either SP or DP
!
! K L O A D : suffixe of routine name, to be replaced by either s (SP) or d (DP)
!
! edited Jan 11, 2006 to deal correctly with polarised alms in write_alms and alms2fits
! edited Apr 04, 2006 to avoid concatenation problem in TFORMs  (write_plm and write_bintabh with Ifort 9)
! edited Dec 20, 2006 to accept alm file with less elements than expected (in particular if vanishing ones are not included)
! 2007-05-10 : increased maxdim (max number of columns per extension) from 20 to 40
! 2008-08-27 : in dump_alms and write_alms and write_*tab*: 
!  do not write TTYPE# and TFORM# in excess of # of fields in the file
! 2008-10-14: corrected bug introduced in write_asctab
! 2012-02-23: correction of a possible bug with index writing in dump_alms and write_alms
! 2013-12-13: increased MAXDIM from 40 to MAXDIM_TOP
! 2018-05-22: added unfold_weights, unfold_weightslist
! 2019-10-14: can write TTYPE??? (ie with up to 3 digits) in write_* and dump_alms
!

!=======================================================================
! map_bad_pixels(map, fin, fout, nbads, verbose)
!   map: input data (2D)
!   fin: input value of 'bad' pixels
!   fout: output value of same 'bad' pixels
!   nbads: number of bad pixels found
!   verbose: OPTIONAL, if set, be verbose
!=======================================================================

subroutine map_bad_pixels_KLOAD(map, fin, fout, nbads, verbose)
  use long_intrinsic, only: long_size
  real(KMAP), dimension(0:,1:), intent(inout) :: map
  real(KMAP),                   intent(in)    :: fin, fout
  integer(I8B),                 intent(out)   :: nbads
  logical(LGT),     optional,   intent(in)    :: verbose
  integer(I8B) :: i, npix
  integer(I8B), dimension(1:100) :: imiss
  integer(I4B) :: imap, nmaps
  logical(LGT) :: be_verbose
  real(KMAP) :: threshold
  !-----------------------------------------
  
  npix  = long_size(map, 1)
  nmaps = long_size(map, 2)
  threshold = abs(fin * 1.e-5_KMAP)
  
  imiss(:) = 0
  do imap = 1, nmaps
     do i=0,npix-1
        if ( abs( map(i,imap) - fin ) < threshold ) then
           map(i,imap) = fout
           imiss(imap) = imiss(imap)+1
        endif
     enddo
  enddo
  nbads = sum(imiss)
  
  be_verbose = .false.
  if (present(verbose)) be_verbose=verbose
  if (be_verbose) then
     write(*,'(a,1pe11.4)') 'blank value : ' ,fin
     do imap = 1, nmaps
        if (imiss(imap) > 0) then
           write(*,'(i12,a,f7.3,a,1pe11.4)') &
                &           imiss(imap),' missing pixels (', &
                &           (100.0_KMAP*imiss(imap))/npix,' %),'// &
                &           ' have been set to : ',fout
        endif
     enddo
  endif
  
  return
end subroutine map_bad_pixels_KLOAD
!=======================================================================
! input_map
!     reads fits file
!     filename = fits file (input)
!     map      = data read from the file (ouput) = real*4 array of size (npixtot,nmaps)
!     npixtot  = length of the map (input)
!     nmaps     = number of maps
!     fmissval  = OPTIONAL argument (input) with the value to be given to missing
!             pixels, its default value is 0
!     header    = OPTIONAL (output) contains extension header
!     units     = OPTIONAL (output) contains the maps units
!     extno     = OPTIONAL (input)  contains the unit number to read from (0 based)
!     ignore_polcconv = OPTIONAL (input), LGT, default=.false.
!                  take into account or not the POLCCONV FITS keyword
!
!     modified Feb 03 for units argument to run with Sun compiler
!     2017-02-15: deals with POLCCONV
!=======================================================================
#ifndef NO64BITS
subroutine input_map4_KLOAD(filename, map, npixtot, nmaps, &
     & fmissval, header, units, extno, ignore_polcconv)
    !=======================================================================

    INTEGER(I4B),     INTENT(IN)                           :: npixtot
    INTEGER(I4B),     INTENT(IN)                           :: nmaps
    REAL(KMAP),       INTENT(OUT), dimension(0:,1:)        :: map
    CHARACTER(LEN=*), INTENT(IN)                           :: filename
    REAL(KMAP),       INTENT(IN),                 OPTIONAL :: fmissval
    CHARACTER(LEN=*), INTENT(OUT), dimension(1:), OPTIONAL :: header
    CHARACTER(LEN=*), INTENT(OUT), dimension(1:), OPTIONAL :: units
    INTEGER(I4B),     INTENT(IN)                , optional :: extno
    logical(LGT),     intent(IN)                , optional :: ignore_polcconv
    integer(i8b) :: npixtot8

    npixtot8 = npixtot
    call input_map8_KLOAD(filename, map, npixtot8, nmaps, &
         fmissval, header, units, extno, ignore_polcconv)

    return
  end subroutine input_map4_KLOAD
#endif

!=======================================================================
subroutine input_map8_KLOAD(filename, map, npixtot, nmaps, &
     fmissval, header, units, extno, ignore_polcconv)
    !=======================================================================
  use head_fits, only: get_card, add_card
  use pix_tools, only: nside2npix
    INTEGER(I8B),     INTENT(IN)                           :: npixtot
    INTEGER(I4B),     INTENT(IN)                           :: nmaps
    REAL(KMAP),       INTENT(OUT), dimension(0:,1:)        :: map
    CHARACTER(LEN=*), INTENT(IN)                           :: filename
    REAL(KMAP),       INTENT(IN),                 OPTIONAL :: fmissval
    CHARACTER(LEN=*), INTENT(OUT), dimension(1:), OPTIONAL :: header
    CHARACTER(LEN=*), INTENT(OUT), dimension(1:), OPTIONAL :: units
    INTEGER(I4B),     INTENT(IN)                , optional :: extno
    logical(LGT),     intent(IN)                , optional :: ignore_polcconv

    INTEGER(I8B) :: i, imissing, obs_npix, maxpix, minpix
    REAL(KMAP)   :: fmissing, fmiss_effct
    integer(I4B) :: imap, nlheader

    LOGICAL(LGT) :: anynull, do_polcconv
    ! Note : read_fits_cut4 still SP and I4B only
    integer(I4B), dimension(:), allocatable :: pixel
!     real(KMAP),     dimension(:), allocatable :: signal
    real(SP),     dimension(:), allocatable :: signal
    integer(I4B) :: status
    integer(I4B) :: type_fits, nmaps_fits
    CHARACTER(LEN=80)  :: units1
    CHARACTER(LEN=80),dimension(1:30)  :: unitsm
    character(len=80), dimension(:), allocatable  :: hbuffer
!    CHARACTER(LEN=80),dimension(:), allocatable  :: unitsm
    integer(I4B) :: extno_i, extno_f
    CHARACTER(LEN=80)  :: polcconv
    integer(I4B)       :: ipolcconv, polar, nside_fits
    character(len=*), parameter :: primer_url = 'http://healpix.sf.net/pdf/intro.pdf'
    !-----------------------------------------------------------------------

    units1    = ' '
    unitsm(:) = ' '
    fmiss_effct = 0.
    imissing = 0
    if (PRESENT(fmissval)) fmiss_effct = fmissval
    if (PRESENT(header)) then
       nlheader = size(header)
    else
       nlheader = 36*100
    endif
    extno_i = 0
    if (present(extno)) extno_i = extno
    allocate(hbuffer(1:nlheader))
    do_polcconv = .true.
    if (present(ignore_polcconv)) then
       do_polcconv = .not. ignore_polcconv
    endif

    obs_npix = getsize_fits(filename, nmaps = nmaps_fits, type=type_fits, extno=extno_i, &
         polcconv=ipolcconv, polarisation=polar, nside=nside_fits)

    !       if (nmaps_fits > nmaps) then 
    !          print*,trim(filename)//' only contains ',nmaps_fits,' maps'
    !          print*,' You try to read ',nmaps
    !       endif
    if (type_fits == 0 .or. type_fits == 2) then ! full sky map (in image or binary table)
       call read_bintab(filename, map(0:,1:), &
            & npixtot, nmaps, fmissing, anynull, header=hbuffer(1:), &
            & units=unitsm(1:), extno=extno_i)
       if (present(header)) then
          do i=1,nlheader
             header(i) = hbuffer(i)
          enddo
       endif
       if (present(units)) then
          units(1:size(units)) = unitsm(1:size(units))
       endif
       call map_bad_pixels(map, fmissing, fmiss_effct, imissing, verbose=.false.)
!        do imap = 1, nmaps
!           anynull = .true.
!           if (anynull) then
!              imissing = 0
!              do i=0,npixtot-1
!                 if ( ABS(map(i,imap)/fmissing -1.) < 1.e-5 ) then
!                    map(i,imap) = fmiss_effct
!                    imissing = imissing + 1
!                 endif
!              enddo
!           endif
!        enddo
       if (imissing > 0) write(*,'(a,1pe11.4)') 'blank value : ' ,fmissing
    else if (type_fits == 3 .and. (nmaps == 1 .or. nmaps == 3)) then
       ! cut sky FITS file, reading 1 map (I) or 3 maps (I,Q,U), each from a different extension
       do imap = 1, nmaps
          extno_f  = extno_i + imap - 1 ! 2016-08-16
          obs_npix = getsize_fits(filename, extno = extno_f)       
          ! one partial map (in binary table with explicit pixel indexing)
          allocate(pixel(0:obs_npix-1), stat = status)
          allocate(signal(0:obs_npix-1), stat = status)
          call read_fits_cut4(filename, int(obs_npix,kind=i4b), &
               &              pixel, signal, header=hbuffer, units=units1, extno=extno_f)
          if (present(header) .and. imap == 1) then
             do i=1,nlheader
                header(i) = hbuffer(i)
             enddo
          endif
          if (present(units)) units(imap) = trim(units1)
          maxpix = maxval(pixel)
          minpix = maxval(pixel)
          if (maxpix > (npixtot-1) .or. minpix < 0) then
             print*,'map constructed from file '//trim(filename)//', with pixels in ',minpix,maxpix
             print*,' wont fit in array with ',npixtot,' elements'
             call fatal_error
          endif
          map(:,imap)        = fmiss_effct
          map(pixel(:),imap) = signal(:)
          imissing = npixtot - obs_npix
          deallocate(signal)
          deallocate(pixel)
       enddo
    else 
       print*,'Unable to read the ',nmaps,' required  map(s) from file '//trim(filename)
       print*,'file type = ',type_fits
       call fatal_error
    endif
    !-----------------------------------------------------------------------
    if (imissing > 0) then
       write(*,'(i12,a,f7.3,a,1pe11.4)') &
            &           imissing,' missing pixels (', &
            &           (100.*imissing)/npixtot,' %),'// &
            &           ' have been set to : ',fmiss_effct
    endif

!    deallocate(unitsm)

    !-----------------------------------------------------------------------
    ! deal with polcconv
    ! print*,'******* in input_map ',nmaps, polar, type_fits, nside_fits

    if ( do_polcconv .and. ( &
         & (nmaps >= 3 .and. type_fits == 3) &  ! cut-sky, multiple maps
         &  .or. &
         & (nmaps >=3 .and. polar==1 .and. type_fits ==2 .and. &
         &    obs_npix==nside2npix(nside_fits)) & ! full-sky, polarized map
         &                  )      ) then 
       if (ipolcconv == 0) then
          print 9000,' The POLCCONV keyword was not found in '//trim(filename)
          print 9000,' COSMO (HEALPix default) will be assumed, and map is unchanged.'
          print 9000,' See HEALPix primer ('//primer_url//') for details.'
       endif
!        if (ipolcconv == 1) then
!           print 9000,' POLCCONV=COSMO found in '//trim(filename)//'. Map is unchanged.'
!        endif
       if (ipolcconv == 2) then
          print 9000,' POLCCONV=IAU found in '//trim(filename)
          map(:,3) = - map(:,3)
          if (present(header)) then
             print 9000,' The sign of the U polarisation is changed in memory,'&
                  & //' and the header is updated.'
             call add_card(header, 'POLCCONV', 'COSMO', &
                  comment='Changed by input_map', update=.true.)
          else
             print 9000,' The sign of the U polarisation is changed in memory.'
          endif
          print 9000,' See HEALPix primer ('//primer_url//') for details.'
       endif
       if (ipolcconv == 3) then
          call get_card(hbuffer,'POLCCONV',polcconv)
          print 9000,' POLCCONV='//trim(polcconv)//' found in '//trim(filename)
          print 9000,' It is neither COSMO nor IAU.   Aborting!'
          print 9000,' See HEALPix primer ('//primer_url//') for details.'
          call fatal_error
       endif
    endif
9000 format(a)
    if (allocated(hbuffer)) deallocate(hbuffer)

    RETURN
  END subroutine input_map8_KLOAD
  !=======================================================================
  !     Read a FITS file
  !     This routine is used for reading MAPS by anafast.
  !     modified Feb 03 for units argument to run with Sun compiler
  !     Jan 2005, EH, improved for faster writing
  !=======================================================================
#ifndef NO64BITS
  subroutine read_bintab4_KLOAD(filename, map, npixtot, nmaps, nullval, anynull, header, units, extno)
    character(len=*),                          intent(IN)  :: filename
    integer(I4B),                              intent(IN)  :: npixtot
    integer(I4B),                              intent(IN)  :: nmaps
    real(KMAP),      dimension(0:,1:),         intent(OUT) :: map
    real(KMAP),                                intent(OUT) :: nullval
    logical(LGT),                              intent(OUT) :: anynull
    character(LEN=*), dimension(1:), optional, intent(OUT) :: header
    character(LEN=*), dimension(1:), optional, intent(OUT) :: units
    integer(I4B)                   , optional, intent(IN) :: extno

    integer(i8b)::  npixtot8

    npixtot8 = int(npixtot,kind=i8b)
    call read_bintab8_KLOAD(filename, map, npixtot8, nmaps, nullval, anynull, header, units, extno)
    return

  end subroutine read_bintab4_KLOAD
#endif
  subroutine read_bintab8_KLOAD(filename, map, npixtot, nmaps, nullval, anynull, header, units, extno)
  !=======================================================================
    character(len=*),                          intent(IN)  :: filename
    integer(I8B),                              intent(IN)  :: npixtot
    integer(I4B),                              intent(IN)  :: nmaps
    real(KMAP),      dimension(0:,1:),         intent(OUT) :: map
    real(KMAP),                                intent(OUT) :: nullval
    logical(LGT),                              intent(OUT) :: anynull
    character(LEN=*), dimension(1:), optional, intent(OUT) :: header
    character(LEN=*), dimension(1:), optional, intent(OUT) :: units
    integer(I4B)                   , optional, intent(IN) :: extno

    integer(I4B) :: nl_header, len_header, nl_units, len_units
    integer(I4B) :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    integer(I4B) :: group, firstpix, i, npix32
    real(KMAP)   :: blank, testval
    real(DP)     :: bscale,bzero
    character(len=80) :: comment
    logical(LGT) :: extend
    integer(I4B) :: nmove, hdutype, hdunum
    integer(I4B) :: frow, imap
    integer(I4B) :: datacode, width
    LOGICAL(LGT) ::  anynull_i

    integer(I4B),     parameter            :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    integer(i8b)                      :: npix_old
    integer(i8b), dimension(1:MAXDIM) :: npix
    integer(i8b), dimension(1:MAXDIM) :: i0, i1
    integer(i4b), dimension(1:MAXDIM) :: repeat
    integer(i4b)                      :: nrow2read, nelem

    integer(I4B)                           :: nrows, tfields, varidat
    character(len=20), dimension(1:MAXDIM) :: ttype, tform, tunit
    character(len=20)                      :: extname
    character(len=*), parameter            :: code='read_bintab'
    !-----------------------------------------------------------------------
    status=0

    unit = 146
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    anynull = .false.
    bscale = 1.0d0
    bzero = 0.0d0
    blank = -2.e25
    nullval = bscale*blank + bzero
    comment=''
    ttype=''
    tform=''
    tunit=''
    extname=''

    nl_header = 0
    if (present(header)) then
       nl_header = size(header)
       len_header = 80
    endif

    nl_units = 0
    if (present(units)) then
       nl_units = size(units)
       len_units = min(80,len(units(1))) ! due to SUN compiler bug
    endif

    readwrite=0
    !call ftopen(unit,filename,readwrite,blocksize,status)
    call ftnopn(unit,filename,readwrite, status) !open primary HDU or specified HDU
    if (status > 0) call printerror(status)
    !     -----------------------------------------
    call ftghdn(unit, hdunum)

    if (hdunum == 1) then  ! in primary HDU
       !     determines the presence of image
       call ftgkyj(unit,'NAXIS', naxis, comment, status)
       if (status > 0) call printerror(status)

       !     determines the presence of an extension
       call ftgkyl(unit,'EXTEND', extend, comment, status)
       if (status > 0) then
          extend = .false.
          status = 0 ! no extension : 
       !     to be compatible with first version of the code
       endif
    endif

    if (naxis > 0 .and. .not.extend .and. hdunum==1) then ! there is an image
       !        determine the size of the image (look naxis1 and naxis2)
       call ftgknj(unit,'NAXIS',1_i4b,2_i4b,naxes,nfound,status)

       !        check that it found only NAXIS1
       if (nfound == 2 .and. naxes(2) > 1) then
          print *,'multi-dimensional image'
          print *,'expected 1-D data.'
          call fatal_error
       end if

       if (nfound < 1) then
          call printerror(status)
          print *,'can not find NAXIS1.'
          call fatal_error
       endif

       npix(1)=naxes(1)
       if (npix(1) /= npixtot) then
          print *,'WARNING: found ',npix(1),' pixels in '//trim(filename)
          print *,'         expected ',npixtot
          npix(1) = min(npix(1), npixtot)
          print *,'         only ',npix(1),' will be read'
       endif

       call ftgkyd(unit,'BSCALE',bscale,comment,status)
       if (status == 202) then ! BSCALE not found
          bscale = 1.0d0
          status = 0
       endif
       call ftgkyd(unit,'BZERO', bzero, comment,status)
       if (status == 202) then ! BZERO not found
          bzero = 0.0d0
          status = 0
       endif
       call f90ftgky_(unit, 'BLANK', blank, comment, status)
       if (status == 202) then ! BLANK not found 
          ! (according to fitsio BLANK is integer)
          blank = -2.e25
          status = 0
       endif
       nullval = bscale*blank + bzero

       !        -----------------------------------------

       group=1
       firstpix = 1
       npix32 = npix(1)
       call f90ftgpv_(unit, group, firstpix, npix32, nullval, map(0:npix(1)-1,1), anynull, status)
       ! if there are any NaN pixels, (real data)
       ! or BLANK pixels (integer data) they will take nullval value
       ! and anynull will switch to .true.
       ! otherwise, switch it by hand if necessary
       testval = 1.e-6 * ABS(nullval)
       do i=0, npix(1)-1
          if (ABS(map(i,1)-nullval) < testval) then
             anynull = .true.
             goto 111
          endif
       enddo
111    continue

    else if (extend .or. hdunum>1) then
       if (hdunum == 1) then
          nmove = +1
          if (present(extno)) nmove = +1 + extno
          call ftmrhd(unit, nmove, hdutype, status)
       else
          call ftghdt(unit, hdutype, status)
       endif

       call assert (hdutype==2, 'this is not a binary table')

       !        reads all the keywords
       call ftghbn(unit, MAXDIM, &
            &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
            &        status)

       if (tfields < nmaps) then
          print *,'found ',tfields,' maps in file '//trim(filename)
          print *,'expected ',nmaps
          call fatal_error
       endif

       !        finds the bad data value
       call f90ftgky_(unit, 'BAD_DATA', nullval, comment, status)
       if (status == 202) then ! bad_data not found
          if (KMAP == SP) nullval = s_bad_value ! default value
          if (KMAP == DP) nullval = d_bad_value ! default value
          status = 0
       endif

       if (nl_header > 0) then
          do i=1,nl_header
             header(i)(1:len_header) = ""
          enddo
          call get_clean_header(unit, header, filename, status)
          status = 0
       endif

       if (nl_units > 0) then
          do i=1,nl_units
             units(i)(1:len_units) = 'unknown' ! default
          enddo
          do imap = 1, min(nmaps, nl_units)
             units(imap)(1:len_units) = adjustl(tunit(imap))
          enddo
       endif

       npix_old = npixtot
       do imap = 1, nmaps
          !parse TFORM keyword to find out the length of the column vector
          call ftbnfm(tform(imap), datacode, repeat(imap), width, status)
          npix(imap) = int(nrows,i8b) * repeat(imap)
          if (npix(imap) /= npixtot .and. npix_old /= npix(imap)) then
             print *,'WARNING: found ',npix(imap),' pixels in '//trim(filename)//', column ',imap
             print *,'         expected ',npixtot,' or ',npix_old
             npix_old = npix(imap)
             npix(imap) = min(npix(imap), npixtot)
             print *,'         only  ',npix(imap),' will be read'
          endif
       enddo


       call ftgrsz(unit, nrow2read, status)
       nrow2read = max(nrow2read, 1)
       firstpix  = 1  ! starting position in FITS within row, 1 based
       i0(:) = 0_i8b  ! starting element in array, 0 based
       do frow = 1, nrows, nrow2read
          do imap = 1, nmaps
             i1(imap) = min(i0(imap) + int(nrow2read,i8b) * repeat(imap), npix(imap)) - 1_i8b
             nelem = i1(imap) - i0(imap) + 1
             call f90ftgcv_(unit, imap, frow, firstpix, nelem, &
                  & nullval, map(i0(imap):i1(imap),imap), anynull_i, status)
             anynull = anynull .or. anynull_i
             i0(imap) = i1(imap) + 1_i8b
          enddo
       enddo
       ! sanity check
       do imap = 1, nmaps
          if (i0(imap) /= npix(imap)) then
             call fatal_error('something wrong during piece wise reading')
          endif
       enddo

    else ! no image no extension, you are dead, man
       call fatal_error(' No image, no extension in '//trim(filename))
    endif
    !     close the file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine read_bintab8_KLOAD

  !=======================================================================
  subroutine read_conbintab_KLOAD(filename, alms, nalms, units, extno)
    !=======================================================================
    !     Read a FITS file containing alms values
    !
    !     slightly modified to deal with vector column 
    !     in binary table       EH/IAP/Jan-98
    !
    !     Used by synfast when reading a binary file with alms for cons.real.
    !                        FKH/Apr-99
    !
    !   extno : optional, number of extension to be read, default=0: first extension
    !     Jan 2005, EH, improved for faster reading
    !=======================================================================
    CHARACTER(LEN=*),                   INTENT(IN) :: filename
    INTEGER(I4B),                       INTENT(IN) :: nalms !, nlheader
    REAL(KMAP), DIMENSION(0:nalms-1,1:6), INTENT(OUT) :: alms
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units
    INTEGER(I4B)                   , optional,  INTENT(IN) :: extno

    REAL(KMAP)                                        :: nullval
    LOGICAL(LGT)                                    ::  anynull

    INTEGER(I4B), DIMENSION(:), allocatable :: lm
    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    INTEGER(I4B) :: npix
    CHARACTER(LEN=80) :: comment
    LOGICAL(LGT) :: extend
    INTEGER(I4B) :: nmove, hdutype
    INTEGER(I4B) :: frow, imap
    INTEGER(I4B) :: datacode, repeat, width
    integer(I4B) :: i, l, m
    integer(i4b) :: nrow2read, nelem
    integer(i8b) :: i0, i1

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat
    CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform, tunit
    CHARACTER(LEN=20) :: extname
    character(len=*), parameter :: code="read_conbintab"

    !-----------------------------------------------------------------------
    status=0

    unit = 145
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    anynull = .false.
    alms=0.  ! set output to 0.
    readwrite=0
    comment=''
    ttype=''
    tform=''
    tunit=''
    extname=''
    call ftopen(unit,filename,readwrite,blocksize,status)
    if (status > 0) call printerror(status)
    !     -----------------------------------------

    !     determines the presence of image
    call ftgkyj(unit,'NAXIS', naxis, comment, status)
    if (status > 0) call printerror(status)

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    if (status > 0) status = 0 ! no extension : 
    !     to be compatible with first version of the code

    if (.not.extend) then
       print*,'No extension!'
       call fatal_error
    endif

    ! go to assigned extension (if it exists)
    nmove = +1
    if (present(extno)) nmove = +1 + extno
    call ftmrhd(unit, nmove, hdutype, status)
    if (status > 0) then
       ! if required extension not found: 
       ! print a warning, fill with dummy values, return to calling routine
       print*,code//' WARNING: the extension ',extno,' was not found in ',trim(filename)
       alms(0:nalms-1,1)=0.    ! l = 0
       alms(0:nalms-1,2)=1.    ! m = 1
       alms(0:nalms-1,3:6)=0.
       status = 0
       call ftclos(unit, status)        !     close the file
       return
    endif

    if (hdutype /= 2) then ! not a binary table
       print*, 'this is not a binary table'
       call fatal_error
    endif

    !        reads all the keywords
    call ftghbn(unit, MAXDIM, &
         &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
         &        status)

    if ((tfields/=3).and.(tfields/=5)) then
       print *,'found ',tfields,' columns in the file'
       print *,'expected 3 or 5'
       call fatal_error
    endif
    !        finds the bad data value
!     if (KMAP == SP) call ftgkye(unit,'BAD_DATA',nullval,comment,status)
!     if (KMAP == DP) call ftgkyd(unit,'BAD_DATA',nullval,comment,status)
    call f90ftgky_(unit, 'BAD_DATA', nullval, comment, status)
    if (status == 202) then ! bad_data not found
       if (KMAP == SP) nullval = s_bad_value ! default value
       if (KMAP == DP) nullval = d_bad_value ! default value
       status = 0
    endif

    !          if (nlheader > 0) then
    !             header = ""
    !             status = 0
    !             call get_clean_header(unit, header, filename, status)
    !          endif

    if (present(units)) then
       units(1) = tunit(2)
    endif

    !parse TFORM keyword to find out the length of the column vector
    call ftbnfm(tform(1), datacode, repeat, width, status)
    npix = nrows * repeat
    if (npix /= nalms) then
       print *,'found ',npix,' alms'
       print *,'expected ',nalms
       call fatal_error
    endif

    call ftgrsz(unit, nrow2read, status)
    nrow2read = max(nrow2read, 1)
    nelem = nrow2read * repeat
    i0 = 0_i8b
    allocate(lm(0:nelem-1))
    do frow = 1, nrows, nrow2read
       i1 = min(i0 + nrow2read * repeat, int(npix,i8b)) - 1_i8b
       nelem = i1 - i0 + 1
       ! first column -> index
       call ftgcvj(unit, 1_i4b, frow, 1_i4b, nelem, i_bad_value, &
         &        lm(0), anynull, status)
       call assert(.not. anynull, 'There are undefined values in the table!')
       ! other columns -> a(l,m)
       do imap = 2, tfields
          call f90ftgcv_(unit, imap, frow, 1_i4b, nelem, nullval, &
               &        alms(i0:i1,imap+1), anynull, status)
          call assert (.not. anynull, 'There are undefined values in the table!')
       enddo
       ! recoding of the mapping, EH, 2002-08-08
       ! lm = l*l + l + m + 1
       do i = i0, i1
          l = int(sqrt(   real(lm(i-i0)-1, kind = DP)  ) )
          m = lm(i-i0) - l*(l+1) - 1
          ! check that round-off did not screw up mapping
          if (abs(m) > l) then
             print*,'Inconsistent l^2+l+m+1 -> l,m mapping'
             print*,l, m, l*(l+1)+m+1, lm(i-i0)
             call fatal_error
          endif
          alms(i,1) = real( l, kind=KMAP)
          alms(i,2) = real( m, kind=KMAP)
       enddo
       i0 = i1 + 1_i8b
    enddo
    deallocate(lm)
    ! sanity check
    if (i0 /= npix) then
       print*,'something wrong during piece-wise reading'
       call fatal_error
    endif

!     !reads the columns
!     ! first column : index -> (l,m)
!     allocate(lm(0:nalms-1))
!     column = 1
!     frow = 1
!     firstpix = 1
!     npix = nrows * repeat
!     if (npix /= nalms) then
!        print *,'found ',npix,' alms'
!        print *,'expected ',nalms
!        call fatal_error
!     endif
!     call ftgcvj(unit, column, frow, firstpix, npix, i_bad_value, &
!          &        lm(0), anynull, status)
!     call assert (.not. anynull, 'There are undefined values in the table!')
!     ! recoding of the mapping, EH, 2002-08-08
!     ! lm = l*l + l + m + 1
!     do i = 0, nalms - 1
!        l = int(sqrt(   real(lm(i)-1, kind = DP)  ) )
!        m = lm(i) - l*(l+1) - 1
!        ! check that round-off did not screw up mapping
!        if (abs(m) > l) then
!           print*,'Inconsistent l^2+l+m+1 -> l,m mapping'
!           print*,l, m, l*(l+1)+m+1, lm(i)
!           call fatal_error
!        endif
!        alms(i,1) = real( l, kind=KMAP )
!        alms(i,2) = real( m, kind=KMAP )
!     enddo
!     deallocate(lm)
!
!     do imap = 2, tfields
!        !parse TFORM keyword to find out the length of the column vector
!        call ftbnfm(tform(imap), datacode, repeat, width, status)
!
!        !reads the columns
!        column = imap
!        frow = 1
!        firstpix = 1
!        npix = nrows * repeat
!        if (npix /= nalms) then
!           print *,'found ',npix,' alms'
!           print *,'expected ',nalms
!           call fatal_error
!        endif
!        call f90ftgcv_(unit, column, frow, firstpix, npix, nullval, &
!             &        alms(0:npix-1,imap+1), anynull, status)
!        call assert (.not. anynull, 'There are undefined values in the table!')
!     enddo
    !     close the file
    call ftclos(unit, status)


    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)
    return
  end subroutine read_conbintab_KLOAD

#ifndef NO64BITS
  subroutine write_bintab4_KLOAD(map, npix, nmap, header, nlheader, filename, extno)
  !=======================================================================
    INTEGER(I4B),     INTENT(IN) :: npix, nmap, nlheader
    REAL(KMAP),       INTENT(IN), DIMENSION(0:npix-1,1:nmap) :: map
    CHARACTER(LEN=*), INTENT(IN), DIMENSION(1:nlheader)      :: header
    CHARACTER(LEN=*), INTENT(IN)           :: filename
    INTEGER(I4B)    , INTENT(IN), optional :: extno

    integer(i8b) :: npix8

    npix8 = npix
    if (present(extno)) then
       call write_bintab8_KLOAD(map, npix8, nmap, header, nlheader, filename, extno)
    else
       call write_bintab8_KLOAD(map, npix8, nmap, header, nlheader, filename)
    endif
    return
  end subroutine write_bintab4_KLOAD
#endif

  subroutine write_bintab8_KLOAD(map, npix, nmap, header, nlheader, filename, extno)
    !=======================================================================
    !     Create a FITS file containing a binary table extension with 
    !     the temperature map in the first column
    !     written by EH from writeimage and writebintable 
    !     (fitsio cookbook package)
    !
    !     slightly modified to deal with vector column (ie TFORMi = '1024E')
    !     in binary table       EH/IAP/Jan-98
    !
    !     simplified the calling sequence, the header sould be filled in
    !     before calling the routine
    !
    !     July 21, 2004: SP version
    !     Jan 2005, EH, improved for faster writing
    !     2009-02-25: EH, accepts I4B and I8B npix
    !=======================================================================
    use pix_tools, only: npix2nside
    INTEGER(I8B),     INTENT(IN) :: npix
    INTEGER(I4B),     INTENT(IN) :: nmap, nlheader
!     REAL(KMAP),       INTENT(IN), DIMENSION(0:npix-1,1:nmap), target :: map
    REAL(KMAP),       INTENT(IN), DIMENSION(0:npix-1,1:nmap) :: map
    CHARACTER(LEN=*), INTENT(IN), DIMENSION(1:nlheader)      :: header
    CHARACTER(LEN=*), INTENT(IN)           :: filename
    INTEGER(I4B)    , INTENT(IN), optional :: extno

    INTEGER(I4B) ::  status,unit,blocksize,bitpix,naxis,naxes(1)
    INTEGER(I4B) ::  i, nside
    LOGICAL(LGT) ::  simple,extend
    CHARACTER(LEN=80) :: comment, ch

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat
    integer(i4b) :: repeat, nrow2write, nelem
    integer(i8b) :: i0, i1
    INTEGER(I4B) :: frow,  felem, colnum, hdutype
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    CHARACTER(LEN=10) ::  card
    CHARACTER(LEN=2) :: stn
    INTEGER(I4B) :: itn, extno_i
    character(len=filenamelen) sfilename
    character(len=1)          :: pform 
!    character(len=80)         :: junk_k, junk_v, junk_c
    !-----------------------------------------------------------------------

    if (KMAP == SP) pform = 'E'
    if (KMAP == DP) pform = 'D'
    status=0
    unit = 144
    blocksize=1

    extno_i = 0
    if (present(extno)) extno_i = extno

    if (extno_i == 0) then
       !*************************************
       !     create the new empty FITS file
       !*************************************
       call ftinit(unit,filename,blocksize,status)
       if (status > 0) call fatal_error("Error while creating file " &
            & //trim(filename) &
            & //". Check path and/or access rights.")

       !     -----------------------------------------------------
       !     initialize parameters about the FITS image
       simple=.true.
       bitpix=32     ! integer*4
       naxis=0       ! no image
       naxes(1)=0
       extend=.true. ! there is an extension

       !     ----------------------
       !     primary header
       !     ----------------------
       !     write the required header keywords
       call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

       !     writes supplementary keywords : none

       !     write the current date
       call ftpdat(unit,status) ! format (yyyy-mm-dd)

       !     ----------------------
       !     image : none
       !     ----------------------

       !     ----------------------
       !     extension
       !     ----------------------
    else

       !*********************************************
       !     reopen an existing file and go to the end
       !*********************************************
       ! remove the leading '!' (if any) when reopening the same file
       sfilename = adjustl(filename)
       if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)
       call ftopen(unit,sfilename,1_i4b,blocksize,status)
       call ftmahd(unit,1_i4b+extno_i,hdutype,status)

    endif

    !     creates an extension
    call ftcrhd(unit, status)

    !     writes required keywords
    tfields  = nmap
    repeat   = 1024
    if (npix < 1024) repeat = 1 ! for nside <= 8
    ! for large npix increase repeat so that nrows < 2^31-1
    nside = npix2nside(npix)
    if (nside > 1024*256) repeat = nside/256
    nrows    = npix / repeat ! naxis1
    ch = string(repeat, format='(i8)')
    ch = trim(adjustl(ch))//pform
    tform(1:nmap) = ch
    ttype(1:nmap) = 'simulation'   ! will be updated
    tunit(1:nmap) = ''      ! optional, will not appear
    extname  = ''      ! optional, will not appear
    varidat  = 0
    call ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
         &     extname, varidat, status)

    !     write the header literally, putting TFORM1 and TUNIT1 at the desired place
    if (KMAP == SP) comment = 'data format of field: 4-byte REAL'
    if (KMAP == DP) comment = 'data format of field: 8-byte REAL'
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE') then ! if TTYPEi is explicitely given
          stn = card(6:8)
          read(stn,'(i3)') itn
          ! discard at their original location:
          call ftdkey(unit,'TTYPE'//stn,status)  ! old TTYPEi and
          status = 0
          call ftdkey(unit,'TFORM'//stn,status)  !     TFORMi
          status = 0
          if (itn <= tfields) then ! only put relevant information 2008-08-27
             call putrec(unit,header(i), status)    ! write new TTYPE1
             status = 0
             call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! and write new TFORM1 right after
          endif
       elseif (header(i)/=' ') then
          call putrec(unit,header(i), status)
       endif
       status = 0
    enddo

    !     write the extension buffer by buffer
    call ftgrsz(unit, nrow2write, status)
    nrow2write = max(nrow2write, 1)
    felem  = 1  ! starting position in FITS (element), 1 based
    i0 = 0_i8b  ! starting element in array, 0 based
    do frow = 1, nrows, nrow2write
       i1 = min(i0 + nrow2write * repeat, npix) - 1_i8b
       nelem = i1 - i0 + 1
       do colnum = 1, nmap
          call f90ftpcl_(unit, colnum, frow, felem, nelem, map(i0:i1, colnum), status)
       enddo
       i0 = i1 + 1_i8b
    enddo
    ! sanity check
    if (i0 /= npix) then
       call fatal_error("something wrong during piece wise writing")
    endif

    !     ----------------------
    !     close and exit
    !     ----------------------

    !     close the file and free the unit number
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine write_bintab8_KLOAD
  !=======================================================================
  subroutine write_asctab_KLOAD &
       &  (clout, lmax, ncl, header, nlheader, filename, extno)
    !=======================================================================
    !     Create a FITS file containing an ASCII table extension with 
    !     the measured power spectra
    !     written by EH from writeimage and writeascii 
    !     (fitsio cookbook package)
    !
    !     clout = power spectra with l in (0:lmax)
    !     ncl = number of spectra
    !     header = FITS header to be put on top of the file
    !     nlheader = number of lines of the header
    !     filename = FITS output file name
    !
    !     2015-09-10: EH, added extno
    !=======================================================================
    !
    INTEGER(I4B),      INTENT(IN)           :: lmax, ncl,nlheader
    REAL(KMAP),        INTENT(IN)           ::  clout(0:lmax,1:ncl)
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)           :: filename
    INTEGER(I4B)    ,  INTENT(IN), optional :: extno

    INTEGER(I4B) :: bitpix,naxis,naxes(1)
    LOGICAL(LGT) :: simple,extend
    CHARACTER(LEN=10) ::  card

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP
    INTEGER(I4B) ::  status,unit,blocksize,tfields,nrows,rowlen
    INTEGER(I4B) ::  nspace,tbcol(MAXDIM),colnum,frow,felem,hdutype
    CHARACTER(LEN=16) :: ttype(MAXDIM),tform(MAXDIM),tunit(MAXDIM),extname
    CHARACTER(LEN=80) :: comment, card_tbcol
    CHARACTER(LEN=2) :: stn
    INTEGER(I4B) :: itn, i, extno_i
    character(len=filenamelen) sfilename
    character(len=6)        :: form
    !=======================================================================
    if (KMAP == SP) form = 'E15.7'
    if (KMAP == DP) form = 'D24.15'
    status=0
    unit = 109
    blocksize=1

    extno_i = 0
    if (present(extno)) extno_i = extno

    if (extno_i == 0) then
       call ftinit(unit,filename,blocksize,status)
       if (status > 0) call fatal_error("Error while creating file " &
            & //trim(filename) &
            & //". Check path and/or access rights.")
       
       !     -----------------------------------------------------
       !     initialize parameters about the FITS image
       simple=.true.
       bitpix=32     ! integer*4
       naxis=0       ! no image
       naxes(1)=0
       extend=.true. ! there is an extension
       
       !     ----------------------
       !     primary header
       !     ----------------------
       !     write the required header keywords
       call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)
       
       !     writes supplementary keywords : none
       
       !     write the current date
       call ftpdat(unit,status) ! (format ccyy-mm-dd)
       
       !     ----------------------
       !     image : none
       !     ----------------------
       
       !     ----------------------
       !     extension
       !     ----------------------
    else
       !*********************************************
       !     reopen an existing file and go to the end
       !*********************************************
       ! remove the leading '!' (if any) when reopening the same file
       sfilename = adjustl(filename)
       if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)
       call ftopen(unit,sfilename,1_i4b,blocksize,status)
       call ftmahd(unit,1_i4b+extno_i,hdutype,status)

    endif

    !     append a new empty extension onto the end of the primary array
    call ftcrhd(unit,status)

    !     define parameters for the ASCII table
    nrows   = lmax+1
    tfields = ncl
    tform(1:ncl) = form
    ttype(1:ncl) = 'power spectrum' ! is updated by the value given in the header
    tunit(1:ncl) = '' ! optional, will not appear
    extname      = '' ! optional, will not appear

    !     calculate the starting position of each column, and the total row length
    nspace=1
    call ftgabc(tfields,tform,nspace,rowlen,tbcol,status)

    !     write the required header parameters for the ASCII table
    call ftphtb(unit,rowlen,nrows,tfields,ttype,tbcol,tform,tunit, &
         &            extname,status)

    !     write the header literally, putting TFORM1 at the desired place
    comment = ''
    card_tbcol=''
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE') then ! if TTYPE1 is explicitely given
          stn = card(6:8)
          read(stn,'(i3)') itn
          ! discard at their original location:
          !!!!!!!call ftdkey(unit,card(1:6),status)  !         old TTYPEi 2019-10-14
          call ftdkey(unit,'TTYPE'//stn,status)  !         old TTYPEi
          status = 0
          call ftdkey(unit,'TFORM'//stn,status) !           TFORMi
          status = 0
          call ftgcrd(unit,'TBCOL'//stn,card_tbcol,status)
          status = 0
          call ftdkey(unit,'TBCOL'//stn,status) !           TBCOLi
          status = 0
          ! and rewrite
          if (itn <= tfields) then
             call putrec(unit,card_tbcol,status) !             TBCOLi
             status = 0
             call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! TFORMi right after
             status = 0
             call putrec(unit,header(i), status)   !           TTYPEi
          endif
       elseif (header(i)/=' ') then
          call putrec(unit,header(i), status)
       endif
       status = 0
    enddo

    frow=1
    felem=1
    do colnum = 1, ncl
       call f90ftpcl_(unit, colnum, frow, felem, nrows, clout(0:nrows-1,colnum), status)  
    enddo

    !     close the FITS file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine write_asctab_KLOAD
  !=======================================================================
  !   DUMP_ALMS
  !
  !     Create/extend a FITS file containing a binary table extension with 
  !     the a_lm coefficients in each extension.
  !
  !     Format of alm FITS file: in each extension, 3 columns: 
  !            index=l*l+l+m+1, real(a_lm), imag(a_lm)
  !      the a_lm are obtained using the complex Y_lm
  !      only the modes with m>=0 are stored (because the map is assumed real)
  !
  !     The extensions contain, in general, T, E (= G) and B (= C) in that order
  !     First extension has extno = 0
  !
  !     Adapted from write_bintab, FKH/Apr-99
  !   SP/DP overloaded, 2004-12, EH
  !    reduced size of intermediate arrays (alms_out, lm)
  !
  subroutine dump_alms_KLOAD(filename, alms, nlmax, header, nlheader, extno)
    !=======================================================================
    INTEGER(I4B),      INTENT(IN) :: nlmax, nlheader, extno
    COMPLEX(KMAPC),      INTENT(IN), DIMENSION(0:,0:) :: alms
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)               :: filename
    ! local variables
    INTEGER(I4B),   DIMENSION(:),   allocatable :: lm
    REAL(KMAP),     DIMENSION(:,:), allocatable :: alms_out
    INTEGER(I4B) ::  status,unit,blocksize,bitpix,naxis,naxes(1)
    INTEGER(I4B) ::  i,l,m,cnt,hdutype, nmmax
    LOGICAL(LGT) ::  simple,extend, found_lmax, found_mmax
    CHARACTER(LEN=80) :: comment

    integer(i8b) :: npix
    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat
    INTEGER(I4B) :: frow,  felem
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    CHARACTER(LEN=10) ::  card
    CHARACTER(LEN=2) :: stn
    INTEGER(I4B) :: itn
    character(len=filenamelen) sfilename
    character(len=1) :: pform
    character(len=*), parameter :: code = 'dump_alms'
    !-----------------------------------------------------------------------

    if (KMAP == SP) pform = 'E'
    if (KMAP == DP) pform = 'D'
    
    nmmax = size(alms,2) - 1
    if (nmmax < 0 .or. nmmax > nlmax) call fatal_error('inconsistent Lmax and Mmax in dump_alms')
!!    npix=((nlmax+1)*(nlmax+2))/2
    npix = ((nmmax+1_i8b)*(2_i8b*nlmax-nmmax+2))/2
    if (npix > MAX_I4B .or. nlmax >= int(sqrt(real(MAX_I4B,kind=dp)))) then
       print*,code//'> Index of a_lm too large for current file format,'
       print*,code//'> '//trim(filename)//' not written.'
       call fatal_error
    endif

    status=0
    unit = 141
    blocksize=1

    if (extno==0) then
       !*********************************************
       !     create the new empty FITS file
       !*********************************************
       call ftinit(unit,filename,blocksize,status)
       if (status > 0) call fatal_error("Error while creating file " &
            & //trim(filename) &
            & //". Check path and/or access rights.")

       !     -----------------------------------------------------
       !     initialize parameters about the FITS image
       simple=.true.
       bitpix=32     ! integer*4
       naxis=0       ! no image
       naxes(1)=0
       extend=.true. ! there is an extension

       !     ----------------------
       !     primary header
       !     ----------------------
       !     write the required header keywords
       call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

       !     writes supplementary keywords : none

       !     write the current date
       call ftpdat(unit,status) ! format (yyyy-mm-dd)

       !     ----------------------
       !     image : none
       !     extension
       !     ----------------------
    else

       !*********************************************
       !     reopen an existing file and go to the end
       !*********************************************
       ! remove the leading '!' (if any) when reopening the same file
       sfilename = adjustl(filename)
       if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)
       call ftopen(unit,sfilename,1_i4b,blocksize,status)
       call ftmahd(unit,1_i4b+extno,hdutype,status)

    endif

    !     creates an extension
    call ftcrhd(unit, status)

    !     writes required keywords
    nrows    = npix  ! naxis1
    tfields  = 3
    tform = '' ; ttype = '' ; tunit = ''
    tform(1)(1:2)=  '1J' ! necessary with ifort 11.1.076
    tform(2)(1:2) = '1'//pform
    tform(3)(1:2) = '1'//pform
    ttype(1)(1:15) = 'index=l^2+l+m+1'
    ttype(2)(1:15) = 'alm (real)     '
    ttype(3)(1:15) = 'alm (imaginary)' 
    tunit(1:3) = ''      ! optional, will not appear
    extname  = ''      ! optional, will not appear
    varidat  = 0
    call ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
         &     extname, varidat, status)

    !     write the header literally, putting TFORM1 at the desired place
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE') then ! if TTYPEi is explicitely given
          stn = card(6:8)
          read(stn,'(i3)') itn
          ! discard at their original location:
          call ftdkey(unit,'TTYPE'//stn,status)  ! old TTYPEi and  ! remove
          status = 0
          call ftdkey(unit,'TFORM'//stn,status)  !     TFORMi
          status = 0
          if (itn <= tfields) then ! only put relevant information 2008-08-27
             call putrec(unit,header(i), status)           ! write new TTYPEi
             status = 0
             if (itn==1) then
                comment = 'data format of field: 4-byte INTEGER'
             else
                if (KMAP == SP) comment = 'data format of field: 4-byte REAL'
                if (KMAP == DP) comment = 'data format of field: 8-byte REAL'
             endif
             call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! and write new TFORM1 right after
          endif
       elseif (header(i)/=' ') then
          call putrec(unit,header(i), status)
       endif
       status = 0
    enddo

    call ftukyj(unit, 'MIN-LPOL', 0_i4b, 'Minimum L multipole order',  status)
    call ftukyj(unit, 'MAX-LPOL', nlmax, 'Maximum L multipole order',  status)
    call ftukyj(unit, 'MAX-MPOL', nmmax, 'Maximum M multipole degree', status)

    allocate(lm      (0:nmmax))
    allocate(alms_out(0:nmmax,1:2))
    !     write the extension one column by one column
    frow   = 1  ! starting position (row)
    felem  = 1  ! starting position (element)
    do l = 0, nlmax
       cnt = 0
       do m = 0, min(l,nmmax)
          lm(cnt) = l**2 + l + m + 1
          alms_out(cnt,1)=REAL( alms(l,m))
          alms_out(cnt,2)=AIMAG(alms(l,m))
          cnt = cnt + 1
       enddo
       call ftpclj(   unit, 1_i4b, frow, felem, cnt, lm,                  status)
       call f90ftpcl_(unit, 2_i4b, frow, felem, cnt, alms_out(0:cnt-1,1), status)
       call f90ftpcl_(unit, 3_i4b, frow, felem, cnt, alms_out(0:cnt-1,2), status)
       frow = frow + cnt
    enddo
    deallocate(lm)
    deallocate(alms_out)

    !     ----------------------
    !     close and exit
    !     ----------------------

    !     close the file and free the unit number
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)


    return
  end subroutine dump_alms_KLOAD
  !=======================================================================
  subroutine write_alms_KLOAD(filename, nalms, alms, ncl, header, nlheader, extno)
    !=======================================================================
    !     Writes alms from to binary FITS file, FKH/Apr-99
    !     ncl is the number of columns, in the output fits file,
    !     either 3 or 5 (with or without errors respectively)
    !
    !    input array (real)                   FITS file
    !     alms(:,1) = l                      )
    !     alms(:,2) = m                      )---> col 1: l*l+l+m+1
    !     alms(:,3) = real(a_lm)              ---> col 2
    !     alms(:,4) = imag(a_lm)              ---> col 3
    !     alms(:,5) = real(delta a_lm)        ---> col 4
    !     alms(:,6) = imag(delta a_lm)        ---> col 5
    !
    !=======================================================================
    
    INTEGER(I4B), INTENT(IN) :: nalms, nlheader, ncl, extno
    REAL(KMAP),        INTENT(IN), DIMENSION(0:nalms-1,1:(ncl+1)) :: alms
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)               :: filename

    INTEGER(I4B), DIMENSION(:), allocatable :: lm
    INTEGER(I4B) ::  status,unit,blocksize,bitpix,naxis,naxes(1)
    INTEGER(I4B) ::  i,hdutype, lmax, mmax, lmin
    LOGICAL(LGT) ::  simple,extend
    CHARACTER(LEN=80) :: comment

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, npix, tfields, varidat, repeat
    INTEGER(I4B) :: frow,  felem, colnum, stride, istart, iend, k
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    CHARACTER(LEN=10) ::  card
    CHARACTER(LEN=2) :: stn
    INTEGER(I4B) :: itn
    integer(I4B) :: l, m
    character(len=filenamelen) sfilename
    character(len=1) :: pform
    !-----------------------------------------------------------------------

    if (KMAP == SP) pform = 'E'
    if (KMAP == DP) pform = 'D'

    status=0
    unit = 140

    !     create the new empty FITS file
    blocksize=1

    if (extno==1) then

       call ftinit(unit,filename,blocksize,status)
       if (status > 0) call fatal_error("Error while creating file " &
            & //trim(filename) &
            & //". Check path and/or access rights.")

       !     -----------------------------------------------------
       !     initialize parameters about the FITS image
       simple=.true.
       bitpix=32     ! integer*4
       naxis=0       ! no image
       naxes(1)=0
       extend=.true. ! there is an extension

       !     ----------------------
       !     primary header
       !     ----------------------
       !     write the required header keywords
       call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

       !     writes supplementary keywords : none

       !     write the current date
       call ftpdat(unit,status) ! format ccyy-mm-dd

       !     ----------------------
       !     image : none
       !     ----------------------

       !     ----------------------
       !     extension
       !     ----------------------

    else

       !*********************************************
       !     reopen an existing file and go to the end
       !*********************************************
       ! remove the leading '!' (if any) when reopening the same file
       sfilename = adjustl(filename)
       if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)
       call ftopen(unit,sfilename,1_i4b,blocksize,status)
       call ftmahd(unit,extno,hdutype,status)

    endif

    !     creates an extension
    call ftcrhd(unit, status)

    !     writes required keywords
    nrows    = nalms  ! naxis1
    tfields  = ncl
    repeat   = 1
    tform(1)(1:2)='1J' ! necessary with ifort 11.1.076
    do i=2, ncl
       tform(i)(1:2) = '1'//pform
    enddo
    ttype(1)(1:15) = 'index=l^2+l+m+1'
    ttype(2)(1:15) = 'alm (real)     '
    ttype(3)(1:15) = 'alm (imaginary)' 
    if (ncl>3) then
       ttype(4)(1:17)  = 'error (real)     '
       ttype(5)(1:17)  = 'error (imaginary)'
    endif
    tunit(1:ncl) = ''      ! optional, will not appear
    extname  = ''      ! optional, will not appear
    varidat  = 0
    call ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
         &     extname, varidat, status)

    !     write the header literally, putting TFORMi at the desired place
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE') then ! if TTYPEi is explicitely given
          stn = card(6:8)
          read(stn,'(i3)') itn
          ! discard at their original location:
          call ftdkey(unit,'TTYPE'//stn,status)  ! old TTYPEi and  ! remove
          status = 0
          call ftdkey(unit,'TFORM'//stn,status)  !     TFORMi
          status = 0
          if (itn <= tfields) then ! only put relevant information 2008-08-27
             call putrec(unit,header(i), status)           ! write new TTYPE1
             status = 0
             if (itn==1) then
                comment = 'data format of field: 4-byte INTEGER'
             else
                if (KMAP == SP) comment = 'data format of field: 4-byte REAL'
                if (KMAP == DP) comment = 'data format of field: 8-byte REAL'
             endif
             call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! and write new TFORM1 right after
          endif
       elseif (header(i)/=' ') then
          call putrec(unit,header(i), status)
       endif
       status = 0
    enddo

    lmax = nint(maxval(alms(:,1)))
    lmin = nint(minval(alms(:,1)))
    mmax = nint(maxval(alms(:,2)))
    call ftukyj(unit, 'MIN-LPOL', lmin, 'Minimum L multipole order',  status)
    call ftukyj(unit, 'MAX-LPOL', lmax, 'Maximum L multipole order',  status)
    call ftukyj(unit, 'MAX-MPOL', mmax, 'Maximum M multipole degree', status)

    !     write the extension by blocks of rows ! EH, Dec 2004
    felem  = 1  ! starting position (element)
!!!    stride = 1000 ! 1000 rows at a time
    call ftgrsz(unit, stride, status) ! find optimal stride in rows
    stride = max( stride, 1)
    allocate(lm(0:stride-1))
    do k = 0, (nalms-1)/(stride * repeat)
       istart = k * (stride * repeat)
       iend   = min(nalms, istart + stride * repeat) - 1
       do i = istart, iend ! recode the (l,m) -> lm mapping, EH, 2002-08-08
          l = nint(alms(i,1))
          m = nint(alms(i,2))
          lm(i-istart) = (l+1)*l + m + 1
       enddo

       frow = istart/repeat + 1
       npix = iend - istart + 1
       call ftpclj(      unit, 1_i4b,  frow, felem, npix, lm,                         status)
       do colnum = 2, ncl
          call f90ftpcl_(unit, colnum, frow, felem, npix, alms(istart:iend,colnum+1), status)
       enddo
    enddo
    deallocate(lm)

    !     ----------------------
    !     close and exit
    !     ----------------------

    !     close the file and free the unit number
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine write_alms_KLOAD
  !=======================================================================
  subroutine read_alms_KLOAD(filename, nalms, alms, ncl, header, nlheader, extno) 
    !=======================================================================
    !     Read a FITS file
    !
    !     slightly modified to deal with vector column 
    !     in binary table       EH/IAP/Jan-98
    !
    !     Used by synfast when reading a binary file with alms for cons.real.
    !                        FKH/Apr-99
    !
    !     called by fits2alms
    !     Jan 2005, EH, improved for faster reading
    !=======================================================================
    CHARACTER(LEN=*),               INTENT(IN) :: filename
    INTEGER(I4B),                        INTENT(IN) :: nalms, ncl,nlheader,extno
    REAL(KMAP), DIMENSION(0:nalms-1,1:(ncl+1)), INTENT(OUT) :: alms
    CHARACTER(LEN=80), INTENT(OUT), DIMENSION(1:nlheader) :: header
    REAL(KMAP)                                        :: nullval
    LOGICAL(LGT)                                    ::  anynull

    INTEGER(I4B), DIMENSION(:), allocatable :: lm
    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    INTEGER(I4B) :: npix
    CHARACTER(LEN=80) :: comment ! , record
    LOGICAL(LGT) :: extend
    INTEGER(I4B) :: nmove, hdutype ! , nkeys , nspace
    INTEGER(I4B) :: frow, imap
    INTEGER(I4B) :: datacode, repeat, width
    integer(I4B) :: i, l, m
    integer(i4b) :: nrow2read, nelem
    integer(i8b) :: i0, i1

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname

    !-----------------------------------------------------------------------
    status=0
    header=''
    comment=''
    ttype=''
    tform=''
    tunit=''
    extname=''
    unit = 139
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    anynull = .false.
    alms=0.
    readwrite=0
    call ftopen(unit,filename,readwrite,blocksize,status)
    if (status > 0) then 
       call printerror(status)
       call fatal_error("Aborting.")
    endif
    !     -----------------------------------------

    !     determines the presence of image
    call ftgkyj(unit,'NAXIS', naxis, comment, status)
    if (status > 0) call printerror(status)

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    if (status > 0) status = 0 ! no extension : 
    !     to be compatible with first version of the code

    call assert (extend, 'No extension!')
    nmove = +extno
    call ftmrhd(unit, nmove, hdutype, status)
    !cc         write(*,*) hdutype

    call assert(hdutype==2, 'this is not a binary table')

    header = ""
    call get_clean_header( unit, header, filename, status)

    !        reads all the keywords
    call ftghbn(unit, MAXDIM, &
         &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
         &        status)

    if (tfields<ncl) then
       print *,'found ',tfields,' columns in the file'
       print *,'expected ',ncl
       call fatal_error
    endif
    !        finds the bad data value
!     if (KMAP == SP) call ftgkye(unit,'BAD_DATA',nullval,comment,status)
!     if (KMAP == DP) call ftgkyd(unit,'BAD_DATA',nullval,comment,status)
    call f90ftgky_(unit, 'BAD_DATA', nullval, comment, status)
    if (status == 202) then ! bad_data not found
       if (KMAP == SP) nullval = s_bad_value ! default value
       if (KMAP == DP) nullval = d_bad_value ! default value
       status = 0
    endif
    !parse TFORM keyword to find out the length of the column vector
    call ftbnfm(tform(1), datacode, repeat, width, status)
    npix = nrows * repeat
!    if (npix /= nalms) then
    if (npix > nalms) then
       print *,'found ',npix,' alms'
!       print *,'expected ',nalms
       print *,'expected ',nalms,' or less'
       call fatal_error
    endif

    call ftgrsz(unit, nrow2read, status)
    nrow2read = max(nrow2read, 1)
    nelem = nrow2read * repeat
    i0 = 0_i8b
    allocate(lm(0:nelem-1))
    do frow = 1, nrows, nrow2read
       i1 = min(i0 + nrow2read * repeat, int(npix,i8b)) - 1_i8b
       nelem = i1 - i0 + 1
       ! first column -> index
       call ftgcvj(unit, 1_i4b, frow, 1_i4b, nelem, i_bad_value, &
         &        lm(0), anynull, status)
       call assert(.not. anynull, 'There are undefined values in the table!')
       ! other columns -> a(l,m)
       do imap = 2, ncl
          call f90ftgcv_(unit, imap, frow, 1_i4b, nelem, nullval, &
               &        alms(i0:i1,imap+1), anynull, status)
          call assert (.not. anynull, 'There are undefined values in the table!')
       enddo
       ! recoding of the mapping, EH, 2002-08-08
       ! lm = l*l + l + m + 1
       do i = i0, i1
          l = int(sqrt(   real(lm(i-i0)-1, kind = DP)  ) )
          m = lm(i-i0) - l*(l+1) - 1
          ! check that round-off did not screw up mapping
          if (abs(m) > l) then
             print*,'Inconsistent l^2+l+m+1 -> l,m mapping'
             print*,l, m, l*(l+1)+m+1, lm(i-i0)
             call fatal_error
          endif
          alms(i,1) = real( l, kind=KMAP)
          alms(i,2) = real( m, kind=KMAP)
       enddo
       i0 = i1 + 1_i8b
    enddo
    deallocate(lm)
    ! sanity check
    if (i0 /= npix) then
       print*,'something wrong during piece-wise reading'
       call fatal_error
    endif

    !     close the file
    call ftclos(unit, status)


    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)
    return
  end subroutine read_alms_KLOAD
  !**************************************************************************
  SUBROUTINE read_bintod_KLOAD(filename, tod, npixtot, ntods, firstpix, nullval, anynull, &
                          header, extno, units)
  !**************************************************************************
    !=======================================================================
    !     Read a FITS file
    !
    !     slightly modified to deal with vector column (ie TFORMi = '1024E')
    !     in binary table       EH/IAP/Jan-98
    !
    !     This routine is used for reading TODS by anafast.
    !     Modified to start at a given pix numb OD & RT 02/02
    !     Modified to handle huge array (npix_tot > 2^32) OD & EH 07/02
    !      2002-07-08 : bugs correction by E.H. 
    !      2007-01-31 : added units optional output
    !=======================================================================
    
    IMPLICIT NONE
    
    CHARACTER(LEN=*),               INTENT(IN)  :: filename
    INTEGER(I8B)   ,                INTENT(IN)  :: npixtot,firstpix
    INTEGER(I4B),                   INTENT(IN)  :: ntods
    REAL(KMAP), DIMENSION(0:,1:),   INTENT(OUT) :: tod
    REAL(KMAP),                     INTENT(OUT) :: nullval
    LOGICAL(LGT),                   INTENT(OUT) :: anynull
    character(len=*), dimension(1:),intent(out), optional :: header
    INTEGER(I4B),                   INTENT(IN),  OPTIONAL :: extno
    character(LEN=*), dimension(1:),intent(OUT), optional :: units

    
    integer(I4B) :: i, nl_header, len_header, nl_units, len_units
    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    INTEGER(I4B) :: npix_32 !,firstpix_32
    CHARACTER(LEN=80) :: comment
    LOGICAL(LGT) :: extend
    INTEGER(I4B) :: nmove, hdutype
    INTEGER(I4B) :: column, frow, itod
    INTEGER(I4B) :: datacode, repeat, width
    
    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat,felem
    CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform,tunit
    CHARACTER(LEN=20) :: extname
 
    INTEGER(I8B) :: q,iq,npix_tmp,firstpix_tmp, i0, i1
    
    !-----------------------------------------------------------------------
    status=0
    
    unit = 138
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    anynull = .FALSE.
    
    nl_header = 0
    if (present(header)) then
       nl_header = size(header)
       len_header = 80
    endif

    nl_units = 0
    if (present(units)) then
       nl_units = size(units)
       len_units = min(80,len(units(1))) ! due to SUN compiler bug
    endif

    readwrite=0
    CALL ftopen(unit,filename,readwrite,blocksize,status)
    IF (status .GT. 0) CALL printerror(status)
    !     -----------------------------------------
    
    !     determines the presence of image
    CALL ftgkyj(unit,'NAXIS', naxis, comment, status)
    IF (status .GT. 0) CALL printerror(status)
    
    !     determines the presence of an extension
    CALL ftgkyl(unit,'EXTEND', extend, comment, status)
    IF (status .GT. 0) status = 0 ! no extension : 
    !     to be compatible with first version of the code
    
    IF (naxis .GT. 0) THEN ! there is an image
       print*,'WARNING : Image is ignored in '//trim(filename)
    ENDIF
    IF (extend) THEN ! there is an extension

       nmove = +1
       if (present(extno)) nmove = +1 + extno
       CALL ftmrhd(unit, nmove, hdutype, status)
       !cc         write(*,*) hdutype

       call assert(hdutype==2, 'this is not a binary table')

       ! reads all the keywords
       CALL ftghbn(unit, MAXDIM, &
            &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
            &        status)

       IF (tfields .LT. ntods) THEN
          PRINT *,'found ',tfields,' tods in the file'
          PRINT *,'expected ',ntods
          call fatal_error
       ENDIF

       if (nl_header > 0) then
          header = ""
          status = 0
          call get_clean_header(unit, header, filename, status)
       endif

       if (nl_units > 0) then
          do i=1,nl_units
             units(i)(1:len_units) = 'unknown' ! default
          enddo
          do itod = 1, min(ntods, nl_units)
             units(itod)(1:len_units) = adjustl(tunit(itod))
          enddo
       endif

       ! finds the bad data value
!        if (KMAP == SP) CALL ftgkye(unit,'BAD_DATA',nullval,comment,status)
!        if (KMAP == DP) CALL ftgkyd(unit,'BAD_DATA',nullval,comment,status)
       call f90ftgky_(unit, 'BAD_DATA', nullval, comment, status)
       IF (status .EQ. 202) THEN ! bad_data not found
          if (KMAP == SP) nullval = s_bad_value ! default value
          if (KMAP == DP) nullval = d_bad_value ! default value
          status = 0
       ENDIF

       IF (npixtot .LT. nchunk_max) THEN

          DO itod = 1, ntods

             !parse TFORM keyword to find out the length of the column vector (repeat)
             CALL ftbnfm(tform(itod), datacode, repeat, width, status)
             frow = (firstpix)/repeat+1          ! 1 based 
             felem = firstpix-(frow-1)*repeat+1  ! 1 based 
             npix_32 = npixtot 

             !reads the columns
             column = itod
             CALL f90ftgcv_(unit, column, frow, felem, npix_32, nullval, &
                  &        tod(0:npix_32-1,itod), anynull, status)
          END DO

       ELSE

          q = (npixtot-1)/nchunk_max
          DO iq = 0,q
             IF (iq .LT. q) THEN
                npix_tmp = nchunk_max
             ELSE
                npix_tmp = npixtot - iq*nchunk_max
             ENDIF
             firstpix_tmp = firstpix + iq*nchunk_max
             npix_32 = npix_tmp
             i0 = firstpix_tmp-firstpix
             i1 = i0 + npix_tmp - 1_i8b

             DO itod = 1, ntods
                ! parse TFORM keyword to find out the length of the column vector
                CALL ftbnfm(tform(itod), datacode, repeat, width, status)
                frow = (firstpix_tmp)/repeat+1          ! 1 based 
                felem = firstpix_tmp-(frow-1)*repeat+1  ! 1 based 
                CALL f90ftgcv_(unit, itod, frow, felem, npix_32, nullval, &
                     &      tod(i0:i1,itod), anynull, status)
             END DO

          ENDDO

       ENDIF

    ELSE ! no image no extension, you are dead, man
       call fatal_error(' No image, no extension')
    ENDIF

    ! close the file
    CALL ftclos(unit, status)

    ! check for any error, and if so print out error messages
    IF (status .GT. 0) CALL printerror(status)

    RETURN

  END SUBROUTINE read_bintod_KLOAD
  !=======================================================================
  
  !======================================================================================
  SUBROUTINE write_bintabh_KLOAD(tod, npix, ntod, header, nlheader, filename, extno, firstpix, repeat)
    !======================================================================================

    ! =================================================================================
    !     Create a FITS file containing a binary table extension in the first extension
    !
    !     Designed to deal with Huge file, (n_elements > 2^31)
    !
    !     OPTIONAL NEW PARAMETERS:
    !     firstpix : position in the file of the first element to be written (starts at 0) 
    !                default value =0
    !                8-byte integer
    !                if NE 0 then suppose that the file already exists
    !
    !     repeat   : length of vector per unit rows and columns of the first binary extension
    !                default value = 12000 (\equiv 1 mn of PLANCK/HFI data)
    !                4-byte integer
    ! 
    !     OTHER PARAMETERS
    !     unchanged with respect to the standard write_bintab of the HEALPIX package except 
    !     npix which is an 8-byte integer
    !
    !     Adapted from write_bintab
    !                                           E.H. & O.D. @ IAP 07/02
    !
    !     Requires a compilation in 64 bits of the CFITSIO 
    !     Note that the flag -D_FILE_OFFSETS_BITS=64 has to be added 
    !         (cf page CFITIO 2.2 User's guide  Chap 4, section 4-13)
    ! 
    ! 2002-07-08 : bugs correction by E.H. 
    !    (uniform use of firstpix_tmp, introduction of firstpix_chunk)
    ! 2015-04-28: better handling of repeat (suggested by R. Keskitalo)
    !==========================================================================================

    USE healpix_types
    IMPLICIT NONE

    INTEGER(I8B)     , INTENT(IN)           :: npix
    INTEGER(I8B)     , INTENT(IN), OPTIONAL :: firstpix
    INTEGER(I4B)     , INTENT(IN), OPTIONAL :: repeat
    INTEGER(I4B)     , INTENT(IN)           :: ntod,nlheader
    REAL(KMAP)       , INTENT(IN), DIMENSION(0:npix-1,1:ntod) :: tod
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader)      :: header
    CHARACTER(LEN=*),  INTENT(IN)           :: filename
    INTEGER(I4B)    , INTENT(IN)     , OPTIONAL :: extno

    INTEGER(I4B) :: status,unit,blocksize,bitpix,naxis,naxes(1),repeat_fits
    INTEGER(I4B) :: i,npix_32
    LOGICAL(LGT) :: simple,extend
    CHARACTER(LEN=80) :: comment, ch
    integer(I8B) :: repeat_tmp

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B)      :: nrows,tfields,varidat
    INTEGER(I4B)      :: frow,felem,colnum,readwrite,width,datacode,hdutype
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    CHARACTER(LEN=10) :: card
    CHARACTER(LEN=2)  :: stn
    INTEGER(I4B)      :: itn  

    real(KMAP), dimension(:), allocatable :: padding
    integer(I8B) :: lastpix
    integer(I4B) :: lengap

    INTEGER(I4B)      :: extno_i
    character(len=filenamelen) :: sfilename
    INTEGER(I8B) :: q,iq,npix_tmp,firstpix_tmp,firstpix_chunk, i0, i1
    character(len=1) :: pform
    character(len=*), parameter :: code='write_bintabh'
    !-----------------------------------------------------------------------

    if (KMAP == SP) pform = 'E'
    if (KMAP == DP) pform = 'D'

    IF (.NOT. PRESENT(repeat) ) THEN 
       repeat_tmp = 1
       if (mod(npix,1024_i8b) == 0) then
          repeat_tmp = 1024
       elseif (npix >= 12000) then
          repeat_tmp = 12000 
       endif
    ELSE 
       repeat_tmp = repeat
    ENDIF
    IF (.NOT. PRESENT(firstpix) ) THEN 
       firstpix_tmp = 0 
    ELSE 
       firstpix_tmp = firstpix
    ENDIF

    extno_i = 0
    if (present(extno)) extno_i = extno

    status=0
    unit = 137
    blocksize=1

    ! remove the leading '!' (if any) when reopening the same file
    sfilename = adjustl(filename)
    if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)

    ! create the new empty FITS file

    IF (firstpix_tmp .EQ. 0) THEN

       if (extno_i == 0) then 
          CALL ftinit(unit,filename,blocksize,status)
          if (status > 0) call fatal_error("Error while creating file " &
               & //trim(filename) &
               & //". Check path and/or access rights.")

          ! -----------------------------------------------------
          ! Initialize parameters about the FITS image
          simple=.TRUE.
          bitpix=32     ! integer*4
          naxis=0       ! no image
          naxes(1)=0
          extend=.TRUE. ! there is an extension

          !     ----------------------
          !     primary header
          !     ----------------------
          !     write the required header keywords
          CALL ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

          !     writes supplementary keywords : none

          !     write the current date
          CALL ftpdat(unit,status) ! format ccyy-mm-dd

       !     ----------------------
       !     image : none
       !     ----------------------

       !     ----------------------
       !     extension
       !     ----------------------
       else

          !*********************************************
          !     reopen an existing file and go to the end
          !*********************************************
          call ftopen(unit,sfilename,1_i4b,blocksize,status)
          call ftmahd(unit,1_i4b+extno_i,hdutype,status)

       endif

       !     creates an extension
       CALL ftcrhd(unit, status)

       !     writes required keywords
       ! if (npix < repeat_tmp) repeat_tmp = npix ! 2015-04-28

       ! nrows    = npix / repeat_tmp + 1 ! naxis1
       nrows    = (npix - 1_i8b) / repeat_tmp + 1_i4b ! 2015-04-28
       tfields  = ntod
       WRITE(ch,'(i8)') repeat_tmp
!       tform(1:ntod)  = TRIM(ADJUSTL(ch))//pform ! does not work with Ifort, EH, 2006-04-04
       ch = TRIM(ADJUSTL(ch))//pform
       tform(1:ntod)  = ch

!        IF (npix .LT. repeat_tmp) THEN  ! 2015-04-28
!           nrows = npix
!           ch = '1'//pform
!           tform(1:ntod) = ch
!        ENDIF
       ttype(1:ntod) = 'simulation'   ! will be updated
       tunit(1:ntod) = ''      ! optional, will not appear

       extname  = ''      ! optional, will not appear
       varidat  = 0

       CALL ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
            &     extname, varidat, status)

       !     write the header literally, putting TFORM1 at the desired place
       if (KMAP == SP) comment = 'data format of field: 4-byte REAL'
       if (KMAP == DP) comment = 'data format of field: 8-byte REAL'
       DO i=1,nlheader
          card = header(i)
          IF (card(1:5) == 'TTYPE') THEN ! if TTYPE1 is explicitely given
             stn = card(6:8)
             READ(stn,'(i3)') itn
             ! discard at their original location:
             call ftdkey(unit,'TTYPE'//stn,status)  ! old TTYPEi and
             status = 0
             call ftdkey(unit,'TFORM'//stn,status)  !     TFORMi
             status = 0
             if (itn <= tfields) then ! only put relevant information 2008-08-27
                call putrec(unit,header(i), status)    ! write new TTYPE1
                status = 0
                call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! and write new TFORM1 right after
                !CALL ftmcrd(unit,'TTYPE'//stn,'COMMENT',status)  ! old TTYPEi and 
                !CALL ftmcrd(unit,'TFORM'//stn,'COMMENT',status)  !     TFORMi
                !CALL ftprec(unit,header(i), status)           ! write new TTYPE1
                !CALL ftpkys(unit,'TFORM'//stn,tform(1),comment,status) ! and write new TFORM1 right after
             endif
          ELSEIF (header(i).NE.' ') THEN
             call putrec(unit,header(i), status)
!              CALL ftprec(unit,header(i), status)
          ENDIF
          status = 0
       ENDDO

    ELSE
       ! The file already exists
       readwrite=1
       CALL ftopen(unit,sfilename,readwrite,blocksize,status)
       CALL ftmahd(unit,2_i4b+extno_i,hdutype,status) 

       CALL ftgkys(unit,'TFORM1',tform(1),comment,status)
       CALL ftbnfm(tform(1),datacode,repeat_fits,width,status)

       IF (repeat_tmp .NE. repeat_fits) THEN
          if (present(repeat)) then 
             write(*,'(a)') code//'> WARNING: In file '//trim(sfilename)
             write(*,'(a)') &
                  & code//'>  user provided REPEAT value (' // &
                  & trim(adjustl(string(repeat_tmp)))       // &
                  & ') differs from value read from file (' // &
                  & trim(adjustl(string(repeat_fits)))      // &  
                  & ').'
             write(*,'(a)') code//'> The latter will be used.'
!           else
!              write(*,'(a,i0.0,a)') &
!                   & code//'> WARNING: REPEAT value read from file (', &
!                   & repeat_fits, &
!                   & ') will be used.'
          endif
          repeat_tmp = repeat_fits
       ENDIF

    ENDIF


    IF (npix .LT. nchunk_max) THEN ! data is small enough to be written in one chunk

       frow = (firstpix_tmp)/repeat_tmp + 1
       felem = firstpix_tmp-(frow-1)*repeat_tmp + 1
       npix_32 = npix 

       DO colnum = 1, ntod
          call f90ftpcl_(unit, colnum, frow, felem, npix_32, tod(0:npix_32-1,colnum), status)
       END DO

    ELSE ! data has to be written in several chunks

       q = (npix-1)/nchunk_max
       DO iq = 0,q
          IF (iq .LT. q) THEN
             npix_tmp = nchunk_max
          ELSE
             npix_tmp = npix - iq*nchunk_max
          ENDIF
          i0 = iq*nchunk_max
          i1 = i0 + npix_tmp - 1_i8b
          firstpix_chunk = firstpix_tmp + i0
          frow  = (firstpix_chunk)/repeat_tmp + 1
          felem =  firstpix_chunk-(frow-1)*repeat_tmp + 1
          npix_32 = npix_tmp
          DO colnum = 1, ntod
             call f90ftpcl_(unit, colnum, frow, felem, npix_32, &
                  &          tod(i0:i1, colnum), status)
          END DO
       ENDDO

    ENDIF

    ! pad entry if necessary ! 2015-04-28
    lastpix = firstpix_tmp + npix  ! number of pixels written above
    lengap = modulo(lastpix, repeat_tmp) ! remaining gap
    if (lengap > 0) then
       firstpix_tmp = lastpix
       npix_32 = repeat_tmp - lengap
       frow    = (firstpix_tmp)/repeat_tmp + 1
       felem   =  firstpix_tmp-(frow-1)*repeat_tmp + 1
       allocate(padding(0:npix_32-1))
       if (KMAP == SP) padding(:) = HPX_SBADVAL
       if (KMAP == DP) padding(:) = HPX_DBADVAL
       do colnum = 1, ntod
          call f90ftpcl_(unit, colnum, frow, felem, npix_32, padding, status)
       enddo
       deallocate(padding)
    endif

    ! ----------------------
    ! close and exit
    ! ----------------------

    ! close the file and free the unit number
    CALL ftclos(unit, status)

    ! check for any error, and if so print out error messages
    IF (status .GT. 0) CALL printerror(status)

    RETURN

  END SUBROUTINE write_bintabh_KLOAD
  ! ==============================================================================

!******************************************************************************
!---------------------------------------
!  reads a FITS file containing a list of 
!  ring-based or pixel-based quadrature weights
!  and turns it into a (ring-ordered) full sky map
!
! adapted from unfold_weights.pro
! 2018-05-25
!---------------------------------------
  subroutine unfold_weightsfile_KLOAD(w8file, w8map)

    USE pix_tools,      only: nside2npix, nside2npweights

    character(len=*), intent(in)                  :: w8file
    real(KMAP),       intent(out), dimension(0:)  :: w8map
    real(KMAP),       allocatable, dimension(:,:) :: w8list
    integer(i4b)                :: nside, status, won
    integer(i8b)                :: nfw8, npw8, nrw8
    character(len=*), parameter :: code = 'unfold_weightsfile'

    nfw8 = getsize_fits(w8file, nside=nside)
    npw8 = nside2npweights(nside)
    nrw8 = 2*nside

    won = 0
    if (nfw8 == nrw8) won = 1
    if (nfw8 == npw8) won = 2
    if (won == 0) then
       print*,'Weights file = '//trim(w8file)
       print*,'contains ',nfw8,' weights'
       print*,'for Nside    = ',nside
       print*,'Expected either ',nrw8,' or ',npw8
       call fatal_error
    endif

    allocate(w8list(0:nfw8-1,1:1), stat=status)
    call assert_alloc(status,code,"w8list")
    call input_map(w8file, w8list, nfw8, 1)
    call unfold_weightslist(nside, won, w8list(:,1), w8map)
    deallocate(w8list)
    
    return
  end subroutine unfold_weightsfile_KLOAD
!---------------------------------------
!  turns a list of ring-based or pixel-based quadrature weights 
!  into a (ring-ordered) full sky map
!
! adapted from unfold_weights.pro
! 2018-05-18
! 2018-09-12: promoted qpix to I8B to avoid consistency problems during compilation with g95  
!---------------------------------------
  subroutine unfold_weightslist_KLOAD(nside, won, w8list, w8map)

    USE pix_tools,      only: nside2npix, nside2npweights
    USE long_intrinsic, only: long_size

    integer(i4b),            intent(in)  :: nside, won
    real(KMAP), dimension(0:), intent(in)  :: w8list
    real(KMAP), dimension(0:), intent(out) :: w8map

    integer(i8b) :: np, npix
    integer(i8b) :: nf, nw8, pnorth, psouth, vpix, qp4, p, qpix
    integer(i4b) :: ring, odd, shifted, rpix, wpix, j4, n4, it

    ! test nside
    npix = nside2npix(nside)
    if (npix <= 0) then 
       print*,'Unvalid Nside = ',nside
       call fatal_error
    endif

    ! test won
    if (won < 1 .or. won > 2) then
       print*,'Expected either 1 or 2, got ',won
       call fatal_error
    endif

    ! test input list size
    nf  = long_size(w8list)
    if (won == 1) then
       nw8 = 2 * nside
    else
       nw8 = nside2npweights(nside)
    endif
    if (nf /= nw8) then
       print*,'Expected in input weight list',nw8
       print*,'got ',nf
       call fatal_error
    endif

    ! test output map size
    np = long_size(w8map)
    if (np /= npix) then
       print*,'Expected in output weight map',npix
       print*,'got ',np
       call fatal_error
    endif

    ! do actual unfolding
    if (won == 1) then

       pnorth = 0_i8b
       n4 = 4 * nside
       do ring=1,n4-1                ! loop on all rings
          it = min(ring, n4 - ring)  ! ring index, counting from closest pole
          qp4= 4_i8b * min(it, nside)    ! pixels / ring
          w8map(pnorth:pnorth+qp4-1) = w8list(it-1)
          pnorth = pnorth + qp4
       enddo

    else
       
       pnorth = 0_i8b            ! position in expanded weights
       vpix   = 0_i8b            ! position in compress list
       do ring=0, 2*nside-1
           qpix    = min(ring+1, nside) ! 1/4 of number of pixels per ring
           shifted = 0
           if (ring < (nside-1) .or. iand(ring+nside,1_i4b) == 1_i4b) shifted = 1
           odd     = iand(qpix,1_i8b)
           qp4     = 4_i8b*qpix       ! number of pixels per ring
           ! fill the weight map
           do p=0,qp4-1
              j4 = mod(p, qpix) ! g95: p and qpix must be of same type
              rpix = min(j4, qpix - shifted - j4) ! seesaw
              w8map(pnorth+p) = w8list(vpix + rpix)
           enddo
       
           if (ring < 2*nside-1) then  ! south part (except equator)
               psouth     = npix - pnorth - qp4
               w8map(psouth:psouth+qp4-1) = w8map(pnorth:pnorth+qp4-1)
           endif
           ! locations on next ring
           pnorth  = pnorth + qp4
           wpix    = (qpix+1)/2  + 1 - ior(odd, shifted)
           vpix    = vpix + wpix
       enddo
    endif

    ! add 1 to get final weight
    w8map = w8map + 1.0_KMAP

    return
  end subroutine unfold_weightslist_KLOAD

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!--------------------------------------------------------------
!
! generic body of the subroutines remove_dipole_*
! to be inserted as is in pix_tools.f90
!
! 2008-02-03: added weights; check that ordering is in [1,2]
! 2008-06-15: accepts Nside>8192
! 2010-04-21: removed unnecessary warnings on mask and weight by 
!    raising threshold from 1 to 11
!
!--------------------------------------------------------------
    integer(i4b), parameter :: MKD = I8B
    ! dummy
    integer(kind=i4b),                  intent(in)    :: nside
    integer(kind=i4b),                  intent(in)    :: ordering, degree
    real   (kind=DP),   dimension(0:),  intent(out)   :: multipoles
!    real   (kind=DP),                   intent(in)    :: cos_theta_cut
    real   (kind=DP),   dimension(1:),  intent(in)    :: zbounds
    real   (kind=KMAP), dimension(0:),  intent(inout) :: map
    real   (kind=KMAP),                 intent(in), optional :: fmissval
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: mask
    real   (kind=KMAP), dimension(0:),  intent(in), optional :: weights
    ! local
    real   (kind=KMAP)                :: fmiss_effct
    integer(kind=i4b)                 :: n_mult, n_mult1
    integer(kind=i4b)                 :: i
    logical(lgt)                      :: dodipole, do_mask, do_weights
    real(kind=dp)                     :: flag, temp, wmin
    real(kind=dp), dimension(1:3)     :: vec
    real(kind=dp), dimension(0:3)     :: b, wdiag
    real(kind=dp), dimension(0:3,0:3) :: mat, umat, vmat, imat
    real(kind=dp), dimension(0:3)     :: dmultipoles, tmpvec
    real(kind=dp)                     :: theta1, theta2
    integer(kind=MKD)                 :: ipix, npix, ncpix, nbad
    integer(kind=MKD)                 :: ncp8
    integer(kind=MKD), dimension(:), allocatable :: cut_pixel8
    integer(kind=I4B)                 :: ncp4
    integer(kind=I4B), dimension(:), allocatable :: cut_pixel4
    !============================================================

    npix = nside2npix(nside)
    multipoles = 0.0_dp
    fmiss_effct = fbad_value
    if (present(fmissval)) fmiss_effct = fmissval

    do_mask = .false.
    if (present(mask)) then
       if (size(mask) == size(map)) then
          do_mask = .true.
       else
          if (size(mask) > 11) print*,'WARNING: '//code//' mask ignored'
       endif
    endif

    do_weights = .false.
    if (present(weights)) then
       if (size(weights) == size(map)) then
          do_weights = .true.
       else
          if (size(weights) > 11) print*,'WARNING: '//code//' weights ignored'
       endif
    endif

    if (ordering < 1 .or. ordering > 2) then
       print*,code//': ordering should be one of 1 (RING) or 2 (NESTED)'
       print*,'       it is: ', ordering
       print*,code//"> ABORT ! "
       call fatal_error       
    endif

    if (degree == 0) then
       print*," No monopole nor dipole removal"
       return
    elseif (degree == 1) then
       dodipole = .false.
    else if (degree == 2) then
       dodipole = .true.
    else
       print*,code//"> degree can only be "
       print*,"      1: monopole (l=0) removal or "
       print*,"      2: monopole and dipole (l=0,1) removal"
       print*,code//"> ABORT ! "
       call fatal_error
    endif

    n_mult = (degree)**2
    n_mult1 = size(multipoles)
    if (n_mult1 < n_mult) then 
       print*,'WARNING: '//code//' multipoles is not large enough to accomodate results:'
       print*, 'size=',n_mult1, ';   needs:',n_mult
       n_mult = n_mult1
    endif

    !----------------------------------------------
    ! flag out pixels excluded by cut
    !----------------------------------------------
    if (zbounds(2) <= zbounds(1)) then ! remove one strip
       ncpix = npix * (zbounds(1)-zbounds(2))/2. * 1.1 + 10* nside
    else ! remove 2 strips
       ncpix = npix * (2.0 + zbounds(1)-zbounds(2))/2 * 1.1 + 10*nside
    endif
    theta1 = acos(zbounds(1)) ; theta2 = acos(zbounds(2))
    if (nside <= ns_max4) then
       allocate(cut_pixel4(0:ncpix))
       call query_strip(nside, theta1, theta2, cut_pixel4, ncp4, nest=ordering-1, inclusive=0)
       map(cut_pixel4(0:ncp4-1)) = fmiss_effct
       deallocate(cut_pixel4)
    else
       allocate(cut_pixel8(0:ncpix))
       call query_strip(nside, theta1, theta2, cut_pixel8, ncp8, nest=ordering-1, inclusive=0)
       map(cut_pixel8(0:ncp8-1)) = fmiss_effct
       deallocate(cut_pixel8)
    endif
    !----------------------------------------------
    ! generate least square linear system
    !----------------------------------------------
    mat = 0.0_dp
    b   = 0.0_dp
    nbad = 0_MKD
    do ipix = 0, npix-1

       ! flag = 1 for good values
       !      = 0 for bad values
       flag = 1.0_dp
       if (do_weights) flag = flag * weights(ipix)

       if ( abs(map(ipix) - fmiss_effct) <= abs(1.e-5*fmiss_effct) ) then
          nbad = nbad + 1_MKD
          goto 20
       endif
       if (do_mask) then
          if (abs(mask(ipix)) <= 1.e-10) then
             nbad = nbad + 1_MKD
             goto 20
          endif
       endif

       if (dodipole) then
          ! computes dipole basis functions
          ! pixel -> vector
          if (ordering == 1) call pix2vec_ring( nside, ipix, vec)
          if (ordering == 2) call pix2vec_nest( nside, ipix, vec)
       endif

       ! construct vector T*(1,x,y,z)
       temp = map(ipix) * flag
       b(0) = b(0) + temp
       if (dodipole) then
          ! computes dipole basis functions
          b(1:3) = b(1:3) + temp * vec(1:3)
       endif

       ! construct matrix (1,x,y,z)#(1,x,y,z)
       mat(0,0) = mat(0,0) + flag
       if (dodipole) then
          do i = 1, 3
             mat(i,0)   = mat(i,0)   + vec(i) * flag
             mat(i,1:3) = mat(i,1:3) + vec(i) * vec(1:3) * flag
          enddo
       endif

20     continue
    enddo
    print*,'Excluding ',nbad,' pixels when computing monopole and/or dipole'

    ! first row = first column (and vice versa)
    mat(0,1:3) = mat(1:3,0)


    !----------------------------------------------
    ! solve system    mat . (mono, dip_x, dip_y, dip_z) = b
    !----------------------------------------------

    if (dodipole) then
       ! SVD decomposition
       umat = mat
       call dsvdcmp(umat, 4, 4, 4, 4, wdiag, vmat)
       ! thresholding
       wmin = maxval(wdiag)* 1.e-6_dp
       where (wdiag < wmin)
          wdiag = 0.0_dp
       end where
       ! back substitution
       call dsvbksb(umat, wdiag, vmat, 4, 4, 4, 4, b, dmultipoles)

! 9000   format(4(1pe13.5))
!        print*,'-------------'
!        write(*,9000) mat

!        print*,'  ------'
!        do i=0,3
!           tmpvec = 0.0_dp
!           tmpvec(i) = 1.0_dp
!           call dsvbksb(umat, wdiag, vmat, 4, 4, 4, 4, tmpvec, imat(0:3,i))
!        enddo
!        write(*,9000) imat

!        print*,'-------------'
!        write(*,9000) matmul(imat,mat)
!        imat = imat+transpose(imat)
!        imat = imat * 0.5d0
!        print*,'  ------'
!        write(*,9000) matmul(imat,mat)
!        print*,'-------------'

    else
       dmultipoles(0) = b(0) / mat(0,0) ! average temperature
    endif

    !----------------------------------------------
    ! remove monopole and dipole
    !----------------------------------------------
    do ipix = 0, npix-1

!        if ( abs(map(ipix) - fmiss_effct) < 1.e-5*fmiss_effct ) goto 10
       if ( abs(map(ipix) - fmiss_effct) < abs(1.e-5*fmiss_effct) ) goto 10

       map(ipix) = map(ipix) - dmultipoles(0)
       if (dodipole) then
          ! computes dipole basis functions
          ! pixel -> vector
          if (ordering == 1) call pix2vec_ring( nside, ipix, vec)
          if (ordering == 2) call pix2vec_nest( nside, ipix, vec)
          map(ipix) = map(ipix) - SUM( dmultipoles(1:3) * vec(1:3))
       endif

10     continue

    enddo

    multipoles(0:n_mult-1) = dmultipoles(0:n_mult-1)

    return

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module fitstools
  !
  ! module fitstools
  !  toward version 2.1
  !
  ! addition of read_fits_cut4 and write_fits_cut4
  ! improvement of input_map (addition of header output)
  ! improvement of read_asctab (more flexible on number of columns)
  ! removal of ask_* routines
  ! addition of get_clean_header
  ! addition of optional keyword units to input_map, read_fits_cut4, read_bintab
  ! 
  ! cleaning of the mapping between (l,m) <-> lm = l*l+l+m+1
  !  to remove round-off errors
  !
  ! v1.2_p01 : input_map, read_bintab : fix SUN compiler bug
  !            getsize_fits           : correct handling of ASCII table
  ! v1.2_p02   getsize_fits : correct handling of files with more than 2^31 elements
  !            read_bintab  : correction to array argument in ftgcve
  !            2004-Feb: 
  !               modification of dump_alms to deal with large arrays on MacOsX
  !               modification of npix in dump_alms
  !               modification of read_conbintab to deal with large arrrays
  !
  !  read_asctab : removal of nl_header from arguments list
  !
  ! 2004-07-21 : overload (SP/DP) output_map and write_bintab
  !   write_dbintab has been renamed write_plm
  ! 2004-11-01 : added function getnumext_fits
  !              added extno keyword to function getsize_fits
  ! 2004-12-22 : overload (SP/DP) read_asctab, dump_alms
  ! 2005-03-03 : added COORDSYS optional output to getsize_fits
  ! 2006-04-04 : edited to avoid concatenation problem in TFORMs (write_plm and write_bintabh with Ifort 9)
  ! 2007-02-16 : added EXTNO and POLARISATION keywords to Write_fits_cut4
  ! 2007-04-04 : close file on exit of getnumext_fits
  ! 2007-05-10 : increased maxdim (max number of columns per extension) from 20 to 40
  ! 2007-10-01 : getsize_fits returns -1 in case of error
  ! 2008-08-27 : in dump_alms and write_alms and write_*tab*: 
  !  do not write TTYPE# and TFORM# in excess of # of fields in the file
  ! 2010-11-23: implemented support for large (>2^31-1 pixel) map IO (ie, Nside > 8192)
  !             alm related IO is still limited to l<46340
  ! 2013-12-13 : increased MAXDIM from 40 to MAXDIM_TOP
  ! 2014-05-02: fixed problem with keywords having a long string value
  ! 2016-08-16: debugged input_map on cut4 FITS files with multi-HDU polarized data
  ! 2018-05-22: added unfold_weightsfile and unfold_weightslist
  ! -------------------------------------------------------------
  !
  ! --------------------------- from include file (see fits_template.f90)
  ! subroutine input_map
  ! subroutine read_bintab
  ! subroutine read_conbintab
  ! subroutine write_bintab (write_bintab4 and write_bintab8)
  ! subroutine write_asctab
  ! subroutine dump_alms
  ! subroutine write_alms
  ! subroutine read_alms
  ! subroutine read_bintod
  ! subroutine write_bintabh
  ! subroutine unfold_weights
  ! ----------------------------------
  !
  ! subroutine read_fits_cut4               ?
  ! subroutine write_fits_cut4              ?
  ! subroutine fits2cl                       NA    accepts extname addressing (eg myfile.fits[beam])
  ! subroutine read_asctab                   NA
  !
  ! subroutine output_map                  (4/8)
  ! subroutine write_dbintab   : Obsolete
  ! subroutine write_plm                    NA
  !
  ! subroutine alms2fits                    NotYet
  ! subroutine fits2alms                    NotYet
  ! subroutine input_tod                   (8)
  ! subroutine read_dbintab                NA
  !                                       
  ! subroutine printerror                  NA
  !                                       
  ! subroutine read_par                    NA
  ! function getnumext_fits                NA
  ! function getsize_fits                  (8)    accepts extname addressing (eg myfile.fits[beam])
  ! function number_of_alms                NotYet
  !                                       
  ! subroutine putrec                      NA
  ! subroutine get_clean_header            NA
  !
  ! subroutine check_input_map
  !
  use healpix_types
  use misc_utils, only : fatal_error, assert, assert_alloc, strupcase, string
  implicit none

  real(kind=SP),     private, parameter :: s_bad_value = HPX_SBADVAL
  real(kind=DP),     private, parameter :: d_bad_value = HPX_DBADVAL
  integer(kind=I4B), private, parameter :: i_bad_value = -1637500000
  integer(I4B) ,     private, parameter :: nchunk_max  = 12000
  integer(I4B),      private, parameter :: MAXDIM_TOP  = 199 ! < 999

!   interface read_fits_cut4
!      module procedure read_fits_cut4_s,read_fits_cut4_d
!   end interface

!   interface write_fits_cut4
!      module procedure write_fits_cut4_s,write_fits_cut4_d
!   end interface


  interface input_map
#ifdef NO64BITS
     module procedure input_map8_s,input_map8_d
#else
     module procedure input_map8_s,input_map8_d, input_map4_s,input_map4_d
#endif
  end interface

  interface output_map
     module procedure output_map_s, output_map_d
  end interface

  interface write_plm
#ifdef NO64BITS
     module procedure write_plm8
#else
     module procedure write_plm8, write_plm4
#endif
  end interface

  interface write_bintab
#ifdef NO64BITS
     module procedure write_bintab8_s, write_bintab8_d
#else
     module procedure write_bintab8_s, write_bintab8_d, write_bintab4_s, write_bintab4_d
#endif
  end interface

  interface read_bintab
#ifdef NO64BITS
     module procedure read_bintab8_s, read_bintab8_d
#else
     module procedure read_bintab8_s, read_bintab8_d, read_bintab4_s, read_bintab4_d
#endif
  end interface

  !
  interface input_tod
     module procedure input_tod_s,input_tod_d
  end interface

  interface read_bintod
     module procedure read_bintod_s,read_bintod_d
  end interface

  interface write_bintabh
     module procedure write_bintabh_s,write_bintabh_d
  end interface
  !
  interface write_asctab
     module procedure write_asctab_s, write_asctab_d
  end interface

  interface fits2cl
     module procedure fits2cl_s, fits2cl_d
  end interface

  interface read_asctab
     module procedure read_asctab_s, read_asctab_d, read_asctab_v12s, read_asctab_v12d
  end interface
  !
  interface fits2alms
     module procedure fits2alms_s, fits2alms_d
  end interface

  interface alms2fits
     module procedure alms2fits_s, alms2fits_d
  end interface

  interface read_conbintab
     module procedure read_conbintab_s, read_conbintab_d
  end interface

  interface dump_alms
     module procedure dump_alms_s, dump_alms_d
  end interface

  interface read_alms
     module procedure read_alms_s, read_alms_d
  end interface

  interface write_alms
     module procedure write_alms_s, write_alms_d
  end interface

  interface f90ftpcl_
     module procedure f90ftpcle, f90ftpcld
  end interface

  interface f90ftgcv_
     module procedure f90ftgcve, f90ftgcvd
  end interface

  interface f90ftgpv_
     module procedure f90ftgpve, f90ftgpvd
  end interface

  interface f90ftgky_
     module procedure f90ftgkye, f90ftgkyd
  end interface

  interface map_bad_pixels
     module procedure map_bad_pixels_s, map_bad_pixels_d
  end interface

  interface unfold_weightsfile
     module procedure unfold_weightsfile_s, unfold_weightsfile_d
  end interface

  interface unfold_weightslist
     module procedure unfold_weightslist_s, unfold_weightslist_d
  end interface

  private

  public :: read_fits_cut4, write_fits_cut4, & 
       & input_map, read_bintab,  &
       & output_map, write_bintab
  public :: write_plm
  public :: fits2cl, read_asctab, write_asctab
  public :: read_dbintab, write_dbintab
  public :: input_tod, write_bintabh
  public :: dump_alms, alms2fits, fits2alms, write_alms, read_alms, read_conbintab
  public :: printerror, read_par, getsize_fits, number_of_alms, getnumext_fits
  public :: putrec
  public :: check_input_map
  public :: unfold_weightsfile, unfold_weightslist

contains

  !-------------------------------------------------------------------------------
  ! generic interface F90FTPCL_ for FITSIO's FTPCLE and FTPCLD
  !           writes data in ASCTAB or BINTAB
  subroutine f90ftpcle(unit, colnum, frow, felem, np, data, status)
    integer(I4B), intent(in)  :: unit, colnum, frow, felem, np
    integer(I4B), intent(out) :: status
    real(SP),     intent(in), dimension(0:)  :: data
    call ftpcle(unit, colnum, frow, felem, np, data, status)
    return
  end subroutine f90ftpcle
  subroutine f90ftpcld(unit, colnum, frow, felem, np, data, status)
    integer(I4B), intent(in)  :: unit, colnum, frow, felem, np
    integer(I4B), intent(out) :: status
    real(DP),     intent(in), dimension(0:)  :: data
    call ftpcld(unit, colnum, frow, felem, np, data, status)
    return
  end subroutine f90ftpcld
  !-------------------------------------------------------------------------------
  ! generic interface F90FTGCV_ for FITSIO's FTGCVE and FTGCVD
  !           reads data from BINTAB
  subroutine f90ftgcve(unit, colnum, frow, felem, np, nullval, data, anynull, status)
    integer(I4B), intent(in)  :: unit, colnum, frow, felem, np
    integer(I4B), intent(out) :: status
    logical(LGT), intent(out) :: anynull
    real(SP),     intent(out), dimension(0:) :: data
    real(SP),     intent(in)                 :: nullval
    call ftgcve(unit, colnum, frow, felem, np, nullval, data, anynull, status)
    return
  end subroutine f90ftgcve
  subroutine f90ftgcvd(unit, colnum, frow, felem, np, nullval, data, anynull, status)
    integer(I4B), intent(in)  :: unit, colnum, frow, felem, np
    integer(I4B), intent(out) :: status
    logical(LGT), intent(out) :: anynull
    real(DP),     intent(out), dimension(0:) :: data
    real(DP),     intent(in)                 :: nullval
    call ftgcvd(unit, colnum, frow, felem, np, nullval, data, anynull, status)
    return
  end subroutine f90ftgcvd
  !-------------------------------------------------------------------------------
  ! generic interface F90FTGPV_ for FITSIO's FTGPVE and FTGPVD
  !           reads data from IMAGE
  subroutine f90ftgpve(unit, group, firstpix, np, nullval, data, anynull, status)
    integer(I4B), intent(in)  :: unit, group, firstpix, np
    integer(I4B), intent(out) :: status
    logical(LGT), intent(out) :: anynull
    real(SP),     intent(out), dimension(0:) :: data
    real(SP),     intent(in)                 :: nullval
    call ftgpve(unit, group, firstpix, np, nullval, data, anynull, status)
    return
  end subroutine f90ftgpve
  subroutine f90ftgpvd(unit, group, firstpix, np, nullval, data, anynull, status)
    integer(I4B), intent(in)  :: unit, group, firstpix, np
    integer(I4B), intent(out) :: status
    logical(LGT), intent(out) :: anynull
    real(DP),     intent(out), dimension(0:) :: data
    real(DP),     intent(in)                 :: nullval
    call ftgpvd(unit, group, firstpix, np, nullval, data, anynull, status)
    return
  end subroutine f90ftgpvd
  !-------------------------------------------------------------------------------
  ! generic interface F90FTGKY_ for FITSIO's FTGKYE and FTGKYD
  !           reads a keyword
  subroutine f90ftgkye(unit, keyword, value, comment, status)
    integer(I4B),     intent(in)  :: unit
    character(len=*), intent(in)  :: keyword
    integer(I4B),     intent(out) :: status
    character(len=*), intent(out) :: comment
    real(SP),         intent(out) :: value
    call ftgkye(unit, keyword, value, comment, status)
    return
  end subroutine f90ftgkye
  subroutine f90ftgkyd(unit, keyword, value, comment, status)
    integer(I4B),     intent(in)  :: unit
    character(len=*), intent(in)  :: keyword
    integer(I4B),     intent(out) :: status
    character(len=*), intent(out) :: comment
    real(DP),         intent(out) :: value
    call ftgkyd(unit, keyword, value, comment, status)
    return
  end subroutine f90ftgkyd
  !-------------------------------------------------------------------------------


  ! define routine with SP I/O
#include "fits_s_inc.f90"

  ! define routine with DP I/O
#include "fits_d_inc.f90"



  !=======================================================================
  subroutine read_fits_cut4(filename, npixtot, pixel, signal, n_obs, serror, header, units, extno)
    !=======================================================================
    !
    ! routine to read FITS file with 4 columns : PIXEL, SIGNAL, N_OBS, SERROR
    !
    ! read_fits_cut4(filename, npixtot, pixel, 
    !      [signal, n_obs, serror, header, units, extno])
    !=======================================================================
    integer(I4b), parameter :: KMAP = SP

    character(len=*),                   intent(in)              :: filename
    integer(I4B),                       intent(in)              :: npixtot
    integer(I4B), dimension(0:npixtot-1), intent(out)           :: pixel
    real(KMAP),   dimension(0:npixtot-1), intent(out), optional :: signal
    integer(I4B), dimension(0:npixtot-1), intent(out), optional :: n_obs
    real(KMAP),   dimension(0:npixtot-1), intent(out), optional :: serror
    character(len=*), dimension(1:),      intent(out), optional :: header
    character(len=*),                     intent(out), optional :: units
    integer(I4B),                         intent(in),  optional :: extno

    integer(I4B) :: obs_npix

    integer(I4B), parameter :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    integer(I4B) :: blocksize, datacode
    integer(I4B) :: firstpix, frow, hdutype
    integer(I4B) :: naxis, nfound, nmove, npix, nrows
    integer(I4B) :: readwrite, status, tfields, unit, varidat, width
    integer(I4B) :: repeat, repeat1, repeat2
    logical(LGT) :: anynull, extend
    character(len=20), dimension(MAXDIM) :: ttype, tform, tunit
    character(len=20) :: extname
    character(len=80) :: comment
    real(KMAP) :: nullval
    !=======================================================================

    status=0

    unit = 150
    nfound = -1
    anynull = .false.

    readwrite=0
    call ftopen(unit,filename,readwrite,blocksize,status)
    if (status > 0) call printerror(status)

    !     determines the presence of image
    call ftgkyj(unit,'NAXIS', naxis, comment, status)
    if (status > 0) call printerror(status)
    if (naxis > 0) then ! there is an image
       print*,'an image was found in the FITS file '//filename
       print*,'... it is ignored.'
    endif

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    if (status > 0) then 
       print*,'extension expected and not found in FITS file '//filename
       print*,'abort code'
       call fatal_error
    endif

    nmove = +1
    if (present(extno)) nmove = +1 + extno
    call ftmrhd(unit, nmove, hdutype, status)

    call assert (hdutype==2, 'this is not a binary table')

    ! reads all the FITS related keywords
    call ftghbn(unit, MAXDIM, &
         &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
         &        status)
    if (tfields < 4) then
       print*,'Expected 4 columns in FITS file '//filename
       print*,'found ',tfields
       if (tfields < 2) call fatal_error
       if (.not.  (trim(ttype(1)) == 'PIXEL' &
            & .or. trim(ttype(1)) == 'PIX'  ) ) call fatal_error
    endif

    if (present(header)) then 
       header = ""
       status = 0
       call get_clean_header(unit, header, filename, status)
    endif

    if (present(units)) then 
       ! the second column contains the SIGNAL, for which we 
       ! already read the units from the header
       units = adjustl(tunit(2))
    endif

    !        finds the bad data value
!     if (KMAP == SP) CALL ftgkye(unit,'BAD_DATA',nullval,comment,status)
!     if (KMAP == DP) CALL ftgkyd(unit,'BAD_DATA',nullval,comment,status)
    call f90ftgky_(unit, 'BAD_DATA', nullval, comment, status)
    if (status == 202) then ! bad_data not found
       if (KMAP == SP) nullval = s_bad_value ! default value
       if (KMAP == DP) nullval = d_bad_value ! default value
       status = 0
    endif

    frow = 1
    firstpix = 1
    !        parse TFORM keyword to find out the length of the column vector
    repeat1 = 1
    repeat2 = 1
    call ftbnfm(tform(1), datacode, repeat1, width, status)
    if (tfields > 1) call ftbnfm(tform(2), datacode, repeat2, width, status)
    repeat = max(repeat1, repeat2)

    call ftgkyj(unit,'OBS_NPIX',obs_npix,comment,status)
    if (status == 202) then ! obs_npix not found
       obs_npix = nrows * repeat
       status = 0
    endif

    npix = min(npixtot, obs_npix)
    call ftgcvj(unit, 1_i4b, frow, firstpix, npix, i_bad_value, pixel(0), anynull, status)
    if (present(signal)) then
       call f90ftgcv_(unit, 2_i4b, frow, firstpix, npix, nullval, signal(0:npix-1), anynull, status)
    endif
    if (tfields >= 3 .and. present(n_obs)) &
         & call ftgcvj(unit, 3_i4b, frow, firstpix, npix, i_bad_value, n_obs(0), anynull, status)
    if (tfields >= 4 .and. present(serror)) then
       call f90ftgcv_(unit, 4_i4b, frow, firstpix, npix, nullval, serror(0:npix-1), anynull, status)
    endif

    !     close the file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine read_fits_cut4

  !=======================================================================
  subroutine write_fits_cut4(filename, obs_npix, pixel, signal, n_obs, serror, &
       &                     header, coord, nside, order, units, extno, polarisation)
    !=======================================================================
    ! writes a fits file for cut sky data set with 4 columns:
    !  PIXEL, SIGNAL, N_OBS, SERROR
    ! 
    ! write_fits_cut4(filename, obs_npix, pixel, signal, n_obs, serror
    !         [, header, coord, nside, order, units, extno, polarisation])
    !=======================================================================
    use pix_tools, only: nside2npix
    integer(I4b), parameter :: KMAP = SP

    character(len=*), intent(in) :: filename
    integer(I4B)     :: obs_npix
    integer(I4B),  dimension(0:obs_npix-1), intent(in)           :: pixel
    real(KMAP),    dimension(0:obs_npix-1), intent(in)           :: signal
    integer(I4B),  dimension(0:obs_npix-1), intent(in)           :: n_obs
    real(KMAP),    dimension(0:obs_npix-1), intent(in)           :: serror
    character(len=*), dimension(1:),       intent(in), optional :: header
    integer(I4B),                          intent(in), optional :: nside, order
    character(len=*),                      intent(in), optional :: coord, units
    integer(I4B),                          intent(in), optional :: extno, polarisation

    character(len=*), parameter :: routine = 'write_fits_cut4'
    ! --- healpix/fits related variables ----
    integer(I4B)     :: ncol, grain
    integer(I4B)     :: npix_hd, nside_hd, nside_final, npix_final, i
    integer(I4B)     :: maxpix, minpix
    character(len=1) :: char1, coord_usr
!    character(len=8) :: char8
    character(len=20) :: units_usr
    logical(LGT)     :: done_nside, done_order, done_coord, done_polar, polar_flag
    integer(I4B)     :: nlheader, extno_i

    ! --- cfitsio related variables ----
    integer(I4B) ::  status, unit, blocksize, bitpix, naxis, naxes(1)
    logical(LGT) ::  simple, extend
    character(LEN=80) :: svalue, comment

    integer(I4B), parameter :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    integer(I4B) :: nrows, tfields, varidat
    integer(I4B) :: frow,  felem, repeat, repeatg, hdutype
    character(len=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    character(len=20), dimension(1:3) :: extnames
    character(len=80) ::  card
    character(len=4) :: srepeat, srepeatg
    character(len=1) :: pform
    character(len=filenamelen) sfilename

    integer(I4B), save :: nside_old
    !=======================================================================
    if (KMAP == SP) pform='E'
    if (KMAP == DP) pform='D'

    extnames = (/ 'TEMPERATURE   ' , & ! default in case of polarisation
         &        'Q_POLARISATION' , &
         &        'U_POLARISATION' /)

    ncol = 4
    grain = 1
    status=0
    unit = 149
    blocksize=1

    nlheader = 0
    if (present(header)) nlheader = size(header)
    units_usr = ' '
    if (present(units)) units_usr = units
    extno_i = 0
    if (present(extno)) extno_i = extno
    polar_flag = .false.
    if (present(polarisation)) then
       polar_flag = (polarisation /= 0)
       done_polar = .true. ! will ignore the header provided value of POLAR
    endif

    if (extno_i == 0) then
       !*************************************
       !     create the new empty FITS file
       !*************************************
       call ftinit(unit,filename,blocksize,status)
       if (status > 0) call fatal_error("Error while creating file " &
            & //trim(filename) &
            & //". Check path and/or access rights.")

       !     -----------------------------------------------------
       !     initialize parameters about the FITS image
       simple=.true.
       bitpix=32     ! integer*4
       naxis=0       ! no image
       naxes(1)=0
       extend=.true. ! there is an extension

       !     ----------------------
       !     primary header
       !     ----------------------
       !     write the required header keywords
       call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

       !     write the current date
       call ftpdat(unit,status) ! format ccyy-mm-dd

    else
       !*********************************************
       !     reopen an existing file and go to the end
       !*********************************************
       ! remove the leading '!' (if any) when reopening the same file
       sfilename = adjustl(filename)
       if (sfilename(1:1) == '!') sfilename = sfilename(2:filenamelen)
       call ftopen(unit,sfilename,1_i4b,blocksize,status)
       ! move to last extension written
       call ftmahd(unit, 1_i4b+ extno_i, hdutype, status)

    endif

       
    !     ----------------------
    !     new extension
    !     ----------------------
    call ftcrhd(unit, status)

       !     writes required keywords
       !     repeat = 1024
    repeat = 1
    nrows    = (obs_npix + repeat - 1)/ repeat ! naxis1
    if (obs_npix < repeat) repeat = 1
    write(srepeat,'(i4)') repeat
    srepeat = adjustl(srepeat)

    repeatg = repeat * grain
    write(srepeatg,'(i4)') repeatg
    srepeatg = adjustl(srepeatg)

    tfields  = ncol
    ttype(1:4) = (/ 'PIXEL ','SIGNAL','N_OBS ','SERROR' /)
    tform(1) = trim(srepeat)//'J'
    tform(2) = trim(srepeatg)//pform
    tform(3) = trim(srepeatg)//'J'
    tform(4) = trim(srepeatg)//pform

    tunit =  ' '      ! optional, will not appear
    tunit(2) = units_usr
    tunit(4) = units_usr
    extname  = 'SKY_OBSERVATION'      ! default, will be overide by user provided one if any
    if (polar_flag) extname = extnames(1+extno_i)
    varidat  = 0
    call ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
         &     extname, varidat, status)

    call ftpcom(unit,'------------------------------------------',status)
    call ftpcom(unit,'          Pixelisation Specific Keywords    ',status)
    call ftpcom(unit,'------------------------------------------',status)
    call ftpkys(unit,'PIXTYPE','HEALPIX ',' HEALPIX Pixelisation',status)      
    call ftpkyu(unit,'NSIDE',   ' ',status) ! place holder, will be updated later on
    call ftpkyu(unit,'ORDERING',' ',status)
    call ftpkys(unit,'COORDSYS',' ',' ',status)
    call ftpcom(unit,'  G = Galactic, E = ecliptic, C = celestial = equatorial', status)   
    call ftpkyl(unit,'POLAR',polar_flag,'Polarisation included in file (T/F)',status)
    call ftpcom(unit,'------------------------------------------',status)
    call ftpcom(unit,'          Data Specific Keywords    ',status)
    call ftpcom(unit,'------------------------------------------',status)
    call ftpkys(unit,'INDXSCHM','EXPLICIT',' Indexing : IMPLICIT or EXPLICIT', status)
    call ftpkyj(unit,'GRAIN',  grain,     ' Grain of pixel indexing',status)
    call ftpcom(unit,'GRAIN=0 : no indexing of pixel data (IMPLICIT) ',status)
    call ftpcom(unit,'GRAIN=1 : 1 pixel index -> 1 pixel data (EXPLICIT)',status)
    call ftpcom(unit,'GRAIN>1 : 1 pixel index -> data of GRAIN consecutive pixels (EXPLICIT)',status)
    call ftpkys(unit,'OBJECT','PARTIAL ',' Sky coverage represented by data',status)     
    call ftpkyj(unit,'OBS_NPIX',obs_npix, ' Number of pixels observed and recorded',status)


    ! add required Healpix keywords (NSIDE, ORDER) if provided by user
    done_order = .false.
    if (present(order)) then
       !        char8 = order
       !        call ftupch(char8)
       !        if (char8(1:4) == 'RING') then
       if (order == 1) then
          call ftukys(unit, 'ORDERING','RING',' Pixel ordering scheme, either RING or NESTED',status)
          done_order = .true.
          !        elseif (char8(1:4) == 'NEST') then
       elseif (order == 2) then
          call ftukys(unit, 'ORDERING','NESTED',' Pixel ordering scheme, either RING or NESTED ',status)
          done_order = .true.
       else
          print*,'Invalid ORDER given : ',order, ' instead of 1 (RING) or 2 (NESTED)'
       endif
    endif

    done_nside = .false.
    if (present(nside)) then
       if (nside2npix(nside) > 0) then ! valid nside
          call ftukyj(unit,'NSIDE',nside,' Resolution parameter for HEALPIX', status)
          done_nside = .true.
          nside_final = nside
       else
          print*,'Invalid NSIDE given : ',nside
       endif
    endif

    ! add non required Healpix keyword (COORD)
    done_coord = .false.
    if (present(coord)) then
       coord_usr = adjustl(coord)
       char1 = coord_usr(1:1)
       call ftupch(char1) ! uppercase
       if (char1 == 'C' .or. char1 == 'Q') then
          coord_usr = 'C'
          done_coord = .true.
       elseif (char1 == 'G') then
          coord_usr = 'G'
          done_coord = .true.
       elseif (char1 == 'E' ) then
          coord_usr='E'
          done_coord = .true.
       else
          print*,'Unrecognised COORD given : ',coord,' instead of C, G, or E'
          print*,'Proceed at you own risks '
          coord_usr = char1
          done_coord = .true.
       endif
       if (done_coord) then
          call ftukys(unit, 'COORDSYS',coord_usr,' Pixelisation coordinate system',status)
       endif
    endif


    !    write the user provided header literally, except for  PIXTYPE, TFORM*, TTYPE*, TUNIT* and INDXSCHM
    !    copy NSIDE, ORDERING and COORDSYS and POLAR if they are valid and not already given
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE' .or. card(1:5) == 'TFORM' .or. card(1:7) == 'PIXTYPE') then
          continue ! don't keep them
       else if (card(1:8) == 'INDXSCHM') then
          continue
       else if (card(1:5) == 'TUNIT') then 
          if ((card(6:6) == '2' .or. card(6:6) == '4') .and. trim(units_usr) == '') then
             call ftucrd(unit,'TUNIT'//card(6:6),card, status) !update TUNIT2 and TUNIT4
          endif
       else if (card(1:5) == 'NSIDE') then
          call ftpsvc(card, svalue, comment, status)
          read(svalue,*) nside_hd
          npix_hd = nside2npix(nside_hd)
          if (.not. done_nside .and. npix_hd > 0) then
             call ftucrd(unit,'NSIDE',card, status) !update NSIDE
             done_nside = .true.
             nside_final = nside_hd
          endif
       else if (card(1:8) == 'ORDERING') then
          call ftpsvc(card, svalue, comment, status)
          svalue = adjustl(svalue)
          svalue = svalue(2:8) ! remove leading quote
          call ftupch(svalue)
          if (.not. done_order .and. (svalue(1:4)=='RING' .or. svalue(1:6) == 'NESTED')) then
             call ftucrd(unit,'ORDERING',card, status) !update ORDERING
             done_order = .true.
          endif
       else if (card(1:8) == 'COORDSYS') then
          if (.not. done_coord) call putrec(unit,card, status)
          done_coord = .true.
       else if (card(1:5) == 'POLAR') then
          if (.not. done_polar) then
             call ftucrd(unit,'POLAR', card, status) ! update POLAR
             done_polar = .true.
          endif
       else if (card(1:7) == 'EXTNAME') then
          call ftucrd(unit, 'EXTNAME', card, status)
       else if (card(1:1) /= ' ') then ! if none of the above, copy to FITS file
          call putrec(unit, card, status)
       endif
10     continue
    enddo


    ! test that required keywords have been provided in some way
    if (.not. done_nside) then
       print*,routine//'> NSIDE is a Healpix required keyword, '
       print*,routine//'>  it was NOT provided either as routine argument or in the input header'
       print*,routine//'>  abort execution, file not written'
       call fatal_error
    endif
    if (.not. done_order) then
       print*,routine//'> ORDER is a Healpix required keyword, '
       print*,routine//'>  it was NOT provided either as routine argument or in the input header'
       print*,routine//'>  abort execution, file not written'
       call fatal_error
    endif
    if ((.not. done_polar) .and. extno_i >=2) then
       print*,routine//'> Warning: POLAR keyword not set while 3 extensions have been written'
    endif

    ! check that NSIDE is the same for all extensions
    if (extno_i == 0) then
       nside_old = nside_final
    else
       if (nside_final /= nside_old) then
          print*,routine//'> Inconsistent NSIDE: ',nside_final, nside_old
          print*,routine//'> Should use same NSIDE for all extensions'
       endif
    endif

    ! check validity of PIXEL
    npix_final = nside2npix(nside_final)
    minpix = minval(pixel(0:obs_npix-1))
    maxpix = maxval(pixel(0:obs_npix-1))
    if (minpix < 0 .or. maxpix > npix_final-1) then
       print*,routine//'> Actual pixel range = ',minpix,maxpix
       print*,routine//'> expected range (for Nside =',nside_final,') : 0, ',npix_final-1
       print*,routine//'> ABORT execution, file not written.'
       call fatal_error
    endif
    if (obs_npix > npix_final) then 
       print*,routine//'> The actual number of pixels ',obs_npix
       print*,routine//'> is larger than the number of pixels over the whole sky : ',npix_final
       print*,routine//'> for Nside = ',nside_final
       print*,routine//'> ABORT execution, file not written.'
       call fatal_error
    endif

    !     write the extension one column by one column
    frow   = 1  ! starting position (row)
    felem  = 1  ! starting position (element)
    call ftpclj(unit, 1_i4b, frow, felem, obs_npix, pixel , status)
    call f90ftpcl_(unit, 2_i4b, frow, felem, obs_npix, signal, status)

    if (tfields >= 3) call ftpclj(unit, 3_i4b, frow, felem, obs_npix, n_obs , status)
    if (tfields >= 4) then
       call f90ftpcl_(unit, 4_i4b, frow, felem, obs_npix, serror, status)
    endif

    !     ----------------------
    !     close and exit
    !     ----------------------

    !     close the file and free the unit number
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine write_fits_cut4

  !=======================================================================
  ! FITS2CL(filename, clin, lmax, ncl, header, units, fmissval)
  !     Read C_l from a FITS file
  !   Aug 2000 : modification by EH of the number of columns actually read
  !
  !     This routine is used for reading input power spectra for synfast
  !
  !  Dec 2004: overloading for single and double precision output array (clin)
  ! Feb 2013: added fmissval (value to be given to NaN or Inf C(l))
  !      if absent, those C(l) are left unchanged
  !   
  !=======================================================================
  subroutine fits2cl_s(filename, clin, lmax, ncl, header, units, fmissval)
    !=======================================================================
    !        single precision
    !=======================================================================
    integer(I4b), parameter :: KCL = SP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl
    REAL(KCL),        DIMENSION(0:lmax,1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),            INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units
    real(KCL),                       optional,  intent(IN):: fmissval

    real(DP), dimension(:,:), allocatable :: cl_dp
    real(DP) :: fmvd

    ! since the arrays involved are small
    ! read in double precision, and then cast in single
    allocate(cl_dp(0:lmax, 1:ncl))
    if (present(fmissval)) then
       fmvd = fmissval * 1.0_DP
       call fits2cl_d(filename, cl_dp, lmax, ncl, header, units, fmvd)
    else
       call fits2cl_d(filename, cl_dp, lmax, ncl, header, units)
    endif
    clin(0:lmax, 1:ncl) = cl_dp(0:lmax, 1:ncl)

    return
  end subroutine fits2cl_s

  subroutine fits2cl_d(filename, clin, lmax, ncl, header, units, fmissval)
    !=======================================================================
    !        double precision
    !=======================================================================
    integer(I4b), parameter :: KCL = DP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl
    REAL(KCL),         DIMENSION(0:lmax, 1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units
    real(KCL),                       optional,  intent(IN):: fmissval

    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),ncl_file, naxis
    INTEGER(I4B) :: firstpix,lmax_file,lmax_min,nelems,datacode,repeat,width
    CHARACTER(LEN=80) :: comment, pdmstr
    LOGICAL :: extend
    INTEGER(I4B) :: nmove, hdutype, hdunum
    INTEGER(I4B) :: column, frow
    REAL(KCL), DIMENSION(:), ALLOCATABLE :: clin_file

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: rowlen, nrows, varidat
    INTEGER(I4B),      dimension(1:MAXDIM) :: tbcol
    CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform, tunit
    CHARACTER(LEN=20)                      :: extname
    LOGICAL :: anynull
    REAL(KCL) ::  nullval
    logical :: planck_format
    integer(i8b) :: nbads


    !-----------------------------------------------------------------------
    status=0
    anynull = .false.
    ttype=''
    tform=''
    tunit=''
    extname=''
    comment=''

    unit = 110
    naxes(1) = 1
    naxes(2) = 1

    readwrite=0
    call ftnopn(unit,filename,readwrite, status) !open primary HDU or specified HDU
    if (status > 0) call printerror(status)
    !     -----------------------------------------
    call ftghdn(unit, hdunum)
    if (hdunum == 1) then  ! in primary HDU: move to next HDU
       !     determines the presence of image
       call ftgkyj(unit,'NAXIS', naxis, comment, status)
       if (status > 0) call printerror(status)

       !     determines the presence of an extension
       call ftgkyl(unit,'EXTEND', extend, comment, status)
       if (status > 0) call printerror(status)

       nmove = +1
       call ftmrhd(unit, nmove, hdutype, status)
    else ! already in non primary HDU
       extend = .true.
       call ftghdt(unit, hdutype, status)
    endif

    if (extend) then ! there is an extension

       call assert ((hdutype==1).or.(hdutype==2), 'this is not a table')

       !        reads keywords related to table layout
       if (hdutype==1) then ! ASCII table
         call ftghtb(unit, MAXDIM, rowlen, &
              &      nrows, ncl_file, ttype, tbcol, &
              &      tform, tunit, extname, status)
         repeat = 1
       else ! binary table
         call ftghbn(unit, MAXDIM, &
              &      nrows, ncl_file, ttype,        &
              &      tform, tunit,extname, varidat, status)
          call ftbnfm(tform(1), datacode, repeat, width, status)
       endif

       status = 0
       header = ""
       call get_clean_header(unit, header, filename, status)

       if (present(units)) then 
          do column = 1, min(ncl, ncl_file)
             units(column) = adjustl(tunit(column))
          enddo
       endif

       !        reads the columns
       column = 1
       frow = 1
       firstpix = 1
       lmax_file = nrows*repeat - 1
       lmax_min = MIN(lmax,lmax_file)
       nelems = lmax_min + 1
       nullval = 0.0_KCL ! CFITSIO will leave bad pixels unchanged, and so will this routine
       if (present(fmissval)) then
          if (fmissval == 0.0_KCL) then
             nullval = HPX_DBADVAL ! sentinel value to be given to bad pixels by CFITSIO, will later be mapped to user defined 0
          else
             nullval = fmissval ! user defined value to be given to bad pixels by CFITSIO, and by this routine
          endif
       endif

! check for the special Planck format (i.e. one additional column)
       planck_format=.true.
       call ftgkys(unit,'PDMTYPE',pdmstr,comment,status)
       if (status==202) then
         planck_format=.false.
         status=0
       endif
       allocate(clin_file(0:lmax_min),stat=status)
       clin = 0.0_KCL                         ! modification by EH
       if (planck_format) then
         do column = 1, MIN(ncl, ncl_file-1) ! modification by EH
            clin_file(:) = 0.0_KCL
            call ftgcvd(unit, column+1_i4b, frow, firstpix, nelems, nullval, &
                 &        clin_file(0), anynull, status)
            clin(0:lmax_min, column) = clin_file(0:lmax_min)
         enddo
       else
         do column = 1, MIN(ncl, ncl_file) ! modification by EH
            clin_file(:) = 0.0_KCL
            call ftgcvd(unit, column, frow, firstpix, nelems, nullval, &
                 &        clin_file(0), anynull, status)
            clin(0:lmax_min, column) = clin_file(0:lmax_min)
         enddo
       endif
       deallocate(clin_file)
       if (present(fmissval)) then
          if (nullval /= fmissval) call map_bad_pixels(clin, nullval, fmissval, nbads)
       endif
    else ! no image no extension, you are dead, man
       call fatal_error(' No image, no extension in '//trim(filename))
    endif

    !     close the file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

!     CHARACTER(LEN=*),                          INTENT(IN) :: filename
!     INTEGER(I4B),                              INTENT(IN) :: lmax, ncl
!     REAL(KCL),         DIMENSION(0:lmax, 1:ncl), INTENT(OUT) :: clin
!     CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
!     CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

!     INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),ncl_file, naxis
!     INTEGER(I4B) :: firstpix,lmax_file,lmax_min,nelems
!     CHARACTER(LEN=80) :: comment, pdmstr
!     LOGICAL :: extend
!     INTEGER(I4B) :: nmove, hdutype
!     INTEGER(I4B) :: column, frow
!     REAL(KCL), DIMENSION(:), ALLOCATABLE :: clin_file

!     INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
!     INTEGER(I4B) :: rowlen, nrows, varidat
!     INTEGER(I4B),      dimension(1:MAXDIM) :: tbcol
!     CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform, tunit
!     CHARACTER(LEN=20)                      :: extname
!     LOGICAL :: anynull
!     REAL(KCL) ::  nullval
!     logical :: planck_format


!     !-----------------------------------------------------------------------
!     status=0
!     anynull = .false.
!     ttype=''
!     tform=''
!     tunit=''
!     extname=''
!     comment=''

!     unit = 110
!     naxes(1) = 1
!     naxes(2) = 1

!     readwrite=0
!     call ftopen(unit,filename,readwrite,blocksize,status)
!     if (status > 0) call printerror(status)
!     !     -----------------------------------------

!     !     determines the presence of image
!     call ftgkyj(unit,'NAXIS', naxis, comment, status)
!     if (status > 0) call printerror(status)

!     !     determines the presence of an extension
!     call ftgkyl(unit,'EXTEND', extend, comment, status)
!     if (status > 0) call printerror(status)

!     if (extend) then ! there is an extension
!        nmove = +1
!        call ftmrhd(unit, nmove, hdutype, status)

!        call assert ((hdutype==1).or.(hdutype==2), 'this is not a table')

!        !        reads keywords related to table layout
!        if (hdutype==1) then
!          call ftghtb(unit, MAXDIM, &
!               &        rowlen, nrows, ncl_file, ttype, tbcol, tform, tunit, &
!               &        extname, status)
!        else
!          call ftghbn(unit, MAXDIM, &
!               &        nrows, ncl_file, ttype, tform, tunit,extname, &
!               &        varidat, status)
!        endif

!        status = 0
!        header = ""
!        call get_clean_header(unit, header, filename, status)

!        if (present(units)) then 
!           do column = 1, min(ncl, ncl_file)
!              units(column) = adjustl(tunit(column))
!           enddo
!        endif

!        !        reads the columns
!        column = 1
!        frow = 1
!        firstpix = 1
!        lmax_file = nrows - 1
!        lmax_min = MIN(lmax,lmax_file)
!        nullval = 0.0_KCL
!        nelems = lmax_min + 1

! ! check for the special Planck format (i.e. one additional column)
!        planck_format=.true.
!        call ftgkys(unit,'PDMTYPE',pdmstr,comment,status)
!        if (status==202) then
!          planck_format=.false.
!          status=0
!        endif
!        allocate(clin_file(0:lmax_min),stat=status)
!        clin = 0.0_KCL                         ! modification by EH
!        if (planck_format) then
!          do column = 1, MIN(ncl, ncl_file-1) ! modification by EH
!             clin_file(:) = 0.0_KCL
!             call ftgcvd(unit, column+1_i4b, frow, firstpix, nelems, nullval, &
!                  &        clin_file(0), anynull, status)
!             clin(0:lmax_min, column) = clin_file(0:lmax_min)
!          enddo
!        else
!          do column = 1, MIN(ncl, ncl_file) ! modification by EH
!             clin_file(:) = 0.0_KCL
!             call ftgcvd(unit, column, frow, firstpix, nelems, nullval, &
!                  &        clin_file(0), anynull, status)
!             clin(0:lmax_min, column) = clin_file(0:lmax_min)
!          enddo
!        endif
!        deallocate(clin_file)
!     else ! no image no extension, you are dead, man
!        call fatal_error(' No image, no extension')
!     endif

!     !     close the file
!     call ftclos(unit, status)

!     !     check for any error, and if so print out error messages
!     if (status > 0) call printerror(status)



    return
  end subroutine fits2cl_d

  !=======================================================================
  ! READ_ASC_TAB(filename, clin, lmax, ncl, header, units)
  ! superseded by fits2cl
  !=======================================================================
  subroutine read_asctab_v12s(filename, clin, lmax, ncl, header, nlheader, units)
    !=======================================================================
    !        single precision, legacy code
    !=======================================================================
    integer(I4b), parameter :: KCL = SP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl,nlheader
    REAL(KCL),         DIMENSION(0:lmax,1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

    print*,"-------------------------------------------------------------"
    print*,"WARNING : the routine read_asctab is now obsolete"
    print*,"  Use "
    print*," call fits2cl(filename, clin, lmax, ncl, header, units)"
    print*,"  instead (same module)"
    print*,"-------------------------------------------------------------"

    call fits2cl(filename, clin, lmax, ncl, header, units)
    return
  end subroutine read_asctab_v12s
  subroutine read_asctab_v12d(filename, clin, lmax, ncl, header, nlheader, units)
    !=======================================================================
    !        double precision, legacy code
    !=======================================================================
    integer(I4b), parameter :: KCL = DP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl,nlheader
    REAL(KCL),         DIMENSION(0:lmax,1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

    print*,"-------------------------------------------------------------"
    print*,"WARNING : the routine read_asctab is now obsolete"
    print*,"  Use "
    print*," call fits2cl(filename, clin, lmax, ncl, header, units)"
    print*,"  instead (same module)"
    print*,"-------------------------------------------------------------"

    call fits2cl(filename, clin, lmax, ncl, header, units)
    return
  end subroutine read_asctab_v12d
  !=======================================================================
  subroutine read_asctab_s(filename, clin, lmax, ncl, header, units)
    !=======================================================================
    !        single precision
    !=======================================================================
    integer(I4b), parameter :: KCL = SP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl
    REAL(KCL),         DIMENSION(0:lmax,1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

    print*,"-------------------------------------------------------------"
    print*,"WARNING : the routine read_asctab is now obsolete"
    print*,"  Use "
    print*," call fits2cl(filename, clin, lmax, ncl, header, units)"
    print*,"  instead (same module)"
    print*,"-------------------------------------------------------------"

    call fits2cl(filename, clin, lmax, ncl, header, units)
    return
  end subroutine read_asctab_s

  subroutine read_asctab_d(filename, clin, lmax, ncl, header, units)
    !=======================================================================
    !        double precision
    !=======================================================================
    integer(I4b), parameter :: KCL = DP
    !
    CHARACTER(LEN=*),                          INTENT(IN) :: filename
    INTEGER(I4B),                              INTENT(IN) :: lmax, ncl
    REAL(KCL),         DIMENSION(0:lmax, 1:ncl), INTENT(OUT) :: clin
    CHARACTER(LEN=*), DIMENSION(1:),   INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

    print*,"-------------------------------------------------------------"
    print*,"WARNING : the routine read_asctab is now obsolete"
    print*,"  Use "
    print*," call fits2cl(filename, clin, lmax, ncl, header, units)"
    print*,"  instead (same module)"
    print*,"-------------------------------------------------------------"

    call fits2cl(filename, clin, lmax, ncl, header, units)
    return
  end subroutine read_asctab_d

  !=======================================================================
  subroutine output_map_s(map, header, outfile, extno)
    !=======================================================================
    ! this is only a wrapper to write_bintab for SP maps
    ! this routine needs an explicit interface
    !=======================================================================
    use long_intrinsic, only: long_size

    REAL(SP),         INTENT(IN), DIMENSION(0:,1:), target :: map
    CHARACTER(LEN=*), INTENT(IN), DIMENSION(1:) :: header
    CHARACTER(LEN=*), INTENT(IN)                :: outfile
    INTEGER(I4B)    , INTENT(IN)     , optional :: extno

    INTEGER(I8B) :: npix
    INTEGER(I4B) :: nlheader, nmap, extno_i
    real(SP), pointer, dimension(:,:) :: pmap
    !-----------------------------------------------------------------------
    npix = long_size(map,1)
    nmap = long_size(map,2)
    nlheader = SIZE(header)

    extno_i = 0
    if (present(extno)) extno_i = extno
    pmap => map(0:npix-1,1:nmap)
    call write_bintab(pmap, npix, nmap, &
         &            header(1:nlheader), nlheader, outfile, extno=extno_i)
    return
  end subroutine output_map_s
  !=======================================================================
  subroutine output_map_d(map, header, outfile, extno)
    !=======================================================================
    ! this is only a wrapper to write_bintab for DP maps
    ! this routine needs an explicit interface
    !=======================================================================
    use long_intrinsic, only: long_size

    REAL(DP),         INTENT(IN), DIMENSION(0:,1:), target :: map
    CHARACTER(LEN=*), INTENT(IN), DIMENSION(1:) :: header
    CHARACTER(LEN=*), INTENT(IN)                :: outfile
    INTEGER(I4B)    , INTENT(IN)     , optional :: extno

    INTEGER(I8B) :: npix
    INTEGER(I4B) :: nlheader, nmap, extno_i
    real(DP), pointer, dimension(:,:) :: pmap
    !-----------------------------------------------------------------------
    npix = long_size(map,1)
    nmap = long_size(map,2)
    nlheader = SIZE(header)

    extno_i = 0
    if (present(extno)) extno_i = extno
    pmap => map(0:npix-1,1:nmap)
    call write_bintab(pmap, npix, nmap, &
         &            header(1:nlheader), nlheader, outfile, extno=extno_i)
    return
  end subroutine output_map_d



  !=======================================================================
  subroutine write_dbintab(plm, nplm, nhar, header, nlheader, filename, nsmax, nlmax)
    !=======================================================================
    ! now obsolete routine
    !=======================================================================
    INTEGER(I4B), INTENT(IN) :: nplm, nhar, nlheader, nsmax, nlmax
    REAL(DP),          INTENT(IN), DIMENSION(0:nplm-1,1:nhar) :: plm
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)               :: filename
    !=======================================================================
    print*,'WRITE_DBINTAB is obsolete.'
    print*,'   '
    print*,'To write a Healpix map into a FITS file'
    print*,'use WRITE_BINTAB or OUTPUT_MAP, which both accept '
    print*,'Single and Double Precision arguments'
    print*,'   '
    print*,'To write Plm polynoms into a FITS file,'
    print*,'use WRITE_PLM  (same syntax)'
    call write_plm(plm, nplm, nhar, header, nlheader, filename, nsmax, nlmax)

    return
  end subroutine write_dbintab
  !=======================================================================
  ! WRITE_PLM
  !     Create a FITS file containing a binary table extension with 
  !     the temperature map in the first column
  !     written by EH from writeimage and writebintable 
  !     (fitsio cookbook package)
  !
  !     slightly modified to deal with vector column 
  !     in binary table       EH/IAP/Jan-98
  !
  !     simplified the calling sequence, the header sould be filled in
  !     before calling the routine
  !
  !     Changed to write double precision plms for const.real. FKH/Apr-99
  !
  !=======================================================================
#ifndef NO64BITS
  subroutine write_plm4(plm, nplm, nhar, header, nlheader, filename, nsmax, nlmax)
    !=======================================================================
    INTEGER(I4B), INTENT(IN) :: nplm
    INTEGER(I4B), INTENT(IN) :: nhar, nlheader, nsmax, nlmax
    REAL(DP),          INTENT(IN), DIMENSION(0:nplm-1,1:nhar) :: plm
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)               :: filename
    integer(i8b) :: nplm8
    nplm8 = nplm
    call write_plm8(plm, nplm8, nhar, header, nlheader, filename, nsmax, nlmax)
    return
  end subroutine write_plm4
    !=======================================================================
#endif
  subroutine write_plm8(plm, nplm, nhar, header, nlheader, filename, nsmax, nlmax)
    !=======================================================================

    INTEGER(I8B), INTENT(IN) :: nplm
    INTEGER(I4B), INTENT(IN) :: nhar, nlheader, nsmax, nlmax
    REAL(DP),          INTENT(IN), DIMENSION(0:nplm-1,1:nhar) :: plm
    CHARACTER(LEN=80), INTENT(IN), DIMENSION(1:nlheader) :: header
    CHARACTER(LEN=*),  INTENT(IN)               :: filename
    !
    INTEGER(I4B) ::  status,unit,blocksize,bitpix,naxis,naxes(1)
    INTEGER(I4B) ::  i
    LOGICAL(LGT) ::  simple,extend
    CHARACTER(LEN=80) :: comment

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat, nmmax
    INTEGER(I8B) :: nlm, nf, i0, i1
    INTEGER(I4B) :: frow,  felem, colnum
    CHARACTER(LEN=20) :: ttype(MAXDIM), tform(MAXDIM), tunit(MAXDIM), extname
    CHARACTER(LEN=10) ::  card, num
    CHARACTER(LEN=2)  :: stn
    INTEGER(I4B)      :: itn, irow, np
    real(DP)          :: dm
    !-----------------------------------------------------------------------

    status=0

    unit = 148

    !     create the new empty FITS file
    blocksize=1
    call ftinit(unit,filename,blocksize,status)
    if (status > 0) call fatal_error("Error while creating file " &
         & //trim(filename) &
         & //". Check path and/or access rights.")

    !     -----------------------------------------------------
    !     initialize parameters about the FITS image
    simple=.true.
    bitpix=32     ! integer*4
    naxis=0       ! no image
    naxes(1)=0
    extend=.true. ! there is an extension

    !     ----------------------
    !     primary header
    !     ----------------------
    !     write the required header keywords
    call ftphpr(unit,simple,bitpix,naxis,naxes,0_i4b,1_i4b,extend,status)

    !     writes supplementary keywords : none

    !     write the current date
    call ftpdat(unit,status) ! (format ccyy-mm-dd)

    !     ----------------------
    !     image : none
    !     ----------------------

    !     ----------------------
    !     extension
    !     ----------------------

    nlm = nplm / (2*nsmax) ! number of Plm per Healpix ring
    dm  = (2*nlmax + 3.0_dp)**2 - 8.0_dp*nlm
    nmmax = nlmax - (nint(sqrt(dm)) - 1)/2
    call assert(nplm == nlm*2*nsmax, 'inconsistent array size in write_plm')
    call assert(nplm == (nmmax+1_i8b)*(2*nlmax-nmmax+2_i8b)*nsmax, &
         &     'inconsistent array size (nmmax) in write_plm')

    !     creates an extension
    call ftcrhd(unit, status)

    !     writes required keywords
    nrows    = 2*nsmax ! naxis1
    tfields  = nhar
    nf = nplm / nrows
    if (nf * nrows /= nplm) then
       print*,' problems in write_plm',nf*nrows,nplm
       stop
    endif
    write (num,'(I10)') nf
!     tform(1:nhar) = trim(adjustl(num))//'D'     ! does not work with Ifort, EH, 2006-04-04
    num = trim(adjustl(num))//'D'
    tform(1:nhar) = num
    ttype(1:nhar) = 'harmonics'   ! will be updated
    tunit(1:nhar) = ''      ! optional, will not appear
    extname  = ''      ! optional, will not appear
    varidat  = 0
    call ftphbn(unit, nrows, tfields, ttype, tform, tunit, &
         &     extname, varidat, status)

    !     write the header literally, putting TFORM1 at the desired place
    comment = 'data format of field: 8-byte REAL'
    do i=1,nlheader
       card = header(i)
       if (card(1:5) == 'TTYPE') then ! if TTYPE1 is explicitely given
          stn = card(6:6)
          read(stn,'(i1)') itn
          ! discard at their original location:
          call ftdkey(unit,'TTYPE'//stn,status)  ! old TTYPEi and
          status = 0
          call ftdkey(unit,'TFORM'//stn,status)  !     TFORMi
          status = 0
          if (itn <= tfields) then ! only put relevant information 2008-08-27
             call putrec(unit,header(i), status)           ! write new TTYPE1
             status = 0
             call ftpkys(unit,'TFORM'//stn,tform(itn),comment,status) ! and write new TFORM1 right after
          endif
       elseif (header(i)/=' ') then
          call putrec(unit,header(i), status)
       endif
       status = 0
    enddo

    ! make sure keywords critical for future use are present and correct
    call ftukyj(unit,'NSIDE',   nsmax, 'HEALPIX resolution parameter', status)
    call ftukyj(unit,'MAX-LPOL',nlmax, 'Maximum multipole order l of P_lm', status)
    call ftukyj(unit,'MAX-MPOL',nmmax, 'Maximum degree m of P_lm', status)
    call ftukyl(unit,'POLAR', (nhar>1),'Polarisation included (T/F)', status)

    !     write the extension one column by one column
    do irow=1, nrows
       frow   = irow  ! starting position (row)
       felem  = 1  ! starting position (element)
       np = nf
       i0 = (irow-1)*nf
       i1 = i0+nf-1
       do colnum = 1, nhar
          !call ftpcld(unit, colnum, frow, felem, nplm, plm(0,colnum), status)
          call ftpcld(unit, colnum, frow, felem, np, plm(i0:i1,colnum), status)
       enddo
    enddo

    !     ----------------------
    !     close and exit
    !     ----------------------

    !     close the file and free the unit number
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine write_plm8

  !=======================================================================
  !       ALMS2FITS
  !     Writes alms from to binary FITS file, FKH/Apr-99
  !     ncl is the number of columns, in the output fits file,
  !     either 3 or 5 (with or without errors respectively)
  !
  !    input array (real)                   FITS file
  !     alms(:,1) = l                      )
  !     alms(:,2) = m                      )---> col 1: l*l+l+m+1
  !     alms(:,3) = real(a_lm)              ---> col 2
  !     alms(:,4) = imag(a_lm)              ---> col 3
  !     alms(:,5) = real(delta a_lm)        ---> col 4
  !     alms(:,6) = imag(delta a_lm)        ---> col 5
  !=======================================================================
  subroutine alms2fits_s(filename, nalms, alms, ncl, header, nlheader, next)
    !=======================================================================
    character(len=*),  intent(in)               :: filename
    integer(I4B),      intent(in)               :: nalms, nlheader, next, ncl
    real(SP),          intent(in), dimension(1:nalms,1:ncl+1,1:next), target :: alms
    character(len=80), intent(in), dimension(1:nlheader,1:next) :: header
    integer(I4B) :: i
    real(SP),          dimension(:,:), pointer :: palms

    do i=1,next
       palms => alms(1:nalms,1:(ncl+1),i) ! use pointer to reduce memory usage
       call write_alms_s(filename, nalms, palms, ncl, &
            &            header(1:nlheader,i), nlheader, i)
    enddo

  end subroutine alms2fits_s
  !=======================================================================
  subroutine alms2fits_d(filename, nalms, alms, ncl, header, nlheader, next)
    !=======================================================================
    character(len=*),  intent(in)               :: filename
    integer(I4B),      intent(in)               :: nalms, nlheader, next, ncl
    real(DP),          intent(in), dimension(1:nalms,1:ncl+1,1:next), target :: alms
    character(len=80), intent(in), dimension(1:nlheader,1:next) :: header
    integer(I4B) :: i
    real(DP),          dimension(:,:), pointer :: palms

    do i=1,next
       palms => alms(1:nalms,1:(ncl+1),i) ! use pointer to reduce memory usage
       call write_alms_d(filename, nalms, palms, ncl, &
            &            header(1:nlheader,i), nlheader, i)
    enddo

  end subroutine alms2fits_d

  !=======================================================================
  subroutine fits2alms_s(filename, nalms, alms, ncl, header, nlheader, next) 
    !=======================================================================
    character(len=*),  intent(in)               :: filename
    integer(I4B),      intent(in)               :: nalms, nlheader, next, ncl
    real(SP),          intent(inout), dimension(1:nalms,1:ncl+1,1:next), target :: alms
    character(len=80), intent(out), dimension(1:nlheader,1:next) :: header
    integer(I4B) :: i
    real(SP),          dimension(:,:), pointer :: palms

    do i=1,next
       palms => alms(1:nalms,1:(ncl+1),i) ! use pointer to reduce memory usage
       call read_alms_s(filename, nalms, palms, ncl, &
            &           header(1:nlheader,i), nlheader, i)
    enddo

  end subroutine fits2alms_s
  !=======================================================================
  subroutine fits2alms_d(filename, nalms, alms, ncl, header, nlheader, next) 
    !=======================================================================
    character(len=*),  intent(in)               :: filename
    integer(I4B),      intent(in)               :: nalms, nlheader, next, ncl
    real(DP),          intent(inout), dimension(1:nalms,1:ncl+1,1:next), target :: alms
    character(len=80), intent(out), dimension(1:nlheader,1:next) :: header
    integer(I4B) :: i
    real(DP),          dimension(:,:), pointer :: palms

    do i=1,next
       palms => alms(1:nalms,1:(ncl+1),i) ! use pointer to reduce memory usage
       call read_alms_d(filename, nalms, palms, ncl, &
            &           header(1:nlheader,i), nlheader, i)
    enddo

  end subroutine fits2alms_d

  SUBROUTINE input_tod_s(filename, tod, npixtot, ntods, &
       &                 header, firstpix, fmissval, extno)
  ! *************************************************************************

  ! *************************************************************************
  ! v1.0 : Olivier Dore et Eric Hivon, June-July 2002
  ! v1.1     2002-07-08 : bugs correction by E.H. 
  ! v1.2     2002-08-22 : pixel number starts at 0 for these routine,
  !                         but starts at 1 for cftisio routines ...
  ! *************************************************************************
    ! ===================================================================================
    !     reads fits file
    !     filename = fits file (input)
    !     tod      = data rad from the file (ouput) = real*4 array of size (npixtot,ntods)
    !     npixtot  = length of the tod (input)
    !     ntods    = number of tods
    !     header   = OPTIONAL, FITS header
    !     fmissval = OPTIONAL argument (input) with the value to be given to missing
    !             pixels, its default value is 0
    !     firstpix = OPTIONAL first pixel to be read (starting at 0)
    !     extno    = OPTIONAL, extension number (starting at 0)
    !                                               O.D. & E.H. 06/02 @ IAP
    !      2002-07-08 : bugs correction by E.H. 
    !       (consistent use of fmiss_effct)
    ! =======================================================================
    
    IMPLICIT NONE

    INTEGER(I8B),     INTENT(IN)           :: npixtot
    INTEGER(I8B),     INTENT(IN), OPTIONAL :: firstpix
    INTEGER(I4B),     INTENT(IN)           :: ntods
    REAL(SP),         INTENT(OUT)          ,dimension(0:,1:) :: tod
    CHARACTER(LEN=*), INTENT(IN)           :: filename
    REAL(SP),         INTENT(IN), OPTIONAL :: fmissval
    character(len=*), intent(out),OPTIONAL, dimension(1:)  :: header
    INTEGER(I4B),     INTENT(IN), OPTIONAL :: extno
    
    INTEGER(I4B) :: i,itod
    REAL(SP)     :: fmissing, fmiss_effct
    INTEGER(I8B) :: imissing
    integer(i8b) :: fp = 0_i8b

    LOGICAL(LGT) :: anynull
    
    !-----------------------------------------------------------------------
    fmiss_effct = 0.
    IF (PRESENT(fmissval)) fmiss_effct = fmissval

    if (present(firstpix)) fp = firstpix

    CALL read_bintod_s(filename, tod, npixtot, ntods, fp, fmissing, anynull, &
         &             header, extno)

    call map_bad_pixels(tod, fmissing, fmiss_effct, imissing, verbose=.true.)
!     DO itod = 1, ntods
!        anynull = .TRUE.
!        IF (anynull) THEN
!           imissing = 0
!           DO i=0,npixtot-1
!              IF ( ABS(tod(i,itod)/fmissing -1.) .LT. 1.e-5 ) THEN
!                 tod(i,itod) = fmiss_effct
!                 imissing = imissing + 1
!              ENDIF
!           ENDDO
!           IF (imissing .GT. 0) THEN
!              WRITE(*,'(a,1pe11.4)') 'blank value : ' ,fmissing
!              WRITE(*,'(i7,a,f7.3,a,1pe11.4)') &
!                   &           imissing,' missing pixels (', &
!                   &           (100.*imissing)/npixtot,' %),'// &
!                   &           ' have been set to : ',fmiss_effct
!           ENDIF
!        ENDIF
!     ENDDO
    RETURN

  END SUBROUTINE input_tod_s
  !=======================================================================

  !**************************************************************************************
  SUBROUTINE input_tod_d(filename, tod, npixtot, ntods, &
       &                 header, firstpix, fmissval, extno)
  !**************************************************************************************

    !=======================================================================
    !     reads fits file
    !     filename = fits file (input)
    !     tod      = data rad from the file (ouput) = real*8 array of size (npixtot,ntods)
    !     npixtot  = length of the tod (input)
    !     ntods     = number of tods
    !     header   = OPTIONAL, FITS header
    !     fmissval = OPTIONAL argument (input) with the value to be given to missing
    !             pixels, its default value is 0
    !     firstpix = OPTIONAL first pixel to be read (starting at 0)
    !     extno    = OPTIONAL, extension number (starting at 0)
    !                                               O.D. & E.H. 06/02 @ IAP
    !      2002-07-08 : bugs correction by E.H. 
    !       (consistent use of fmiss_effct)
    !=======================================================================
    
    IMPLICIT NONE

    INTEGER(I8B),     INTENT(IN)           :: npixtot
    INTEGER(I8B),     INTENT(IN), OPTIONAL :: firstpix
    INTEGER(I4B),     INTENT(IN)           :: ntods
    REAL(DP),         INTENT(OUT)          ,dimension(0:,1:) :: tod
    CHARACTER(LEN=*), INTENT(IN)           :: filename
    REAL(DP),         INTENT(IN), OPTIONAL :: fmissval
    character(len=*), intent(out),OPTIONAL, dimension(1:)  :: header
    INTEGER(I4B),     INTENT(IN), OPTIONAL :: extno
    
    INTEGER(I4B) :: i,itod
    REAL(DP)     :: fmissing, fmiss_effct
    INTEGER(I8B) :: imissing
    integer(i8b) :: fp = 0_i8b

    LOGICAL(LGT) :: anynull
    
    !-----------------------------------------------------------------------
    
    fmiss_effct = 0.
    IF (PRESENT(fmissval)) fmiss_effct = fmissval

    if (present(firstpix)) fp = firstpix
    
    CALL read_bintod_d(filename, tod, npixtot, ntods, fp, fmissing, anynull, &
         &             header, extno)

    call map_bad_pixels(tod, fmissing, fmiss_effct, imissing, verbose=.true.)
!     DO itod = 1, ntods
!        anynull = .TRUE.
!        IF (anynull) THEN
!           imissing = 0
!           DO i=0,npixtot-1
!              IF ( ABS(tod(i,itod)/fmissing -1.) .LT. 1.e-5 ) THEN
!                 tod(i,itod) = fmiss_effct
!                 imissing = imissing + 1
!              ENDIF
!           ENDDO
!           IF (imissing .GT. 0) THEN
!              WRITE(*,'(a,1pe11.4)') 'blank value : ' ,fmissing
!              WRITE(*,'(i7,a,f7.3,a,1pe11.4)') &
!                   &           imissing,' missing pixels (', &
!                   &           (100.*imissing)/npixtot,' %),'// &
!                   &           ' have been set to : ',fmiss_effct
!           ENDIF
!        ENDIF
!     ENDDO
    RETURN

  END SUBROUTINE input_tod_d
  !=======================================================================
  !=======================================================================
  subroutine read_dbintab(filename,map,npixtot,nmaps,nullval,anynull, units)
    !=======================================================================
    !     Read a FITS file
    !
    !     slightly modified to deal with vector column 
    !     in binary table       EH/IAP/Jan-98
    !
    !     Reads a double-precision array with precomputed plms, used by syn/anafast
    !                FKH/Apr-99
    !=======================================================================
    CHARACTER(LEN=*),                           INTENT(IN) :: filename
    INTEGER(I4B),                               INTENT(IN) :: npixtot, nmaps
    !       REAL(DP), DIMENSION(0:npixtot-1,1:nmaps),   INTENT(OUT) :: map
    REAL(DP), DIMENSION(0:,1:),                 INTENT(OUT) :: map
    REAL(DP),                                   INTENT(OUT) :: nullval
    LOGICAL(LGT),                               INTENT(OUT) ::  anynull
    !       CHARACTER(LEN=*), dimension(1:), optional,           INTENT(OUT) :: header
    CHARACTER(LEN=*), dimension(1:), optional,  INTENT(OUT) :: units

    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    INTEGER(I4B) :: group,firstpix,npix,i
    REAL(SP) :: blank, testval
    REAL(DP) ::  bscale,bzero
    CHARACTER(LEN=80) :: comment
    LOGICAL(LGT) :: extend
    INTEGER(I4B) :: nmove, hdutype
    INTEGER(I4B) :: column, frow, imap
    INTEGER(I4B) :: datacode, repeat, width

    INTEGER(I4B), PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B) :: nrows, tfields, varidat
    CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform, tunit
    CHARACTER(LEN=20)                      :: extname
    !-----------------------------------------------------------------------
    status=0

    unit = 147
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    anynull = .false.
    bscale = 1.0d0
    bzero = 0.0d0
    blank = -2.e25
    nullval = bscale*blank + bzero

    readwrite=0
    call ftopen(unit,filename,readwrite,blocksize,status)
    if (status > 0) call printerror(status)
    !     -----------------------------------------

    !     determines the presence of image
    call ftgkyj(unit,'NAXIS', naxis, comment, status)
    if (status > 0) call printerror(status)

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    if (status > 0) status = 0 ! no extension : 
    !     to be compatible with first version of the code

    if (naxis > 0) then ! there is an image
       !        determine the size of the image (look naxis1 and naxis2)
       call ftgknj(unit,'NAXIS',1_i4b,2_i4b,naxes,nfound,status)

       !        check that it found only NAXIS1
       if (nfound == 2 .and. naxes(2) > 1) then
          print *,'multi-dimensional image'
          print *,'expected 1-D data.'
          call fatal_error
       end if

       if (nfound < 1) then
          call printerror(status)
          print *,'can not find NAXIS1.'
          call fatal_error
       endif

       npix=naxes(1)
       if (npix /= npixtot) then
          print *,'found ',npix,' plms'
          print *,'expected ',npixtot
          call fatal_error
       endif

       call ftgkyd(unit,'BSCALE',bscale,comment,status)
       if (status == 202) then ! BSCALE not found
          bscale = 1.0d0
          status = 0
       endif
       call ftgkyd(unit,'BZERO', bzero, comment,status)
       if (status == 202) then ! BZERO not found
          bzero = 0.0d0
          status = 0
       endif
       call ftgkye(unit,'BLANK', blank, comment,status)
       if (status == 202) then ! BLANK not found 
          ! (according to fitsio BLANK is integer)
          blank = -2.e25
          status = 0
       endif
       nullval = bscale*blank + bzero

       !        -----------------------------------------

       group=1
       firstpix = 1
       call ftgpvd(unit,group,firstpix,npix,nullval,map,anynull,status)
       ! if there are any NaN pixels, (real data)
       ! or BLANK pixels (integer data) they will take nullval value
       ! and anynull will switch to .true.
       ! otherwise, switch it by hand if necessary
       testval = 1.e-6 * ABS(nullval)
       do i=0, npix-1
          if (ABS(map(i,1)-nullval) < testval) then
             anynull = .true.
             goto 111
          endif
       enddo
111    continue

    else if (extend) then ! there is an extension
       nmove = +1
       call ftmrhd(unit, nmove, hdutype, status)
       !cc         write(*,*) hdutype

       call assert (hdutype==2, 'this is not a binary table')

       !        reads all the keywords
       call ftghbn(unit, MAXDIM, &
            &        nrows, tfields, ttype, tform, tunit, extname, varidat, &
            &        status)

       if (tfields < nmaps) then
          print *,'found ',tfields,' maps in the file'
          print *,'expected ',nmaps
          call fatal_error
       endif

       !        finds the bad data value
       call ftgkyd(unit,'BAD_DATA',nullval,comment,status)
       if (status == 202) then ! bad_data not found
          nullval = d_bad_value
          status = 0
       endif

       !          if (nlheader > 0) then
       !             call get_clean_header(unit, header, filename, status)
       !          endif

       if (present(units)) then
          units = 'unknown'
          do imap = 1, nmaps
             units(imap) = adjustl(tunit(imap))
          enddo
       endif

       do imap = 1, nmaps
          !parse TFORM keyword to find out the length of the column vector
          call ftbnfm(tform(imap), datacode, repeat, width, status)

          !reads the columns
          column = imap
          frow = 1
          firstpix = 1
          npix = nrows * repeat
          if (npix /= npixtot) then
             print *,'found ',npix,' plms'
             print *,'expected ',npixtot
             call fatal_error("read_dbintab "//trim(filename))
          endif
          call ftgcvd(unit, column, frow, firstpix, npix, nullval, &
               &        map(0:npix-1,imap), anynull, status)
       enddo

    else ! no image no extension, you are dead, man
       call fatal_error(' No image, no extension')
    endif

    !     close the file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    return
  end subroutine read_dbintab


  !=======================================================================
  subroutine printerror(status)
    !=======================================================================
    !     Print out the FITSIO error messages to the user
    !=======================================================================
    INTEGER(I4B), INTENT(IN) :: status
    CHARACTER ::  errtext*30,errmessage*80
    !-----------------------------------------------------------------------
    !     check if status is OK (no error); if so, simply return
    if (status .le. 0)return

    !     get the text string which describes the error
    call ftgerr(status,errtext)
    print *,'FITSIO Error Status =',status,': ',errtext

    !     read and print out all the error messages on the FITSIO stack
    call ftgmsg(errmessage)
    do while (errmessage /= ' ')
       print *,errmessage
       call ftgmsg(errmessage)
    end do

    return
  end subroutine printerror


  !=======================================================================
  subroutine read_par(filename,nside,lmax,tfields,mmax)
    !=======================================================================
    !        Read nside, lmax, tfields and mmax from a FITS file          
    !    parameters not found take a value of -1
    !
    !         Frode K. Hansen, April 1999
    !         EH, Dec 2004
    !
    !=======================================================================
    CHARACTER(LEN=*), INTENT(IN)            :: filename

    INTEGER(I4B), INTENT(OUT)   :: nside, lmax, tfields
    integer(i4b), intent(out), optional :: mmax

    INTEGER(I4B) :: status,unit,readwrite,blocksize,naxis
    CHARACTER(LEN=80) :: comment, ttype1
    LOGICAL(LGT) ::  extend, anyf
    INTEGER(I4B)::  nmove, hdutype, idmax, nrows

    !-----------------------------------------------------------------------
    status=0
    unit = 120
    comment=''
    ttype1=''

    readwrite=0
    call ftopen(unit,filename,readwrite,blocksize,status)
    if (status > 0) call printerror(status)
    !     -----------------------------------------
    call ftgkyj(unit,'NAXIS', naxis, comment, status)

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    call assert (status<=0, 'No Extension in FITS file!')

    nmove = +1
    call ftmrhd(unit, nmove, hdutype, status)

    call assert (hdutype==2, 'This is not a FITS binary-table')

    call ftgkyj(unit,'NSIDE',nside,comment,status)
    if (status == 202) then
       print*,'WARNING: NSIDE keyword not found!'
       nside = -1
       status = 0
    endif

    call ftgkyj(unit,'TFIELDS',tfields,comment,status)
    if (status == 202) then
       print*,'WARNING: TFIELDS keyword not found!'
       tfields = -1
       status = 0
    endif
    
    call ftgkyj(unit,'MAX-LPOL',lmax,comment,status)
    if (status == 202) then
       status = 0
       ! if not found, determines if file contains indexed list of alm
       ! if so, find out largest l
       if (tfields >= 3 .and. hdutype==2) then ! 3 column binary table
          call ftgkys(unit,'TTYPE1',ttype1,comment,status)
          ttype1 = trim(strupcase(adjustl(ttype1)))
          if (trim(ttype1(1:5)) == 'INDEX') then
             call ftgkyj(unit, 'NAXIS2', nrows, comment, status) ! find number of rows
             call ftgcvj(unit, 1_i4b, nrows, 1_i4b, 1_i4b, 0_i4b, idmax, anyf, status) ! read element on last row of first column
             if (status == 0) then
                lmax = int(sqrt(   real(idmax-1, kind = DP)  ) )
                if (lmax > 0) goto 1000
             endif
          endif
       endif
       print*,'WARNING: MAX-LPOL keyword not found!'
       lmax = -1
       status = 0
    endif
1000 continue

    if (present(mmax)) then
       call ftgkyj(unit,'MAX-MPOL',mmax,comment,status)
       if (status == 202) then
          print*,'WARNING: MAX-MPOL keyword not found!'
          mmax = -1
          status = 0
       endif
    endif
    call ftclos(unit, status)

  end subroutine read_par

  !=======================================================================
  function getnumext_fits(filename)
    !=======================================================================
    !  result = getnumext_fits(filename)
    !    returns the number of extensions present in FITS file 'filename'
    !
    ! EH, Nov 2004
    ! April 2007: close file on exit
    !=======================================================================
    character(LEN=*), intent(IN)             :: filename
    integer(i4b)                             :: getnumext_fits
    !
    integer(i4b) :: status, unit, readwrite, blocksize, nhdu
    !-----------------------------------------------------------------------
    status         = 0
    unit           = 149
    getnumext_fits = 0
    readwrite      = 0 ! Read only
    call ftopen(unit, filename, readwrite, blocksize, status)
    if (status > 0) then
       call printerror(status)
       call ftclos(unit, status)
       return
    endif

    call ftthdu(unit, nhdu, status)
    getnumext_fits = nhdu - 1

    call ftclos(unit, status)
    return
  end function getnumext_fits
  !=======================================================================
  function getsize_fits(filename, nmaps, ordering, obs_npix, &
       &    nside, mlpol, type, polarisation, fwhm_arcmin, beam_leg, & 
       &    coordsys, polcconv, extno)
    !=======================================================================
    !  result = getsize_fits(filename, nmaps, ordering, nside, mlpol, type)
    !     Get the number of pixels stored in a map FITS file.
    !     Each pixel is counted only once 
    !     (even if several information is stored on each of them, see nmaps).
    !     Depending on the data storage format, this may be :
    !       - equal or smaller to the number Npix of Healpix pixels available 
    !          over the sky for the given resolution (Npix = 12*nside*nside)
    !       - equal or larger to the number of non blank pixels (obs_npix)
    !     
    !     filename = (IN) name of the FITS file containing the map
    !     nmaps = (OPTIONAL, OUT) number of maps in the file
    !     ordering = (OPTIONAL, OUT) Healpix ordering scheme used
    !                  0 = unknown
    !                  1 = RING
    !                  2 = NESTED
    !     obs_npix =  (OPTIONAL, OUT) number of non blanck pixels.    
    !                It is set to -1 if it can not be determined from header
    !                information alone
    !     nside = (OPTIONAL, OUT) Healpix parameter Nside
    !                 returns a negative value if not found
    !     mlpol = (OPTIONAL, OUT) maximum multipole used to generate the map (for simulated map)
    !                 returns a negative value if not found
    !     type = (OPTIONAL, OUT) Healpix/FITS file type
    !                  <0 : file not found, or not valid
    !                  0  : image only fits file, deprecated Healpix format
    !                        (result = 12 * nside * nside)
    !                  1  : ascii table, generally used for C(l) storage
    !                  2  : binary table : with implicit pixel indexing (full sky)
    !                        (result = 12 * nside * nside)
    !                  3  : binary table : with explicit pixel indexing (generally cut sky)
    !                        (result <= 12 * nside * nside)
    !                999  : unable to determine the type
    !     polarisation = (OPTIONAL, OUT) presence of polarisation data in the file
    !                  <0 : can not find out
    !                   0 : no polarisation
    !                   1 : contains polarisation (Q,U or G,C)
    !     fwhm_arcmin     = (OPTIONAL, DP, OUT) returns the beam FWHM read from FITS header, 
    !                        translated from Deg (hopefully) to arcmin
    !                     returns a negative value if not found
    !
    !     beam_leg     = (OPTIONAL, CHR, OUT) filename of beam or filtering window function applied to data
    !                     returns a empty string if not found
    !     coordsys     = (OPTIONAL, CHR, OUT) string describing coordinate system,  
    !                     G = Galactic, E = ecliptic, C = celestial = equatorial.
    !                     empty if not found.
    !
    !     polcconv     = (OPTIONAL, I4B, OUT) coordinate convention for polarisation
    !                   0: not found
    !                   1: COSMO (default for Healpix)
    !                   2: IAU
    !                   3: neither COSMO nor IAU
    !
    !     extno = (OPTIONAL, IN) specify FITS extension to look at (0 based)
    !                  default = 0 (first extension)
    !
    !     Benjamin D. Wandelt January 1998
    !     includes Eric Hivon's modification of FITS columns
    !     and draws heavily on the read_bintab routine.
    !
    !     addition of optional Ordering by E.H. (July 98)
    !     addition of optional Nside and Mlpol by ?? (??)
    !     addition of optional type by E.H. (Sept 00)
    !     improved for ASCII table E.H (Feb 03)
    !     addition of extno, E.H (Nov 04)
    !     addition of fwhm_arcmin and beam_leg, EH (Jan 05).
    !     addition of polcconv, EH (June 05).
    !     accept files with NAXIS2 > 2^31 (2015-04) (requires recent cfitsio >= 3.20)
    !     accept files with polarisation columns named Q_S*, Q-S*, ... U_S*, U-S*
    !=======================================================================
    use pix_tools, only: nside2npix
    character(LEN=*), intent(IN)             :: filename
    integer(I4B),     intent(out),  optional :: nmaps
    integer(I4B),     intent(out),  optional :: ordering
    integer(I4B),     intent(out),  optional :: nside
    integer(I4B),     intent(out),  optional :: mlpol
    integer(I4B),     intent(out),  optional :: obs_npix
    integer(I4B),     intent(out),  optional :: type
    integer(I4B),     intent(out),  optional :: polarisation
    real(DP),         intent(out),  optional :: fwhm_arcmin
    character(LEN=*), intent(out),  optional :: beam_leg
    character(LEN=*), intent(out),  optional :: coordsys
    integer(I4B),     intent(out),  optional :: polcconv
    integer(I4B),     intent(in),   optional :: extno

    INTEGER(I4B)           :: nmaps_in, ordering_in, nside_in
    INTEGER(I4B)           :: mlpol_in, obs_npix_in, ftype_in
    INTEGER(I4B)           :: extno_in, polcconv_in
    real(DP)               :: fwhm_arcmin_in
    character(len=FILENAMELEN)        :: beam_leg_in
    character(len=20)        :: coordsys_in
    INTEGER(I4B)           :: grain
    CHARACTER(len=20)      :: indxschm
    CHARACTER(LEN=20)      :: order_val, object_val, ttype_val, polcconv_val
!     INTEGER(I4B)           :: getsize_fits
    INTEGER(I8B)           :: getsize_fits
    LOGICAL(LGT)           ::  polar_in
    character(len=3),  dimension(1:16,1:2)  :: defpol
    logical(kind=LGT), dimension(1:2)       :: pf
    integer(kind=I4B)                       :: ndp, j, k

    INTEGER(I4B)      :: status,unit,readwrite,blocksize,naxes(2),nfound, naxis
    INTEGER(I4B)      :: i
!     INTEGER(I4B) :: nsize
    INTEGER(I8B)      :: nsize
    CHARACTER(LEN=80) :: comment
    LOGICAL(LGT)      ::  extend
    INTEGER(I4B)      ::  nmove, hdutype, hdunum
    INTEGER(I4B)      :: datacode, repeat1, repeat2, width

    INTEGER(I4B),           PARAMETER :: MAXDIM = MAXDIM_TOP !number of columns in the extension
    INTEGER(I4B)                      :: tfields, varidat, rowlen
    CHARACTER(LEN=20), dimension(1:MAXDIM) :: ttype, tform, tunit
    INTEGER(I4B),      dimension(1:MAXDIM) :: tbcol
    CHARACTER(LEN=20)                      :: extname
    integer(I4B) :: nrows32
    integer(I8B) :: nrows64
    !-----------------------------------------------------------------------
    status=0
    order_val = ''
    nmaps_in = 0
    ordering_in = 0
    mlpol_in = -1
    nside_in = -1
    ftype_in = 999 !   
    obs_npix_in = -1
    unit = 119
    naxes(1) = 1
    naxes(2) = 1
    nfound = -1
    extno_in = 0
    polcconv_in = 0
    comment=''
    ttype=''
    tform=''
    tunit=''
    extname=''
    if (present(extno)) extno_in = extno
    naxis = 0
    extend = .false.

    readwrite=0
    !call ftopen(unit,filename,readwrite,blocksize,status)
    call ftnopn(unit,filename,readwrite,status)
    if (status > 0) then
       ftype_in = -1
       getsize_fits = -1
       call printerror(status)
       call ftclos(unit, status)
       return
    endif
    !     -----------------------------------------
    call ftghdn(unit, hdunum)
    if (hdunum == 1) then  ! in primary HDU: move to next HDU
       !     determines the presence of image
       call ftgkyj(unit,'NAXIS', naxis, comment, status)

       !     determines the presence of an extension
       call ftgkyl(unit,'EXTEND', extend, comment, status)
       if (status > 0) then
          ftype_in = 0
          status = 0 ! no extension : 
       !     to be compatible with first version of the code
       endif

    else ! already in non primary HDU
       extend = .true.
       call ftghdt(unit, hdutype, status)
    endif

    if (naxis > 0) then 
       !---------------------------------
       ! there is an image
       !---------------------------------
       !        determine the size of the image (look naxis1 and naxis2)
       call ftgknj(unit,'NAXIS',1_i4b,2_i4b,naxes,nfound,status)

       !        check that it found only NAXIS1
       if (nfound == 2 .and. naxes(2) > 1) then
          print *,'multi-dimensional image'
          print *,'expected 1-D data.'
          call ftclos(unit, status)
          call fatal_error
       end if

       if (nfound < 1) then
          call printerror(status)
          print *,'can not find NAXIS1.'
          call ftclos(unit, status)
          call fatal_error
       endif

       nsize=naxes(1)

       call ftgkys(unit,'ORDERING',order_val,comment,status)
       if (status == 202) then ! Ordering not found
          ordering_in = 0
          order_val = ''
          status = 0
       endif

       call ftgkyj(unit,'NSIDE',nside_in,comment,status)
       if (status == 202) then ! Nside not found
          nside_in = -1
          status = 0
       endif

       if (present(mlpol)) then
          call ftgkyj(unit,'MAX-LPOL',mlpol_in,comment,status)
          if (status == 202) then ! max-lpol not found
             mlpol_in = -1
             status = 0
          endif
       endif

       if (present(polarisation)) then
          polarisation = 0
       endif
    else if (extend) then 
       !-----------------------------------------------------------------
       ! there is an extension
       !-----------------------------------------------------------------

       nmove =  extno_in
       if (hdunum == 1) nmove = extno_in + 1
       call ftmrhd(unit, nmove, hdutype, status)
       if (status > 0) then ! extension not found
          print*,'Extension #',extno_in,' not found in '//trim(filename)
          call printerror(status)
          call ftclos(unit, status)
          call fatal_error
       endif
       !c         write(*,*) hdutype

       !        reads all the keywords
       if (hdutype == 2) then ! binary table
          call ftghbn(unit, MAXDIM, &
            &         nrows32, tfields, ttype,        tform, tunit, &
            &         extname, varidat, status)
       else ! ASCII table (hdutype = 1)
          ftype_in = 1
          call ftghtb(unit, MAXDIM, &
            &         rowlen, &
            &         nrows32, tfields, ttype, tbcol, tform, tunit, &
            &         extname,          status)
       endif
       ! deal with NAXIS2 > 2^31, 2015-04
#ifdef NO64BITS
       call ftgnrw  (unit, nrows32, status)
       nrows64 = nrows32
#else
       call ftgnrwll(unit, nrows64, status)
#endif

       !        parse TFORM keyword to find out the length of the column vector
       repeat1 = 1
       repeat2 = 1
       call ftbnfm(tform(1), datacode, repeat1, width, status)
       if (tfields > 1) call ftbnfm(tform(2), datacode, repeat2, width, status)

       !nsize = int(nrows32, kind=i8b) * max(repeat1,repeat2) ! corrected Oct-03
       nsize = int(nrows64, kind=i8b) * max(repeat1,repeat2) ! 2015-04

       nmaps_in = tfields

       call ftgkys(unit,'ORDERING',order_val,comment,status)
       if (status == 202) then ! Ordering not found
          ordering_in = 0
          order_val = ''
          status = 0
       endif

       call ftgkyj(unit,'NSIDE',nside_in,comment,status)
       if (status == 202) then ! Nside not found
          nside_in = -1
          status = 0
       endif

       call ftgkyj(unit,'OBS_NPIX',obs_npix_in,comment,status)
       if (status == 202) then ! obs_npix not found
          obs_npix_in = -1
          status = 0
       endif

       if (present(mlpol)) then
          call ftgkyj(unit,'MAX-LPOL',mlpol_in,comment,status)
          if (status == 202) then ! max-lpol not found
             status = 0
             call ftgkyj(unit,'LMAX',mlpol_in,comment,status)
             if (status == 202) then
                mlpol_in = -1
                status = 0
             endif
          endif
       endif

       if (present(fwhm_arcmin)) then
          call ftgkyd(unit,'FWHM',fwhm_arcmin_in, comment, status)
          if (status == 202) then ! fwhm not found
             fwhm_arcmin_in = -1.
             status = 0
          else
             fwhm_arcmin_in = 60.0_dp * fwhm_arcmin_in
          endif
       endif

       if (present(beam_leg)) then
          call ftgkys(unit,'BEAM_LEG',beam_leg_in, comment, status)
          if (status == 202) then ! beam_leg not found
             beam_leg_in = ' '
             status = 0
          endif
       endif

       if (present(coordsys)) then
          call ftgkys(unit,'COORDSYS',coordsys_in, comment, status)
          if (status == 202) then ! coordsys not found
             coordsys_in = ' '
             status = 0
          endif
       endif

       ! determines pixel indexing (for binary tables)
       if (present(type) .and. ftype_in == 999) then
          ! most stringent test
          call ftgkys(unit,'INDXSCHM',indxschm,comment,status)
          if (status == 0) then ! found
             ftype_in = 3
             if (trim(indxschm) == 'IMPLICIT') ftype_in = 2
             goto 1000
          else
             status = 0
          endif
          ! 2nd most stringent test
          call ftgkyj(unit,'GRAIN',grain,comment,status)
          if (status == 0) then ! found
             ftype_in = 3
             if (grain == 0) ftype_in = 2
             goto 1000
          else
             status = 0
          endif
          ! 3rd most stringent test
          if (trim(ttype(1)) /= '') then
             if (trim(ttype(1)) == 'PIXEL' .or. trim(ttype(1)) == 'PIX') then
                ftype_in = 3
             else
                ftype_in = 2
             endif
             goto 1000
          endif
          ! lousy test
          call ftgkys(unit,'OBJECT',object_val,comment,status)
          if (status == 0) then
             if (trim(object_val) == 'PARTIAL') ftype_in = 3
             if (trim(object_val) == 'FULLSKY') ftype_in = 2
             if (ftype_in /= 999) goto 1000
          else
             status = 0
          endif
          ! very lousy test
          if (nside_in > 0) then
             ftype_in = 3
             if (nside2npix(nside_in) == nsize) ftype_in = 2
             goto 1000
          endif
       endif
1000   continue

       ! find out if polarisation data is present
       if (present(polarisation)) then
          if (tfields < 3) then
             polarisation = 0 ! no polarisation
             goto 2000
          endif
          call ftgkyl(unit,'POLAR',polar_in,comment,status)
          if (status == 0) then ! polar found
             polarisation = 0
             if (polar_in) polarisation = 1
             goto 2000
          else ! polar not found
             status = 0
             polarisation = -1
             if (hdutype <= 0) goto 2000
             if (hdutype == 1) then ! ascii table -> power spectra
                ndp = 4
                defpol(1:ndp,1) = (/ "GRA","E-M","POW","EE " /)
                defpol(1:ndp,2) = (/ "CUR","B-M","POW","BB " /)    
             endif
             if (hdutype == 2) then ! binary table -> maps or power spectra
                ndp = 10
                defpol(1:ndp,1) = (/ "Q-P","Q_P","Q P", "Q-S","Q_S", &
                     &               "Q  ",      "GRA","E-M","POW","EE " /)
                defpol(1:ndp,2) = (/ "U-P","U_P","U P", "U-S","U_S", &
                     &               "U  ",      "CUR","B-M","POW","BB " /)
             endif
             pf(:) = .false.
             do i = 2, tfields ! do not consider first field (generally temperature)
                ttype_val = adjustl(ttype(i))
                call ftupch(ttype_val) ! upper case
                do k=1,2
                   do j=1, ndp
                      if (index( ttype_val, trim(defpol(j,k)) ) == 1) then
                         pf(k) = .true.
                         goto 1500 ! move to next field
                      endif
                   enddo
                enddo ! loop on k
1500            continue
             enddo ! loop on i
             if (pf(1) .and. pf(2)) polarisation = 1
             if (.not. (pf(1) .or. pf(2))) polarisation = 0
          endif ! polar not found
       endif ! present(polarisation)
2000   continue

       call ftgkys(unit,'POLCCONV',polcconv_val,comment,status)
       if (status == 0) then
          polcconv_in = 3 ! neither COSMO nor IAU
          if (trim(polcconv_val) == 'COSMO') polcconv_in = 1
          if (trim(polcconv_val) == 'IAU')   polcconv_in = 2
       else
          polcconv_in = 0 ! not found
          status = 0
       endif

    else ! no image no extension, you are dead, man
       ftype_in = -1
       call fatal_error(' No image, no extension')
    endif

    !     close the file
    call ftclos(unit, status)

    !     check for any error, and if so print out error messages
    if (status > 0) call printerror(status)

    getsize_fits=nsize

    call ftupch(order_val) ! convert order_val to upper case
    if (order_val(1:4) == 'RING') ordering_in = 1
    if (order_val(1:4) == 'NEST') ordering_in = 2

    if (present(nmaps))       nmaps       = nmaps_in
    if (present(mlpol))       mlpol       = mlpol_in
    if (present(obs_npix))    obs_npix    = obs_npix_in
    if (present(ordering))    ordering    = ordering_in
    if (present(nside))       nside       = nside_in
    if (present(type))        type        = ftype_in
    if (present(fwhm_arcmin)) fwhm_arcmin = fwhm_arcmin_in
    if (present(beam_leg))    beam_leg    = adjustl(beam_leg_in)
    if (present(coordsys))    coordsys    = adjustl(coordsys_in)
    if (present(polcconv))    polcconv    = polcconv_in

    return
  end function getsize_fits
  !=======================================================================
  function number_of_alms(filename, extnum)
    !=======================================================================
    !    Read the number of alms from a FITS-file containing alms          
    !    for constrained realisations in synfast.
    !
    !         Frode K. Hansen, April 1999
    !    EH. Jan 2004: use repeat information
    !=======================================================================
    character(len=*),           intent(in)    :: filename
    integer(I4B),     optional, intent(inout) :: extnum
    integer(I4B)                              :: number_of_alms
    !integer(I8B)                              :: number_of_alms

    integer(I4B), dimension(2)           :: naxes
    integer(I4B) :: status, unit, readwrite, blocksize, naxis, nfound
    integer(I4B) :: nmove, hdutype, hdunum
    integer(I4B) :: datacode, repeat, width
    character(len=80) :: comment
    character(len=20) :: tform
    logical(LGT)      ::  extend

    !-----------------------------------------------------------------------
    status=0
    unit = 118
    comment=''

    readwrite=0
    call ftopen(unit, filename, readwrite, blocksize, status)
    if (status > 0) call printerror(status)
    !     -----------------------------------------
    call ftgkyj(unit,'NAXIS', naxis, comment, status)

    !     determines the presence of an extension
    call ftgkyl(unit,'EXTEND', extend, comment, status)
    call assert (status<=0, 'No Extension in FITS file!')

    nmove = +1
    call ftmrhd(unit, nmove, hdutype, status)

    call assert (hdutype==2, 'This is not a FITS binary-table')

    call ftgknj(unit,'NAXIS', 1_i4b, 2_i4b, naxes, nfound, status)
    call assert (nfound>=2, 'NAXIS2-keyword not found!')

    call ftgkys(unit,'TFORM1', tform, comment, status)
    call ftbnfm(tform, datacode, repeat, width, status)

    number_of_alms = int(naxes(2),kind=i8b) * repeat

    if (present(extnum)) then
       call ftthdu(unit,hdunum,status)
       extnum = hdunum - 1 ! first HDU : primary array
    endif

    call ftclos(unit, status)

  end function number_of_alms

  !======================================================================
  subroutine putrec(unit, card, status)
    !======================================================================
    ! append, delete or update a card from the current header
    ! (deletion of keyword KWD is described by : - KWD)
    ! EH, version 1.0, Dec 2001
    !======================================================================
    integer(kind=I4B), intent(IN)  :: unit
    character(len=*),  intent(IN)  :: card
    integer(kind=I4B), intent(OUT) :: status

    character(len=80) :: cardfits,record
    character(len=8)  :: kwd
    integer(kind=I4B) :: hdtype
    character(len=80) :: nullarr(0)
    !======================================================================

    status = 0
    cardfits=''
    record=''
    call ftgthd(card, cardfits, hdtype, status)
    kwd = cardfits(1:8)
    status = 0

    select case (hdtype)
    case (-1) ! delete keyword (starting from the top)
       call ftgrec(unit,0_i4b,record,status)
       !             call ftdkey(unit, kwd, status)
       ! patch around cfitsio bug 
       ! (ftdkey does not recognize wild cards while ftgnxk does)
       do
          call ftgnxk(unit, kwd, 1_i4b, nullarr, 0_i4b, record, status)
          if (status /= 0) exit
          call ftdkey(unit, record(1:8), status)
       enddo
    case (0) ! append or update
       if (kwd == 'CONTINUE') then
          call ftprec(unit, trim(card), status)
       else
          ! if long string, put LongStringWarning
          if (index(card, "&'")>0) call ftplsw(unit, status)
          ! delete keyword in its current location (if any)
          call ftdkey(unit, kwd, status)
          status = 0
          ! append
          call ftprec(unit, trim(cardfits), status)
       endif
    case (1) ! append (for HISTORY and COMMENT)
       call ftprec(unit, trim(cardfits), status)
    case default
       write(unit=*,fmt=*)" Unexpected card format in fits header :"
       write(unit=*,fmt="(a80)") card
       write(unit=*,fmt=*)" card not written."
    end select
    status = 0

    return
  end subroutine putrec

  !====================================================================
  subroutine get_clean_header(unit, header, filename, error, xalso, xonly)
    !====================================================================
    ! get_clean_header(unit, header, error [, xalso, xonly])
    ! gets the FITS header from unit, after excluding some default keywords 
    !  defined in def_excl
    ! if header in non void on input, its content will be concatenated with that
    !  of the FITS header
    ! if xalso is defined as a list of keywords, they are also excluded from the header
    ! if xonly is defined as a list of keywords, only those keywords are excluded from
    ! the header.
    ! xonly and xalso are exclusive
    !====================================================================
    INTEGER(I4B),                    intent(IN)           :: unit
    CHARACTER(LEN=*), DIMENSION(1:), INTENT(IN OUT)       :: header
    CHARACTER(LEN=*),                INTENT(IN)           :: filename
    INTEGER(I4B),                    intent(OUT)          :: error
    character(len=8), dimension(1:), intent(IN), optional :: xalso
    character(len=8), dimension(1:), intent(IN), optional :: xonly

    INTEGER(I4B) :: nlheader, status, i, n_excl
    CHARACTER(LEN=80) :: record
    CHARACTER(len=8), dimension(:), allocatable :: to_excl

    CHARACTER(len=8), dimension(1:21) :: def_excl
    !====================================================================

    ! keywords to be excluded by default from output header
    ! Note that TTYPE# and TUNIT# keywords are not excluded
    ! from the output header as they might be useful to the 
    ! calling routines
    def_excl=(/&
         & "SIMPLE  ","BITPIX  ","NAXIS   ",&
         & "NAXIS#  ","PCOUNT  ","GCOUNT  ",&
         & "EXTEND  ","ORIGIN  ","DATE*   ",&
         & "TFIELDS ","TFORM#  ",           & 
         & "TBCOL#  ","EXTNAME ","CTYPE#  ",&
         & "CRVAL#  ","CRPIX#  ","CDELT#  ",&
         & "XTENSION","INSTRUME","TELESCOP",&
         & "PDMTYPE "/)

    error = 0
    record=''

    if (present(xonly)) then 
       n_excl = size(xonly)
       allocate(to_excl(1:n_excl))
       to_excl = xonly

    else if (present(xalso)) then
       n_excl = size(xalso) + size(def_excl)
       allocate(to_excl(1:n_excl))
       to_excl(1:size(def_excl)) = def_excl
       to_excl(size(def_excl)+1:n_excl) = xalso

    else
       n_excl = size(def_excl)
       allocate(to_excl(1:n_excl))
       to_excl = def_excl
    endif

    nlheader=size(header)
    ! go to end of fortran header
    do i = 1, nlheader
       if (trim(header(i)) == "") exit
    enddo
    ! go to top of fits file header
    status=0
    call ftgrec(unit,0_i4b,record,status)
    ! read in all header lines except those excluded
    do
       call ftgnxk(unit,'*',1_i4b,to_excl,n_excl,record,status)
       if (status > 0) exit ! end of header
       if (i > nlheader) then
          write(unit=*,fmt="(a,i5,a)") &
               & " WARNING : The header in "//  &
               &    trim(filename)//" has more than ", &
               &  nlheader," lines."
          print*," It will be truncated."
          error = 1
          exit
       endif
       header(i)=record
       i=i+1
    enddo
    status=0

    return
  end subroutine get_clean_header

  
  !====================================================================
  subroutine check_input_map(code, mapfile, polarisation)
  !====================================================================
    ! check out that file contains a valid HEALPIX map
    ! on input polarisation is set to T if one wants to get polarisation data from map,
    ! and on output it will be set to F if that is not possible
    !====================================================================
    use pix_tools, only: nside2npix, npix2nside
    character(len=*)                      :: code
    character(len=*)                      :: mapfile
    logical(LGT), intent(inout)           :: polarisation
    
    !
    integer(I4B) :: nmaps, order_map, nsmax, mlpol, type, polar_fits, polcconv
    integer(I4B) :: npixtot
    character(len=1) :: coordsys
    character(len=*), parameter :: primer_url = 'http://healpix.sf.net/pdf/intro.pdf'
    !====================================================================
    
    npixtot = getsize_fits(mapfile, nmaps = nmaps, ordering=order_map, nside=nsmax,&    
         &              mlpol=mlpol, type = type, polarisation = polar_fits, &
         &             coordsys=coordsys, polcconv=polcconv)
    
    if (nsmax<=0) then
       print*,"Keyword NSIDE not found in FITS header!"
       call fatal_error(code)
    endif
    if (type == 3) npixtot = nside2npix(nsmax) ! cut sky input data set
    if (nsmax/=npix2nside(npixtot)) then
       print 9000,"FITS header keyword NSIDE does not correspond"
       print 9000,"to the size of the map!"
       call fatal_error(code)
    endif

    if (polarisation .and. (nmaps >=3) .and. polar_fits == -1) then
       print 9000,"The input fits file MAY NOT contain polarisation data."
       print 9000,"Proceed at your own risk"
    endif
    
    if (polarisation .and. (nmaps<3 .or. polar_fits ==0)) then
       print 9000,"The file does NOT contain polarisation maps"
       print 9000,"only the temperature field will be analyzed"
       polarisation = .false.
    endif
    
    ! POLCCONV now dealt with in input_map
!     if (polarisation .and. (polcconv == 3)) then
!        print 9000,"The polarisation coordinate convention (POLCCONV) is neither COSMO nor IAU."
!        print 9000,code//" can not proceed with these data"
!        print 9000,"See Healpix primer ("//primer_url//") for details."
!        call fatal_error(code)
!     endif
    
!     if (polarisation .and. (polcconv == 2)) then
!        print 9000,"The input map contains polarized data in the IAU coordinate convention (POLCCONV)"
!        print 9000,code//" can not proceed with these data"
!        print 9000,"See Healpix primer ("//primer_url//") for details."
!        call fatal_error(code)
!     endif
    
!     if (polarisation .and. (polcconv == 0)) then
!        print 9000,"WARNING: the polarisation coordinate convention (POLCCONV) can not be determined"
!        print 9000,"         COSMO will be assumed."
!        print 9000,"See Healpix primer ("//primer_url//") for details."
!     endif
    
    !     --- check ordering scheme ---
    if ((order_map/=1).and.(order_map/=2)) then
       print 9000,"The ordering scheme of the map must be RING or NESTED."
       print 9000,"No ordering specification is given in the FITS-header!"
       call fatal_error(code)
    endif
    
9000 format(a)
    
    return
  end subroutine check_input_map
      

end module fitstools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module udgmod

  USE healpix_types
  USE fitstools, ONLY : getsize_fits, write_bintab, input_map
  USE pix_tools, ONLY : nside2npix, npix2nside
  USE misc_utils
  USE head_fits, ONLY : add_card, del_card, get_card, write_minimal_header
  USE udgrade_nr, ONLY : udgrade_ring, udgrade_nest
  USE extension, ONLY : getArgument, nArguments
  USE paramfile_io
  IMPLICIT none

  character(len=*), parameter :: CODE = "UD_GRADE"
  character(len=FILENAMELEN)  :: lcode

  private
  public :: udg_sub_s, udg_sub_d, CODE, lcode

  contains

    subroutine udg_sub_s(parafile)
      ! single precision implementation
      integer(I4B),               parameter  :: KMAP  = SP  ! precision of map arrays
      character(len=FILENAMELEN), intent(in) :: parafile
      include 'udg_sub_inc.f90'
    end subroutine udg_sub_s
    !------------------------------------


    subroutine udg_sub_d(parafile)
      ! double precision implementation
      integer(I4B),               parameter  :: KMAP  = DP  ! precision of map arrays
      character(len=FILENAMELEN), intent(in) :: parafile
      include 'udg_sub_inc.f90'
    end subroutine udg_sub_d

end module udgmod
!====================================================================================

program ud_grade

  use healpix_types
  use extension, only: getArgument, nArguments
  use udgmod,    only: udg_sub_s, udg_sub_d, CODE, lcode
  use misc_utils,only: assert, fatal_error, strlowcase

  integer(i4b)                :: n_args, i
  character(len=FILENAMELEN)  :: arg
  logical(lgt)                :: do_double
  character(len=FILENAMELEN)  :: parafile

  ! count arguments, should be 0, 1 or 2
  n_args = nArguments()
  lcode = trim(strlowcase(CODE))
  call assert(n_args <= 2,' Usage: '//trim(lcode)//' [-s|--single|-d|--double] [parameter_file_name]')

  parafile = ''
  do_double = .false.

  ! parse arguments
  do i=1, n_args
     call getArgument(i, arg)
     arg = trim(adjustl(arg))
     if (arg(1:1) == '-') then
        select case (trim(arg))
        case ('-d', '--double')
           do_double = .true.
        case ('-s', '--single')
           do_double = .false.
        case default
           call fatal_error(CODE//': Invalid argument: '//trim(arg))
        end select
     else
        parafile = arg
     endif
  enddo

  ! start calculations
  if (do_double) then
     call udg_sub_d(parafile)
  else
     call udg_sub_s(parafile)
  endif

  stop
end program ud_grade

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! Simulation of full sky map of CMB anisotropies from their power spectrum
! in HEALPIX pixelisation.
! Written and developed by E. Hivon (efh@ipac.caltech.edu) and K. Gorski
! (krzysztof.m.gorski@jpl.nasa.gov) based on HEALPIX pixelisation developed
! by K. Gorski
!
! Copyright 1997 by Eric Hivon and Krzysztof M. Gorski.
!  All rights reserved.
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!=======================================================================
  !=======================================================================
  !  EXTERNAL LIBRARY:
  !     this code uses the CFITSIO library that can be found at
  !     http://heasarc.gsfc.nasa.gov/docs/software/fitsio/
  !
  !  RELATED LITTERATURE:
  !     about HEALPIX   : see Gorski et al, 2005, ApJ, 622, 759
  !     about this code : see Hivon & Gorski, 1997, in preparation
  !
  !  HISTORY:
  !     April-October 1997, Eric Hivon, TAC
  !               Jan 1998 : translation in Fortran 90
  !               Aug 1998 : version 1.0.0
  !               Apr 1999 : constr.real, precomp.plms included, FKH
  !               Nov 2000 : v 1.2, EH
  !               Sep 2002 : implement new parser
  !               2004-2005: v 2.0
  !               2006-2007: v 2.1
  !               Jun 2010 : supports large maps
  !
  !  FEEDBACK:
  !     for any questions : hivon@iap.fr
  !
  !=======================================================================
  !     version 2.2.0
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file synfast.f90 by the command  include
  !
  integer(I4B),             parameter :: KALM  = KMAP ! precision of alm arrays
  integer(I4B),             parameter :: KALMC = KIND((1.0_KMAP, 1.0_KMAP)) ! precision of alm arrays
  integer(I4B),             parameter :: KCL   = KMAP  ! precision of c(l) arrays
  !-------------------------------------------------------------------------

  integer(I4B) :: nsmax, nlmax, nmmax

  COMPLEX(KALMC), DIMENSION(:,:,:), ALLOCATABLE :: alm_TGC
  REAL(KALM),     DIMENSION(:,:),   ALLOCATABLE :: alms_in
  REAL(KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_TQU
  REAL(DP),       DIMENSION(:,:),   ALLOCATABLE :: plm
  real(DP),       dimension(:,:),   allocatable :: beam_const, pixel_const
  integer(I4B) :: status

  integer(I4B) l, m         !, alms
  integer(I8B) npixtot
  integer(I4B) i, j, junk
  integer(I4B) iseed, ioriginseed
  integer(I4B) simul_type
  integer(I4B) polar, polar_cl
  integer(I4B) nlheader, nalms, extnum_alms
  integer(I8B) :: n_plm
  integer(I4B) :: plm_nside, plm_lmax, plm_pol, plm_mmax

  REAL(KALM) :: fwhm_arcmin, fwhm_deg, pix_size_arcmin
  REAL(SP) :: clock_time, time0, time1
  REAL(SP) :: ptime, ptime0, ptime1
  REAL(DP) :: nullval

  character(len=FILENAMELEN)          :: infile
  character(len=FILENAMELEN)          :: outfile
!  character(len=FILENAMELEN)          :: parafile = ''
  character(len=FILENAMELEN)          :: infile_alms
  character(len=FILENAMELEN)          :: outfile_alms
  character(len=FILENAMELEN)          :: infile_plm
  character(len=FILENAMELEN)          :: windowfile
  character(len=FILENAMELEN)          :: windowname
  character(len=FILENAMELEN)          :: def_dir, def_file
  character(len=FILENAMELEN)          :: usr_dir, usr_file
  character(len=FILENAMELEN)          :: final_file
  character(len=FILENAMELEN)          :: healpixtestdir
  character(len=FILENAMELEN)          :: beam_file
  character(len=80), DIMENSION(1:180) :: header_PS
  character(len=80), DIMENSION(1:180) :: header
!  character(len=4)                    :: sstr
  LOGICAL(LGT) :: ok, bad, polarisation, input_cl, input_alms, do_map, output_alms, apply_windows
!   character(len=*), PARAMETER :: code = "SYNFAST"
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  character(len=80), allocatable, dimension(:) :: units_alm, units_map

  type(paramfile_handle) :: handle
  character(len=FILENAMELEN)          :: description
  character(len=100)                  :: chline
  type(planck_rng) :: rng_handle

  integer(i4b) :: deriv, n_pols, n_maps
  character(len=20) :: coordsys = ' '
  real(DP), dimension(1:2) :: zbounds
!  real :: ttime0, ttime1, ttime2

  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------
  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  PRINT *, " "
  PRINT *,"                    "//code//" "//version
  write(*,'(a)') &
       & " *** Synthesis of a Temperature (and Polarisation) map from its power spectrum ***"
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  PRINT *, " "
  handle = parse_init(parafile)

  !     --- choose temp. only or  temp. + pol. ---
  description = concatnl( &
       & " Do you want to simulate", &
       & " 1) Temperature only", &
       & " 2) Temperature + polarisation", &
       & " 3) Temperature + 1st derivatives", &
       & " 4) Temperature + 1st & 2nd derivatives", &
       & " 5) T+P + 1st derivatives", &
       & " 6) T+P + 1st & 2nd derivates")
  simul_type = parse_int(handle, 'simul_type', default=1, vmin=1, vmax=6, descr=description)
  deriv = 0 ! no derivatives
  polarisation = (simul_type == 2 .or. simul_type == 5 .or. simul_type == 6)
  if (simul_type == 3 .or. simul_type == 5) deriv = 1
  if (simul_type == 4 .or. simul_type == 6) deriv = 2

  !     --- gets the effective resolution of the sky map ---
3 continue
  description = concatnl( &
       & "", &
       & " Enter the resolution parameter (Nside) for the simulated skymap: ",&
       & " (Npix = 12*Nside**2, where Nside HAS to be a power of 2, eg: 32, 512, ...)" )
  nsmax = parse_int(handle, 'nsmax', default=32, descr=description)
  if (nside2npix(nsmax) < 0) then
     print *, " Error: nsmax is not a power of two."
     if (handle%interactive) goto 3
     call fatal_error(code)
  endif

  !     --- gets the L range for the simulation ---
  WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",3*nsmax-1,")"
  description = concatnl(&
       & "", &
       & " Enter the maximum l range (l_max) for the simulation. ", &
       & chline )
  nlmax = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)

  ! ----------  default parameters ----------------
  nmmax   = nlmax
  npixtot = nside2npix(nsmax)
  pix_size_arcmin = 360.*60./SQRT(npixtot*PI)
  !   -------------------------------------

  !     --- gets the file name for the Power Spectrum ---
  chline = ''
  healpixtestdir = get_healpix_test_dir()
  if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/cl.fits'
  description = concatnl(&
       & "", &
       & " Enter input Power Spectrum filename", &
       & " If '' (empty single quotes) is typed, no file is read ", &
       & "    (then an alm_file should be entered later on)")
  infile = parse_string(handle, 'infile', default=chline, descr=description, filestatus='old')
  input_cl = (trim(infile) /= "")

  !     --- inputs the random seed ---
  description = concatnl(&
       & "", &
       & " Enter NON-ZERO random seed (eg: -1) : ", &
       & "  if set to zero, it will be over-riden by self generated seed. " )
  iseed = parse_int(handle, 'iseed', default=-1, descr=description)
!!  iseed = -ABS(iseed)

  !     --- inputs the FWHM or beam file ---
  beam_file = ''
  description = concatnl(&
       & "", &
       & " Enter the Gaussian beam FWHM in arcmin >= 0 (eg: 420.) : ")
  fwhm_arcmin = parse_double(handle, 'fwhm_arcmin', default=420.0_dp, vmin=0.0_dp,descr=description)

  description = concatnl(&
       & "", &
       & " Enter an external file name containing ", &
       & " a symmetric beam Legendre transform (eg: mybeam.fits)", &
       & " NB: if set to an existing file, it will override the FWHM chosen above", &
       & "     if set to '', the gaussian FWHM will be used.")
  beam_file = parse_string(handle, 'beam_file', default="''", &
       &                 descr=description, filestatus='old')
  if (trim(beam_file) /= '') then
     fwhm_arcmin = 0.
     print*,'fwhm_arcmin is now : 0.'
     print*,'The beam file '//trim(beam_file)//' will be used instead.'
  endif
  fwhm_deg = fwhm_arcmin/60.

  !     --- check for pixel-window-files ---
  windowname = get_healpix_pixel_window_file(nsmax)

  def_file = trim(windowname)
  def_dir  = get_healpix_data_dir()

22 continue
  final_file = ''
  ok = .false.
  ! if interactive, try default name in default directories first
  if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
  if (.not. ok) then
     ! not found, ask the user
     description = concatnl("",&
          &        " Could not find window file", &
          &        " Enter the directory where this file can be found:")
     usr_dir = parse_string(handle,'winfiledir',default="''",descr=description)
     if (trim(usr_dir) == '') usr_dir = trim(def_dir)
     description = concatnl("",&
          &        " Enter the name of the window file:")
     usr_file = parse_string(handle,'windowfile',default=def_file,descr=description)
     ! look for new name in user provided or default directories
     ok   = scan_directories(usr_dir, usr_file, final_file)
     ! if still fails, crash or ask again if interactive
     if (.not. ok) then
        print*,' File not found'
        if (handle%interactive) goto 22
        call fatal_error(code)
     endif
  endif
  windowfile = final_file

  !     --- constrained realisations ---
  description = concatnl( &
       & "", &
       & " Enter name of file with constraining a_lms :", &
       & "(eg, alms.fits;  if '' is typed, no file is read)", &
       & " These should EITHER already have the same beam and pixel as the final map,", &
       & "OR be totally free of beam and pixel window.", &
       & " See the alteralm facility if neither is true.")
  infile_alms = parse_string(handle, 'almsfile', default="''", &
       &                     descr=description, filestatus="old")
  input_alms = (trim(infile_alms) /= "")

  if (input_alms) then

     nalms=number_of_alms(infile_alms,extnum=extnum_alms)
     junk = getsize_fits(infile_alms, coordsys=coordsys)

  !      --- apply windows to constraining alms ---
     description = concatnl( &
          & "", &
          & " Do you want to use the constraining a_lms as they are, (F) ", &
          & "or apply first the beam and pixel window functions chosen previously ? (T)", &
          & " The latter assumes the a_lm to be free of any window functions,", &
          & " see the alteralm facility if these a_lm already have different window functions.")
     apply_windows = parse_lgt(handle, 'apply_windows', default=.false., descr=description)

  endif

  ! --- check that some form of input has been given ---
  if (.not. input_cl .and. .not. input_alms) then
     print *," "
     print *," "//code//"> ERROR: No input spectrum were given"
     print *," "//code//"> ERROR:   and the a_lm were not constrained"
     print *," "//code//"> ERROR: No map can be generated"
     call fatal_error("Abort execution")
  endif

  !          --- precomputed plms  ---
40 continue
  n_plm   = 0
  plm_pol = 0
  description = concatnl(&
       & "", &
       & " Enter name of file with precomputed p_lms :", &
       & "(eg, plm.fits; if '' is typed, no file is read)" )
  infile_plm = parse_string(handle, 'plmfile', default="''", descr=description, filestatus='old')

  if (trim(infile_plm) /= "") then
     ! check that the plm file matches the current simulation (for nside,lmax,mmax)
     call read_par(infile_plm, plm_nside, plm_lmax, plm_pol, mmax=plm_mmax)

     if ((plm_pol /= 1).and.(.not.polarisation)) plm_pol=1

     if (plm_nside /= nsmax .or. plm_lmax /= nlmax .or. plm_mmax /= nmmax) then
        print *," "//code//"> Plm file does not match map to simulate in Nside, Lmax or Mmax ! "
        print*,'nside (plm file, map) = ',plm_nside,nsmax
        print*,'lmax                  = ',plm_lmax,nlmax
        print*,'mmax                  = ',plm_mmax,nmmax
        if (handle%interactive) goto 40
        call fatal_error(code)
     endif
     n_plm = (nmmax + 1_i8b)*(2*nlmax + 2_i8b - nmmax)*nsmax
     print *," "
  endif

  !     --- gets the output sky map filename ---
  description = concatnl(&
       & "", &
       & " Enter Output map file name (eg, test.fits) :", &
       & "  (or !test.fits to overwrite an existing file)" , &
       & " (If '', no map is created) ")
  outfile = parse_string(handle, "outfile", &
       & default="!test.fits", descr=description, filestatus="new")
  do_map = (trim(outfile) /= '')

  !     --- gets the output alm-filename ---
  description = concatnl(&
       & "", &
       & " Enter file name in which to write a_lm used to synthesize the map : ", &
       & " (eg alm.fits or !alms.fits to overwrite an existing file): ", &
       & " (If '', the alms are not written to a file) ")
  outfile_alms = parse_string(handle, 'outfile_alms', &
       & default="''", descr=description, filestatus='new')
  output_alms = (trim(outfile_alms) /= '')

  PRINT *," "
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
  call brag_openmp()

  !     --- If necessary use current system time to set seed  ---
  IF (iseed .eq. 0) THEN
     CALL SYSTEM_CLOCK(COUNT = iseed)
     !-- Seed should initially be set to a large, odd integer --
     IF (MOD(iseed,2) .EQ. 0) iseed = iseed + 1
     PRINT *,"      "//code//"> Generating random number seed ", iseed
  END IF
  ioriginseed = iseed

  ! --- initialize random sequence ---
  call rand_init(rng_handle, iseed) ! takes up to 4 seeds simultaneously

  !-----------------------------------------------------------------------
  !                  allocates space for arrays
  !-----------------------------------------------------------------------
  polar = 0
  if (polarisation) polar = 1
  n_pols = 1 + 2*polar ! either 1 or 3
  n_maps = max(n_pols, 3*deriv*n_pols) ! either 1 (T), 3 (TQU or T+d1) or 6 (T+d1+d2) or 9 (T,Q,U+d1) or 18 (T,Q,U+d1+d2)

  ALLOCATE(units_alm(1:n_pols),units_map(1:n_maps),stat = status)
  call assert_alloc(status,code,"units_alm & units_map")
  units_alm(:)=''

  ALLOCATE(alm_TGC(1:n_pols, 0:nlmax, 0:nmmax),stat = status)
  call assert_alloc(status,code,"alm_TGC")

  if (do_map) then
     ALLOCATE(map_TQU(0:npixtot-1, 1:n_maps),stat = status)
     call assert_alloc(status,code,"map_TQU")
  endif


  !-----------------------------------------------------------------------
  !                    creates/reads (and write) the a_lm
  !-----------------------------------------------------------------------

  PRINT *,"      "//code//"> Generating alm coefficients "
  PRINT *,"      "//code//"> Pixel window file:"//trim(adjustl(windowfile))

  alm_TGC = 0. ! very important

  if (input_cl) then
     polar_cl =     polar  ! 0 or 1: input 1 or 4 field spectrum
     !polar_cl = 2 * polar  ! 0 or 2; input 1 or 6 field spectrum
     call create_alm(nsmax, nlmax, nmmax, polar_cl, &
          & infile, rng_handle, fwhm_arcmin, &
          & alm_TGC, header_PS, windowfile, units=units_alm, beam_file=beam_file)
     units_map(1:n_pols) = units_alm(1:n_pols)
     call del_card(header_PS, (/ "TUNIT#","TTYPE#"/))
  else
     header_PS = ""
     units_map = "unknown"
  endif

  !      --- constrained alms ---
  ! they are assumed to produce a REAL map
  ! therefore the a_lm with m<0 are ignored
  ! and are assumed to be a_l-|m| = (-1)^m a_l|m|
  if (input_alms) then

     allocate(alms_in(0:nalms-1,1:6),stat = status)
     call assert_alloc(status,code,"alms_in")
     alms_in = 0.0_KALM

     if (apply_windows) then
        allocate(pixel_const(0:nlmax, 1:n_pols), beam_const(0:nlmax, 1:n_pols), stat=status)
        call assert_alloc(status, CODE, "pixel_const, beam_const")
        call pixel_window(pixel_const, windowfile=windowfile)
        call generate_beam(real(fwhm_arcmin,kind=dp), nlmax, beam_const, beam_file=beam_file)
        beam_const = pixel_const * beam_const
        deallocate(pixel_const)
     else
        allocate(beam_const(0:nlmax, 1:n_pols), stat=status)
        beam_const = 1.0_KALM
     endif

     PRINT *,"      "//code//"> Reading alms for constrained realisations "
     if (apply_windows) PRINT *,"      "//code//"> and applying same beam and pixel size on them"
     do j = 1, MIN(n_pols,extnum_alms)
        call read_conbintab(infile_alms, alms_in(0:nalms-1,1:6), nalms,extno=j-1_i4b)
        do i=0,nalms-1
           l = nint(alms_in(i,1))
           m = nint(alms_in(i,2))
           if (m < 0) then
              write(*,'(a,i6,a,i6)') '     the a_lm with m<0 are ignored, l=',l,', m=',m
           else
  ! MR: the constraining a_lm in the input file could have entries with
  !     l>nlmax. If they were entered into alm_TGC, this would cause memory
  !     corruption, so this must be checked.
              if (l <= nlmax) then
                 alm_TGC(j,l,m) = &
!                &   CMPLX(alms_in(i,3)+randgauss_boxmuller(iseed)*alms_in(i,5), &
!                &         alms_in(i,4)+randgauss_boxmuller(iseed)*alms_in(i,6), kind=KALM) * beam_const(l,j)
               &   CMPLX(alms_in(i,3)+rand_gauss(rng_handle)*alms_in(i,5), &
               &         alms_in(i,4)+rand_gauss(rng_handle)*alms_in(i,6), kind=KALM) * beam_const(l,j)
              endif
           endif
        enddo
     enddo

     deallocate(alms_in)
     deallocate(beam_const)
  endif

  if (output_alms) then

     PRINT *,"      "//code//"> outputting alms "

     ! write each component (T,G,C) in a different extension of the same file
     do i = 1, n_pols
        header = ""
        ! put inherited information immediatly, so that keyword values can be updated later on
        ! by current code values
        call add_card(header,"COMMENT","****************************************************************")
        call merge_headers(header_PS, header) ! insert header_PS in header at this point
        call add_card(header,"COMMENT","****************************************************************")

        ! start putting information relative to this code and run
        call write_minimal_header(header, 'alm', append=.true., &
             creator = CODE, version = VERSION, &
             nlmax = nlmax, nmmax = nmmax, randseed = ioriginseed, &
             units = units_alm(i), polar = polarisation)
        if (i == 1) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (TEMPERATURE)'", update = .true.)
        elseif (i == 2) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (GRAD / ELECTRIC component)'", update = .true.)
        elseif (i == 3) then
           call add_card(header,"EXTNAME","'SIMULATED a_lms (CURL / MAGNETIC component)'", update = .true.)
        endif
        if (input_alms) then
           call add_card(header,"HISTORY","File constraining alms:")
           call add_card(header,"HISTORY",trim(infile_alms))
           if (apply_windows) then
              call add_card(header,"HISTORY","These alms are multiplied by pixel and beam window functions")
           else
              call add_card(header,"HISTORY","These alms are used as they are.")
           endif
        endif
        if (input_cl) then
           call add_card(header,"HISTORY","File with input C(l):")
           call add_card(header,"HISTORY",trim(infile))
           call add_card(header,"HISTORY","These alms are multiplied by pixel and beam window functions")
        endif
        if (input_cl .or. (input_alms.and.apply_windows)) then
           call add_card(header,"NSIDE"   ,nsmax,   "Resolution parameter for HEALPIX")
           if (trim(beam_file) == '') then
              call add_card(header,"FWHM"    ,fwhm_deg   ," [deg] FWHM of gaussian symmetric beam")
           else
              call add_card(header,"BEAM_LEG",trim(beam_file), &
                   & "File containing Legendre transform of symmetric beam")
           endif
        endif
        call add_card(header,"HISTORY")
        nlheader = SIZE(header)
        call dump_alms (outfile_alms,alm_TGC(i,0:nlmax,0:nmmax),nlmax,header,nlheader,i-1_i4b)
     enddo
  endif

  !   skip to the end if no map is asked for
  if (.not. do_map) goto 1000
  !-----------------------------------------------------------------------
  !                    precomputed plms
  !-----------------------------------------------------------------------

  if (n_plm.ne.0) then

     allocate(plm(0:n_plm-1,1:plm_pol),stat = status)
     call assert_alloc(status,code,"plm")

     if (plm_pol.eq.1) then
        PRINT*,"      "//code//"> Reading precomputed scalar P_lms "
     else
        PRINT*,"      "//code//"> Reading precomputed tensor P_lms "
     endif
!!     call read_dbintab(infile_plm,plm,n_plm,plm_pol,nullval,anynull=bad)
     call read_bintab(infile_plm, plm, n_plm, plm_pol, nullval, anynull=bad)
     if (bad) call fatal_error("Missing points in P_lm-file!")

  endif

  !-----------------------------------------------------------------------
  !                           a_lm to map
  !-----------------------------------------------------------------------

  PRINT *,"      "//code//"> Generating sky map(s) "

  zbounds=(/-1.0_DP, 1.0_DP/) ! full sky  = default
  select case (plm_pol + polar*10 + deriv*100)
  case(0) ! temperature only
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1), &
          &       zbounds=zbounds)
  case(1) ! temperature only with precomputed Ylm
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1),plm=plm(:,1))
  case(10) ! T+P
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU, &
                  zbounds=zbounds)
  case(11) ! T+P with precomputed Ylm_T
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU,plm=plm(:,1))
   case(13)  ! T+P with precomputed Ylm
     call alm2map(nsmax,nlmax,nmmax,alm_TGC,map_TQU,plm=plm)
  case(100)
     call alm2map_der(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1),&
                      der1=map_TQU(:,2:3), zbounds=zbounds)
  case(200)
     call alm2map_der(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1),&
          &           der1=map_TQU(:,2:3),der2=map_TQU(:,4:6), zbounds=zbounds)
  case(110)
     call alm2map_der(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1:3),&
                      der1=map_TQU(:,4:9), zbounds=zbounds)
  case(210)
     call alm2map_der(nsmax,nlmax,nmmax,alm_TGC,map_TQU(:,1:3),&
          &           der1=map_TQU(:,4:9),der2=map_TQU(:,10:18), zbounds=zbounds)
  case default
     print*,'Not valid case'
     print*,'Polarisation:', polarisation
     print*,'Derivatives: ', deriv
     print*,'P_lm pol:    ', plm_pol
     call fatal_error(code)
  end select

  if (n_plm.ne.0) then
     deallocate(plm)
  endif

  !-----------------------------------------------------------------------
  !                      write the map to FITS file
  !-----------------------------------------------------------------------

  nlheader = SIZE(header)
  header = ""
  PRINT *,"      "//code//"> Writing sky map to FITS file "
  ! put inherited information immediatly, so that keyword values can be updated later on
  ! by current code values
  call add_card(header,"COMMENT","****************************************************************")
  call merge_headers(header_PS, header) ! insert header_PS in header at this point
  call add_card(header,"COMMENT","****************************************************************")
  ! start putting information relative to this code and run
  call write_minimal_header(header, 'map', append=.true., &
       nside = nsmax, ordering = 'RING', coordsys = coordsys, &
       fwhm_degree = fwhm_arcmin / 60.d0, &
       beam_leg = trim(beam_file), &
       polar = polarisation, &
       deriv = deriv, &
       creator = CODE, version = VERSION, &
       nlmax = nlmax, &
       randseed = ioriginseed, &
       units = units_map(1) )
  ! update 'EXTNAME' in place
  call add_card(header,"EXTNAME","'SIMULATED MAP'", update=.true.)
  call add_card(header,"COMMENT","*************************************")
  if (input_alms) then
     call add_card(header,"HISTORY","File constraining alms:")
     call add_card(header,"HISTORY",trim(infile_alms))
     if (apply_windows) then
        call add_card(header,"HISTORY","These alms are multiplied by pixel and beam window functions")
     else
        call add_card(header,"HISTORY","These alms are used as they are.")
     endif
  endif


  ! call output_map(map_TQU(0:npixtot-1,1:n_maps), header, outfile) !not on Sun
  call write_bintab(map_TQU, npixtot, n_maps, header, nlheader, outfile)
  
  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------

  DEALLOCATE( map_TQU )
1000 continue ! no map done
  DEALLOCATE( alm_TGC )
  DEALLOCATE( units_alm, units_map )

  !-----------------------------------------------------------------------
  !                      output and report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" simulation run"
  write(*,9000) "----------------------------------------"
  write(*,9000) " "
  if (.not. polarisation) then
     chline = "      Temperature alone"
     if (deriv == 1) chline = "      Temperature + 1st derivatives"
     if (deriv == 2) chline = "     Temperature + 1st & 2nd derivatives"
  else
     chline = "    Temperature + Polarisation"
     if (deriv == 1) chline = "      T+P + 1st derivatives"
     if (deriv == 2) chline = "     T+P + 1st & 2nd derivatives"
  endif
  write(*,9000) chline
  write(*,9000) " "
  write(*,9000) " Input power spectrum : "//TRIM(infile)
  if (input_alms) then
     write(*,9000) " Constraining a_lms : "//TRIM(infile_alms)
  endif
  write(*,9005) " Multipole range      : 0 < l <= ", nlmax
  write(*,9010) " Number of pixels     : ", npixtot
  write(*,9020) " Pixel size in arcmin : ", pix_size_arcmin
  write(*,9010) " Initial random # seed: ", ioriginseed
  if (trim(beam_file) == '') then
     write(*,9020) " Gauss. FWHM in arcmin: ", fwhm_arcmin
  else
     write(*,9000) " Beam file: "//trim(beam_file)
  endif
  if (do_map) then
     write(*,9000) " Output map           : "//TRIM(outfile)
  else
     write(*,9000) " no map done!"
  endif
  if (output_alms) then
     write(*,9000) " Output a_lms in      : "//TRIM(outfile_alms)
  endif
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! Computes the spherical harmonics coefficients (a_lm)
! and the power spectrum from a full sky map in HEALPIX pixelisation
! Written and developed by E. Hivon (hivon@iap.fr) and K. Gorski
! (krzysztof.m.gorski@jpl.nasa.gov) based on HEALPIX pixelisation developed
! by K. Gorski
!
! Copyright 1997 by Eric Hivon and Krzysztof M. Gorski.
!  All rights reserved.
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!=======================================================================
  !=======================================================================
  !  EXTERNAL LIBRARY:
  !     this code uses the CFITSIO library that can be found at
  !     http://heasarc.gsfc.nasa.gov/docs/software/fitsio/
  !
  !  RELATED LITTERATURE:
  !     about HEALPIX   : see Gorski et al, 2005, ApJ, 622, 759
  !     about this code : see Hivon & Gorski, in preparation
  !
  !  HISTORY:
  !     April-October 1997, Eric Hivon, TAC (f77)
  !               Jan 1998 : translation in Fortran 90
  !               Aug 1998 : version 1.0.0
  !               Apr 1999 : precomp. plms, higher order iterations and alm dumping, FKH
  !               Aug 2000 : CMBFAST convention for polarisation
  !               Sep 2002 : implement new parser
  !               May 2007 : can cross-correlate 2 maps, introduced map2alm_iterative
  !               Jun 2010 : supports large maps
  !               May 2012:  pro/down-grading of mask now works
  !
  !  FEEDBACK:
  !     for any questions : hivon@iap.fr
  !
  !=======================================================================
  !     version 2.3
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file anafast.f90 by the command  include
  !
  integer(I4B),             parameter :: KALMC = KIND((1.0_KMAP, 1.0_KMAP)) ! precision of alm arrays
  integer(I4B),             parameter :: KCL   = KMAP  ! precision of c(l) arrays
  !-------------------------------------------------------------------------

  integer(I4B) :: nsmax, nlmax, nmmax, nsmax2

  complex(kind=KALMC), DIMENSION(:,:,:), ALLOCATABLE :: alm_TGC, alm_TGC2
  real(kind=KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_TQU, map_TQU2
  real(kind=KMAP),     DIMENSION(:,:), target, ALLOCATABLE :: mask, mask_tmp
  real(kind=KMAP),     dimension(:,:), pointer :: pmask, pmask_tmp
  real(kind=KCL),      DIMENSION(:,:),   ALLOCATABLE :: clout
  real(kind=KCL),      DIMENSION(:),     ALLOCATABLE :: fact_norm
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: w8ring_TQU
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: dw8
  real(kind=DP),       DIMENSION(:,:),   ALLOCATABLE :: plm
!  real(kind=KMAP),     dimension(:,:),   ALLOCATABLE :: pw8list
  real(kind=KMAP),     dimension(:,:), target, ALLOCATABLE :: pw8map
  integer(kind=I4B) :: status

  integer(kind=I4B) :: mlpol, mlpol2
  integer(kind=I4B), dimension(1:2) :: order_map
  integer(kind=I4B) :: l, plm_nside, plm_lmax, plm_pol, plm_mmax
  integer(kind=I8B) :: npixtot, npixtot2, ipix, n_plm !, n_pw8_read
  integer(kind=I4B) :: i, j
  integer(kind=I4B) :: iter_order, polar, n_pols, n_maps
  integer(kind=I4B) :: simul_type
  integer(kind=I4B) :: n_rings, n_rings_read, won, nmw8

  real(kind=KMAP)               :: fmissval, fmiss_mask
  real(kind=DP)                 :: pix_size_arcmin
  real(kind=DP)                 :: theta_cut_deg, cos_theta_cut
  real(kind=DP)                 :: nullval
  real(kind=DP), dimension(1:2) :: zbounds
  real(kind=DP)                 :: fsky
  real(kind=SP)                 :: clock_time, time0, time1
  real(kind=SP)                 :: ptime, ptime0, ptime1
  real(kind=DP)                 :: min_mask, max_mask

  character(len=80), DIMENSION(1:120) :: header
  integer(kind=I4B) :: ncl, nlheader

  character(len=FILENAMELEN), dimension(2) :: infile
  character(len=FILENAMELEN)          :: outfile
!  character(len=FILENAMELEN)          :: parafile = ''
  character(len=FILENAMELEN), dimension(2) :: outfile_alms
  character(len=FILENAMELEN)          :: infile_plm
  character(len=FILENAMELEN)          :: infile_w8
  character(len=FILENAMELEN)          :: w8name
  character(len=FILENAMELEN)          :: def_dir, def_file
  character(len=FILENAMELEN)          :: usr_dir, usr_file
  character(len=FILENAMELEN)          :: final_file
  character(len=FILENAMELEN)          :: healpixtestdir
  character(len=FILENAMELEN)          :: description
  character(len=FILENAMELEN)          :: maskfile
  character(len=100)                  :: chline, chline1, strw8file
  character(len=20)                   :: coordsys, coordsys2
!  character(len=5)                    :: sstr
  LOGICAL(kind=LGT) :: bad, ok, polarisation, bcoupling, do_mask, twomaps, asym_cl
!   character(len=*), PARAMETER :: code = "ANAFAST"
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  character(len=80), dimension(1:3,1:2)   :: units_map
  character(len=80), dimension(1:3)       :: units_pow

  type(paramfile_handle) :: handle

  real(kind=DP), dimension(0:3,1:2) :: mono_dip
  real(kind=DP)                 :: theta_dip, phi_dip, long_dip, lat_dip, ampl_dip
  integer(kind=I4B)             :: lowlreg

  integer(kind=I4B)        :: npix_mask, order_mask, nside_mask, nmasks, i_mask
  logical(LGT)             :: pessim_mask
  !=========================================================================

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !-----------------------------------------------------------------------
  !                    get input parameters
  !-----------------------------------------------------------------------
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  PRINT *, " "
  PRINT *, "                "//code//" "//version
  write(*,'(a)') " *** Analysis and power spectrum calculation for a Temperature/Polarisation map ***"
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  PRINT *, " "
  handle = parse_init(parafile)

  !     --- choose temp. only or  temp. + pol. ---
  description = concatnl( &
       & " Do you want to analyse", &
       & " 1) a Temperature only map", &
       & " 2) Temperature + polarisation maps")
  simul_type = parse_int(handle, 'simul_type', default=1, vmin=1, vmax=2, descr=description)
  if (simul_type .eq. 1) polarisation = .false.
  if (simul_type .eq. 2) polarisation = .true.
  bcoupling = polarisation ! <<<<
!!  print*, " Bcoupling :  ",bcoupling
  order_map = -1

  !     --- gets the file name for the map(s) ---
  chline = "''"
  healpixtestdir = get_healpix_test_dir()
  if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/map.fits'
  description = concatnl( &
       & "", &
       & " Enter input file name 1 (Map FITS file): ")
  infile(1) = parse_string(handle, 'infile',default=chline, descr=description, filestatus='old')
  n_maps = 1
  description = concatnl( &
       & "", &
       & " Enter input file name 2 (Map FITS file): ")
  infile(2) = parse_string(handle, 'infile2',default="''", descr=description, filestatus='old')
  twomaps = (trim(infile(2)) /= "")
  if (twomaps) n_maps = 2

  !     --- check that this map is usable for this analysis
  call check_input_map(code, infile(1), polarisation) ! this may change polarisation from T to F

  !     --- finds out the pixel number of the map and its ordering and coordinates ---
  npixtot = getsize_fits(infile(1), ordering=order_map(1), &
       &                 nside=nsmax, mlpol=mlpol, coordsys=coordsys)
  if (trim(coordsys) == '') coordsys = 'unknown'

  if (twomaps) then
     call check_input_map(code, infile(2), polarisation)
     npixtot2 = getsize_fits(infile(2), ordering=order_map(2), &
          &                  nside=nsmax2, mlpol=mlpol2, coordsys=coordsys2)
     if (trim(coordsys2) == '') coordsys2 = 'unknown'
     mlpol = max(mlpol, mlpol2)
     if (nsmax2 /= nsmax .or. trim(coordsys2) /= trim(coordsys)) then
        print *," "//code//"> The 2 maps to be analyzed"
        print 9000, trim(infile(1)), trim(infile(2))
        print*,'do not match in resolution or coordinates'
        print*,nsmax,nsmax2
        print*,trim(coordsys)//' '//trim(coordsys2)
        call fatal_error(code)
     endif
  endif

  !     --- gets the L range for the analysis ---
  WRITE(chline1,"(a,i5)") " The map has Nside = ",nsmax
  if (mlpol<=0) WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",3*nsmax-1,")"
  if (mlpol> 0) WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",mlpol,")"
  description = concatnl(&
       & "", &
       & chline1, &
       & " Enter the maximum l range (l_max) for the analysis. ", &
       & chline )
  nlmax = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)

  ! ----------  default parameters ----------------
  nmmax   = nlmax
  npixtot = nside2npix(nsmax)
  pix_size_arcmin = 360.*60./SQRT(npixtot*PI)
  !   -------------------------------------

  !     --- ask for pixel mask ---
  description = concatnl(&
       & "", &
       & " Enter FITS file containing pixel mask and/or weight you want to use: ", &
       & " the map(s) will be multiplied by this mask(s) before analysis ", &
       & " (If '', all valid pixels are used with their current value) ")
  maskfile = parse_string(handle, 'maskfile', default="''", descr=description, filestatus='old')
  do_mask = (trim(maskfile) /= "")

  !     --- gets the cut applied to the map ---
  description = concatnl(&
       & "", &
       & " Enter the symmetric cut around the equator in DEGREES : ", &
       & " (One ignores data within |b| < b_cut)     0 <= b_cut = ")
  theta_cut_deg = parse_double(handle, 'theta_cut_deg', &
       &                       vmin=0.0_dp, default=0.0_dp, descr=description)
  cos_theta_cut = SIN(theta_cut_deg/180.d0*PI) !counted from equator instead of from pole

  zbounds = (/ cos_theta_cut , -cos_theta_cut /)
  if (theta_cut_deg<1e-4) zbounds = (/ -1.0_dp, 1.0_dp /) !keep all sphere if cut not set
  fsky = (zbounds(2)-zbounds(1))/2.0_dp
  if (fsky <= 0.0_dp) fsky = 1.0_dp + fsky
  write(*,"(a,f6.1,a)") "One keeps ",100.*fsky," % of the original map(s)"

  !     --- ask about monopole/dipole removal ---
  description = concatnl(&
       & "", &
       & " To improve the temperature map analysis (specially on a cut sky) ", &
       & " you have the option of first regressing out the best fit monopole and dipole", &
       & "   NOTE : the regression is made on valid (unflagged) pixels, ", &
       & " out of the symmetric cut (if any)", &
       & "  Do you want to : ", &
       & " 0) Do the analysis on the raw map", &
       & " 1) Remove the monopole (l=0) first ", &
       & " 2) Remove the monopole and dipole (l=1) first")
  lowlreg = parse_int(handle, 'regression', vmin=0, vmax=2, default=0, descr=description)

  !          --- precomputed plms  ---
40 continue
  n_plm   = 0
  plm_pol = 0
  description = concatnl(&
       & "", &
       & " Enter name of file with precomputed p_lms :", &
       & "(eg, plm.fits) (if '' is typed, no file is read)" )
  infile_plm = parse_string(handle, 'plmfile', default="''", descr=description, filestatus='old')

  if (trim(infile_plm) /= "") then
     ! check that the plm file matches the current simulation (for nside,lmax,mmax)
     call read_par(infile_plm, plm_nside, plm_lmax, plm_pol, mmax=plm_mmax)

     if ((plm_pol /= 1).and.(.not.polarisation)) plm_pol=1

     if (plm_nside /= nsmax .or. plm_lmax /= nlmax .or. plm_mmax /= nmmax) then
        print *," "//code//"> Plm file does not match map to analyze in Nside, Lmax or Mmax ! "
        print*,'nside (plm file, map) = ',plm_nside,nsmax
        print*,'lmax                  = ',plm_lmax, nlmax
        print*,'mmax                  = ',plm_mmax, nmmax
        if (handle%interactive) goto 40
        call fatal_error(code)
     endif
     n_plm = (nmmax + 1_i8b)*(2*nlmax + 2_i8b - nmmax)*nsmax
     print *," "
  endif

50 continue
  !     --- gets the output power spectrum filename ---
  if (twomaps) then
     chline =  " Enter Output CROSS Power Spectrum file name (eg, cl_out.fits) :"
  else
     chline =  " Enter Output Auto Power Spectrum file name (eg, cl_out.fits) :"
  endif
  description = concatnl(&
       & "", &
       & trim(chline), &
       & "  (or !cl_out.fits to overwrite an existing file)" )
  outfile = parse_string(handle, "outfile", &
       default="!cl_out.fits", descr=description, filestatus="new")

  !     --- gets the output alm-filename ---
  description = concatnl(&
       & "", &
       & " Enter output file name for alms(eg: alms.fits): ", &
       & " (or !alms.fits to overwrite an existing file): ", &
       & " (If '', the alms are not written to a file) ")
  outfile_alms(1) = parse_string(handle, 'outfile_alms', default="''", descr=description, filestatus='new')

  outfile_alms(2) = ''
  if (twomaps) then
     description = concatnl(&
          & "", &
          & " Enter output file name for alms of the second map")
     outfile_alms(2) = parse_string(handle, 'outfile_alms2', default="''", descr=description, filestatus='new')
  endif

  if (trim(outfile)=="" .and. trim(outfile_alms(1))=="" .and. trim(outfile_alms(2))=="") then
     print*,'ERROR: No output file provided'
     if (handle%interactive) goto 50
     call fatal_error(code)
  endif
  !-----------------------------------------------------------------------
  !                      ask for weights
  !-----------------------------------------------------------------------

  description = concatnl(&
       & "", &
       & " Do you want to use quadrature weights in the analysis: ", &
       & " 0: no weight            ", &
       & " 1: ring-based weights   ", &
       & " 2: pixel-based weights ?")
  won = parse_int(handle, 'won', vmin=0, vmax=2, default=0, descr=description)

  infile_w8=""
  strw8file = ""

  if (won == 1 .or. won == 2) then

     ! default weight file name
     w8name = get_healpix_weight_file(nsmax, won)

     def_file = trim(w8name)
     def_dir  = get_healpix_data_dir()

     if (won == 1) strw8file = "ring-based  quadrature weight file"
     if (won == 2) strw8file = "pixel-based quadrature weight file"

22   continue
     final_file = ''
     ok = .false.
     ! if interactive, try default name in default directories first
     if (handle%interactive) ok = scan_directories(def_dir, def_file, final_file)
     if (.not. ok) then
        ! not found, ask the user
        description = concatnl("",&
             &        " Could not find "//trim(strw8file), &
             &        " Enter the directory where this file can be found:")
        usr_dir = parse_string(handle,'w8filedir',default='',descr=description)
        if (trim(usr_dir) == '') usr_dir = trim(def_dir)
        description = concatnl("",&
             &        " Enter the name of the "//trim(strw8file)//":")
        usr_file = parse_string(handle,'w8file',default=def_file,descr=description)
        ! look for new name in user provided or default directories
        ok   = scan_directories(usr_dir, usr_file, final_file)
        ! if still fails, crash or ask again if interactive
        if (.not. ok) then
           print*,' File not found:'//trim(usr_file)
           if (handle%interactive) goto 22
           call fatal_error(code)
        endif
     endif
     infile_w8 = final_file
  endif

  !     --- gets the order of iteration ---
  description = concatnl(&
       & "", &
       & " Do you want : ", &
       & " 0) a standard analysis", &
       & " 1,2,3,4....) an iterative analysis", &
       & " (enter order of iteration, 3rd order is usually optimal)")
  iter_order=parse_int(handle, 'iter_order', vmin=0, default=0, descr=description)
  if (.not. handle%interactive) then
     select case (iter_order)
     case (0)
        PRINT*," Standard analysis"
     case default
        PRINT*," Iterative analysis"
     end select
  end if

  PRINT *," "
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
  call brag_openmp()


  if (iter_order > 0 .and. won==2) then
     write(*,'(a,i3,a)') 'WARNING: iter_order>0 (currently ',iter_order,')'
     write(*,*)          '         can not be used with won=2 (pixel-based weights)'
  endif

  !-----------------------------------------------------------------------
  !              allocate space for arrays
  !-----------------------------------------------------------------------
  polar = 0
  if (polarisation) polar = 1
  n_pols = 1 + 2*polar ! either 1 or 3

  ALLOCATE(map_TQU(0:npixtot-1,1:n_pols),stat = status)
  call assert_alloc(status,code,"map_TQU")

  if (twomaps) then
     ALLOCATE(map_TQU2(0:npixtot-1,1:n_pols),stat = status)
     call assert_alloc(status,code,"map_TQU2")
  endif

  ALLOCATE(w8ring_TQU(1:2*nsmax,1:n_pols),stat = status)
  call assert_alloc(status,code,"w8ring_TQU")

  ALLOCATE(dw8(1:2*nsmax,1:n_pols),stat = status)
  call assert_alloc(status,code,"dw8")

  ALLOCATE(fact_norm(0:nlmax),stat = status)
  call assert_alloc(status,code,"fact_norm")

  if (n_plm/=0) then
     ALLOCATE(plm(0:n_plm-1,1:plm_pol),stat = status)
     call assert_alloc(status,code,"plm")
  endif
  !-----------------------------------------------------------------------
  !                      reads the map
  !-----------------------------------------------------------------------
  PRINT *,"      "//code//"> Inputting map "

  fmissval = 0.0
  if (lowlreg > 0) fmissval = real(HPX_DBADVAL,kind=KMAP)
  call input_map(infile(1), map_TQU(0:,1:n_pols), &
       &  npixtot, n_pols, fmissval=fmissval, units=units_map(1:n_pols,1))
  units_map(1,1) = adjustl(units_map(1,1))
  units_pow(1) = trim(units_map(1,1))//'^2'

  if (twomaps) then
     call input_map(infile(2), map_TQU2(0:,1:n_pols), &
          &  npixtot, n_pols, fmissval=fmissval, units=units_map(1:n_pols,2))
     units_map(1,2) = adjustl(units_map(1,2))
     if (units_map(1,2) /= units_map(1,2)) then
        PRINT *,"      "//code//"> Warning: the 2 maps have different units"
     endif
  endif


  !-----------------------------------------------------------------------
  !                 reorder maps to RING if necessary
  !-----------------------------------------------------------------------
  if (order_map(1) == 2 .or. (twomaps .and. order_map(2) == 2)) then
     PRINT *,"      "//code//"> Convert Nest -> Ring "
     if (order_map(1) == 2) then
        call convert_nest2ring (nsmax, map_TQU)
        order_map(1) = 1
     endif
     if (twomaps .and. order_map(2) == 2) then
        call convert_nest2ring (nsmax, map_TQU2)
        order_map(2) = 1
     endif
  endif

  !-----------------------------------------------------------------------
  !                      reads the mask
  !-----------------------------------------------------------------------
  if (do_mask) then
     fmiss_mask = 0.0_KMAP ! set to mask=0 missing pixels
     pessim_mask = .true.
     PRINT *,"      "//code//"> Inputting mask from "//trim(maskfile)
     npix_mask = getsize_fits(maskfile, ordering=order_mask, nside=nside_mask, nmaps=nmasks)

     if (nside_mask <= 0) then
        print*,"Keyword NSIDE not found in FITS header!"
        call fatal_error(code)
     endif
     if ((order_mask /= 1).and.(order_mask /= 2)) then
        print*,"The ordering scheme of the mask must be RING or NESTED."
        print*,"No ordering specification is given in the FITS header!"
        call fatal_error(code)
     endif

     if (nside_mask == nsmax) then
        ! mask has same resolution as map: read and proceed
        allocate(mask(0:npix_mask-1,1:nmasks),stat=status)
        call assert_alloc(status,code,"mask")
        call input_map(maskfile, mask, npix_mask, nmasks, fmissval = fmiss_mask)
     else
        ! mask has different resolution than map: read
        allocate(mask(0:npixtot-1,1:nmasks),stat=status)
        call assert_alloc(status,code,"mask")
        allocate(mask_tmp(0:npix_mask-1,1:nmasks),stat=status)
        call assert_alloc(status,code,"mask_tmp")
        call input_map(maskfile, mask_tmp, npix_mask, nmasks, fmissval = fmiss_mask)
        ! then degrade or prograde
        print*,'Modifying mask to match map resolution:'
        write(*,'(a,i6,a,i6)') 'Nside:  ',nside_mask,' --> ',nsmax
        do i_mask = 1, nmasks
           pmask_tmp => mask_tmp(:,i_mask:i_mask)
           pmask     => mask(:,i_mask:i_mask)
           if (order_mask == 2) then ! nested scheme
              call udgrade_nest(pmask_tmp, nside_mask, pmask, nsmax, &
                   &            fmissval= fmiss_mask, pessimistic=pessim_mask)
           else ! ring scheme
              call udgrade_ring(pmask_tmp, nside_mask, pmask, nsmax, &
                   &            fmissval= fmiss_mask, pessimistic=pessim_mask)
           endif
        enddo
        deallocate(mask_tmp)
        nside_mask = nsmax ; npix_mask = npixtot
     endif

     !--------------------------------------
     ! **** what if nmasks /= nmaps ??? ****
     !---------------------------------------
     do i_mask = 1, nmasks
        max_mask = maxval(mask(:,i_mask))
        min_mask = minval(mask(:,i_mask))
        if (max_mask > 0. .and. min_mask >=0.) then
           write(*,'(a,i2,a)') 'Field #', i_mask,' is OK'
           exit
        endif
        write(*,'(a,i2,a,2(1pg11.3))') 'Field #', i_mask, &
             & ' of '//trim(maskfile)//' has range ', min_mask, max_mask
        print*,' not a valid mask, will try next field'
        if (i_mask == nmasks) then
           print*,'Error : No valid mask found in '//trim(maskfile)
           call fatal_error(code)
        endif
     enddo

     ! keep only first valid mask found
     pmask => mask(:,i_mask:i_mask)
     nmasks = 1

     ! make sure mask and sky map have same ordering
     if (order_mask /= order_map(1)) then 
        PRINT *,"      "//code//"> Reorder mask "      
        if (order_mask == 2) call convert_nest2ring (nside_mask, pmask)
!!!!        if (order_mask == 1) call convert_ring2nest (nside_mask, pmask)
        order_mask = order_map(1)
     endif

  else ! create mask place holder
     allocate(pmask(0:1,1))
  endif 

  !-----------------------------------------------------------------------
  !                      remove dipole
  !-----------------------------------------------------------------------

  if (lowlreg > 0) then
     PRINT *,"      "//code//"> Remove monopole (and dipole) from Temperature map"
     call remove_dipole(nsmax, map_TQU(0:npixtot-1,1), order_map(1), lowlreg, &
          & mono_dip(0:,1), zbounds, fmissval=fmissval, mask=pmask(:,1))
     if (twomaps) then
        call remove_dipole(nsmax, map_TQU2(0:npixtot-1,1), order_map(2), lowlreg, &
             & mono_dip(0:,2), zbounds, fmissval=fmissval, mask=pmask(:,1))
     endif

     if (fmissval /= 0.0) then
        do j=1,n_pols
           do ipix=0, npixtot-1
              if (abs(map_TQU(ipix,j)-fmissval) <= abs(1.e-6*fmissval)) map_TQU(ipix,j) = 0.0_kmap
           enddo
           if (twomaps) then
              do ipix=0, npixtot-1
                 if (abs(map_TQU2(ipix,j)-fmissval) <= abs(1.e-6*fmissval)) map_TQU2(ipix,j) = 0.0_kmap
              enddo
           endif
        enddo
     endif

     do i=1, n_maps
        write(unit=*,fmt=8000)  " Monopole = ", mono_dip(0,i)," "//trim(units_map(1,i))
        if (lowlreg > 1) then
           call vec2ang( mono_dip(1:3,i), theta_dip, phi_dip)
           ampl_dip = sqrt(sum(mono_dip(1:3,i)**2))
           long_dip =      phi_dip  /PI*180.0_dp
           lat_dip  = 90.0-theta_dip/PI*180.0_dp
           write(unit=*,fmt=8000)  " Dipole   = ",ampl_dip," "//trim(units_map(1,i))
           write(unit=*,fmt=8002) "(long.,lat.) = (",long_dip,lat_dip,") Deg"
        endif
     enddo
8000 format(a,1pg13.3,a)
8002 format(a,1pg10.3,', ',1pg10.3,a)

  endif
  !-----------------------------------------------------------------------
  !                      Input weights
  !-----------------------------------------------------------------------

  dw8=0.0_dp ! read as DP
  if (trim(infile_w8)/="") then
     if (won == 1) then
        ! ring based weights: treated as such in map2alm
        n_rings = 2 * nsmax
        n_rings_read = getsize_fits(infile_w8, nmaps=nmw8)

        if (n_rings_read /= n_rings) then
           PRINT *," "
           print *,"wrong ring weight file:"//trim(infile_w8)
           call fatal_error(code)
        endif
        nmw8 = min(nmw8, n_pols)
        
        PRINT *,"      "//code//"> Inputting "//trim(strw8file)
        call input_map(infile_w8, dw8, n_rings, nmw8, fmissval=0.0_dp)
     endif

     if (won == 2) then 
        ! pixel based weights: turned into full sky map and multiply with mask
        allocate(pw8map (0:npixtot-1,   1:1), stat=status)
        call assert_alloc(status,code,"pw8map")

        PRINT *,"      "//code//"> Inputting and unfolding "//trim(strw8file)

!         n_pw8_read = getsize_fits(infile_w8)
!         allocate(pw8list(0:n_pw8_read-1,1:1), stat=status)
!         call assert_alloc(status,code,"pw8list")
!         call input_map(infile_w8, pw8list, n_pw8_read, 1)
!         call unfold_weights(nsmax, won, pw8list(:,1), pw8map(:,1))
!         deallocate(pw8list)

        call unfold_weightsfile(infile_w8, pw8map(:,1))

        if (do_mask) then
           do i=1,size(pmask,2)
              pmask(1:npixtot,i:i) = pmask(1:npixtot,i:i) * pw8map(0:npixtot-1,1:1)
           enddo
        else
           deallocate(pmask)
           pmask => pw8map(:,1:1)
        endif
        !print*,pmask(1:12,1)
        !print*,pmask(npixtot-11:npixtot,1)
     endif
  endif
  w8ring_TQU = 1.0_dp + dw8

  !-----------------------------------------------------------------------
  !                    precomputed plms
  !-----------------------------------------------------------------------

  if (n_plm/=0) then
     if (plm_pol.eq.1) then
        PRINT*,"      "//code//"> Reading precomputed scalar P_lms "
     else
        PRINT*,"      "//code//"> Reading precomputed tensor P_lms "
     endif
     !call read_dbintab(infile_plm,plm,n_plm,plm_pol,nullval,anynull=bad) ! replaced 2010-11-24
     call read_bintab(infile_plm, plm, n_plm, plm_pol, nullval, anynull=bad)
     if (bad) call fatal_error("Missing points in P_lm-file!")
  endif

  !-----------------------------------------------------------------------
  !                        map to alm
  !  map2alm_iterative will apply mask to map
  !-----------------------------------------------------------------------

  ALLOCATE(alm_TGC(1:n_pols, 0:nlmax, 0:nmmax),stat = status)
  call assert_alloc(status,code,"alm_TGC")

  PRINT *,"      "//code//"> Analyse map "
  if (n_plm/=0) then
     call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU, alm_TGC, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, plm=plm, mask=pmask)
  else
     call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU, alm_TGC, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, mask=pmask)
  endif

  if (twomaps) then
     allocate(alm_TGC2(1:n_pols, 0:nlmax, 0:nmmax),stat = status)
     call assert_alloc(status,code,"alm_TGC2")
     if (n_plm/=0) then
        call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU2, alm_TGC2, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, plm=plm, mask=pmask)
     else
        call map2alm_iterative(nsmax, nlmax, nmmax, iter_order, map_TQU2, alm_TGC2, &
          &                 zbounds=zbounds, w8ring=w8ring_TQU, mask=pmask)
     endif
     deallocate( map_TQU2 )
  endif

  deallocate( map_TQU )
  deallocate(w8ring_TQU)
  deallocate(dw8)
  if (allocated(pw8map)) deallocate(pw8map)

  !-----------------------------------------------------------------------
  !                  power spectrum calculation
  !-----------------------------------------------------------------------

  PRINT *,"      "//code//"> Compute power spectrum "

  ncl = 1
  if (polarisation) ncl = 4
  if (polarisation .and. bcoupling)    ncl = 6
  asym_cl = polarisation .and. bcoupling .and. twomaps
  if (asym_cl) ncl = 9
  allocate(clout(0:nlmax,1:ncl))

  if (twomaps) then
     call alm2cl(nlmax, nmmax, alm_TGC, alm_TGC2, clout)
  else
     call alm2cl(nlmax, nmmax, alm_TGC, alm_TGC, clout)
  endif
  !-----------------------------------------------------------------------
  !                  outputs the power spectrum
  !-----------------------------------------------------------------------

  if (trim(outfile)/="") then
     PRINT *,"      "//code//"> outputting Power Spectrum "

!      do l = 0, nlmax
!         fact_norm(l) = 1.0_KCL !  Normalisation=1, Output 'pure' C_ls
!      enddo
!      do i = 1, ncl
!         clout(:,i) = clout(:,i) * fact_norm(:)
!      enddo

!     units_pow(1) = "'"//trim(units_pow(1))//"'" ! add quotes to keep words together
     call write_minimal_header(header,'cl', &
          creator = CODE, version = VERSION, &
          polar = polarisation, bcross = bcoupling, asym_cl = asym_cl, &
          nlmax = nlmax, nside = nsmax, coordsys = coordsys, units = units_pow(1) )
     if (twomaps) then
        call add_card(header,"EXTNAME","'ANALYSED CROSS POWER SPECTRUM'",update=.true.)
     else
        call add_card(header,"EXTNAME","'ANALYSED AUTO POWER SPECTRUM'",update=.true.)
     endif
     call add_card(header,"CUT-SKY", theta_cut_deg," [deg] Symmetric Cut Sky")
     call add_card(header,"NITERALM",iter_order,   " Number of iterations for a_lms extraction")
     call add_card(header,"LREGRESS",lowlreg,      " Regression of low multipoles (0/1/2)")
     call add_card(header,"NMAPS_IN",n_maps,       " Number of maps (co-)analysed (1/2)")
     call add_card(header,"QUADSCHM",won,          " Quadrature scheme (0/1/2)")
     call add_card(header)
     if (twomaps) then
        call add_card(header,"HISTORY","Input Map1 = "//TRIM(infile(1)))
        call add_card(header,"HISTORY","Input Map2 = "//TRIM(infile(2)))        
     else
        call add_card(header,"HISTORY","Input Map = "//TRIM(infile(1)))
     endif
     nlheader = SIZE(header)
     !print*,'wrtting file'
     call write_asctab (clout, nlmax, ncl, header, nlheader, outfile)
  endif
  !-----------------------------------------------------------------------
  !                  outputs the alm
  !-----------------------------------------------------------------------
  do j = 1,n_maps
     if (trim(outfile_alms(j))/="") then

        PRINT *,"      "//code//"> outputting alms "
!        units_map(1,j) = ''''//trim(units_map(1,j))//'''' ! add quotes to keep words together

        ! write each component (T,G,C) in a different extension of the same file
        do i=1,1+polar*2
           call write_minimal_header(header,'alm', &
                creator = CODE, version = VERSION, &
                nside = nsmax, coordsys = coordsys, &
                nlmax = nlmax, nmmax = nmmax, polar = polarisation, &
                units = units_map(1,j)) 
           if (i == 1) then
              call add_card(header,"EXTNAME","'ANALYSED a_lms (TEMPERATURE)'")
           elseif (i == 2) then
              call add_card(header,"EXTNAME","'ANALYSED a_lms (GRAD / ELECTRIC component)'")
           elseif (i == 3) then
              call add_card(header,"EXTNAME","'ANALYSED a_lms (CURL / MAGNETIC component)'")
           endif
           call add_card(header,"CUT-SKY", theta_cut_deg," [deg] Symmetric Cut Sky")
           call add_card(header,"NITERALM",iter_order,   " Number of iterations for a_lms extraction")
           call add_card(header,"LREGRESS",lowlreg,      " Regression of low multipoles (0/1/2)")
           call add_card(header,"HISTORY","Input Map = "//TRIM(infile(j)))
           call add_card(header,"QUADSCHM",won,          " Quadrature scheme (0/1/2)")
           nlheader = SIZE(header)
           if (j == 1) call dump_alms(outfile_alms(j), alm_TGC (i,0:nlmax,0:nmmax), &
                &                     nlmax, header, nlheader, i-1_i4b)
           if (j == 2) call dump_alms(outfile_alms(j), alm_TGC2(i,0:nlmax,0:nmmax), &
                &                     nlmax, header, nlheader, i-1_i4b)
        enddo ! i: extension
     endif
  enddo ! j: file

  !-----------------------------------------------------------------------
  !                      deallocate memory for arrays
  !-----------------------------------------------------------------------

  deallocate( alm_TGC )
  if (twomaps) deallocate( alm_TGC2 )

  !-----------------------------------------------------------------------
  !                      report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" analysis run"
  write(*,9000) "----------------------------------------"
  write(*,9000) " "
  if (.not. polarisation) then
     write(*,9000) "      Temperature alone"
  else
     write(*,9000) "    Temperature + Polarisation"
  endif
  write(*,9000) " "
  write(*,9000) " Input map              : "//TRIM(infile(1))
  if (trim(infile(2))/="") write(*,9000) " Input map 2            : "//TRIM(infile(2))
  write(*,9006) " Multipole range        : ",lowlreg ," <= l <= ", nlmax
  write(*,9010) " Number of pixels       : ", npixtot
  write(*,9020) " Pixel size in arcmin   : ", pix_size_arcmin
  write(*,9020) " Symmetric cut in deg   : ", theta_cut_deg
  if (do_mask) write(*,9000) &
       &        " Mask read from         : "//trim(maskfile)
  write(*,9000) " Output power spectrum  : "//TRIM(outfile)
  if (outfile_alms(1)/="") write(*,9000) " Output alm             : "//TRIM(outfile_alms(1))
  if (outfile_alms(2)/="") write(*,9000) " Output alm 2           : "//TRIM(outfile_alms(2))
  if (won >0) write(*,9000) " Quadrature weight file : "//trim(infile_w8)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9006 format(a,i2,a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
! Written by Hans Kristian Eriksen and Snorre Boasson, 
! but copying large parts from the serial HEALPix code.
module mpi_alm_tools

  use healpix_types
  use healpix_fft
  use misc_utils
  use alm_tools
  
  implicit none

  include "mpif.h"

  ! define large and small numbers used to renormalise the recursion 
  ! on the Legendre Polynomials
  integer(I4B),      private, parameter :: LOG2LG   = 100
  real(KIND=DP),     private, parameter :: FL_LARGE = 2.0_dp **   LOG2LG
  real(KIND=DP),     private, parameter :: FL_SMALL = 2.0_dp ** (-LOG2LG)
  ! declare array for dynamic rescaling of the Ylm
  integer(kind=i4b), private, parameter :: RSMAX = 20, RSMIN = -20
  real(dp),          private, dimension(RSMIN:RSMAX) :: rescale_tab
  real(DP),          private, parameter :: ALN2_INV = 1.4426950408889634073599246810_dp ! 1/log(2)

  ! Do not change SMAXCHK -- this will affect the load balancing, and the
  ! corresponding constants in find_rings must be re-adjusted
  integer(i4b),      private, parameter :: SMAXCHK = 50 ! maximum size of chunk (in ring pairs)
  

  !--------------------------------------------------------------------------

  ! Internal parameters for the mpi_alm_tools module
  integer(i4b), private :: nsmax, nlmax, nmmax, precompute_plms
  logical(lgt), private :: polarization
  real(dp),     dimension(2), private :: zbounds

  ! MPI and parallelization variables
  integer(i4b), private :: myid, numprocs, comm, ierr, root = 0
  integer(i4b), private :: first_ring, last_ring, num_segment, map_size, nmaps

  real(dp),     allocatable, dimension(:,:),     private :: local_map, buffer
  complex(dpc), allocatable, dimension(:,:,:),   private :: local_alms, alms_work
  real(dp),     allocatable, dimension(:,:),     private :: local_w8ring, plm
  integer(i4b),              dimension(0:1,0:1), private :: segment

  integer(i4b), allocatable, dimension(:),       private :: num_segments, map_sizes
  integer(i4b), allocatable, dimension(:,:),     private :: ring_procs
  integer(i4b), allocatable, dimension(:,:,:),   private :: segments

  interface mpi_map2alm_simple
     module procedure mpi_map2alm_simple_s, mpi_map2alm_simple_d
  end interface

  interface mpi_alm2map_simple
     module procedure mpi_alm2map_simple_s, mpi_alm2map_simple_d
  end interface

  interface mpi_map2alm
     module procedure mpi_map2alm_s, mpi_map2alm_d
  end interface

  interface mpi_alm2map
     module procedure mpi_alm2map_s, mpi_alm2map_d
  end interface

  interface distribute_map
     module procedure distribute_map_s, distribute_map_d
  end interface

  interface gather_map
     module procedure gather_map_s, gather_map_d
  end interface


contains

  ! ***************************************************************
  !            Initialization and destruction routines
  ! ***************************************************************

  subroutine mpi_initialize_alm_tools(comm_in, nsmax_in, nlmax_in, &
       & nmmax_in, zbounds_in, polarization_in, &
       & precompute_plms_in, w8ring)
    implicit none
    
    integer(i4b),                   intent(in)           :: comm_in
    integer(i4b),                   intent(in), optional :: nsmax_in, nlmax_in, nmmax_in
    integer(i4b),                   intent(in), optional :: precompute_plms_in
    logical(lgt),                   intent(in), optional :: polarization_in
    real(dp),     dimension(2),     intent(in), optional :: zbounds_in
    real(dp),     dimension(1:,1:), intent(in), optional :: w8ring

    integer(i4b) :: i, s, smax
    real(dp)     :: logOVFLOW
    
    comm            = comm_in

    ! Initialize MPI variables
    call mpi_comm_rank(comm, myid, ierr)
    call mpi_comm_size(comm, numprocs, ierr)

    if (myid == root) then
       nsmax            = nsmax_in
       nlmax            = nlmax_in
       nmmax            = nmmax_in
       zbounds          = zbounds_in
       polarization     = polarization_in
       precompute_plms  = precompute_plms_in
    end if

    call mpi_bcast(nsmax,            1, MPI_INTEGER,          root, comm, ierr)
    call mpi_bcast(nlmax,            1, MPI_INTEGER,          root, comm, ierr)
    call mpi_bcast(nmmax,            1, MPI_INTEGER,          root, comm, ierr)
    call mpi_bcast(precompute_plms,  1, MPI_INTEGER,          root, comm, ierr)
    call mpi_bcast(zbounds,          2, MPI_DOUBLE_PRECISION, root, comm, ierr)
    call mpi_bcast(polarization,     1, MPI_LOGICAL,          root, comm, ierr)

    ! Find which rings to compute
    call find_rings(myid, first_ring, last_ring)

    ! Find corresponding pixel numbers
    call find_pixel_numbers(first_ring, last_ring, num_segment, map_size, segment)

    if (polarization) then
       nmaps = 3
    else
       nmaps = 1
    end if

    ! Allocate work space for both map and ring weights
    allocate(local_map(0:map_size-1,1:nmaps))
    allocate(local_alms(1:nmaps,0:nlmax,0:nmmax))
    allocate(alms_work(1:nmaps,0:nlmax,0:nmmax))
    allocate(local_w8ring(1:last_ring-first_ring+1,1:nmaps)) 
    
    if (myid == root) then
       allocate(ring_procs(2,0:numprocs-1))
       allocate(num_segments(0:numprocs-1))
       allocate(map_sizes(0:numprocs-1))
       allocate(segments(0:1,0:1,0:numprocs-1))

       do i = 0, numprocs-1
          call find_rings(i, ring_procs(1,i), ring_procs(2,i))
          call find_pixel_numbers(ring_procs(1,i), ring_procs(2,i), &
               & num_segments(i), map_sizes(i), segments(0:1,0:1,i))
       end do

       allocate(buffer(0:2*maxval(segments(0,1,:)-segments(0,0,:))+1,1:nmaps))

    end if

    ! Distribute ring weights
    if (myid == root) then
       call distribute_w8ring(local_w8ring, w8ring)
    else
       call distribute_w8ring(local_w8ring)
    end if

    
    ! Initialize rescale_tab
    logOVFLOW=log(FL_LARGE)
    smax = INT( log(MAX_DP) / logOVFLOW )

    rescale_tab(RSMIN:RSMAX) = 0.0_dp
    do s = -smax, smax
       rescale_tab(s) = FL_LARGE ** s
    enddo
    rescale_tab(0) = 1.0_dp

    ! Pre-compute if requested
    if (precompute_plms == 1) then
       call mpi_plm_gen(.false.)
    else if (precompute_plms == 2) then
       call mpi_plm_gen(.true.)
    end if

  end subroutine mpi_initialize_alm_tools


  subroutine mpi_cleanup_alm_tools
    implicit none

    if (allocated(alms_work))       deallocate(alms_work)
    if (allocated(local_alms))      deallocate(local_alms)
    if (allocated(local_map))       deallocate(local_map)
    if (allocated(plm))             deallocate(plm)
    if (allocated(local_w8ring))    deallocate(local_w8ring)

    if (myid == root) then
       if (allocated(ring_procs))   deallocate(ring_procs)
       if (allocated(num_segments)) deallocate(num_segments)
       if (allocated(map_sizes))    deallocate(map_sizes)
       if (allocated(segments))     deallocate(segments)
       if (allocated(buffer))       deallocate(buffer)
    end if

  end subroutine mpi_cleanup_alm_tools




  ! ***************************************************************
  !            Include the SP/DP specific routines
  ! ***************************************************************

  include 'mpi_alm_tools_ss.f90'

  include 'mpi_alm_tools_dd.f90'


  ! ***************************************************************
  !            Wrappers for the computational routines
  ! ***************************************************************

  
  subroutine mpi_map2alm_slave
    implicit none

    call distribute_map_slave

    if (polarization) then
       ! Polarization routines
       if (precompute_plms == 1) then
          call mpi_map2alm_pol_pre1
       else if (precompute_plms == 2) then
          call mpi_map2alm_pol_pre2
       else
          call mpi_map2alm_pol
       end if
    else
       ! Temperature routines
       if (precompute_plms == 1 .or. precompute_plms == 2) then
          call mpi_map2alm_sc_pre
       else
          call mpi_map2alm_sc
       end if
    end if

    call mpi_reduce(local_alms, alms_work, size(local_alms), &
         & MPI_DOUBLE_COMPLEX, MPI_SUM, root, comm, ierr) 

  end subroutine mpi_map2alm_slave


  subroutine mpi_alm2map_slave
    implicit none

    call mpi_bcast(local_alms, size(local_alms), MPI_DOUBLE_COMPLEX, root, comm, ierr)

    if (polarization) then
       ! Polarization routines
       if (precompute_plms == 1) then
          call mpi_alm2map_pol_pre1
       else if (precompute_plms == 2) then
          call mpi_alm2map_pol_pre2
       else
          call mpi_alm2map_pol
       end if
    else
       ! Temperature routines
       if (precompute_plms == 1 .or. precompute_plms == 2) then
          call mpi_alm2map_sc_pre
       else
          call mpi_alm2map_sc
       end if
    end if

    call gather_map_slave

  end subroutine mpi_alm2map_slave



  ! *****************************************************************
  ! *           Distribution routines
  ! *****************************************************************

  subroutine distribute_map_slave
    ! Distributes the map data
    implicit none

    integer(i4b) :: i, seg_size, ierr

    integer(i4b), dimension(MPI_STATUS_SIZE)          :: status

    !Processes 1 and up recieves map data
    seg_size = segment(0,1)-segment(0,0)+1
    if (num_segment == 2) then
       
       call mpi_recv(local_map(0:2*seg_size-1,1:nmaps), 2*seg_size*nmaps, &
            & MPI_DOUBLE_PRECISION, root, 90, comm, status, ierr)
       
    else
       
       call mpi_recv(local_map(0:seg_size-1,1:nmaps), seg_size*nmaps, &
            & MPI_DOUBLE_PRECISION, root, 90, comm, status, ierr)
       
    end if
    
  end subroutine distribute_map_slave


  subroutine gather_map_slave
    ! Gathers the map data
    implicit none

    integer(i4b) :: i, seg_size, ierr

    integer(i4b), dimension(MPI_STATUS_SIZE)          :: status

    !Processes 1 and up sends map data
    if(num_segment == 2) then
       
       seg_size = segment(0,1)-segment(0,0)+1

       call mpi_send(local_map(0:2*seg_size-1,1:nmaps), 2*seg_size*nmaps, &
            & MPI_DOUBLE_PRECISION, root, 91, comm, ierr)
       
    else
       
       seg_size = segment(0,1)-segment(0,0)+1
       call mpi_send(local_map(0:seg_size-1,1:nmaps), seg_size*nmaps, &
            & MPI_DOUBLE_PRECISION, root, 91, comm, ierr)
       
    end if

  end subroutine gather_map_slave


  subroutine distribute_w8ring(local_w8ring, w8ring)
    implicit none

    real(dp), dimension(1:,1:), intent(out)           :: local_w8ring
    real(dp), dimension(1:,1:), intent(in), optional  :: w8ring
    
    integer(i4b) :: i, ierr

    integer(i4b), dimension(MPI_STATUS_SIZE)          :: status

    if (myid == root) then

       do i = 1, numprocs-1
          call mpi_send(w8ring(ring_procs(1,i):ring_procs(2,i),1:nmaps), &
               & (ring_procs(2,i)-ring_procs(1,i)+1)*nmaps, MPI_DOUBLE_PRECISION, &
               & i, 92, comm, ierr)
       end do

       local_w8ring = w8ring(ring_procs(1,0):ring_procs(2,0),1:nmaps)

    else

       call mpi_recv(local_w8ring, (last_ring-first_ring+1)*nmaps, &
            & MPI_DOUBLE_PRECISION, root, 92, comm, status, ierr)

    end if
    
  end subroutine distribute_w8ring

  
  ! Finds the rings to compute for the processor with ID "myid"
  subroutine find_rings(myid, first_ring, last_ring)
    implicit none

    integer(i4b), intent(in)  :: myid
    integer(i4b), intent(out) :: first_ring, last_ring

    integer(i4b) :: i, base_size, remainder, n_iter, ring
    real(dp)     :: integral, x, dx, int_per_proc

    real(dp)     :: alpha = 1.8
    real(dp)     :: beta  = 0.45
    real(dp)     :: gamma = 1.1

    if (numprocs == 1) then
       first_ring = 1
       last_ring  = 2*nsmax
    else

       ring         = 1
       integral     = 0.d0
       dx           = 1.d0 / real(2*nsmax,dp)
       x            = 0.d0
       int_per_proc = 1.d0 / real(numprocs,dp)

       do i = 0, myid-1
          do while (integral < real(i+1,dp)*int_per_proc)
             ring = ring+1
             x    = x+dx
             if (ring <= nsmax) then
                integral = integral + (alpha*x+beta)*dx
             else
                integral = integral + gamma*dx
             end if
          end do
       end do

       first_ring = ring
       do while (integral < real(myid+1,dp)*int_per_proc)
          ring = ring+1
          x = x+dx
          if (ring <= nsmax) then
             integral = integral + (alpha*x+beta)*dx
          else
             integral = integral + gamma*dx
          end if
       end do
       last_ring = ring-1

    end if

    if (myid == numprocs-1) last_ring = 2*nsmax

!    n_iter    = 2*nsmax
!    base_size = n_iter/numprocs
!    remainder = n_iter - base_size*numprocs 

!    if (myid < remainder) then 
!       first_ring = base_size*myid + myid + 1
!       last_ring  = first_ring + base_size 
!    else 
!       first_ring = base_size*myid + remainder + 1
!       last_ring  = first_ring + base_size - 1
!    end if

  end subroutine find_rings


  !Returns the map segment(s) needed given ring numbers
  subroutine find_pixel_numbers(first_ring, last_ring, num_segment, map_size, segment)
    implicit none

    integer(i4b), intent(in)  :: first_ring, last_ring
    integer(i4b), intent(out) :: num_segment, map_size
    integer(i4b), dimension(0:1,0:1), intent(out) :: segment

    num_segment = 2

    segment(0,0) = ring_start(first_ring) 
    segment(0,1) = ring_start(last_ring+1)-1
    segment(1,0) = (12*nsmax**2) - segment(0,1)-1
    segment(1,1) = (12*nsmax**2) - segment(0,0)-1

    if (segment(1,0) < segment(0,1)) then
       ! End of segment 1 is after the start of segment 2 => overlapping
       ! at equator.
       num_segment  = 1
       segment(0,1) = segment(1,1)
       segment(1,0) = 0
       segment(1,1) = 0
    end if

    if (num_segment == 2) then 
       map_size = segment(0,1) - segment(0,0) + segment(1,1) - segment(1,0) + 2
    else
       map_size = segment(0,1) - segment(0,0) + 1
    end if
    
  end subroutine find_pixel_numbers

  ! Finds the first pixel in ring number i
  function ring_start(i)
    implicit none

    integer(i4b), intent(in) :: i

    integer(i4b) :: ring_start

    if (i <= nsmax) then
       ring_start = 2 * (i**2-i)
    else
       ring_start = 2 * (nsmax**2-nsmax) + 4*nsmax * (i-nsmax)
    endif

  end function ring_start



  ! ***************************************************************
  !                Computational routines
  ! ***************************************************************

  subroutine mpi_map2alm_sc
    !=======================================================================
    !     computes the a(l,m) from a Temperature map for the HEALPIX pixelisation
    !        all from scratch
    !=======================================================================

    integer(I4B) :: l, m, ith, scalem, scalel   ! alm related
    integer(I4B) :: istart_south, istart_north  ! map related
    integer(I4B) :: nrings, npix, nphmx
    real(DP)     :: omega_pix

    integer(I4B)                              :: par_lm
    real(DP)              :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
    real(DP)                      :: ovflow, unflow
    real(DP),     dimension(-1:2)             :: phas_sd
    real(DP),     dimension(:,:), allocatable :: dalm
    real(DP),     dimension(:),   allocatable :: mfac
    real(DP),     dimension(:,:), allocatable :: recfac

    integer(I4B)                              :: l_min, kphi1
    complex(DPC)                              :: php, phm
    complex(DPC), dimension(:,:), allocatable :: phas_n, phas_s
    real(DP),     dimension(:),   allocatable :: ring
    integer(I4B)                   :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK-1) :: cth, sth
    logical(LGT), dimension(0:SMAXCHK-1) :: keep_north, keep_south, keep_it

    character(LEN=*), PARAMETER :: code = 'MAP2ALM'
    integer(I4B) :: status

    real(dp) :: t1, t2

    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    omega_pix = FOURPI / real(npix, DP)  ! pixel area (identical for all pixels)

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')

    allocate(phas_n(0:nmmax,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_n')

    allocate(phas_s(0:nmmax,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_s')

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax,mfac)

    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    local_alms = 0.0 ! set the whole alm array to zero

    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk  = first_ring + ichunk * chunksize 
       uchk  = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          ! find out which rings are to be analysed
          call select_rings(cth(ithl), zbounds, keep_north(ithl), keep_south(ithl), keep_it(ithl))
       enddo

       !-----------------------------------------------------------------------
       !  computes the integral in phi : phas_m(theta)
       !  for each parallele from Pole to Equator (use symmetry for S. Hemisphere)
       !-----------------------------------------------------------------------
       phas_n = 0_dpc
       phas_s = 0_dpc

       allocate(ring(0:nphmx-1),stat = status)
       call assert_alloc(status,code,'ring')

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          nphl = nph(ithl)
          ! do Fourier Transform on rings
          if (keep_north(ithl)) then
             ring(0:nphl-1) = local_map(istart_north:istart_north+nphl-1,1) * &
                  & local_w8ring(ith-first_ring+1,1)
             call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_n(0,ithl), kphi0(ithl))
             istart_north = istart_north+nphl
          endif

          if (ith < 2*nsmax .and. keep_south(ithl)) then
             istart_south = istart_south-nphl
             ring(0:nphl-1) = local_map(istart_south:istart_south+nphl-1,1) * &
                  & local_w8ring(ith-first_ring+1,1)
             call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_s(0,ithl), kphi0(ithl))
          endif
       enddo ! loop on ring

       deallocate(ring)

       !-----------------------------------------------------------------------
       !              computes the a_lm by integrating over theta
       !                  lambda_lm(theta) * phas_m(theta)
       !                         for each m and l
       !-----------------------------------------------------------------------

       allocate(recfac(0:1,0:nlmax),stat = status)
       call assert_alloc(status,code,'recfac')
       allocate(dalm(1:2,0:nlmax),stat = status)
       call assert_alloc(status,code,'dalm')

       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)

          ! introduce double precision vector to perform summation over ith for each l
          dalm(1:2, m:nlmax ) = 0.0_dp

          do ithl = 0, uchk-lchk
             l_min = l_min_ylm(m, sth(ithl))
             if (keep_it(ithl) .and. nlmax >= l_min) then ! avoid un-necessary calculations (EH, 09-2001)
                ! determine lam_mm
                call mpi_compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)

                !           ---------- l = m ----------
                par_lm = 1

                php = phas_n(m,ithl) + phas_s(m,ithl) ! sum  (if (l+m) even)
                phm = phas_n(m,ithl) - phas_s(m,ithl) ! diff (if (l+m) odd)
                phas_sd(-1:0) =  (/ real(phm, kind=dp), aimag(phm) /)
                phas_sd( 1:2) =  (/ real(php, kind=dp), aimag(php) /)
                
                if (m >= l_min) then
                   lam_lm = corfac * lam_mm !Actual lam_mm 
                   dalm(1:2, m) = dalm(1:2, m) + lam_lm * phas_sd(par_lm:par_lm+1)
                endif

                !           ---------- l > m ----------
                lam_0 = 0.0_dp
                lam_1 = 1.0_dp
                scalel=0
                cth_ring = cth(ithl)
                lam_2 = cth_ring * lam_1 * recfac(0,m)
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = (-1)^(l+m)
                   if (l >= l_min) then
                      lam_lm = lam_2 * corfac * lam_mm
                      dalm(1:2, l) = dalm(1:2, l) &
                           &       + lam_lm * phas_sd(par_lm:par_lm+1)
                   endif

                   lam_0 = lam_1 * recfac(1,l-1)
                   lam_1 = lam_2
                   lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                   if (abs(lam_2) > OVFLOW) then
                      lam_1 = lam_1*UNFLOW
                      lam_2 = lam_2*UNFLOW
                      scalel= scalel + 1
                      corfac= rescale_tab(max(scalem+scalel,RSMIN))
                   elseif (abs(lam_2) < UNFLOW) then
                      lam_1 = lam_1*OVFLOW
                      lam_2 = lam_2*OVFLOW
                      scalel= scalel - 1
                      corfac= rescale_tab(max(scalem+scalel,RSMIN))
                   endif

                enddo ! loop on l
             endif ! test on cut sky and nlmax
          enddo ! loop on ithl
          do l = m, nlmax
             local_alms(1,l,m) = local_alms(1,l,m) + &
                  & cmplx(dalm(1, l), dalm(2, l), kind=DP) * omega_pix
          enddo
       enddo ! loop on m

       deallocate (recfac,dalm)

    enddo ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(phas_n,phas_s)
    deallocate(mfac)

    return

  end subroutine mpi_map2alm_sc


  subroutine mpi_map2alm_sc_pre
    !=======================================================================
    !     computes the a(l,m) from a Temperature map for the HEALPIX pixelisation
    !       with precomputed Ylm(theta)
    !=======================================================================

    integer(I8B) :: istart_south, istart_north, npix
    integer(I4B) :: nrings, nphmx
    real(DP)     :: omega_pix

    integer(I8B)                              :: n_lm, i_mm
    integer(I4B)                              :: l, m, ith
    integer(I4B)                              :: par_lm
    real(DP),     dimension(-1:2)             :: phas_sd
    real(DP),     dimension(:,:), allocatable :: dalm
    integer(I4B)                              :: l_min
    complex(DPC)                              :: php, phm
    complex(DPC), dimension(:,:), allocatable :: phas_n, phas_s
    real(DP),     dimension(:),   allocatable :: ring
    real(DP)                                  :: cth
    integer(I4B)                   :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl
    integer(i4b)                   :: plm_ind
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    real(DP),     dimension(0:SMAXCHK-1) :: sth
    logical(LGT), dimension(0:SMAXCHK-1) :: keep_north, keep_south, keep_it

    character(LEN=*), PARAMETER :: code = 'MAP2ALM'
    integer(I4B) :: i, l_start, status, seed
    real(dp) :: t1, t2

    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    omega_pix = FOURPI / real(npix, DP)  ! pixel area (identical for all pixels)
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(phas_n(0:nmmax,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_n')

    allocate(phas_s(0:nmmax,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_s')

    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')
    allocate(dalm(1:2,0:nlmax),stat = status)
    call assert_alloc(status,code,'dalm')

    !     ------------ initiate variables and arrays ----------------
    local_alms = 0.0 ! set the whole alm array to zero
    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       call cpu_time(t1)

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth, sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          ! find out which rings are to be analysed
          call select_rings(cth, zbounds, keep_north(ithl), keep_south(ithl), keep_it(ithl))
       enddo

       !-----------------------------------------------------------------------
       !  computes the integral in phi : phas_m(theta)
       !  for each parallele from Pole to Equator (use symmetry for S. Hemisphere)
       !-----------------------------------------------------------------------
       phas_n = 0_dpc
       phas_s = 0_dpc

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          nphl = nph(ithl)
          ! do Fourier Transform on rings
          if (keep_north(ithl)) then
             ring(0:nphl-1) = local_map(istart_north:istart_north+nphl-1,1) * &
                  & local_w8ring(ith-first_ring+1,1)
             call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_n(0,ithl), kphi0(ithl))
             istart_north = istart_north+nphl
          endif

          if (ith < 2*nsmax .and. keep_south(ithl)) then
             istart_south = istart_south-nphl
             ring(0:nphl-1) = local_map(istart_south:istart_south+nphl-1,1) * &
                  & local_w8ring(ith-first_ring+1,1)
             call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_s(0,ithl), kphi0(ithl))
          endif
       enddo ! loop on ring

       !-----------------------------------------------------------------------
       !              computes the a_lm by integrating over theta
       !                  lambda_lm(theta) * phas_m(theta)
       !                         for each m and l
       !-----------------------------------------------------------------------

       do m = 0, nmmax
 
          ! introduce double precision vector to perform summation over ith for each l
          dalm(1:2, m:nlmax ) = 0.0_dp

          do ithl = 0, uchk-lchk 

             l_min = l_min_ylm(m, sth(ithl))
             if (keep_it(ithl) .and. nlmax >= l_min) then ! avoid un-necessary calculations (EH, 09-2001)
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + &
                     & ((2_I8B*nlmax+3-m)*m)/2 ! location of Ym,m for ring ith

                !           ---------- l = m ----------
                par_lm = 1

                php = phas_n(m,ithl) + phas_s(m,ithl) ! sum  (if (l+m) even)
                phm = phas_n(m,ithl) - phas_s(m,ithl) ! diff (if (l+m) odd)
                phas_sd(-1:0) =  (/ real(phm, kind=dp), aimag(phm) /)
                phas_sd( 1:2) =  (/ real(php, kind=dp), aimag(php) /)
                
                if (m >= l_min) then
                   dalm(1:2, m) = dalm(1:2, m) + plm(i_mm,1) * phas_sd(par_lm:par_lm+1)
                endif

                !           ---------- l > m ----------
                l_start = max(m+1, l_min)
                if (mod(m+l_start,2) == 0) l_start = l_start+1
                do l = l_start, nlmax, 2
                   dalm(1,l) = dalm(1,l) + plm(i_mm+l-m,1) * phas_sd(-1)
                   dalm(2,l) = dalm(2,l) + plm(i_mm+l-m,1) * phas_sd(0)
                enddo ! loop on l

                l_start = max(m+2, l_min)
                if (mod(m+l_start,2) == 1) l_start = l_start+1
                do l = l_start, nlmax, 2
                   dalm(1,l) = dalm(1,l) + plm(i_mm+l-m,1) * phas_sd(1)
                   dalm(2,l) = dalm(2,l) + plm(i_mm+l-m,1) * phas_sd(2)
                enddo ! loop on l

             endif ! test on cut sky and nlmax
          enddo ! loop on ithl
          do l = m, nlmax
             local_alms(1,l,m) = local_alms(1,l,m) + &
                  & cmplx(dalm(1, l), dalm(2, l), kind=DP) * omega_pix
          enddo
       enddo ! loop on m

       call cpu_time(t2)
!       write(*,*) (lchk+uchk)/2, t2-t1

    enddo ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(dalm, ring)
    deallocate(phas_n,phas_s)

    return

  end subroutine mpi_map2alm_sc_pre


  subroutine mpi_map2alm_pol
    !=======================================================================
    !     computes the a(l,m) from a polarized map for the HEALPIX pixelisation
    !       all from scratch
    !=======================================================================

    integer(I4B) :: l, m, ith, scalel, scalem, nrings, nphmx
    integer(I8B) :: istart_south, istart_north, npix
    real(DP)     :: omega_pix

    integer(I4B)                              :: par_lm
    real(DP)            :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
    real(DP)                 :: lambda_w, lambda_x, normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP)                 :: ovflow, unflow
    real(DP),     dimension(-3:8)             :: phas_sd
    real(DP),     dimension(-3:6)             :: phas_sdx
    real(DP),     dimension(:,:), allocatable :: recfac, dalm
    real(DP),     dimension(:),   allocatable :: lam_fact, mfac

    integer(i4b)                              :: l_min
    real(DP),     dimension(:),   allocatable :: normal_l
    complex(DPC)                              :: php, phm
    complex(DPC), dimension(:,:,:), allocatable :: phas_ns
    real(DP),     dimension(:),   allocatable :: ring
    integer(i4b)    :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl, i, ii
    integer(i4b)    :: l_start
    integer(I8B), dimension(0:SMAXCHK) :: startpix
    integer(I4B), dimension(0:SMAXCHK) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK) :: cth, sth
    real(DP),     dimension(0:SMAXCHK) :: one_on_s2, c_on_s2
    logical(LGT), dimension(0:SMAXCHK-1) :: keep_north, keep_south, keep_it

    character(LEN=*), parameter :: code = 'MAP2ALM'
    integer(I4B) :: status
    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    omega_pix = FOURPI / real(npix, DP)

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(normal_l(0:nlmax),stat = status)
    call assert_alloc(status,code,'normal_l')

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')

    allocate(phas_ns(0:nlmax,0:5,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_ns')

    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')
    allocate(recfac(0:1,0:nlmax),stat = status)
    call assert_alloc(status,code,'recfac')
    allocate(dalm(0:5,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm')
    allocate(lam_fact(0:nlmax),stat = status)
    call assert_alloc(status,code,'lam_fact')

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax,mfac)

    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    local_alms = 0.0 ! set the whole alm array to zero
    istart_north = 0
    istart_south = map_size

    ! generate Polarization normalisation
    call gen_normpol(nlmax, normal_l)

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
          ! find out which rings are to be analysed
          call select_rings(cth(ithl), zbounds, keep_north(ithl), keep_south(ithl), keep_it(ithl))
       enddo

       !-----------------------------------------------------------------------
       !  computes the integral in phi : phas_m(theta)
       !  for each parallele from Pole to Equator (use symmetry for S. Hemisphere)
       !-----------------------------------------------------------------------
       phas_ns = 0_dpc

       ! do Fourier Transform on rings
       do ith = lchk, uchk
          ithl = ith - lchk !local index
          nphl = nph(ithl)
          if (keep_north(ithl)) then
             do i=1,3
                ii = 2*(i-1) ! 0,2,4
                ring(0:nphl-1) = local_map(istart_north:istart_north+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
             istart_north = istart_north+nphl
          endif

          if (ith < 2*nsmax .and. keep_south(ithl)) then
             istart_south = istart_south-nphl
             do i=1,3
                ii = 2*i - 1 ! 1,3,5
                ring(0:nphl-1) = local_map(istart_south:istart_south+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
          endif
       enddo

       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)
          ! generate Ylm relation factor for degree m
          call gen_lamfac(nlmax, m, lam_fact)
          fm2 = real(m * m, kind = DP)
          normal_m = (2.0_dp * m) * (1 - m)

          ! introduce double precision vector to perform summation over ith for each l
          dalm(0:5, m:nlmax) = 0.0_dp

          do ithl = 0, uchk-lchk
             l_min = l_min_ylm(m, sth(ithl)) ! lower l bound of non-negligible Ylm
             if (keep_it(ithl) .and. nlmax >= l_min) then ! avoid un-necessary calculations (EH, 09-2001)
                ! determine lam_mm
                call mpi_compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)

                do i=0,2 ! loop on T, Q, U
                   phm = phas_ns(m, 2*i, ithl) - phas_ns(m, 2*i+1, ithl) ! N-S: (l+m) odd
                   phas_sd(-3+2*i)   =  real(phm, kind=dp) 
                   phas_sd(-3+2*i+1) = aimag(phm)
                   php = phas_ns(m, 2*i, ithl) + phas_ns(m, 2*i+1, ithl) ! N+S: (l+m) even
                   phas_sd( 3+2*i)   =  real(php, kind=dp) 
                   phas_sd( 3+2*i+1) = aimag(php)
                enddo
                phas_sdx(-3: 0) = (/ phas_sd(8), - phas_sd(7), - phas_sd(6),   phas_sd(5) /)
                phas_sdx( 3: 6) = (/ phas_sd(2), - phas_sd(1), - phas_sd(0),   phas_sd(-1) /)

                !           ---------- l = m ----------
                par_lm = 3  ! = 3 * (-1)^(l+m)
                lam_lm = corfac * lam_mm            ! Actual lam_mm

                if (m >= l_min) then
                   lambda_w =  (normal_m * lam_lm)  * ( 0.5_dp - one_on_s2(ithl) )
                   lambda_x =  (normal_m * lam_lm)  *            c_on_s2(ithl)

                   ! alm_T = \int T Ylm
                   ! alm_G = \int ( - Q Wlm - i U Xlm )
                   ! alm_C = \int ( - U Wlm + i Q Xlm )
                   dalm(0:1, m) = dalm(0:1, m) + lam_lm * phas_sd(par_lm:par_lm+1)
                   dalm(2:5, m) = dalm(2:5, m)  &
                        &       - lambda_w * phas_sd(par_lm+2:par_lm+5) &
!                         &       + lambda_x * (/ phas_sd(-par_lm+5), - phas_sd(-par_lm+4), &
!                         &                     - phas_sd(-par_lm+3),   phas_sd(-par_lm+2) /)
                        &       + lambda_x * phas_sdx(par_lm:par_lm+3)
                endif

                !           ---------- l > m ----------
                lam_0 = 0.0_dp
                lam_1 = 1.0_dp
                scalel=0
                cth_ring = cth(ithl)
                lam_2 = cth_ring * lam_1 * recfac(0,m)
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl) 
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = 3 * (-1)^(l+m)
                   if (l >= l_min) then
                      lam_lm1m = lam_lm * lam_fact(l)
                      lam_lm = lam_2 * corfac * lam_mm

                      fl = real(l, kind = DP)
                      flm1 = fl - 1.0_dp
                      a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                      a_x =  two_cth_ring * flm1
                      lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                      lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)

                      dalm(0:1, l) = dalm(0:1, l) + lam_lm * phas_sd(par_lm:par_lm+1)
                      dalm(2:5, l) = dalm(2:5, l)  &
                           &       - lambda_w * phas_sd(par_lm+2:par_lm+5) &
!                            &       + lambda_x * (/ phas_sd(-par_lm+5), - phas_sd(-par_lm+4), &
!                            &                     - phas_sd(-par_lm+3),   phas_sd(-par_lm+2) /)
                           &       + lambda_x * phas_sdx(par_lm:par_lm+3)
                   endif

                   lam_0 = lam_1 * recfac(1,l-1)
                   lam_1 = lam_2
                   lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                   if (abs(lam_2) > OVFLOW) then
                      lam_1 = lam_1*UNFLOW
                      lam_2 = lam_2*UNFLOW
                      scalel= scalel + 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   elseif (abs(lam_2) < UNFLOW) then
                      lam_1 = lam_1*OVFLOW
                      lam_2 = lam_2*OVFLOW
                      scalel= scalel - 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   endif
                   
                enddo ! loop on l

             endif ! test on cut sky
          enddo ! loop on ithl
          do l = m, nlmax
             local_alms(1,l,m) = local_alms(1,l,m) + cmplx(dalm(0,l), dalm(1,l)) * omega_pix
             local_alms(2,l,m) = local_alms(2,l,m) + &
                  & cmplx(dalm(2,l), dalm(3,l)) * normal_l(l) * omega_pix
             local_alms(3,l,m) = local_alms(3,l,m) + &
                  & cmplx(dalm(4,l), dalm(5,l)) * normal_l(l) * omega_pix
          enddo
       enddo ! loop on m

    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate (recfac,dalm,lam_fact,ring)
    deallocate(mfac, normal_l)
    deallocate(phas_ns)

    return

  end subroutine mpi_map2alm_pol


  subroutine mpi_map2alm_pol_pre1
    !=======================================================================
    !     computes the a(l,m) from a polarized map for the HEALPIX pixelisation
    !       with precomputed Ylm_T(theta)
    !=======================================================================

    integer(I4B) :: l, m, ith
    integer(I8B) :: istart_south, istart_north, npix, n_lm, i_mm
    integer(I4B) :: nrings, nphmx
    real(DP)     :: omega_pix

    integer(I4B)                              :: par_lm
    real(DP)            :: lam_lm, cth_ring
    real(DP)                 :: lambda_w, lambda_x, normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP),     dimension(-3:8)             :: phas_sd
    real(DP),     dimension(-3:6)             :: phas_sdx
    real(DP),     dimension(:,:), allocatable :: dalm
    real(DP),     dimension(:),   allocatable :: lam_fact

    integer(i4b)                              :: l_min
    real(DP),     dimension(:),   allocatable :: normal_l
    complex(DPC)                              :: php, phm
    complex(DPC), dimension(:,:,:), allocatable :: phas_ns
    real(DP),     dimension(:),   allocatable :: ring
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl, i, ii
    integer(i4b)        :: l_start
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK-1) :: cth, sth
    real(DP),     dimension(0:SMAXCHK-1) :: one_on_s2, c_on_s2
    logical(LGT), dimension(0:SMAXCHK-1) :: keep_north, keep_south, keep_it
    integer(I4B)                       :: nphl

    character(LEN=*), parameter :: code = 'MAP2ALM'
    integer(I4B) :: status
    logical(lgt) :: start_iter_even, start_iter_odd

    real(dp) :: t1, t2, t3

    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    omega_pix = FOURPI / real(npix, DP)
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(normal_l(0:nlmax),stat = status)
    call assert_alloc(status,code,'normal_l')

    allocate(phas_ns(0:nlmax,0:5,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_ns')

    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')
    allocate(dalm(0:5,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm')
    allocate(lam_fact(0:nlmax),stat = status)
    call assert_alloc(status,code,'lam_fact')

    !     ------------ initiate variables and arrays ----------------

    local_alms = 0.0 ! set the whole alm array to zero
    istart_north = 0
    istart_south = map_size

    ! generate Polarization normalisation
    call gen_normpol(nlmax, normal_l)

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
          ! find out which rings are to be analysed
          call select_rings(cth(ithl), zbounds, keep_north(ithl), keep_south(ithl), keep_it(ithl))
       enddo

       !-----------------------------------------------------------------------
       !  computes the integral in phi : phas_m(theta)
       !  for each parallele from Pole to Equator (use symmetry for S. Hemisphere)
       !-----------------------------------------------------------------------
       phas_ns = 0_dpc

       ! do Fourier Transform on rings
       do ith = lchk, uchk
          ithl = ith - lchk !local index
          nphl = nph(ithl)
          if (keep_north(ithl)) then
             do i=1,3
                ii = 2*(i-1) ! 0,2,4
                ring(0:nphl-1) = local_map(istart_north:istart_north+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
             istart_north = istart_north+nphl
          endif

          if (ith < 2*nsmax .and. keep_south(ithl)) then
             istart_south = istart_south-nphl
             do i=1,3
                ii = 2*i - 1 ! 1,3,5
                ring(0:nphl-1) = local_map(istart_south:istart_south+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
          endif
       enddo

       do m = 0, nmmax
          ! generate Ylm relation factor for degree m
          call gen_lamfac(nlmax, m, lam_fact)
          fm2 = real(m * m, kind = DP)
          normal_m = (2.0_dp * m) * (1 - m)

          ! introduce double precision vector to perform summation over ith for each l
          dalm(0:5, m:nlmax) = 0.0_dp

          do ithl = 0, uchk-lchk
             l_min = l_min_ylm(m, sth(ithl)) ! lower l bound of non-negligible Ylm
             if (keep_it(ithl) .and. nlmax >= l_min) then ! avoid un-necessary calculations (EH, 09-2001)
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + ((2_I8B*nlmax + 3 - m)*m)/2 ! location of Ym,m for ring ith

                do i=0,2 ! loop on T, Q, U
                   phm = phas_ns(m, 2*i, ithl) - phas_ns(m, 2*i+1, ithl) ! N-S: (l+m) odd
                   phas_sd(-3+2*i)   =  real(phm, kind=dp) 
                   phas_sd(-3+2*i+1) = aimag(phm)
                   php = phas_ns(m, 2*i, ithl) + phas_ns(m, 2*i+1, ithl) ! N+S: (l+m) even
                   phas_sd( 3+2*i)   =  real(php, kind=dp) 
                   phas_sd( 3+2*i+1) = aimag(php)
                enddo
                phas_sdx(-3: 0) = (/ phas_sd(8), - phas_sd(7), - phas_sd(6),   phas_sd(5) /)
                phas_sdx( 3: 6) = (/ phas_sd(2), - phas_sd(1), - phas_sd(0),   phas_sd(-1) /)

                !           ---------- l = m ----------
                par_lm = 3  ! = 3 * (-1)^(l+m)
                lam_lm = plm(i_mm,1)

                if (m >= l_min) then
                   lambda_w =  (normal_m * lam_lm)  * ( 0.5_dp - one_on_s2(ithl) )
                   lambda_x =  (normal_m * lam_lm)  *            c_on_s2(ithl)

                   ! alm_T = \int T Ylm
                   ! alm_G = \int ( - Q Wlm - i U Xlm )
                   ! alm_C = \int ( - U Wlm + i Q Xlm )
                   dalm(0:1, m) = dalm(0:1, m) + lam_lm * phas_sd(par_lm:par_lm+1)
                   dalm(2:5, m) = dalm(2:5, m)  &
                        &       - lambda_w * phas_sd(par_lm+2:par_lm+5) &
!                         &       + lambda_x * (/ phas_sd(-par_lm+5), - phas_sd(-par_lm+4), &
!                         &                     - phas_sd(-par_lm+3),   phas_sd(-par_lm+2) /)
                        &       + lambda_x * phas_sdx(par_lm:par_lm+3)
                endif

                !           ---------- l > m ----------
                cth_ring = cth(ithl)
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl) 

                l_start = max(m+1, l_min)
                if (mod(m+l_start,2) == 0) l_start = l_start+1
                do l = l_start, nlmax, 2

                   lam_lm1m = plm(i_mm+l-m-1,1) * lam_fact(l)
                   lam_lm   = plm(i_mm+l-m,1)

                   fl = real(l, kind = DP)
                   flm1 = fl - 1.0_dp
                   a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                   a_x =  two_cth_ring * flm1
                   lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                   lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)
                   
                   dalm(0,l) = dalm(0,l) + lam_lm * phas_sd(-3)
                   dalm(1,l) = dalm(1,l) + lam_lm * phas_sd(-2)

                   dalm(2,l) = dalm(2,l) - lambda_w * phas_sd(-1) + lambda_x * phas_sdx(-3)
                   dalm(3,l) = dalm(3,l) - lambda_w * phas_sd(0) + lambda_x * phas_sdx(-2)
                   dalm(4,l) = dalm(4,l) - lambda_w * phas_sd(1) + lambda_x * phas_sdx(-1)
                   dalm(5,l) = dalm(5,l) - lambda_w * phas_sd(2) + lambda_x * phas_sdx(0)
                enddo ! loop on l

                l_start = max(m+2, l_min)
                if (mod(m+l_start,2) == 1) l_start = l_start+1
                do l = l_start, nlmax, 2

                   lam_lm1m = plm(i_mm+l-m-1,1) * lam_fact(l)
                   lam_lm   = plm(i_mm+l-m,1)

                   fl = real(l, kind = DP)
                   flm1 = fl - 1.0_dp
                   a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                   a_x =  two_cth_ring * flm1
                   lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                   lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)

                   dalm(0,l) = dalm(0,l) + lam_lm * phas_sd(3)
                   dalm(1,l) = dalm(1,l) + lam_lm * phas_sd(4)
                   dalm(2,l) = dalm(2,l) - lambda_w * phas_sd(5) + lambda_x * phas_sdx(3)
                   dalm(3,l) = dalm(3,l) - lambda_w * phas_sd(6) + lambda_x * phas_sdx(4)
                   dalm(4,l) = dalm(4,l) - lambda_w * phas_sd(7) + lambda_x * phas_sdx(5)
                   dalm(5,l) = dalm(5,l) - lambda_w * phas_sd(8) + lambda_x * phas_sdx(6)
                enddo ! loop on l

             endif ! test on cut sky
          enddo ! loop on ithl

          do l = m, nlmax
             local_alms(1,l,m) = local_alms(1,l,m) + &
                  & cmplx(dalm(0,l), dalm(1,l)) * omega_pix
             local_alms(2,l,m) = local_alms(2,l,m) + &
                  & cmplx(dalm(2,l), dalm(3,l)) * normal_l(l) * omega_pix
             local_alms(3,l,m) = local_alms(3,l,m) + &
                  & cmplx(dalm(4,l), dalm(5,l)) * normal_l(l) * omega_pix
          enddo

       enddo ! loop on m

    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate (dalm,lam_fact,ring)
    deallocate(normal_l, phas_ns)

    return

  end subroutine mpi_map2alm_pol_pre1


  subroutine mpi_map2alm_pol_pre2

    !=======================================================================
    !     computes the a(l,m) from a polarized map for the HEALPIX pixelisation
    !       with precomputed Ylm_T(theta) an dYlm_P(theta)
    !=======================================================================

    integer(I4B) :: l, m, ith
    integer(I8B) :: istart_south, istart_north, npix, n_lm, i_mm, i_up
    integer(I4B) :: nrings, nphmx
    real(DP)     :: omega_pix

    integer(I4B)                              :: par_lm
    real(DP),     dimension(-3:8)             :: phas_sd
    real(DP),     dimension(-3:6)             :: phas_sdx
    real(DP),     dimension(:,:), allocatable :: dalm, plm_sub

    integer(i4b)                              :: l_min
    complex(DPC)                              :: php, phm
    complex(DPC), dimension(:,:,:), allocatable :: phas_ns
    real(DP),     dimension(:),   allocatable :: ring
    integer(i4b)    :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl, i, ii
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    real(DP)                           :: cth
    real(DP),     dimension(0:SMAXCHK-1) :: sth
    logical(LGT), dimension(0:SMAXCHK-1) :: keep_north, keep_south, keep_it

    character(LEN=*), parameter :: code = 'MAP2ALM'
    integer(I4B) :: status
    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    omega_pix = FOURPI / real(npix, DP)
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(phas_ns(0:nlmax,0:5,0:chunksize-1),stat = status)
    call assert_alloc(status,code,'phas_ns')

    allocate(dalm(0:5,0:nlmax), plm_sub(1:3,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm & plm_sub')
    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')

    !     ------------ initiate variables and arrays ----------------

    local_alms = 0.0 ! set the whole alm array to zero
    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth, sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          ! find out which rings are to be analysed
          call select_rings(cth, zbounds, keep_north(ithl), keep_south(ithl), keep_it(ithl))
       enddo

       !-----------------------------------------------------------------------
       !  computes the integral in phi : phas_m(theta)
       !  for each parallele from Pole to Equator (use symmetry for S. Hemisphere)
       !-----------------------------------------------------------------------
       phas_ns = 0_dpc

       ! do Fourier Transform on rings
       do ith = lchk, uchk
          ithl = ith - lchk !local index
          nphl = nph(ithl)
          if (keep_north(ithl)) then
             do i=1,3
                ii = 2*(i-1) ! 0,2,4
                ring(0:nphl-1) = local_map(istart_north:istart_north+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
             istart_north = istart_north + nphl
          endif

          if (ith < 2*nsmax .and. keep_south(ithl)) then
             istart_south = istart_south - nphl
             do i=1,3
                ii = 2*i - 1 ! 1,3,5
                ring(0:nphl-1) = local_map(istart_south:istart_south+nphl-1,i) * &
                     & local_w8ring(ith-first_ring+1,i)
                call ring_analysis(nsmax, nlmax, nmmax, ring, nphl, phas_ns(0,ii,ithl), kphi0(ithl))
             enddo
          endif
       enddo

       do m = 0, nmmax 

          ! introduce double precision vector to perform summation over ith for each l
          dalm(0:5, m:nlmax) = 0.0_dp

          do ithl = 0, uchk - lchk
             l_min = l_min_ylm(m, sth(ithl)) ! lower l bound of non-negligible Ylm
             if (keep_it(ithl) .and. nlmax >= l_min) then ! avoid un-necessary calculations (EH, 09-2001)
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + ((2_I8B*nlmax + 3 - m)*m)/2 ! location of Ym,m for ring ith
                i_up = i_mm + nlmax - m
                plm_sub(1,m:nlmax) = plm(i_mm:i_up,1)
                plm_sub(2,m:nlmax) = plm(i_mm:i_up,2)
                plm_sub(3,m:nlmax) = plm(i_mm:i_up,3)

                do i=0,2 ! loop on T, Q, U
                   phm = phas_ns(m, 2*i, ithl) - phas_ns(m, 2*i+1, ithl) ! N-S: (l+m) odd
                   phas_sd(-3+2*i)   =  real(phm, kind=dp) 
                   phas_sd(-3+2*i+1) = aimag(phm)
                   php = phas_ns(m, 2*i, ithl) + phas_ns(m, 2*i+1, ithl) ! N+S: (l+m) even
                   phas_sd( 3+2*i)   =  real(php, kind=dp) 
                   phas_sd( 3+2*i+1) = aimag(php)
                enddo
                phas_sdx(-3: 0) = (/ phas_sd(8), - phas_sd(7), - phas_sd(6),   phas_sd(5) /)
                phas_sdx( 3: 6) = (/ phas_sd(2), - phas_sd(1), - phas_sd(0),   phas_sd(-1) /)

                !           ---------- l = m ----------
                par_lm = 3  ! = 3 * (-1)^(l+m)

                if (m >= l_min) then
                   
                   ! alm_T = \int T Ylm
                   ! alm_G = \int ( - Q Wlm - i U Xlm )
                   ! alm_C = \int ( - U Wlm + i Q Xlm )
                   dalm(0:1, m) = dalm(0:1, m) + plm_sub(1,m) * phas_sd(par_lm:par_lm+1)
                   dalm(2:5, m) = dalm(2:5, m)  &
                        &       - plm_sub(2,m) * phas_sd(par_lm+2:par_lm+5) &
!                         &       + plm_sub(3,m) * (/ phas_sd(-par_lm+5), - phas_sd(-par_lm+4), &
!                         &                     - phas_sd(-par_lm+3),   phas_sd(-par_lm+2) /)
                        &       + plm_sub(3,m) * phas_sdx(par_lm:par_lm+3)
                endif

                !           ---------- l > m ----------
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = 3 * (-1)^(l+m)
                   if (l >= l_min) then
                      dalm(0:1, l) = dalm(0:1, l) + plm_sub(1,l) * phas_sd(par_lm:par_lm+1)
                      dalm(2:5, l) = dalm(2:5, l)  &
                           &       - plm_sub(2,l) * phas_sd(par_lm+2:par_lm+5) &
!                            &       + plm_sub(3,l) * (/ phas_sd(-par_lm+5), - phas_sd(-par_lm+4), &
!                            &                     - phas_sd(-par_lm+3),   phas_sd(-par_lm+2) /)
                        &       + plm_sub(3,l) * phas_sdx(par_lm:par_lm+3)
                   endif
                   
                enddo ! loop on l
             endif ! test on cut sky
          enddo ! loop on ithl
          do l = m, nlmax
             local_alms(1,l,m) = local_alms(1,l,m) + cmplx(dalm(0,l), dalm(1,l)) * omega_pix
             local_alms(2,l,m) = local_alms(2,l,m) + cmplx(dalm(2,l), dalm(3,l)) * omega_pix
             local_alms(3,l,m) = local_alms(3,l,m) + cmplx(dalm(4,l), dalm(5,l)) * omega_pix
          enddo
       enddo ! loop on m
    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(phas_ns)
    deallocate (ring, dalm, plm_sub)

    return

  end subroutine mpi_map2alm_pol_pre2





  subroutine mpi_alm2map_sc
    !=======================================================================
    !     computes a map form its alm for the HEALPIX pixelisation
    !      for the Temperature field
    !     map(theta,phi) = sum_l_m a_lm Y_lm(theta,phi)
    !                    = sum_m {e^(i*m*phi) sum_l a_lm*lambda_lm(theta)}
    !
    !     where Y_lm(theta,phi) = lambda(theta) * e^(i*m*phi)
    !
    !     * the recurrence of Ylm is the standard one (cf Num Rec)
    !     * the sum over m is done by FFT
    !
    !=======================================================================

    integer(I4B) :: l, m, ith, scalel, scalem ! alm related
    integer(I8B) :: istart_south, istart_north, npix   ! map related
    integer(I4B) :: nrings, nphmx

    integer(I4B)                              :: par_lm
    real(DP)              :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
    real(DP)                                  :: ovflow, unflow
    complex(DPC), dimension(-1:1)             :: b_ns
    real(DP),     dimension(:,:), allocatable :: dalm
    real(DP),     dimension(:),   allocatable :: mfac
    real(DP),     dimension(:,:), allocatable :: recfac

    integer(i4b)                                :: ll, l_min
    complex(DPC), dimension(:,:), allocatable :: b_north, b_south
    real(DP),     dimension(:),   allocatable :: ring
    integer(i4b)             :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK-1) :: cth, sth

    character(LEN=*), parameter :: code = 'ALM2MAP'
    integer(I4B) :: status

    real(dp) :: t1, t2
    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')

    allocate(b_north(0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_north')

    allocate(b_south(0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_south')

    allocate(recfac(0:1,0:nlmax),stat = status)
    call assert_alloc(status,code,'recfac')
    allocate(dalm(0:1,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm')
    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax,mfac)

    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    local_map = 0.d0 ! set the whole map to zero

    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
       enddo
       !        -----------------------------------------------------
       !        for each theta, and each m, computes
       !        b(m,theta) = sum_over_l>m (lambda_l_m(theta) * a_l_m)
       !        ------------------------------------------------------
       !        lambda_mm tends to go down when m increases (risk of underflow)
       !        lambda_lm tends to go up   when l increases (risk of overflow)


       b_north(:,:) = 0_dpc ! pad with zeros
       b_south(:,:) = 0_dpc

       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)

          ! extract needed alm under memory and CPU efficient form
          do ll = m, nlmax
             dalm(0,ll) =  real(local_alms(1,ll,m),kind=dp)
             dalm(1,ll) = aimag(local_alms(1,ll,m))
          enddo
          do ithl = 0, uchk-lchk
             l_min = l_min_ylm(m, sth(ithl))
             if (nlmax >= l_min) then ! skip calculations when Ylm too small
                ! determine lam_mm
                call mpi_compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)
               
                !           ---------- l = m ----------
                par_lm = 1  ! = (-1)^(l+m)

                if (m >= l_min) then
                   lam_lm = corfac * lam_mm
                   b_ns( 1) = cmplx(lam_lm * dalm(0,m), lam_lm * dalm(1,m), kind=DP)
                   b_ns(-1) = 0.0_dpc
                else
                   b_ns = 0.0_dpc
                endif

                !           ---------- l > m ----------
                lam_0 = 0.0_dp
                lam_1 = 1.0_dp
                scalel=0
                cth_ring = cth(ithl)
                lam_2 = cth_ring * lam_1 * recfac(0,m)
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = (-1)^(l+m)
                   if (l >= l_min) then
                      lam_lm = lam_2 * corfac * lam_mm                   
                      b_ns(par_lm)  = b_ns(par_lm) &
                           &        + cmplx(lam_lm * dalm(0,l), lam_lm * dalm(1,l), kind=DP)  ! increment even or odd
                   endif

                   lam_0 = lam_1 * recfac(1,l-1)
                   lam_1 = lam_2
                   lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                   if (abs(lam_2) > OVFLOW) then
                      lam_1 = lam_1*UNFLOW
                      lam_2 = lam_2*UNFLOW
                      scalel= scalel + 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   elseif (abs(lam_2) < UNFLOW) then
                      lam_1 = lam_1*OVFLOW
                      lam_2 = lam_2*OVFLOW
                      scalel= scalel - 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   endif
                   
                enddo ! loop on l

                b_north(m,ithl) = b_ns(1) + b_ns(-1)
                b_south(m,ithl) = b_ns(1) - b_ns(-1)
             endif ! test on nlmax
          enddo ! loop on rings (ithl)
       enddo ! loop on m

       do ithl = 0, uchk-lchk
          nphl = nph(ithl)
          ith  = ithl + lchk
          !        ---------------------------------------------------------------
          !        sum_m  b(m,theta)*exp(i*m*phi)   -> f(phi,theta) by FFT
          !        ---------------------------------------------------------------
          call ring_synthesis(nsmax,nlmax,nmmax,b_north(0,ithl),nphl,ring,kphi0(ithl))   ! north hemisph. + equator
          local_map(istart_north:istart_north+nphl-1,1) = ring(0:nphl-1)
          istart_north = istart_north+nphl

          if (ith < 2*nsmax) then
             istart_south = istart_south-nphl
             call ring_synthesis(nsmax,nlmax,nmmax,b_south(0,ithl),nphl,ring,kphi0(ithl)) ! south hemisph. w/o equat
             local_map(istart_south:istart_south+nphl-1,1) = ring(0:nphl-1)
          endif
       enddo ! loop on ithl

    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(ring,recfac,dalm)
    deallocate(mfac)
    deallocate(b_north, b_south)

    return

  end subroutine mpi_alm2map_sc


  subroutine mpi_alm2map_sc_pre
    !=======================================================================
    !     computes a map form its alm for the HEALPIX pixelisation
    !      for the Temperature field, with precomputed Ylm
    !     map(theta,phi) = sum_l_m a_lm Y_lm(theta,phi)
    !                    = sum_m {e^(i*m*phi) sum_l a_lm*lambda_lm(theta)}
    !
    !     where Y_lm(theta,phi) = lambda(theta) * e^(i*m*phi)
    !
    !     * the recurrence of Ylm is the standard one (cf Num Rec)
    !     * the sum over m is done by FFT
    !
    !=======================================================================

    integer(I4B) :: l, m, ith
    integer(I8B) :: istart_south, istart_north, npix
    integer(I4B) :: nrings, nphmx

    integer(I8B) :: n_lm, i_mm
    integer(I4B)                              :: par_lm
    complex(DPC), dimension(-1:1)             :: b_ns
    real(DP),     dimension(:,:), allocatable :: dalm
    integer(i4b)                              :: ll, l_min
    real(DP)                                  :: cth
    complex(DPC), dimension(:,:), allocatable :: b_north, b_south
    real(DP),     dimension(:),   allocatable :: ring
    integer(i4b)             :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl
    integer(I8B), dimension(0:SMAXCHK-1) :: startpix
    integer(I4B), dimension(0:SMAXCHK-1) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK-1) :: sth

    character(LEN=*), parameter :: code = 'ALM2MAP'
    integer(I4B) :: status, l_start

    real(dp) :: t1, t2

    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(b_north(0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_north')

    allocate(b_south(0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_south')

    allocate(dalm(0:1,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm')
    allocate(ring(0:nphmx-1),stat = status)
    call assert_alloc(status,code,'ring')

    !     ------------ initiate variables and arrays ----------------

    local_map = 0.d0 ! set the whole map to zero
    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       call cpu_time(t1)

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth, sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
       enddo

       !        -----------------------------------------------------
       !        for each theta, and each m, computes
       !        b(m,theta) = sum_over_l>m (lambda_l_m(theta) * a_l_m)
       !        ------------------------------------------------------

       b_north(:,:) = 0_dpc ! pad with zeros
       b_south(:,:) = 0_dpc

       do m = 0, nmmax

          ! extract needed alm under memory and CPU efficient form
          do ll = m, nlmax
             dalm(0,ll) =  real(local_alms(1,ll,m),kind=dp)
             dalm(1,ll) = aimag(local_alms(1,ll,m))
          enddo
          do ithl = 0, uchk-lchk
             l_min = l_min_ylm(m, sth(ithl))
             if (nlmax >= l_min) then ! skip calculations when Ylm too small
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + ((2_I8B*nlmax + 3 - m)*m)/2 ! location of Ym,m for ring ith

                !           ---------- l = m ----------
                par_lm = 1  ! = (-1)^(l+m)

                if (m >= l_min) then
                   b_ns( 1) = cmplx(plm(i_mm,1) * dalm(0,m), plm(i_mm,1) * dalm(1,m), kind=DP)
                   b_ns(-1) = 0.0_dpc
                else
                   b_ns = 0.0_dpc
                endif

                !           ---------- l > m ----------
                l_start = max(m+1, l_min)
                if (mod(m+l_start,2) == 0) l_start = l_start+1
                do l = l_start, nlmax, 2
                   b_ns(-1) = b_ns(-1) + &
                        & cmplx(plm(i_mm+l-m,1) * dalm(0,l), plm(i_mm+l-m,1)*dalm(1,l), kind=DP)
                enddo ! loop on l

                l_start = max(m+2, l_min)
                if (mod(m+l_start,2) == 1) l_start = l_start+1
                do l = l_start, nlmax, 2
                   b_ns(1)  = b_ns(1) + &
                        & cmplx(plm(i_mm+l-m,1) * dalm(0,l), plm(i_mm+l-m,1)*dalm(1,l),kind=DP) 
                enddo ! loop on l

                b_north(m,ithl) = b_ns(1) + b_ns(-1)
                b_south(m,ithl) = b_ns(1) - b_ns(-1)
             endif ! test on nlmax
          enddo ! loop on rings (ithl)
       enddo ! loop on m

       do ithl = 0, uchk-lchk
          nphl = nph(ithl)
          ith  = ithl + lchk
          !        ---------------------------------------------------------------
          !        sum_m  b(m,theta)*exp(i*m*phi)   -> f(phi,theta) by FFT
          !        ---------------------------------------------------------------
          call ring_synthesis(nsmax,nlmax,nmmax,b_north(0,ithl),nphl,ring,kphi0(ithl))   ! north hemisph. + equator
          local_map(istart_north:istart_north+nphl-1,1) = ring(0:nphl-1)
          istart_north = istart_north+nphl

          if (ith < 2*nsmax) then
             call ring_synthesis(nsmax,nlmax,nmmax,b_south(0,ithl),nphl,ring,kphi0(ithl)) ! south hemisph. w/o equat
             istart_south = istart_south-nphl
             local_map(istart_south:istart_south+nphl-1,1) = ring(0:nphl-1)
          endif
       enddo ! loop on ithl

       call cpu_time(t2)
!       write(*,*) (lchk+uchk)/2, t2-t1

    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate (ring,dalm)
    deallocate(b_north, b_south)

    return

  end subroutine mpi_alm2map_sc_pre



  subroutine mpi_alm2map_pol
    !=======================================================================
    !     computes a map form its alm for the HEALPIX pixelisation
    !      for the Temperature+Polarization field
    !=======================================================================

    integer(I4B) :: l, m, ith, scalel, scalem ! alm related
    integer(I4B) :: istart_south, istart_north   ! map related
    integer(I4B) :: nrings, npix, nphmx

    integer(I4B)                              :: par_lm
    real(DP)            :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
    real(DP)                 :: lambda_w, lambda_x, normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP)                 :: ovflow, unflow
    real(DP),     dimension(-3:8)             :: b_ns
    real(DP),     dimension(:,:), allocatable :: recfac, dalm
    real(DP),     dimension(:),   allocatable :: lam_fact
    real(DP),     dimension(:), allocatable :: mfac

    integer(i4b)                                :: ll, l_min
    real(DP),     dimension(:),     allocatable :: normal_l
    complex(DPC), dimension(:,:,:), allocatable :: b_TQU
    complex(DPC), dimension(:),     allocatable :: bsub
    real(DP),     dimension(:),     allocatable :: ring
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl, i
    integer(I8B), dimension(0:SMAXCHK) :: startpix
    integer(I4B), dimension(0:SMAXCHK) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK) :: cth, sth
    real(DP),     dimension(0:SMAXCHK) :: one_on_s2, c_on_s2

    character(LEN=*), parameter :: code = 'ALM2MAP'
    integer(I4B) :: status
    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')

    allocate(normal_l(0:nlmax),stat = status)
    call assert_alloc(status,code,'normal_l')

    allocate(b_TQU(1:6, 0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_TQU')

    allocate(recfac(0:1,0:nlmax), dalm(0:5,0:nlmax), lam_fact(0:nlmax),stat = status)
    call assert_alloc(status,code,'recfac, dalm & lam_fact')
    allocate(ring(0:nphmx-1),bsub(0:nlmax),stat = status)
    call assert_alloc(status,code,'ring & bsub')

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax,mfac)

    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    local_map = 0.d0 ! set the whole map to zero
    istart_north = 0
    istart_south = map_size

    ! generate Polarization normalisation
    call gen_normpol(nlmax, normal_l)

    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
       enddo
       !        -----------------------------------------------------
       !        for each theta, and each m, computes
       !        b(m,theta) = sum_over_l>m (lambda_l_m(theta) * a_l_m)
       !        ------------------------------------------------------
       !        lambda_mm tends to go down when m increases (risk of underflow)
       !        lambda_lm tends to go up   when l increases (risk of overflow)


       b_TQU = 0_dpc ! pad with zeros

       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)
          ! generate Ylm relation factor for degree m
          call gen_lamfac(nlmax, m, lam_fact)
          fm2 = real(m * m, kind = DP)
          normal_m = (2.0_dp * m) * (1 - m)

          ! extract needed alm under memory and CPU efficient form
          do ll = m, nlmax
             dalm(0,ll) =  real(local_alms(1,ll,m),kind=dp) ! T, real
             dalm(1,ll) = aimag(local_alms(1,ll,m))         ! T, imag
             dalm(2,ll) =  real(local_alms(2,ll,m),kind=dp)*normal_l(ll) ! G, real
             dalm(3,ll) = aimag(local_alms(2,ll,m))        *normal_l(ll)
             dalm(4,ll) =  real(local_alms(3,ll,m),kind=dp)*normal_l(ll) ! C, real
             dalm(5,ll) = aimag(local_alms(3,ll,m))        *normal_l(ll)
          enddo
          do ithl = 0, uchk-lchk
             l_min =  l_min_ylm(m, sth(ithl)) ! lowest l of non-negligible Ylm
             if (nlmax >= l_min) then
                ! determine lam_mm
                call mpi_compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)

                !           ---------- l = m ----------
                par_lm = 3  ! = 3 * (-1)^(l+m)
                lam_lm = corfac * lam_mm !Actual lam_mm 

                if (m >= l_min) then ! skip Ymm if too small
                   lambda_w =  (normal_m * lam_lm)  * ( 0.5_dp - one_on_s2(ithl) )
                   lambda_x =  (normal_m * lam_lm)  *            c_on_s2(ithl)

                   !      T =   alm_T * Ylm
                   !      Q = - alm_E * Wlm - i alm_B * Xlm
                   !      U = i alm_E * Xlm -   alm_B * Wlm
                   b_ns(-3:-2) = 0.0_dp               ! T odd
                   b_ns(-1: 0) =   lambda_x * (/   dalm(5,m), - dalm(4,m) /) ! Q odd
                   b_ns( 1: 2) =   lambda_x * (/ - dalm(3,m),   dalm(2,m) /) ! U odd
!                    b_ns(-1) =   lambda_x * dalm(5,m) ! Q odd
!                    b_ns( 0) =  -lambda_x * dalm(4,m) ! Q odd
!                    b_ns( 1) =  -lambda_x * dalm(3,m) ! U odd
!                    b_ns( 2) =   lambda_x * dalm(2,m) ! U odd

                   b_ns( 3: 4) =   lam_lm   * dalm(0:1,m) ! T even
                   b_ns( 5: 6) = - lambda_w * dalm(2:3,m) ! Q even
                   b_ns( 7: 8) = - lambda_w * dalm(4:5,m) ! U even
                else
                   b_ns = 0.0_dp
                endif

                !           ---------- l > m ----------
                lam_0 = 0.0_dp
                lam_1 = 1.0_dp
                scalel=0
                cth_ring = cth(ithl)
                lam_2 = cth_ring * lam_1 * recfac(0,m)
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl) 
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = 3 * (-1)^(l+m)
                   if (l >= l_min) then
                      lam_lm1m = lam_lm * lam_fact(l)
                      lam_lm = lam_2 * corfac * lam_mm

                      fl = real(l, kind = DP)
                      flm1 = fl - 1.0_dp
                      a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                      a_x =  two_cth_ring * flm1
                      lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                      lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)

!                      b_ns(par_lm:  par_lm+1) = b_ns(par_lm:  par_lm+1) + lam_lm   * dalm(0:1,l) ! T even or odd
!                      b_ns(par_lm+2:par_lm+5) = b_ns(par_lm+2:par_lm+5) - lambda_w * dalm(2:5,l) ! Q, U  even or odd
!                      b_ns(2-par_lm) = b_ns(2-par_lm) + lambda_x * dalm(5,l) ! Q odd (or even)
!                      b_ns(3-par_lm) = b_ns(3-par_lm) - lambda_x * dalm(4,l)
!                      b_ns(4-par_lm) = b_ns(4-par_lm) - lambda_x * dalm(3,l) ! U odd (or even)
!                      b_ns(5-par_lm) = b_ns(5-par_lm) + lambda_x * dalm(2,l)

                      ! Speed up change by Gregory Bauer
                      if (par_lm==-3) then
                         b_ns(-3) = b_ns(-3) + lam_lm   * dalm(0,l) ! T even or odd
                         b_ns(-2) = b_ns(-2) + lam_lm   * dalm(1,l) ! T even or odd
                         b_ns(-1) = b_ns(-1) - lambda_w * dalm(2,l) ! Q, U  even or odd
                         b_ns(8) = b_ns(8) + lambda_x * dalm(2,l)
                         b_ns(0) = b_ns(0) - lambda_w * dalm(3,l) ! Q, U  even or odd
                         b_ns(7) = b_ns(7) - lambda_x * dalm(3,l) ! U odd (or even)
                         b_ns(1) = b_ns(1) - lambda_w * dalm(4,l) ! Q, U  even or odd
                         b_ns(6) = b_ns(6) - lambda_x * dalm(4,l)
                         b_ns(2) = b_ns(2) - lambda_w * dalm(5,l) ! Q, U  even or odd
                         b_ns(5) = b_ns(5) + lambda_x * dalm(5,l) ! Q odd (or even)
                      else
                         b_ns(3) = b_ns(3) + lam_lm   * dalm(0,l) ! T even or odd
                         b_ns(4) = b_ns(4) + lam_lm   * dalm(1,l) ! T even or odd
                         b_ns(2) = b_ns(2) + lambda_x * dalm(2,l)
                         b_ns(5) = b_ns(5) - lambda_w * dalm(2,l) ! Q, U  even or odd
                         b_ns(1) = b_ns(1) - lambda_x * dalm(3,l) ! U odd (or even)
                         b_ns(6) = b_ns(6) - lambda_w * dalm(3,l) ! Q, U  even or odd
                         b_ns(0) = b_ns(0) - lambda_x * dalm(4,l)
                         b_ns(7) = b_ns(7) - lambda_w * dalm(4,l) ! Q, U  even or odd
                         b_ns(-1) = b_ns(-1) + lambda_x * dalm(5,l) ! Q odd (or even)
                         b_ns(8) = b_ns(8) - lambda_w * dalm(5,l) ! Q, U  even or odd
                      endif
                      
                   endif

                   lam_0 = lam_1 * recfac(1,l-1)
                   lam_1 = lam_2
                   lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                   if (abs(lam_2) > OVFLOW) then
                      lam_1 = lam_1*UNFLOW
                      lam_2 = lam_2*UNFLOW
                      scalel= scalel + 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   elseif (abs(lam_2) < UNFLOW) then
                      lam_1 = lam_1*OVFLOW
                      lam_2 = lam_2*OVFLOW
                      scalel= scalel - 1
                      corfac = rescale_tab(max(scalel+scalem,RSMIN))
                   endif

                enddo ! loop on l

                b_TQU(1,m,ithl) = cmplx(b_ns(3) + b_ns(-3), b_ns(4) + b_ns(-2), kind = DP) ! T north
                b_TQU(4,m,ithl) = cmplx(b_ns(3) - b_ns(-3), b_ns(4) - b_ns(-2), kind = DP) ! T south
                b_TQU(2,m,ithl) = cmplx(b_ns(5) + b_ns(-1), b_ns(6) + b_ns( 0), kind = DP) ! Q n
                b_TQU(5,m,ithl) = cmplx(b_ns(5) - b_ns(-1), b_ns(6) - b_ns( 0), kind = DP) ! Q s
                b_TQU(3,m,ithl) = cmplx(b_ns(7) + b_ns( 1), b_ns(8) + b_ns( 2), kind = DP) ! U n
                b_TQU(6,m,ithl) = cmplx(b_ns(7) - b_ns( 1), b_ns(8) - b_ns( 2), kind = DP) ! U s
             endif ! test on nlmax
          enddo ! loop on rings (ithl)
       enddo ! loop on m


       do ithl = 0, uchk-lchk
          nphl = nph(ithl)
          ith  = ithl + lchk
          !        ---------------------------------------------------------------
          !        sum_m  b(m,theta)*exp(i*m*phi)   -> f(phi,theta) by FFT
          !        ---------------------------------------------------------------
          do i=1,3
             bsub = b_TQU(i,:,ithl)
             call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl))   ! north hemisph. + equator
             local_map(istart_north:istart_north+nphl-1, i) = ring(0:nphl-1)
          enddo
          istart_north = istart_north+nphl

          if (ith < 2*nsmax) then
             istart_south = istart_south-nphl
             do i=1,3
                bsub = b_TQU(3+i,:,ithl)
                call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl)) ! south hemisph. w/o equat
                local_map(istart_south:istart_south+nphl-1, i) = ring(0:nphl-1)
             enddo
          endif
       enddo ! loop on ithl
    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(recfac, dalm, lam_fact, ring, bsub)
    deallocate(mfac, normal_l)
    deallocate(b_TQU)

    return

  end subroutine mpi_alm2map_pol


  subroutine mpi_alm2map_pol_pre1
    !=======================================================================
    !     computes a map form its alm for the HEALPIX pixelisation
    !      for the Temperature+Polarization field
    !=======================================================================

    integer(I4B) :: l, m, ith
    integer(I8B) :: istart_south, istart_north, npix, n_lm, i_mm
    integer(I4B) :: nrings, nphmx

    integer(I4B)                              :: par_lm
    real(DP)            :: lam_lm, cth_ring, lambda_w, lambda_x, normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP),     dimension(-3:8)             :: b_ns
    real(DP),     dimension(:,:), allocatable :: dalm
    real(DP),     dimension(:),   allocatable :: lam_fact

    integer(i4b)                                :: ll, l_min
    real(DP),     dimension(:),     allocatable :: normal_l
    complex(DPC), dimension(:,:,:), allocatable :: b_TQU
    complex(DPC), dimension(:),     allocatable :: bsub
    real(DP),     dimension(:),     allocatable :: ring
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl, i
    integer(i4b)        :: l_start
    integer(I8B), dimension(0:SMAXCHK) :: startpix
    integer(I4B), dimension(0:SMAXCHK) :: nph, kphi0
    real(DP),     dimension(0:SMAXCHK) :: cth, sth
    real(DP),     dimension(0:SMAXCHK) :: one_on_s2, c_on_s2

    character(LEN=*), parameter :: code = 'ALM2MAP'
    integer(I4B) :: status
    !=======================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(normal_l(0:nlmax),stat = status)
    call assert_alloc(status,code,'normal_l')

    allocate(b_TQU(1:6, 0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_TQU')

    allocate(dalm(0:5,0:nlmax), lam_fact(0:nlmax),stat = status)
    call assert_alloc(status,code,'dalm & lam_fact')
    allocate(ring(0:nphmx-1),bsub(0:nlmax),stat = status)
    call assert_alloc(status,code,'ring & bsub')

    !     ------------ initiate variables and arrays ----------------

    local_map = 0.d0 ! set the whole map to zero
    istart_north = 0
    istart_south = map_size

    ! generate Polarization normalisation
    call gen_normpol(nlmax, normal_l)

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
       enddo
       !        -----------------------------------------------------
       !        for each theta, and each m, computes
       !        b(m,theta) = sum_over_l>m (lambda_l_m(theta) * a_l_m)
       !        ------------------------------------------------------
       !        lambda_mm tends to go down when m increases (risk of underflow)
       !        lambda_lm tends to go up   when l increases (risk of overflow)


       b_TQU = 0_dpc ! pad with zeros

       do m = 0, nmmax
          ! generate Ylm relation factor for degree m
          call gen_lamfac(nlmax, m, lam_fact)
          fm2 = real(m * m, kind = DP)
          normal_m = (2.0_dp * m) * (1 - m)

          ! extract needed alm under memory and CPU efficient form
          do ll = m, nlmax
             dalm(0,ll) =  real(local_alms(1,ll,m),kind=dp) ! T, real
             dalm(1,ll) = aimag(local_alms(1,ll,m))         ! T, imag
             dalm(2,ll) =  real(local_alms(2,ll,m),kind=dp)*normal_l(ll) ! G, real
             dalm(3,ll) = aimag(local_alms(2,ll,m))        *normal_l(ll)
             dalm(4,ll) =  real(local_alms(3,ll,m),kind=dp)*normal_l(ll) ! C, real
             dalm(5,ll) = aimag(local_alms(3,ll,m))        *normal_l(ll)
          enddo
          do ithl = 0, uchk-lchk
             l_min =  l_min_ylm(m, sth(ithl)) ! lowest l of non-negligible Ylm
             if (nlmax >= l_min) then
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + ((2_I8B*nlmax + 3 - m)*m)/2 ! location of Ym,m for ring ith

                !           ---------- l = m ----------
                par_lm = 3  ! = 3 * (-1)^(l+m)
                lam_lm = plm(i_mm,1)

                if (m >= l_min) then ! skip Ymm if too small
                   lambda_w =  (normal_m * lam_lm)  * ( 0.5_dp - one_on_s2(ithl) )
                   lambda_x =  (normal_m * lam_lm)  *            c_on_s2(ithl)

                   !      T =   alm_T * Ylm
                   !      Q = - alm_E * Wlm - i alm_B * Xlm
                   !      U = i alm_E * Xlm -   alm_B * Wlm
                   b_ns(-3:-2) = 0.0_dp               ! T odd
                   b_ns(-1: 0) =   lambda_x * (/   dalm(5,m), - dalm(4,m) /) ! Q odd
                   b_ns( 1: 2) =   lambda_x * (/ - dalm(3,m),   dalm(2,m) /) ! U odd
                   b_ns( 3: 4) =   lam_lm   * dalm(0:1,m) ! T even
                   b_ns( 5: 6) = - lambda_w * dalm(2:3,m) ! Q even
                   b_ns( 7: 8) = - lambda_w * dalm(4:5,m) ! U even
                else
                   b_ns = 0.0_dp
                endif

                !           ---------- l > m ----------
                cth_ring = cth(ithl)
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl) 

                l_start = max(m+1, l_min)
                if (mod(m+l_start,2) == 0) l_start = l_start+1
                do l = l_start, nlmax, 2

                      lam_lm1m = plm(i_mm+l-m-1,1) * lam_fact(l)
                      lam_lm   = plm(i_mm+l-m,1)

                      fl = real(l, kind = DP)
                      flm1 = fl - 1.0_dp
                      a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                      a_x =  two_cth_ring * flm1
                      lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                      lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)

                      b_ns(-3) = b_ns(-3) + lam_lm * dalm(0,l) 
                      b_ns(-2) = b_ns(-2) + lam_lm * dalm(1,l) 

                      b_ns(-1) = b_ns(-1) - lambda_w * dalm(2,l) 
                      b_ns(0)  = b_ns(0)  - lambda_w * dalm(3,l) 
                      b_ns(1)  = b_ns(1)  - lambda_w * dalm(4,l) 
                      b_ns(2)  = b_ns(2)  - lambda_w * dalm(5,l) 

                      b_ns(5) = b_ns(5) + lambda_x * dalm(5,l) ! Q odd (or even)
                      b_ns(6) = b_ns(6) - lambda_x * dalm(4,l)
                      b_ns(7) = b_ns(7) - lambda_x * dalm(3,l) ! U odd (or even)
                      b_ns(8) = b_ns(8) + lambda_x * dalm(2,l)

                enddo ! loop on l

                l_start = max(m+2, l_min)
                if (mod(m+l_start,2) == 1) l_start = l_start+1
                do l = l_start, nlmax, 2

                   lam_lm1m = plm(i_mm+l-m-1,1) * lam_fact(l)
                   lam_lm   = plm(i_mm+l-m,1)
                   
                   fl = real(l, kind = DP)
                   flm1 = fl - 1.0_dp
                   a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                   a_x =  two_cth_ring * flm1
                   lambda_w =                b_w * lam_lm1m - a_w * lam_lm 
                   lambda_x = fm_on_s2 * (         lam_lm1m - a_x * lam_lm)
                   
                   b_ns(3) = b_ns(3) + lam_lm * dalm(0,l) 
                   b_ns(4) = b_ns(4) + lam_lm * dalm(1,l) 
                   
                   b_ns(5) = b_ns(5) - lambda_w * dalm(2,l) 
                   b_ns(6) = b_ns(6) - lambda_w * dalm(3,l) 
                   b_ns(7) = b_ns(7) - lambda_w * dalm(4,l) 
                   b_ns(8) = b_ns(8) - lambda_w * dalm(5,l) 
                   
                   b_ns(-1) = b_ns(-1) + lambda_x * dalm(5,l) 
                   b_ns(0)  = b_ns(0)  - lambda_x * dalm(4,l)
                   b_ns(1)  = b_ns(1)  - lambda_x * dalm(3,l) 
                   b_ns(2)  = b_ns(2)  + lambda_x * dalm(2,l)
                   
                enddo ! loop on l

                b_TQU(1,m,ithl) = cmplx(b_ns(3) + b_ns(-3), b_ns(4) + b_ns(-2), kind = DP) ! T north
                b_TQU(4,m,ithl) = cmplx(b_ns(3) - b_ns(-3), b_ns(4) - b_ns(-2), kind = DP) ! T south
                b_TQU(2,m,ithl) = cmplx(b_ns(5) + b_ns(-1), b_ns(6) + b_ns( 0), kind = DP) ! Q n
                b_TQU(5,m,ithl) = cmplx(b_ns(5) - b_ns(-1), b_ns(6) - b_ns( 0), kind = DP) ! Q s
                b_TQU(3,m,ithl) = cmplx(b_ns(7) + b_ns( 1), b_ns(8) + b_ns( 2), kind = DP) ! U n
                b_TQU(6,m,ithl) = cmplx(b_ns(7) - b_ns( 1), b_ns(8) - b_ns( 2), kind = DP) ! U s
             endif ! test on nlmax
          enddo ! loop on rings (ithl)
       enddo ! loop on m

       do ithl = 0, uchk-lchk
          nphl = nph(ithl)
          ith  = ithl + lchk
          !        ---------------------------------------------------------------
          !        sum_m  b(m,theta)*exp(i*m*phi)   -> f(phi,theta) by FFT
          !        ---------------------------------------------------------------
          do i=1,3
             bsub = b_TQU(i,:,ithl)
             call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl))   ! north hemisph. + equator
             local_map(istart_north:istart_north+nphl-1, i) = ring(0:nphl-1)
          enddo
          istart_north = istart_north+nphl


          if (ith < 2*nsmax) then
             istart_south = istart_south-nphl
             do i=1,3
                bsub = b_TQU(3+i,:,ithl)
                call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl)) ! south hemisph. w/o equat
                local_map(istart_south:istart_south+nphl-1, i) = ring(0:nphl-1)
             enddo
          endif
       enddo ! loop on ithl
    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(dalm, lam_fact, ring, bsub)
    deallocate(normal_l)
    deallocate(b_TQU)

    return

  end subroutine mpi_alm2map_pol_pre1


  subroutine mpi_alm2map_pol_pre2

    !=======================================================================
    !     computes a map form its alm for the HEALPIX pixelisation
    !      for the Temperature+Polarization field
    !=======================================================================

    integer(I4B) :: l, m, ith
    integer(I8B) :: istart_south, istart_north, npix
    integer(I4B) :: nrings, nphmx

    integer(I8B) :: n_lm, i_mm, i_up
    integer(I4B)                              :: par_lm
    real(DP),     dimension(-3:8)             :: b_ns
    real(DP),     dimension(:,:), allocatable :: dalm, plm_sub

    integer(i4b)                                :: ll, l_min
    complex(DPC), dimension(:,:,:), allocatable :: b_TQU
    complex(DPC), dimension(:),     allocatable :: bsub
    real(DP),     dimension(:),     allocatable :: ring
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl, nphl, i
    real(DP)                           :: cth
    integer(I4B), dimension(0:SMAXCHK) :: nph, kphi0
    integer(I8B), dimension(0:SMAXCHK) :: startpix
    real(DP),     dimension(0:SMAXCHK) :: sth

    character(LEN=*), parameter :: code = 'ALM2MAP'
    integer(I4B) :: status
    !=======================================================================

    ! Healpix definitions
    nrings = last_ring - first_ring + 1
    npix   = (12_I8B*nsmax)*nsmax    ! total number of pixels on the sphere
    nphmx  = 4*nsmax           ! maximum number of pixels/ring
    n_lm   = ((nmmax+1_I8B)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(b_TQU(1:6, 0:nmmax, 0:chunksize-1),stat = status)
    call assert_alloc(status,code,'b_TQU')

    allocate(dalm(0:5,0:nlmax),plm_sub(1:3,0:nlmax), stat = status)
    call assert_alloc(status,code,'dalm & plm_sub')
    allocate(ring(0:nphmx-1),bsub(0:nlmax),stat = status)
    call assert_alloc(status,code,'ring & bsub')

    !     ------------ initiate variables and arrays ----------------
    local_map = 0.d0 ! set the whole map to zero
    istart_north = 0
    istart_south = map_size

    ! loop on chunks
    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth, sth(ithl), nph(ithl), startpix(ithl), kphi0(ithl))
       enddo
       !        -----------------------------------------------------
       !        for each theta, and each m, computes
       !        b(m,theta) = sum_over_l>m (lambda_l_m(theta) * a_l_m)
       !        ------------------------------------------------------
       !        lambda_mm tends to go down when m increases (risk of underflow)
       !        lambda_lm tends to go up   when l increases (risk of overflow)


       b_TQU = 0_dpc ! pad with zeros

       do m = 0, nmmax

          ! extract needed alm under memory and CPU efficient form
          do ll = m, nlmax
             dalm(0,ll) =  real(local_alms(1,ll,m),kind=dp) ! T, real
             dalm(1,ll) = aimag(local_alms(1,ll,m))         ! T, imag
             dalm(2,ll) =  real(local_alms(2,ll,m),kind=dp) ! G, real
             dalm(3,ll) = aimag(local_alms(2,ll,m))        
             dalm(4,ll) =  real(local_alms(3,ll,m),kind=dp) ! C, real
             dalm(5,ll) = aimag(local_alms(3,ll,m))        
          enddo
          do ithl = 0, uchk - lchk
             l_min =  l_min_ylm(m, sth(ithl)) ! lowest l of non-negligible Ylm
             if (nlmax >= l_min) then
                ith = ithl + lchk
                i_mm = n_lm * (ith-first_ring) + ((2_I8B*nlmax + 3 - m)*m)/2 ! location of Ym,m for ring ith
                i_up = i_mm + nlmax - m
                plm_sub(1,m:nlmax) = plm(i_mm:i_up,1)
                plm_sub(2,m:nlmax) = plm(i_mm:i_up,2)
                plm_sub(3,m:nlmax) = plm(i_mm:i_up,3)
                !           ---------- l = m ----------

                par_lm = 3  ! = 3 * (-1)^(l+m)

                if (m >= l_min) then ! skip Ymm if too small
                   !      T =   alm_T * Ylm
                   !      Q = - alm_E * Wlm - i alm_B * Xlm
                   !      U = i alm_E * Xlm -   alm_B * Wlm
                   b_ns(-3:-2) = 0.0_dp               ! T odd
                   b_ns(-1: 0) =   plm_sub(3,m) * (/   dalm(5,m), - dalm(4,m) /) ! Q odd
                   b_ns( 1: 2) =   plm_sub(3,m) * (/ - dalm(3,m),   dalm(2,m) /) ! U odd
                   b_ns( 3: 4) =   plm_sub(1,m)   * dalm(0:1,m) ! T even
                   b_ns( 5: 6) = - plm_sub(2,m) * dalm(2:3,m) ! Q even
                   b_ns( 7: 8) = - plm_sub(2,m) * dalm(4:5,m) ! U even
                else
                   b_ns = 0.0_dp
                endif

                !           ---------- l > m ----------
                do l = m+1, nlmax
                   par_lm = - par_lm  ! = 3 * (-1)^(l+m)
                   if (l >= l_min) then

                      b_ns(par_lm:  par_lm+1) = b_ns(par_lm:  par_lm+1) + plm_sub(1,l) * dalm(0:1,l) ! T even or odd
                      b_ns(par_lm+2:par_lm+5) = b_ns(par_lm+2:par_lm+5) - plm_sub(2,l) * dalm(2:5,l) ! Q, U  even or odd
                      b_ns(2-par_lm) = b_ns(2-par_lm) + plm_sub(3,l) * dalm(5,l) ! Q odd (or even)
                      b_ns(3-par_lm) = b_ns(3-par_lm) - plm_sub(3,l) * dalm(4,l)
                      b_ns(4-par_lm) = b_ns(4-par_lm) - plm_sub(3,l) * dalm(3,l) ! U odd (or even)
                      b_ns(5-par_lm) = b_ns(5-par_lm) + plm_sub(3,l) * dalm(2,l)
                   endif

                enddo ! loop on l

                b_TQU(1,m,ithl) = cmplx(b_ns(3) + b_ns(-3), b_ns(4) + b_ns(-2), kind = DP) ! T north
                b_TQU(4,m,ithl) = cmplx(b_ns(3) - b_ns(-3), b_ns(4) - b_ns(-2), kind = DP) ! T south
                b_TQU(2,m,ithl) = cmplx(b_ns(5) + b_ns(-1), b_ns(6) + b_ns( 0), kind = DP) ! Q n
                b_TQU(5,m,ithl) = cmplx(b_ns(5) - b_ns(-1), b_ns(6) - b_ns( 0), kind = DP) ! Q s
                b_TQU(3,m,ithl) = cmplx(b_ns(7) + b_ns( 1), b_ns(8) + b_ns( 2), kind = DP) ! U n
                b_TQU(6,m,ithl) = cmplx(b_ns(7) - b_ns( 1), b_ns(8) - b_ns( 2), kind = DP) ! U s
             endif ! test on nlmax
          enddo ! loop on rings (ithl)
       enddo ! loop on m

       do ithl = 0, uchk - lchk
          nphl = nph(ithl)
          ith  = ithl + lchk
          !        ---------------------------------------------------------------
          !        sum_m  b(m,theta)*exp(i*m*phi)   -> f(phi,theta) by FFT
          !        ---------------------------------------------------------------
          do i=1,3
             bsub = b_TQU(i,:,ithl)
             call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl))   ! north hemisph. + equator
             local_map(istart_north:istart_north+nphl-1, i) = ring(0:nphl-1)
          enddo
          istart_north = istart_north + nphl

          if (ith < 2*nsmax) then
             istart_south = istart_south - nphl
             do i=1,3
                bsub = b_TQU(3+i,:,ithl)
                call ring_synthesis(nsmax,nlmax,nmmax,bsub,nphl,ring,kphi0(ithl)) ! south hemisph. w/o equat
                local_map(istart_south:istart_south+nphl-1, i) = ring(0:nphl-1)
             enddo
          endif
       enddo ! loop on ithl
    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate(dalm, ring, bsub)
    deallocate(b_TQU)

    return

  end subroutine mpi_alm2map_pol_pre2







  !**************************************************************************
  !
  !             PLM GENERATION
  !
  !**************************************************************************
  !========================================================
  subroutine mpi_plm_gen(polarization)

    logical(lgt), intent(in) :: polarization

    INTEGER(I4B) :: l, m, ith, scalem, scalel, nd2, nrings
    integer(I8B) :: nd1, n_lm, n_plm, i_mm, i_up
    real(DP)            :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
    real(DP)                 :: normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1, fpol
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP)                 :: ovflow, unflow
    real(DP),     dimension(:,:,:), allocatable :: plm_sub
    real(DP),     dimension(:,:), allocatable :: recfac
    real(DP),     dimension(:),   allocatable :: lam_fact
    real(DP),     dimension(:), allocatable :: mfac

    real(DP),     dimension(:),     allocatable :: normal_l
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl
    integer(i4b)        :: nph, kphi0, i, j, plm_ind
    integer(i8b)        :: startpix
    real(DP),     dimension(0:SMAXCHK) :: cth, sth
    real(DP),     dimension(0:SMAXCHK) :: one_on_s2, c_on_s2

    INTEGER(I4B) :: status
    character(len=*), parameter :: code = 'PLM_GEN'

    !=================================================================

    ! Healpix definitions
    nrings = (last_ring-first_ring+1)
    n_lm   = ((nmmax+1)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]
    n_plm  = n_lm * (last_ring-first_ring+1)

    if (polarization) then
       allocate(plm(0:n_plm-1,3))
       nd2 = 3
    else
       allocate(plm(0:n_plm-1,1))
       nd2 = 1
    end if

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')
    if (polarization) then
       allocate(normal_l(0:nlmax),stat = status)
       call assert_alloc(status,code,'normal_l')
    endif

    allocate(recfac(0:1,0:nlmax), plm_sub(1:nd2,0:nlmax,0:chunksize-1), stat = status)
    call assert_alloc(status,code,'recfac & plm_sub')
    if (polarization) then
       allocate(lam_fact(0:nlmax),stat = status)
       call assert_alloc(status,code,'lam_fact')
    endif

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax, mfac)
    ! generate Polarization normalisation
    if (polarization) call gen_normpol(nlmax, normal_l)

    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    plm = 0.0_dp

    do ichunk = 0, nchunks-1

       lchk = first_ring + ichunk * chunksize 
       uchk = min(lchk+chunksize - 1, last_ring)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph, startpix, kphi0)
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
       enddo

       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)
          if (polarization) then
             ! generate Ylm relation factor for degree m
             call gen_lamfac(nlmax, m, lam_fact)
             fm2 = real(m * m, kind = DP)
             normal_m = (2.0_dp * m) * (1 - m)
          endif

          do ithl = 0, uchk-lchk
             ! determine lam_mm
             call mpi_compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)
             ! ---------- l = m ----------
             !           temperature 
             lam_lm = corfac * lam_mm !Actual lam_mm 
             plm_sub(1, m, ithl) = lam_lm

             lam_0 = 0.0_dp
             lam_1 = 1.0_dp
             scalel=0
             cth_ring = cth(ithl)
             lam_2 = cth_ring * lam_1 * recfac(0,m)

             if (polarization) then
                fpol = normal_m * normal_l(m) * lam_lm
                plm_sub(2, m, ithl) =  fpol * ( 0.5_dp - one_on_s2(ithl) )
                plm_sub(3, m, ithl) =  fpol *              c_on_s2(ithl)
                !
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl) 
             endif
             ! ---------- l > m ----------
             do l = m+1, nlmax
                if (polarization) lam_lm1m = lam_lm * lam_fact(l)
                lam_lm = lam_2 * corfac * lam_mm
                plm_sub(1, l, ithl) = lam_lm
                
                if (polarization) then
                   fl = real(l, kind = DP)
                   flm1 = fl - 1.0_dp
                   a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                   a_x =  two_cth_ring * flm1
                   plm_sub(2, l, ithl) =            ( b_w * lam_lm1m - a_w * lam_lm) * normal_l(l)
                   plm_sub(3, l, ithl) = fm_on_s2 * (       lam_lm1m - a_x * lam_lm) * normal_l(l)
                endif

                lam_0 = lam_1 * recfac(1,l-1)
                lam_1 = lam_2
                lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                if (abs(lam_2) > OVFLOW) then
                   lam_1 = lam_1*UNFLOW
                   lam_2 = lam_2*UNFLOW
                   scalel= scalel + 1
                   corfac = rescale_tab(max(scalel+scalem,RSMIN))
                elseif (abs(lam_2) < UNFLOW) then
                   lam_1 = lam_1*OVFLOW
                   lam_2 = lam_2*OVFLOW
                   scalel= scalel - 1
                   corfac = rescale_tab(max(scalel+scalem,RSMIN))
                endif
             enddo ! loop on l
          enddo ! loop on rings (ithl)

          ! do memory skipping operations outside inner loops
          do ith = lchk, uchk
             i_mm = n_lm*(ith-first_ring) + ((2*nlmax+3-m)*m)/2 ! location of Ym,m for ring ith
             i_up = i_mm + nlmax - m ! location of Ynlmax,m for ring ith
             ithl = ith - lchk
             do i = 1, nd2
                plm(i_mm:i_up, i) = plm_sub(i, m:nlmax, ithl)
             enddo
          enddo

       enddo ! loop on m
    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    deallocate (recfac, plm_sub)
    if (polarization) deallocate(lam_fact)
    deallocate(mfac)
    if (polarization) deallocate(normal_l)

    return

  end subroutine mpi_plm_gen




  subroutine mpi_compute_lam_mm(mfac, m, sth, lam_mm, corfac, scalem)
    !=======================================================================
    ! computes lam_mm
    ! the true lam_mm is     lam_mm * corfac
    !=======================================================================
    integer(I4B),            intent(in)  :: m
    real(DP),                intent(in)  :: sth, mfac
!!!    real(DP), dimension(0:), intent(in)  :: mfac
    real(DP),                intent(out) :: lam_mm, corfac
    integer(I4B),            intent(out) :: scalem
    !
    real(DP) :: log2val, dlog2lg

    dlog2lg = real(LOG2LG, kind=DP)

    log2val = mfac + m*log(sth) * ALN2_INV ! log_2(lam_mm)
    scalem = int (log2val / dlog2lg)
    corfac = rescale_tab(max(scalem,RSMIN))
    lam_mm = 2.0_dp **(log2val - scalem * dlog2lg) ! rescaled lam_mm
    if (IAND(m,1)>0) lam_mm = -lam_mm ! negative for odd m

    return
  end subroutine mpi_compute_lam_mm





end module mpi_alm_tools

! to be included in indmed.f90 (part 1/2)
      NMED = (NDAT+1) / 2
      IWRKT(1:ndat) = IDATT(:)
!
!  If the number of values is small, then use insertion sort
!
     If (NDAT < 35) Then
!
!  Bring minimum to first location to save test in decreasing loop
!
        IDCR = NDAT
        If (XDATT (IWRKT (1)) < XDATT (IWRKT (IDCR))) Then
           IWRK = IWRKT (1)
        Else
           IWRK = IWRKT (IDCR)
           IWRKT (IDCR) = IWRKT (1)
        Endif
        XWRK = XDATT (IWRK)
        Do ITMP = 1, NDAT - 2
           IDCR = IDCR - 1
           IWRK1 = IWRKT (IDCR)
           XWRK1 = XDATT (IWRK1)
           If (XWRK1 < XWRK) Then
              IWRKT (IDCR) = IWRK
              XWRK = XWRK1
              IWRK = IWRK1
           Endif
        End Do
        IWRKT (1) = IWRK
!
! Sort the first half, until we have NMED sorted values
!
        Do ICRS = 3, NMED
           XWRK = XDATT (IWRKT (ICRS))
           IWRK = IWRKT (ICRS)
           IDCR = ICRS - 1
           Do
              If (XWRK >= XDATT (IWRKT(IDCR))) Exit
              IWRKT (IDCR+1) = IWRKT (IDCR)
              IDCR = IDCR - 1
           End Do
           IWRKT (IDCR+1) = IWRK
        End Do
!
!  Insert any value less than the current median in the first half
!
        XWRK1 = XDATT (IWRKT (NMED))
        Do ICRS = NMED+1, NDAT
           XWRK = XDATT (IWRKT (ICRS))
           IWRK = IWRKT (ICRS)
           If (XWRK < XWRK1) Then
              IDCR = NMED - 1
              Do
                 If (XWRK >= XDATT (IWRKT(IDCR))) Exit
                 IWRKT (IDCR+1) = IWRKT (IDCR)
                 IDCR = IDCR - 1
              End Do
              IWRKT (IDCR+1) = IWRK
              XWRK1 = XDATT (IWRKT (NMED))
           End If
        End Do
        ires_med = IWRKT (NMED)
        Return
     End If
!
!  Make sorted subsets of 7 elements
!  This is done by a variant of insertion sort where a first
!  pass is used to bring the smallest element to the first position
!  decreasing disorder at the same time, so that we may remove
!  remove the loop test in the insertion loop.
!
     IMAX = 1
     IMIN = 1
     XMAX = XDATT (IWRKT(IMAX))
     XMIN = XDATT (IWRKT(IMIN))
     DO IDEB = 1, NDAT-6, 7
        IDCR = IDEB + 6
        If (XDATT (IWRKT(IDEB)) < XDATT (IWRKT(IDCR))) Then
           IWRK = IWRKT(IDEB)
        Else
           IWRK = IWRKT (IDCR)
           IWRKT (IDCR) = IWRKT(IDEB)
        Endif
        XWRK = XDATT (IWRK)
        Do ITMP = 1, 5
           IDCR = IDCR - 1
           IWRK1 = IWRKT (IDCR)
           XWRK1 = XDATT (IWRK1)
           If (XWRK1 < XWRK) Then
              IWRKT (IDCR) = IWRK
              IWRK = IWRK1
              XWRK = XWRK1
           Endif
        End Do
        IWRKT (IDEB) = IWRK
        If (XWRK < XMIN) Then
           IMIN = IWRK
           XMIN = XWRK
        End If
        Do ICRS = IDEB+1, IDEB+5
           IWRK = IWRKT (ICRS+1)
           XWRK = XDATT (IWRK)
           IDON = IWRKT(ICRS)
           If (XWRK < XDATT(IDON)) Then
              IWRKT (ICRS+1) = IDON
              IDCR = ICRS
              IWRK1 = IWRKT (IDCR-1)
              XWRK1 = XDATT (IWRK1)
              Do
                 If (XWRK >= XWRK1) Exit
                 IWRKT (IDCR) = IWRK1
                 IDCR = IDCR - 1
                 IWRK1 = IWRKT (IDCR-1)
                 XWRK1 = XDATT (IWRK1)
              End Do
              IWRKT (IDCR) = IWRK
           EndIf
        End Do
        If (XWRK > XMAX) Then
           IMAX = IWRK
           XMAX = XWRK
        End If
     End Do
!
!  Add-up alternatively MAX and MIN values to make the number of data
!  an exact multiple of 7.
!
     IDEB = 7 * (NDAT/7)
     NTRI = NDAT
     If (IDEB < NDAT) Then
!
        Do ICRS = IDEB+1, NDAT
           XWRK1 = XDATT (IWRKT (ICRS))
           IF (XWRK1 > XMAX) Then
              IMAX = IWRKT (ICRS)
              XMAX = XWRK1
           End If
           IF (XWRK1 < XMIN) Then
              IMIN = IWRKT (ICRS)
              XMIN = XWRK1
           End If
        End Do
        IWRK1 = IMAX
        Do ICRS = NDAT+1, IDEB+7
           IWRKT (ICRS) = IWRK1
           If (IWRK1 == IMAX) Then
              IWRK1 = IMIN
           Else
              NMED = NMED + 1
              IWRK1 = IMAX
           End If
        End Do
!
        Do ICRS = IDEB+2, IDEB+7
           IWRK = IWRKT (ICRS)
           XWRK = XDATT (IWRK)
           Do IDCR = ICRS - 1, IDEB+1, - 1
              If (XWRK >= XDATT (IWRKT(IDCR))) Exit
              IWRKT (IDCR+1) = IWRKT (IDCR)
           End Do
           IWRKT (IDCR+1) = IWRK
        End Do
!
        NTRI = IDEB+7
     End If
!
!  Make the set of the indices of median values of each sorted subset
!
     IDON1 = 0
     Do IDON = 1, NTRI, 7
        IDON1 = IDON1 + 1
        IMEDT (IDON1) = IWRKT (IDON + 3)
     End Do
!
!  Find XMED7, the median of the medians
!

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
! -*- f90 -*-

!
! v1.0: M. Reinecke
! v1.1: 2002-09, E. Hivon, added concatnl, scan_directories, numeric_string
!                     made interactive mode more user friendly
! v1.2: added parse_summarize
! v1.3: 2008-01-22, added parse_check_unused
!       2008-01-29, addition of silent keyword in parse_init
!       2008-03-25: expand environment variables (${XXX}) in parse_string
! v1.4: 2008-10-15, avoid over-running keylist in parse_summarize
! v1.5: 2009-09-07, introduces get_healpix_main_dir, get_healpix_data_dir, get_healpix_test_dir
! v1.6: 2009-11-26: bug correction in get_healpix_*_dir
! v1.7: 2011-01-03: addition of get_healpix_pixel_window_file & get_healpix_ring_weight_file
! v1.8: 2012-10-29: replaced F90 inquire with misc_utils's file_present which will accept remote files
! v1.9: 2012-11-14: deal correctly with undefined HEALPIX (or equivalent) in get_healpix_data_dir
! v2.0: 2018-05-18: added get_healpix_pixel_weight_file and get_healpix_weight_file
module paramfile_io
  use healpix_types
  use extension
  use misc_utils
  implicit none
  private

  public paramfile_handle, parse_init, parse_real, parse_double, parse_int, &
         parse_long, parse_lgt, parse_string, parse_summarize, parse_finish, &
         parse_check_unused

  public concatnl, scan_directories

  public get_healpix_main_dir, get_healpix_data_dir, get_healpix_test_dir

  public get_healpix_pixel_window_file, get_healpix_ring_weight_file, &
       get_healpix_pixel_weight_file, get_healpix_weight_file

  type paramfile_handle
    character(len=filenamelen) filename
    character(len=filenamelen), pointer, dimension(:) :: keylist=>NULL()
    character(len=filenamelen), pointer, dimension(:) :: valuelist=>NULL()
    logical(LGT),               pointer, dimension(:) :: usedlist=>NULL()
    logical interactive, verbose
  end type paramfile_handle

  character(len=*), parameter, public :: ret = achar(10)//' '
  character(len=*), parameter, private :: swdef = ' <default>'

contains

!=====================================================================
subroutine notify_user (keyname, rdef, rmin, rmax, ddef, dmin, dmax, &
  idef, imin, imax, ldef, lmin, lmax, logdef, chdef, descr, ivalid)
  !=====================================================================
  ! prompts user for next parameter when in interactive mode
  !=====================================================================
  character(len=*), intent(in) :: keyname
  real(sp), intent(in), optional :: rdef, rmin, rmax
  real(dp), intent(in), optional :: ddef, dmin, dmax
  integer(i4b), intent(in), optional :: idef, imin, imax
  integer(i8b), intent(in), optional :: ldef, lmin, lmax
  logical, intent(in), optional :: logdef
  character(len=*), intent(in), optional :: chdef, descr
  integer(i4b), intent(in), optional, dimension(1:) :: ivalid

  if (present(descr)) then
     write(*,'(a)') trim(descr)
  else
     print *, 'Please enter a value for the key ', keyname
  endif
  if (present(rmin) .and. present(rmax)) then
     print *, "allowed range: ", rmin, rmax
  else
     if (present(rmin)) print *, "min value: ", rmin
     if (present(rmax)) print *, "max value: ", rmax
  endif
  if (present(dmin) .and. present(dmax)) then
     print *, "allowed range: ", dmin, dmax
  else
     if (present(dmin)) print *, "min value: ", dmin
     if (present(dmax)) print *, "max value: ", dmax
  endif
  if (present(imin) .and. present(imax)) then
     print *, "allowed range: ", imin, imax
  else
     if (present(imin)) print *, "min value: ", imin
     if (present(imax)) print *, "max value: ", imax
  endif
  if (present(ivalid)) then
     print *, "allowed values: ",ivalid(1:)
  endif
  if (present(lmin) .and. present(lmax)) then
     print *, "allowed range: ", lmin, lmax
  else
     if (present(lmin)) print *, "min value: ", lmin
     if (present(lmax)) print *, "max value: ", lmax
  endif
  if (present(rdef)) print *, "default value: ", rdef
  if (present(ddef)) print *, "default value: ", ddef
  if (present(idef)) print *, "default value: ", idef
  if (present(ldef)) print *, "default value: ", ldef
  if (present(logdef)) print *, "default value: ", logdef
  if (present(chdef)) print *, "default value: ", trim(chdef)
end subroutine notify_user

!===================================================================
function parse_init (fname, silent)
  !===================================================================
  character(len=*), intent(in) :: fname
  type(paramfile_handle) parse_init
  logical(LGT), intent(in), optional :: silent

  integer  :: i,cnt
  character(len=filenamelen) :: line, name, value
  logical(LGT) :: myverbose

  ! be verbose by default
  myverbose = .true.
  if (present(silent)) myverbose = .not.silent

  if (len(trim(fname))==0) then
    parse_init%filename    = ''
    parse_init%interactive = .true.
    parse_init%verbose     = .true.
    parse_init%keylist     => NULL()
    parse_init%valuelist   => NULL()
    parse_init%usedlist    => NULL()
    cnt = 30
    allocate(parse_init%keylist(cnt),parse_init%valuelist(cnt))
    allocate(parse_init%usedlist(cnt))
    parse_init%keylist = ''
    parse_init%valuelist = ''
    parse_init%usedlist = .false.
  else
    call assert_present (fname)
    call assert(len(fname)<=filenamelen, 'Parser: error: file name too long')
    parse_init%filename    = fname
    parse_init%interactive = .false.
    parse_init%verbose     = myverbose
    parse_init%keylist     => NULL()
    parse_init%valuelist   => NULL()
    parse_init%usedlist    => NULL()
    ! count valid lines
    open  (1, file=trim(fname))
    cnt=0
    do
      read (1,'(a)',end=2) line
      line = adjustl(line)
      i=scan(line,'=')
      if (i/=0 .and. line(1:1)/='#' .and. line(1:1)/='!') cnt=cnt+1
    end do
2   close (1)
    ! read and parse valid lines
    allocate(parse_init%keylist(cnt),parse_init%valuelist(cnt))
    allocate(parse_init%usedlist(cnt))
    open  (1, file=trim(fname))
    cnt=0
    do
      read (1,'(a)',end=3) line
      line = adjustl(line)
      i=scan(line,'=')
      if (i/=0 .and. line(1:1)/='#' .and. line(1:1)/='!') then
        cnt=cnt+1
        name = trim(adjustl(line(:i-1)))
        value = trim(adjustl(line(i+1:)))
        if (trim(value)=="") then
           write(*,'(a)') ' '
           write(*,'(a)') 'ERROR: Inputs of the form '
           write(*,'(a)') trim(name)//' = '
           write(*,'(a)') ' (ie, defined as a blank value) are not valid'
           write(*,'(a)') 'To get the default value, comment out the keyword in '&
                &         //trim(parse_init%filename)
           write(*,'(a)') '# '//trim(name)//' = '
           write(*,'(a)') "If you mean 'No file', use"
           write(*,'(a)') trim(name)//" = ''   "
           write(*,'(a)') ' '
           call fatal_error
        endif
        parse_init%keylist(cnt) = name 
        parse_init%valuelist(cnt) = value
        parse_init%usedlist(cnt) = .false.
      endif
    end do
3   close (1)
  endif

  ! be verbose
  if (parse_init%interactive) then
     write(*,'(a)') 'Interactive mode. Answer the following questions.'
     write(*,'(a)') 'If no answer is entered, the default value will be taken'
  else
     if (parse_init%verbose) then
        write(*,'(a)') 'Reading run parameters from '//trim(parse_init%filename)
        write(*,'(a)') ' parameters not defined in that file will be set to their default value'
     endif
  endif
end function parse_init
!===================================================================
subroutine parse_summarize (handle, code, prec)
  !===================================================================
  type(paramfile_handle),     intent(in) :: handle
  character(len=*), optional, intent(in) :: code
  integer(i4b),     optional, intent(in) :: prec
  !
  integer(i4b) :: i, nkeys
  character(len=filenamelen) :: name, value, next_name, command

  if (handle%interactive) then
     command = ''
     if (present(code)) then
        command = trim(code)
        if (present(prec)) then
           if (prec == SP) command = trim(command)//' --single'
           if (prec == DP) command = trim(command)//' --double'
        endif
     endif
     if (trim(command) /= '') then
        print*,'  This run can be reproduced in non-interactive mode, with the command'
        print*,trim(command)//' paramfile'
        print*,'where paramfile contains'
     else
        print*,'  This run can be reproduced in non-interactive mode'
        print*,'if a parameter file with the following content is provided:'
     endif
     nkeys = size(handle%keylist)
     do i=1, nkeys
        name = handle%keylist(i)
        if (i < nkeys) then
           next_name = handle%keylist(i+1)
        else
           next_name = ''
        endif
        value = handle%valuelist(i)
        if (trim(name) /= '' .and. trim(name) /= trim(next_name)) then
           if (trim(value) == '') then
              write(*,'(a)') '# '//trim(name)
           else
              write(*,'(a)') trim(name)//' = '//trim(value)
           endif
        endif
     enddo
     print*,' '
  endif
end subroutine parse_summarize
!===================================================================
subroutine parse_check_unused(handle, code)
  !===================================================================
  ! print out unused keywords, if any
  !===================================================================
  type(paramfile_handle),     intent(in) :: handle
  character(len=*), optional, intent(in) :: code
  !
  integer(i4b) :: i, unused
  character(len=80) :: mycode
!  character(len=filenamelen) :: name, value, next_name, command


  ! non interactive mode
  if (.not.handle%interactive) then
     mycode = 'this code'
     if (present(code)) mycode = trim(code)
     ! count unused keywords in input parameter files
     unused = 0
     do i=1,size(handle%keylist)
        if (.not. handle%usedlist(i)) unused = unused + 1
     enddo
     if (unused > 0) then
        print*,' '
        print*,' ====================================================='
        print*,'  WARNING: the following keywords found in '//trim(handle%filename)
        print*,'           have NOT been used by '//trim(mycode)
        !print*,'           Make sure they are correctly spelled.'
        do i=1,size(handle%keylist)
           if (.not. handle%usedlist(i)) then
              write(*,'(a)') trim(handle%keylist(i))//' = '//trim(handle%valuelist(i))
           endif
        enddo        
        print*,' ====================================================='
        print*,' '
     endif

  end if
  return
end subroutine parse_check_unused

!===================================================================
subroutine parse_finish (handle)
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle

  if (associated(handle%keylist)) then
     deallocate(handle%keylist, handle%valuelist)
     deallocate(handle%usedlist)
  endif
end subroutine parse_finish

!===================================================================
subroutine find_param (handle,keyname,result,found,rdef,rmin,rmax, &
    ddef,dmin,dmax,idef,imin,imax,ldef,lmin,lmax,logdef,chdef,descr, &
    ivalid)
  !===================================================================
  ! extract parameter from file or read from standard input
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  character(len=*), intent(out) :: result
  logical, intent(out) :: found
  real(sp), intent(in), optional :: rdef, rmin, rmax
  real(dp), intent(in), optional :: ddef, dmin, dmax
  integer(i4b), intent(in), optional :: idef, imin, imax
  integer(i8b), intent(in), optional :: ldef, lmin, lmax
  logical, intent(in), optional :: logdef
  character(len=*), intent(in), optional :: chdef, descr
  integer(i4b), intent(in), optional, dimension(1:) :: ivalid

  character(len=filenamelen) :: line, name, value
  integer i
  !===================================================================

  found=.false.

  if (handle%interactive) then
     call notify_user (keyname,rdef,rmin,rmax,ddef,dmin,dmax, &
          &            idef,imin,imax,ldef,lmin,lmax,logdef,chdef,descr, &
          &            ivalid)
     read (*,'(a)',err=5) result
     found = (trim(result)/='')
     do i=1,size(handle%keylist)
        if (trim(handle%keylist(i))=='') then
           handle%keylist(i)   = trim(keyname)
           if (found) then
              handle%valuelist(i) = trim(result)
              handle%usedlist(i)  = .true.
           else
              if (present(rdef)) write(handle%valuelist(i),*) rdef
              if (present(ddef)) write(handle%valuelist(i),*) ddef
              if (present(idef)) write(handle%valuelist(i),*) idef
              if (present(ldef)) write(handle%valuelist(i),*) ldef
              if (present(logdef)) write(handle%valuelist(i),*) logdef
              if (present(chdef))  handle%valuelist(i) = chdef
           endif
           exit
        end if
     end do
  else
     do i=1,size(handle%keylist)
        if (trim(handle%keylist(i))==keyname) then
           result=trim(handle%valuelist(i))
           found=.true.
           handle%usedlist(i) = .true.
        end if
     end do
2    close (1)
  endif
  return

5 print*,'Parser: find_param: error reading value'
  call fatal_error
end subroutine find_param
!===================================================================

!===================================================================
function parse_real (handle, keyname, default, vmin, vmax, descr)
  !===================================================================
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  real(sp), intent(in), optional :: default, vmin, vmax
  character(len=*), intent(in), optional :: descr
  real(sp) :: parse_real

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical found
  !===================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, rdef=default, &
       &           rmin=vmin, rmax=vmax, descr=descr)
  if (found) then
     read (result,*,err=5) parse_real
  else
     if (present(default)) then
!      print *,'Parser: warning: using default value for ',trim(keyname)
        about_def = swdef
        parse_real = default
     else
        print *,'Parser: error: ',trim(keyname),' not found.'
        goto 2
     endif
  endif
  if (handle%verbose) print *,'Parser: ',trim(keyname),' = ',parse_real, trim(about_def)
  if (present(vmin)) then
     if (parse_real<vmin) then
        print *,'Parser: error: value for ', trim(keyname),' too small.'
        goto 2
     endif
  endif
  if (present(vmax)) then
     if (parse_real>vmax) then
        print *,'Parser: error: value for ', trim(keyname),' too large.'
        goto 2
     endif
  endif
  
  return ! normal exit
  
5 print*,'Parser: parse_real: error reading value'
2 if (handle%interactive) goto 10 ! try again
  call fatal_error
  
end function parse_real

!===================================================================
function parse_double (handle, keyname, default, vmin, vmax, descr)
  !===================================================================
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  real(dp), intent(in), optional :: default, vmin, vmax
  character(len=*), intent(in), optional :: descr
  real(dp) :: parse_double

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical found
  !===================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, ddef=default, &
       &           dmin=vmin, dmax=vmax, descr=descr)
  if (found) then
    read (result,*,err=5) parse_double
  else
    if (present(default)) then
!      print *,'Parser: warning: using default value for ',trim(keyname)
        about_def = swdef
      parse_double = default
    else
      print *,'Parser: error: ',trim(keyname),' not found.'
      goto 2
    endif
  endif
  if (handle%verbose) print *,'Parser: ',trim(keyname),' = ',parse_double, trim(about_def)
  if (present(vmin)) then
    if (parse_double<vmin) then
      print *,'Parser: error: value for ', trim(keyname),' too small.'
      goto 2
    endif
  endif
  if (present(vmax)) then
    if (parse_double>vmax) then
      print *,'Parser: error: value for ', trim(keyname),' too large.'
      goto 2
    endif
  endif

  return ! normal exit

5 print*,'Parser: parse_double: error reading value'
2 if (handle%interactive) goto 10 ! try again
  call fatal_error

end function parse_double

!==================================================================
function parse_int (handle, keyname, default, vmin, vmax, descr, valid)
  !==================================================================
  ! parse 4 byte integer parameter
  !==================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  integer(i4b), intent(in), optional :: default, vmin, vmax
  integer(i4b), intent(in), optional, dimension(1:) :: valid
  character(len=*), intent(in), optional :: descr
  integer(i4b) :: parse_int

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical :: found
  integer(i4b) :: i
  !==================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, idef=default, &
       &           imin=vmin, imax=vmax, descr=descr, ivalid=valid)
  if (found) then
    read (result,*,err=5) parse_int
  else
    if (present(default)) then
!      print *,'Parser: warning: using default value for ',trim(keyname)
        about_def = swdef
      parse_int = default
    else
      print *,'Parser: error: ',trim(keyname),' not found.'
      goto 2
    endif
  endif
  if (handle%verbose) print *,'Parser: ',trim(keyname),' = ',parse_int, trim(about_def)
  if (present(vmin)) then
    if (parse_int<vmin) then
      print *,'Parser: error: value for ', trim(keyname),' too small.'
      goto 2
    endif
  endif
  if (present(vmax)) then
    if (parse_int>vmax) then
      print *,'Parser: error: value for ', trim(keyname),' too large.'
      goto 2
    endif
  endif
  if (present(valid)) then
     found = .false.
     do i=1, size(valid)
        if (parse_int == valid(i)) found=.true.
     enddo
     if (.not.found) then
        print *,'Parser: error: invalid value for '//trim(keyname)
        goto 2
     endif
  endif

  return ! normal exit

5 print*,'Parser: parse_int: error reading value'
2 if (handle%interactive) goto 10 ! try again
  call fatal_error

end function parse_int
!==================================================================

!==================================================================
function parse_long (handle, keyname, default, vmin, vmax, descr)
  !==================================================================
  ! parse 8 byte integer parameter
  !==================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  integer(i8b), intent(in), optional :: default, vmin, vmax
  character(len=*), intent(in), optional :: descr
  integer(i8b) :: parse_long

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical found
  !==================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, ldef=default, &
                   lmin=vmin, lmax=vmax, descr=descr)
  if (found) then
    read (result,*,err=5) parse_long
  else
    if (present(default)) then
!      print *,'Parser: warning: using default value for ',trim(keyname)
        about_def = swdef
      parse_long = default
    else
      print *,'Parser: error: ',trim(keyname),' not found.'
      goto 2
    endif
  endif
  if (handle%verbose) print *,'Parser: ',trim(keyname),' = ',parse_long, trim(about_def)
  if (present(vmin)) then
    if (parse_long<vmin) then
      print *,'Parser: error: value for ', trim(keyname),' too small.'
      goto 2
    endif
  endif
  if (present(vmax)) then
    if (parse_long>vmax) then
      print *,'Parser: error: value for ', trim(keyname),' too large.'
      goto 2
    endif
  endif

  return ! normal exit

5 print*,'Parser: parse_long: error reading value'
2 if (handle%interactive) goto 10 ! try again
  call fatal_error

end function parse_long

!===================================================================
function parse_lgt (handle, keyname, default, descr)
  !===================================================================
  ! parse (1 byte) logical parameter
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  logical, intent(in), optional :: default
  character(len=*), intent(in), optional :: descr
  logical :: parse_lgt

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical found
  !===================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, logdef=default, &
       &           descr=descr)
  if (found) then
     select case (strupcase(result))
     case ('Y','YES','T','TRUE', '.TRUE.','1')
        parse_lgt = .true.
     case ('N','NO', 'F','FALSE','.FALSE.','0')
        parse_lgt= .false.
     case default
        goto 5
     end select
  else
    if (present(default)) then
!       print *,'Parser: warning: using default value for ',trim(keyname)
      parse_lgt = default
    else
      print *,'Parser: error: ',trim(keyname),' not found.'
      goto 2
    endif
  endif
  if (handle%verbose) print *,'Parser: ',trim(keyname),' = ',parse_lgt, trim(about_def)

  return ! normal exit

5 print*,'Parser: parse_lgt: error reading value'
2 if (handle%interactive) goto 10 ! try again
  call fatal_error

end function parse_lgt

!===================================================================
function parse_string (handle, keyname, default, descr, filestatus, options)
  !===================================================================
  ! parse a character string parameter
  !
  ! if filestatus is 'old', look for an existing file having the name of the string
  !
  ! if filestatus is 'new', no file with the exact same name as the string should exist
  !
  ! options is the list of valid options
  !
  !===================================================================
  type(paramfile_handle), intent(inout) :: handle
  character(len=*), intent(in) :: keyname
  character(len=*), intent(in), optional :: default
  character(len=*), intent(in), optional :: descr
  character(len=*), intent(in), optional :: filestatus
  character(len=*), intent(in), optional, dimension(1:) :: options

  character(len=filenamelen) :: parse_string

  character(len=filenamelen) :: result
  character(len=30)          :: about_def
  logical :: found, there
  integer :: i
  !===================================================================

10 continue
  about_def = ''
  call find_param (handle, trim(keyname), result, found, chdef=default, &
                   descr=descr)
  if (found) then
    parse_string = trim(result)
  else
    if (present(default)) then
!       write(*,'(1x,a)') 'Parser: warning: using default value for '//trim(keyname)
        about_def = swdef
      parse_string = trim(default)
    else
      write(*,'(1x,a)') 'Parser: error: '//trim(keyname)//' not found.'
      goto 2
    endif
  endif
  parse_string = expand_env_var(parse_string)
  if (handle%verbose) write(*,'(1x,a)') 'Parser: '//trim(keyname)//' = '//trim(parse_string)//trim(about_def)

  ! 0 (zero), '' and ' ' (2 single quotes with nothing or one space in between)
  !         are interpreted as "No File"
  if (trim(adjustl(parse_string)) == "0" )  parse_string = ''
  if (trim(adjustl(parse_string)) == "''")  parse_string = ''
  if (trim(adjustl(parse_string)) == "' '") parse_string = ''

  if (present(filestatus) .and. trim(parse_string) /= '') then
     if (trim(filestatus)=='new' .or. trim(filestatus)=='NEW') then
        !inquire(file=trim(parse_string),exist=there)
        there = file_present(trim(parse_string))
        if (there) then
           print *, 'Parser: error: output file ' // trim(parse_string) // &
                ' already exists!'
           goto 2
        end if
     else if (trim(filestatus)=='old' .or. trim(filestatus)=='OLD') then
        !inquire(file=trim(parse_string),exist=there)
        there = file_present(trim(parse_string))
        if (.not. there) then
           print *, 'Parser: error: input file ' // trim(parse_string) // &
                ' does not exist!'
           goto 2
        end if
     else
        print *, 'Parser: error: wrong value for filestatus :',filestatus
        call fatal_error
     endif
  endif

  if (present(options)) then
     do i=1, size(options) 
        if (trim(adjustl(parse_string)) == trim(adjustl(options(i)))) goto 5
     enddo
     print*,'Invalid choice'
     goto 2
5   continue
  endif

  return ! normal exit

2 if (handle%interactive) goto 10 ! try again
  call fatal_error

end function parse_string



!========================================================================
function concatnl(line1,line2,line3,line4,line5,line6,line7,line8,line9,line10)
  !========================================================================
  ! concatenate line1, line2, line3,... into one string,
  ! while putting a char(10) Line Feed in between
  !========================================================================

  character(len=*), intent(in)           :: line1
  character(len=*), intent(in), optional ::       line2,line3,line4,line5
  character(len=*), intent(in), optional :: line6,line7,line8,line9,line10

  character(len=filenamelen) :: concatnl

  concatnl = trim(line1)
  if (present(line2)) concatnl = trim(concatnl)//ret//trim(line2)
  if (present(line3)) concatnl = trim(concatnl)//ret//trim(line3)
  if (present(line4)) concatnl = trim(concatnl)//ret//trim(line4)
  if (present(line5)) concatnl = trim(concatnl)//ret//trim(line5)
  if (present(line6)) concatnl = trim(concatnl)//ret//trim(line6)
  if (present(line7)) concatnl = trim(concatnl)//ret//trim(line7)
  if (present(line8)) concatnl = trim(concatnl)//ret//trim(line8)
  if (present(line9)) concatnl = trim(concatnl)//ret//trim(line9)
  if (present(line10)) concatnl = trim(concatnl)//ret//trim(line10)


end function concatnl
!========================================================================

!========================================================================
function scan_directories(directories, filename, fullpath)
  !========================================================================
  ! scan directories in search of filename,
  ! if found, returns .true. and the full path is in fullpath.
  ! The search is *NOT* recursive
  !
  ! it assumes that the given directory and filename are separated by either
  !  nothing, a / (slash) or a \ (backslash)
  !
  ! if several directories are to be searched (up to 20),
  ! concatenate them into 'directories',
  ! putting a special character (ASCII < 32) between them.
  !  see concatnl
  ! NB: a space is not a special character
  !========================================================================
  logical(LGT) :: scan_directories
  character(len=*), intent(in)  :: filename, directories
  character(len=*), intent(out) :: fullpath

  logical :: found
  integer(I4B), dimension(1:20) :: index
  integer(I4B)                  :: i, k, nc, nspecial
  character(len=1)              :: ch
  character(len=filenamelen)    :: directory
  character(len=3000)           :: string
  character(LEN=1), DIMENSION(1:3) :: separator
  character(len=*), parameter   :: code = 'scan_directories'
  !========================================================================

  ! define separators (this is the only way that works for all compilers)
  separator(1) = char(32) ! ' '
  separator(2) = char(47) ! '/'
  separator(3) = char(92) ! '\'

  ! find location of special characters
  nc = len_trim(directories)
  index(1) = 0
  nspecial = 2
  do i=1,nc
     ch = directories(i:i)
     if (iachar(ch) < 32) then
        index(nspecial) = i
        nspecial        = nspecial + 1
     endif
  enddo
  index(nspecial) = nc + 1

  ! test string between special character as potential directory
  fullpath = ''
  found = .false.
  do i = 1, nspecial-1
     directory=trim(adjustl(directories(index(i)+1:index(i+1)-1)))
        do k = 1, size(separator)
           string = trim(directory)//trim(separator(k))//trim(filename)
!            inquire(&
!                 &  file=string, &
!                 &  exist=found)
           found = file_present(string)
           if (found) goto 10
        enddo
  enddo

10 continue
  if (found) then
     if (len(fullpath) >= len_trim(string)) then
        fullpath = trim(string)
     else
        print*,code
        print*,'variable fullpath is not large enough'
        print*,'requires ',len_trim(string),' characters'
        print*,'has only ',trim(fullpath)
        call fatal_error
     endif
  endif

  scan_directories = found

end function scan_directories


  !-----------------------------------------------------------
  function get_healpix_main_dir() result (hmd)
    character(len=FILENAMELEN)    :: hmd
    !-----------------------------------------------------------
    ! healpix_dir = get_healpix_main_dir()
    ! returns the full path to the HEALPIX main directory
    ! using 
    ! 1) the preprocessing macros
    ! 1a HEALPIX
    ! 1b HEALPIXDIR
    ! 2) the environment variable
    ! 2a HEALPIX
    !-----------------------------------------------------------
    hmd = ''
!    print*,'get_healpix_main'
#ifdef HEALPIX
    hmd = HEALPIX
#else
#ifdef HEALPIXDIR
    hmd = HEALPIXDIR
#else
    call getEnvironment('HEALPIX',hmd)
#endif
#endif

    if (trim(hmd) == '') then
!!!       call fatal_error("Can not determine main HEALPIX directory")
    else
       hmd = trim(hmd) // '/'
    endif

    return
  end function get_healpix_main_dir
  !-----------------------------------------------------------

  function get_healpix_data_dir() result (hdd)
    character(len=FILENAMELEN)    :: hdd
    character(len=FILENAMELEN)    :: def_dir, healpixdir    
    !-----------------------------------------------------------
    ! healpix_data_dir = get_healpix_data_dir()
    ! returns the full path to the HEALPIX DATA directory
    ! using 
    ! 1) the preprocessing macro
    !    HEALPIXDATA
    ! 2) the environment variable
    !    $HEALPIXDATA
    ! otherwise, it will return the list of directories:
    !  .
    !  ../data
    !  ./data
    !  ..
    !       (and if $HEALPIX is defined)
    !  $HEALPIX
    !  $HEALPIX/data
    !  $HEALPIX/../data
    !  $HEALPIX\data
    ! separated by LineFeed
    !
    ! bug correction 2009-11-26
    ! treat correctly the case where HEALPIX not defined 2012-11-14
    !-----------------------------------------------------------
    hdd = ''
!    print*,'get_healpix_data'
#ifdef HEALPIXDATA
    hdd = HEALPIXDATA
#else
    call getEnvironment('HEALPIXDATA',hdd)

    if (trim(hdd) == '') then
       def_dir  = concatnl("","../data","./data","..")
       healpixdir = get_healpix_main_dir()
       if (trim(healpixdir) /= "") then ! if $HEALPIX defined
!          def_dir = concatnl(&
          hdd = concatnl(&
               & def_dir, &
               & healpixdir, &
               & trim(healpixdir)//"/data", &
               & trim(healpixdir)//"/../data", &
               & trim(healpixdir)//char(92)//"data") !backslash
       else ! if $HEALPIX (or equivalent) not defined
          hdd = def_dir
       endif
    endif
#endif

    if (trim(hdd) == '') then
!!!       call fatal_error("Can not determine HEALPIX DATA directory")
    else
       hdd = trim(hdd) // '/'
    endif

    return
  end function get_healpix_data_dir

  !-----------------------------------------------------------

  function get_healpix_test_dir() result (htd)
    character(len=FILENAMELEN)    :: htd
    character(len=FILENAMELEN)    :: hmd
    !-----------------------------------------------------------
    ! healpix_test_dir = get_healpix_test_dir()
    ! returns the full path to the HEALPIX TEST directory
    ! using 
    ! 1) the preprocessing macro
    !    HEALPIXTEST
    ! 2) the environment variable
    !    $HEALPIXTEST
    ! 3) 
    !    $HEALPIX/test
    ! bug correction 2009-11-26
    !-----------------------------------------------------------
    htd = ''
!    print*,'get_healpix_test'
#ifdef HEALPIXTEST
    htd = HEALPIXTEST
#else
    call getEnvironment('HEALPIXTEST',htd)

    if (trim(htd) == '') then
       call getEnvironment('HEALPIX',hmd)
       if (trim(hmd) /= '') then ! bug correction
          htd = trim(hmd)//'/test'
       endif
       
    endif
#endif

    if (trim(htd) == '') then
!!!       call fatal_error("Can not determine HEALPIX TEST directory")
    else
       htd = trim(htd) // '/'
    endif

    return
  end function get_healpix_test_dir


  !-----------------------------------------------------------
  ! file = get_healpix_pixel_window_file(nside)
  ! returns default file name of Healpix pixel window
  !-----------------------------------------------------------
  function get_healpix_pixel_window_file(nside) result(filename)
    integer(i4b),              intent(in) :: nside
    character(len=FILENAMELEN)            :: filename
    character(len=6) :: sstr

    if (nside <= 8192) then
       sstr = adjustl(string(nside,'(i4.4)'))
    else
       sstr = adjustl(string(nside,'(i6.6)'))
    endif
    filename = "pixel_window_n"//trim(sstr)//".fits"
    
  end function get_healpix_pixel_window_file

  !-----------------------------------------------------------
  ! file = get_healpix_ring_weight_file(nside)
  ! returns default file name of Healpix ring weights
  !-----------------------------------------------------------
  function get_healpix_ring_weight_file(nside) result (filename)
    integer(i4b),              intent(in) :: nside
    character(len=FILENAMELEN)            :: filename
    character(len=6) :: sstr

    if (nside <= 8192) then
       sstr = adjustl(string(nside,'(i5.5)'))
    else
       sstr = adjustl(string(nside,'(i6.6)'))
    endif
    filename = "weight_ring_n"//trim(sstr)//".fits"

  end function get_healpix_ring_weight_file

  !-----------------------------------------------------------
  ! file = get_healpix_pixel_weight_file(nside)
  ! returns default file name of Healpix pixel weights
  !-----------------------------------------------------------
  function get_healpix_pixel_weight_file(nside) result (filename)
    integer(i4b),              intent(in) :: nside
    character(len=FILENAMELEN)            :: filename
    character(len=6) :: sstr

    if (nside <= 8192) then
       sstr = adjustl(string(nside,'(i5.5)'))
    else
       sstr = adjustl(string(nside,'(i6.6)'))
    endif
    filename = "weight_pixel_n"//trim(sstr)//".fits"

  end function get_healpix_pixel_weight_file

  !-----------------------------------------------------------
  ! file = get_healpix_weight_file(nside, type)
  ! returns default file name of Healpix ring weights (if type=1)
  ! or pixel weigts (if type=2)
  !-----------------------------------------------------------
  function get_healpix_weight_file(nside, type) result (filename)
    integer(i4b),              intent(in) :: nside, type
    character(len=FILENAMELEN)            :: filename

    if (type == 0) then
       filename = ''
    else if (type == 1) then
       filename = get_healpix_ring_weight_file(nside)
    else if (type == 2) then
       filename = get_healpix_pixel_weight_file(nside)
    else
       print*,'Wrong choice of weight: must be either'
       print*,' 0: no weight'
       print*,' 1: ring-based weights'
       print*,' 2: pixel-based weights'
       print*,' value: '//string(type)
       call fatal_error
    endif

  end function get_healpix_weight_file

end module paramfile_io

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module healpix_modules
! Healpix meta module, giving access to all specific modules


  use healpix_types
  use extension
  use misc_utils
  use utilities
  use paramfile_io
  use long_intrinsic

  use healpix_fft
  use num_rec
!  use m_indmed
  use statistics
  use rngmod
  use coord_v_convert

  use bit_manipulation
  use pix_tools
  use head_fits
  use fitstools
  use alm_tools
!  use mpi_alm_tools
  use udgrade_nr
  use mask_tools

  use ran_tools
  use obsolete

  public

end module healpix_modules

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday,
!                          Matthias Bartelmann, Hans K. Eriksen,
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module alm_tools
#ifndef DONT_USE_SHARP
#define USE_SHARP
#endif
#ifdef USE_SHARP
use healpix_sharp_f90
#endif
  !   Scalar+Open_MP implementation
  !
  !   function do_opemp
  !   subroutine init_rescale
  !   subroutine get_pixel_layout
  !   subroutine select_rings
  !   subroutine gen_recfac
  !   subroutine gen_recfac_spin
  !   subroutine gen_lamfac
  !   subroutine gen_lamfac_der
  !   subroutine gen_mfac
  !   subroutine gen_mfac_spin
  !   subroutine compute_lam_mm
  !   subroutine do_lam_lm
  !   subroutine do_lam_lm_spin
  !   subroutine do_lam_lm_pol
  !   subroutine gen_normpol
  !   function l_min_ylm
  !   subroutine warning_oldbounds
  !
  !   subroutine ring_synthesis
  !   subroutine ring_analysis
  !
  !   -------------------- in include files (see alm_map_template.f90) ---------
  !   subroutine alm2map_sc
  !   subroutine alm2map_spin
  !   subroutine alm2map_sc_pre
  !   subroutine alm2map_pol
  !   subroutine alm2map_pol_pre1
  !   subroutine alm2map_pol_pre2
  !   subroutine alm2map_sc_der
  !   subroutine alm2map_pol_der
  !
  !   subroutine map2alm_sc
  !   subroutine map2alm_spin
  !   subroutine map2alm_sc_pre
  !   subroutine map2alm_pol
  !   subroutine map2alm_pol_pre1
  !   subroutine map2alm_pol_pre2
  !
  !   subroutine map2alm_iterative
  !
  !   subroutine alter_alm
  !   subroutine create_alm
  !   subroutine alm2cl
  !
  !   subroutine rotate_alm
  !   ------------------------------------------------------------------
  !
  !   subroutine plm_gen
  !
  !   subroutine pow2alm_units
  !   subroutine generate_beam
  !   subroutine gaussbeam
  !   subroutine pixel_window
  !
  use misc_utils, only: assert_alloc, assert_present, assert, fatal_error, string, strupcase !, wall_clock_time
  use healpix_types
  use healpix_fft, only: real_fft2, planck_fft2_plan, make_fft2_plan, destroy_fft2_plan, &
       &                 fft2_forward, fft2_backward
  IMPLICIT none

  ! keep everything private unless stated otherwise
  private
  !--------------------------------------------------------------------------
  ! define large and small numbers used to renormalise the recursion on the Legendre Polynomials
  integer(I4B),      private, parameter :: LOG2LG   = 100
  real(KIND=DP),     private, parameter :: FL_LARGE = 2.0_dp **   LOG2LG
  real(KIND=DP),     private, parameter :: FL_SMALL = 2.0_dp ** (-LOG2LG)
  ! declare array for dynamic rescaling of the Ylm
  integer(kind=i4b), private, parameter :: RSMAX = 20, RSMIN = -20
  real(dp),          private, dimension(RSMIN:RSMAX) :: rescale_tab
  real(DP),          private, parameter :: ALN2_INV = 1.4426950408889634073599246810_dp ! 1/log(2)
  ! misc
  integer(i4b),      private, parameter :: SMAXCHK = 50 ! maximum size of chunk (in number of ring pairs)
  ! parameters of Ylm short-cut
  integer(kind=i4b), private, parameter :: HPX_MXL0 = 40 ! minimum used, choose <=0 to do full loop
  real   (kind=dp),  private, parameter :: HPX_MXL1 = 1.35_dp
  !--------------------------------------------------------------------------

  ! make (front end) routines public
  public :: alm2map, map2alm, alm2map_der, alm2map_spin, map2alm_spin
  public :: map2alm_iterative
  public :: map2alm_iterative_old
  public :: alter_alm, create_alm, alm2cl, rotate_alm
  public :: create_alm_old ! for tests only
  public :: plm_gen
  public :: ring_synthesis, ring_analysis
  public :: generate_beam, gaussbeam, pixel_window, pow2alm_units

  interface alm2cl
     module procedure alm2cl2_s, alm2cl2_d, alm2cl1_s, alm2cl1_d
  end interface

  interface sub_alm2cl
     module procedure sub_alm2cl_s, sub_alm2cl_d
  end interface

  interface rotate_alm
     module procedure rotate_alm_s, rotate_alm_d
  end interface

  interface alter_alm
     module procedure alter_alm_s, alter_alm_d
  end interface

  interface create_alm
     module procedure create_alm_s, create_alm_d, create_alm_v12_s, create_alm_v12_d
  end interface

  interface create_alm_old ! for tests only
     module procedure create_alm_old_s, create_alm_old_d
  end interface

  interface alm2map_der
     module procedure alm2map_sc_der_s, alm2map_sc_der_d, alm2map_pol_der_s, alm2map_pol_der_d
  end interface

  interface alm2map_spin
     module procedure alm2map_spin_s, alm2map_spin_d
  end interface

  interface map2alm_spin
     module procedure map2alm_spin_s, map2alm_spin_d
  end interface

  interface alm2map
     ! Call the correct alm2map routine, depending on whether polarisation is included
     ! (determined from the rank of the map_TQU array) or precomputed plms
     ! (scalar or tensor, determined from the rank of the plm array) are included,
     ! or whether the map and alm are single or double precision
     module procedure alm2map_sc_wrapper_s, &
          &           alm2map_pol_wrapper_s, alm2map_pol_pre2_s, &
          &           alm2map_sc_wrapper_d, &
          &           alm2map_pol_wrapper_d,  alm2map_pol_pre2_d
!!!     module procedure alm2map_sc_s, alm2map_sc_pre_s, &
!!!          &           alm2map_pol_s, alm2map_pol_pre1_s, alm2map_pol_pre2_s, &
!!!          &           alm2map_sc_d, alm2map_sc_pre_d, &
!!!          &           alm2map_pol_d, alm2map_pol_pre1_d, alm2map_pol_pre2_d
  end interface

  interface map2alm
     ! Call the correct map2alm routine, depending on whether polarisation is included
     ! (determined from the rank of the map_TQU array) or precomputed plms
     ! (scalar or tensor, determined from the rank of the plm array) are included,
     ! or whether the map and alm are single or double precision
     module procedure map2alm_old_sc_s,  map2alm_old_pol_s,  map2alm_old_pol2_s, &
          &           map2alm_sc_s, map2alm_sc_pre_s, &
          &           map2alm_pol_s, map2alm_pol_pre1_s, map2alm_pol_pre2_s, &
          &           map2alm_old_sc_d,  map2alm_old_pol_d,  map2alm_old_pol2_d, &
          &           map2alm_sc_d, map2alm_sc_pre_d, &
          &           map2alm_pol_d, map2alm_pol_pre1_d, map2alm_pol_pre2_d
  end interface

  interface map2alm_iterative
     module procedure map2alm_iterative_s, map2alm_iterative_d
  end interface
  interface map2alm_iterative_old
     module procedure map2alm_iterative_old_s, map2alm_iterative_old_d
  end interface

  interface sub_map2ring
     module procedure sub_map2ring_1d_s, sub_map2ring_1d_d, sub_map2ring_nd_s, sub_map2ring_nd_d
  end interface
  interface sub_ring2map
     module procedure sub_ring2map_1d_s, sub_ring2map_1d_d, sub_ring2map_nd_s, sub_ring2map_nd_d
  end interface
  ! make routines public as most of them are called by mpi_alm* routines
  public :: do_openmp
  public :: init_rescale
  public :: do_lam_lm, do_lam_lm_pol
  ! needed by mpi_alm*
  public :: l_min_ylm
  public :: get_pixel_layout
  public :: gen_recfac, gen_lamfac, gen_lamfac_der, gen_mfac, compute_lam_mm, gen_normpol
  public :: select_rings ! added Feb 2006
  !
  public :: gen_recfac_spin, gen_mfac_spin, do_lam_lm_spin ! July 2007

  !=========================================================

  !
  ! Aug 14, 2000, EH, Caltech, switch to CMBFAST normalisation of polarisation power spectra
  !  (see Zaldarriaga, astro-ph/9709271; ApJ, 503, 1 (1998))
  !   the factor normal_l (used for synthesis and analysis) is reduced by sqrt(2)
  !
  ! Oct 17, 2001
  !   polarised alm expression is larger by a factor 2
  !   introduced FL_LARGE and FL_SMALL parameters
  !
  ! Sept 2001, EH, Caltech: map2alm* : skip calculations for cut out pixels
  !                                  : use explicit loops for multiplication of alm by omega_pix
  !
  ! Nov 2001, EH, Caltech : added KIND=DP in all CMPLX commands that missed it
  !                         turned 1.d0 in 1.0_dp and so on
  !                         moved 'use healpix_types' and 'implicit none' to module top level
  !
  ! Dec 2001, EH, Caltech : corrected error on inner loop upper bound of lam_fact initialisation
  !   in alm2map_pol_pre1, alm2map_pol, map2alm_pol_pre1, map2alm_pol
  !   pointed out by M. Ashdown to Level S
  !
  !   added pow2alm_units, gaussbeam, generate_beam and alter_alm (moved for smoothing/alter_alm.f90)
  !
  !
  ! Nov 2002, EH, reordered routines to simplify maintenance of scalar vs parallel routines
  ! ------post 1.21
  ! Dec 2003-Jan 2004, EH, remove 'trig' array from ring_analysis and ring_synthesis
  ! 2004-05-28, EH, edition of pixel_window
  ! Aug 2004 : put ring in DP in ring_synthesis
  !            add alm2map_sc_der for calculation of derivatives
  !            moved plm_gen here from plmgen main code
  ! Oct 2004: reduced size of recfac and lam_fact
  !         : introduced m_max_syn and m_max_ana
  ! Nov 2004: streamlining of *alm* routines to gain CPU time
  ! Dec 2004: editions to alter_alm (new argument), pixel_window
  ! April 2005: separate Lambda_lm calculation (with do_lam_lm[_pol]) from scalar
  !  product in alm2map_sc and alm2map_pol for speed up.
  !  does not improve the speed of map2alm though, so stick to former code for those
  ! May 2005: pixel window returns 1. if nside = 0 (interpreted as infinitely small pixel)
  ! Aug 2005: added alm2map_pol_der
  ! ------post 2.00
  ! Sep-Oct 2005: made internal subroutines public so they can be called by mpi_alm,
  !              corrected OpenMP+SGI bug in alm2map_pol_der
  ! Feb 2006: added select_rings to public routines (for MPI use)
  ! Sep 2006: corrected resetting of lam_fact in gen_lamfac
  ! July, Sep-Oct 2007: added alm2map_spin, map2alm_spin
  ! Oct 2007: zbounds and w8rings optional in map2alm (without plm)
  ! Nov 2008: correction of a crash bug in map2alm_iterative
  ! Jan 2009: correction of a PGF90 specific bug in create_alm
  ! Jan 2010: correction of a bug in alm2map_pol_der affecting Q and U derivatives
  ! Jan 2011: use get_healpix_pixel_window_file in pixel_window()
  ! =====================================================
  ! about the F90 compilers 'features'
  ! - Intel compiler (ifc) (and maybe the other compilers as well)
  !  is apparently very slow at allocating arrays
  ! therefore as much as possible the 'allocate' should be done outside the loops.
  ! This what is done below, expect when OpenMP require thread safe arrays that much
  ! be created each time we enter the loop.
  !
  ! - NagF95 (f95) is very slow at creating vectors with the operator (/ ... /)
  ! therefore, in a loop, the operation
  ! x(0:4) = x(0:4) + (/ a, b, c, d /) should be replaced by the equivalent
  ! but MUCH faster, explicit form
  ! x(0) = x(0) + a
  ! x(1) = x(1) + b
  ! ...
  ! unless (/ a,b,c,d /) can be constructed before entering the loop
  !
contains

  !**************************************************************************
  !
  !             ALM2MAP/MAP2ALM    SIDEKICKS
  !
  !**************************************************************************
  !================================================
  function do_openmp()
    !================================================
    ! returns .true. if code was compiled with OpenMP
    !================================================
    logical(LGT) :: do_openmp
    !------------------------------------------------

    do_openmp = .false.
! DO NOT REMOVE FOLLOWING LINES
!$    do_openmp = .true.  ! Intel f90
!IBMP do_openmp = .true.  ! IBM xlf90
! -----------------------------

    return
  end function do_openmp

  !================================================
  subroutine init_rescale()
    !================================================
    ! local variables
    integer(i4b) :: s, smax
    real(dp) :: logOVFLOW
    character(len=*), parameter :: code = 'gen_rescale'
    !------------------------------------------------
    logOVFLOW=log(FL_LARGE)
    smax = INT( log(MAX_DP) / logOVFLOW )

    if (smax > (RSMAX-1)) then
       print*,'Array rescale_tab too small in '//code
       print*,smax ,'>', RSMAX
       stop
    endif

    rescale_tab(RSMIN:RSMAX) = 0.0_dp
    do s = -smax, smax
       rescale_tab(s) = FL_LARGE ** s
    enddo
    rescale_tab(0) = 1.0_dp

    return
  end subroutine init_rescale

  !=======================================================================
  subroutine get_pixel_layout(nside, ith, cth, sth, nphi, startpix, kphi0)
    !=======================================================================
    ! output Healpix pixel layout for the ring ith in [0,2*nside]
    !=======================================================================
    integer(I4B), intent(IN)  :: nside, ith
    real(DP)    , intent(OUT) :: cth, sth
    integer(I4B), intent(OUT) :: nphi, kphi0
    integer(I8B), intent(OUT) :: startpix
    !
    integer(I4B) :: nrings
    real(DP)     :: dth1, dth2, dst1
    !=======================================================================

    nrings = 2*nside
    if (ith < 1 .or. ith> nrings) then
       print*,'ith out of bounds ',ith,1,nrings
       call fatal_error
    endif

    dth1 = 1.0_dp / (3.0_dp*DBLE(nside)**2)
    dth2 = 2.0_dp / (3.0_dp*DBLE(nside))
    dst1 = 1.0_dp / (SQRT(6.0_dp) * DBLE(nside) )

    if (ith < nside) then  ! polar cap (north)
       cth = 1.0_dp  - DBLE(ith)**2 * dth1
       nphi = 4*ith
       kphi0 = 1
       sth = SIN( 2.0_dp * ASIN( ith * dst1 ) ) ! sin(theta)
       startpix = 2*ith*(ith-1_I8B)
    else                   ! tropical band (north) + equator
       cth = DBLE(2*nside-ith) * dth2
       nphi = 4*nside
       kphi0 = MOD(ith+1-nside,2)
       sth = DSQRT((1.0_dp-cth)*(1.0_dp+cth)) ! sin(theta)
       startpix = 2*nside*(nside-1_I8B) + (ith-nside)*int(nphi,kind=I8B)
    endif

    return
  end subroutine get_pixel_layout
  !=======================================================================
  subroutine select_rings_old(z, zbounds, keep_north, keep_south, keep_either)
    !=======================================================================
    ! select rings laying within zbounds
    ! if zbounds(1) < zbounds(2) : keep  zbounds(1) < z < zbounds(2)
    ! if zbounds(2) < zbounds(1) : keep z < zbounds(2) Union  zbounds(1) < z
    ! if zbounds(1)=zbounds(2) : keep everything
    ! input z should be >= 0
    !=======================================================================
    real(DP)    , intent(in)  :: z
    real(DP)    , intent(in), dimension(1:2)  :: zbounds
    logical(LGT), intent(OUT) :: keep_north, keep_south, keep_either
    !
    real(DP) :: zn, zs
    !=======================================================================

    ! if (zbounds(1) = zbounds(2)) keep everything
    if (abs(zbounds(1)-zbounds(2)) < 1.e-6) then
       keep_north    = .true.
       keep_south    = .true.
       keep_either   = .true.
       return
    endif

    zn = abs(z)
    zs = -zn

    if (zbounds(1) < zbounds(2)) then
       ! inner ring
       keep_north = (zn >= zbounds(1) .and. zn <= zbounds(2))
       keep_south = (zs >= zbounds(1) .and. zs <= zbounds(2))

    else
       ! outter ring
       keep_north = (zn > zbounds(1) .or. zn < zbounds(2))
       keep_south = (zs > zbounds(1) .or. zs < zbounds(2))
    endif
    keep_either   = keep_north .or. keep_south


    return
  end subroutine select_rings_old

  !=======================================================================
  subroutine select_rings(z, zbounds, keep_north, keep_south, keep_either)
    !=======================================================================
    ! select rings laying within zbounds
    ! if zbounds(1) <  zbounds(2) : keep  zbounds(1) < z < zbounds(2)
    ! if zbounds(2) <= zbounds(1) : keep z < zbounds(2) Union  zbounds(1) < z
    ! input z should be >= 0
    ! edited 2018-11-09 to be identical to remove_dipole, apply_mask
!             and libsharp's hpsharp_make_healpix_geom_info_2
    !=======================================================================
    real(DP)    , intent(in)  :: z
    real(DP)    , intent(in), dimension(1:2)  :: zbounds
    logical(LGT), intent(OUT) :: keep_north, keep_south, keep_either
    !
    real(DP) :: zn, zs
    !=======================================================================


    zn = abs(z)
    zs = -zn

    if (zbounds(1) < zbounds(2)) then
       ! inner ring
       keep_north = (zn > zbounds(1) .and. zn < zbounds(2))
       keep_south = (zs > zbounds(1) .and. zs < zbounds(2))

    else
       ! outter ring
       keep_north = (zn > zbounds(1) .or. zn < zbounds(2))
       keep_south = (zs > zbounds(1) .or. zs < zbounds(2))
    endif
    keep_either   = keep_north .or. keep_south


    return
  end subroutine select_rings

  !=======================================================================
  subroutine gen_recfac( l_max, m, recfac)
  !=======================================================================
    ! generates recursion factors used to computes the Ylm of degree m
    ! for all l in m<=l<=l_max
    !=======================================================================
    integer(I4B), intent(IN)                            :: l_max, m
    real(DP),     intent(OUT), dimension(0:1, 0:l_max)  :: recfac
    !
    real(DP) :: fm2, fl2
    integer(I4B) :: l

    recfac(0:1,0:m) = 0.0_dp
    fm2 = DBLE(m) **2
    do l = m, l_max
       fl2 = DBLE(l+1) **2
       recfac(0,l) = DSQRT( (4.0_dp * fl2 - 1.0_dp) / (fl2-fm2) )
    enddo
    ! put outside the loop because of problem on some compilers
    recfac(1,m:l_max) = 1.0_dp / recfac(0,m:l_max)


    return
  end subroutine gen_recfac

  !=======================================================================
  subroutine gen_recfac_spin( l_max, m, spin, recfac_spin)
  !=======================================================================
    ! generates recursion factors used to computes the Ylms of degree m and spin s
    ! for all l in max(m,s)<=l<=l_max
    !=======================================================================
    integer(I4B), intent(IN)                            :: l_max, m, spin
    real(DP),     intent(OUT), dimension(0:2, 0:l_max)  :: recfac_spin
    !
    real(DP) :: fm2, fl2, fs2
    integer(I4B) :: l, l_low, aspin


    aspin = abs(spin)
    l_low = max(m, aspin)

    recfac_spin(0:2, 0:l_max) = 0.0_dp
    fm2 = DBLE(m) **2
    fs2 = DBLE(spin) **2
    do l = l_low, l_max
       fl2 = DBLE(l+1) **2
       recfac_spin(0,l) = DSQRT( (4.0_dp * fl2 - 1.0_dp) / (fl2-fm2) /(1.0_dp-fs2/fl2) )
    enddo
    do l = max(l_low, 1), l_max
       recfac_spin(2,l) = aspin * m / dble( l * (l+1) )
    enddo
    ! put outside the loop because of problem on some compilers
    recfac_spin(1,l_low:l_max) = 1.0_dp / recfac_spin(0,l_low:l_max)


    return
  end subroutine gen_recfac_spin

  !=======================================================================
  subroutine gen_lamfac( l_max, m, lam_fact)
  !=======================================================================
    ! generates factor relating scalar Ylm to polar Ylm
    ! for all l in m<=l<=l_max
    !=======================================================================
    integer(I4B), intent(IN)                       :: l_max, m
    real(DP),     intent(OUT), dimension(0:l_max)  :: lam_fact
    !
    real(DP) :: fm2, fl, fl2
    integer(I4B) :: l

!    lam_fact(0:m) = 0.
    lam_fact(0:max(1,m)) = 0.0_dp
    fm2 = real(m * m, kind=DP)
    do l = max(2,m+1), l_max
       fl  = real(l, kind=dp)
       fl2 = fl * fl
       lam_fact(l) = 2.0_dp * SQRT( (2.0_dp * fl + 1.0_dp) / (2.0_dp * fl - 1.0_dp) * (fl2-fm2) )
    enddo

    return
  end subroutine gen_lamfac

  !=======================================================================
  subroutine gen_lamfac_der(l_max, m, lam_fact)
    !=======================================================================
    ! generates factor relating scalar Ylm to its derivatives
    ! for all l in m<=l<=l_max
    !=======================================================================
    integer(I4B), intent(IN)                       :: l_max, m
    real(DP),     intent(OUT), dimension(0:l_max)  :: lam_fact
    !
    real(DP) :: fm2, fl, fl2
    integer(I4B) :: l

    lam_fact(0:m) = 0.
    fm2 = real(m * m, kind=DP)
    do l = max(1,m+1), l_max ! different lower bound than pol. factor
       fl  = real(l, kind=dp)
       fl2 = fl * fl
       lam_fact(l) = SQRT( (2.0_dp * fl + 1.0_dp) / (2.0_dp * fl - 1.0_dp) * (fl2-fm2) )
       ! different normalization than polarization factor
    enddo

    return
  end subroutine gen_lamfac_der

  !=======================================================================
  subroutine gen_mfac( m_max, m_fact)
  !=======================================================================
    ! generates factor used in lam_mm calculation
    ! for all m in 0<=m<=m_max
    !=======================================================================
    integer(I4B), intent(IN)                       :: m_max
    real(DP),     intent(OUT), dimension(0:m_max)  :: m_fact
    !
    integer(I4B) :: m

    ! fact(m) = fact(m-1) * sqrt( (2m+1) / (2m) )
    m_fact(0) = 1.0_dp
    do m=1,m_max
      m_fact(m) = m_fact(m-1)*sqrt(dble(2*m+1)/dble(2*m))
    end do

    ! Log_2 ( fact(m) / sqrt(4 Pi) )
    do m=0,m_max
       m_fact(m) = log(SQ4PI_INV * m_fact(m)) * ALN2_INV
    enddo

    return
  end subroutine gen_mfac
  !=======================================================================
  subroutine gen_mfac_spin( m_max, spin, m_fact)
  !=======================================================================
    ! generates factor used in lam_mm,s calculation
    ! for all m in 0<=m<=m_max
    !=======================================================================
    integer(I4B), intent(IN)                       :: m_max, spin
    real(DP),     intent(OUT), dimension(0:m_max)  :: m_fact
    !
    integer(I4B) :: m, aspin
    real(DP) :: tmp

    aspin = abs(spin)
    m_fact(:) = -1.e30
    if (aspin <= m_max) m_fact(aspin) = 1.0_dp
    ! fact(m) = fact(m+1) * sqrt((s+m+1)/(s-m) )
    if (aspin > 0) then
       tmp = 1.d0
       do m = aspin-1, 0, -1
          tmp = tmp * sqrt( dble(aspin+m+1)/dble(aspin-m) )
          if (m <= m_max) m_fact(m) = tmp
       enddo
    endif
    ! fact(m) = fact(m-1) * sqrt(m*(2m+1)/(m-s)/(m+s)/2 )
    do m = aspin+1, m_max
      m_fact(m) = m_fact(m-1)*sqrt( m*dble(2*m+1)/dble(2*(m-aspin)*(m+aspin)) )
    end do

    ! Log_2 ( fact(m)  / sqrt(4 Pi))
    do m=0,m_max
       m_fact(m) = log(SQ4PI_INV * m_fact(m)) * ALN2_INV
    enddo

    return
  end subroutine gen_mfac_spin
  !=======================================================================
  subroutine compute_lam_mm(mfac, m, sth, lam_mm, corfac, scalem)
    !=======================================================================
    ! computes lam_mm
    ! the true lam_mm is     lam_mm * corfac
    !=======================================================================
    integer(I4B),            intent(in)  :: m
    real(DP),                intent(in)  :: sth, mfac
    real(DP),                intent(out) :: lam_mm, corfac
    integer(I4B),            intent(out) :: scalem
    !
    real(DP) :: log2val, dlog2lg

    dlog2lg = real(LOG2LG, kind=DP)

    log2val = mfac + m*log(sth) * ALN2_INV ! log_2(lam_mm)
    scalem = int (log2val / dlog2lg)
    corfac = rescale_tab(max(scalem,RSMIN))
    lam_mm = 2.0_dp **(log2val - scalem * dlog2lg) ! rescaled lam_mm
    if (IAND(m,1)>0) lam_mm = -lam_mm ! negative for odd m

    return
  end subroutine compute_lam_mm

  !=======================================================================
  subroutine do_lam_lm(lmax, m, cth, sth, mfac, recfac, lam_lm)
    !=======================================================================
    ! computes scalar lambda_lm(theta) for all l in [m,lmax] for a given m, and given theta
    ! input: lmax, m, cos(theta), sin(theta)
    !        mfac: precomputed (by gen_mfac) quantity useful for lambda_mm calculation
    !        recfac: precomputed (by gen_recfac) quantities useful for
    !            lambda_lm recursion for a given m
    ! output: lam_lm
    ! the routine also needs the array rescale_tac initialized by init_rescale
    !=======================================================================
    integer(I4B),                    intent(in)  :: lmax,  m
    real(DP),                        intent(in)  :: cth, sth, mfac
    real(DP), dimension(0:1,0:lmax), intent(in)  :: recfac
    real(DP), dimension(    0:lmax), intent(out) :: lam_lm
    !
    real(DP) :: log2val, dlog2lg
    real(DP) :: ovflow, unflow, corfac
    real(DP) :: lam_mm, lam_0, lam_1, lam_2
    integer(I4B) :: scalel, l, l_min
    !---------------------------------------------------------------

    ! define constants
    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    l_min = l_min_ylm(m, sth)
    dlog2lg = real(LOG2LG, kind=DP)

    ! computes lamba_mm
    log2val = mfac + m*log(sth) * ALN2_INV ! log_2(lam_mm)
    scalel = int (log2val / dlog2lg)
    corfac = rescale_tab(max(scalel,RSMIN))
    lam_mm = 2.0_dp **(log2val - scalel * dlog2lg) ! rescaled lam_mm
    if (IAND(m,1)>0) lam_mm = -lam_mm ! negative for odd m

    lam_lm(0:lmax) = 0.0_dp
    ! --- l = m ---
    lam_lm(m) = lam_mm * corfac

    ! --- l > m ---
    lam_0 = 0.0_dp
    lam_1 = 1.0_dp
    lam_2 = cth * lam_1 * recfac(0,m)
    do l = m+1, lmax
       ! do recursion
       if (l >= l_min) then
          lam_lm(l) = lam_2 * corfac * lam_mm
       endif
       lam_0 = lam_1 * recfac(1,l-1)
       lam_1 = lam_2
       lam_2 = (cth * lam_1 - lam_0) * recfac(0,l)

       ! do dynamic rescaling
       if (abs(lam_2) > ovflow) then
          lam_1 = lam_1*unflow
          lam_2 = lam_2*unflow
          scalel= scalel + 1
          corfac = rescale_tab(max(scalel,RSMIN))
       elseif (abs(lam_2) < unflow .and. abs(lam_2) /= 0.0_dp) then
          lam_1 = lam_1*ovflow
          lam_2 = lam_2*ovflow
          scalel= scalel - 1
          corfac = rescale_tab(max(scalel,RSMIN))
       endif

    enddo ! loop on l
  end subroutine do_lam_lm
  !=======================================================================
  subroutine do_lam_lm_spin(lmax, m, spin, cth, sth, mfac, mfac_spin, recfac_spin, lam_lm_spin)
    !=======================================================================
    ! computes spin lambda_lm(theta) for all l in [m,lmax] for a given m, spin, and theta
    ! input: lmax, m, spin, cos(theta), sin(theta)
    !        mfac: precomputed (by gen_mfac) quantity useful for lambda_mm calculation
    !        mfac_spin: precomputed (by gen_mfac_spin) quantity useful for lambda_mm calculation
    !        recfac_spin: precomputed (by gen_recfac_spin) quantities useful for
    !            lambda_lm recursion for a given m
    ! output: lam_lm
    ! the routine also needs the array rescale_tab initialized by init_rescale
    !=======================================================================
    integer(I4B),                    intent(in)  :: lmax,  m, spin
    real(DP),                        intent(in)  :: cth, sth, mfac, mfac_spin
    real(DP), dimension(0:2,0:lmax), intent(in)  :: recfac_spin
    real(DP), dimension(1:2,0:lmax), intent(out) :: lam_lm_spin
    !
    real(DP) :: dlog2lg
    real(DP) :: ovflow, unflow
    real(DP) :: lam_0, lam_1, lam_2
    real(DP) :: thetao2, ttho2, stho2, ctho2, kss, tmp1, tmp2
    real(DP), dimension(1:2) :: log10sss, corfac, log2val, lam_mm
    integer(I4B) :: l, l_min, l_low, aspin, iss
    integer(I4B), dimension(1:2) :: scalel
    !---------------------------------------------------------------

    lam_lm_spin(1:2,0:lmax) = 0.0_dp
    aspin = abs(spin)
    l_low = max(m, aspin)
    if (l_low > lmax) return

    ! define constants
    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    l_min = l_min_ylm(m, sth)
    dlog2lg = real(LOG2LG, kind=DP)

    thetao2 = atan2(sth, cth)/2.d0
    ttho2 = tan(thetao2)
    stho2 = sin(thetao2) ! sqrt(1-cth)/sqrt(2)
    ctho2 = cos(thetao2) ! sqrt(1+cth)/sqrt(2)
    ! lambda(s,s, s) = (-)^s * sqrt(2s+1/4Pi) sin(theta/2)^(2s)
    ! lambda(s,s,-s) = (-)^s * sqrt(2s+1/4Pi) cos(theta/2)^(2s)
    log10sss(1) = (2*aspin *log(stho2) + 0.5d0*log(2*aspin+1.0_dp)) ! log_10(abs(lam_sss)*sqrt(4Pi))
    log10sss(2) = (2*aspin *log(ctho2) + 0.5d0*log(2*aspin+1.0_dp)) ! log_10(abs(lam_ss-s)*sqrt(4Pi))
    !
    if (m >= aspin) then
       ! computes directly lambda(m,m,s)
       ! lambda(m,m,s) = - lambda(m-1,m-1,s) * sin(theta) * sqrt(m(2m+1)/2/(m^2-s^2))
       log2val(1:2) = mfac_spin + ((m-aspin)*log(sth) + log10sss(1:2)) * ALN2_INV ! log_2(lam_mms)
       scalel(1:2) = int (log2val(1:2) / dlog2lg)
       corfac(1) = rescale_tab(max(scalel(1),RSMIN))
       corfac(2) = rescale_tab(max(scalel(2),RSMIN))
       lam_mm(1:2) = 2.0_dp **(log2val(1:2) - scalel(1:2) * dlog2lg) ! rescaled lam_mm
       if (IAND(m,1)>0) lam_mm(1:2) = -lam_mm(1:2) ! negative for odd m
    else
       ! computes lambda(s,m,s)
       ! lambda(s,m,s)  = - lambda(s,m+1, s) / tan(theta/2) * sqrt((s+m+1)/(s-m))
       ! lambda(s,m,-s) = + lambda(s,m+1,-s) * tan(theta/2) * sqrt((s+m+1)/(s-m))
       log2val(1) = mfac_spin + ( (m-aspin)*log(ttho2) + log10sss(1)) * ALN2_INV ! log_2(lam_mms)
       log2val(2) = mfac_spin + (-(m-aspin)*log(ttho2) + log10sss(2)) * ALN2_INV ! log_2(lam_mms)
       scalel(1:2) = int (log2val(1:2) / dlog2lg)
       corfac(1) = rescale_tab(max(scalel(1),RSMIN))
       corfac(2) = rescale_tab(max(scalel(2),RSMIN))
       lam_mm(1:2) = 2.0_dp **(log2val(1:2) - scalel(1:2) * dlog2lg) ! rescaled lam_mm
       if (IAND(m,1)>0)     lam_mm(1) = -lam_mm(1) ! negative for odd m, and s>0
       if (IAND(aspin,1)>0) lam_mm(2) = -lam_mm(2) ! negative for odd s, and s<0
    endif

    ! --- l = m ---
    lam_lm_spin(1:2,l_low) = lam_mm(1:2) * corfac(1:2)

    do iss=1,2 ! +spin and then -spin
       kss = 1.0_dp
       if (iss == 2) kss = -1.0_dp
       ! --- l > m ---
       lam_0 = 0.0_dp
       lam_1 = 1.0_dp
       lam_2 = (cth + kss*recfac_spin(2,l_low)) * lam_1 * recfac_spin(0,l_low)
       do l = l_low+1, lmax
          ! do recursion
          if (l >= l_min) then
             lam_lm_spin(iss,l) = lam_2 * corfac(iss) * lam_mm(iss)
          endif
          lam_0 = lam_1 * recfac_spin(1,l-1)
          lam_1 = lam_2
          lam_2 = ((cth + kss*recfac_spin(2,l)) * lam_1 - lam_0) * recfac_spin(0,l)

          ! do dynamic rescaling
          if (abs(lam_2) > ovflow) then
             lam_1 = lam_1*unflow
             lam_2 = lam_2*unflow
             scalel(iss)= scalel(iss) + 1
             corfac(iss) = rescale_tab(max(scalel(iss),RSMIN))
          elseif (abs(lam_2) < unflow .and. abs(lam_2) /= 0.0_dp) then
             lam_1 = lam_1*ovflow
             lam_2 = lam_2*ovflow
             scalel(iss)= scalel(iss) - 1
             corfac(iss) = rescale_tab(max(scalel(iss),RSMIN))
          endif
       enddo ! loop on l
    enddo ! loop on spin sign (iss)

    ! compute functions with fixed parity
    ! beware: the first one is always the half sum
    !         the second one is always the half difference, independently of spin
    do l=0, lmax
       tmp1 = lam_lm_spin(1,l) * 0.5_dp
       tmp2 = lam_lm_spin(2,l) * 0.5_dp
       lam_lm_spin(1,l) = tmp1 + tmp2
       lam_lm_spin(2,l) = tmp1 - tmp2
    enddo

  end subroutine do_lam_lm_spin
  !=======================================================================
  subroutine do_lam_lm_pol(lmax, m, cth, sth, mfac, recfac, lam_fact, lam_lm)
    !=======================================================================
    ! computes temperature&polar lambda_lm(p,theta) for all l in [m,lmax] for a given m, and given theta
    ! input: lmax, m, cos(theta), sin(theta)
    !        mfac: precomputed (by gen_mfac) quantity useful for lambda_mm calculation
    !        recfac: precomputed (by gen_recfac) quantities useful for
    !            lambda_lm recursion for a given m
    !        lam_fact: precomputed (by gen_lamfac) factor useful for polarised lambda recursion
    ! output: lam_lm for T and P
    ! the routine also needs the array rescale_tac initialized by init_rescale
    !=======================================================================
    integer(I4B),                    intent(in)  :: lmax,  m
    real(DP),                        intent(in)  :: cth, sth, mfac
    real(DP), dimension(0:1,0:lmax), intent(in)  :: recfac
    real(DP), dimension(    0:lmax), intent(in)  :: lam_fact
    real(DP), dimension(1:3,0:lmax), intent(out) :: lam_lm
    !
    real(DP) :: log2val, dlog2lg
    real(DP) :: ovflow, unflow, corfac
    real(DP) :: lam_mm, lam_0, lam_1, lam_2, lam_lm1m
    integer(I4B) :: scalel, l, l_min
    real(DP) :: normal_m, fm2, fl, flm1
    real(DP) :: two_cth, one_on_s2, fm_on_s2, two_on_s2, c_on_s2
    real(DP) :: a_w, a_x, b_w
    !---------------------------------------------------------------

    ! define constants
    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    l_min = l_min_ylm(m, sth)
    dlog2lg = real(LOG2LG, kind=DP)

    fm2       = real(m * m, kind = DP)
    normal_m  = (2.0_dp * m) * (1 - m)
    two_cth   = 2.0_dp * cth
    one_on_s2 = 1.0_dp / (sth * sth)
    fm_on_s2  =      m * one_on_s2
    two_on_s2 = 2.0_dp * one_on_s2
    c_on_s2   = cth    * one_on_s2
    b_w       =  c_on_s2


    ! computes lamba_mm
    log2val = mfac + m*log(sth) * ALN2_INV ! log_2(lam_mm)
    scalel = int (log2val / dlog2lg)
    corfac = rescale_tab(max(scalel,RSMIN))
    lam_mm = 2.0_dp **(log2val - scalel * dlog2lg) ! rescaled lam_mm
    if (IAND(m,1)>0) lam_mm = -lam_mm ! negative for odd m

    lam_lm(1:3,m:lmax) = 0.0_dp
    ! --- l = m ---
    lam_lm(1,m) = corfac * lam_mm !Actual lam_mm

    if (m >= l_min) then ! skip Ymm if too small
       lam_lm(2,m) =  (normal_m * lam_lm(1,m))  * ( 0.5_dp - one_on_s2 )
       lam_lm(3,m) =  (normal_m * lam_lm(1,m))  *            c_on_s2
    endif

    ! --- l > m ---
    lam_0 = 0.0_dp
    lam_1 = 1.0_dp
    lam_2 = cth * lam_1 * recfac(0,m)

    do l = m+1, lmax
       ! do recursion
       lam_lm1m = lam_lm(1,l-1) * lam_fact(l) ! must be incremented even if not used
       lam_lm(1,l) = lam_2 * corfac * lam_mm
       if (l >= l_min) then
          fl = real(l, kind = DP)
          flm1 = fl - 1.0_dp
          a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
          a_x =  two_cth * flm1
          lam_lm(2,l) =                b_w * lam_lm1m - a_w * lam_lm(1,l)
          lam_lm(3,l) = fm_on_s2 * (         lam_lm1m - a_x * lam_lm(1,l))
       endif
       lam_0 = lam_1 * recfac(1,l-1)
       lam_1 = lam_2
       lam_2 = (cth * lam_1 - lam_0) * recfac(0,l)

       ! do dynamic rescaling
       if (abs(lam_2) > ovflow) then
          lam_1 = lam_1*unflow
          lam_2 = lam_2*unflow
          scalel= scalel + 1
          corfac = rescale_tab(max(scalel,RSMIN))
       elseif (abs(lam_2) < unflow .and. abs(lam_2) /= 0.0_dp) then
          lam_1 = lam_1*ovflow
          lam_2 = lam_2*ovflow
          scalel= scalel - 1
          corfac = rescale_tab(max(scalel,RSMIN))
       endif

    enddo ! loop on l
  end subroutine do_lam_lm_pol
  !=======================================================================
  subroutine gen_normpol(l_max, normal_l)
    !=======================================================================
    ! generates normalisaton factors for polarisation basis functions
    ! for all l
    !=======================================================================
    integer(I4B), intent(IN)                       :: l_max
    real(DP),     intent(OUT), dimension(0:l_max)  :: normal_l
    !
    integer(I4B) :: l
    real(DP)     :: fl, xx

    normal_l(0:1) = 0.0_dp
    do l = 2, l_max
       fl = DBLE(l)
       xx = (fl+2.0_dp) * (fl+1.0_dp) * fl * (fl-1.0_dp)
       normal_l(l) = SQRT ( KvS / xx)
       ! either CMBFAST (KvS=1) or Kamionkowski et al. (KvS=2) definition
    enddo

    return
  end subroutine gen_normpol

  !================================================================
  function l_min_ylm(m, sth) result(lmin)
  !================================================================
    ! returns minimal order l at which to keep Ylm
    ! |Ylm| < eps * Y00 ==>
    ! m_cut(theta, l) = theta * l * e / 2 + | ln(eps)| + ln(l)/2
    ! if eps = 1.e-15 and l < 1.e4
    ! m_cut(theta, l) = theta * l * 1.35 + 40
    ! the choice of 1.35 (or larger)
    ! also insures that the equatorial rings will have all their Ylm's computed
    ! default parameters are HPX_MXL0 = 40 and HPX_MXL1 = 1.35_DP
    !======================================================
    ! parameters of short-cut: defined in module header
    ! dummy variables
    integer(I4B)             :: lmin
    integer(I4B), intent(IN) :: m
    real(DP),     intent(IN) :: sth

    lmin = m ! default
    if (HPX_MXL0 > 0) lmin = max(lmin, int((m - HPX_MXL0)/(HPX_MXL1 * sth)))

    return
  end function l_min_ylm
  !=========================================================
  subroutine warning_oldbounds(cos_theta_cut, zbounds)
    !=========================================================
    real(DP), intent(in)                  :: cos_theta_cut
    real(DP), intent(out), dimension(1:2) :: zbounds

    if (cos_theta_cut <= 0.0_dp) then ! no cut
       zbounds(1:2) = 0.0_dp
    else
       zbounds(1) =   cos_theta_cut
       zbounds(2) = - cos_theta_cut
    endif
    print*,' -------------------------------------'
    print*,'WARNING: obsolete interface to MAP2ALM: '
    print*,'    cos_theta_cut (6th argument) currently a DP scalar with value'
    write(*,9000) '    ',cos_theta_cut
    print*,'    should now be replaced with a 2-element vector with values:'
    write(*,9001) '    ',zbounds(1),zbounds(2)
    print*,'    See documentation for details.'
    print*,' -------------------------------------'
9000 format (a,g13.6)
9001 format (a,g13.6,g13.6)

    return
  end subroutine warning_oldbounds

  !**************************************************************************
  !
  !             FOURIER TRANSFORM ON RINGS
  !
  !**************************************************************************
  !=======================================================================
  subroutine ring_synthesis(nsmax,nlmax,nmmax,datain,nph,dataout,kphi0)
    !=======================================================================
    !     RING_SYNTHESIS
    !       called by alm2map
    !       calls     real_fft
    !
    !     dataout(j) = sum_m datain(m) * exp(i*m*phi(j))
    !     with phi(j) = j*2pi/nph + kphi0*pi/nph and kphi0 =0 or 1
    !
    !     as the set of frequencies {m} is larger than nph,
    !     we wrap frequencies within {0..nph-1}
    !     ie  m = k*nph + m' with m' in {0..nph-1}
    !     then
    !     noting bw(m') = exp(i*m'*phi0)
    !                   * sum_k (datain(k*nph+m') exp(i*k*pi*kphi0))
    !        with bw(nph-m') = CONJ(bw(m')) (if datain(-m) = CONJ(datain(m)))
    !     dataout(j) = sum_m' [ bw(m') exp (i*j*m'*2pi/nph) ]
    !                = Fourier Transform of bw
    !        is real
    !
    !         NB nph is not necessarily a power of 2
    !
    !=======================================================================


    INTEGER(I4B), INTENT(IN) :: nsmax, nlmax, nmmax
    INTEGER(I4B), INTENT(IN) :: nph, kphi0
    COMPLEX(DPC), DIMENSION(0:nmmax), INTENT(IN)  :: datain
    REAL(DP),     DIMENSION(0:nph-1), INTENT(OUT) :: dataout

    INTEGER(I4B) :: iw,ksign,m,k,kshift
    COMPLEX(DPC), DIMENSION(0:nph-1) :: bw
    type(planck_fft2_plan) :: plan
    COMPLEX(DPC) :: dat
    real(DP)     :: arg
    !=======================================================================

    ksign = + 1
    kshift = (-1)**kphi0  ! either 1 or -1
    bw(0:nph-1) = CMPLX(0.0_dp, 0.0_dp, KIND=DP)

    !     all frequencies [-m,m] are wrapped in [0,nph-1]
    bw(0)=datain(0)
    do m  = 1, nmmax                        ! in -nmmax, nmmax
       iw = MODULO(m, nph)  ! between 0 and nph-1  = m', F90 intrisic
       k  = (m - iw) / nph                ! number of 'turns'
       bw(iw) = bw(iw) + datain(m)*(kshift**k)  ! complex number
       iw = MODULO(-m, nph)  ! between 0 and nph-1  = m', F90 intrisic
       k  = (-m - iw) / nph                ! number of 'turns'
       bw(iw) = bw(iw) + CONJG(datain(m))*(kshift**k)  ! complex number
    enddo

    !     kshift**k = 1       for even turn numbers
    !               = 1 or -1 for odd  turn numbers : results from the shift in space

    !     applies the shift in position <-> phase factor in Fourier space
    dataout(0)=REAL(bw(0), kind=DP)
    do iw = 1, nph/2-1
       m = ksign*(iw)
       if(kphi0==1) then
          arg = m * PI / dble(nph)
          dat =bw(iw) * CMPLX( DCOS(arg), DSIN(arg), kind=DP)
       else
          dat =bw(iw)
       endif
       dataout(iw*2-1) = REAL(dat, kind=DP)
       dataout(iw*2  ) = AIMAG(dat)
    enddo
    iw=nph/2
    m = ksign*(iw)
    if(kphi0==1) then
       arg = m * PI / dble(nph)
       dat =bw(iw) * CMPLX( DCOS(arg), DSIN(arg), kind=DP)
    else
       dat =bw(iw)
    endif
    dataout(iw*2-1) = REAL(dat, kind=DP)

    call make_fft2_plan(plan,length=nph,direction=fft2_backward)
    call real_fft2 (plan, dataout)
    !     ^^^^^^^^^^^^
    call destroy_fft2_plan (plan)
    RETURN
  END subroutine ring_synthesis

  !=======================================================================
  subroutine ring_analysis(nsmax,nlmax,nmmax,datain,nph,dataout,kphi0)
    !=======================================================================
    !     ring_analysis
    !       called by map2alm
    !       calls     real_fft
    !
    !     integrates (data * phi-dependence-of-Ylm) over phi
    !     --> function of m can be computed by FFT
    !     with  0<= m <= npoints/2 (: Nyquist)
    !     because the data is real the negative m are the conjugate of the
    !     positive ones
    !=======================================================================

    INTEGER(I4B), INTENT(IN) :: nsmax, nlmax, nmmax
    INTEGER(I4B), INTENT(IN) :: nph, kphi0
    REAL(DP),     DIMENSION(0:nph-1), INTENT(IN)  :: datain
    COMPLEX(DPC), DIMENSION(0:nmmax), INTENT(OUT) :: dataout

    INTEGER(I4B) :: i,m,im_max,ksign
!    REAL(DP) :: phi0
    REAL(DP), DIMENSION(0:nph-1) :: data
    type(planck_fft2_plan) :: plan
    real(DP)  :: arg

    !=======================================================================

    ksign = - 1
    data=0.
    data(0:nph-1)=datain(0:nph-1)

    call make_fft2_plan(plan,length=nph,direction=fft2_forward)
    call real_fft2(plan,data)
    call destroy_fft2_plan(plan)

    im_max = MIN(nph/2,nmmax)

    ! m = 0,  i=0
    dataout(0)=CMPLX(data(0),0.0_dp,kind=DP)

    ! 1 <= m <= im_max, --> i=1,2,3,..., im_max
    do i = 1, im_max*2-3, 2
       dataout((i+1)/2) = CMPLX( data(i), data(i+1),kind= DP)
    enddo

    if(im_max==nph/2) then
       dataout(im_max)= CMPLX( data(nph-1),0.0_dp,kind=DP) ! m = Nyquist
    else
       dataout(im_max)= CMPLX( data(2*im_max-1),data(2*im_max),kind=DP)
    endif

    if(im_max==nmmax) goto 1000 ! m_max <= Nyquist

    ! if (m > Nyquist)
    do i =  im_max+1,min(nph,nmmax)
       dataout(i) = conjg(dataout(2*im_max-i) )
    end do

    if(min(nph,nmmax)==nmmax) goto 1000 ! nph > nmmax

    do i =  2*im_max+1,nmmax
       dataout(i) = dataout(mod(i,2*im_max))
    end do

1000 continue

    if(kphi0==1)then
       do i =  0,nmmax
          m = ksign*i
!           dataout(i)=dataout(i)* CONJG(trig(-m,nph/4))
          arg = m * PI / dble(nph)
          dataout(i)=dataout(i)* CMPLX( DCOS(arg), DSIN(arg), kind=DP)
       enddo
    end if

    RETURN
  END subroutine ring_analysis

  !**************************************************************************
  !   ALM2MAP
  !   MAP2ALM
  !   ALM creation and alteration
  !   import overloaded routines
  !**************************************************************************

  ! single precision routines
#include "alm_map_ss_inc.F90"

  ! double precision routines
#include "alm_map_dd_inc.F90"


  !**************************************************************************
  !
  !             PLM GENERATION
  !
  !**************************************************************************
  !========================================================
  subroutine plm_gen(nsmax, nlmax, nmmax, plm)
    !========================================================
    use long_intrinsic, only: long_size

    integer(i4b),             intent(IN) :: nsmax, nlmax, nmmax
    real(dp), dimension(0:,1:), intent(OUT):: plm

    INTEGER(I4B) :: l, m, ith, scalem, scalel, nd2, nrings
    integer(I8B) :: nd1, n_lm, n_plm, i_mm, i_up
    real(DP)            :: lam_mm, lam_lm, lam_0, lam_1, lam_2, corfac, cth_ring
!!    real(DP)                 :: lambda_w, lambda_x
    real(DP)                 :: normal_m, lam_lm1m
    real(DP)                 :: fm2, fl, flm1, fpol
    real(DP)                 :: a_w, b_w, a_x, fm_on_s2, two_on_s2, two_cth_ring
    real(DP)                 :: ovflow, unflow
    real(DP),     dimension(:,:,:), allocatable :: plm_sub
    real(DP),     dimension(:,:), allocatable :: recfac
    real(DP),     dimension(:),   allocatable :: lam_fact
    real(DP),     dimension(:), allocatable :: mfac

    real(DP),     dimension(:),     allocatable :: normal_l
    integer(i4b)        :: nchunks, chunksize, ichunk, lchk, uchk, ithl
    integer(i4b)        :: nph, kphi0, i
    integer(i8b)        :: startpix
    real(DP),     dimension(0:SMAXCHK) :: cth, sth
    real(DP),     dimension(0:SMAXCHK) :: one_on_s2, c_on_s2

    INTEGER(I4B) :: status
    LOGICAL(LGT) :: polarisation
    character(len=*), parameter :: code = 'PLM_GEN'

    !=================================================================

    ! Healpix definitions
    nrings = 2*nsmax           ! number of isolatitude rings on N. hemisphere + equat

    n_lm  = ((nmmax+1)*(2*nlmax-nmmax+2))/2 !number of (l,m) with m in[0,M] and l in [m,L]
    n_plm = n_lm * nrings
    nd1 = long_size(plm, 1)
    nd2 = long_size(plm, 2)

    if (nd1 < n_plm) then
       print*,code//' > Plm array too small:', nd1, n_plm
       stop
    endif
    if (nd2 /= 1 .and. nd2 /= 3) then
       print*,code//' > Plm array should have dimension 1 or 3:',nd2
       stop
    endif
    polarisation = (nd2 == 3)

    !     --- allocates space for arrays ---
    nchunks   = nrings/SMAXCHK + 1  ! number of chunks
    chunksize = (nrings+nchunks-1)/nchunks ! <= SMAXCHK

    allocate(mfac(0:nmmax),stat = status)
    call assert_alloc(status,code,'mfac')
    if (polarisation) then
       allocate(normal_l(0:nlmax),stat = status)
       call assert_alloc(status,code,'normal_l')
    endif

    if (.not. do_openmp()) then
       allocate(recfac(0:1,0:nlmax), plm_sub(1:nd2,0:nlmax,0:chunksize-1), stat = status)
       call assert_alloc(status,code,'recfac & plm_sub')
       if (polarisation) then
          allocate(lam_fact(0:nlmax),stat = status)
          call assert_alloc(status,code,'lam_fact')
       endif
    endif

    !     ------------ initiate variables and arrays ----------------

    call gen_mfac(nmmax, mfac)
    ! generate Polarization normalisation
    if (polarisation) call gen_normpol(nlmax, normal_l)
    call init_rescale()
    ovflow = rescale_tab(1)
    unflow = rescale_tab(-1)
    plm = 0.0_dp

    do ichunk = 0, nchunks-1
       lchk = ichunk * chunksize + 1
       uchk = min(lchk+chunksize - 1, nrings)

       do ith = lchk, uchk
          ithl = ith - lchk !local index
          ! get pixel location information
          call get_pixel_layout(nsmax, ith, cth(ithl), sth(ithl), nph, startpix, kphi0)
          one_on_s2(ithl) =    1.0_dp / sth(ithl)**2
            c_on_s2(ithl) = cth(ithl) / sth(ithl)**2
       enddo

!$OMP parallel default(none) &
!$OMP shared(nlmax, nmmax, lchk, uchk, nd2, chunksize, n_lm, &
!$OMP    rescale_tab, ovflow, unflow, polarisation, &
!$OMP    plm, cth, sth, mfac, normal_l, one_on_s2, c_on_s2) &
!$OMP private(plm_sub, recfac, lam_fact, status, &
!$OMP   m, fm2, normal_m, ithl, ith, i_mm, i_up, &
!$OMP   scalem, scalel, corfac, fpol, &
!$OMP   lam_mm, lam_lm, lam_lm1m, lam_0, lam_1, lam_2, &
!$OMP   cth_ring, fm_on_s2, two_on_s2, two_cth_ring, a_w, a_x, b_w,  &
!$OMP   l, fl, flm1, i)

       if (do_openmp()) then
          ! allocate thread safe arrays
          allocate(recfac(0:1,0:nlmax), plm_sub(1:nd2,0:nlmax,0:chunksize-1), stat = status)
          call assert_alloc(status,code,'recfac & plm_sub')
          if (polarisation) then
             allocate(lam_fact(0:nlmax),stat = status)
             call assert_alloc(status,code,'lam_fact')
          endif
       endif

!$OMP do schedule(dynamic,1)
       do m = 0, nmmax
          ! generate recursion factors (recfac) for Ylm of degree m
          call gen_recfac(nlmax, m, recfac)
          if (polarisation) then
             ! generate Ylm relation factor for degree m
             call gen_lamfac(nlmax, m, lam_fact)
             fm2 = real(m * m, kind = DP)
             normal_m = (2.0_dp * m) * (1 - m)
          endif

          do ithl = 0, uchk - lchk
             ! determine lam_mm
             call compute_lam_mm(mfac(m), m, sth(ithl), lam_mm, corfac, scalem)
             ! ---------- l = m ----------
             !           temperature
             lam_lm = corfac * lam_mm !Actual lam_mm
             plm_sub(1, m, ithl) = lam_lm

             lam_0 = 0.0_dp
             lam_1 = 1.0_dp
             scalel=0
             cth_ring = cth(ithl)
             lam_2 = cth_ring * lam_1 * recfac(0,m)

             if (polarisation) then
                fpol = normal_m * normal_l(m) * lam_lm
                plm_sub(2, m, ithl) =  fpol * ( 0.5_dp - one_on_s2(ithl) )
                plm_sub(3, m, ithl) =  fpol *              c_on_s2(ithl)
                !
                fm_on_s2     =      m * one_on_s2(ithl)
                two_on_s2    = 2.0_dp * one_on_s2(ithl)
                two_cth_ring = 2.0_dp * cth_ring
                b_w          =  c_on_s2(ithl)
             endif
             ! ---------- l > m ----------
             do l = m+1, nlmax
                if (polarisation) lam_lm1m = lam_lm * lam_fact(l)
                lam_lm = lam_2 * corfac * lam_mm
                plm_sub(1, l, ithl) = lam_lm

                if (polarisation) then
                   fl = real(l, kind = DP)
                   flm1 = fl - 1.0_dp
                   a_w =  two_on_s2 * (fl - fm2)  + flm1 * fl
                   a_x =  two_cth_ring * flm1
                   plm_sub(2, l, ithl) =            (   b_w * lam_lm1m - a_w * lam_lm) * normal_l(l)
                   plm_sub(3, l, ithl) = fm_on_s2 * (         lam_lm1m - a_x * lam_lm) * normal_l(l)
                endif

                lam_0 = lam_1 * recfac(1,l-1)
                lam_1 = lam_2
                lam_2 = (cth_ring * lam_1 - lam_0) * recfac(0,l)
                if (abs(lam_2) > OVFLOW) then
                   lam_1 = lam_1*UNFLOW
                   lam_2 = lam_2*UNFLOW
                   scalel= scalel + 1
                   corfac = rescale_tab(max(scalel+scalem,RSMIN))
                elseif (abs(lam_2) < UNFLOW) then
                   lam_1 = lam_1*OVFLOW
                   lam_2 = lam_2*OVFLOW
                   scalel= scalel - 1
                   corfac = rescale_tab(max(scalel+scalem,RSMIN))
                endif
             enddo ! loop on l
          enddo ! loop on rings (ithl)

          ! do memory skipping operations outside inner loops
          do ith = lchk, uchk
             i_mm = n_lm * (ith-1) + ((2*nlmax+3-m)*m)/2 ! location of Ym,m for ring ith
             i_up = i_mm + nlmax - m ! location of Ynlmax,m for ring ith
             ithl = ith - lchk
             do i=1, nd2
                plm(i_mm:i_up, i) = plm_sub(i, m:nlmax, ithl)
             enddo
          enddo
!!!!!!!!
!           i_mm = n_lm*chunksize*ichunk + ((2*nlmax+3-m)*m)/2
!           do ithl = 0, uchk-lchk
!              i_up = i_mm+(nlmax-m+1)*ithl
!           do i=1,nd2
!              plm(i_up:i_up+nlmax-m,i) = plm_sub(i, m:nlmax, ithl)
!           enddo
!           enddo
          !------------------------------------------------
       enddo ! loop on m
!$OMP end do
       if (do_openmp()) then
          deallocate (recfac, plm_sub)
          if (polarisation) deallocate(lam_fact)
       endif
!$OMP end parallel


    enddo    ! loop on chunks

    !     --------------------
    !     free memory and exit
    !     --------------------
    if (.not. do_openmp()) then
       deallocate (recfac, plm_sub)
       if (polarisation) deallocate(lam_fact)
    endif
    deallocate(mfac)
    if (polarisation) deallocate(normal_l)

    return
  end subroutine plm_gen
  !**************************************************************************
  !
  !             M I S C
  !
  !**************************************************************************
  !=======================================================================
  subroutine pow2alm_units(units_pow, units_alm)
    !=======================================================================
    ! does the unit conversion between power and alm (and map)
    !=======================================================================
    character(len=*), dimension(1:), intent(in)  :: units_pow
    character(len=*), dimension(1:), intent(out) :: units_alm

    integer(kind=i4b) :: i, nu, j, ntemplate, idx
    character(len=80) :: uu, ui, uo
    character(len=5),dimension(1:7) :: template = &
         & (/ "_SQUA","-SQUA","SQUA ","^2   ","^ 2  ","**2  ","** 2 " /)
    !=======================================================================
    nu = min( size(units_pow), size(units_alm))
    ntemplate = size(template)

    units_alm = ""
    do i = 1, nu
       ui = adjustl(units_pow(i))
       uu = trim(strupcase(ui))
       uo = "unknown" ! default
       do j = 1, ntemplate
          idx = index(uu, template(j))
          if (idx > 0) then
             uo = ui(1:idx-1)
             exit
          endif
       enddo
       units_alm(i) = uo
       !         print*,i,trim(units_pow(i))," -> ",trim(units_alm(i))
    enddo

    return
  end subroutine pow2alm_units
  !****************************************************************************
  subroutine generate_beam(fwhm_arcmin, lmax, gb, beam_file)
    !==========================================================================
    !
    ! generate_beam(fwhm_arcmin, lmax, gb [, beam_file])
    ! generate the beam window function gb up to lmax
    !  either a gaussian of FHWM : fwhm_arcmin (in arcmin)
    !  or the function read from beam_file
    !
    ! July 2003, EH : replicate temperature beam for polarization when reading
    !  standard ASCII file
    ! Sep 2014, EH: accept ASCII files with 1,2 or 3 columns (on top of multipoles)
    !    read all requested columns from FITS file
    !  FITSIO extended file syntax (eg file.fits[col 1]) must be used to select row(s)
    ! missing columns will be copied from existing ones
    !==========================================================================
    use fitstools, only : getsize_fits, fits2cl
    real(kind=DP),                   intent(in)  :: fwhm_arcmin
    real(kind=DP), dimension(0:,1:), intent(out) :: gb
    integer(kind=I4B),               intent(in)  :: lmax
    character(len=*),      optional, intent(in)  :: beam_file

    character(len=FILENAMELEN) :: new_beam_file
    logical(kind=lgt) :: extfile, found_unix
    integer(kind=i4b) :: type, nl, nd, lunit, il, i, l100, iline, junk, nc
    character(len=80), dimension(1:180) :: header
    character(len=1600) :: str
    character(len=80) :: card
    real(dp) :: bref
    real(dp), dimension(1:3) :: buffer
    character(len=*), parameter :: code = 'generate_beam'
    !==========================================================================
    ! test if name of external is given and valid
    extfile = .false.
    if (present(beam_file)) then
       extfile = (trim(beam_file) /= "")
    endif

    lunit = 15
    nl = size(gb, 1)
    nd = size(gb, 2)
    gb = 0.0_dp

    if (nl <= lmax) then
       print 9000,' Generate_beam: beam array only available up to ',nl
    endif
    nl = min(nl, lmax+1)

    if (extfile) then
       call assert_present(beam_file)
       new_beam_file = beam_file
       print 9000,' Reading beam information from '//trim(new_beam_file)

       ! find out file nature
       type = 1 ! FITS by default
       inquire(file=new_beam_file, exist=found_unix)
       if (found_unix) then
          open(unit=lunit,file=new_beam_file,status='old', &
               &          form='formatted',action='read')
          read(lunit,'(a)') card
          close(lunit)
          card = adjustl(card)
          if (card(1:8) /= 'SIMPLE  ' .AND. card(1:8) /= 'XTENSION') type = -1
       endif

       ! read file according to its type
       if (type < 0) then
          ! ordinary ascii file ?
          lunit = 32
          iline = 0 ! line index
          open(unit=lunit,file=new_beam_file,status='old', &
               &          form='formatted',action='read')
          do
             iline = iline+1
             read(lunit,'(a)', end=100, err=100) str
             if (len_trim(str)>0 .and. str(1:1) /= '#') then
                buffer = 0_dp

                ! try 3 columns
3               continue
                read(str,*, err=2, end=2) il, buffer(1:3)
                nc = 3
                goto 99

                ! try 2 columns
2               continue
                read(str,*, err=1, end=1) il, buffer(1:2)
                nc = 2
                goto 99

                ! try 1 column
1               continue
                read(str,*, err=666, end=666) il, buffer(1)
                nc = 1
                goto 99

                ! failure
666             continue
                print 9000, 'ERROR in '//code
                print 9000, 'Unable to parse ASCII file '//trim(new_beam_file)
                print 9000, 'at line '//trim(adjustl(string(iline)))//' containing'
                print 9000, trim(str)
                print 9000, 'Expected format :'
                print 9000, ' Multipole,  column_1 [, column_2, column_3]'
                print 9000, ' with OPTIONAL colum_2 and column_3'
                call fatal_error

                ! record data, keep going until end of file
99              continue
                gb(il, 1:nd) = buffer(1:nd)
                if (il == nl-1) exit
             endif
          enddo
100       continue
          close(lunit)
          if (il < (nl-1)) then
             print 9001,' WARNING: Beam transfer function only available up to l= ',il !
             print 9000,'          The larger multipoles will be set to 0'
          endif


       else if (type == 1) then
          ! FITS file with ascii or binary table
          call fits2cl(new_beam_file, gb, nl-1_i4b, nd, header, fmissval=0.0_dp)
          junk = getsize_fits(new_beam_file, nmaps=nc)
       else
          print 9000,' the file '//trim(new_beam_file) &
               &            //' is of unknown type.'
          call fatal_error
       endif

       ! if Grad absent, replicate Temperature; if Curl absent, replicate Grad
       if (nc < nd) then
          print 9000,'Not enough columns found in '//trim(new_beam_file)
          print 9000,'Expected '//trim(adjustl(string(nd)))&
               //', found '//trim(adjustl(string(nc)))
          do i=nc+1, nd
             print 9000,' column #'//trim(adjustl(string(i))) &
                  &                //' empty, fill in with column #' &
                  &                //trim(adjustl(string(i-1)))
             gb(:,i) = gb(:,i-1)
          enddo
       else
          print 9000,'Read '//trim(adjustl(string(nd)))&
               //' columns from '//trim(new_beam_file)
          print 9000,'(out of '//trim(adjustl(string(nc)))//')'
       endif

!        ! if Grad absent, replicate Temperature; if Curl absent, replicate Grad
!        l100 = min(100, nl-1)
!        bref = 1.e-4*sum(abs(gb(0:l100,1)))
!        do i=2,nd
!           if ( sum(abs(gb(0:l100,i))) <  bref ) then
!              print 9002,' column #',i,' empty, fill in with column #',i-1
!              gb(:,i) = gb(:,i-1)
!           endif
!        enddo

    else
       ! gaussian beam
       print*,'Generating gaussian beam of FHWM [arcmin] = ',fwhm_arcmin
       call gaussbeam(fwhm_arcmin, nl-1, gb)
    endif

9000 format(a)
9001 format(a,i6)
9002 format(a,i3,a,i3)

    return
  end subroutine generate_beam
  !*************************************************************
  subroutine gaussbeam(fwhm_arcmin, lmax, gb)
    !===========================================================
    ! gaussbeam(fwhm_arcmin, gb)
    !   returns in gb the window function on [0,lmax] corresponding
    !   to the gaussian beam of FWHM = fwhm_arcmin
    ! The returned beam function has up to 3 components,
    ! gb(*,1) = bt                  : temperature
    ! gb(*,2) = bt * exp(2*sigma^2) : grad
    ! gb(*,3) = bt * exp(2*sigma^2) : curl
    ! with sigma = gaussian rms in radian
    ! and bt = exp( l(l+1) * sigma^2 / 2)
    !===========================================================
    real(kind=DP),                   intent(in)  :: fwhm_arcmin
    real(kind=DP), dimension(0:,1:), intent(out) :: gb
    integer(kind=I4B),               intent(in)  :: lmax

    integer(kind=I4B) :: l, nd
    real(kind=DP)     :: sigma, arcmin2rad, sigma2fwhm, fact_pol
    !===========================================================

    call assert (fwhm_arcmin>=0.0_dp,'fwhm of gaussian beam should be positive')

    nd   = size(gb,2)

    arcmin2rad = PI / (180.0_dp * 60.0_dp)
    sigma2fwhm = sqrt(8.0_dp * log(2.0_dp))

    sigma    = fwhm_arcmin * arcmin2rad / sigma2fwhm ! in radians

    fact_pol = exp(2.0_dp*sigma**2) ! correction for polarised fields

    ! temperature
    do l=0,lmax
       gb(l,1) = exp(-.5_dp * l*(l+1.0_dp) * sigma**2)
    enddo
    ! electric or gradient
    if (nd > 1) gb(0:lmax,2) = gb(0:lmax,1) * fact_pol
    ! magnetic or curl
    if (nd > 2) gb(0:lmax,3) = gb(0:lmax,1) * fact_pol

    return
  end subroutine gaussbeam

  !=======================================================================
  subroutine pixel_window(pixlw, nside, windowfile)
    !=======================================================================
    !=======================================================================

    use fitstools, only : getsize_fits, read_bintab
    use extension, only : getEnvironment
    use pix_tools, only : nside2npix
    use paramfile_io, only: get_healpix_data_dir, scan_directories, &
         & get_healpix_pixel_window_file

    real(DP),     dimension(0:,1:), intent(OUT)          :: pixlw
    character(len=*),             intent(IN), optional :: windowfile
    integer(i4b),                 intent(IN), optional :: nside

    character(len=filenamelen) :: wfile, wfile_def, healpixdatadir
    character(len=4) :: sstr
    integer(I4B) :: npw_file, ncolw_file
    integer(I8B) :: npix
    integer(I4B) :: npw, ncolw, i
    logical(LGT) :: good, bad
    REAL(DP) ::  nullval
    character(len=*), parameter :: code = 'Pixel_Window > '
    real(DP),     dimension(:,:), allocatable :: pixtmp
    !=======================================================================

    call assert (present(nside) .or. present(windowfile), &
      code//'Nside or windowfile have to be present')

    npw   = size(pixlw, dim=1)
    ncolw = size(pixlw, dim=2)

    if (present(windowfile)) then
       wfile = trim(windowfile)
       inquire(file=wfile, exist = good)
    else
       if (nside == 0) then
          pixlw = 1.0_dp
          return
       endif
       npix = nside2npix(nside)
       if (npix < 0) then
          print*,code//'invalid Nside = ',nside
          call fatal_error
       endif
       healpixdatadir = get_healpix_data_dir()
       wfile_def = get_healpix_pixel_window_file(nside)
       good = scan_directories(healpixdatadir, wfile_def, wfile)
    endif
    if (.not.good) then
       print*,code//trim(wfile)//' not found'
       call fatal_error
    endif
10  continue

    npw_file = getsize_fits(wfile, nmaps = ncolw_file)
    if (ncolw_file > 3) then
       print*,code//' Too many columns in '//trim(wfile)
       call fatal_error
    endif
    ! allocate tmp array large enough to read the whole file
    allocate(pixtmp(0:npw_file-1, 1:ncolw_file))

    if (npw_file < npw) then
       print*,'Only ',npw_file,' multipoles available in '//trim(wfile)//', expected ',npw
    endif

!     call read_dbintab(windowfile, pixlw, npw, ncolw_file, nullval, bad)
!     edited 2004-05-28
!     call read_dbintab(wfile, pixlw, npw, ncolw_file, nullval, bad)

!    call read_dbintab(wfile, pixtmp, npw_file, ncolw_file, nullval, bad)
    call read_bintab(wfile, pixtmp, npw_file, ncolw_file, nullval, bad)

    npw = min(npw_file, npw)
    ncolw_file = min(ncolw_file, ncolw)

    do i=1, ncolw_file
       pixlw(0:npw-1, i) = pixtmp(0:npw-1, i)
    enddo
    if (ncolw_file == 1) then       ! T only in file
       if (ncolw > 1) pixlw(:,2)  = pixlw(:,1) ! w_G = w_T
       if (ncolw > 2) pixlw(:,3)  = pixlw(:,1) ! w_C = w_T
    else if (ncolw_file == 2) then  ! T and G in file
       if (ncolw > 2) pixlw(:,3)  = pixlw(:,2) ! w_C = w_G
    endif

    deallocate(pixtmp)

    return
  end subroutine pixel_window


!***********************************************************************************

end module alm_tools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!--------------------------------------------------------------
!
! generic body of the subroutines convert_nest2ring_*_nd 
! to be inserted as is in pix_tools.f90
!    edited 2009-04-03 to accept Nside>8192
!--------------------------------------------------------------
    !=======================================================================
    !     makes the conversion NEST to RING
    !=======================================================================
    integer(kind=I4B), intent(in) :: nside
    integer(kind=I4B) :: nd, j
    integer(kind=I4B) :: ipn4, ipr4
    integer(kind=I8B) :: ipn8, ipr8, npix
    integer(kind=I4B),  dimension(:), allocatable :: mapping4
    integer(kind=I8B),  dimension(:), allocatable :: mapping8
    !=======================================================================

    npix = nside2npix(nside)
    call assert (npix>0,       code//": invalid Nside")

    nd = size(map,2)

    ! case where 2nd dimension=1
    if (nd == 1) then
       map1 => map(0:npix-1,1)
       call convert_nest2ring(nside, map1)
       return
    endif

    allocate(map_tmp(0:npix-1))

    if (nside <= ns_max4) then
       allocate(mapping4(0:npix-1))

    ! do N->R mapping only once
!$OMP parallel default(none) &
!$OMP   shared(mapping4, npix, nside) private(ipr4, ipn4)
!$OMP do schedule(dynamic,64)
       do ipn4 = 0_i4b, npix-1
          call nest2ring(nside, ipn4, ipr4)
          mapping4(ipn4) = ipr4
       enddo
!$OMP end do
!$OMP end parallel

       ! convert maps one by one
       do j = 1, nd
          do ipn4 = 0_i4b, npix-1
             map_tmp(mapping4(ipn4)) = map(ipn4,j)
          enddo
          map(0:npix-1, j) = map_tmp(0:npix-1)
       enddo

       deallocate(mapping4)

    else

       allocate(mapping8(0:npix-1))

    ! do N->R mapping only once
!$OMP parallel default(none) &
!$OMP   shared(mapping8, npix, nside) private(ipr8, ipn8)
!$OMP do schedule(dynamic,64)
       do ipn8 = 0_i8b, npix-1
          call nest2ring(nside, ipn8, ipr8)
          mapping8(ipn8) = ipr8
       enddo
!$OMP end do
!$OMP end parallel

       ! convert maps one by one
       do j = 1, nd
          do ipn8 = 0_i8b, npix-1
             map_tmp(mapping8(ipn8)) = map(ipn8,j)
          enddo
          map(0:npix-1, j) = map_tmp(0:npix-1)
       enddo

       deallocate(mapping8)

    endif

    deallocate(map_tmp)

    return

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module num_rec
  use healpix_types
  use misc_utils
  implicit none

  integer(i4b), parameter :: IZERO = 0_i4b, IONE = 1_i4b, ITWO = 2_i4b
  private


#ifndef NO64BITS
  interface isort
     module procedure isort, isort_8
  end interface
  interface iindexx
     module procedure iindexx, iindexx_8
  end interface
  interface sort
     module procedure sort, sort_8
  end interface
  interface indexx
     module procedure indexx, indexx_8
  end interface
#endif
  public :: dsvbksb, dsvdcmp, isort, sort, iindexx, indexx, othpl, pythag


contains
! f pythag
! s SVD
! s IPSORT
! s IPSORT_8
! S XPSORT
! s OTHPL
! s dsvbksb
! s dsvdcmp
! s isort
! s isort_8
! s sort
! S iindexx
! s iindexx_8
! S indexx
!
! The routines PYTHAG, SVD and IPSORT were taken from SLATEC:
! http://www.netlib.org/slatec/src/<routine>.f
! The SLATEC routines are in the public domain.
!
! Changes by MR:
!  - processed with f2f90 sed script
!  - replaced REAL with REAL(DP)
!  - replaced xx.0E0 with xx.0_DP
!  - rewrote some loops to avoid shared CONTINUE statements and loop end
!    statements which are not CONTINUE
!  - removed calls to XERMSG; the error code is checked in the calling routine
!
! Changes by EH:
!  psort has been edited from slatec's IPSORT
!   IX --> XX
!   ITEMP --> XTEMP
! Jan 2008: replaced integer by integer(I4B)
!           0, 1, 2 -> IZERO, IONE, ITWO
!           int(x)  -> int(x, kind=i4b)
! Mar 2017: PYTHAG: made public, replaced xx.0 with xx.0_dp
!
! The routine OTHPL was taken from:
!   S. Zhang & J. Jin "Computation of Special Functions" (Wiley, 1996).
!    http://jin.ece.uiuc.edu/routines/routines.html
! editions by EH:
! replaced implicit declaration by explicit ones,
! added intent of dummy arguments
! added tests (n>0)
! -----------------------------------------------------------
!
!DECK PYTHAG
      FUNCTION PYTHAG (A, B) result(pyth)
!***BEGIN PROLOGUE  PYTHAG
!***SUBSIDIARY
!***PURPOSE  Compute the complex square root of a complex number without
!            destructive overflow or underflow.
!***LIBRARY   SLATEC
!***AUTHOR  (UNKNOWN)
!***DESCRIPTION
!
!     Finds sqrt(A**2+B**2) without overflow or destructive underflow
!
!***SEE ALSO  EISDOC
!***ROUTINES CALLED  (NONE)
!***REVISION HISTORY  (YYMMDD)
!   811101  DATE WRITTEN
!   890531  Changed all specific intrinsics to generic.  (WRB)
!   891214  Prologue converted to Version 4.0 format.  (BAB)
!   900402  Added TYPE section.  (WRB)
!***END PROLOGUE  PYTHAG
      REAL(DP):: PYTH
      REAL(DP), intent(IN):: A,B
!
      REAL(DP):: P,Q,R,S,T
!***FIRST EXECUTABLE STATEMENT  PYTHAG
      P = MAX(ABS(A),ABS(B))
      Q = MIN(ABS(A),ABS(B))
      IF (Q .EQ. 0.0_dp) GO TO 20
   10 CONTINUE
         R = (Q/P)**ITWO
         T = 4.0_dp + R
         IF (T .EQ. 4.0_dp) GO TO 20
         S = R/T
         P = P + 2.0_dp*P*S
         Q = Q*S
      GO TO 10
   20 PYTH = P
      RETURN
      END FUNCTION PYTHAG

!DECK SVD
      SUBROUTINE SVD (NM, M, N, A, W, MATU, U, MATV, V, IERR, RV1)
!***BEGIN PROLOGUE  SVD
!***SUBSIDIARY
!***PURPOSE  Perform the singular value decomposition of a rectangular
!            matrix.
!***LIBRARY   SLATEC
!***TYPE      SINGLE PRECISION (SVD-S)
!***AUTHOR  (UNKNOWN)
!***DESCRIPTION
!
!     This subroutine is a translation of the ALGOL procedure SVD,
!     NUM. MATH. 14, 403-420(1970) by Golub and Reinsch.
!     HANDBOOK FOR AUTO. COMP., VOL II-LINEAR ALGEBRA, 134-151(1971).
!
!     This subroutine determines the singular value decomposition
!          T
!     A=USV  of a REAL M by N rectangular matrix.  Householder
!     bidiagonalization and a variant of the QR algorithm are used.
!
!     On Input
!
!        NM must be set to the row dimension of the two-dimensional
!          array parameters, A, U and V, as declared in the calling
!          program dimension statement.  NM is an INTEGER variable.
!          Note that NM must be at least as large as the maximum
!          of M and N.
!
!        M is the number of rows of A and U.
!
!        N is the number of columns of A and U and the order of V.
!
!        A contains the rectangular input matrix to be decomposed.  A is
!          a two-dimensional REAL array, dimensioned A(NM,N).
!
!        MATU should be set to .TRUE. if the U matrix in the
!          decomposition is desired, and to .FALSE. otherwise.
!          MATU is a LOGICAL variable.
!
!        MATV should be set to .TRUE. if the V matrix in the
!          decomposition is desired, and to .FALSE. otherwise.
!          MATV is a LOGICAL variable.
!
!     On Output
!
!        A is unaltered (unless overwritten by U or V).
!
!        W contains the N (non-negative) singular values of A (the
!          diagonal elements of S).  They are unordered.  If an
!          error exit is made, the singular values should be correct
!          for indices IERR+1, IERR+2, ..., N.  W is a one-dimensional
!          REAL array, dimensioned W(N).
!
!        U contains the matrix U (orthogonal column vectors) of the
!          decomposition if MATU has been set to .TRUE.  Otherwise,
!          U is used as a temporary array.  U may coincide with A.
!          If an error exit is made, the columns of U corresponding
!          to indices of correct singular values should be correct.
!          U is a two-dimensional REAL array, dimensioned U(NM,N).
!
!        V contains the matrix V (orthogonal) of the decomposition if
!          MATV has been set to .TRUE.  Otherwise, V is not referenced.
!          V may also coincide with A if U does not.  If an error
!          exit is made, the columns of V corresponding to indices of
!          correct singular values should be correct.  V is a two-
!          dimensional REAL array, dimensioned V(NM,N).
!
!        IERR is an INTEGER flag set to
!          Zero       for normal return,
!          K          if the K-th singular value has not been
!                     determined after 30 iterations.
!
!        RV1 is a one-dimensional REAL array used for temporary storage,
!          dimensioned RV1(N).
!
!     CALLS PYTHAG(A,B) for sqrt(A**2 + B**2).
!
!     Questions and comments should be directed to B. S. Garbow,
!     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
!     ------------------------------------------------------------------
!
!***SEE ALSO  EISDOC
!***ROUTINES CALLED  PYTHAG
!***REVISION HISTORY  (YYMMDD)
!   811101  DATE WRITTEN
!   890531  Changed all specific intrinsics to generic.  (WRB)
!   890831  Modified array declarations.  (WRB)
!   891214  Prologue converted to Version 4.0 format.  (BAB)
!   900402  Added TYPE section.  (WRB)
!***END PROLOGUE  SVD
!
      INTEGER(I4B) :: I,J,K,L,M,N,II,I1,KK,K1,LL,L1,MN,NM,ITS,IERR
      REAL(DP) A(NM,*),W(*),U(NM,*),V(NM,*),RV1(*)
      REAL(DP) C,F,G,H,S,X,Y,Z,SCALE,S1
!      REAL(DP) PYTHAG
      LOGICAL MATU,MATV
!
!***FIRST EXECUTABLE STATEMENT  SVD
      IERR = 0
!
      DO I = IONE, M
!
         DO J = IONE, N
            U(I,J) = A(I,J)
         END DO
      END DO
!     .......... HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM ..........
      G = 0.0_DP
      SCALE = 0.0_DP
      S1 = 0.0_DP
!
      DO 300 I = IONE, N
         L = I + IONE
         RV1(I) = SCALE * G
         G = 0.0_DP
         S = 0.0_DP
         SCALE = 0.0_DP
         IF (I .GT. M) GO TO 210
!
         DO K = I, M
           SCALE = SCALE + ABS(U(K,I))
         END DO
!
         IF (SCALE .EQ. 0.0_DP) GO TO 210
!
         DO 130 K = I, M
            U(K,I) = U(K,I) / SCALE
            S = S + U(K,I)**2
  130    CONTINUE
!
         F = U(I,I)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,I) = F - G
         IF (I .EQ. N) GO TO 190
!
         DO 150 J = L, N
            S = 0.0_DP
!
            DO K = I, M
              S = S + U(K,I) * U(K,J)
            END DO
!
            F = S / H
!
            DO K = I, M
              U(K,J) = U(K,J) + F * U(K,I)
            END DO
  150    CONTINUE
!
  190    DO K = I, M
           U(K,I) = SCALE * U(K,I)
         END DO
!
  210    W(I) = SCALE * G
         G = 0.0_DP
         S = 0.0_DP
         SCALE = 0.0_DP
         IF (I .GT. M .OR. I .EQ. N) GO TO 290
!
         DO K = L, N
           SCALE = SCALE + ABS(U(I,K))
         END DO
!
         IF (SCALE .EQ. 0.0_DP) GO TO 290
!
         DO 230 K = L, N
            U(I,K) = U(I,K) / SCALE
            S = S + U(I,K)**2
  230    CONTINUE
!
         F = U(I,L)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,L) = F - G
!
         DO K = L, N
           RV1(K) = U(I,K) / H
         END DO
!
         IF (I .EQ. M) GO TO 270
!
         DO 260 J = L, M
            S = 0.0_DP
!
            DO K = L, N
              S = S + U(J,K) * U(I,K)
            END DO
!
            DO K = L, N
               U(J,K) = U(J,K) + S * RV1(K)
            END DO
  260    CONTINUE
!
  270    DO K = L, N
           U(I,K) = SCALE * U(I,K)
         END DO
!
  290    S1 = MAX(S1,ABS(W(I))+ABS(RV1(I)))
  300 CONTINUE
!     .......... ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS ..........
      IF (.NOT. MATV) GO TO 410
!     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 400 II = IONE, N
         I = N + IONE - II
         IF (I .EQ. N) GO TO 390
         IF (G .EQ. 0.0_DP) GO TO 360
!
         DO J = L, N
!     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
           V(J,I) = (U(I,J) / U(I,L)) / G
         END DO
!
         DO 350 J = L, N
            S = 0.0_DP
!
            DO K = L, N
              S = S + U(I,K) * V(K,J)
            END DO
!
            DO K = L, N
               V(K,J) = V(K,J) + S * V(K,I)
            END DO
  350    CONTINUE
!
  360    DO 380 J = L, N
            V(I,J) = 0.0_DP
            V(J,I) = 0.0_DP
  380    CONTINUE
!
  390    V(I,I) = 1.0_DP
         G = RV1(I)
         L = I
  400 CONTINUE
!     .......... ACCUMULATION OF LEFT-HAND TRANSFORMATIONS ..........
  410 IF (.NOT. MATU) GO TO 510
!     ..........FOR I=MIN(M,N) STEP -1 UNTIL 1 DO -- ..........
      MN = N
      IF (M .LT. N) MN = M
!
      DO 500 II = IONE, MN
         I = MN + IONE - II
         L = I + IONE
         G = W(I)
         IF (I .EQ. N) GO TO 430
!
         DO J = L, N
           U(I,J) = 0.0_DP
         END DO
!
  430    IF (G .EQ. 0.0_DP) GO TO 475
         IF (I .EQ. MN) GO TO 460
!
         DO 450 J = L, N
            S = 0.0_DP
!
            DO K = L, M
              S = S + U(K,I) * U(K,J)
            END DO
!     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            F = (S / U(I,I)) / G
!
            DO K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
            END DO
  450    CONTINUE
!
  460    DO J = I, M
           U(J,I) = U(J,I) / G
         END DO
!
         GO TO 490
!
  475    DO J = I, M
           U(J,I) = 0.0_DP
         END DO
!
  490    U(I,I) = U(I,I) + 1.0_DP
  500 CONTINUE
!     .......... DIAGONALIZATION OF THE BIDIAGONAL FORM ..........
  510 CONTINUE
!     .......... FOR K=N STEP -1 UNTIL 1 DO -- ..........
      DO 700 KK = IONE, N
         K1 = N - KK
         K = K1 + IONE
         ITS = 0
!     .......... TEST FOR SPLITTING.
!                FOR L=K STEP -1 UNTIL 1 DO -- ..........
  520    DO 530 LL = IONE, K
            L1 = K - LL
            L = L1 + IONE
            IF (S1 + ABS(RV1(L)) .EQ. S1) GO TO 565
!     .......... RV1(1) IS ALWAYS ZERO, SO THERE IS NO EXIT
!                THROUGH THE BOTTOM OF THE LOOP ..........
            IF (S1 + ABS(W(L1)) .EQ. S1) GO TO 540
  530    CONTINUE
!     .......... CANCELLATION OF RV1(L) IF L GREATER THAN 1 ..........
  540    C = 0.0_DP
         S = 1.0_DP
!
         DO 560 I = L, K
            F = S * RV1(I)
            RV1(I) = C * RV1(I)
            IF (S1 + ABS(F) .EQ. S1) GO TO 565
            G = W(I)
            H = PYTHAG(F,G)
            W(I) = H
            C = G / H
            S = -F / H
            IF (.NOT. MATU) GO TO 560
!
            DO 550 J = IONE, M
               Y = U(J,L1)
               Z = U(J,I)
               U(J,L1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  550       CONTINUE
!
  560    CONTINUE
!     .......... TEST FOR CONVERGENCE ..........
  565    Z = W(K)
         IF (L .EQ. K) GO TO 650
!     .......... SHIFT FROM BOTTOM 2 BY 2 MINOR ..........
         IF (ITS .EQ. 30) GO TO 1000
         ITS = ITS + IONE
         X = W(L)
         Y = W(K1)
         G = RV1(K1)
         H = RV1(K)
         F = 0.5_DP * (((G + Z) / H) * ((G - Z) / Y) + Y / H - H / Y)
         G = PYTHAG(F,1.0_DP)
         F = X - (Z / X) * Z + (H / X) * (Y / (F + SIGN(G,F)) - H)
!     .......... NEXT QR TRANSFORMATION ..........
         C = 1.0_DP
         S = 1.0_DP
!
         DO 600 I1 = L, K1
            I = I1 + IONE
            G = RV1(I)
            Y = W(I)
            H = S * G
            G = C * G
            Z = PYTHAG(F,H)
            RV1(I1) = Z
            C = F / Z
            S = H / Z
            F = X * C + G * S
            G = -X * S + G * C
            H = Y * S
            Y = Y * C
            IF (.NOT. MATV) GO TO 575
!
            DO 570 J = IONE, N
               X = V(J,I1)
               Z = V(J,I)
               V(J,I1) = X * C + Z * S
               V(J,I) = -X * S + Z * C
  570       CONTINUE
!
  575       Z = PYTHAG(F,H)
            W(I1) = Z
!     .......... ROTATION CAN BE ARBITRARY IF Z IS ZERO ..........
            IF (Z .EQ. 0.0_DP) GO TO 580
            C = F / Z
            S = H / Z
  580       F = C * G + S * Y
            X = -S * G + C * Y
            IF (.NOT. MATU) GO TO 600
!
            DO 590 J = IONE, M
               Y = U(J,I1)
               Z = U(J,I)
               U(J,I1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  590       CONTINUE
!
  600    CONTINUE
!
         RV1(L) = 0.0_DP
         RV1(K) = F
         W(K) = X
         GO TO 520
!     .......... CONVERGENCE ..........
  650    IF (Z .GE. 0.0_DP) GO TO 700
!     .......... W(K) IS MADE NON-NEGATIVE ..........
         W(K) = -Z
         IF (.NOT. MATV) GO TO 700
!
         DO J = IONE, N
           V(J,K) = -V(J,K)
         END DO
!
  700 CONTINUE
!
      GO TO 1001
!     .......... SET ERROR -- NO CONVERGENCE TO A
!                SINGULAR VALUE AFTER 30 ITERATIONS ..........
 1000 IERR = K
 1001 RETURN
      END SUBROUTINE SVD


!=====================================
!   ipsort   (ix, n, iperm, kflag, ier)
!   ipsort_8 (ix, n, iperm, kflag, ier)
!   xpsort   (ix, n, iperm, kflag, ier)
!   xpsort_8 (ix, n, iperm, kflag, ier)
!
!***PURPOSE  Return the permutation vector generated by sorting a given
!            array and, optionally, rearrange the elements of the array.
!            The array may be sorted in increasing or decreasing order.
!            A slightly modified quicksort algorithm is used.
!***LIBRARY   SLATEC
!***CATEGORY  N6A1A, N6A2A
!***TYPE      INTEGER (SPSORT-S, DPSORT-D, IPSORT-I, HPSORT-H)
!***KEYWORDS  NUMBER SORTING, PASSIVE SORTING, SINGLETON QUICKSORT, SORT
!***AUTHOR  Jones, R. E., (SNLA)
!           Kahaner, D. K., (NBS)
!           Rhoads, G. S., (NBS)
!           Wisniewski, J. A., (SNLA)
!***DESCRIPTION
!
!   IPSORT returns the permutation vector IPERM generated by sorting
!   the array IX and, optionally, rearranges the values in IX.  IX may
!   be sorted in increasing or decreasing order.  A slightly modified
!   quicksort algorithm is used.
!
!   IPERM is such that IX(IPERM(I)) is the Ith value in the
!   rearrangement of IX.  IPERM may be applied to another array by
!   calling IPPERM, SPPERM, DPPERM or HPPERM.
!
!   The main difference between IPSORT and its active sorting equivalent
!   ISORT is that the data are referenced indirectly rather than
!   directly.  Therefore, IPSORT should require approximately twice as
!   long to execute as ISORT.  However, IPSORT is more general.
!
!   Description of Parameters
!      IX - input/output -- integer array of values to be sorted.
!           If ABS(KFLAG) = 2, then the values in IX will be
!           rearranged on output; otherwise, they are unchanged.
!      N  - input -- number of values in array IX to be sorted.
!      IPERM - output -- permutation array such that IPERM(I) is the
!              index of the value in the original order of the
!              IX array that is in the Ith location in the sorted
!              order.
!      KFLAG - input -- control parameter:
!            =  2  means return the permutation vector resulting from
!                  sorting IX in increasing order and sort IX also.
!            =  1  means return the permutation vector resulting from
!                  sorting IX in increasing order and do not sort IX.
!            = -1  means return the permutation vector resulting from
!                  sorting IX in decreasing order and do not sort IX.
!            = -2  means return the permutation vector resulting from
!                  sorting IX in decreasing order and sort IX also.
!      IER - output -- error indicator:
!          =  0  if no error,
!          =  1  if N is zero or negative,
!          =  2  if KFLAG is not 2, 1, -1, or -2.
!***REFERENCES  R. C. Singleton, Algorithm 347, An efficient algorithm
!                 for sorting with minimal storage, Communications of
!                 the ACM, 12, 3 (1969), pp. 185-187.
!***ROUTINES CALLED  XERMSG
!***REVISION HISTORY  (YYMMDD)
!   761101  DATE WRITTEN
!   761118  Modified by John A. Wisniewski to use the Singleton
!           quicksort algorithm.
!   810801  Further modified by David K. Kahaner.
!   870423  Modified by Gregory S. Rhoads for passive sorting with the
!           option for the rearrangement of the original data.
!   890620  Algorithm for rearranging the data vector corrected by R.
!           Boisvert.
!   890622  Prologue upgraded to Version 4.0 style by D. Lozier.
!   891128  Error when KFLAG.LT.0 and N=1 corrected by R. Boisvert.
!   920507  Modified by M. McClain to revise prologue text.
!   920818  Declarations section rebuilt and code restructured to use
!           IF-THEN-ELSE-ENDIF.  (SMR, WRB)
!
! 2009-06-17: uses generic source file :  source_gen_sort_inc.f90
!  the array to sort is now generically gen_xx
!=====================================
      SUBROUTINE IPSORT (gen_xx, N, IPERM, KFLAG, IER)
        ! integer 4 array with less than 2^31 elements to sort
!=====================================
      integer(i4b), parameter :: MKD = I4B
      INTEGER(MKD), intent(in)  :: N
      INTEGER(I4B), intent(in)  :: KFLAG
      INTEGER(I4B), intent(out) :: IER
      INTEGER(MKD),                dimension(1:*) :: gen_xx
      INTEGER(MKD), intent(out),   dimension(1:*) :: IPERM
!     .. Local Scalars ..
      REAL(DP) ::  R
      INTEGER(MKD) :: gen_temp
      INTEGER(MKD) :: I, IJ, INDX, INDX0, ISTRT, J, K, KK, L, LM, LMT, M, NN
!     .. Local Arrays ..
      INTEGER(MKD) :: IL(21), IU(21)

#include "source_gen_sort_inc.f90"

      RETURN
      END SUBROUTINE IPSORT

!=====================================
      SUBROUTINE IPSORT_8 (gen_xx, N, IPERM, KFLAG, IER)
        ! integer 8 array with any number of elements to sort
!=====================================
      integer(i4b), parameter :: MKD = I8B
      INTEGER(MKD), intent(in)  :: N
      INTEGER(I4B), intent(in)  :: KFLAG
      INTEGER(I4B), intent(out) :: IER
      INTEGER(MKD),                dimension(1:*) :: gen_xx
      INTEGER(MKD), intent(out),   dimension(1:*) :: IPERM
!     .. Local Scalars ..
      REAL(DP) ::  R
      INTEGER(MKD) :: gen_temp
      INTEGER(MKD) :: I, IJ, INDX, INDX0, ISTRT, J, K, KK, L, LM, LMT, M, NN
!     .. Local Arrays ..
      INTEGER(MKD) :: IL(21), IU(21)

#include "source_gen_sort_inc.f90"

      RETURN
      END SUBROUTINE IPSORT_8

!=====================================
      SUBROUTINE XPSORT (gen_xx, N, IPERM, KFLAG, IER)
        ! double precision real with less than 2^31 elements to sort
! ========================================================
        integer(i4b), parameter :: MKD = I4B
      INTEGER(MKD), intent(in)  :: N
      INTEGER(I4B), intent(in)  :: KFLAG
      INTEGER(I4B), intent(out) :: IER
      REAL(DP),                    dimension(1:*) :: gen_xx
      INTEGER(MKD), intent(out),   dimension(1:*) :: IPERM
!     .. Local Scalars ..
      REAL(DP) :: R
      real(DP) :: gen_temp
      INTEGER(I4B) :: I, IJ, INDX, INDX0, ISTRT, J, K, KK, L, LM, LMT, M, NN
!     .. Local Arrays ..
      INTEGER(I4B) :: IL(21), IU(21)

#include "source_gen_sort_inc.f90"

      RETURN
    END SUBROUTINE XPSORT
!=========================================

!=====================================
      SUBROUTINE XPSORT_8 (gen_xx, N, IPERM, KFLAG, IER)
        ! double precision real with any number of elements to sort
! ========================================================
      integer(i4b), parameter :: MKD = I8B
      INTEGER(MKD), intent(in)  :: N
      INTEGER(I4B), intent(in)  :: KFLAG
      INTEGER(I4B), intent(out) :: IER
      REAL(DP),                    dimension(1:*) :: gen_xx
      INTEGER(MKD), intent(out),   dimension(1:*) :: IPERM
!     .. Local Scalars ..
      REAL(DP) :: R
      real(DP) :: gen_temp
      INTEGER(I4B) :: I, IJ, INDX, INDX0, ISTRT, J, K, KK, L, LM, LMT, M, NN
!     .. Local Arrays ..
      INTEGER(I4B) :: IL(21), IU(21)

#include "source_gen_sort_inc.f90"

      RETURN
    END SUBROUTINE XPSORT_8
!=========================================


    SUBROUTINE OTHPL(KF,N,X,PL,DPL)
      !
      !       ==========================================================
      !       Purpose: Compute orthogonal polynomials: Tn(x) or Un(x),
      !                or Ln(x) or Hn(x), and their derivatives
      !       Input :  KF --- Function code
      !                       KF=1 for Chebyshev polynomial Tn(x)
      !                       KF=2 for Chebyshev polynomial Un(x)
      !                       KF=3 for Laguerre polynomial Ln(x)
      !                       KF=4 for Hermite polynomial Hn(x)
      !                n ---  Order of orthogonal polynomials
      !                x ---  Argument of orthogonal polynomials
      !       Output:  PL(n) --- Tn(x) or Un(x) or Ln(x) or Hn(x)
      !                DPL(n)--- Tn'(x) or Un'(x) or Ln'(x) or Hn'(x)
      !       =========================================================
      ! copyright: 
      !   S. Zhang & J. Jin "Computation of Special Functions" (Wiley, 1996).
      !    http://jin.ece.uiuc.edu/routines/routines.html
      !--------------------------------------------------------------------------
      use healpix_types
      IMPLICIT none
      integer(i4b), intent(in) :: kf, n
      real(DP), intent(in) :: x
      real(DP), dimension(0:), intent(out) :: pl(0:),dpl(0:)
      !
      real(DP) :: a, b, c, y0, y1, dy0, dy1, yn, dyn
      integer(i4b) :: k

      a = 2.0d0
      b = 0.0d0
      c = 1.0d0
      y0 = 1.0d0
      y1 = 2.0d0*x
      dy0 = 0.0d0
      dy1 = 2.0d0
      pl(0) = 1.0d0
      dpl(0) = 0.0d0
      if (n > 0) then
         pl(1) = 2.0d0*x
         dpl(1) = 2.0d0
      endif
      if (kf == 1) then
         y1 = x
         dy1 = 1.0d0
         if (n > 0) then
            pl(1) = x
            dpl(1) = 1.0d0
         endif
      else if (kf == 3) then
         y1 = 1.0d0-x
         dy1 = -1.0d0
         if (n > 0) then
            pl(1) = 1.0d0-x
            dpl(1) = -1.0d0
         endif
      endif
      do k = 2,n
         if (kf == 3) then
            a = -1.0d0/k
            b = 2.0d0+a
            c = 1.0d0+a
         else if (kf == 4) then
            c = 2.0d0*(k-1.0d0)
         endif
         yn = (a*x+b)*y1-c*y0
         dyn = a*y1+(a*x+b)*dy1-c*dy0
         pl(k) = yn
         dpl(k) = dyn
         y0 = y1
         y1 = yn
         dy0 = dy1
         dy1 = dyn
      enddo
      return

    END SUBROUTINE OTHPL

!=========================================

  subroutine dsvbksb(u,w,v,m,n,mp,np,b,x)
    integer(i4b), intent(in) :: m,mp,n,np
    real(dp), intent(in) ::  b(mp),u(mp,np),v(np,np),w(np)
    real(dp), intent(out) :: x(np)
    integer(i4b) ::  i,j,jj
    real(dp) ::  s,tmp(n)
    do j=IONE,n
       s = 0d0
       if (w(j)/=0d0) then
          do i=IONE,m
             s=s+u(i,j)*b(i)
          end do
          s=s/w(j)
       endif
       tmp(j)=s
    end do
    do j=IONE,n
       s=0.0d0
       do jj=IONE,n
          s=s+v(j,jj)*tmp(jj)
       end do
       x(j)=s
    end do
  end subroutine dsvbksb

  subroutine dsvdcmp(a,m,n,mp,np,w,v)
    integer(i4b), intent(in):: m,mp,n,np
    real(dp), intent(inout) ::  a(mp,np),v(np,np),w(np)
    integer(i4b) :: ierr
    real(dp) rv1(np),u(mp,np)

    call svd(mp,m,n,a,w,.true.,u,.true.,v,ierr,rv1)
    call assert(ierr==0,"error in svd()")
    a=u
  end subroutine dsvdcmp

  subroutine isort(n,ra)
    integer(i4b), intent(in) :: n
    integer(i4b), intent(inout), dimension(1:) :: ra
    integer(i4b) :: indx(n)
    integer(i4b) :: ier
    call ipsort (ra,n,indx,ITWO,ier)
    call assert (ier==IZERO, "error in ipsort()")
  end subroutine isort

  subroutine isort_8(n,ra)
    integer(i8b), intent(in) :: n
    integer(i8b), intent(inout), dimension(1:) :: ra
    integer(i8b) :: indx(n)
    integer(i4b) :: ier
    call ipsort_8(ra,n,indx,ITWO,ier)
    call assert (ier==IZERO, "error in ipsort_8()")
  end subroutine isort_8

  subroutine sort(n,ra)
    integer(i4b), intent(in) :: n
    real(dp), intent(inout), dimension(1:) :: ra
    integer(i4b) :: indx(n)
    integer(i4b) :: ier
    call xpsort (ra,n,indx,ITWO,ier)
    call assert (ier==IZERO, "error in xpsort()")
  end subroutine sort

  subroutine sort_8(n,ra)
    integer(i8b), intent(in) :: n
    real(dp), intent(inout), dimension(1:) :: ra
    integer(i8b) :: indx(n)
    integer(i4b) :: ier
    call xpsort_8(ra,n,indx,ITWO,ier)
    call assert (ier==IZERO, "error in xpsort_8()")
  end subroutine sort_8

  SUBROUTINE iindexx(n,arr,indx)
    INTEGER(I4B),                 intent(IN)  :: n
    INTEGER(I4B), dimension(1:n), intent(IN)  :: arr
    integer(i4b), dimension(1:n), intent(out) :: indx
    integer(i4b) :: ier
    call ipsort (arr,n,indx,IONE,ier)
    call assert (ier==IZERO, "error in ipsort()")
  END SUBROUTINE iindexx

  SUBROUTINE iindexx_8(n,arr,indx)
    INTEGER(I8B),                 intent(IN)  :: n
    INTEGER(I8B), dimension(1:n), intent(IN)  :: arr
    integer(i8b), dimension(1:n), intent(out) :: indx
    integer(i4b) :: ier
    call ipsort_8(arr,n,indx,IONE,ier)
    call assert (ier==IZERO, "error in ipsort_8()")
  END SUBROUTINE iindexx_8

  SUBROUTINE indexx(n,arr,indx)
    INTEGER(I4B),                  intent(IN)  :: n
    real(DP),      dimension(1:n), intent(IN)  :: arr
    integer(i4b),  dimension(1:n), intent(out) :: indx
    integer(i4b) ::  ier
    call xpsort (arr,n,indx,IONE,ier)
    call assert (ier==IZERO, "error in xpsort()")
  END SUBROUTINE indexx

  SUBROUTINE indexx_8(n,arr,indx)
    INTEGER(I8B),                  intent(IN)  :: n
    real(DP),      dimension(1:n), intent(IN)  :: arr
    integer(i8b),  dimension(1:n), intent(out) :: indx
    integer(i4b) ::  ier
    call xpsort_8(arr,n,indx,IONE,ier)
    call assert  (ier==IZERO, "error in xpsort()")
  END SUBROUTINE indexx_8

end module num_rec

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------

module utilities

  ! WARNING :most of the routines initially in the module utilities
  ! have been moved to module obsolete in version 1.2

  public :: die_alloc


contains

  !=======================================================================
  subroutine die_alloc(routine_name,array_name)
    !=======================================================================
    !     write a message and die
    !     to be used if status /= 0 after an allocate
    !=======================================================================
    implicit none
    character(len=*), intent(in) :: routine_name
    character(len=*), intent(in) :: array_name
    !=======================================================================

    print*,routine_name// &
         &     '> can not allocate memory for array : '//array_name
    stop 'program aborted'

    return
  end subroutine die_alloc


end module utilities

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!! This module provides functions that permute bits of the binary
!! representation of a number.
!!
!! @author Benjamin D. Wandelt October 1997
!! edited by E. Hivon, October 2001 to be 'F' compatible
! 2009-06-16: deals with Nside > 8192
module bit_manipulation

use healpix_types
implicit none
private

integer(i4b), parameter :: oddbits=89478485   ! 2^0 + 2^2 + 2^4+..+2^26
integer(i4b), parameter :: evenbits=178956970 ! 2^1 + 2^3 + 2^4+..+2^27

#ifndef NO64BITS
interface swapLSBMSB
   module procedure swapLSBMSB, swapLSBMSB8
end interface
interface invswapLSBMSB
   module procedure invswapLSBMSB, invswapLSBMSB8
end interface
interface invLSB
   module procedure invLSB, invLSB8 
end interface
interface invMSB
   module procedure invMSB, invMSB8
end interface
#endif

public :: swapLSBMSB, invswapLSBMSB, invLSB, invMSB

contains

!! Returns i with even and odd bit positions interchanged.
function swapLSBMSB(i)
  integer(i4b) :: swapLSBMSB
  integer(i4b), intent(in) :: i

  swapLSBMSB = IAND(i,evenbits)/2 + IAND(i,oddbits)*2
end function swapLSBMSB

!! Returns NOT(i) with even and odd bit positions interchanged.
function invswapLSBMSB(i)
  integer(i4b) :: invswapLSBMSB
  integer(i4b), intent(in) :: i

  invswapLSBMSB = NOT(swapLSBMSB(i))
end function invswapLSBMSB

!! Returns i with odd (1,3,5,...) bits inverted.
function invLSB(i)
  integer(i4b) :: invLSB
  integer(i4b), intent(in) :: i

  invLSB = IEOR(i,oddbits)
end function invLSB

!! Returns i with even (0,2,4,...) bits inverted.
function invMSB(i)
  integer(i4b) :: invMSB
  integer(i4b), intent(in) :: i

  invMSB = IEOR(i,evenbits)
end function invMSB

!**********************************************************************
#ifndef NO64BITS
!! Returns i with even and odd bit positions interchanged.
function swapLSBMSB8(i)
  integer(i8b) :: swapLSBMSB8
  integer(i8b), intent(in) :: i
  integer(i8b), parameter :: oddbits8 = 96076792050570581_i8b ! 2^0 + 2^2 + 2^4+..+2^56
  integer(i8b), parameter :: evenbits8=192153584101141162_i8b ! 2^1 + 2^3 + 2^4+..+2^57

  swapLSBMSB8 = IAND(i,evenbits8)/2_i8b + IAND(i,oddbits8)*2_i8b
end function swapLSBMSB8

!! Returns NOT(i) with even and odd bit positions interchanged.
function invswapLSBMSB8(i)
  integer(i8b) :: invswapLSBMSB8
  integer(i8b), intent(in) :: i

  invswapLSBMSB8 = NOT(swapLSBMSB8(i))
end function invswapLSBMSB8

!! Returns i with odd (1,3,5,...) bits inverted.
function invLSB8(i)
  integer(i8b) :: invLSB8
  integer(i8b), intent(in) :: i
  integer(i8b), parameter :: oddbits8 = 96076792050570581_i8b ! 2^0 + 2^2 + 2^4+..+2^56

  invLSB8 = IEOR(i,oddbits8)
end function invLSB8

!! Returns i with even (0,2,4,...) bits inverted.
function invMSB8(i)
  integer(i8b) :: invMSB8
  integer(i8b), intent(in) :: i
  integer(i8b), parameter :: evenbits8=192153584101141162_i8b ! 2^1 + 2^3 + 2^4+..+2^57

  invMSB8 = IEOR(i,evenbits8)
end function invMSB8
#endif
!**********************************************************************

end module bit_manipulation

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!=======================================================================
!
! For a given input binary mask, in which pixels have either value 0 (=invalid) or 1 (=valid),
! this code produces a map containing for each valid pixel,
! its distance (in Radians) to the closest invalid pixel.
! It can then be used to define an apodisation scheme.
! Distances are measured between pixel centers.
!
! It is possible to treat small holes (=cluster of adjacent invalid pixels) as valid,
! by specifying a minimal number of pixels and/or minimal surface area (which ever is the largest),
! and the resulting new mask can be output.
!
! The output FITS files have the same ordering as the input mask
! (even though the processing is done in NESTED ordering).
!
! 2 pixels are adjacent if they have at least one point in common 
! (eg, a pixel corner or a pixel side).
!
! 
! HISTORY:
!  E. Hivon 2006-2010 firt developments
!  2011-11-22: inclusion in Healpix 
!=======================================================================
program process_mask

  use healpix_types
  use extension, only: getArgument, nArguments
  use fitstools, only: getsize_fits, input_map, output_map
  use head_fits, only: add_card, write_minimal_header
  use pix_tools, only: convert_ring2nest, convert_nest2ring, nside2npix
  USE paramfile_io, only: paramfile_handle, parse_init, parse_int, &
         parse_string, parse_double, parse_summarize, parse_check_unused, parse_finish, concatnl
  use misc_utils, only: assert_alloc, fatal_error, wall_clock_time, brag_openmp
  use mask_tools, only: fill_holes_nest, dist2holes_nest
  implicit none

  integer(I4B) :: nbordpix, status, n_args
  integer(I4B) :: nside, npix, order, new_min_size
  integer(I4B), allocatable, dimension(:) :: mask
  real(SP), allocatable, dimension(:,:) :: map
  real(DP), allocatable, dimension(:,:) :: map2
  real(DP):: surface_deg2, surf_pix_deg
  
  real(kind=SP)                 :: clock_time, time0, time1, t0, t1
  real(kind=SP)                 :: ptime, ptime0, ptime1, pt0, pt1
  type(paramfile_handle)     :: handle

  character(len=FILENAMELEN) :: parafile
  character(len=FILENAMELEN)          :: description
  character(len=80), dimension(1:200) :: header
  character(len=*), parameter :: code = 'process_mask'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION
  integer(i8b) :: tot1, tot2
  
  type proc_mask
     character(len=filenamelen) :: mask_file, distance_file, filled_file !, file_bord
     real(DP)                   :: hole_min_surf_arcmin2 
     integer(i4b)               :: hole_min_size
  end type proc_mask
  type(proc_mask) :: pm

!------------------------------------------------
  call wall_clock_time(time0)
  call cpu_time(ptime0)

  print *, " "
  print *, "                "//code//" "//version
  write(*,'(a)') " *** Mask processing ***"
  ! ------ parse arguments -----
  n_args = nArguments()
  parafile = ''
  if (n_args > 1) then
     stop 'Expected 0 or 1 argument'
  endif
  if (n_args == 1) then
     call getArgument(1, parafile)
  endif
  handle = parse_init(parafile)
  
  description = concatnl('',&
       & 'Enter the input (binary) mask file')
  pm%mask_file = parse_string(handle, 'mask_file', descr=description, filestatus='old')

  description = concatnl('',&
       & 'Enter the minimal size (in pixels) of invalid regions to be kept',&
       & '(can be used together with hole_min_surf_arcmin2 below,'// &
       & ' the result will be the largest of the two)')
  pm%hole_min_size = parse_int(handle,'hole_min_size',descr=description, default=0)

  description = concatnl('',&
       & 'Enter the minimal surface area (in arcmin^2) of invalid regions to be kept',&
       & '(can be used together with hole_min_size above,' // &
       & ' the result will be the largest of the two)')
  !surface_deg2 = parse_double(handle,'surface_deg2',descr=description, default=0.d0)
  pm%hole_min_surf_arcmin2 = parse_double(handle,'hole_min_surf_arcmin2',descr=description, default=0.d0)

  description = concatnl('',&
       & 'Enter the OPTIONAL output file to contain mask with filled-in small invalid regions',&
       & '(as defined above)')
  pm%filled_file = parse_string(handle,'filled_file',descr=description,filestatus='new',default="''")

  description = concatnl('',&
       & 'Enter the OPTIONAL output distance file')
  pm%distance_file = parse_string(handle,'distance_file',descr=description,filestatus='new',default="''")

  !call parse_check_unused(handle, code=code)
  call parse_summarize(handle,code=code)
  call parse_finish(handle)
  ! ----------------------------
  call brag_openmp()
  ! input mask
  npix = getsize_fits(pm%mask_file, nside=nside, ordering=order)
  allocate(map(0:npix-1,1:1),stat=status)
  call assert_alloc(status,code,'map')
  call input_map(pm%mask_file, map, npix, 1)

  surf_pix_deg = fourpi/npix * rad2deg**2 ! area/pixel [Deg^2]
  surface_deg2 = pm%hole_min_surf_arcmin2 / 3600.0_dp
  new_min_size = max( NINT(surface_deg2/surf_pix_deg), pm%hole_min_size)
  ! print*,'hole minimal size (in pixels) :',new_min_size

  if (order == 1) then
     write(*,*) code//'> Converting RING -> NESTED'
     call convert_ring2nest(nside, map)
     !print*,'conversion done'
  endif
  allocate(mask(0:npix-1),stat=status)
  call assert_alloc(status,code,'mask')
  mask = NINT(map(:,1))
  tot1 = sum(mask)

  !----------------------------------------------------------------------
  ! generate new mask by filling small holes
  !----------------------------------------------------------------------
  call fill_holes_nest(nside, new_min_size, mask, mask)
  tot2 = sum(mask)

  if (trim(pm%filled_file) /= '') then
     ! output new mask
     map(:,1) = mask
     if (order == 1) call convert_nest2ring(nside, map)
     
     !print*, trim(file_filled)
     !header(:) = ' '
     call write_minimal_header(header,'MAP',&
          &   nside=nside, &
          &   order=order, &
          &   creator=code, &
          &   version=version)
     call add_card(header,'HISTORY','Hole filler')
     call add_card(header,'HISTORY','Input mask:')
     call add_card(header,'HISTORY',trim(pm%mask_file))
     !call add_card(header,'SURFMIN',surface_deg2,'[Deg^2] Minimal surface')
     call add_card(header,'NP_MIN',new_min_size,'[pixels] Minimal size')
     call output_map(map, header, pm%filled_file)
  endif

  !----------------------------------------------------------------------
  ! compute distance to nearest hole on new mask
  !----------------------------------------------------------------------
  if (trim(pm%distance_file) /= '') then

     allocate(map2(0:npix-1,1:1),stat=status)
     call assert_alloc(status,code,'map2')
     call dist2holes_nest(nside, mask, map2(:,1))

     if (order == 1) call convert_nest2ring(nside, map2)

     call write_minimal_header(header,'MAP',&
          &   nside=nside, &
          &   order=order, &
          &   creator=code, &
          &   version=version, &
          &   units='RADIANS')
     call add_card(header,'TTYPE1','ANGULAR_DISTANCE','[RAD]')
     call add_card(header,'HISTORY','Distance to closest hole for')
     call add_card(header,'HISTORY','Input mask:')
     call add_card(header,'HISTORY',trim(pm%mask_file))
     call add_card(header,'HISTORY','Filled mask:')
     call add_card(header,'HISTORY',trim(pm%filled_file))
     !call add_card(header,'SURFMIN',surface_deg2,'[Deg^2] Minimal surface')
     call add_card(header,'NP_MIN',new_min_size,'[pixels] Minimal size')
     call output_map(map2, header, pm%distance_file)
  endif

  call wall_clock_time(time1)
  call cpu_time(ptime1)
  !----------------------------------------------------------------------
  ! report card
  !----------------------------------------------------------------------
  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" run"
  write(*,9000) "--------------------------------------"
  write(*,9000) " "
  write(*,9000) " Input binary mask       : "//TRIM(pm%mask_file)
  write(*,9010) " Total number of pixels  : ", npix
  write(*,9010) " Input valid pixels      : ", tot1
  write(*,9010) " Effective min. hole size: ", new_min_size
  write(*,9010) " Filled-in pixels        : ", tot2-tot1
  if (trim(pm%filled_file) /= '') write(*,9000) &
       &        " Output filled-in mask    : "//TRIM(pm%filled_file)
  if (trim(pm%distance_file) /= '') write(*,9000) &
       &        " Output distance file    : "//TRIM(pm%distance_file)
  write(*,9030) " Clock and CPU time [s]  : ", time1-time0, ptime1-ptime0

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)



stop
end program process_mask

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module sub_ngpdf_sho


  use healpix_types
  integer(i4b), parameter :: namax = 20
  real(DP), dimension(0:namax) :: factorial
!  logical(LGT) :: precomp_done = .false.
  logical(LGT), save :: precomp_done ! 2013-05-07: edited for G95


  private
  public :: shodev_driver
  ! subroutine shodev_driver
  ! subroutine compute_factorial
  ! function shopdf
  ! subroutine rand_sho

contains


  !-----*-----------------------------------------------------------------

  SUBROUTINE shodev_driver(handle, ns, sigma0, x, nu, bins)

    Use healpix_types
    Use paramfile_io, ONLY : paramfile_handle, parse_int, parse_double, concatnl, parse_lgt
    use rngmod,    only: rand_init, planck_rng, rand_uni
    use misc_utils, only : wall_clock_time, assert_alloc
    Use sky_sub
    use statistics, only: compute_statistics, print_statistics, tstats

    implicit none

    !       type(paramfile_handle), Intent(In) :: handle
    integer(I4B), parameter :: KMAP = SP
    type(paramfile_handle), Intent(InOut)       :: handle
    Integer(I4B), Intent(In) :: ns
    Real(DP),   Intent(Out) :: sigma0
    Real(KMAP), Intent(Out), dimension(0:ns-1) :: x
    Real(DP),   Intent(Out) :: nu(1:3)
    Integer,    Intent(In), Optional :: bins

    integer                           ::  namax,nsmax 
    integer                           ::  i,j,iseed,na,status
    real(KMAP)                            ::  xmin,xmax
    real(DP)                              ::  skewrel, alpha0, mean
    real(DP), dimension(:), allocatable   ::  alpha
    character(len=filenamelen)          :: description
    character(len=20)                  :: chline
    logical :: plot, do_bin = .false.
    character(len = 20) :: form1 = '(a, i1)', form2 = '(a, i1, a)'
#ifdef PGPLOT
    Integer, parameter                ::  npts = 1000 
    real(SP), dimension(1:npts)       ::  xline,yline
    real(DP)                          ::  xval,xstep
    integer :: pgopen, pgdev
#endif
    character(len=*), parameter :: code = 'shodev_driver'
    type(planck_rng) :: rng_handle
    real(DP), parameter :: one = 1.0_dp, two = 2.0_dp, three = 3.0_dp
    real(DP), parameter :: four = 4.0_dp, six = 6.0_dp
    real(DP), allocatable, dimension(:) :: shovar
    real :: time0, time1, time2
    integer :: loc(1)
    type(tstats) :: my_stats


    !      initialize variables

    If (present(bins)) do_bin = .True.
    precomp_done = .false.

    chline = 'iseed'
    If (do_bin) call add_subscript(chline, bins)
    description = concatnl( "", &
         & " Input seed integer iseed:")
    iseed = parse_int(handle, chline, default=1, descr=description)

    !     --- If necessary use current system time to set seed  ---
    IF (iseed .eq. 0) THEN
       CALL SYSTEM_CLOCK(COUNT = iseed)
       !-- Seed should initially be set to a large, odd integer --
       IF (MOD(iseed,2) .EQ. 0) iseed = iseed + 1
       PRINT *,"      "//code//"> Generating random number seed ", iseed
    END IF

    call rand_init(rng_handle, iseed)    

    chline = 'sigma0'
    If (do_bin) call add_subscript(chline, bins)
    description = concatnl( "", &
         & " Input value of sigma0:")
!    sigma0 = parse_real(handle, chline, default=1.0, descr=description)
    sigma0 = parse_double(handle, chline, default=1.d0, descr=description)

    chline = 'na'
    If (do_bin) call add_subscript(chline, bins)
    description = concatnl( "", &
         & " Input order of highest non-zero alpha (na):")
    na = parse_int(handle, chline, default=3, vmin = 0, vmax = 20, descr=description)
    ! Note maximum value of na is 20, but currently moments can only be calculated analytically
    ! for na no greater than 3


    !---allocate space for arrays---
    allocate(shovar(0:ns-1), stat=status)
    call assert_alloc(status, code, ' cannot allocate space for alpha array')

    allocate(alpha(1:MAX(na,3)), stat=status)
    call assert_alloc(status, code, ' cannot allocate space for alpha array')
    alpha = 0.0_dp
    !---end of allocation for arrays---

    Do i = 1, na
       If (i .EQ. 10) Then
          form1 = "(a, i2)"
          form2 = "(a, i2, a)"
       End If
       Write (chline, form1) "alpha_", i
       Write (description, form2) ' Input alpha(',i,')'
       If (do_bin) call add_subscript(chline, bins)
       description = concatnl( "", description)
       alpha(i) = parse_double(handle, chline, default = 0.0_dp, vmin = 0.0_dp, &
            &vmax = sqrt(1.0_dp-SUM(alpha**2)), descr = description)
    End Do

    ! 
    Write (*,*) 'Drawing pixel values from non-Gaussian pdf...'
    if (.not. precomp_done) call compute_factorial()
    call rand_sho(rng_handle, ns, shovar, sigma0, alpha, na)
    call compute_statistics(shovar, my_stats)
    call print_statistics(my_stats)
    xmin = minval(shovar)
    xmax = maxval(shovar)

    mean = 0.0
    if (na.le.3) then
       !      compute moments of this distribution
       alpha0 = sqrt(1.0 - SUM(alpha**2))
       write (*,*) 'alpha0 is ',alpha0
       nu(1)=sqrt(TWO*sigma0)*(TWO*alpha(1)*alpha(2) + sqrt(TWO)*alpha0*alpha(1) &
            & + sqrt(SIX)*alpha(2)*alpha(3))
       nu(2)=sigma0**2 *(ONE + TWO*alpha(1)**2 + FOUR*alpha(2)**2 + SIX*alpha(3)**2 &
            & + TWO*sqrt(TWO)*alpha0*alpha(2) + TWO*sqrt(SIX)*alpha(1)*alpha(3))
       nu(3)=THREE*alpha0*alpha(1)/sqrt(TWO) + SIX*alpha(1)*alpha(2) + &
            & 9.0_dp*sqrt(THREE)*alpha(2)*alpha(3)/sqrt(TWO) + sqrt(THREE)*alpha0*alpha(3)
       nu(3)=(TWO*sigma0**2)**(THREE/TWO)*nu(3)

       skewrel=nu(3)/nu(2)**(THREE/TWO)

       Write(*,*) 'Raw (theoretical) moments of distribution:'
       write(*,*) 'nu1=', nu(1)
       write(*,*) 'nu2=', nu(2)
       write(*,*) 'nu3=', nu(3)
       write(*,*) 'Relative skewness=', skewrel

       If (nu(1) .NE. 0.0) Then
          Write(*,*) 'Re-centering distribution on zero'
          mean = nu(1)
          shovar = shovar - nu(1)
          xmin = xmin - nu(1)
          xmax = xmax - nu(1)
          nu(3) = nu(3) - THREE*nu(1)*nu(2) + TWO*nu(1)**3
          nu(2) = nu(2) - nu(1)**2
          nu(1) = 0.0_dp
          skewrel=nu(3)/nu(2)**(THREE/TWO)
          Write (*,*) 'Centered (theoretical) moments are:'
          Write (*,*) 'nu1=', nu(1)
          write (*,*) 'nu2=', nu(2)
          write (*,*) 'nu3=', nu(3)
          write (*,*) 'Relative skewness=', skewrel
       End If

    Else
       nu = 0.0_dp
       nu(1) = -1.0_dp
       Write (*,*) 'Cannot calculate moments when highest non-zero alpha > 3'
    End If

    x = shovar

    ! Find out if plotting is required
#ifdef PGPLOT
    description = concatnl( "", &
         & " Plot histogram of pixel values? (True or False)")
    plot = parse_lgt(handle, 'plot', default=.false., descr=description)

    If (plot) then
!        call pgbegin(0,'?',1,1)
111    pgdev = pgopen('?')
       if (pgdev < 0) goto 111
       call pghist(ns,real(x,SP),real(xmin,SP),real(xmax,SP),200,0)
       call pglab('Pixel value','Number of pixels','Non-Gaussian SHO White Noise Map')

       xstep=(xmax-xmin)/real(npts-1, DP)
       Do i=1,npts        
          xval=xmin+real(i -1, DP)*xstep
          xline(i)=xval
          yline(i)=shopdf(xval+mean, sigma0, alpha, na)
       End Do
       yline = yline*real(ns)*(xmax-xmin)/200.
       call pgsci(12)
       call pgline(npts,xline,yline)
       call pgend
    End If !plot
#endif


  END SUBROUTINE shodev_driver

  !==================================================================================
  subroutine compute_factorial()
    !-------------------------------------------------------------------------------
    integer(i4b) :: i


    if (precomp_done) return

    factorial(0) = 1.0_dp
    factorial(1) = 1.0_dp
    
    do i = 2, namax
       factorial(i) = factorial(i-1) * real(i, DP)
    enddo
    precomp_done = .true.

    return
  end subroutine compute_factorial

  !-----*-----------------------------------------------------------------

  FUNCTION shopdf(x, sigma0, alpha, na) result(spdf)
    !------------------------------------------------------------
    ! calculates the general simple harmonic oscillator pdf 
    !------------------------------------------------------------
    use healpix_types
    use num_rec, only : othpl
    implicit none
    real(DP), intent(in)                 :: x
    integer(i4b), intent(in)             :: na
    real(DP), intent(in)                 :: sigma0
    real(DP), intent(in)                 :: alpha(Max(na,3))
    real(DP)                             :: spdf

    integer, parameter   :: namax=20
    integer(i4b)         :: i,m,n
    real(DP), dimension(0:namax)     :: pars, hermxp, dhermxp
    real(DP)                         :: xp,sumsq,fact
    !------------------------------------------------------------

    xp = x/(sqrt(2.d0)*sigma0)

    pars(1:na) = alpha(1:na)
    sumsq=0d0
    do i=1,na
       sumsq=sumsq + pars(i)*pars(i)
    end do
    pars(0)=sqrt(1d0-sumsq)

    call othpl(4,na,xp,hermxp,dhermxp)

    if (.not. precomp_done) call compute_factorial

    spdf=0.0_dp
    do m=0,na
       do n=0,na
          fact=  sqrt( (2d0**dble(m+n)) * factorial(m) * factorial(n) )
          spdf=spdf+ pars(m)*pars(n)*hermxp(m)*hermxp(n) / fact
       end do
    end do
    spdf=spdf* exp(-xp*xp)/sqrt(2d0*pi)/sigma0

    return
  END FUNCTION shopdf

! =====================================================================
  subroutine rand_sho(rng_handle, npix, xvar, sigma0, alpha, na)
    !------------------------------------------------------------
    ! draws npix numbers from a SHO variable
    !------------------------------------------------------------
    use healpix_types
    use misc_utils, only: fatal_error
    use rngmod, only: rand_uni, planck_rng
    implicit none

    type(planck_rng), intent(inout)      :: rng_handle
    integer(i4b), intent(in)             :: na, npix
    real(DP), intent(out)                :: xvar(0: npix-1)
    real(DP), intent(in)                 :: sigma0
    real(DP), intent(in)                 :: alpha(Max(na,3))

    character(len=*), parameter :: code = 'rand_sho'
    real(DP), parameter :: threshold = 1.d-12

    real(DP) :: x, xmin, xmax, xstep, xlin, y, yold, yuni
    real(DP), dimension(:), allocatable :: integral
    integer(I4B) :: nx, i, p, ilow, ihi, imid
    !----------------------------------------------------------

    ! find out x range
    xmax =  5.0_dp * sigma0
    xmin = -xmax
    do
       if (shopdf(xmax, sigma0, alpha, na) < threshold) exit
       xmax = xmax + sigma0
    enddo
    do
       if (shopdf(xmin, sigma0, alpha, na) < threshold) exit
       xmin = xmin - sigma0
    enddo
    nx = (xmax - xmin)/sigma0 * 2000

    ! build cumulative table, using trapeze integral
    allocate(integral(0:nx-1))
    xstep = (xmax-xmin)/(nx-1.d0)
    integral = 0_dp
    yold = 0.0_dp
    do i=0, nx - 1
       x = xmin +  i * xstep
       y = shopdf(x, sigma0, alpha, na)
       if (i > 0) integral(i) = integral(i-1) + (y+yold)*0.5_dp
       yold = y
    enddo
    integral = integral * xstep ! normalize
    if (abs(integral(nx-1)-1.d0) > 5.d0*threshold) then
       call fatal_error(code//': problem with computation of integral')
       print*,'Error on integral: ',integral(nx-1)-1.d0
    endif
    integral(nx-1) = 1.d0
    
    ! solve y = F(x)
    do p = 0, npix-1
       ! uniform variate in [0,1]
       yuni = rand_uni(rng_handle)
       ! locate point in tabulated integral by dichotomy
       ilow = 0
       ihi  = nx-1
       do 
          imid = (ihi + ilow)/2
          if ((integral(imid) <= yuni) .eqv. (yuni <= integral(ihi))) then
             ilow = imid
          else
             ihi = imid
          endif
          if ((ihi - ilow) == 1) exit
       enddo
       ! linear interpolation
       xlin = (yuni - integral(ilow))/(integral(ihi)-integral(ilow)) * xstep
       ! return non-gaussian variate
       xvar(p) =  xmin + ilow * xstep + xlin
    enddo
    deallocate(integral)

    return
  end subroutine rand_sho
  !-----*-----------------------------------------------------------------

end module sub_ngpdf_sho

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------

subroutine euler_matrix_new(       &
                            a1,    &
                            a2,    &
                            a3,    &
                            matrix,&
                            itype   &
                           )

  ! --------------------------------------------------------------
  !
  ! this subroutine computes the Euler matrix for different prescription
  !          X: +0, Y: +1, Z: +2
  !
  !itype=1 :    rotation a1 around original Z
  !             rotation a2 around interm   Y   (+1)
  !             rotation a3 around final    X   (+0)
  !     aeronautics convention                   =1
  !
  !itype=2 :    rotation a1 around original Z
  !             rotation a2 around interm   X   (+0)
  !             rotation a3 around final    Z   (+2)
  !     classical mechanics convention           =2
  !
  !
  !itype=3 :    rotation a1 around original Z
  !             rotation a2 around interm   Y   (+1)
  !             rotation a3 around final    Z   (+2)
  !     quantum mechanics convention             =3
  !
  ! see H. Goldestein, Classical Mechanics (2nd Ed.) p. 147 for
  ! discussion
  ! INPUTS:
  !        a1, a2, a3 = Euler angles, in radians
  !         all the angles are measured counterclockwise
  !
  ! MODIFICATION HISTORY:
  !    October 1997, Eric Hivon, TAC (original IDL code)
  !    January 1999, A.J. Banday MPA (conversion to F90)
  !    March 22 1999, E.H. Caltech   (modification to match IDL version,
  !    correction of a bug on the matrix product)
  !    May 2002, E. H. Caltech (transformation of euler_matrix into euler_matrix_new)
  !       M_new(a,b,c)  =  M_old(-a, b,-c)
  ! --------------------------------------------------------------

   USE healpix_types

   IMPLICIT NONE

   REAL(DP)                , INTENT(IN)  :: a1,a2,a3
   REAL(DP), DIMENSION(3,3), INTENT(OUT) :: matrix
   INTEGER(I4B)            , INTENT(IN)  :: itype

   REAL(DP)                 :: c1,c2,c3, s1,s2,s3
   REAL(DP)                 :: ze,un
   REAL(DP), DIMENSION(3,3) :: m1,m2,m3
   character(len=*), parameter :: code ="Euler_Matrix_New"

   ! --------------------------------------------------------------

   !-- convert to sin and cosine values --
   c1 = COS(a1)
   s1 = SIN(a1)
   c2 = COS(a2)
   s2 = SIN(a2)
   c3 = COS(a3)
   s3 = SIN(a3)

   ze = 0.0_dp
   un = 1.0_dp

   !-- form full rotation matrix --
   !-- FOR REFERENCE:

   ! itype : 1
   ! m1 = [[ c1,-s1,  0],[ s1, c1,  0],[  0,  0,  1]] ; around   z
   ! m2 = [[ c2,  0, s2],[  0,  1,  0],[-s2,  0, c2]] ; around   y
   ! m3 = [[  1,  0,  0],[  0, c3,-s3],[  0, s3, c3]] ; around   x

   ! itype : 2
   ! m1 = [[ c1,-s1,  0],[ s1, c1,  0],[  0,  0,  1]] ; around   z
   ! m2 = [[  1,  0,  0],[  0, c2,-s2],[  0, s2, c2]] ; around   x
   ! m3 = [[ c3,-s3,  0],[ s3, c3,  0],[  0,  0,  1]] ; around   z

   ! itype : 3
   ! m1 = [[ c1,-s1,  0],[ s1, c1,  0],[  0,  0,  1]] ; around   z
   ! m2 = [[ c2,  0, s2],[  0,  1,  0],[-s2,  0, c2]] ; around   y
   ! m3 = [[ c3,-s3,  0],[ s3, c3,  0],[  0,  0,  1]] ; around   z


   ! matrix = m1 ( m2 m3 )

   m1(:,1) = (/ c1,-s1, ze /)  ! 1st column
   m1(:,2) = (/ s1, c1, ze /)  ! 2nd column
   m1(:,3) = (/ ze, ze, un /)  ! 3rd column

   select case (itype)

   case(1) ! ZYX

      m2(:,1) = (/ c2, ze, s2 /)
      m2(:,2) = (/ ze, un, ze /)
      m2(:,3) = (/-s2, ze, c2 /)

      m3(:,1) = (/ un, ze, ze /)
      m3(:,2) = (/ ze, c3,-s3 /)
      m3(:,3) = (/ ze, s3, c3 /)

   case(2) ! ZXZ

      m2(:,1) = (/ un, ze, ze /)
      m2(:,2) = (/ ze, c2,-s2 /)
      m2(:,3) = (/ ze, s2, c2 /)

      m3(:,1) = (/ c3,-s3, ze /)
      m3(:,2) = (/ s3, c3, ze /)
      m3(:,3) = (/ ze, ze, un /)

   case(3) ! ZYZ

      m2(:,1) = (/ c2, ze, s2 /)
      m2(:,2) = (/ ze, un, ze /)
      m2(:,3) = (/-s2, ze, c2 /)

      m3(:,1) = (/ c3,-s3, ze /)
      m3(:,2) = (/ s3, c3, ze /)
      m3(:,3) = (/ ze, ze, un /)

   case default

      print*,'Unknow rotation prescription in '//code
      print*,'Must be in [1,2,3]'
      print*,'is ',itype
      stop

   end select

   matrix = matmul(m1,matmul(m2,m3))

 end subroutine euler_matrix_new

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!! Generator for uniformly distributed and Gaussian random numbers
module ran_tools

use healpix_types
implicit none
private

public randgauss_boxmuller, ran_mwc

contains

!! Box-Muller method for converting uniform into Gaussian deviates.
function randgauss_boxmuller(iseed)
  integer(i4b), intent(inout) :: iseed  !! random number state
  real(sp) :: randgauss_boxmuller       !! result
  logical, save :: empty=.true.
  real(sp) :: fac,rsq,v1,v2
  real(sp),save :: gset !! test

  if (empty .or. iseed < 0) then ! bug correction, EH, March 13, 2003
    do
      v1 = 2._sp*ran_mwc(iseed) - 1._sp
      v2 = 2._sp*ran_mwc(iseed) - 1._sp
      rsq = v1**2+v2**2
      if((rsq<1._sp) .and. (rsq>0._sp)) exit
    end do

    fac = sqrt(-2._sp*log(rsq)/rsq)
    gset = v1*fac
    randgauss_boxmuller = v2*fac
    empty = .false.
  else
    randgauss_boxmuller = gset
    empty = .true.
  endif
end function randgauss_boxmuller


!! This routine implements the Marsaglia "multiply with carry method"
!! and adds a Marsaglia shift sequence to it.
!! (cf. references at http://www.cs.hku.hk/)
!!
!! You are welcome to replace this with your preferred generator
!! of uniform variates in the interval ]0,1[ (i.e. excluding 0 and 1).
!!
!! (Re-)initialise with setting iseed to a negative number.
!! Note that iseed=0 gives the same sequence as iseed=-1.
!! After initialisation iseed becomes abs(iseed) (or 1 if it was 0).

!! @author B. D. Wandelt, May 1999

function ran_mwc(iseed)
  integer(i4b), intent(inout):: iseed !! random number state
  real(sp) :: ran_mwc                 !! result

  integer(i4b) :: i,iseedl,iseedu,mwc,combined
  integer(i4b),save :: upper,lower,shifter
  integer(i4b),parameter :: mask16=65535,mask30=2147483647
  real(sp),save :: small
  logical, save :: first=.true.

  if (first .or. (iseed<=0)) then
    if (iseed==0) iseed=-1
    iseed = abs(iseed)
    small = nearest (1._sp,-1._sp)/mask30

    ! Users often enter small seeds - I spread them out using the
    ! Marsaglia shifter a few times.
    shifter=iseed
    do i=1,9
      shifter=ieor(shifter,ishft(shifter,13))
      shifter=ieor(shifter,ishft(shifter,-17))
      shifter=ieor(shifter,ishft(shifter,5))
    enddo

    iseedu=ishft(shifter,-16)
    upper=ishft(iseedu+8765,16)+iseedu !This avoids the fixed points.
    iseedl=iand(shifter,mask16)
    lower=ishft(iseedl+4321,16)+iseedl !This avoids the fixed points.

    first=.false.
  endif

  do
    shifter=ieor(shifter,ishft(shifter,13))
    shifter=ieor(shifter,ishft(shifter,-17))
    shifter=ieor(shifter,ishft(shifter,5))

    upper=36969*iand(upper,mask16)+ishft(upper,-16)
    lower=18000*iand(lower,mask16)+ishft(lower,-16)

    mwc=ishft(upper,16)+iand(lower,mask16)

    combined=iand(mwc,mask30)+iand(shifter,mask30)

    ran_mwc=small*iand(combined,mask30)
    if(ran_mwc/=0._sp) exit
  end do
end function ran_mwc

end module ran_tools

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!
! file to be inserted in pix_tools.F90 with
!  #include "pixel_routines.F90"
!
! the following routines should be compiled twice:
! once without DOI8B, and once with DOI8B
! in order to respectively support 4-byte and 8-byte pixel indexing
!
!   s pix2ang_ring
!   s pix2vec_ring
!   s ang2pix_ring
!   s vec2pix_ring
!   s pix2ang_nest
!   s pix2vec_nest
!   s ang2pix_nest
!   s vec2pix_nest
!   s nest2ring
!   s ring2nest
!   f npix2nside
!   s in_ring
!   s getdisc_ring
!   s query_disc
!   s query_strip
!   s query_polygon
!   s query_triangle
!   s xy2pix_nest
!   s pix2xy_nest
!   s neighbours_nest
!   s next_in_line_nest
!   s template_pixel_ring
!   s same_shape_pixels_ring
!   s template_pixel_nest
!   s same_shape_pixels_nest
!   s uniq2nest
!   s nest2uniq
!
! 2012-03-02: make sure that both arguments of iand and modulo 
!      are of the same type (for XL Fortran compiler)
!=======================================================================
!     pix2ang_ring
!
!     renders theta and phi coordinates of the nominal pixel center
!     for the pixel number ipix (RING scheme)
!     given the map resolution parameter nside
!
!=======================================================================
#ifdef DOI8B
  subroutine pix2ang_ring_8(nside, ipix, theta, phi)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine pix2ang_ring  (nside, ipix, theta, phi)
    integer(i4b), parameter :: MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    INTEGER(KIND=MKD), INTENT(IN)  :: ipix
    REAL(KIND=DP),     INTENT(OUT) :: theta, phi

    INTEGER(KIND=I4B) ::  nl2, nl4, iring, iphi
    INTEGER(KIND=MKD) ::  npix, ncap, ip
    REAL(KIND=DP) ::  fodd, dnside
    real(kind=dp), parameter :: half = 0.500000000000000_dp
    !real(kind=dp), parameter :: one  = 1.000000000000000_dp
    !real(kind=dp), parameter :: three = 3.00000000000000_dp
    real(kind=dp), parameter :: threehalf = 1.50000000000000_dp
    character(len=*), parameter :: code = "pix2ang_ring"
    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call pix2ang_ring(nside, int(ipix,kind=i4b), theta, phi)
       return
    endif
#else
    if (nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error (code//"> ipix out of range")

    nl2  = 2*nside
    ncap = nl2*(nside-1_MKD) ! points in each polar cap, =0 for nside =1
    dnside = real(nside, kind=dp)

    if (ipix < ncap) then ! North Polar cap -------------

!       iring = nint( sqrt( (ipix+1) * half ), kind=MKD) ! counted from North pole
       iring = (cheap_isqrt(2*ipix+2) + 1)/2
       iphi  = ipix - 2*iring*(iring - 1_MKD)
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(1, iring, iphi)
! #endif

!       theta = ACOS( one - (iring/dnside)**2 / three )
       theta = 2.0_dp * asin(iring / (sqrt(6.0_dp)*dnside))
       phi   = (real(iphi,kind=dp) + half) * HALFPI/iring

    elseif (ipix < npix-ncap) then ! Equatorial region ------

       ip    = ipix - ncap
       nl4   = 4*nside
       iring = INT( ip / nl4 ) + nside ! counted from North pole
       iphi  = iand(ip, nl4-1_MKD)

       fodd  = half * ( iand(iring+nside+1,1) )  ! 0 if iring+nside is odd, 1/2 otherwise
       theta = ACOS( (nl2 - iring) / (threehalf*dnside) )
       phi   = (real(iphi,kind=dp) + fodd) * HALFPI / dnside

    else ! South Polar cap -----------------------------------

       ip    = npix - ipix
!       iring = nint( sqrt( ip * half ), kind=MKD)     ! counted from South pole
       iring = (cheap_isqrt(2*ip) + 1) / 2
       iphi  = 2*iring*(iring + 1_MKD) - ip
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(-1, iring, iphi)
! #endif

!       theta = ACOS( (iring/dnside)**2 / three  - one)
       theta = PI - 2.d0 * asin(iring / (sqrt(6.0_dp)*dnside))
       phi   = (real(iphi,kind=dp) + half) * HALFPI/iring

    endif

    return
#ifdef DOI8B
  end subroutine pix2ang_ring_8
#else
  end subroutine pix2ang_ring
#endif

!=======================================================================
!     pix2vec_ring
!
!     renders vector (x,y,z) coordinates of the nominal pixel center
!     for the pixel number ipix (RING scheme)
!     given the map resolution parameter nside
!     also returns the (x,y,z) position of the 4 pixel vertices (=corners)
!     in the order N,W,S,E
!=======================================================================

#ifdef DOI8B
  subroutine pix2vec_ring_8(nside, ipix, vector, vertex)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine pix2vec_ring  (nside, ipix, vector, vertex)
    integer(i4b), parameter :: MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)                             :: nside
    INTEGER(KIND=MKD), INTENT(IN)                             :: ipix
    REAL(KIND=DP),     INTENT(OUT),dimension(1:)              :: vector
    REAL(KIND=DP),     INTENT(OUT),dimension(1:,1:), optional :: vertex

    INTEGER(KIND=I4B) :: nl2, nl4, iring, iphi
    INTEGER(KIND=MKD) ::  npix, ncap, ip
    REAL(KIND=DP) ::  fact1, fact2, fodd, z, sth, phi
    real(kind=dp), parameter :: half = 0.500000000000000_dp

    real(kind=DP) :: phi_nv, phi_wv, phi_sv, phi_ev, sin_phi, cos_phi
    real(kind=DP) :: z_nv, z_sv, sth_nv, sth_sv
    real(kind=DP) :: hdelta_phi
    integer(kind=I4B) :: iphi_mod, iphi_rat
    logical(kind=LGT) :: do_vertex
    integer(kind=i4b) :: diff_phi
    character(len=*), parameter :: code = "pix2vec_ring"
    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       if (present(vertex)) then
          call pix2vec_ring(nside, int(ipix, kind=i4b), vector, vertex)
       else
          call pix2vec_ring(nside, int(ipix, kind=i4b), vector)
       endif
       return
    endif
#else
    if (nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error(code//"> ipix out of range")

    nl2   = 2*nside
    ncap  = nl2*(nside-1_MKD) ! points in each polar cap, =0 for nside =1

    do_vertex = .false.
    if (present(vertex)) then
       if (size(vertex,dim=1) >= 3 .and. size(vertex,dim=2) >= 4) then
          do_vertex = .true.
       else
          call fatal_error(code//">  vertex array has wrong size ")
       endif
    endif

    if (ipix < ncap) then ! North Polar cap -------------

!        iring = nint( sqrt( (ipix+1) * half ), kind=MKD) ! counted from North pole
       iring = (cheap_isqrt(2*ipix+2) + 1) / 2
       iphi  = ipix - 2*iring*(iring - 1_MKD)
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(1, iring, iphi)
! #endif

       fact2 = (3.00000_dp*nside)*nside
       z =  1.0_dp - (iring / fact2) * iring
       sth = iring * sqrt( (1.d0+z)/fact2 )
       phi   = (real(iphi,kind=dp) + half) * HALFPI/iring

       if (do_vertex) then
          hdelta_phi = PI/(4.0_dp*iring)   ! half pixel width
          z_nv = 1.0_dp - (iring-1) / fact2 * (iring-1)
          z_sv = 1.0_dp - (iring+1) / fact2 * (iring+1)
          iphi_mod = MODULO(iphi, iring) ! in {0,1,... iring-1}
          iphi_rat = (iphi) / iring      ! in {0,1,2,3}
          phi_nv = 0.0_dp
          if (iring > 1) phi_nv = HALFPI * (iphi_rat +  iphi_mod   /real(iring-1,kind=dp))
          phi_sv                = HALFPI * (iphi_rat + (iphi_mod+1)/real(iring+1,kind=dp))
          diff_phi = 3 ! both phi_nv and phi_sv different from phi
       endif


    elseif (ipix < npix - ncap) then ! Equatorial region ------

       nl4 = 4*nside
       ip    = ipix - ncap
       iring = INT( ip / nl4 ) + nside ! counted from North pole
       iphi  = iand(ip, nl4-1_MKD)

       fact1 =  1.50000_dp*nside
       fodd  = half * ( iand(iring+nside+1,1) )  ! 0 if iring+nside is odd, 1/2 otherwise
       z = (nl2 - iring) / fact1
       sth = SQRT((1.0_dp-z)*(1.0_dp+z))
       phi   = (real(iphi,kind=dp) + fodd) * HALFPI / nside

       if (do_vertex) then
          fact2 = (3.00000_dp*nside)*nside
          hdelta_phi = PI/(4.0_dp*nside)   ! half pixel width
          phi_nv = phi
          phi_sv = phi
          z_nv = (nl2 - iring +1) / fact1
          z_sv = (nl2 - iring -1) / fact1
          diff_phi = 0 ! phi_nv = phi_sv = phi
          if (iring == nside) then ! northern transition
             z_nv = 1.0_dp - (nside-1) / fact2 * (nside-1)
             iphi_mod = iand(iphi, nside-1) ! in {0,1,... nside-1}
             iphi_rat = (iphi) / nside      ! in {0,1,2,3}
             if (nside > 1) then
                phi_nv = HALFPI * (iphi_rat +  iphi_mod /real(nside-1,kind=dp))
                diff_phi = 1
             endif
          elseif (iring == 3*nside) then ! southern transition
             z_sv = -1.0_dp + (nside-1) / fact2 * (nside-1)
             iphi_mod = iand(iphi, nside-1) ! in {0,1,... iring-1}
             iphi_rat = (iphi) / nside      ! in {0,1,2,3}
             if (nside > 1) then
                phi_sv = HALFPI * (iphi_rat +  iphi_mod   /real(nside-1,kind=dp))
                diff_phi = 2
             endif
          endif
       endif

    else ! South Polar cap -----------------------------------

       ip    = npix - ipix
!        iring = nint( sqrt( ip * half ), kind=MKD)     ! counted from South pole
       iring = (cheap_isqrt(2*ip) + 1)/2
       iphi  = 2*iring*(iring + 1_MKD) - ip
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(-1, iring, iphi)
! #endif

       fact2 = (3.00000_dp*nside)*nside
       z = -1.0_dp + (iring / fact2) * iring
       sth = iring * sqrt( (1.0_dp - z)/fact2 )
       phi   = (real(iphi,kind=dp) + half) * HALFPI/iring

       if (do_vertex) then
          hdelta_phi = PI/(4.0_dp*iring)   ! half pixel width
          z_nv = -1.0_dp + (iring+1)/ fact2 * (iring+1)
          z_sv = -1.0_dp + (iring-1)/ fact2 * (iring-1)
          iphi_mod = MODULO(iphi, iring) ! in {0,1,... iring-1}
          iphi_rat = (iphi) / iring      ! in {0,1,2,3}
          phi_nv                = HALFPI * (iphi_rat + (iphi_mod+1)/real(iring+1,kind=dp))
          phi_sv = 0.0_dp
          if (iring > 1) phi_sv = HALFPI * (iphi_rat +  iphi_mod   /real(iring-1,kind=dp))
          diff_phi = 3
       endif

    endif

    ! pixel center
    !!!!sth = SQRT((1.0_dp-z)*(1.0_dp+z))
    cos_phi = cos(phi)
    sin_phi = sin(phi)
    vector(1) = sth * cos_phi
    vector(2) = sth * sin_phi
    vector(3) = z

    if (do_vertex) then
       ! west vertex
       phi_wv      = phi - hdelta_phi
       vertex(1,2) = sth * COS(phi_wv)
       vertex(2,2) = sth * SIN(phi_wv)
       vertex(3,2) = z

       ! east vertex
       phi_ev      = phi + hdelta_phi
       vertex(1,4) = sth * COS(phi_ev)
       vertex(2,4) = sth * SIN(phi_ev)
       vertex(3,4) = z

       ! north and south vertices
       sth_nv = SQRT((1.0_dp-z_nv)*(1.0_dp+z_nv))
       sth_sv = SQRT((1.0_dp-z_sv)*(1.0_dp+z_sv))
       if (diff_phi == 0) then
          vertex(1,1) = sth_nv * cos_phi
          vertex(2,1) = sth_nv * sin_phi
          vertex(1,3) = sth_sv * cos_phi
          vertex(2,3) = sth_sv * sin_phi
       else
          vertex(1,1) = sth_nv * COS(phi_nv)
          vertex(2,1) = sth_nv * SIN(phi_nv)
          vertex(1,3) = sth_sv * COS(phi_sv)
          vertex(2,3) = sth_sv * SIN(phi_sv)
       endif
       vertex(3,1) = z_nv
       vertex(3,3) = z_sv
    endif

    return
#ifdef DOI8B
  end subroutine pix2vec_ring_8
#else
  end subroutine pix2vec_ring
#endif

!=======================================================================
!     ang2pix_ring
!
!     renders the pixel number ipix (RING scheme) for a pixel which contains
!     a point on a sphere at coordinates theta and phi, given the map
!     resolution parameter nside
!=======================================================================
#ifdef DOI8B
  subroutine ang2pix_ring_8(nside, theta, phi, ipix)
    integer(i4b), parameter :: MKD = I8B
    integer(i4b), parameter :: mykind = I4B ! replace with i8b to reach nside=2^29
#else
  subroutine ang2pix_ring  (nside, theta, phi, ipix)
    integer(i4b), parameter :: MKD = I4B
    integer(i4b), parameter :: mykind = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    REAL(KIND=DP),     INTENT(IN)  :: theta, phi
    INTEGER(KIND=MKD), INTENT(OUT) :: ipix

    INTEGER(mykind)   ::  nl4, jp, jm, ir, ip
    REAL(KIND=DP)     ::  z, za, tt, tp, tmp, temp1, temp2
    INTEGER(KIND=I4B) ::  kshift, ipix4
    character(len=*), parameter :: code = "ang2pix_ring"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call ang2pix_ring(nside, theta, phi, ipix4)
       ipix = int(ipix4, kind=MKD)
       return
    endif
    if (nside <1 .or. nside > ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside <1 .or. nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    if (theta<0.0_dp .or. theta>pi)  then
       print*,code//"> theta : ",theta," is out of range [0, Pi]"
       call fatal_error
    endif

    z = COS(theta)
    za = ABS(z)
    tt = MODULO( phi, twopi) / halfpi  ! in [0,4)

    nl4 = 4_mykind*nside
    if ( za <= twothird ) then ! Equatorial region ------------------
       temp1 = nside*(0.50000_dp + tt)
       temp2 = nside* 0.75000_dp * z
       jp = int(temp1-temp2, kind=mykind) ! index of  ascending edge line
       jm = int(temp1+temp2, kind=mykind) ! index of descending edge line

       ir = nside + jp - jm ! in {0,2n} (ring number counted from z=2/3)
       kshift = iand(ir, 1) ! kshift=1 if ir is odd, 0 otherwise

       ip = INT( ( jp+jm - nside + kshift + 1 ) / 2 , kind=mykind) ! in {0,4n-1}
       if (ip >= nl4) ip = ip - nl4

       ipix = 2*nside*(nside-1_MKD) + nl4*int(ir,MKD) + ip

    else ! North & South polar caps -----------------------------

       tp = tt - INT(tt)      !MODULO(tt,1.0_dp)
       !tmp = nside * SQRT( 3.0_dp*(1.0_dp - za) )
       if (z > 0.0_dp) then
          tmp = sqrt(6.0_dp) * sin( theta * 0.5_dp) * nside
       else
          tmp = sqrt(6.0_dp) * cos( theta * 0.5_dp) * nside
       endif

       jp = INT(  tp          * tmp, kind=mykind) ! increasing edge line index
       jm = INT((1.0_dp - tp) * tmp, kind=mykind) ! decreasing edge line index

       ir = jp + jm + 1        ! ring number counted from the closest pole
       ip = INT( tt * ir, kind=mykind)     ! in {0,4*ir-1}
       if (ip >= 4*ir) ip = ip - 4*ir

       if (z>0._dp) then
          ipix = 2*ir*(ir-1_MKD) + ip
       else
          ipix = 3*nside*int(nl4,MKD) - 2*ir*(ir+1_MKD) + ip
       endif

    endif

    return
#ifdef DOI8B
  end subroutine ang2pix_ring_8
#else
  end subroutine ang2pix_ring
#endif
!=======================================================================
!     vec2pix_ring
!
!     renders the pixel number ipix (RING scheme) for a pixel which contains
!     a point on a sphere at coordinate vector (=x,y,z), given the map
!     resolution parameter nside
!=======================================================================
#ifdef DOI8B
  subroutine vec2pix_ring_8(nside, vector, ipix)
    integer(i4b), parameter :: MKD = I8B
    integer(i4b), parameter :: mykind = I4B ! replace with i8b to reach nside=2^29
#else
  subroutine vec2pix_ring  (nside, vector, ipix)
    integer(i4b), parameter :: MKD = I4B
    integer(i4b), parameter :: mykind = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)                :: nside
    REAL(KIND=DP),     INTENT(IN), dimension(1:) :: vector
    INTEGER(KIND=MKD), INTENT(OUT)               :: ipix

    INTEGER(mykind)   :: nl4, jp, jm, ir, ip
    REAL(KIND=DP)     :: z, za, tt, tp, tmp, dnorm, phi,temp1,temp2
    INTEGER(KIND=I4B) :: kshift, ipix4
    character(len=*), parameter :: code = "vec2pix_ring"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call vec2pix_ring(nside, vector, ipix4)
       ipix = int(ipix4, kind=MKD)
       return
    endif
    if (nside<1 .or. nside>ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside<1 .or. nside>ns_max4) call fatal_error(code//"> nside out of range")
#endif
    dnorm = SQRT(vector(1)**2+vector(2)**2+vector(3)**2)
    z  = vector(3) / dnorm  ! cos(theta)
    phi = 0.0_dp
    if (vector(1) /= 0.0_dp .or. vector(2) /= 0.0_dp) &
         &     phi = ATAN2(vector(2),vector(1)) ! phi in ]-pi,pi]

    za = ABS(z)
    if (phi < 0.0_dp)     phi = phi + twopi ! phi in [0,2pi[
    tt = phi / halfpi   ! in [0,4)

    nl4 = 4_mykind*nside
    if ( za <= twothird ) then ! Equatorial region ------------------
       temp1 = nside*(0.50000_dp + tt)
       temp2 = nside* 0.75000_dp * z
       jp = int(temp1-temp2, kind=mykind) ! index of  ascending edge line
       jm = int(temp1+temp2, kind=mykind) ! index of descending edge line
!        jp = INT(nside*(0.5_dp + tt - z*0.75_dp), kind=mykind) index of  ascending edge line
!        jm = INT(nside*(0.5_dp + tt + z*0.75_dp), kind=mykind) index of descending edge line

       ir = nside + jp - jm ! in {0,2n} (ring number counted from z=2/3)
       kshift = iand(ir, 1) ! kshift=1 if ir is odd, 0 otherwise

       ip = INT( ( jp+jm - nside + kshift + 1 ) / 2, kind=mykind) ! in {0,4n-1}
       if (ip >= nl4) ip = ip - nl4

       ipix = 2*nside*(nside-1_MKD) + nl4*int(ir,MKD) + ip

    else ! North & South polar caps -----------------------------

       tp = tt - INT(tt)      !MODULO(tt,1.0_dp)
       !tmp = nside * SQRT( 3.0_dp*(1.0_dp - za) )
       tmp = SQRT(vector(1)**2+vector(2)**2) / dnorm ! sin(theta)
       tmp = nside * tmp * SQRT( 3.0_dp / (1.0_dp + za) ) !more accurate

       jp = INT(  tp          * tmp, kind=mykind) ! increasing edge line index
       jm = INT((1.0_dp - tp) * tmp, kind=mykind) ! decreasing edge line index

       ir = jp + jm + 1        ! ring number counted from the closest pole
       ip = INT( tt * ir, kind=mykind)     ! in {0,4*ir-1}
       if (ip >= 4*ir) ip = ip - 4*ir

       if (z>0._dp) then
          ipix = 2*ir*(ir-1_MKD) + ip
       else
          ipix = 3*nside*int(nl4,MKD) - 2*ir*(ir+1_MKD) + ip
       endif

    endif

    return
#ifdef DOI8B
  end subroutine vec2pix_ring_8
#else
  end subroutine vec2pix_ring
#endif
!=======================================================================
!     pix2ang_nest
!
!     renders theta and phi coordinates of the nominal pixel center
!     for the pixel number ipix (NESTED scheme)
!     given the map resolution parameter nside
!=======================================================================
#ifdef DOI8B
  subroutine pix2ang_nest_8(nside, ipix, theta, phi)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine pix2ang_nest  (nside, ipix, theta, phi)
    integer(i4b), parameter :: MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    INTEGER(KIND=MKD), INTENT(IN)  :: ipix
    REAL(KIND=DP),     INTENT(OUT) :: theta, phi

    INTEGER(KIND=MKD) :: npix, npface, ipf
    INTEGER(KIND=I4B) :: ip_low, ip_trunc, ip_med, ip_hi, &
         &     jrt, jr, nr, jpt, jp, kshift, nl4, scale, i, ismax
    INTEGER(KIND=I4B) :: ix, iy, face_num
    REAL(KIND=DP)     :: z, fn, fact1, fact2

    ! coordinate of the lowest corner of each face
    INTEGER(KIND=I4B), dimension(1:12) :: jrll = (/ 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4 /) ! in unit of nside
    INTEGER(KIND=I4B), dimension(1:12) :: jpll = (/ 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7 /) ! in unit of nside/2
    character(len=*), parameter :: code = "pix2ang_nest"
    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call pix2ang_nest(nside, int(ipix,kind=i4b), theta, phi)
       return
    endif
#else
    if (nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error ("ipix out of range")

    !     initiates the array for the pixel number -> (x,y) mapping
    if (pix2x(1023) <= 0) call mk_pix2xy()

    npface = nside * int(nside, kind=MKD)
    nl4    = 4_MKD*nside

    !     finds the face, and the number in the face
    face_num = ipix/npface  ! face number in {0,11}
    ipf = MODULO(ipix,npface)  ! pixel number in the face {0,npface-1}

    fn = real(nside, kind=dp)
    !fact1 = 1.0_dp/(3.0_dp*fn*fn)

    !     finds the x,y on the face (starting from the lowest corner)
    !     from the pixel number
    if (nside <= ns_max4) then
       ip_low = iand(ipf,1023_MKD)       ! content of the last 10 bits
       ip_trunc =    ipf/1024        ! truncation of the last 10 bits
       ip_med = iand(ip_trunc,1023)  ! content of the next 10 bits
       ip_hi  =      ip_trunc/1024   ! content of the high weight 10 bits

       ix = 1024*pix2x(ip_hi) + 32*pix2x(ip_med) + pix2x(ip_low)
       iy = 1024*pix2y(ip_hi) + 32*pix2y(ip_med) + pix2y(ip_low)
    else
       ix = 0
       iy = 0
       scale = 1
       ismax = 4
       do i=0, ismax
          ip_low = iand(ipf,1023_MKD)
          ix = ix + scale * pix2x(ip_low)
          iy = iy + scale * pix2y(ip_low)
          scale = scale * 32
          ipf   = ipf/1024
       enddo
       ix = ix + scale * pix2x(ipf)
       iy = iy + scale * pix2y(ipf)
    endif

    !     transforms this in (horizontal, vertical) coordinates
    jrt = ix + iy  ! 'vertical' in {0,2*(nside-1)}
    jpt = ix - iy  ! 'horizontal' in {-nside+1,nside-1}

    !     computes the z coordinate on the sphere
    jr =  jrll(face_num+1)*nside - jrt - 1   ! ring number in {1,4*nside-1}

    if (jr < nside) then     ! north pole region
       nr = jr
       !z = 1.0_dp - nr * fact1 * nr
       theta = 2.0_dp * asin( nr / (sqrt(6.0_dp) * fn) )
       !kshift = 0

    else if (jr <= 3*nside) then ! equatorial region
       !fact2 = 2.0_dp/(3.0_dp*fn)
       nr = nside
       theta = ACOS((2*nside-jr)* 2.0_dp/(3.0_dp*fn) )
       !kshift = iand(jr - nside, 1)

    else if (jr > 3*nside) then ! south pole region
       nr = nl4 - jr
       !z = - 1.0_dp + nr * fact1 * nr
       theta = PI - 2.0_dp * asin( nr / (sqrt(6.0_dp) * fn) )
       !kshift = 0
    endif


!     !     computes the phi coordinate on the sphere, in [0,2Pi]
!     jp = (jpll(face_num+1)*nr + jpt + 1_MKD + kshift)/2  ! 'phi' number in the ring in {1,4*nr}
!     if (jp > nl4) jp = jp - nl4
!     if (jp < 1)   jp = jp + nl4

!     phi = (jp - (kshift+1)*0.5_dp) * (halfpi / nr)
    !     computes the phi coordinate on the sphere, in [0,2Pi]
    jp = jpll(face_num+1)*nr + jpt  ! 'phi' number in the ring in {0,8*nr-1}
    if (jp < 0)   jp = jp + 2_MKD*nl4

    phi = jp  * (quartpi / nr)

    return

#ifdef DOI8B
  end subroutine pix2ang_nest_8
#else
  end subroutine pix2ang_nest
#endif
!=======================================================================
!     pix2vec_nest
!
!     renders vector (x,y,z) coordinates of the nominal pixel center
!     for the pixel number ipix (NESTED scheme)
!     given the map resolution parameter nside
!     also returns the (x,y,z) position of the 4 pixel vertices (=corners)
!     in the order N,W,S,E
!=======================================================================
#ifdef DOI8B
  subroutine pix2vec_nest_8(nside, ipix, vector, vertex)
    integer(i4b), parameter :: MKD = i8b
#else
  subroutine pix2vec_nest  (nside, ipix, vector, vertex)
    integer(i4b), parameter :: MKD = i4b
#endif
    INTEGER(KIND=I4B), INTENT(IN) :: nside
    INTEGER(KIND=MKD), INTENT(IN) :: ipix
    REAL(KIND=DP),     INTENT(OUT), dimension(1:) :: vector
    REAL(KIND=DP),     INTENT(OUT), dimension(1:,1:), optional :: vertex

    INTEGER(KIND=MKD) :: npix, npface, ipf
    INTEGER(KIND=I4B) :: ip_low, ip_trunc, ip_med, ip_hi
    INTEGER(KIND=I4B) :: face_num, ix, iy, kshift, scale, i, ismax
    INTEGER(KIND=I4B) :: jrt, jr, nr, jpt, jp, nl4
    REAL(KIND=DP)     :: z, fn, fact1, fact2, sth, phi

    ! coordinate of the lowest corner of each face
    INTEGER(KIND=I4B), dimension(1:12) :: jrll = (/ 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4 /) ! in unit of nside
    INTEGER(KIND=I4B), dimension(1:12) :: jpll = (/ 1, 3, 5, 7, 0, 2, 4, 6, 1, 3, 5, 7 /) ! in unit of nside/2

    real(kind=DP) :: phi_nv, phi_wv, phi_sv, phi_ev, phi_up, phi_dn, sin_phi, cos_phi
    real(kind=DP) :: z_nv, z_sv, sth_nv, sth_sv
    real(kind=DP) :: hdelta_phi
    integer(kind=I4B) :: iphi_mod, iphi_rat
    logical(kind=LGT) :: do_vertex
    integer(kind=i4b) :: diff_phi
    character(len=*), parameter :: code = "pix2vec_nest"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       if (present(vertex)) then
          call pix2vec_nest(nside, int(ipix, kind=i4b), vector, vertex)
       else
          call pix2vec_nest(nside, int(ipix, kind=i4b), vector)
       endif
       return
    endif
#else
    if (nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)       ! total number of points
    if (ipix <0 .or. ipix>npix-1) call fatal_error(code//"> ipix out of range")

    !     initiates the array for the pixel number -> (x,y) mapping
    if (pix2x(1023) <= 0) call mk_pix2xy()

    npface = nside * int(nside, kind=MKD)
    nl4    = 4*nside

    !     finds the face, and the number in the face
    face_num = ipix/npface  ! face number in {0,11}
    ipf = MODULO(ipix,npface)  ! pixel number in the face {0,npface-1}

    do_vertex = .false.
    if (present(vertex)) then
       if (size(vertex,dim=1) >= 3 .and. size(vertex,dim=2) >= 4) then
          do_vertex = .true.
       else
          call fatal_error(code//">  vertex array has wrong size ")
       endif
    endif
    fn = real(nside, kind=dp)
    fact1 = 1.0_dp/(3.0_dp*fn*fn)
    fact2 = 2.0_dp/(3.0_dp*fn)

    !     finds the x,y on the face (starting from the lowest corner)
    !     from the pixel number
    if (nside <= ns_max4) then
       ip_low = iand(ipf,1023_MKD)       ! content of the last 10 bits
       ip_trunc =    ipf/1024        ! truncation of the last 10 bits
       ip_med = iand(ip_trunc,1023)  ! content of the next 10 bits
       ip_hi  =      ip_trunc/1024   ! content of the high weight 10 bits

       ix = 1024*pix2x(ip_hi) + 32*pix2x(ip_med) + pix2x(ip_low)
       iy = 1024*pix2y(ip_hi) + 32*pix2y(ip_med) + pix2y(ip_low)
    else
       ix = 0
       iy = 0
       scale = 1
       ismax = 4
       do i=0, ismax
          ip_low = iand(ipf,1023_MKD)
          ix = ix + scale * pix2x(ip_low)
          iy = iy + scale * pix2y(ip_low)
          scale = scale * 32
          ipf   = ipf/1024
       enddo
       ix = ix + scale * pix2x(ipf)
       iy = iy + scale * pix2y(ipf)
    endif

    !     transforms this in (horizontal, vertical) coordinates
    jrt = ix + iy  ! 'vertical' in {0,2*(nside-1)}
    jpt = ix - iy  ! 'horizontal' in {-nside+1,nside-1}

    !     computes the z coordinate on the sphere
    jr =  jrll(face_num+1)*nside - jrt - 1   ! ring number in {1,4*nside-1}


    if (jr < nside) then     ! north pole region
       nr = jr
       z = 1.0_dp - nr*fact1*nr
       sth = nr * sqrt(fact1 * (1.d0 + z) ) ! more accurate close to pole
       kshift = 0
       if (do_vertex) then
          z_nv = 1.0_dp - (nr-1)*fact1*(nr-1)
          z_sv = 1.0_dp - (nr+1)*fact1*(nr+1)
       endif

    else if (jr <= 3*nside) then ! equatorial region
       nr = nside
       z  = (2*nside-jr)*fact2
       sth = SQRT((1.0_dp-z)*(1.0_dp+z)) ! good enough on Equator
       kshift = iand(jr - nside, 1)
       if (do_vertex) then
          z_nv = (2*nside-jr+1)*fact2
          z_sv = (2*nside-jr-1)*fact2
          if (jr == nside) then ! northern transition
             z_nv =  1.0_dp - (nside-1) * fact1 * (nside-1)
          elseif (jr == 3*nside) then  ! southern transition
             z_sv = -1.0_dp + (nside-1) * fact1 * (nside-1)
          endif
       endif

    else if (jr > 3*nside) then ! south pole region
       nr = nl4 - jr
       z   = - 1.0_dp + nr*fact1*nr
       sth = nr * sqrt(fact1 * (1.d0 - z) )
       kshift = 0
       if (do_vertex) then
          z_nv = - 1.0_dp + (nr+1)*fact1*(nr+1)
          z_sv = - 1.0_dp + (nr-1)*fact1*(nr-1)
       endif
    endif

    !     computes the phi coordinate on the sphere, in [0,2Pi]
    jp = (jpll(face_num+1)*nr + jpt + 1_MKD + kshift)/2  ! 'phi' number in the ring in {1,4*nr}
    if (jp > nl4) jp = jp - nl4
    if (jp < 1)   jp = jp + nl4

    phi = (jp - (kshift+1)*0.5_dp) * (halfpi / nr)

    ! pixel center
    !
    cos_phi = cos(phi)
    sin_phi = sin(phi)
    vector(1) = sth * cos_phi
    vector(2) = sth * sin_phi
    vector(3) = z

    if (do_vertex) then
       phi_nv = phi
       phi_sv = phi
       diff_phi = 0 ! phi_nv = phi_sv = phi

       phi_up = 0.0_dp
       iphi_mod = MODULO(jp-1, nr) ! in {0,1,... nr-1}
       iphi_rat = (jp-1) / nr      ! in {0,1,2,3}
       if (nr > 1) phi_up = HALFPI * (iphi_rat +  iphi_mod   /real(nr-1,kind=dp))
       phi_dn             = HALFPI * (iphi_rat + (iphi_mod+1)/real(nr+1,kind=dp))
       if (jr < nside) then            ! North polar cap
          phi_nv = phi_up
          phi_sv = phi_dn
          diff_phi = 3 ! both phi_nv and phi_sv different from phi
       else if (jr > 3*nside) then     ! South polar cap
          phi_nv = phi_dn
          phi_sv = phi_up
          diff_phi = 3 ! both phi_nv and phi_sv different from phi
       else if (jr == nside) then      ! North transition
          phi_nv = phi_up
          diff_phi = 1
       else if (jr == 3*nside) then    ! South transition
          phi_sv = phi_up
          diff_phi = 2
       endif

       hdelta_phi = PI / (4.0_dp*nr)

       ! west vertex
       phi_wv      = phi - hdelta_phi
       vertex(1,2) = sth * COS(phi_wv)
       vertex(2,2) = sth * SIN(phi_wv)
       vertex(3,2) = z

       ! east vertex
       phi_ev      = phi + hdelta_phi
       vertex(1,4) = sth * COS(phi_ev)
       vertex(2,4) = sth * SIN(phi_ev)
       vertex(3,4) = z

       ! north and south vertices
       sth_nv = SQRT((1.0_dp-z_nv)*(1.0_dp+z_nv))
       sth_sv = SQRT((1.0_dp-z_sv)*(1.0_dp+z_sv))
       if (diff_phi == 0) then
          vertex(1,1) = sth_nv * cos_phi
          vertex(2,1) = sth_nv * sin_phi
          vertex(1,3) = sth_sv * cos_phi
          vertex(2,3) = sth_sv * sin_phi
       else
          vertex(1,1) = sth_nv * COS(phi_nv)
          vertex(2,1) = sth_nv * SIN(phi_nv)
          vertex(1,3) = sth_sv * COS(phi_sv)
          vertex(2,3) = sth_sv * SIN(phi_sv)
       endif
       vertex(3,1) = z_nv
       vertex(3,3) = z_sv
    endif

    return

#ifdef DOI8B
  end subroutine pix2vec_nest_8
#else
  end subroutine pix2vec_nest
#endif

!=======================================================================
!     ang2pix_nest
!
!     renders the pixel number ipix (NESTED scheme) for a pixel which contains
!     a point on a sphere at coordinates theta and phi, given the map
!     resolution parameter nside
!
! 2009-03-09: calculations done directly at nside rather than ns_max
!             with ifort, for x and y integers>0, 
!             iand(x,y-1) is slightly faster than modulo(x,y)
!=======================================================================
#ifdef DOI8B
  subroutine ang2pix_nest_8(nside, theta, phi, ipix)
    integer(i4b), parameter :: MKD = i8b
#else
  subroutine ang2pix_nest  (nside, theta, phi, ipix)
    integer(i4b), parameter :: MKD = i4b
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    REAL(KIND=DP),     INTENT(IN)  :: theta, phi
    INTEGER(KIND=MKD), INTENT(OUT) :: ipix

    integer(kind=MKD) :: ipf, scale, scale_factor
    REAL(KIND=DP)     ::  z, za, tt, tp, tmp
    INTEGER(KIND=I4B) :: jp, jm, ifp, ifm, face_num, &
         &     ix, iy, ix_low, iy_low, ntt, i, ismax, ipix4
    character(len=*), parameter :: code = "ang2pix_nest"
    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call ang2pix_nest(nside, theta, phi, ipix4)
       ipix = int(ipix4, kind=MKD)
       return
    endif
    if (nside <1 .or. nside > ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside <1 .or. nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    if (theta<0.0_dp .or. theta>pi)  then
       print*,code//"> theta : ",theta," is out of range [0,Pi]"
       call fatal_error
    endif
    if (x2pix1(127) <= 0) call mk_xy2pix1()

    z  = COS(theta)
    za = ABS(z)
    tt = MODULO(phi, twopi) / halfpi  ! in [0,4[

    if (za <= twothird) then ! equatorial region

       !        (the index of edge lines increase when the longitude=phi goes up)
       jp = INT(nside*(0.5_dp + tt - z*0.75_dp)) !  ascending edge line index
       jm = INT(nside*(0.5_dp + tt + z*0.75_dp)) ! descending edge line index

       !        finds the face
       ifp = jp / nside  ! in {0,4}
       ifm = jm / nside
       if (ifp == ifm) then          ! faces 4 to 7
          face_num = iand(ifp,3) + 4
       else if (ifp < ifm) then     ! (half-)faces 0 to 3
          face_num = iand(ifp,3)
       else                            ! (half-)faces 8 to 11
          face_num = iand(ifm,3) + 8
       endif

       ix =         iand(jm, nside-1)
       iy = nside - iand(jp, nside-1) - 1

    else ! polar region, za > 2/3

       ntt = INT(tt)
       if (ntt >= 4) ntt = 3
       tp = tt - ntt
!        tmp = SQRT( 3.0_dp*(1.0_dp - za) )  ! in ]0,1]
       if (z > 0.0_dp) then
          tmp = sqrt(6.0_dp) * sin( theta * 0.5_dp)
       else
          tmp = sqrt(6.0_dp) * cos( theta * 0.5_dp)
       endif

       !        (the index of edge lines increase when distance from the closest pole goes up)
       jp = INT( nside * tp          * tmp ) ! line going toward the pole as phi increases
       jm = INT( nside * (1.0_dp - tp) * tmp ) ! that one goes away of the closest pole
       jp = MIN(nside-1, jp) ! for points too close to the boundary
       jm = MIN(nside-1, jm)

       !        finds the face and pixel's (x,y)
       if (z >= 0) then
          face_num = ntt  ! in {0,3}
          ix = nside - jm - 1
          iy = nside - jp - 1
       else
          face_num = ntt + 8 ! in {8,11}
          ix =  jp
          iy =  jm
       endif

    endif

    if (nside <= ns_max4) then 
       ix_low = iand(ix, 127)
       iy_low = iand(iy, 127)
       ipf =     x2pix1(ix_low) + y2pix1(iy_low) &
            & + (x2pix1(ix/128) + y2pix1(iy/128)) * 16384
    else
       scale = 1_MKD
       scale_factor = 16384_MKD ! 128*128
       ipf = 0_MKD
       ismax = 1 ! for nside in [2^14, 2^20]
       if (nside >  1048576 ) ismax = 3
       do i=0, ismax
          ix_low = iand(ix, 127) ! last 7 bits
          iy_low = iand(iy, 127) ! last 7 bits
          ipf = ipf + (x2pix1(ix_low)+y2pix1(iy_low)) * scale
          scale = scale * scale_factor
          ix  =     ix / 128 ! truncate out last 7 bits
          iy  =     iy / 128
       enddo
       ipf =  ipf + (x2pix1(ix)+y2pix1(iy)) * scale
    endif
    ipix = ipf + face_num* int(nside,MKD) * nside    ! in {0, 12*nside**2 - 1}

    return

#ifdef DOI8B
  end subroutine ang2pix_nest_8
#else
  end subroutine ang2pix_nest
#endif

!=======================================================================
!     vec2pix_nest
!
!     renders the pixel number ipix (NESTED scheme) for a pixel which contains
!     a point on a sphere at coordinate vector (=x,y,z), given the map
!     resolution parameter nside
!
! 2009-03-10: calculations done directly at nside rather than ns_max
!=======================================================================
#ifdef DOI8B
  subroutine vec2pix_nest_8(nside, vector, ipix)
    integer(i4b), parameter :: MKD = I8B
    integer(i4b), parameter :: mykind = I4B ! replace with i8b to reach nside=2^29
#else
  subroutine vec2pix_nest  (nside, vector, ipix)
    integer(i4b), parameter :: MKD = I4B
    integer(i4b), parameter :: mykind = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)                :: nside
    REAL(KIND=DP),     INTENT(IN), dimension(1:) :: vector
    INTEGER(KIND=MKD), INTENT(OUT)               :: ipix

    integer(kind=MKD) :: ipf, scale, scale_factor
    REAL(KIND=DP)     ::  z, za, tt, tp, tmp, dnorm, phi
    INTEGER(KIND=I4B) ::  jp, jm, ifp, ifm, face_num, &
         &     ix, iy, ix_low, iy_low, ntt, i, ismax, ipix4
    character(len=*), parameter :: code = "vec2pix_nest"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       call vec2pix_nest(nside, vector, ipix4)
       ipix = int(ipix4, kind=MKD)
       return
    endif
    if (nside<1 .or. nside>ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside<1 .or. nside>ns_max4) call fatal_error(code//"> nside out of range")
#endif
    dnorm = SQRT(vector(1)**2+vector(2)**2+vector(3)**2)
    z = vector(3) / dnorm
    phi = 0.0_dp
    if (vector(1) /= 0.0_dp .or. vector(2) /= 0.0_dp) &
         &     phi = ATAN2(vector(2),vector(1)) ! phi in ]-pi,pi]

    za = ABS(z)
    if (phi < 0.0)    phi = phi + twopi ! phi in [0,2pi[
    tt = phi / halfpi ! in [0,4[
    if (x2pix1(127) <= 0) call mk_xy2pix1()

    if (za <= twothird) then ! equatorial region

       !        (the index of edge lines increase when the longitude=phi goes up)
       jp = INT(nside*(0.5_dp + tt - z*0.75_dp)) !  ascending edge line index
       jm = INT(nside*(0.5_dp + tt + z*0.75_dp)) ! descending edge line index

       !        finds the face
       ifp = jp / nside  ! in {0,4}
       ifm = jm / nside
       if (ifp == ifm) then          ! faces 4 to 7
          face_num = iand(ifp,3) + 4
       else if (ifp < ifm) then     ! (half-)faces 0 to 3
          face_num = iand(ifp,3)
       else                            ! (half-)faces 8 to 11
          face_num = iand(ifm,3) + 8
       endif

       ix =         iand(jm, nside-1)
       iy = nside - iand(jp, nside-1) - 1

    else ! polar region, za > 2/3

       ntt = INT(tt)
       if (ntt >= 4) ntt = 3
       tp = tt - ntt
       !tmp = SQRT( 3.0_dp*(1.0_dp - za) )  ! in ]0,1]
       tmp = SQRT(vector(1)**2+vector(2)**2) / dnorm ! sin(theta)
       tmp = tmp * SQRT( 3.0_dp / (1.0_dp + za) ) !more accurate

       !        (the index of edge lines increase when distance from the closest pole goes up)
       jp = INT( nside * tp          * tmp ) ! line going toward the pole as phi increases
       jm = INT( nside * (1.0_dp - tp) * tmp ) ! that one goes away of the closest pole
       jp = MIN(nside-1, jp) ! for points too close to the boundary
       jm = MIN(nside-1, jm)

       !        finds the face and pixel's (x,y)
       if (z >= 0) then
          face_num = ntt  ! in {0,3}
          ix = nside - jm - 1
          iy = nside - jp - 1
       else
          face_num = ntt + 8 ! in {8,11}
          ix =  jp
          iy =  jm
       endif

    endif

    if (nside <= ns_max4) then 
       ix_low = iand(ix, 127)
       iy_low = iand(iy, 127)
       ipf =     x2pix1(ix_low) + y2pix1(iy_low) &
            & + (x2pix1(ix/128) + y2pix1(iy/128)) * 16384
    else
       scale = 1_MKD
       scale_factor = 16384_MKD ! 128*128
       ipf = 0_MKD
       ismax = 1 ! for nside in [2^14, 2^20]
       if (nside >  1048576 ) ismax = 3
       do i=0, ismax
          ix_low = iand(ix, 127) ! last 7 bits
          iy_low = iand(iy, 127) ! last 7 bits
          ipf = ipf + (x2pix1(ix_low)+y2pix1(iy_low)) * scale
          scale = scale * scale_factor
          ix  =     ix / 128 ! truncate out last 7 bits
          iy  =     iy / 128
       enddo
       ipf =  ipf + (x2pix1(ix)+y2pix1(iy)) * scale
    endif
    ipix = ipf + face_num* int(nside,MKD) * nside    ! in {0, 12*nside**2 - 1}

    return
#ifdef DOI8B
  end subroutine vec2pix_nest_8
#else
  end subroutine vec2pix_nest
#endif

!=======================================================================
!     nest2ring
!
!     performs conversion from NESTED to RING pixel number
!=======================================================================
#ifdef DOI8B
  subroutine nest2ring_8(nside, ipnest, ipring)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine nest2ring  (nside, ipnest, ipring)
    integer(i4b), parameter :: MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    INTEGER(KIND=MKD), INTENT(IN)  :: ipnest
    INTEGER(KIND=MKD), INTENT(OUT) :: ipring

    INTEGER(KIND=MKD) :: npix, npface, n_before, ipf
    INTEGER(KIND=I4B) :: ip_low, ip_trunc, ip_med, ip_hi
    INTEGER(KIND=I4B) :: face_num, ix, iy, kshift, scale, i, ismax
    INTEGER(KIND=I4B) :: jrt, jr, nr, jpt, jp, nl4
    integer(kind=i4b) :: ipring4, ipnest4
    character(len=*), parameter :: code = "nest2ring"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       ipnest4 = ipnest
       call nest2ring(nside, ipnest4, ipring4)
       ipring = ipring4
       return
    endif
#else
    if (nside>ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)
    if (ipnest<0 .or. ipnest>npix-1) call fatal_error(code//"> ipnest out of range")

    !     initiates the array for the pixel number -> (x,y) mapping
    if (pix2x(1023) <= 0) call mk_pix2xy()

    npface = nside*int(nside, MKD)
    nl4    = 4*nside

    !     finds the face, and the number in the face
    face_num = ipnest/npface  ! face number in {0,11}
    ipf = iand(ipnest, npface-1)  ! pixel number in the face {0,npface-1}

    !     finds the x,y on the face (starting from the lowest corner)
    !     from the pixel number
    if (nside <= ns_max4) then
       ip_low = iand(ipf,1023_MKD)       ! content of the last 10 bits
       ip_trunc =    ipf/1024        ! truncation of the last 10 bits
       ip_med = iand(ip_trunc,1023)  ! content of the next 10 bits
       ip_hi  =      ip_trunc/1024   ! content of the high weight 10 bits

       ix = 1024*pix2x(ip_hi) + 32*pix2x(ip_med) + pix2x(ip_low)
       iy = 1024*pix2y(ip_hi) + 32*pix2y(ip_med) + pix2y(ip_low)
    else
       ix = 0
       iy = 0
       scale = 1
       ismax = 4
       do i=0, ismax
          ip_low = iand(ipf,1023_MKD)
          ix = ix + scale * pix2x(ip_low)
          iy = iy + scale * pix2y(ip_low)
          scale = scale * 32
          ipf   = ipf/1024
       enddo
       ix = ix + scale * pix2x(ipf)
       iy = iy + scale * pix2y(ipf)
    endif

    !     transforms this in (horizontal, vertical) coordinates
    jrt = ix + iy  ! 'vertical' in {0,2*(nside-1)}
    jpt = ix - iy  ! 'horizontal' in {-nside+1,nside-1}

    !     computes the z coordinate on the sphere
    jr =  jrll1(face_num)*nside - jrt - 1   ! ring number in {1,4*nside-1}

    if (jr < nside) then     ! north pole region
       nr = jr
       n_before = 2 * nr * (nr - 1_MKD)
       kshift = 0

    else if (jr <= 3*nside) then  ! equatorial region (the most frequent)
       nr = nside                
       n_before = 2 * nr * ( 2 * jr - nr - 1_MKD)
       kshift = iand(jr - nside, 1)

    else ! south pole region
       nr = nl4 - jr
       n_before = npix - 2 * nr * (nr + 1_MKD)
       kshift = 0

    endif

    !     computes the phi coordinate on the sphere, in [0,2Pi]
    jp = (jpll1(face_num)*nr + jpt + 1_MKD + kshift)/2  ! 'phi' number in the ring in {1,4*nr}
    if (jp > nl4) jp = jp - nl4
    if (jp < 1)   jp = jp + nl4

    ipring = n_before + jp - 1_MKD ! in {0, npix-1}

    return

#ifdef DOI8B
  end subroutine nest2ring_8
#else
  end subroutine nest2ring
#endif

!=======================================================================
!     ring2nest
!
!     performs conversion from RING to NESTED pixel number
!=======================================================================
#ifdef DOI8B
  subroutine ring2nest_8(nside, ipring, ipnest)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine ring2nest  (nside, ipring, ipnest)
    integer(i4b), parameter :: MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    INTEGER(KIND=MKD), INTENT(IN)  :: ipring
    INTEGER(KIND=MKD), INTENT(OUT) :: ipnest

    INTEGER(KIND=MKD) :: npix, ncap, ip
    INTEGER(KIND=MKD) :: scale, scale_factor
    INTEGER(KIND=I4B) :: nl2, nl4, iphi, ipt, &
         &     kshift, face_num, nr, &
         &     irn, ire, irm, irs, irt, ifm , ifp, &
         &     ix, iy, ix_low, iy_low, ipf, i, ismax
    integer(kind=i4b) :: ipring4, ipnest4
    character(len=*), parameter :: code = "ring2nest"

    !-----------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       ipring4 = ipring
       call ring2nest(nside, ipring4, ipnest4)
       ipnest = ipnest4
       return
    endif
#else
    if (nside>ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside)
    if (ipring <0 .or. ipring>npix-1) call fatal_error(code//"> ipring out of range")

    if (x2pix1(127) <= 0) call mk_xy2pix1()

    nl2 = 2*nside
    nl4 = 4*nside
    ncap = nl2*(nside-1_MKD) ! points in each polar cap, =0 for nside =1

    !     finds the ring number, the position of the ring and the face number
    if (ipring < ncap) then ! north polar cap

!       irn   = nint( sqrt( (ipring+1) * 0.50000_dp)) ! counted from North pole
       irn   = (cheap_isqrt(2*ipring+2) + 1) / 2 ! counted from North pole
       iphi  = ipring - 2*irn*(irn - 1_MKD)
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(1, irn, iphi)
! #endif

       kshift = 0
       nr = irn                  ! 1/4 of the number of points on the current ring
       face_num = iphi / irn ! in {0,3}

    elseif (ipring < npix - ncap) then ! equatorial region

       ip    = ipring - ncap
       irn   = INT( ip / nl4 ) + nside               ! counted from North pole
       iphi  = iand(ip, nl4-1_MKD)

       kshift  = iand(irn+nside,1) ! MODULO(irn+nside,2)  ! 1 if irn+nside is odd, 0 otherwise
       nr = nside
       ire =  irn - nside + 1 ! in {1, 2*nside +1}
       irm =  nl2 + 2 - ire
       ifm = (iphi - ire/2 + nside) / nside ! face boundary
       ifp = (iphi - irm/2 + nside) / nside
       if (ifp == ifm) then          ! faces 4 to 7
          face_num = iand(ifp,3) + 4
       else if (ifp < ifm) then ! (half-)faces 0 to 3
          face_num = ifp
       else ! (half-)faces 8 to 11
          face_num = ifp + 7
       endif

    else ! south polar cap

       ip    = npix - ipring
!       irs   = nint( sqrt( ip * 0.500000_dp) )  ! counted from South pole
       irs   = (cheap_isqrt(2*ip) +1)/2  ! counted from South pole
       iphi  = 2*irs*(irs + 1_MKD) - ip
! #ifdef DOI8B
!        ! fix round-off error appearing at large Nside
!        call correct_ring_phi(-1, irs, iphi)
! #endif

       kshift = 0
       nr = irs
       irn   = nl4 - irs
       face_num = iphi / irs + 8 ! in {8,11}

    endif

    !     finds the (x,y) on the face
    irt =   irn  - jrll1(face_num)*nside + 1       ! in {-nside+1,0}
    ipt = 2*iphi - jpll1(face_num)*nr - kshift + 1 ! in {-nside+1,nside-1}
    if (ipt >= nl2) ipt = ipt - 8*nside ! for the face #4

    ix =  (ipt - irt ) / 2
    iy = -(ipt + irt ) / 2

    if (nside <= ns_max4) then 
       ix_low = iand(ix, 127)
       iy_low = iand(iy, 127)
       ipf =     x2pix1(ix_low) + y2pix1(iy_low) &
            & + (x2pix1(ix/128) + y2pix1(iy/128)) * 16384
    else
       scale = 1_MKD
       scale_factor = 16384_MKD ! 128*128
       ipf = 0_MKD
       ismax = 1 ! for nside in [2^14, 2^20]
       if (nside >  1048576 ) ismax = 3
       do i=0, ismax
          ix_low = iand(ix, 127) ! last 7 bits
          iy_low = iand(iy, 127) ! last 7 bits
          ipf = ipf + (x2pix1(ix_low)+y2pix1(iy_low)) * scale
          scale = scale * scale_factor
          ix  =     ix / 128 ! truncate out last 7 bits
          iy  =     iy / 128
       enddo
       ipf =  ipf + (x2pix1(ix)+y2pix1(iy)) * scale
    endif
    ipnest = ipf + face_num* (npix/12)    ! in {0, 12*nside**2 - 1}

    return

#ifdef DOI8B
  end subroutine ring2nest_8
#else
  end subroutine ring2nest
#endif

!=======================================================================
!   npix2nside
!
! given npix, returns nside such that npix = 12*nside^2
!  nside should be a power of 2 smaller than ns_max
!  if not, -1 is returned
! EH, Feb-2000
! 2009-03-05, edited, accepts 8-byte npix
!=======================================================================
#ifdef DOI8B
  function npix2nside_8(npix) result(nside_result)
    integer(i4b), parameter :: MKD = I8B
    INTEGER(KIND=MKD), PARAMETER  :: npix_max = (12_MKD*ns_max)*ns_max
#else
  function npix2nside  (npix) result(nside_result)
    integer(i4b), parameter :: MKD = I4B
    INTEGER(KIND=MKD), PARAMETER  :: npix_max = (12_MKD*ns_max4)*ns_max4
#endif
    INTEGER(KIND=MKD), INTENT(IN) :: npix
    INTEGER(KIND=MKD)             :: npix1, npix2
    INTEGER(KIND=I4B)             :: nside_result
    INTEGER(KIND=I4B)             :: nside
    CHARACTER(LEN=*),  PARAMETER  :: code = "npix2nside"
    !=======================================================================

    if (npix < 12 .or. npix > npix_max) then
       print*, code//"> Npix="//trim(string(npix))// &
            & " is out of allowed range: {12,"//trim(string(npix_max))//"}"
       nside = -1
       goto 1
    endif

    nside = NINT( sqrt(npix/12.0_dp) )
    npix1 = (12_MKD*nside)*nside
    if (abs(npix1-npix) > 0) then
       print*, code//"> Npix="//trim(string(npix))// &
            & " is not 12 * Nside * Nside "
       nside = -1
       goto 1
    endif

    ! test validity of Nside
    npix2 = nside2npix(nside)
    if (npix2 < 0) then
       nside = -1
       goto 1
    endif

1   continue
    nside_result = nside
    return

#ifdef DOI8B
  end function npix2nside_8
#else
  end function npix2nside
#endif


!=======================================================================
! in_ring
!     returns the list of pixels in RING or NESTED scheme (listir)
!     and their number (nir)
!     with latitude in [phi0-dphi, phi0+dphi] on the ring ir
!     (in {1,4*nside-1})
!     the pixel id-numbers are in {0,12*nside^2-1}
!     the indexing is RING, unless NEST is set to 1
!=======================================================================
#ifdef DOI8B
  subroutine in_ring_8(nside, iz, phi0, dphi, listir, nir, nest)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine in_ring (nside, iz, phi0, dphi, listir, nir, nest)
    integer(i4b), parameter :: MKD = I4B
#endif
    !=======================================================================
    integer(kind=i4b), intent(in)                 :: nside, iz
    integer(kind=i4b), intent(out)                :: nir
    real(kind=dp),     intent(in)                 :: phi0, dphi
    integer(kind=MKD), intent(out), dimension(0:) :: listir
    integer(kind=i4b), intent(in), optional       :: nest

!     logical(kind=lgt) :: conservative = .true.
    logical(kind=lgt) :: conservative = .false.
    logical(kind=lgt) :: take_all, to_top, do_ring

    integer(kind=i4b) :: i, diff
    integer(kind=i4b) :: nir1, nir2, ir, kshift
    integer(kind=MKD) :: ii, in, inext, npix, ncap, ipix1, ipix2
    integer(kind=MKD) :: ip_low, ip_hi, nr
    real(kind=dp)     :: phi_low, phi_hi, shift
    !=======================================================================

    take_all = .false.
    to_top   = .false.
    do_ring  = .true.
    if (present(nest)) then
       do_ring = (nest == 0)
    endif
    npix = (12_MKD * nside) * nside
    ncap  = 2*nside*(nside-1_MKD) ! number of pixels in the north polar cap
    listir = -1_MKD
    nir = 0

    phi_low = MODULO(phi0 - dphi, twopi)
    phi_hi  = MODULO(phi0 + dphi, twopi)
    if (ABS(dphi-PI) < 1.0e-6_dp) take_all = .true.

    !     ------------ identifies ring number --------------
    if (iz >= nside .and. iz <= 3*nside) then ! equatorial region
       ir = iz - nside + 1  ! in {1, 2*nside + 1}
       ipix1 = ncap  + 4*nside*(ir-1_MKD) !  lowest pixel number in the ring
       ipix2 = ipix1 + 4*nside - 1_MKD    ! highest pixel number in the ring
       kshift = MODULO(ir,2)
       nr = nside*4
    else
       if (iz < nside) then       !    north pole
          ir = iz
          ipix1 = 2*ir*(ir-1_MKD)        !  lowest pixel number in the ring
          ipix2 = ipix1 + 4*ir - 1_MKD   ! highest pixel number in the ring
       else                          !    south pole
          ir = 4*nside - iz
          ipix1 = npix - 2*ir*(ir+1_MKD) !  lowest pixel number in the ring
          ipix2 = ipix1 + 4*ir - 1_MKD   ! highest pixel number in the ring
       endif
       nr = ir*4
       kshift = 1
    endif

    !     ----------- constructs the pixel list --------------
    if (take_all) then
       nir    = ipix2 - ipix1 + 1
       if (do_ring) then
          listir(0:nir-1) = (/ (ii, ii=ipix1,ipix2) /)
       else
          call ring2nest(nside, ipix1, in)
          listir(0) = in
          do i=1,nir-1
             call next_in_line_nest(nside, in, inext)
             in = inext
             listir(i) = in
          enddo
       endif
       return
    endif

    shift = kshift * 0.5_dp
    if (conservative) then
       ! conservative : include every intersected pixels,
       ! even if pixel CENTER is not in the range [phi_low, phi_hi]
       ip_low = nint (nr * phi_low / TWOPI - shift, kind=MKD)
       ip_hi  = nint (nr * phi_hi  / TWOPI - shift, kind=MKD)
       ip_low = modulo (ip_low, nr) ! in {0,nr-1}
       ip_hi  = modulo (ip_hi , nr) ! in {0,nr-1}
    else
       ! strict : include only pixels whose CENTER is in [phi_low, phi_hi]
       ip_low = ceiling (nr * phi_low / TWOPI - shift, kind=MKD)
       ip_hi  = floor   (nr * phi_hi  / TWOPI - shift, kind=MKD)
!        if ((ip_low - ip_hi == 1) .and. (dphi*nr < PI)) then ! EH, 2004-06-01
       diff = modulo(ip_low - ip_hi, nr) ! in {-nr+1, nr-1} or {0,nr-1} ???
       if (diff < 0) diff = diff + nr    ! in {0,nr-1}
       if ((diff == 1) .and. (dphi*nr < PI)) then
          ! the interval is so small (and away from pixel center)
          ! that no pixel is included in it
          nir = 0
          return
       endif
!        ip_low = min(ip_low, nr-1) !  EH, 2004-05-28
!        ip_hi  = max(ip_hi , 0   )
       if (ip_low >= nr) ip_low = ip_low - nr
       if (ip_hi  <  0 ) ip_hi  = ip_hi  + nr
    endif
    !
    if (ip_low > ip_hi) to_top = .true.
    ip_low = ip_low + ipix1
    ip_hi  = ip_hi  + ipix1

    if (to_top) then
       nir1 = ipix2 - ip_low + 1
       nir2 = ip_hi - ipix1  + 1
       nir  = nir1 + nir2
       if (do_ring) then
          listir(0:nir1-1)   = (/ (ii, ii=ip_low, ipix2) /)
          listir(nir1:nir-1) = (/ (ii, ii=ipix1, ip_hi) /)
       else
          call ring2nest(nside, ip_low, in)
          listir(0) = in
          do i=1,nir-1
             call next_in_line_nest(nside, in, inext)
             in = inext
             listir(i) = in
          enddo
       endif
    else
       nir = ip_hi - ip_low + 1
       if (do_ring) then
          listir(0:nir-1) = (/ (ii, ii=ip_low, ip_hi) /)
       else
          call ring2nest(nside, ip_low, in)
          listir(0) = in
          do i=1,nir-1
             call next_in_line_nest(nside, in, inext)
             in = inext
             listir(i) = in
          enddo
       endif
    endif

    return
#ifdef DOI8B
  end subroutine in_ring_8
#else
  end subroutine in_ring
#endif

  !=======================================================================
#ifdef DOI8B
  subroutine getdisc_ring_8( nside, vector0, radius, listpix, nlist)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine getdisc_ring ( nside, vector0, radius, listpix, nlist)
    integer(i4b), parameter :: MKD = I4B
#endif

    integer(kind=I4B), intent(in)                 :: nside
    real(kind=DP),     intent(in), dimension(1:)  :: vector0
    real(kind=DP),     intent(in)                 :: radius
    integer(kind=MKD), intent(out), dimension(0:) :: listpix
    integer(kind=MKD), intent(out)                :: nlist
  !=======================================================================

    print*,"-------------------------------------------------------------"
    print*,"WARNING : the routine getdisc_ring is now obsolete"
    print*,"  Use "
    print*," call query_disc(nside, vector0, radius_radian, listpix, nlist [, nest]) "
    print*,"  instead (same module)"
    print*," It lets you choose the indexing scheme (RING or NESTED) "
    print*," used for the outuput"
    print*,"-------------------------------------------------------------"

    call query_disc(nside, vector0, radius, listpix, nlist)

    return

#ifdef DOI8B
  end subroutine getdisc_ring_8
#else
  end subroutine getdisc_ring
#endif

!=======================================================================
#ifdef DOI8B
  subroutine query_disc_old_8( nside, vector0, radius, listpix, nlist, nest, inclusive)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine query_disc_old ( nside, vector0, radius, listpix, nlist, nest, inclusive)
    integer(i4b), parameter :: MKD = I4B
#endif
    !=======================================================================

    integer(kind=I4B), intent(in)                 :: nside
    real(kind=DP),     intent(in), dimension(1:)  :: vector0
    real(kind=DP),     intent(in)                 :: radius
    integer(kind=MKD), intent(out), dimension(0:) :: listpix
    integer(kind=MKD), intent(out)                :: nlist
    integer(kind=I4B), intent(in), optional       :: nest
    integer(kind=I4B), intent(in), optional       :: inclusive

    INTEGER(kind=I4B) :: irmin, irmax, iz, ip, nir
    REAL(kind=DP) :: norm_vect0
    REAL(kind=DP) :: x0, y0, z0, radius_eff, fudge
    REAL(kind=DP) :: a, b, c, cosang
    REAL(kind=DP) :: dth1, dth2
    REAL(kind=DP) :: phi0, cosphi0, cosdphi, dphi
    REAL(kind=DP) :: rlat0, rlat1, rlat2, zmin, zmax, z
    INTEGER(kind=MKD), DIMENSION(:),   ALLOCATABLE  :: listir
    integer(kind=MKD) :: npix, list_size, nlost, ilist
    INTEGER(kind=I4B) :: status
    character(len=*), parameter :: code = "QUERY_DISC_OLD"
    logical(kind=LGT) :: do_inclusive
    integer(kind=I4B)                             :: my_nest

    !=======================================================================

    list_size = long_size(listpix)
    !     ---------- check inputs ----------------
    npix = nside2npix(nside)

    if (radius < 0.0_dp .or. radius > PI) then
       write(unit=*,fmt="(a)") code//"> the angular radius is in RADIAN "
       write(unit=*,fmt="(a)") code//"> and should lie in [0,Pi] "
       call fatal_error("> program abort ")
    endif

    do_inclusive = .false.
    if (present(inclusive)) then
       if (inclusive == 1) do_inclusive = .true.
    endif

    my_nest = 0
    if (present(nest)) then
       if (nest == 0 .or. nest == 1) then
          my_nest = nest
       else
          print*,code//"> NEST should be 0 or 1"
          call fatal_error("> program abort ")
       endif
    endif

    !     --------- allocate memory -------------
    ALLOCATE( listir(0: 4*nside-1), STAT = status)
    if (status /= 0) then
       write(unit=*,fmt="(a)") code//"> can not allocate memory for listir :"
       call fatal_error("> program abort ")
    endif

    dth1 = 1.0_dp / (3.0_dp*real(nside,kind=dp)**2)
    dth2 = 2.0_dp / (3.0_dp*real(nside,kind=dp))

    radius_eff = radius
    if (do_inclusive) then
! !        fudge = PI / (4.0_dp*nside) ! increase radius by half pixel size
!        fudge = acos(TWOTHIRD) / real(nside,kind=dp) ! 1.071* half pixel size
!        radius_eff = radius + fudge
       radius_eff = fudge_query_radius(nside, radius)
    endif
    cosang = COS(radius_eff)

    !     ---------- circle center -------------
    norm_vect0 =  SQRT(DOT_PRODUCT(vector0,vector0))
    x0 = vector0(1) / norm_vect0
    y0 = vector0(2) / norm_vect0
    z0 = vector0(3) / norm_vect0

    phi0=0.0_dp
    if ((x0/=0.0_dp).or.(y0/=0.0_dp)) phi0 = ATAN2 (y0, x0)  ! in ]-Pi, Pi]
    cosphi0 = COS(phi0)
    a = x0*x0 + y0*y0

    !     --- coordinate z of highest and lowest points in the disc ---
    rlat0  = ASIN(z0)    ! latitude in RAD of the center
    rlat1  = rlat0 + radius_eff
    rlat2  = rlat0 - radius_eff
    if (rlat1 >=  halfpi) then
       zmax =  1.0_dp
    else
       zmax = SIN(rlat1)
    endif
    irmin = ring_num(nside, zmax)
    irmin = MAX(1, irmin - 1) ! start from a higher point, to be safe

    if (rlat2 <= -halfpi) then
       zmin = -1.0_dp
    else
       zmin = SIN(rlat2)
    endif
    irmax = ring_num(nside, zmin)
    irmax = MIN(4*nside-1, irmax + 1) ! go down to a lower point

    ilist = -1_MKD

    !     ------------- loop on ring number ---------------------
    do iz = irmin, irmax

       z = ring2z(nside, iz) 

       !        --------- phi range in the disc for each z ---------
       b = cosang - z*z0
       c = 1.0_dp - z*z
       if ((x0==0.0_dp).and.(y0==0.0_dp)) then
          dphi=PI
          if (b > 0.0_dp) goto 1000 ! out of the disc, 2008-03-30
          goto 500
       endif
       cosdphi = b / SQRT(a*c)
       if (ABS(cosdphi) <= 1.0_dp) then
          dphi = ACOS (cosdphi) ! in [0,Pi]
       else
          if (cosphi0 < cosdphi) goto 1000 ! out of the disc
          dphi = PI ! all the pixels at this elevation are in the disc
       endif
500    continue

       !        ------- finds pixels in the disc ---------
       call in_ring(nside, iz, phi0, dphi, listir, nir, nest=my_nest)

       !        ----------- merge pixel lists -----------
       nlost = ilist + nir + 1_MKD - list_size
       if ( nlost > 0 ) then
          print*,code//"> listpix is too short, it will be truncated at ",nir
          print*,"                         pixels lost : ", nlost
          nir = nir - nlost
       endif
       do ip = 0, nir-1
          ilist = ilist + 1_MKD
          listpix(ilist) = listir(ip)
       enddo

1000   continue
    enddo

    !     ------ total number of pixel in the disc --------
    nlist = ilist + 1_MKD


    !     ------- deallocate memory and exit ------
    DEALLOCATE(listir)

    return

#ifdef DOI8B
  end subroutine query_disc_old_8
#else
  end subroutine query_disc_old
#endif


  !=======================================================================
#ifdef DOI8B
  subroutine discedge2fulldisc_8( nside, ringphi, ngr, list, nlist)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine discedge2fulldisc( nside, ringphi, ngr, list, nlist)
    integer(i4b), parameter :: MKD = I4B
#endif
    !=======================================================================
    integer(i4b), intent(in) :: nside
    integer(i4b), dimension(1:3,1:ngr), intent(in) :: ringphi
    integer(i4b),                       intent(in) :: ngr
    integer(MKD), dimension(1:),        intent(out) :: list
    integer(MKD),                       intent(out) :: nlist
    !
    integer(i4b) :: j, jr_min, jr_max, nj, nr, kshift, np, my_low, my_hi
    integer(i4b) :: ir, i, ip
    integer(i8b) :: npc, listsize
    !=======================================================================
    
    listsize = long_size(list)
    nlist = 0_MKD
    if (ngr == 0) then ! no valid rings
       list(1) = -1
       return
    endif

    do j=0, ngr-1
       ir = ringphi(1, j+1)             ! current ring, in [1, nl4-1]
       call pixels_per_ring(nside, ir, nr, kshift, npc)
       my_low = ringphi(2, j+1)
       if (my_low >= 0) then
          my_hi  = ringphi(3, j+1)
          np = my_hi - my_low     ! in [-nr+1, nr-1]
          np = modulo(np, nr) + 1 ! deal with periodic BC
          np = min(np, nr)
          if (nlist + np > listsize) then
             print*,'Pixel query: too many pixels found for output list provided.'
             print*,'truncated at ',nlist
             return
          endif
          do i=0, np-1
             ip = modulo(my_low + i, nr)
             list(nlist+1+i) = npc - nr + ip ! fill final list
          enddo
          nlist = nlist + np
       endif
    enddo
    
    if (nlist == 0) list(1) = -1
    
    return
#ifdef DOI8B
  end subroutine discedge2fulldisc_8
#else
  end subroutine discedge2fulldisc
#endif

!=======================================================================
!
!      query_disc (Nside, Vector0, Radius, Listpix, Nlist[, Nest, Inclusive])
!      ----------
!      routine for pixel query in the RING or NESTED scheme
!      all pixels within an angular distance Radius of the center
!
!     Nside    = resolution parameter (a power of 2)
!     Vector0  = central point vector position (x,y,z in double precision)
!     Radius   = angular radius in RADIAN (in double precision)
!     Listpix  = list of pixel closer to the center (angular distance) than Radius
!     Nlist    = number of pixels in the list
!     nest  (OPT), :0 by default, the output list is in RING scheme
!                  if set to 1, the output list is in NESTED scheme
!     inclusive (OPT) , :0 by default, only the pixels whose center
!                       lie in the triangle are listed on output
!                  if set to 1, all pixels overlapping the triangle are output
!
!      * all pixel numbers are in {0, 12*Nside*Nside - 1}
!     NB : the dimension of the listpix array is fixed in the calling
!     routine and should be large enough for the specific configuration
!
!      lower level subroutines called by getdisc_ring :
!       (you don't need to know them)
!      x=fudge_query_radius()
!      x=ring_num (nside, ir)
!      x=ring2z()
!      discphirange_at_z()
!      pixels_on_edge()
!      check_edge_pixels()
!      discedge2fulldisc()
!      -------
!
! v1.0, EH, TAC, ??
! v1.1, EH, Caltech, Dec-2001
! v1.2, EH, IAP, 2008-03-30: fixed bug appearing when disc centered on either pole
! 2009-06-17: deals with Nside > 8192
! 2011-06-09: uses ring2z
! 2011-10-18: improve fudge radius determination.
! New algorithm for Inclusive case: test boundary of edge pixels on each ring
!    2013-04-02: bug correction in query_disc in inclusive mode
!    2014-07-07: bug correction in discedge2fulldisc
    !=======================================================================
#ifdef DOI8B
  subroutine query_disc_8( nside, vector0, radius, listpix, nlist, nest, inclusive)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine query_disc ( nside, vector0, radius, listpix, nlist, nest, inclusive)
    integer(i4b), parameter :: MKD = I4B
#endif
    !=======================================================================
    integer(kind=I4B), intent(in)                 :: nside
    real(kind=DP),     intent(in), dimension(1:)  :: vector0
    real(kind=DP),     intent(in)                 :: radius
    integer(kind=MKD), intent(out), dimension(0:) :: listpix
    integer(kind=MKD), intent(out)                :: nlist
    integer(kind=I4B), intent(in), optional       :: nest
    integer(kind=I4B), intent(in), optional       :: inclusive

    INTEGER(kind=I4B) :: irmin, irmax, iz, ip, nir, nr, ngr, nrh
    REAL(kind=DP) :: norm_vect0
    REAL(kind=DP) :: z0, radius_eff, fudge
    REAL(kind=DP) :: phi0, dphi
    REAL(kind=DP) :: rlat0, rlat1, rlat2, zmin, zmax, z
    integer(kind=MKD) :: npix, list_size, nlost, ilist
    INTEGER(kind=I4B) :: status
    character(len=*), parameter :: code = "QUERY_DISC"
    logical(kind=LGT) :: do_inclusive
    integer(kind=I4B) :: my_nest
!    real(dp), allocatable, dimension(:) :: ztab, dphitab
    real(dp), dimension(1:4*nside-1) :: ztab, dphitab
    real(dp), dimension(:), allocatable :: zlist, dphilist
    integer(i4b), dimension(1:3, 1:4*nside-1) :: ringphi
    integer(i4b) :: nsideh, nsboost
    real(dp) :: radiush

    !=======================================================================

    list_size = long_size(listpix)
    !     ---------- check inputs ----------------
    npix = nside2npix(nside)

    if (radius < 0.0_dp .or. radius > PI) then
       write(unit=*,fmt="(a)") code//"> the angular radius is in RADIAN "
       write(unit=*,fmt="(a)") code//"> and should lie in [0,Pi] "
       call fatal_error("> program abort ")
    endif

    do_inclusive = .false.
    if (present(inclusive)) then
       if (inclusive == 1) do_inclusive = .true.
    endif

    my_nest = 0
    if (present(nest)) then
       if (nest == 0 .or. nest == 1) then
          my_nest = nest
       else
          print*,code//"> NEST should be 0 or 1"
          call fatal_error("> program abort ")
       endif
    endif

    radius_eff = radius
    if (do_inclusive) radius_eff = fudge_query_radius(nside, radius)

    !     ---------- circle center -------------
    norm_vect0 =  SQRT(DOT_PRODUCT(vector0,vector0))
    z0 = vector0(3) / norm_vect0

    !     --- coordinate z of highest and lowest points in the disc ---
    rlat0  = ASIN(z0)    ! latitude in RAD of the center
    rlat1  = rlat0 + radius_eff
    rlat2  = rlat0 - radius_eff
    if (rlat1 >=  halfpi) then
       zmax =  1.0_dp
    else
       zmax = SIN(rlat1)
    endif
    irmin = ring_num(nside, zmax)
    irmin = MAX(1, irmin - 1) ! start from a higher point, to be safe

    if (rlat2 <= -halfpi) then
       zmin = -1.0_dp
    else
       zmin = SIN(rlat2)
    endif
    irmax = ring_num(nside, zmin)
    irmax = MIN(4*nside-1, irmax + 1) ! go down to a lower point

    nr = irmax-irmin+1 ! in [1, 4*Nside-1]
    do iz = irmin, irmax
       ztab(iz-irmin+1) = ring2z(nside, iz)
    enddo
    call discphirange_at_z(vector0, radius_eff, ztab, nr, dphitab, phi0)
    call pixels_on_edge(nside, irmin, irmax, phi0, dphitab, ringphi, ngr)
    if (do_inclusive) then
       ! sample edge pixels at larger Nside
       nsboost = 16
       nsideh = min(NS_MAX8, nside * int(nsboost,i8b))
       radiush = fudge_query_radius(nsideh, radius, quadratic=.true.)

       irmin = ring_num(nsideh, zmax, shift=+1) ! shifted South
       irmax = ring_num(nsideh, zmin, shift=-1) ! shifted North
       nrh = irmax - irmin + 1
       allocate(zlist(1:nrh), dphilist(1:nrh))
       do iz = irmin, irmax
          zlist(iz-irmin+1) = ring2z(nsideh, iz)
       enddo
       call discphirange_at_z(vector0, radiush, zlist, nrh, dphilist, phi0)
       call check_edge_pixels(nside, nsboost, irmin, irmax, phi0, dphilist, ringphi, ngr)
       deallocate(zlist, dphilist)
    endif
    call discedge2fulldisc(nside, ringphi, ngr, listpix, nlist)

    if (my_nest == 1) then
       do ip=0_MKD, nlist-1
          call ring2nest(nside, listpix(ip), listpix(ip))
       enddo
    endif
    
    return

#ifdef DOI8B
  end subroutine query_disc_8
#else
  end subroutine query_disc
#endif

!=======================================================================
! query_strip ( nside, theta1, theta2, listpix, nlist, nest, inclusive)
!
! finds pixels having a colatitude (measured from North Pole):
!  theta1 < colatitude < theta2
!  with 0 <= theta1 < theta2 <= Pi
! if theta2 < theta1 then pixels with
! 0 <= colatitude < theta2   or   theta1 < colatitude < Pi are returned
!
! nside :          I4,       input,  resolution parameter
! theta1, theta2 : DP,       input,  bounds
! listpix :        I4/I8  array, output,  list of pixels
! nlist :          I4/I8,        output, number of pixels in list
! nest  :          I4 opt.,  input, =0 : RING scheme, =1 : NESTED scheme
! inclusive:       I4 opt.,  input, if=1 include pixel touched by strip, 
!                                   if 0 keep pixels with center in strip
!
! v1.0, EH, Caltech, Jan-2002
! v2.0: 2004-12 : added inclusive keyword
! v2.1: 2008-03-28: improved inclusive regime
! 2009-06-15: deals with Nside > 8192
!=======================================================================
#ifdef DOI8B
  subroutine query_strip_8( nside, theta1, theta2, listpix, nlist, nest, inclusive)
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine query_strip  ( nside, theta1, theta2, listpix, nlist, nest, inclusive)
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    integer(kind=I4B), intent(in)                    :: nside
    real(kind=DP),     intent(in)                    :: theta1, theta2
    integer(kind=MKD), intent(out), dimension(0:)    :: listpix
    integer(kind=MKD), intent(out)                   :: nlist
    integer(kind=I4B), intent(in),  optional         :: nest
    integer(kind=i4b), intent(in),  optional         :: inclusive

    integer(kind=I4B)                  :: nstrip, my_nest
    integer(kind=I4B)                  :: iz, ip, is, irmin, irmax
    integer(kind=I4B)                  :: nir
    real(kind=DP)                      :: phi0, dphi, zu, zd, zring
    real(kind=DP), dimension(1:4)      :: colrange
    character(len=*), parameter        :: code = "query_strip"
    integer(kind=MKD)                  :: npix, ilist, nlost, list_size
    integer(kind=MKD), dimension(:), allocatable :: listir
    logical(kind=LGT) :: be_inclusive

    !=======================================================================
    list_size = long_size(listpix)
    !     ---------- check inputs ----------------
    npix = nside2npix(nside)
    if (npix < 0) then
       print*,code//"> Nside should be a power of 2"
       print*,code//"> current value = ",nside
       call fatal_error("> program abort ")
    endif

    if    (theta1 < 0.0_dp .or. theta1 > PI .or. &
         & theta2 < 0.0_dp .or. theta2 > PI) then
       write(unit=*,fmt="(a)") code//"> the colatitudes are in RADIAN "
       write(unit=*,fmt="(a)") code//"> and should lie in [0,Pi] "
       print*,code//"> current value = ", theta1, theta2
       call fatal_error("> program abort ")
    endif

    if (theta1 <= theta2) then
       nstrip = 1
       colrange(1:2*nstrip) = (/ theta1, theta2 /)
    else
       nstrip = 2
       colrange(1:2*nstrip) = (/ 0.0_dp, theta2, theta1, PI/)
    endif

    be_inclusive = .false.
    if (present(inclusive)) be_inclusive = (inclusive==1)

    my_nest = 0
    if (present(nest)) then
       if (nest == 0 .or. nest == 1) then
          my_nest = nest
       else
          print*,code//"> NEST should be 0 or 1"
          call fatal_error("> program abort ")
       endif
    endif

    !     ------------- loop on strips ---------------------
    ilist = -1_MKD
    allocate(listir(0:4*nside-1))
    do is =0, nstrip-1
       zu = cos(colrange(2*is+1)) ! upper bound in z
       zd = cos(colrange(2*is+2)) ! lower bound in z
       if (be_inclusive) then
          irmin = ring_num(nside, zu, shift=-1_i4b) ! shift up north
          irmax = ring_num(nside, zd, shift=+1_i4b) ! shift down south
       else
          irmin = ring_num(nside, zu)
          irmax = ring_num(nside, zd)
       endif


       !     ------------- loop on ring number ---------------------
       do iz = irmin, irmax

          zring = ring2z(nside, iz) ! z of ring being considered

          if ((zring >= zd .and. zring <= zu) .or. be_inclusive) then
             !        ------- finds pixels in the ring ---------
             phi0 = 0
             dphi = PI
             call in_ring(nside, iz, phi0, dphi, listir, nir, nest=my_nest)
             
             nlost = ilist + nir + 1_MKD - list_size
             if ( nlost > 0 ) then
                print*,code//"> listpix is too short, it will be truncated at ",nir
                print*,"                         pixels lost : ", nlost
                nir = nir - nlost
             endif
             do ip = 0, nir-1
                ilist = ilist + 1_MKD
                listpix(ilist) = listir(ip)
             enddo
          endif

       enddo

    enddo

    !     ------ total number of pixel in the strip --------
    nlist = ilist + 1_MKD

    !     ------- deallocate memory and exit ------
    DEALLOCATE(listir)

    return
#ifdef DOI8B
  end subroutine query_strip_8
#else
  end subroutine query_strip
#endif

!=======================================================================
!  query_polygon
!
! finds pixels that lie within a CONVEX polygon defined by its vertex on the sphere
!
! nside             : IN
! vlist(1:3, 0:n-1) : IN, list of vertices
! nv                : IN, number of vertices to be used (nv <= n)
! listpix           : OUT
! nlist             : OUT
! nest              : IN, OPTIONAL
! inclusive         : IN, OPTIONAL
!
! algorithm:
!   the polygon is divided into triangles
!   vertex 0 belongs to all the triangles
!
! v1.0, EH, Caltech, Dec-2001
! 2009-06-17: deals with Nside > 8192
  !=======================================================================
#ifdef DOI8B
  subroutine query_polygon_8( nside, vlist, nv, listpix, nlist, nest, inclusive)
    USE num_rec, ONLY : isort
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine query_polygon ( nside, vlist, nv, listpix, nlist, nest, inclusive)
    USE num_rec, ONLY : isort
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    !=======================================================================
    integer(kind=I4B), intent(in)                    :: nside
    real(kind=DP),     intent(in),  dimension(1:,1:) :: vlist
    integer(kind=I4B), intent(in)                    :: nv
    integer(kind=MKD), intent(out), dimension(0:)    :: listpix
    integer(kind=MKD), intent(out)                   :: nlist
    integer(kind=I4B), intent(in),  optional         :: nest
    integer(kind=i4b), intent(in),  optional         :: inclusive

    real(kind=DP),     dimension(:), pointer         :: vp0, vp1, vp2
    real(kind=DP),     dimension(1:3)                :: vo
    real(kind=DP),     dimension(:,:), allocatable, target   :: vvlist
    real(kind=DP),     dimension(:),   allocatable   :: ss
    real(kind=DP)                                    :: surface, fsky, hand
    integer(kind=MKD)                                :: npix, n_in_trg, ilist, ntl
    integer(kind=MKD)                                :: list_size, nlost, i, k
    integer(kind=I4B)                                :: n_remain
    integer(kind=I4B)                                :: i0, i1, i2
    integer(kind=I4B)                                :: np, nm, nlow
    integer(kind=I4B), dimension(1:1)                :: ix
    integer(kind=MKD), dimension(:), allocatable     :: templist
    character(len=*), parameter :: code = "QUERY_POLYGON"
    integer(kind=I4B)                                :: my_nest

    !=======================================================================

    list_size = long_size(listpix)
    n_remain = nv
    ilist = -1_MKD
    listpix(:) = -1_MKD

    call assert(n_remain>=3, &
      code//"> The polygon should have at least 3 vertices")

    if (size(vlist) < n_remain*3) then
       print*,code//"> ",size(vlist)/3," vertices are given"
       print*,code//"> expected : ",n_remain
       call fatal_error
    endif

    allocate(vvlist(1:3, 1:n_remain))
    vvlist = vlist

    my_nest = 0
    if (present(nest)) then
       if (nest == 0 .or. nest == 1) then
          my_nest = nest
       else
          print*,code//"> NEST should be 0 or 1"
          call fatal_error("> program abort ")
       endif
    endif

    !-----------------------------------------------------------------
    ! check that the polygon is convex or has only one concave vertex
    !-----------------------------------------------------------------
    if (n_remain == 3) goto 1000 ! a triangle is always convex

    allocate(ss(1:n_remain))
    do i1 = 0, n_remain-1
       i0 = modulo(i1-1, n_remain)  ! in [0, n_remain-1]
       i2 = modulo(i1+1, n_remain)  ! in [0, n_remain-1]

       vp0 => vvlist(:,i0+1)
       vp1 => vvlist(:,i1+1)
       vp2 => vvlist(:,i2+1)

       ! computes the handedness   (v0 x v2) . v1  for each vertex v1
       call vect_prod(vp0, vp2, vo)
       hand = dot_product(vo, vp1)
       ss(i1+1) = sign(1.0_dp, hand) ! either +1 or -1
    enddo
    np = count( ss > 0.0_dp) ! number of vertex with positive handedness
    nm = n_remain - np

    nlow = min(np,nm)
    if (nlow == 0) goto 1000
    if (nlow == 1) then
       ! only one concave vertex
       if (np == 1) then
          ix = maxloc(ss)
       else
          ix = minloc(ss)
       endif
       ! rotate pixel list to put that vertex in #0
       vvlist = cshift(vvlist, ix(1)-1, dim = 2)
    endif
    if (nlow > 1) then
       ! more than 1 concave vertex
       print*,"***************************************"
       print*,"The polygon is not convex"
       print*," and has more than one concave vertex"
       print*,"The result is unpredictable"
       print*,"***************************************"
    endif
    deallocate(ss)

1000 continue

    !--------------------------------------------
    ! fill the polygon, one triangle at a time
    !--------------------------------------------
    npix = nside2npix(nside)
    do
       ! build triangle from vertices #0, n-2, and n-1
       vp0 => vvlist(1:3,1)
       vp1 => vvlist(1:3,n_remain-1)
       vp2 => vvlist(1:3,n_remain  )

       ! computes its surface
       call surface_triangle( vp0, vp1, vp2, surface )
       fsky = surface/FOURPI
       n_in_trg = npix * (fsky * 1.4) + 12*nside
       n_in_trg = min(n_in_trg, npix)

       ! find pixels within triangle
       allocate(templist(0:n_in_trg-1))
       call query_triangle( nside, vp0, vp1, vp2, templist, ntl, nest=my_nest,inclusive=inclusive )

       ! merge new list with existing one
       nlost = ilist + ntl + 1_MKD - list_size
       if ( nlost > 0 ) then
          print*,code//"> listpix is too short, it will be truncated at ",list_size
          print*,"                         pixels lost : ", nlost
          print*, list_size
          ntl = ntl - nlost
       endif
       do i = 0_MKD, ntl - 1_MKD
          ilist = ilist + 1_MKD
          listpix(ilist) = templist(i)
       enddo
       deallocate(templist)

       if (n_remain == 3) exit

       ! prune vertex list
       n_remain = n_remain - 1

    enddo
    deallocate(vvlist)

    !-------------------------
    ! make final pixel list
    !-------------------------
    nlist = ilist + 1_MKD

    ! sort final list
    if (nlist > 0) call isort(nlist, listpix)

    ! remove redondant pixels
    ! (we keep 0th element of the list)
    k = 1_MKD
    do i = 1, nlist-1_MKD
       if (listpix(i) > listpix(i-1)) then
          listpix(k) = listpix(i)
          k = k + 1_MKD
       endif
    enddo
    nlist = k

    ! pad end of list with -1
    listpix(nlist:list_size-1) = -1_MKD

    return
#ifdef DOI8B
  end subroutine query_polygon_8
#else
  end subroutine query_polygon
#endif

!=======================================================================
!
!    query_triangle ( nside, v1, v2, v3, listpix, nlist, nest, inclusive)
!    --------------
!     nside       = resolution parameter (a power of 2)
!     v1, v2, v3  = 3D vector location of the 3 triangle vertices
!     list_pix    = list of pixel lying in the triangle
!     nlist       = number of pixels in the list
!     nest  (OPT), :0 by default, the output list is in RING scheme
!                  if set to 1, the output list is in NESTED scheme
!     inclusive (OPT) , :0 by default, only the pixels whose center
!                       lie in the triangle are listed on output
!                  if set to 1, all pixels overlapping the triangle are output
!
!     NB : the dimension of the listpix array is fixed in the calling
!     routine and should be large enough for the specific configuration
!
!
! v1.0, EH, Caltech, Nov-Dec-2001
! v1.1,  Aug-Sep-2002 : added nest and inclusive
! v1.2, 2008-03-28, EH/IAP: check that input vectors are 3D
! 2009-06-17: deals with Nside > 8192
  !=======================================================================
#ifdef DOI8B
  subroutine query_triangle_8 ( nside, v1, v2, v3, listpix, nlist, nest, inclusive)
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine query_triangle   ( nside, v1, v2, v3, listpix, nlist, nest, inclusive)
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    !=======================================================================
    integer(kind=I4B), intent(in) :: nside
    real(kind=DP),     intent(in),  dimension(1:)  :: v1, v2, v3
    integer(kind=MKD), intent(out), dimension(0:)  :: listpix
    integer(kind=MKD), intent(out)                 :: nlist
    integer(kind=I4B), intent(in), optional        :: nest
    integer(kind=I4B), intent(in), optional        :: inclusive

    integer(kind=MKD) :: npix, ilist !, ip1, ip2, ip3
    integer(kind=MKD) :: list_size, nlost
    integer(kind=I4B) :: iz, irmin, irmax
    integer(kind=I4B) :: n12, n123a, n123b, ndom
    integer(kind=I4B), dimension(:),   allocatable  :: listir
    logical(kind=LGT) :: test1, test2, test3
    logical(kind=LGT) :: test1a, test1b, test2a, test2b, test3a, test3b
!!!    real(kind=DP) :: dth1, dth2
    real(kind=DP) :: determ, sdet
    real(kind=DP) :: zmax, zmin, z1max, z1min, z2max, z2min, z3max, z3min
    real(kind=DP) :: z, zz
    real(kind=DP) :: tgth, st
    real(kind=DP) :: offset, sin_off, cos_off
    real(kind=DP), dimension(1:3,1:3) :: vv, vo
    real(kind=DP), dimension(1:3) :: sprod, sto, phi0i, tgthi
    real(kind=DP), dimension(1:3) :: dc
    real(kind=DP), dimension(1:2,1:4) :: dom
    !real(kind=DP), dimension(1:4) :: dom12, dom123a, dom123b
    real(kind=DP), dimension(1:8) :: alldom, adtmp
    real(kind=DP) :: a_i, b_i, phi0, dphiring, dphi, phi0disc, radius_eff, tmp
    integer(kind=I4B) :: idom, nir, ip, nr
    integer(kind=I4B) :: status
    integer(kind=I4B) :: j
    character(len=*), parameter :: code = "QUERY_TRIANGLE"
    logical(LGT)      :: do_inclusive
    integer(kind=I4B)       :: my_nest
    integer(i4b), dimension(1:1) :: longside
    integer(i4b) :: lsp1, lsp2, i
    real(dp), dimension(1:3) :: vcenter, dd
    real(dp), allocatable, dimension(:) :: ztab, dphitab

    !=======================================================================

    list_size = long_size(listpix)

    npix = nside2npix(nside)
    if (npix < 0) then
       print*,"Invalid Nside = ",nside
       call fatal_error
    endif

    do_inclusive = .false.
    if (present(inclusive)) then
       if (inclusive == 1) do_inclusive = .true.
    endif

    my_nest = 0
    if (present(nest)) then
       if (nest == 0 .or. nest == 1) then
          my_nest = nest
       else
          print*,code//"> NEST should be 0 or 1"
          call fatal_error("> program abort ")
       endif
    endif

    if (size(v1) < 3 .or. size(v2) < 3 .or. size(v3) < 3) then
       print*,'Expecting 3d vectors in '//code
       call fatal_error
    endif

    vv(1:3,1) = v1(1:3) / sqrt(dot_product(v1,v1))
    vv(1:3,2) = v2(1:3) / sqrt(dot_product(v2,v2))
    vv(1:3,3) = v3(1:3) / sqrt(dot_product(v3,v3))

    !     --------- allocate memory -------------
    ALLOCATE( listir(0: 4*nside-1), STAT = status)
    if (status /= 0) then
       write(unit=*,fmt="(a)") code//" > can not allocate memory for listir :"
       call fatal_error(" > program abort ")
    endif

!     dth1 = 1.0_dp / (3.0_dp*REAL(nside,kind=dp)**2)
!     dth2 = 2.0_dp / (3.0_dp*REAL(nside,kind=dp))


    ! determ = (vect1 X vect2) . vect3
    ! determines the left(<0)/right(>0) handedness of the triangle
    determ = vv(1,1)*vv(2,2)*vv(3,3) + vv(1,2)*vv(2,3)*vv(3,1) + vv(1,3)*vv(2,1)*vv(3,2) &
         & - vv(3,1)*vv(2,2)*vv(1,3) - vv(3,2)*vv(2,3)*vv(1,1) - vv(3,3)*vv(2,1)*vv(1,2)

    if (abs(determ) < 1.e-20_dp) then
       print*,' ************************************************************'
       print*,' The triangle is degenerated (2 of the vertices are antipodal)'
       print*,' The query can not be performed '
       print*,' ************************************************************'
       call fatal_error
    endif

    !   print*,determ
    sdet = SIGN(1.0_dp,determ) ! = +1 or -1, the sign of determ

    ! scalar product of vertices vectors
    sprod(1) = dot_product(vv(1:3,2),vv(1:3,3))
    sprod(2) = dot_product(vv(1:3,3),vv(1:3,1))
    sprod(3) = dot_product(vv(1:3,1),vv(1:3,2))

    ! vector orthogonal to the great circle containing the vertex doublet
    call vect_prod(vv(1:3,2), vv(1:3,3), vo(1:3,1))
    call vect_prod(vv(1:3,3), vv(1:3,1), vo(1:3,2))
    call vect_prod(vv(1:3,1), vv(1:3,2), vo(1:3,3))

    ! normalize the orthogonal vector
    vo(1:3,1) = vo(1:3,1) /  SQRT(SUM(vo(1:3,1)**2))
    vo(1:3,2) = vo(1:3,2) /  SQRT(SUM(vo(1:3,2)**2))
    vo(1:3,3) = vo(1:3,3) /  SQRT(SUM(vo(1:3,3)**2))
    
    ! test presence of poles in the triangle
    zmax = -1.0_dp
    zmin =  1.0_dp
    test1 = (vo(3,1) * sdet >= 0.0_dp) ! north pole in hemisphere defined by 2-3
    test2 = (vo(3,2) * sdet >= 0.0_dp) ! north pole in hemisphere defined by 1-2
    test3 = (vo(3,3) * sdet >= 0.0_dp) ! north pole in hemisphere defined by 1-3
    if (test1 .and. test2 .and. test3) then
       zmax = 1.0_dp ! north pole in the triangle
    endif
    if ((.not.test1) .and. (.not.test2) .and. (.not.test3)) then
       zmin = -1.0_dp ! south pole in the triangle
    endif

    ! look for northernest and southernest points in the triangle
    !   node(1,2) = vector of norm=1, in the plane defined by (1,2) and with z=0
    test1a = ((vv(3,3) - sprod(1) * vv(3,2)) >= 0.0_dp) ! segment 2-3 : -vector(3) . node(2,3)
    test1b = ((vv(3,2) - sprod(1) * vv(3,3)) >= 0.0_dp) !                vector(2) . node(2,3)
    test2a = ((vv(3,3) - sprod(2) * vv(3,1)) >= 0.0_dp) ! segment 1-3 : -vector(3) . node(1,3)
    test2b = ((vv(3,1) - sprod(2) * vv(3,3)) >= 0.0_dp) !                vector(1) . node(1,3)
    test3a = ((vv(3,2) - sprod(3) * vv(3,1)) >= 0.0_dp) ! segment 1-2 : -vector(2) . node(1,2)
    test3b = ((vv(3,1) - sprod(3) * vv(3,2)) >= 0.0_dp) !                vector(1) . node(1,2)

    ! sin of theta for orthogonal vector
    sto(1:3) = SQRT( (1.0_dp-vo(3,1:3))*(1.0_dp+vo(3,1:3)) )

    ! for each segment (=side of the triangle) the extrema are either
    ! - the 2 vertices
    ! - one of the vertices and a point within the segment

    ! segment 2-3
    z1max = vv(3,2)
    z1min = vv(3,3)
    if ( test1a .EQV. test1b ) then
       zz = sto(1)
       if (z1min+z1max >= 0.0_dp) then
          z1max =  zz
       else
          z1min = -zz
       endif
    endif

    ! segment 1-3
    z2max = vv(3,3)
    z2min = vv(3,1)
    if ( test2a .EQV. test2b ) then
       zz = sto(2)
       if (z2min+z2max >= 0.0_dp) then
          z2max =  zz
       else
          z2min = -zz
       endif
    endif

    ! segment 1-2
    z3max = vv(3,1)
    z3min = vv(3,2)
    if ( test3a .EQV. test3b ) then
       zz = sto(3)
       if (z3min+z3max >= 0.0_dp) then
          z3max =  zz
       else
          z3min = -zz
       endif
    endif

    zmax = MAX(z1max, z2max, z3max, zmax)
    zmin = MIN(z1min, z2min, z3min, zmin)

    offset = 0.0_dp
    sin_off = 0.0_dp
    if (do_inclusive) then
       ! if we are inclusive, move the upper point up, and the lower point down, by a fudge offset
       offset = fudge_query_radius(nside)
       sin_off = sin(offset)
       cos_off = cos(offset)
       zmax = min( 1.0_dp, cos_off * zmax + sin_off * sqrt(1.0_dp - zmax**2))  !cos(theta_zmax-offset)
       zmin = max(-1.0_dp, cos_off * zmin - sin_off * sqrt(1.0_dp - zmin**2))  !cos(theta_zmin+offset)

       ! find one small circle containing all points, 
       ! increased by fudge offset in inclusive case
       longside = minloc(sprod)      ! l   in {1,2,3}: longest leg
       lsp1 = mod(longside(1)  , 3) + 1 ! l+1 in {2,3,1}
       lsp2 = mod(longside(1)+1, 3) + 1 ! l+2 in {3,1,2}
       vcenter = 0.5_dp*(vv(1:3,lsp1) + vv(1:3,lsp2)) ! mid point of longest side
       vcenter = vcenter/sqrt(sum(vcenter**2))
       do i=1,3 
          call angdist(vcenter, vv(1:3,i), dd(i))
       enddo
       radius_eff = maxval(dd) + offset
!        print*,'radius_eff, offset',radius_eff, offset
!        print*,'vcenter',vcenter
    endif


    ! northernmost and sourthernmost ring number
    irmin = ring_num(nside, zmax)
    irmax = ring_num(nside, zmin)

    ilist = -1

    ! -------- loop on the rings -------------------------

    tgthi(1:3) = -1.0e30_dp * vo(3,1:3)
    phi0i(1:3) =  0.0_dp
    do j=1,3
       if (sto(j) > 1.0e-10_dp) then
          tgthi(j) = -vo(3,j) / sto(j)  ! -cotan(theta_orth)
          phi0i(j) = ATAN2(vo(2,j),vo(1,j))
       endif
    enddo
    !   print*,tgthi,phi0i

    ! the triangle boundaries are geodesics : intersection of the sphere with plans going thru (0,0,0)
    ! if we are inclusive, the boundaries are the intersecion of the sphere with plans pushed outward
    ! by sin(offset)

    nr = irmax - irmin + 1
    allocate(ztab(1:nr))
    do iz = irmin, irmax
       ztab(iz-irmin+1) = ring2z(nside, iz)
    enddo
    if (do_inclusive) then
       allocate(dphitab(1:nr))
       call discphirange_at_z(vcenter, radius_eff, ztab, nr, dphitab, phi0disc)
    endif

    do iz = irmin, irmax
       z = ztab(iz-irmin+1) ! z of ring being considered

       ! computes the 3 intervals described by the 3 great circles
       st = SQRT((1.0_dp - z)*(1.0_dp + z))
       tgth = z / st ! cotan(theta_ring)
       dc(1:3)  = tgthi(1:3) * tgth - sdet * sin_off / ((sto(1:3)+1.e-30_dp) * st) ! sto is slightly offset to avoid division by 0

       do j=1,3
          if (dc(j)*sdet <= -1.0_dp) then  ! the whole iso-latitude ring is on the right side of the great circle
             dom(1, j) = 0.0_dp
             dom(2, j) = twopi
          else if (dc(j)*sdet >= 1.0_dp) then ! all on the wrong side
             dom(1, j) = -1.000001_dp * j
             dom(2, j) = -1.0_dp * j
          else ! some is good, some is bad
             tmp = acos(dc(j)) * sdet
             dom(1, j) = modulo( phi0i(j) - tmp , twopi)
             dom(2, j) = modulo( phi0i(j) + tmp , twopi)
          endif
       enddo
       dom(1:2,4) = (/ -2.000002_dp, -2.0_dp /)
       if (do_inclusive) then
          dphi = dphitab(iz-irmin+1)
          if (dphi >= 0.0_dp) then
             dom(1,4) =  modulo (phi0disc - dphi + twopi, twopi)
             dom(2,4) =  modulo (phi0disc + dphi + twopi, twopi)
          endif
       endif

       call process_intervals(dom(1:2,2),dom(1:2,1), alldom, ndom)
       if (ndom == 0) goto 20
       adtmp(1:2*ndom) = alldom(1:2*ndom) ! to avoid using same variable in input and output of process_intervals
       call process_intervals(dom(1:2,3), adtmp(1:2*ndom), alldom, ndom)
       if (ndom == 0) goto 20
       if (do_inclusive) then
          adtmp(1:2*ndom) = alldom(1:2*ndom)
          call process_intervals(dom(1:2,4), adtmp(1:2*ndom), alldom, ndom)
          if (ndom == 0) goto 20
       endif
       do idom=0,ndom-1
          a_i = alldom(2*idom+1)
          b_i = alldom(2*idom+2)
          phi0     = (a_i + b_i) * 0.5_dp
          dphiring = (b_i - a_i) * 0.5_dp
          if (dphiring < 0.0_dp) then
             phi0     = phi0 + pi
             dphiring = dphiring + pi
          endif

          !        ------- finds pixels in the triangle on that ring ---------
          call in_ring(nside, iz, phi0, dphiring, listir, nir, nest=my_nest)

          !        ----------- merge pixel lists -----------
          nlost = ilist + nir + 1_MKD - list_size
          if ( nlost > 0 ) then
             print*,code//"> listpix is too short, it will be truncated at ",nir
             print*,"                         pixels lost : ", nlost
             print*, list_size
             nir = nir - nlost
          endif
          do ip = 0, nir-1
             ilist = ilist + 1
             listpix(ilist) = listir(ip)
          enddo
       enddo
20     continue
    enddo !-----------------------------------------

    !     ------ total number of pixel in the disc --------
    nlist = ilist + 1_MKD

    !     ------- deallocate memory and exit ------
    DEALLOCATE(listir)
    deallocate(ztab)
    if (allocated(dphitab)) deallocate(dphitab)

    return
#ifdef DOI8B
  end subroutine query_triangle_8
#else
  end subroutine query_triangle
#endif

!=======================================================================
!     gives the pixel number ipix (NESTED)
!     corresponding to ix, iy and face_num
!
!     Benjamin D. Wandelt 13/10/97
!     using code from HEALPIX toolkit by K.Gorski and E. Hivon
!     2009-06-15: deals with Nside > 8192
!     2012-03-02: test validity of ix_in and iy_in instead of undefined ix and iy
!=======================================================================
#ifdef DOI8B
  subroutine xy2pix_nest_8(nside, ix_in, iy_in, face_num, ipix)
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine xy2pix_nest(nside, ix_in, iy_in, face_num, ipix)
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    !=======================================================================
    INTEGER(KIND=I4B), INTENT(IN) ::  nside, ix_in, iy_in, face_num
    INTEGER(KIND=MKD), INTENT(OUT) :: ipix
    INTEGER(KIND=I4B) ::  ix, iy, ix_low, ix_hi, iy_low, iy_hi, i, ismax
    integer(kind=MKD) :: ipf, scale, scale_factor
    character(len=*), parameter :: code = "xy2pix_nest"

    !-----------------------------------------------------------------------
    if (nside<1 .or. nside>ns_max) call fatal_error(code//"> nside out of range")
    if (ix_in<0 .or. ix_in>(nside-1)) call fatal_error(code//"> ix out of range")
    if (iy_in<0 .or. iy_in>(nside-1)) call fatal_error(code//"> iy out of range")
    if (x2pix1(127) <= 0) call mk_xy2pix1()

    ix = ix_in
    iy = iy_in
    if (nside <= ns_max4) then 
       ix_low = iand(ix, 127)
       iy_low = iand(iy, 127)
       ipf =     x2pix1(ix_low) + y2pix1(iy_low) &
            & + (x2pix1(ix/128) + y2pix1(iy/128)) * 16384
    else
       scale = 1_MKD
       scale_factor = 16384_MKD ! 128*128
       ipf = 0_MKD
       ismax = 1 ! for nside in [2^14, 2^20]
       if (nside >  1048576 ) ismax = 3
       do i=0, ismax
          ix_low = iand(ix, 127) ! last 7 bits
          iy_low = iand(iy, 127) ! last 7 bits
          ipf = ipf + (x2pix1(ix_low)+y2pix1(iy_low)) * scale
          scale = scale * scale_factor
          ix  =     ix / 128 ! truncate out last 7 bits
          iy  =     iy / 128
       enddo
       ipf =  ipf + (x2pix1(ix)+y2pix1(iy)) * scale
    endif
    ipix = ipf + face_num* int(nside,MKD) * nside    ! in {0, 12*nside**2 - 1}
    return

#ifdef DOI8B
  end subroutine xy2pix_nest_8
#else
  end subroutine xy2pix_nest
#endif
!=======================================================================
!  pix2xy_nest
!     gives the x, y coords in a face from pixel number within the face (NESTED)
!
!     Benjamin D. Wandelt 13/10/97
!
!     using code from HEALPIX toolkit by K.Gorski and E. Hivon
!     2009-06-15: deals with Nside > 8192
!     2012-03-02: test validity of ipf_in instead of undefined ipf
!                 define ipf as MKD
!     2012-08-27:  corrected bug on (ix,iy) for Nside > 8192 (MARK)
!=======================================================================
#ifdef DOI8B
  subroutine pix2xy_nest_8(nside, ipf_in, ix, iy)
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine pix2xy_nest  (nside, ipf_in, ix, iy)
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    INTEGER(KIND=I4B), INTENT(IN)  :: nside
    INTEGER(KIND=MKD), INTENT(IN)  :: ipf_in
    INTEGER(KIND=I4B), INTENT(OUT) :: ix, iy

    integer(kind=MKD) :: ipf
    INTEGER(KIND=I4B) ::  ip_low, ip_trunc, ip_med, ip_hi, scale, i, ismax
    character(len=*), parameter :: code = "pix2xy_nest"

    !-----------------------------------------------------------------------
    if (nside<1 .or. nside>ns_max) call fatal_error(code//"> nside out of range")
    if (ipf_in<0 .or. ipf_in>nside*nside-1) &
         &     call fatal_error(code//"> ipix out of range")
    if (pix2x(1023) <= 0) call mk_pix2xy()

    ipf = ipf_in
    if (nside <= ns_max4) then
       ip_low = iand(ipf,1023_MKD)   ! content of the last 10 bits
       ip_trunc =    ipf/1024        ! truncation of the last 10 bits
       ip_med = iand(ip_trunc,1023)  ! content of the next 10 bits
       ip_hi  =      ip_trunc/1024   ! content of the high weight 10 bits

       ix = 1024*pix2x(ip_hi) + 32*pix2x(ip_med) + pix2x(ip_low)
       iy = 1024*pix2y(ip_hi) + 32*pix2y(ip_med) + pix2y(ip_low)
    else
       ix = 0
       iy = 0
       scale = 1
       ismax = 4
       do i=0, ismax
          ip_low = iand(ipf,1023_MKD)
          ix = ix + scale * pix2x(ip_low)
          iy = iy + scale * pix2y(ip_low) ! corrected 2012-08-27
          scale = scale * 32
          ipf   = ipf/1024
       enddo
       ix = ix + scale * pix2x(ipf)
       iy = iy + scale * pix2y(ipf) ! corrected 2012-08-27
    endif

    return

#ifdef DOI8B
  end subroutine pix2xy_nest_8
#else
  end subroutine pix2xy_nest
#endif



!====================================================================
! The following is a routine which finds the 7 or 8 neighbours of
! any pixel in the nested scheme of the HEALPIX pixelisation.
!====================================================================
!  neighbours_nest
!
!   Returns list n(8) of neighbours of pixel ipix (in NESTED scheme)
!   the neighbours are ordered in the following way:
!   First pixel is the one to the south (the one west of the south
! direction is taken
! for the pixels which don't have a southern neighbour). From
! then on the neighbours are ordered in the clockwise direction
! about the pixel with number ipix.
!
!   nneigh is the number of neighbours (mostly 8, 8 pixels have 7 neighbours)
!
!   Benjamin D. Wandelt October 1997
!   Added to pix_tools in March 1999
!   added 'return' for case nside=1, EH, Oct 2005
!   corrected bugs in case nside=1 and ipix=7, 9 or 11, EH, June 2006
!   2009-06-16: deals with Nside > 8192
!====================================================================
#ifdef DOI8B
  subroutine neighbours_nest_8(nside, ipix, n, nneigh)
    use bit_manipulation
    integer(kind=i4b), parameter  ::   MKD = I8B
#else
  subroutine neighbours_nest(nside, ipix, n, nneigh)
    use bit_manipulation
    integer(kind=i4b), parameter  ::   MKD = I4B
#endif
    !====================================================================
    integer(kind=i4b), intent(in)::  nside
    integer(kind=MKD), intent(in)::  ipix
    integer(kind=MKD), intent(out), dimension(1:):: n
    integer(kind=i4b), intent(out):: nneigh

    integer(kind=i4b) :: ix,ixm,ixp,iy,iym,iyp,ixo,iyo
    integer(kind=i4b) :: face_num,other_face, ipix4
    integer(kind=i4b) :: ia,ib,ibp,ibm,ib2,icase
    integer(kind=MKD) :: npix,ipf,ipo
    integer(kind=MKD) :: local_magic1,local_magic2,nsidesq
    integer(kind=i4b), dimension(1:8) :: n4
    character(len=*), parameter :: code = "neighbours_nest"

!     integer(kind=i4b), intrinsic :: IAND

    !--------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       ipix4 = int(ipix, kind=i4b)
       call neighbours_nest(nside, ipix4, n4, nneigh)
       n(1:nneigh) = int(n4(1:nneigh), kind=MKD)
       return
    endif
    if (nside <1 .or. nside > ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside <1 .or. nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside) ! total number of points
    nsidesq = npix / 12
    if (ipix <0 .or. ipix>npix-1) call fatal_error(code//"> ipix out of range")

    ! quick and dirty hack for Nside=1

    if (nside == 1) then
       nneigh = 6
       if (ipix==0 ) n(1:6) = (/ 8, 4, 3, 2, 1, 5 /)
       if (ipix==1 ) n(1:6) = (/ 9, 5, 0, 3, 2, 6 /)
       if (ipix==2 ) n(1:6) = (/10, 6, 1, 0, 3, 7 /)
       if (ipix==3 ) n(1:6) = (/11, 7, 2, 1, 0, 4 /)
       if (ipix==4 ) n(1:6) = (/11, 7, 3, 0, 5, 8 /)
       if (ipix==5 ) n(1:6) = (/ 8, 4, 0, 1, 6, 9 /)
       if (ipix==6 ) n(1:6) = (/ 9, 5, 1, 2, 7,10 /)
       if (ipix==7 ) n(1:6) = (/10, 6, 2, 3, 4,11 /)
       if (ipix==8 ) n(1:6) = (/10,11, 4, 0, 5, 9 /)
       if (ipix==9 ) n(1:6) = (/11, 8, 5, 1, 6,10 /)
       if (ipix==10) n(1:6) = (/ 8, 9, 6, 2, 7,11 /)
       if (ipix==11) n(1:6) = (/ 9,10, 7, 3, 4, 8 /)
       return
    endif

    !     initiates array for (x,y)-> pixel number -> (x,y) mapping
    if (x2pix1(127) <= 0) call mk_xy2pix1()

    local_magic1=(nsidesq-1)/3
    local_magic2=2*local_magic1
    face_num=ipix/nsidesq

    ipf=modulo(ipix,nsidesq)   !Pixel number in face

    call pix2xy_nest(nside,ipf,ix,iy)
    ixm=ix-1
    ixp=ix+1
    iym=iy-1
    iyp=iy+1

    nneigh=8                  !Except in special cases below

    !     Exclude corners
    if(ipf==local_magic2)     then !WestCorner
       icase=5
       goto 100
    endif
    if(ipf==(nsidesq-1)) then !NorthCorner
       icase=6
       goto 100
    endif
    if(ipf==0)           then !SouthCorner
       icase=7
       goto 100
    endif
    if(ipf==local_magic1)     then !EastCorner
       icase=8
       goto 100
    endif

    !     Detect edges
    if(IAND(ipf,local_magic1)==local_magic1) then !NorthEast
       icase=1
       goto 100
    endif
    if(IAND(ipf,local_magic1)==0)      then !SouthWest
       icase=2
       goto 100
    endif
    if(IAND(ipf,local_magic2)==local_magic2) then !NorthWest
       icase=3
       goto 100
    endif
    if(IAND(ipf,local_magic2)==0)      then !SouthEast
       icase=4
       goto 100
    endif

    !     Inside a face
    call xy2pix_nest(nside, ixm, iym, face_num, n(1))
    call xy2pix_nest(nside, ixm, iy , face_num, n(2))
    call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
    call xy2pix_nest(nside, ix , iyp, face_num, n(4))
    call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
    call xy2pix_nest(nside, ixp, iy , face_num, n(6))
    call xy2pix_nest(nside, ixp, iym, face_num, n(7))
    call xy2pix_nest(nside, ix , iym, face_num, n(8))
    return

100 continue

    ia= face_num/4            !in {0,2}
    ib= modulo(face_num,4)       !in {0,3}
    ibp=modulo(ib+1,4)
    ibm=modulo(ib+4-1,4)
    ib2=modulo(ib+2,4)

    if(ia==0) then          !North Pole region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=0+ibp
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          ipo=modulo(swapLSBMSB(ipf),nsidesq)    !East-West flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo+1 , iyo, other_face, n(5))
          n(6)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(7))
       case(2)              !SouthWest edge
          other_face=4+ib
          ipo=modulo(invLSB(ipf),nsidesq)        !SW-NE flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(1))
          n(2)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo+1, other_face, n(3))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
       case(3)              !NorthWest edge
          other_face=0+ibm
          ipo=modulo(swapLSBMSB(ipf),nsidesq)    !East-West flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(3))
          n(4)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo+1, other_face, n(5))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
       case(4)              !SouthEast edge
          other_face=4+ibp
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          ipo=modulo(invMSB(ipf),nsidesq) !SE-NW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo+1, iyo, other_face, n(7))
          n(8)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(1))
       case(5)              !West corner
          nneigh=7
          other_face=4+ib
          n(2)=other_face*nsidesq+nsidesq-1
          n(1)=n(2)-2
          other_face=0+ibm
          n(3)=other_face*nsidesq+local_magic1
          n(4)=n(3)+2
          n(5)=ipix+1
          n(6)=ipix-1
          n(7)=ipix-2
       case(6)              !North corner
          n(1)=ipix-3
          n(2)=ipix-1
          n(8)=ipix-2
          other_face=0+ibm
          n(4)=other_face*nsidesq+nsidesq-1
          n(3)=n(4)-2
          other_face=0+ib2
          n(5)=other_face*nsidesq+nsidesq-1
          other_face=0+ibp
          n(6)=other_face*nsidesq+nsidesq-1
          n(7)=n(6)-1
       case(7)              !South corner
          other_face=8+ib
          n(1)=other_face*nsidesq+nsidesq-1
          other_face=4+ib
          n(2)=other_face*nsidesq+local_magic1
          n(3)=n(2)+2
          n(4)=ipix+2
          n(5)=ipix+3
          n(6)=ipix+1
          other_face=4+ibp
          n(8)=other_face*nsidesq+local_magic2
          n(7)=n(8)+1
       case(8)              !East corner
          nneigh=7
          n(2)=ipix-1
          n(3)=ipix+1
          n(4)=ipix+2
          other_face=0+ibp
          n(6)=other_face*nsidesq+local_magic2
          n(5)=n(6)+1
          other_face=4+ibp
          n(7)=other_face*nsidesq+nsidesq-1
          n(1)=n(7)-1
       end select ! north

    elseif(ia==1) then      !Equatorial region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=0+ib
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          ipo=modulo(invLSB(ipf),nsidesq)    !NE-SW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo , iyo+1, other_face, n(5))
          n(6)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(7))
       case(2)              !SouthWest edge
          other_face=8+ibm
          ipo=modulo(invLSB(ipf),nsidesq)        !SW-NE flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(1))
          n(2)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo+1, other_face, n(3))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
       case(3)              !NorthWest edge
          other_face=0+ibm
          ipo=modulo(invMSB(ipf),nsidesq)    !NW-SE flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(3))
          n(4)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo+1, iyo, other_face, n(5))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
       case(4)              !SouthEast edge
          other_face=8+ib
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          ipo=modulo(invMSB(ipf),nsidesq) !SE-NW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo+1, iyo, other_face, n(7))
          n(8)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(1))
       case(5)              !West corner
          other_face=8+ibm
          n(2)=other_face*nsidesq+nsidesq-1
          n(1)=n(2)-2
          other_face=4+ibm
          n(3)=other_face*nsidesq+local_magic1
          other_face=0+ibm
          n(4)=other_face*nsidesq
          n(5)=n(4)+1
          n(6)=ipix+1
          n(7)=ipix-1
          n(8)=ipix-2
       case(6)              !North corner
          nneigh=7
          n(1)=ipix-3
          n(2)=ipix-1
          other_face=0+ibm
          n(4)=other_face*nsidesq+local_magic1
          n(3)=n(4)-1
          other_face=0+ib
          n(5)=other_face*nsidesq+local_magic2
          n(6)=n(5)-2
          n(7)=ipix-2
       case(7)              !South corner
          nneigh=7
          other_face=8+ibm
          n(1)=other_face*nsidesq+local_magic1
          n(2)=n(1)+2
          n(3)=ipix+2
          n(4)=ipix+3
          n(5)=ipix+1
          other_face=8+ib
          n(7)=other_face*nsidesq+local_magic2
          n(6)=n(7)+1
       case(8)              !East corner
          other_face=8+ib
          n(8)=other_face*nsidesq+nsidesq-1
          n(1)=n(8)-1
          n(2)=ipix-1
          n(3)=ipix+1
          n(4)=ipix+2
          other_face=0+ib
          n(6)=other_face*nsidesq
          n(5)=n(6)+2
          other_face=4+ibp
          n(7)=other_face*nsidesq+local_magic2
       end select ! equator
    else                    !South Pole region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=4+ibp
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          ipo=modulo(invLSB(ipf),nsidesq)    !NE-SW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo , iyo+1, other_face, n(5))
          n(6)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(7))
       case(2)              !SouthWest edge
          other_face=8+ibm
          ipo=modulo(swapLSBMSB(ipf),nsidesq)        !W-E flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(1))
          n(2)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo+1, iyo, other_face, n(3))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
       case(3)              !NorthWest edge
          other_face=4+ib
          ipo=modulo(invMSB(ipf),nsidesq)    !NW-SE flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo-1, iyo, other_face, n(3))
          n(4)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo+1, iyo, other_face, n(5))
          call xy2pix_nest(nside, ixm, iym, face_num, n(1))
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ix , iym, face_num, n(8))
          call xy2pix_nest(nside, ixp, iym, face_num, n(7))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
       case(4)              !SouthEast edge
          other_face=8+ibp
          call xy2pix_nest(nside, ixm, iy , face_num, n(2))
          call xy2pix_nest(nside, ixm, iyp, face_num, n(3))
          call xy2pix_nest(nside, ix , iyp, face_num, n(4))
          call xy2pix_nest(nside, ixp, iyp, face_num, n(5))
          call xy2pix_nest(nside, ixp, iy , face_num, n(6))
          ipo=modulo(swapLSBMSB(ipf),nsidesq) !E-W flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo+1, other_face, n(7))
          n(8)=other_face*nsidesq+ipo
          call xy2pix_nest(nside, ixo, iyo-1, other_face, n(1))
       case(5)              !West corner
          nneigh=7
          other_face=8+ibm
          n(2)=other_face*nsidesq+local_magic1
          n(1)=n(2)-1
          other_face=4+ib
          n(3)=other_face*nsidesq
          n(4)=n(3)+1
          n(5)=ipix+1
          n(6)=ipix-1
          n(7)=ipix-2
       case(6)              !North corner
          n(1)=ipix-3
          n(2)=ipix-1
          other_face=4+ib
          n(4)=other_face*nsidesq+local_magic1
          n(3)=n(4)-1
          other_face=0+ib
          n(5)=other_face*nsidesq
          other_face=4+ibp
          n(6)=other_face*nsidesq+local_magic2
          n(7)=n(6)-2
          n(8)=ipix-2
       case(7)              !South corner
          other_face=8+ib2
          n(1)=other_face*nsidesq
          other_face=8+ibm
          n(2)=other_face*nsidesq
          n(3)=n(2)+1
          n(4)=ipix+2
          n(5)=ipix+3
          n(6)=ipix+1
          other_face=8+ibp
          n(8)=other_face*nsidesq
          n(7)=n(8)+2
       case(8)              !East corner
          nneigh=7
          other_face=8+ibp
          n(7)=other_face*nsidesq+local_magic2
          n(1)=n(7)-2
          n(2)=ipix-1
          n(3)=ipix+1
          n(4)=ipix+2
          other_face=4+ibp
          n(6)=other_face*nsidesq
          n(5)=n(6)+2
       end select ! south
    endif

    return

#ifdef DOI8B
  end subroutine neighbours_nest_8
#else
  end subroutine neighbours_nest
#endif
!====================================================================
!  next_in_line_nest
!
!   given nside and a NESTED pixel number ipix, returns in inext
!  the pixel that lies on the East side (and the same latitude) as ipix
!
!   Hacked by EH from BDW's neighbours_nest, 2001-12-18
!   Hacked for Nside=1 by EH, 2004-05-28
  !====================================================================
#ifdef DOI8B
  subroutine next_in_line_nest_8(nside, ipix, inext)
    use bit_manipulation
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine next_in_line_nest  (nside, ipix, inext)
    use bit_manipulation
    integer(i4b), parameter :: MKD = I4B
#endif
    !====================================================================
    integer(kind=i4b), intent(in)::nside
    integer(kind=MKD), intent(in)::  ipix
    integer(kind=MKD), intent(out):: inext

    integer(kind=i4b) :: ix,ixp,iy,iym,ixo,iyo
    integer(kind=i4b) :: face_num,other_face
    integer(kind=i4b) :: ia,ib,ibp,ibm,ib2,icase
    integer(kind=i4b) :: ipix4, inext4
    integer(kind=MKD) :: npix,ipf,ipo
    integer(kind=MKD) :: local_magic1,local_magic2,nsidesq
    character(len=*), parameter :: code = "next_in_line_nest"

    !--------------------------------------------------------------------
#ifdef DOI8B
    if (nside <= ns_max4) then ! use faster 32-bit routine whenever possible
       ipix4 = int(ipix, kind=i4b)
       call next_in_line_nest(nside, ipix4, inext4)
       inext = int(inext4, kind=MKD)
       return
    endif
    if (nside <1 .or. nside > ns_max ) call fatal_error(code//"> nside out of range")
#else
    if (nside <1 .or. nside > ns_max4) call fatal_error(code//"> nside out of range")
#endif
    npix = nside2npix(nside) ! total number of points
    nsidesq = npix / 12
    if (ipix <0 .or. ipix>npix-1) call fatal_error(code//"> ipix out of range")

    ! quick and dirty hack for Nside=1
    if (nside == 1) then
       inext = ipix + 1
       if (ipix == 3)  inext = 0_MKD
       if (ipix == 7)  inext = 4_MKD
       if (ipix == 11) inext = 8_MKD
       return
    endif
    !     initiates array for (x,y)-> pixel number -> (x,y) mapping
    if (x2pix1(127) <= 0) call mk_xy2pix1()

    local_magic1=(nsidesq-1)/3
    local_magic2=2*local_magic1
    face_num=ipix/nsidesq

    ipf=modulo(ipix,nsidesq)   !Pixel number in face

    call pix2xy_nest(nside,ipf,ix,iy)
    ixp=ix+1
    iym=iy-1

    !     Exclude corners
    if(ipf==local_magic2)     then !WestCorner
       inext = ipix - 1
       return
    endif
    if(ipf==(nsidesq-1)) then !NorthCorner
       icase=6
       goto 100
    endif
    if(ipf==0)           then !SouthCorner
       icase=7
       goto 100
    endif
    if(ipf==local_magic1)     then !EastCorner
       icase=8
       goto 100
    endif

    !     Detect edges
    if(IAND(ipf,local_magic1)==local_magic1) then !NorthEast
       icase=1
       goto 100
    endif
    if(IAND(ipf,local_magic2)==0)      then !SouthEast
       icase=4
       goto 100
    endif

    !     Inside a face
    call xy2pix_nest(nside, ixp, iym, face_num, inext)
    return

100 continue

    ia= face_num/4            !in {0,2}
    ib= modulo(face_num,4)       !in {0,3}
    ibp=modulo(ib+1,4)
    ibm=modulo(ib+4-1,4)
    ib2=modulo(ib+2,4)

    if(ia==0) then          !North Pole region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=0+ibp
          ipo=modulo(swapLSBMSB(ipf),nsidesq)    !East-West flip
          inext = other_face*nsidesq+ipo         ! (6)
       case(4)              !SouthEast edge
          other_face=4+ibp
          ipo=modulo(invMSB(ipf),nsidesq) !SE-NW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo+1, iyo, other_face, inext)
       case(6)              !North corner
          other_face=0+ibp
          inext=other_face*nsidesq+nsidesq-1
       case(7)              !South corner
          other_face=4+ibp
          inext=other_face*nsidesq+local_magic2+1
       case(8)              !East corner
          other_face=0+ibp
          inext=other_face*nsidesq+local_magic2
       end select ! north

    elseif(ia==1) then      !Equatorial region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=0+ib
          ipo=modulo(invLSB(ipf),nsidesq)    !NE-SW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo-1, other_face, inext)
       case(4)              !SouthEast edge
          other_face=8+ib
          ipo=modulo(invMSB(ipf),nsidesq) !SE-NW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo+1, iyo, other_face, inext)
       case(6)              !North corner
          other_face=0+ib
          inext=other_face*nsidesq+local_magic2-2
       case(7)              !South corner
          other_face=8+ib
          inext=other_face*nsidesq+local_magic2+1
       case(8)              !East corner
          other_face=4+ibp
          inext=other_face*nsidesq+local_magic2
       end select ! equator
    else                    !South Pole region
       select case(icase)
       case(1)              !NorthEast edge
          other_face=4+ibp
          ipo=modulo(invLSB(ipf),nsidesq)    !NE-SW flip
          call pix2xy_nest(nside,ipo,ixo,iyo)
          call xy2pix_nest(nside, ixo, iyo-1, other_face, inext)
       case(4)              !SouthEast edge
          other_face=8+ibp
          ipo=modulo(swapLSBMSB(ipf),nsidesq) !E-W flip
          inext = other_face*nsidesq+ipo   ! (8)
       case(6)              !North corner
          other_face=4+ibp
          inext=other_face*nsidesq+local_magic2 -2
       case(7)              !South corner
          other_face=8+ibp
          inext=other_face*nsidesq
       case(8)              !East corner
          other_face=8+ibp
          inext=other_face*nsidesq+local_magic2
       end select ! south
    endif

    return
#ifdef DOI8B
  end subroutine next_in_line_nest_8
#else
  end subroutine next_in_line_nest
#endif


    !=======================================================================
    ! template_pixel_ring
    !    Returns template-pixel index corresponding to each (RING ordered) pixel provided
    !    The reflexion (E-W, or N-W or both) to apply to the pixel to match the
    !    template is optionally returned
    !-------------------------------------------------------------
    !   For a given resolution Nside, there are 12*Nside*Nside pixels on the
    !   sphere, whose shape belong to one of the (Nside+6)*Nside/4 templates.
    !   (2 in the case Nside=1).
    !   Any pixel can be matched to a single of these templates by a combination of
    !    - a rotation around the polar axis with 
    !    - reflexion(s) around a meridian and/or the equator.
    !   The reflexion number returned by this routine for each pixel is
    !   Reflexion         Operation to do to match template
    !     0                 rotation only
    !     1                 rotation + East-West swap
    !     2                 rotation + North-South swap
    !     3                 rotation + East-West + North-South swaps
    !   
    !   The template pixels are all located in the Northern Hemisphere, or on the
    !   Equator.
    !   They are chosen to have
    !       z >= 2/3,      0< phi <= Pi/2               [Nside*(Nside+2)/4]
    !       2/3 > z >= 0,  phi=0, or phi=Pi/(4*Nside)   [Nside]
    !   They are numbered from 0, starting at the North Pole, with the index
    !   increasing in phi, and then increasing for decreasing z.
  !=======================================================================
#ifdef DOI8B
  subroutine template_pixel_ring_8(nside, pixel, templ8, reflexion)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine template_pixel_ring  (nside, pixel, templ8, reflexion)
    integer(i4b), parameter :: MKD = I4B
#endif
    !-------------------------------------------------------------
    character(len=*),           parameter :: code = "Template_pixel_ring"
    integer(I4B),    intent(IN)           :: nside
    integer(MKD),    intent(IN)           :: pixel
    integer(MKD),    intent(OUT)          :: templ8
    integer(I4B),    intent(OUT), optional:: reflexion
    ! local variables
    integer(MKD) :: npix, ncap, n0, ip
    integer(MKD) :: iring ! I4B would be enough, but more convenient for iring*iring
    integer(I4B) :: ns4, ifi, ifd, iff, refl
    real(DP)     :: fip
    !-------------------------------------------------------------

    npix = nside2npix(nside)
    if (npix < 0) then
       print*,'Invalid Nside = ',nside
       call fatal_error(code//' Abort')
    endif

    if (pixel < 0 .or. pixel >= npix) then
       print*,'Invalid Pixel = ',pixel
       call fatal_error(code//' Abort')
    endif

    ncap = 2*nside*(nside+1)
    ns4  = 4*nside
!     n0   = max( (nside*(nside+2))/4, 1)
    n0   = (1_MKD + nside * (nside + 2_MKD)) / 4_MKD


    refl = 0 ! no swap

    ! North polar cap
    if (pixel < ncap) then
       ip    = pixel + 1
       fip   = real(int(ip/2, kind=MKD) , kind=dp)
       iring = int(sqrt(ip/2.0_dp - sqrt(fip) )) + 1 ! counted from NORTH pole, starting at 1
       ifi   = MOD( (ip - 1 - 2*iring*(iring-1)), iring) ! in [0,iring-1], upwards
       ifd   = iring - 1 - ifi                           ! in [0,iring-1], downwards
       iff   = min(ifi, ifd)                             ! in [0,(iring-1)/2]
       templ8 = (iring*iring)/4 + iff
       if (ifd < ifi) refl = 1 ! East-West swap


    ! North-Equatorial region
    elseif (pixel < (npix+ns4)/2) then
       templ8 = n0 + (pixel - ncap)/ns4

    ! South-Equatorial region
    elseif (pixel < (npix-ncap)) then
       templ8 = n0 + (npix - 1 - pixel - ncap)/ns4
       refl = 2  ! North-South swap

    ! South polar cap
    else
       ip =  npix - pixel
       fip   = real(int(ip/2, kind=MKD) , kind=dp)
       iring = int(sqrt(ip/2.0_dp - sqrt(fip) )) + 1 ! counted from SOUTH pole, starting at 1
       ifi   = MOD( (2*iring*(iring+1) - ip), iring)    ! in [0,iring-1], upwards
       ifd  = iring - 1 - ifi                           ! in [0,iring-1], downwards
       iff  = min(ifi, ifd)                             ! in [0,(iring-1)/2]
       templ8 = (iring*iring)/4 + iff
       if (ifd < ifi) refl = 1 ! East-West swap
       refl = refl + 2    ! North-South swap
    endif

    if (present(reflexion)) reflexion = refl

    return
#ifdef DOI8B
  end subroutine template_pixel_ring_8
#else
  end subroutine template_pixel_ring
#endif


  !=======================================================================
  ! same_shape_pixels_ring
  !   Returns the list of RING ordered pixels having the same shape as the
  !   template provided
  !=======================================================================
#ifdef DOI8B
  subroutine same_shape_pixels_ring_8(nside, templ8, list, reflexion, nrep)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine same_shape_pixels_ring  (nside, templ8, list, reflexion, nrep)
    integer(i4b), parameter :: MKD = I4B
#endif
    !-------------------------------------------------------------

    character(len=*), parameter :: code = "same_shape_pixels_ring"
    integer(I4B),    intent(IN)                        :: nside
    integer(MKD),    intent(IN)                        :: templ8
    integer(MKD),    pointer,   dimension(:), optional :: list
    integer(I4B),    pointer,   dimension(:), optional :: reflexion
    integer(MKD),    intent(OUT)            , optional :: nrep

    integer(MKD) :: npix, ncap, ntplt, n0, nrep_in, iring, in0, is0
    integer(i4b) :: ns4 ! = 4*Nside <= 2^30
    integer(i4b) :: i, ifi
    integer(i4b), dimension(0:3) :: ramp4 = (/ 0, 1, 2, 3 /)
    integer(i4b), dimension(0:7) :: alt8  = (/ 0, 1, 0, 1, 0, 1, 0, 1 /)
    integer(i4b), dimension(0:7) :: rr8
    logical(lgt) :: do_list, do_rfx, do_nrep
    integer(i4b) :: ll=1, lr=1
    !-------------------------------------------------------------

    do_list = (present(list))
    do_rfx  = (present(reflexion))
    do_nrep = (present(nrep))

    if (do_rfx .and. .not. do_list) then
       print*,'Error in '//code//'. Can not have Reflexion without pixel list'
       call fatal_error()
    endif

    npix = nside2npix(nside)
    if (npix < 0) then
       print*,'Invalid Nside = ',nside
       call fatal_error(code//' Abort')
    endif

    ntplt= nside2ntemplates(nside)

    if (templ8 < 0 .or. templ8 >= ntplt) then
       print*,'Error on template argument'
       print*,'Nside = ',nside,', Template = ',templ8
       print*,'Template should be in [0, (1+Nside*(Nside+6))/4-1=',ntplt-1,']'
       call fatal_error(code//' Abort')
    endif

    ncap = 2*nside*(nside+1)
    ns4  = 4*nside
!    n0   = max( (nside*(nside+2))/4, 1)
    n0 = (1_MKD + nside * (nside + 2_MKD))/ 4

    ! find number of repetition of template around the sphere
    if (templ8 >= n0) then
       nrep_in = ns4 * 2_MKD ! Non- Equator: nrep = 8*Nside
       if (templ8 == ntplt - 1) nrep_in = ns4 ! Equator : nrep = 4*Nside
    else
       nrep_in  = 16
       iring = int(sqrt(4*templ8+1.0_dp), kind=MKD) ! in [1,Nside]
       ifi   = templ8 - (iring*iring)/4
       if (2*ifi+1 == iring) nrep_in = 8
    endif
    if (do_nrep) nrep = nrep_in
          

    ! create or expand (or leave alone) list array
    if (do_list) then
       if (associated(list)) then
          ll = lbound(list,dim=1)
          if (long_size(list) < nrep_in) then
             deallocate(list)
             allocate(list(ll:ll+nrep_in-1))
          endif
       else
          allocate(list(ll:ll+nrep_in-1))
       endif
       list = -1 ! default value for unused array elements
    endif

    ! create or expand (or leave alone) reflexion array
    if (do_rfx) then
       if (associated(reflexion)) then
          lr = lbound(reflexion,dim=1)
          if (long_size(reflexion) < nrep_in) then
             deallocate(reflexion)
             allocate(reflexion(lr:lr+nrep_in-1))
          endif
       else
          allocate(reflexion(lr:lr+nrep_in-1))
       endif
       reflexion = -1 ! default value for unused array elements
    endif


    ! fill up list and reflexion arrays
    if (templ8 >= n0) then 
       ! Non Polar pixels (most frequent)
    
       in0 = ncap + (templ8 - n0)*ns4

       if (templ8 == ntplt-1) then 
          ! Equator : nrep = 4*Nside
          if (do_list) list      = in0 + (/ (i, i=0, ns4-1) /)
          if (do_rfx)  reflexion = 0
       else 
          ! Non- Equator: nrep = 8*Nside
          is0 = npix - in0 - ns4
          if (do_list) then
             list(ll    :ll+  ns4-1) = in0 + (/ (i, i=0, ns4-1) /)
             list(ll+ns4:ll+2*ns4-1) = is0 + (/ (i, i=0, ns4-1) /)
          endif
          if (do_rfx) then
             reflexion(lr    :lr+  ns4-1) = 0
             reflexion(lr+ns4:lr+2*ns4-1) = 2
          endif
       endif

    else 
       ! Polar pixels
       in0   = 2*iring*(iring-1)
       is0   = npix - in0 - 4*iring

       if (2*ifi+1 == iring) then 
          ! pixel on phi = Pi/4, Nrep = 8
          if (do_list) then
             list(ll  :ll+3) = in0 + ifi + ramp4*iring
             list(ll+4:ll+7) = is0 + ifi + ramp4*iring
          endif
          if (do_rfx) then
             reflexion = (/ 0, 0, 0, 0, 2, 2, 2, 2 /)
          endif
       else 
          ! Nrep = 16
          rr8(0:6:2) = (/ 0, 1, 2, 3 /) * iring + ifi
          rr8(1:7:2) = (/ 1, 2, 3, 4 /) * iring - ifi - 1
          if (do_list) then
             list(ll  :ll+7 ) = in0 + rr8
             list(ll+8:ll+15) = is0 + rr8
          endif
          if (do_rfx) then
             reflexion(lr  :lr+7 ) = alt8
             reflexion(lr+8:lr+15) = alt8 + 2
          endif
       endif
    endif

    return

#ifdef DOI8B
  end subroutine same_shape_pixels_ring_8
#else
  end subroutine same_shape_pixels_ring
#endif


  !=======================================================================
  ! template_pixel_nest
  !    Returns template-pixel index corresponding to each (NESTED ordered) pixel provided
  !    The reflexion (E-W, or N-W or both) to apply to the pixel to match the
  !    template is optionally returned
  !=======================================================================
#ifdef DOI8B
  subroutine template_pixel_nest_8(nside, pixel, templ8, reflexion)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine template_pixel_nest  (nside, pixel, templ8, reflexion)
    integer(i4b), parameter :: MKD = I4B
#endif
    character(len=*), parameter :: code = "Template_pixel_nest"
    integer(I4B),    intent(IN)           :: nside
    integer(MKD),    intent(IN)           :: pixel
    integer(MKD),    intent(OUT)          :: templ8
    integer(I4B),    intent(OUT), optional:: reflexion
    !
    integer(MKD) :: pix_ring, npix
    
    npix = nside2npix(nside)
    if (npix < 0) then
       print*,'Invalid Nside = ',nside
       call fatal_error(code//' Abort')
    endif

    if (pixel < 0 .or. pixel >= npix) then
       print*,'Invalid Pixel = ',pixel
       call fatal_error(code//' Abort')
    endif

    call nest2ring(nside, pixel, pix_ring)
    call template_pixel_ring(nside, pix_ring, templ8, reflexion)

    return

#ifdef DOI8B
  end subroutine template_pixel_nest_8
#else
  end subroutine template_pixel_nest
#endif

  !=======================================================================
  ! same_shape_pixels_nest  
  !   Returns the list of NESTED ordered pixels having the same shape as the
  !   template provided
  !=======================================================================
#ifdef DOI8B
  subroutine same_shape_pixels_nest_8(nside, templ8, list, reflexion, nrep)
    use num_rec, only : iindexx
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine same_shape_pixels_nest  (nside, templ8, list, reflexion, nrep)
    use num_rec, only : iindexx
    integer(i4b), parameter :: MKD = I4B
#endif

    character(len=*), parameter :: code = "same_shape_pixels_nest"
    integer(I4B),    intent(IN)                        :: nside
    integer(MKD),    intent(IN)                        :: templ8
    integer(MKD),    pointer,   dimension(:), optional :: list
    integer(I4B),    pointer,   dimension(:), optional :: reflexion
    integer(MKD),    intent(OUT)            , optional :: nrep

    integer(MKD) :: ntplt, nr, i
    integer(MKD),   allocatable,   dimension(:)   :: idx, tmp
    integer(i4b) :: ll, lr
    logical(lgt) :: do_list, do_rfx, do_nrep
    !-------------------------------------------------------------

    do_list = (present(list))
    do_rfx  = (present(reflexion))
    do_nrep = (present(nrep))
  
    if (do_rfx .and. .not. do_list) then
       print*,'Error in '//code//'. Can not have Reflexion without pixel list'
       call fatal_error
    endif

    ntplt= nside2ntemplates(nside)

    if (templ8 < 0 .or. templ8 >= ntplt) then
       print*,'Error on template argument'
       print*,'Nside = ',nside,', Template = ',templ8
       print*,'Template should be in [0, (1+Nside*(Nside+6))/4-1=',ntplt-1,']'
       call fatal_error(code//' Abort')
    endif

    ! makes pixel list in RING indexing
    call same_shape_pixels_ring( nside, templ8, list, reflexion, nr)
    if (do_nrep) nrep = nr

    if (do_list .or. do_rfx) then
       allocate(idx  (0:nr-1))
       allocate(tmp  (0:nr-1))

       ! convert to NESTED
       if (do_list) then
          ll = lbound(list,      dim=1)
          do i = 0, nr-1
             call ring2nest(nside, list(ll+i), list(ll+i))
          enddo

          ! sort arrays in increasing order of pixel NESTED index
          call iindexx(nr, list, idx)
          !!!!!  list(ll:nr-1+ll) = list(idx-1+ll) ! replaced by loops for Gfortran
          do i=0, nr-1
             tmp(i) = list(idx(i)-1+ll)
          enddo
          do i=0, nr-1
             list(ll+i) = tmp(i)
          enddo
       endif
  
       if (do_rfx) then
          lr = lbound(reflexion,      dim=1)
          !!!!! reflexion(lr:nr-1+lr) = reflexion(idx-1+lr) ! replaced by loops for Gfortran
          do i=0, nr-1
             tmp(i) = reflexion(idx(i)-1+lr)
          enddo
          do i=0, nr-1
             reflexion(lr+i) = tmp(i)
          enddo
       endif

       deallocate(tmp)
       deallocate(idx)
    endif

    return

#ifdef DOI8B
  end subroutine same_shape_pixels_nest_8
#else
  end subroutine same_shape_pixels_nest
#endif


  !=======================================================================
  ! uniq2nest
  !  returns the Nside and Pnest (NESTED ordering pixel index) of
  !  input Puniq (Unique pixel indexing)
  !   Puniq = Pnest + 4 * Nside^2
  ! Sept 2015
  !=======================================================================

#ifdef DOI8B
  subroutine uniq2nest_8(puniq, nside, pnest)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine uniq2nest  (puniq, nside, pnest)
    integer(i4b), parameter :: MKD = I4B
#endif
    integer(MKD), intent(in)  :: puniq
    integer(I4B), intent(out) :: nside
    integer(MKD), intent(out) :: pnest
    integer(MKD) :: tmp_i
    real(DP)     :: tmp_d

    tmp_i = cheap_isqrt(puniq / 4_MKD)
    tmp_d = log( real(tmp_i, kind=DP) ) / log(2.0_DP)
    nside = 2_i4b ** int( tmp_d, kind=I4B )
    pnest = puniq - (4_MKD * nside) * nside

    return
#ifdef DOI8B
  end subroutine uniq2nest_8
#else
  end subroutine uniq2nest
#endif

  !=======================================================================
  ! nest2uniq
  !  returns Puniq (Unique pixel indexing)
  !  for given Nside and Pnest (NESTED ordering pixel index) of
  !   Puniq = Pnest + 4 * Nside^2
  ! Sept 2015
  !=======================================================================

#ifdef DOI8B
  subroutine nest2uniq_8(nside, pnest, puniq)
    integer(i4b), parameter :: MKD = I8B
#else
  subroutine nest2uniq  (nside, pnest, puniq)
    integer(i4b), parameter :: MKD = I4B
#endif
    character(len=*), parameter :: code='nest2uniq'
    integer(I4B), intent(in)  :: nside
    integer(MKD), intent(in)  :: pnest
    integer(MKD), intent(out) :: puniq
    integer(MKD) :: npix

    npix = nside2npix(nside)
    call assert(npix > 0, code//": invalid Nside")
    puniq = pnest + (4_MKD * nside) * nside


#ifdef DOI8B
    end subroutine nest2uniq_8
#else
    end subroutine nest2uniq
#endif

  !=======================================================================
  !=======================================================================
  !=======================================================================
! #ifdef DOI8B
!     integer(i4b), parameter :: MKD = I8B
! #else
!     integer(i4b), parameter :: MKD = I4B
! #endif
! #ifdef DOI8B
!     integer(i4b), parameter :: MKD = I8B
! #else
!     integer(i4b), parameter :: MKD = I4B
! #endif

! #ifdef DOI8B
! #else
! #endif

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
PROGRAM MAP2GIF
   !-------------------------------------------------------------------
   ! This program is a simplified kluge of mollview.pro, a basic tool to
   ! view a Mollweide projection of maps made in the Healpix pixelisation
   ! scheme. A map in FITS format is read and converted to a GIF image.
   !
   ! PURPOSE:
   !    basic tool to view a Mollweide projection of maps made
   !    in Healpix pixelisation
   !
   ! CALLING SEQUENCE:
   !    MAP2GIF  -inp input_file -out output_file 
   !            [-max usermax] [-min usermin]
   !            [-add offset] [-mul factor]
   !            [-pro projection] [-res gridresn]
   !            [-lon lon0] [-lat lat0]
   !            [-col color_table] [-sig signal]
   !            [-xsz xsize] [-log logflg]
   !            [-ash ashflg]
   !            [-bar barflg] [-ttl title]
   !            [-hlp]
   !
   ! INPUTS:
   !    input_file = string containing the name of a FITS file of
   !                 the healpix map in an extension or in the image field
   !
   !    output_file= string containing the name of the output GIF file(s)
   !
   !    color_table= color table number, in [1,5]
   !                 if unset the color table will be 5 (Blue-Red)
   !
   !    signal     = integer defining which field of the FITS file should be plotted
   !                 for an IQU map    1 = I; 2 = Q; 3 = U
   !                 for a polarized WMAP map  4=5= N_obs, 6 = N_QQ, ...
   !
   !    xsize      = x-dimension of image array to be stored in GIF file
   !                 if unset the x-size will be ysize = xsize/2
   !
   !     offset    = displays   map = (data+offset) * factor, default = 0
   !
   !     factor    = displays   map = (data+offset) * factor, default = 1
   !
   !     logflg    = if .true.,  displays    log(map)
   !                   default = .false. (ie. use actual temperatures)
   !
   !     ashflg    = if .true.,  displays   sinh^(-1)(map) (inverse Hyperbolic sinus)
   !                   default = .false. (ie. use actual temperatures)
   !
   !     title     = character string to be used as plot title
   !
   !     usermax   = sets the upper bound of plotted map
   !
   !     usermin   = sets the lower bound of plotted map
   !
   !     lon0      = longitude (deg) of central point
   !
   !     lat0      = latitude (deg) of central point
   !
   !     barflg    =   if set, add color bar
   !
   !     projection =  either "MOL" or "mol" (Mollweide, default) 
   !                       or "GNO" or "gno" (gnomic)
   !
   !     gridresn  = resolution in (u,v) plan in arcmin (only for Gnomic projection)
   !
   !
   ! PROCEDURES USED:
   !    parseOptions, getnumext_fits, getsize_fits, input_map, proj_mollw, proj_gnomic
   !
   ! EXTERNAL LIBRARY:
   !    this code uses the CFITSIO library that can be found at
   !    http://heasarc.gsfc.nasa.gov/docs/software/fitsio/
   !
   ! RELATED LITERATURE:
   !    see the web site http://www.tac.dk/~healpix
   !
   ! MODIFICATION HISTORY:
   !    October 1997,  Eric Hivon,      TAC (original IDL code)
   !    December 1998, A.J. Banday,     MPA (simple conversion to F90)
   !    December 1998, M.S. Bartelmann, MPA (cleanup, color tables, ...)
   !    January 1999,  A.J. Banday,     MPA (added gnomic routine)
   !    ??             M. Reinecke,     MPA
   !    November 2004, Eric Hivon,      IPAC (upgraded for WMAP polarized maps)
   !    Jan 2005,      EH               IPAC (edited to reduce stack consomption)
   !
  ! note: explicit loop on pixels instead of where structure because the latter requires large stack size
  !   for large maps
   !-------------------------------------------------------------------

   USE healpix_types
   USE misc_utils
   USE fitstools, only: getnumext_fits, getsize_fits, input_map
   use pix_tools, only: npix2nside
   USE gifmod

   IMPLICIT NONE

   INTEGER(I8B) :: npixtot, i
   INTEGER(I4B) :: nsmax
   INTEGER(I4B) :: nmaps
   INTEGER(I4B) :: ordering

   REAL(SP),     DIMENSION(:,:),   ALLOCATABLE :: map_IQU
   REAL(SP),     DIMENSION(:),     ALLOCATABLE :: map
   REAL(SP),     DIMENSION(:,:),   ALLOCATABLE :: image

   INTEGER(I4B), ALLOCATABLE, DIMENSION(:,:) :: imgint

   INTEGER(I4B), POINTER, DIMENSION(:,:) :: imgbar
   INTEGER(I4B), POINTER, DIMENSION(:,:) :: imgttl

   LOGICAL(LGT), DIMENSION(:,:),   ALLOCATABLE :: mask
   LOGICAL(LGT), DIMENSION(:),     ALLOCATABLE :: observed

   REAL(SP)     :: mindata, maxdata, Tmin, Tmax
   REAL(SP)     :: fmissval

   INTEGER(I4B) :: status, chunk

   CHARACTER(LEN=7), PARAMETER :: code = 'MAP2GIF'
   character(len=*), parameter :: VERSION = HEALPIX_VERSION

   CHARACTER(LEN=filenamelen) :: input_file = ''
   CHARACTER(LEN=filenamelen) :: output_file = ''
   CHARACTER(LEN=filenamelen) :: title = ''
   CHARACTER(LEN=3)   :: projection = 'MOL'
   REAL(SP)           :: usermax = 1.1e30
   REAL(SP)           :: usermin = -1.1e30
   REAL(SP)           :: lon0 = 0.0
   REAL(SP)           :: lat0 = 0.0
   REAL(SP)           :: gridresn = 2.0
   INTEGER(I4B)       :: color_table = 5
   INTEGER(I4B)       :: signal = 1         ! I/intensity measurement
   INTEGER(I4B)       :: xsize  = 800
   LOGICAL(LGT)       :: logflg = .false.
   LOGICAL(LGT)       :: bar = .false.
   LOGICAL(LGT)       :: ashflg = .false.
   REAL(SP)           :: offset = 0.0
   REAL(SP)           :: factor = 1.0
   logical            :: anynull 

   integer(i4b)       :: n_ext, i_ext, nmaps_sum, icolumn
!   real(sp) :: time0, time1, time2, time3, time4, time5, time6, time11, time12, time13
   !-------------------------------------------------------------------
!   call wall_clock_time(time0)
   !--- acquire input parameters ---
   call parseOptions()

   !--- read in the FITS file header, find out the pixel number of the map
   !    and its ordering ---
   nmaps_sum = 0
   icolumn   = signal
   n_ext   = getnumext_fits(input_file)
   do i_ext = 0, n_ext-1
      npixtot = getsize_fits(input_file, nmaps = nmaps, ordering=ordering, extno=i_ext)
      nmaps_sum = nmaps_sum + nmaps
      if (signal <= nmaps_sum) exit
      icolumn = signal - nmaps_sum
   enddo

   !--- are requested signal and map compatible? ---
   if (signal > nmaps_sum) THEN
      print *,' requested signal incompatible with file'
      call fatal_error
   end if

!    nsmax = NINT(SQRT( npixtot / 12.) )
!    call assert(npixtot == 12*nsmax*nsmax,'wrong number of pixels')
   nsmax = npix2nside(npixtot)
   call assert(nsmax > 0, 'wrong number of pixels')
   chunk = 1024*512
   if (nsmax <= 256) chunk = 2

   !--- allocate space for arrays ---
   ALLOCATE(map(0:npixtot-1),stat = status)
   call assert_alloc(status,'map2gif','map') 
   ALLOCATE(map_IQU(0:npixtot-1,1:nmaps),stat = status)
   call assert_alloc(status,'map2gif','map_IQU') 

   !--- read in the FITS file ---
   !call read_bintab(input_file, map_IQU, npixtot, nmaps, fmissval, anynull, extno=i_ext) ! flagged, NaN and Infinity pixels take same value of HPX_*BADVAL (returned in fmissval)
   call input_map(input_file, map_IQU, npixtot, nmaps, &
        & fmissval=HPX_SBADVAL, extno=i_ext, & ! flagged, NaN and Infinity pixels take value HPX_SBADVAL
        ignore_polcconv=.true.) ! ignore POLCCONV
!    call wall_clock_time(time1)
!    print*,'file read:', time1-time0

   !--- select correct signal to plot ---
   map(:) = map_IQU(:,icolumn)

   deallocate(map_IQU,stat = status)
   allocate(observed(0:npixtot-1),stat = status)
   call assert_alloc(status,'map2gif','observed') 

   !--- Test for unobserved pixels ---
!$OMP PARALLEL DEFAULT(NONE) SHARED(chunk,observed, map, npixtot) PRIVATE(i)
!$OMP DO schedule(dynamic, chunk)
   do i = 0, npixtot-1
      observed(i) = map(i) > HPX_SBADVAL
   enddo
!$OMP END DO
!$OMP END PARALLEL
!    call wall_clock_time(time11)
!    print*,'obs:', time11-time1

   if (offset /= 0. .or. factor /= 1.0) then
!$OMP PARALLEL DEFAULT(NONE) &
!$OMP SHARED(chunk,observed, map, npixtot, offset, factor) PRIVATE(i)
!$OMP DO schedule(dynamic, chunk)
      do i = 0, npixtot-1
         if (observed(i)) map(i) = (map(i)+offset)*factor
      enddo
!$OMP END DO
!$OMP END PARALLEL
   endif
   if (ashflg) then
!$OMP PARALLEL DEFAULT(NONE) SHARED(chunk,observed, map, npixtot) PRIVATE(i)
!$OMP DO schedule(dynamic, chunk)
      do i=0,npixtot-1
        if (observed(i)) then
          if (map(i)>=0) then
            map(i) = log(map(i)+sqrt(map(i)**2+1))
          else
            map(i) = -log(-map(i)+sqrt(map(i)**2+1))
          endif
        endif
      end do
!$OMP END DO
!$OMP END PARALLEL
   endif
   IF( logflg )THEN
!$OMP PARALLEL DEFAULT(NONE) SHARED(chunk,observed, map, npixtot) PRIVATE(i)
!$OMP DO schedule(dynamic, chunk)
      do i=0, npixtot - 1
         observed(i) = (map(i) > 0.)
         if (observed(i)) then
            map(i) = log10(map(i))
         else
            map(i) = HPX_SBADVAL
         endif
      enddo
!$OMP END DO
!$OMP END PARALLEL
   END IF
!    call wall_clock_time(time12)
!    print*,'loops:', time12-time11
!$OMP PARALLEL SHARED(chunk,mindata, maxdata, observed)
!$OMP SECTIONS
!$OMP SECTION
   mindata = minval(map, mask = observed)
!$OMP SECTION
   maxdata = maxval(map, mask = observed)
!$OMP END SECTIONS
!$OMP END PARALLEL
!    call wall_clock_time(time13)
!    print*,'minmax:', time13-time12

   if (mindata==maxdata) then
     print *,"Warning: map contains completely uniform values!"
     maxdata=mindata+1e-5
   endif

   !--- sets MIN and MAX using linear scaling ---
   if (ABS((maxdata+mindata)/(maxdata-mindata)) < 5.e-2) then
      !--- center of color scale is 0
      Tmax = MAXVAL(ABS((/mindata,maxdata/)))
      Tmin = -Tmax
   else
      Tmax = maxdata
      Tmin = mindata
   end if

   !--- allow for user min/max settings ---
   if (usermax <  1.1e30) Tmax = usermax
   if (usermin > -1.1e30) Tmin = usermin

   !--- adjust 'offscale' temperatures ---
!$OMP PARALLEL DEFAULT(NONE) &
!$OMP SHARED(chunk,observed, map, npixtot, Tmin, Tmax) &
!$OMP PRIVATE(i)
!$OMP DO schedule(dynamic, chunk)
   do i = 0, npixtot - 1
      if (observed(i)) map(i) = max(min(map(i), Tmax), Tmin)
   enddo
!$OMP END DO
!$OMP END PARALLEL
   deallocate(observed)
!    call wall_clock_time(time2)
!    print*,'cut:', time2-time13

   !--- create the projection ---
   select case (projection)
   case ('MOL', 'mol')
      !--- allocate space for image and mask ---
      ALLOCATE(image(0:xsize-1,0:xsize/2-1),stat = status)
      call assert_alloc(status,'map2gif','image') 
      ALLOCATE(mask(0:xsize-1,0:xsize/2-1),stat = status)
      call assert_alloc(status,'map2gif','mask') 

      !--- create the mollweide projection ---
      call proj_mollw_new(&
           map,      &
           nsmax,    &
           ordering, &
           xsize,    &
           lon0,     &
           lat0,     &
           image,    &
           mask      &
           )
   case ('GNO', 'gno')
      !--- allocate space for image and mask ---
      ALLOCATE(image(0:xsize-1,0:xsize-1),stat = status)
      call assert_alloc(status,'map2gif','image') 
      ALLOCATE(mask(0:xsize-1,0:xsize-1),stat = status)
      call assert_alloc(status,'map2gif','mask') 

      !--- create the gnomic projection ---
      call proj_gnomic(&
           map,        &
           nsmax,      &
           ordering,   &
           xsize,      &
           lon0,       &
           lat0,       &
           gridresn,   &
           image,      &
           mask        &
           )
   case default
      print '(" unknown projection type: ",a3)', projection
      call fatal_error
   end select
!    call wall_clock_time(time3)
!    print*,'project:', time3-time2

   !--- load the color table ---
   call setcol( color_table )

   !--- scale image ---
   allocate(imgint(size(image,1),size(image,2)), stat = status)
   call assert_alloc(status,'map2gif','imgint (image)') 
   call imgscl(&
        image,  &
        imgint, &
        mask    &
        )
   deallocate(image)

   !--- add color bar ---
   if (bar) then
      call addbar(&
           imgint, &
           imgbar  &
           )
      deallocate(imgint)
      allocate(imgint(size(imgbar,1),size(imgbar,2)), stat = status)
      call assert_alloc(status,'map2gif','imgint (bar)') 
      imgint = imgbar
      deallocate(imgbar)
   end if

   !--- add title ---
   if (title /= '') then
      call addttl(&
           imgint, &
           imgttl, &
           title   &
           )
      deallocate(imgint)
      allocate(imgint(size(imgttl,1),size(imgttl,2)), stat = status)
      call assert_alloc(status,'map2gif','imgint (title)') 
      imgint = imgttl
      deallocate(imgttl)
   end if

   !--- create the GIF image ---
   call gifmap(&
        imgint,           &
        trim(output_file) &
        )

   !--- deallocate memory for arrays ---
   DEALLOCATE(map,stat = status)
   DEALLOCATE(mask,stat = status)
!    call wall_clock_time(time4)
!    print*,'finish:', time4-time3

   !--- Exit, stage left ...

contains



SUBROUTINE PROJ_MOLLW_New(&
     map,      &
     nside,    &
     ordering, &
     xsize,    &
     lon0,     &
     lat0,     &
     image,    &
     mask      &
     )
   ! --------------------------------------------------------------
   ! This subroutine takes an input HEALPIX sky map array and
   ! generates the (u,v) position on a mollweide projection.
   !
   ! INPUTS:
   !       map     = array containing pixel temperatures
   !       nside   = defines number of pixels on the sky
   !       ordering= whether input map is in RING or NESTED format
   !       xsize   = x-dimension of output image array
   !       lon0    = longitude (in degrees) of the center of the plot
   !       image   = output mollweide projection image
   !       mask    = logical array defining usable pixels in output image array
   !
   ! PROCEDURES USED:
   !            ang_pix, ang_nest_pix
   !
   !  RELATED LITERATURE:
   !  see the web site http://www.tac.dk/~healpix
   !
   ! MODIFICATION HISTORY:
   !    October 1997, Eric Hivon, TAC (original IDL code)
   !       December 1998, A.J. Banday MPA (conversion to F90)
   !    Nov 2010, E.H., IAP (implement lat0 rotation)
   !
   ! --------------------------------------------------------------

   USE healpix_types
   USE pix_tools
   use misc_utils

   IMPLICIT NONE

   REAL(SP), DIMENSION(0:), intent(in) :: map
   INTEGER(I4B),            intent(in) :: ordering, nside, xsize
   REAL(SP),     DIMENSION(0:xsize-1,0:xsize/2-1), intent(out) :: image
   LOGICAL(LGT), DIMENSION(0:xsize-1,0:xsize/2-1), intent(out) :: mask
   REAL(SP), intent(in) :: lon0, lat0

   INTEGER(I4B) :: ysize,I,J
   INTEGER(I4B) :: xc, dx, yc, dy
   INTEGER(I8B) :: id_pix

   REAL(DP) :: lon0rad, lat0rad
   !REAL(DP) :: DtoR = PI/180.0_dp

   REAL(DP), DIMENSION(:,:), ALLOCATABLE :: u, v
   real(DP), dimension(1:3) :: vector
   real(DP), dimension(3,3) :: matrix
   real(DP) :: s_tmp, sz_tmp, z_tmp, phi_tmp, uu, vv

   INTEGER(I4B) :: status
   ! --------------------------------------------------------------

   ! --- define rotation matrix ---
   lon0rad = lon0 * DEG2RAD
   lat0rad = lat0 * DEG2RAD
   ! euler matrix: ZYX convention (itype=1)
   ! the minus sign on the second angle is because we work on latitude
   ! while the Euler matrix works on co-latitude
   call euler_matrix_new(-lon0rad, lat0rad, 0.0_dp, matrix, 1_i4b)

   !--- generates the (u,v) position on the mollweide map ---
   image(:,:) = 1.                         ! white background ???
   mask(:,:)  = .false.  ! unobserved

   ysize = xsize/2
   xc = (xsize-1)/2
   dx = xc
   yc = (ysize-1)/2
   dy = yc

   !--- allocate memory for arrays ---
   ALLOCATE(u(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','u')
   do i = 0,xsize-1
      u(i,:) = real(i,dp)
   end do
   ALLOCATE(v(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','v')
   do i = 0,ysize-1
      v(:,i) = real(i,dp)
   end do

   u =  2._dp*(u - real(xc,dp))/(real(dx,dp)/1.02_dp)   ! 1.02 : fudge factor in [-2,2]*1.02
   v =        (v - real(yc,dp))/(real(dy,dp)/1.02_dp)   ! in [-1,1] * 1.02

!$OMP PARALLEL DEFAULT(NONE) &
!$OMP SHARED(u,v,xsize,ysize,mask,matrix,nside,ordering,image,map) &
!$OMP PRIVATE(i,j,uu,vv,s_tmp,z_tmp,sz_tmp,phi_tmp,vector,id_pix)
!$OMP DO schedule(dynamic, 1000)
   DO J = 0,ysize-1
      DO I = 0,xsize-1
         uu = u(i,j)
         vv = v(i,j)
         if ((uu*uu*0.25_dp + vv*vv) <= 1._dp) then
            !--- for each point on the mollweide map looks for the corresponding
            !    vector position on the sphere ---
            mask(i,j) = .true.
            s_tmp  = sqrt( (1._dp-vv)*(1._dp+vv) )
            z_tmp  = (asin(vv) + vv*s_tmp) / HALFPI
            sz_tmp = SQRT( (1._dp - z_tmp)*(1._dp + z_tmp) )

            phi_tmp   = - HALFPI * uu / s_tmp
            vector(1) = sz_tmp * cos(phi_tmp)
            vector(2) = sz_tmp * sin(phi_tmp)
            vector(3) = z_tmp
            ! rotate position
            vector = matmul(matrix, vector)
            ! read out input map
            if (ordering == 2) then
               call vec2pix_nest( nside, vector, id_pix )
            else ! default
               call vec2pix_ring( nside, vector, id_pix )
            end if
            image(I,J) = map(id_pix)
         endif
      enddo
   enddo
!$OMP END DO
!$OMP END PARALLEL

   !--- deallocate memory for arrays ---
   deallocate( u )
   deallocate( v )

END SUBROUTINE PROJ_MOLLW_New



SUBROUTINE PROJ_GNOMIC(&
     map,      &
     nside,    &
     ordering, &
     xsize,    &
     lon0,     &
     lat0,     &
     resgrid,  &
     image,    &
     mask      &
     )

   ! --------------------------------------------------------------
   ! This subroutine takes an input HEALPIX sky map array and
   ! generates the gnomic (tangential) projection on a rectangular grid.
   !
   ! INPUTS:
   !       map     = array containing pixel temperatures
   !       nside   = defines number of pixels on the sky
   !       ordering= whether input map is in RING or NESTED format
   !       xsize   = x-dimension of output image array
   !       lon0    = longitude (in degrees) of the center of the plot
   !       lat0    = latitude (in degrees) of the center of the plot
   !       gridresn= resolution of the grid elements in ARCMINUTES
   !       image   = output gnomic projection image
   !       mask    = logical array defining usable pixels in output
   !                 image array
   !
   ! PROCEDURES USED:
   !            ang_pix, ang_nest_pix, euler_matrix_new
   !
   !  RELATED LITERATURE:
   !  see the web site http://www.tac.dk/~healpix
   !
   ! MODIFICATION HISTORY:
   !    October 1997, Eric Hivon, TAC (original IDL code)
   !    January 1999, A.J. Banday MPA (conversion to F90)
   !    March   1999, EH Caltech (consistent with new IDL version,
   !                       fixed a bug on rotation)
   !
   ! --------------------------------------------------------------

   USE healpix_types
   USE pix_tools
   use misc_utils

   IMPLICIT NONE

   INTEGER(I4B) :: I,J
   INTEGER(I8B) :: id_pix
   INTEGER(I4B) :: ordering
   INTEGER(I4B) :: nside

   INTEGER(I4B) :: xsize

!   REAL(SP), DIMENSION(0:12*nside**2-1) :: map
   REAL(SP), DIMENSION(0:) :: map

   REAL(SP),     DIMENSION(0:xsize-1,0:xsize-1) :: image
   LOGICAL(LGT), DIMENSION(0:xsize-1,0:xsize-1) :: mask

   REAL(SP) :: lon0, lat0, resgrid
   REAL(DP) :: lon0rad, lat0rad, resgrid_rad
   REAL(DP) :: DtoR = PI/180.0_dp

   REAL(DP), DIMENSION(:,:), ALLOCATABLE :: xg, yg, zg, rg
   REAL(DP), DIMENSION(3,3)              :: matrix
   REAL(DP), DIMENSION(3)                :: nvs

   INTEGER(I4B) :: status

   ! --------------------------------------------------------------

   !-- some basic variable manipulations --
   resgrid_rad = (real(resgrid,dp)/60.0_dp) * DtoR !/ real(xsize-1,dp)
   lon0rad = real(lon0,dp) * DtoR
   lat0rad = real(lat0,dp) * DtoR
!   theta0  = halfpi - lat0rad
!   phi0    = lon0rad

   !-- generates the projection around the chosen contact point
   !   on the planar grid  (1,Y,Z) --
   image(:,:) = 1.0
   mask(:,:)  = .true.

   !--- allocate memory for arrays ---
   ALLOCATE(xg(0:xsize-1,0:xsize-1),stat = status)
   call assert_alloc(status,'map2gif','xg')
   xg = 1.0_dp
   ALLOCATE(yg(0:xsize-1,0:xsize-1),stat = status)
   call assert_alloc(status,'map2gif','yg')
   do i = 0,xsize-1
      yg(i,:) = -(real(i,dp) - 0.5_dp*real(xsize,dp) + 0.5_dp) *&
           & resgrid_rad  ! minus sign = astro convention
   end do
   ALLOCATE(zg(0:xsize-1,0:xsize-1),stat = status)
   call assert_alloc(status,'map2gif','zg')
   do i = 0,xsize-1
      zg(:,i) = (real(i,dp) - 0.5_dp*real(xsize,dp) + 0.5_dp) *&
           & resgrid_rad
   end do
   ALLOCATE(rg(0:xsize-1,0:xsize-1),stat = status)
   call assert_alloc(status,'map2gif','rg')
   rg = sqrt(1.0_dp + yg**2 + zg**2)

   !-- the contact point is rotated by theta0 around y (=colatitude)
   !   and phi0 around z (=azimut) --
   ! euler matrix: ZYX convention (itype=1)
   ! the minus sign on the second angle is because we work on latitude
   ! while the Euler matrix works on co-latitude
   call euler_matrix_new(-lon0rad, lat0rad, 0.0_dp, matrix, 1_i4b)

   xg = 1.0_dp / rg
   yg = yg / rg
   zg = zg / rg


   !--- converts the position on the sphere into pixel number and project the
   !    corresponding data value on the map ---
!$OMP PARALLEL DEFAULT(NONE) &
!$OMP SHARED(xsize, matrix, nside, ordering, image, map, xg, yg, zg) &
!$OMP PRIVATE(i, j, nvs, id_pix)
!$OMP DO schedule(dynamic, 1000)
   DO I = 0,xsize-1
      DO J = 0,xsize-1
         !-- rotated positions --
         nvs = matmul(matrix,(/ xg(i,j), yg(i,j), zg(i,j) /))
         if (ordering .eq. 2) then
            call vec2pix_nest( nside, nvs, id_pix )
            ! id_pix in [0,12*nside^2-1]
         else ! default
            call vec2pix_ring( nside, nvs, id_pix )
            ! id_pix in [0,12*nside^2-1]
         end if
         image(I,J) = map(id_pix)
      END DO
   END DO
!$OMP END DO
!$OMP END PARALLEL

   !--- deallocate memory for arrays ---
   deallocate( xg )
   deallocate( yg )
   deallocate( zg )

END SUBROUTINE PROJ_GNOMIC

   subroutine parseOptions ()

     USE extension, ONLY : getArgument, nArguments
      implicit none

      integer(I4B)       :: i,n
      character(len=4)   :: opt
      character(len=filenamelen) :: arg

      n = nArguments()

      if (n < 4) then
         print *, 'usage: MAP2GIF -inp input_file -out output_file'
         print *, '               [-add offset] [-ash ashflg] '
         print *, '               [-bar add color bar] [-col color_table] '
         print *, '               [-hlp]'
         print *, '               [-max usermax] [-min usermin]'
         print *, '               [-mul factor]'
         print *, '               [-lat lat0] [-log logflg] [-lon lon0] '
         print *, '               [-pro projection] [-res gridresn]'
         print *, '               [-sig signal] [-ttl title]'
         print *, '               [-xsz xsize] '
         print *, '               '
         print *, '               '
      end if


      do i = 1,n,2
         call getArgument(i,opt)
         if (opt == '-hlp') then
            print 1, trim(input_file),trim(output_file),&
                 & offset, &
                 & ashflg,&
                 & bar,&
                 & color_table,&
                 & usermax,&
                 & usermin,&
                 & factor, &
                 & lat0, &
                 & logflg,&
                 & lon0, &
                 & trim(projection), &
                 & gridresn, &
                 & signal,&
                 & trim(title), &
                 & xsize
            stop
         end if
         if (i == n) then
            print '("option ",a2," has no argument")', opt
            call fatal_error
         end if
         call getArgument(i+1,arg)
         select case (opt)
         case ('-inp')
            input_file = trim(arg)
         case ('-out')
            output_file = trim(arg)
         case ('-col')
            read (arg,*) color_table
         case('-sig')
            read (arg,*) signal
         case ('-xsz')
            read (arg,*) xsize
         case ('-log')
            read (arg,*) logflg
         case ('-ash')
            read (arg,*) ashflg
         case ('-bar')
            read (arg,*) bar
         case ('-ttl')
            title = trim(arg)
         case ('-max')
            read (arg,*) usermax
         case ('-min')
            read (arg,*) usermin
         case ('-add')
            read (arg,*) offset
         case ('-mul')
            read (arg,*) factor
         case ('-pro')
            projection = trim(arg)
         case ('-lat')
            read (arg,*) lat0
         case ('-lon')
            read (arg,*) lon0
         case ('-res')
            read (arg,*) gridresn
         case default
            print '("unknown option ",a4," ignored")', opt
         end select
      end do
      if (n < 4) then
         call fatal_error('Not enough arguments')
      endif

      call assert_present(input_file)
      if (output_file(1:1) /= '!') then
         call assert_not_present(output_file)
      else
         output_file = output_file(2:len(output_file))
      endif

      if (usermax == usermin) then
         print *, 'it is silly to set the maximum and the minimum'
         print *, 'to the same value, is it not?'
         call fatal_error
      end if

      if (ashflg .and. logflg) then
         print *, '-log and -ash cannot both be true!'
         call fatal_error
      end if

1     format(/,&
           & " -inp [Req] ",A,/,&
           & " -out [Req] ",A/,&
           & " -add [Opt] ",g10.2,/,&
           & " -ash [Opt] ",L1,/,&
           & " -bar [Opt] ",L1,/,&
           & " -col [Opt] ",I1,/,&
           & " -max [Opt] ",g10.2,/,&
           & " -min [Opt] ",g10.2,/,&
           & " -mul [Opt] ",g10.2,/,&
           & " -lat [Opt] ",g10.2,/,&
           & " -log [Opt] ",L1,/,&
           & " -lon [Opt] ",g10.2,/,&
           & " -pro [Opt] ",A,/,&
           & " -res [Opt] ",g10.2,/,&
           & " -sig [Opt] ",I1,/,&
           & " -ttl [Opt] ",A,/,&
           & " -xsz [Opt] ",I6,/)

   end subroutine parseOptions

!********************************************************************
!********************************************************************
!********************************************************************
!********************************************************************
!                   O B S O L E T E
!********************************************************************
!********************************************************************
!********************************************************************
!********************************************************************

subroutine euler_matrix(       &
                        a1,    &
                        a2,    &
                        a3,    &
                        matrix &
                                )

   ! --------------------------------------------------------------
   !
   ! this subroutine computes the Euler matrix corresponding
   ! to aeronautics conventionn following the prescription
   !    rotation a1 around original Z
   !    rotation a2 around interm   Y
   !    rotation a3 around final    X
   ! see H. Goldestein, Classical Mechanics (2nd Ed.) p. 147 for
   ! discussion
   ! INPUTS:
   !        a1, a2, a3 = Euler angles, in radians
   !        all the angles are measured counterclockwise
   !
   ! MODIFICATION HISTORY:
   !    October 1997, Eric Hivon, TAC (original IDL code)
   !    January 1999, A.J. Banday MPA (conversion to F90)
   !    March 22 1999, E.H. Caltech   (modification to match IDL version,
   !    correction of a bug on the matrix product)
   !
   ! --------------------------------------------------------------

   USE healpix_types

   IMPLICIT NONE

   REAL(DP)                 :: a1,a2,a3, c1,c2,c3, s1,s2,s3
   REAL(DP)                 :: ze,un
   REAL(DP), DIMENSION(3,3) :: matrix
   REAL(DP), DIMENSION(3,3) :: m1,m2,m3

   ! --------------------------------------------------------------

   !-- convert to sin and cosine values --
   c1 = COS(a1)
   s1 = SIN(a1)
   c2 = COS(a2)
   s2 = SIN(a2)
   c3 = COS(a3)
   s3 = SIN(a3)

   ze = 0.0_dp
   un = 1.0_dp

   !-- form full rotation matrix --
   !-- FOR REFERENCE:
   ! m1 = [[ c1, s1,  0],[-s1, c1,  0],[  0,  0,  1]] ! around orig  z
   ! m2 = [[ c2,  0, s2],[  0,  1,  0],[-s2,  0, c2]] ! around orig  y
   ! m3 = [[  1,  0,  0],[  0, c3, s3],[  0,-s3, c3]] ! around orig  x
   ! A ## B = matrix product AB
   ! matrix = m3 # ( m2 # m1)  = m1 m2 m3 ! here was the bug

   m1(:,1) = (/ c1, s1, ze /)
   m1(:,2) = (/-s1, c1, ze /)
   m1(:,3) = (/ ze, ze, un /)

   m2(:,1) = (/ c2, ze, s2 /)
   m2(:,2) = (/ ze, un, ze /)
   m2(:,3) = (/-s2, ze, c2 /)

   m3(:,1) = (/ un, ze, ze /)
   m3(:,2) = (/ ze, c3, s3 /)
   m3(:,3) = (/ ze,-s3, c3 /)

   matrix = matmul(m1,matmul(m2,m3))

end subroutine euler_matrix

SUBROUTINE PROJ_MOLLW(&
     map,      &
     nside,    &
     ordering, &
     xsize,    &
     lon0,     &
     image,    &
     mask      &
     )
   ! --------------------------------------------------------------
   ! This subroutine takes an input HEALPIX sky map array and
   ! generates the (u,v) position on a mollweide projection.
   !
   ! INPUTS:
   !       map     = array containing pixel temperatures
   !       nside   = defines number of pixels on the sky
   !       ordering= whether input map is in RING or NESTED format
   !       xsize   = x-dimension of output image array
   !       lon0    = longitude (in degrees) of the center of the plot
   !       image   = output mollweide projection image
   !       mask    = logical array defining usable pixels in output image array
   !
   ! PROCEDURES USED:
   !            ang_pix, ang_nest_pix
   !
   !  RELATED LITERATURE:
   !  see the web site http://www.tac.dk/~healpix
   !
   ! MODIFICATION HISTORY:
   !    October 1997, Eric Hivon, TAC (original IDL code)
   !       December 1998, A.J. Banday MPA (conversion to F90)
   !
   ! --------------------------------------------------------------

   USE healpix_types
   USE pix_tools
   use misc_utils

   IMPLICIT NONE

   INTEGER(I4B) :: I,J
   INTEGER(I8B) :: id_pix
   INTEGER(I4B) :: ordering
   INTEGER(I4B) :: nside

   INTEGER(I4B) :: xsize, ysize

!   REAL(SP), DIMENSION(0:12*nside**2-1) :: map
   REAL(SP), DIMENSION(0:) :: map

   REAL(SP),     DIMENSION(0:xsize-1,0:xsize/2-1) :: image
   LOGICAL(LGT), DIMENSION(0:xsize-1,0:xsize/2-1) :: mask

   REAL(SP) :: lon0
   REAL(DP) :: lon0rad
   REAL(DP) :: DtoR = PI/180.0_dp

   INTEGER(I4B) :: xc, dx, yc, dy

   REAL(DP), DIMENSION(:,:), ALLOCATABLE :: u, v
   REAL(DP), DIMENSION(:,:), ALLOCATABLE :: out_lat, out_lon

   INTEGER(I4B) :: status

   ! --------------------------------------------------------------

   ysize = xsize/2

   !--- generates the (u,v) position on the mollweide map ---
   image(:,:) = 1.                         ! white background ???

   xc = (xsize-1)/2
   dx = xc
   yc = (ysize-1)/2
   dy = yc

   !--- allocate memory for arrays ---
   ALLOCATE(u(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','u')
   do i = 0,xsize-1
      u(i,:) = real(i,dp)
   end do
   ALLOCATE(v(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','v')
   do i = 0,ysize-1
      v(:,i) = real(i,dp)
   end do
   ALLOCATE(out_lat(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','out_lat')
   ALLOCATE(out_lon(0:xsize-1,0:ysize-1),stat = status)
   call assert_alloc(status,'map2gif','out_lon')

   u =  2._dp*(u - real(xc,dp))/(real(dx,dp)/1.02_dp)   ! 1.02 : fudge factor in [-2,2]*1.02
   v =    (v - real(yc,dp))/(real(dy,dp)/1.02_dp)   ! in [-1,1] * 1.02

   !--- for each point on the mollweide map looks for the corresponding
   !    position (lon, lat) on the sphere ---
   mask = (u**2/4._dp + v**2) <= 1._dp
   out_lat = 1.e12_dp ! values for points out of the sphere
   out_lon = 1.e12_dp
   lon0rad = real(lon0,dp) * DtoR
   WHERE( mask )
      out_lat = PI/2._dp - (ASIN ( 2._dp/PI * (&
           & ASIN(v) + v*SQRT( (1._dp-v)*(1._dp+v) )) ))
      ! colat in [0,pi]
      out_lon = -lon0rad - PI/2._dp * u/MAX(SQRT( (1._dp-v)*(1._dp+v) ),1.e-6_dp)
      ! lon in [-pi,pi], the minus sign for astro convention
   END WHERE

   WHERE(out_lon < 0._dp)
      out_lon = out_lon  + 2._dp*PI
      ! lon in RAD in [0,2pi]
   END WHERE

   !--- converts the position on the sphere into pixel number and project the
   !    corresponding data value on the map ---
   DO I = 0,xsize-1
      DO J = 0,ysize-1
         IF(ABS(out_lat(I,J)) .LE. 1.e5_dp)THEN ! keep only meaningful points
            if (ordering .eq. 1) then
               call ang2pix_ring( nside, out_lat(I,J), out_lon(I,J), id_pix )
               ! id_pix in [0,12*nside^2-1]
            else
               call ang2pix_nest( nside, out_lat(I,J), out_lon(I,J), id_pix )
               ! id_pix in [0,12*nside^2-1]
            end if
            image(I,J) = map(id_pix)
         END IF
      END DO
   END DO

   !--- deallocate memory for arrays ---
   deallocate( u )
   deallocate( v )
   deallocate( out_lat )
   deallocate( out_lon )

END SUBROUTINE PROJ_MOLLW
!********************************************************************
!********************************************************************

END PROGRAM MAP2GIF

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!===================================================================================
program plmgen
  ! scalar implementation
  !===================================================================================
  ! precomputation of scalar and tensorial spherical harmonics
  ! version 1.0 : ?
  ! version 1.1 : ?
  ! version 1.2 :
  !   Aug 14, 2000, EH, Caltech, switch to CMBFAST normalisation of tensorial spherical harmonics
  !       (see Zaldarriaga, astro-ph/9709271; ApJ, 503, 1 (1998))
  ! version 1.3 : Aug 2004, EH, Ipac
  !      put calculations in plm_gen in alm_tools
  ! version 1.4: June 2008: check that job is compatible with 4 bytes variable,
  !              more verbose parsing
  !===================================================================================
  USE healpix_types
  USE misc_utils, ONLY: assert_alloc, wall_clock_time, strlowcase, brag_openmp, fatal_error
  USE head_fits, ONLY: add_card
  USE fitstools, ONLY: write_plm
  USE pix_tools, ONLY: nside2npix
  USE alm_tools, ONLY: plm_gen
  USE extension, ONLY : getArgument, nArguments
  USE paramfile_io, ONLY : paramfile_handle, parse_init, parse_int, &
         parse_string, concatnl, parse_check_unused, parse_summarize, parse_finish

  implicit none

  INTEGER(I4B) :: nsmax, nlmax, nmmax
  INTEGER(I4B) :: nd
  REAL(DP), DIMENSION(:,:),ALLOCATABLE :: plm
  LOGICAL(LGT) :: polarisation

  CHARACTER(LEN=filenamelen)        :: outfile
  CHARACTER(LEN=80), DIMENSION(160) :: header
  CHARACTER(LEN=*), PARAMETER :: code = 'PLMGEN'
  character(len=*), parameter :: VERSION = HEALPIX_VERSION

  INTEGER(I4B) :: n_plm
  integer(i8b) :: n_plm_8
  INTEGER(I4B) :: status, nlheader, simul_type

  type(paramfile_handle)        :: handle
  character(LEN=filenamelen)    :: parafile = ''
  character(len=filenamelen)    :: description
  character(len=100)            :: chline
  character(len=20)             :: lcode

  real(kind=SP)                 :: clock_time, time0, time1
  real(kind=SP)                 :: ptime, ptime0, ptime1

  !===================================================================================

  call wall_clock_time(time0)
  call cpu_time(ptime0)
  lcode = trim(strlowcase(code))

  if (nArguments() == 0) then
     parafile=''
  else
     if (nArguments() /= 1) then
        write(*,'(a)') " Usage:"//trim(lcode)//" [parameter file name]"
        stop 1
     end if
     call getArgument(1,parafile)
  end if

  PRINT *, " "
  PRINT *,"                    "//code//" "//version
  write(*,'(a)') &
       & " *** Precomputation of spherical harmonics (modulus of the complex Ylm) ***" 
  write(*,'(a)') &
       & " ***   used to analyse/synthetize Healpix maps of a given resolution    ***"
  PRINT *, " "

  handle = parse_init(parafile)

  !     --- choose temp. only or  temp. + pol. ---
  description = concatnl( &
       & " Do you want to compute the spherical harmonics for", &
       & " 1) Temperature only", &
       & " 2) Temperature + polarisation")
  simul_type = parse_int(handle, 'simul_type', default=1, vmin=1, vmax=2, descr=description)
  if (simul_type .eq. 1) polarisation = .false.
  if (simul_type .eq. 2) polarisation = .true.

  !     --- get resolution parameter ---
3 continue
  description = concatnl( &
       & "", &
       & " Enter the resolution parameter (Nside) of the map to be analysed/synthetized: ",&
       & " (Npix = 12*Nside**2, where Nside HAS to be a power of 2, eg: 32, 512, ...)" )
  nsmax = parse_int(handle, 'nsmax', default=32, descr=description)
  if (nside2npix(nsmax) < 0) then
     print *, " Error: nsmax is not a power of two."
     if (handle%interactive) goto 3
     stop 1
  endif

  !     --- gets the L range for the simulation ---
  WRITE(chline,"(a,i5,a)") "We recommend: (0 <= l <= l_max <= ",3*nsmax-1,")"
  description = concatnl(&
       & "", &
       & " Enter the maximum l range (l_max) for the computation. ", &
       & chline )
  nlmax = parse_int(handle, 'nlmax', default=2*nsmax, descr=description)

  !     --- gets the output sky map filename ---
  description = concatnl(&
       & "", &
       & " Enter Output file name (eg, plm.fits) :", &
       & "  (or !plm.fits to overwrite an existing file)" )
  outfile = parse_string(handle, "outfile", &
       & default="!plm.fits", descr=description, filestatus="new")

  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle, code=lcode)
  call parse_finish(handle)

  nmmax = nlmax ! not required
  n_plm_8 = (nmmax+1_i8b)*(2*nlmax-nmmax+2_i8b)*nsmax
  n_plm   = (nmmax+1    )*(2*nlmax-nmmax+2    )*nsmax

!   if (n_plm_8 > 2147483647 .or. n_plm < 0) then
!      print*,' '
!      write(*,'(a,i6,i6,a)') 'Error: these values of Nside and l_max (',nsmax,nlmax,')'
!      print*,' are too large for the current implementation of '//trim(lcode)//'.'
!      print*,'See documentation for details.'
!      call fatal_error('Aborting')
!   endif
  if (n_plm_8 > 2147483647 .or. n_plm < 0) then
     print*,' '
     write(*,'(a,i6,i6,a)') 'Warning: these values of Nside and l_max (',nsmax,nlmax,')'
     print*,' are too large for the current implementation of '//trim(lcode)//'.'
     print*,'See documentation for details.'
     print*,'This may create problems.'
  endif

  nd = 1
  if (polarisation) nd = 3
  write(*,'(a,f10.2,a)') 'The code requires ',n_plm_8 * nd * 8e-6, ' Mbytes'

  ALLOCATE(plm(0:n_plm_8-1,1:nd),stat = status)
  call assert_alloc(status,code,'plm')
  ! print*,'allocated'

  call plm_gen(nsmax, nlmax, nmmax, plm)

  header = ' '
  call add_card(header,'CREATOR', code,        'Software creating the FITS file')
  call add_card(header,'VERSION', version,     'Version of the simulation software')
  ! NSIDE, MAX-LPOL, MAX-MPOL, POLAR kwds are automatically updated (or added) by write_plm
  call add_card(header,'NSIDE'   ,nsmax,   'Resolution parameter for HEALPIX')
  call add_card(header,'MAX-LPOL',nlmax      ,'Maximum multipole l of P_lm')
  call add_card(header,'MAX-MPOL',nmmax      ,'Maximum m of P_lm')
  call add_card(header,'POLAR',   polarisation, 'Polarisation included (T/F)')
  call add_card(header)

  call add_card(header,'COMMENT','-----------------------------------------------')
  call add_card(header,'COMMENT','     Data Description Specific Keywords       ')
  call add_card(header,'COMMENT','-----------------------------------------------')
  call add_card(header)
!   call add_card(header,'COMMENT','contains precomputed Y_lms,')
!   call add_card(header,'COMMENT','in the order: ')
!   call add_card(header,'COMMENT','m=0:      Y_00, Y_10, Y_20, Y_30, ...')
!   call add_card(header,'COMMENT','m=1:            Y_11, Y_21, Y_31, ...')
!   call add_card(header,'COMMENT','m=2:                  Y_22, Y_32, ...')
!   call add_card(header)
!   call add_card(header,'COMMENT',' for each ring from North Pole to Equator.')
!   call add_card(header,'COMMENT','synfast and anafast execute faster with precomputed Y_lms')
!   call add_card(header)
!   call add_card(header,'TTYPE1', 'SCALAR',  'Scalar Spherical Harmonics (Y_lm)')
!   if (polarisation) then
!      call add_card(header,'TTYPE2', 'SPINSUM', 'half sum        of Spin-weighted Spherical Harmonics')
!      call add_card(header,'TTYPE3', 'SPINDIFF','half difference of Spin-weighted Spherical Harmonics')
!      call add_card(header,'COMMENT','spin-weighted spherical harmocis now have CMBFAST normalisation')
!   endif
!   call add_card(header)
  call add_card(header,'COMMENT','The complex spherical harmonics are defined as')
  call add_card(header,'COMMENT','  Y_lm(theta, phi) = L_lm(theta) * exp(i m phi),')
  call add_card(header,'COMMENT',' where L_lm are real numbers related to the Legendre Polynomials Plm')
  call add_card(header)
  call add_card(header,'COMMENT','This file contains precomputed L_lms,')
  call add_card(header,'COMMENT','in the order: ')
  call add_card(header,'COMMENT','m=0:      L_00, L_10, L_20, L_30, ...')
  call add_card(header,'COMMENT','m=1:            L_11, L_21, L_31, ...')
  call add_card(header,'COMMENT','m=2:                  L_22, L_32, ...')
  call add_card(header)
  call add_card(header,'COMMENT',' for each ring from North Pole to Equator.')
  call add_card(header,'COMMENT','synfast and anafast execute faster with precomputed L_lms')
  call add_card(header)
  call add_card(header,'TTYPE1', 'SCALAR',  'Scalar Spherical Harmonics (L_lm)')
  if (polarisation) then
     call add_card(header,'TTYPE2', 'SPINSUM', 'half sum   of Spin-weighted Spherical Harmonics')
     call add_card(header,'TTYPE3', 'SPINDIFF','half diff. of Spin-weighted Spherical Harmonics')
     call add_card(header,'COMMENT','spin-weighted spherical harmonics now have CMBFAST normalisation')
  endif
  call add_card(header)


  nlheader = SIZE(header)
  call write_plm(plm, n_plm_8, nd, header, nlheader, outfile, nsmax, nlmax)

  deallocate(plm)

  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" run"
  write(*,9000) " -----------------------------"
  write(*,9000) " "
  if (.not. polarisation) then
     write(*,9000) "      Temperature alone"
  else
     write(*,9000) "    Temperature + Polarisation"
  endif
  write(*,9000) " "

  write(*,9005) " Resolution parameter   : ", nsmax
  write(*,9005) " Multipole range        : 0 < l <= ", nlmax
  write(*,9000) " Output file            : "//TRIM(outfile)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

9000 format(a)
9005 format(a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)

end program plmgen

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!
! module m_indmed of Orderpack 2.0, by Michel Olagnon   http://www.fortran-2000.com/rank/
!
! edited 2012-07-16: 
!         - use includes to avoid repetition of same lines of code 
!           for R,D, I (and forthcoming) implementations
!         - remove SAVE attribute of IDONT, and remove IDONT from module header
!
! 2016-10-05: faster code by turning IDONT array from allocatable to stack array
!
Module m_indmed
  Integer, Parameter :: kdp = selected_real_kind(12,200)
  Integer, Parameter :: ksp = selected_real_kind(5, 30)
  Integer, Parameter :: i4b = selected_int_kind(9)
  public :: indmed
  private :: kdp, ksp, i4b
  private :: R_indmed, I_indmed, D_indmed
  private :: r_med, i_med, d_med
!!  Integer, Allocatable, Dimension(:), Private, Save :: IDONT
  interface indmed
     module procedure d_indmed, r_indmed, i_indmed
  end interface
contains

! *************************************************************
  Subroutine D_indmed (XDONT, INDM)
    !  Returns index of median value of XDONT.
    ! __________________________________________________________
    Real (kind=kdp), Dimension (:), Intent (In) :: XDONT
    Integer (kind=i4b),             Intent (Out):: INDM
    integer, dimension(size(xdont)) :: idont
    Integer :: tmpout, IDON ! can be 4 or 8 bytes depending on default
    ! __________________________________________________________
    !
    Do IDON = 1, SIZE(XDONT)
       IDONT (IDON) = IDON
    End Do
    !
    Call d_med (XDONT, IDONT, tmpout)
    indm = tmpout
    !
  End Subroutine D_indmed

  Recursive Subroutine d_med (XDATT, IDATT, ires_med)
    !  Finds the index of the median of XDONT using the recursive procedure
    !  described in Knuth, The Art of Computer Programming,
    !  vol. 3, 5.3.3 - This procedure is linear in time, and
    !  does not require to be able to interpolate in the
    !  set as the one used in INDNTH. It also has better worst
    !  case behavior than INDNTH, but is about 30% slower in
    !  average for random uniformly distributed values.
    ! __________________________________________________________
    Real (kind=kdp), Dimension (:), Intent (In) :: XDATT
    Integer, Dimension (:), Intent (In) :: IDATT
    Integer, Intent (Out):: ires_med
    ! __________________________________________________________
    !
    Real (kind=kdp), Parameter :: XHUGE = HUGE (XDATT)
    Real (kind=kdp) :: XWRK, XWRK1, XMED7, XMAX, XMIN
    !
    Integer, Dimension (7*(((Size (IDATT)+6)/7+6)/7)) :: ISTRT, IENDT, IMEDT
    Integer, Dimension (7*((Size(IDATT)+6)/7)) :: IWRKT
    Integer :: NTRI, NMED, NORD, NEQU, NLEQ, IMED, IDON, IDON1
    Integer :: IDEB, ITMP, IDCR, ICRS, ICRS1, ICRS2, IMAX, IMIN
    Integer :: IWRK, IWRK1, IMED1, IMED7, NDAT
    !
    NDAT = Size (IDATT)
    include 'indmed_part1.f90'
    Call d_med (XDATT, IMEDT(1:IDON1), IMED7)
    include 'indmed_part2.f90'
    !
  END Subroutine d_med

  ! *************************************************************
  Subroutine R_indmed (XDONT, INDM)
    !  Returns index of median value of XDONT.
    ! __________________________________________________________
    Real (kind=ksp), Dimension (:), Intent (In) :: XDONT
    Integer (kind=i4b),             Intent (Out):: INDM
    integer, dimension(size(xdont)) :: idont
    Integer :: tmpout, IDON ! can be 4 or 8 bytes depending on default
    ! __________________________________________________________
    !
    Do IDON = 1, SIZE(XDONT)
       IDONT (IDON) = IDON
    End Do
    !
    Call r_med (XDONT, IDONT, tmpout)
    indm = tmpout
    !
  End Subroutine R_indmed
  Recursive Subroutine r_med (XDATT, IDATT, ires_med)
    ! __________________________________________________________
    Real, Dimension (:), Intent (In) :: XDATT
    Integer, Dimension (:), Intent (In) :: IDATT
    Integer, Intent (Out) :: ires_med
    ! __________________________________________________________
    !
    Real, Parameter :: XHUGE = HUGE (XDATT)
    Real :: XWRK, XWRK1, XMED7, XMAX, XMIN
    !
    Integer, Dimension (7*(((Size (IDATT)+6)/7+6)/7)) :: ISTRT, IENDT, IMEDT
    Integer, Dimension (7*((Size(IDATT)+6)/7)) :: IWRKT
    Integer :: NTRI, NMED, NORD, NEQU, NLEQ, IMED, IDON, IDON1
    Integer :: IDEB, ITMP, IDCR, ICRS, ICRS1, ICRS2, IMAX, IMIN
    Integer :: IWRK, IWRK1, IMED1, IMED7, NDAT
    !
    NDAT = Size (IDATT)
    include 'indmed_part1.f90'
    Call r_med (XDATT, IMEDT(1:IDON1), IMED7)
    include 'indmed_part2.f90'
    !
  END Subroutine r_med

  ! *************************************************************
  Subroutine I_indmed (XDONT, INDM)
    !  Returns index of median value of XDONT.
    ! __________________________________________________________
    Integer, Dimension (:), Intent (In) :: XDONT
    Integer, Intent (Out) :: INDM
    integer, dimension(size(xdont)) :: idont
    Integer :: tmpout, IDON
    ! __________________________________________________________
    !
    Do IDON = 1, SIZE(XDONT)
       IDONT (IDON) = IDON
    End Do
    !
    Call i_med (XDONT, IDONT, tmpout)
    INDM = tmpout
!
  End Subroutine I_indmed

  Recursive Subroutine i_med (XDATT, IDATT, ires_med)
    ! __________________________________________________________
    Integer, Dimension (:), Intent (In) :: XDATT
    Integer, Dimension (:), Intent (In) :: IDATT
    Integer, Intent (Out) :: ires_med
    ! __________________________________________________________
    !
    Integer, Parameter :: XHUGE = HUGE (XDATT)
    Integer :: XWRK, XWRK1, XMED7, XMAX, XMIN
    !
    Integer, Dimension (7*(((Size (IDATT)+6)/7+6)/7)) :: ISTRT, IENDT, IMEDT
    Integer, Dimension (7*((Size(IDATT)+6)/7)) :: IWRKT
    Integer :: NTRI, NMED, NORD, NEQU, NLEQ, IMED, IDON, IDON1
    Integer :: IDEB, ITMP, IDCR, ICRS, ICRS1, ICRS2, IMAX, IMIN
    Integer :: IWRK, IWRK1, IMED1, IMED7, NDAT
    !
    NDAT = Size (IDATT)
    include 'indmed_part1.f90'
    Call i_med (XDATT, IMEDT(1:IDON1), IMED7)
    include 'indmed_part2.f90'
  END Subroutine i_med

end module m_indmed

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
module healpix_fft
  use healpix_types
  use extension, only: exit_with_status
  implicit none
  private

  ! module for FFT operations
  ! edited for compatibility with Absoft Pro, G95 and GFORTRAN
  ! edited Sept 6, 2005 for GFORTRAN
  !
  public real_fft2, complex_fft2, make_fft2_plan, destroy_fft2_plan, &
       & planck_fft2_plan, init_fft2_plan, complex_fft, real_fft

  ! routines of Healpix 2.0, compatible with FFTW 2.x

  logical, parameter, public :: fft2_forward=.false., fft2_backward=.true.

  type planck_fft2_plan
     logical      :: direction
     integer(i4b) :: length
  end type planck_fft2_plan

  interface complex_fft2
     module procedure d_c_complex_fft2, d_r_complex_fft2
  end interface

  interface real_fft2
     module procedure s_real_fft2, d_real_fft2
  end interface

  ! routines of Healpix 1.2

  interface complex_fft
     module procedure complex_fft_orig, complex_fft_alt
  end interface

  interface real_fft
     module procedure s_real_fft, d_real_fft
  end interface

contains

  subroutine fft_gpd (data,nn,backward,onlyreal)
    real(dp), intent(inout) :: data(*)
!    integer(i4b), intent(in) :: nn(:)
    integer, intent(in) :: nn(:)
    logical, intent(in) :: backward, onlyreal

!  real(dp) :: work(2*maxval(nn)) ! not valid with Absoft
   real(dp) :: work(2*nn(1)) ! assumes 1 dimension
  real(dp) :: difr, difi, oldsr, oldsi, sumr, sumi, sinth
  real(dp) :: twowr, t2r,t2i, t3r, t3i, t4r, t4i
  real(dp) :: theta
  real(dp) :: tempr, tempi
  real(dp) :: u1r, u1i, u2r, u2i, u3r, u3i, u4r, u4i
  real(dp) :: wr, wi, w2r, w2i, w3r, w3i, wstpr, wstpi
  integer(i4b) :: i, imin, i1, i2, i3, imax, i1max, i2max, idiv, idim

  integer(i4b) :: ifact(32), iff, ifp1, ifp2, ipar, i1rng, icase, irem, iquot
  integer(i4b) :: j, jmin, j1, j2, j3, j1min, j2min, j2stp
  integer(i4b) :: jmax, j1max, j2max, j3max, j1cnj, j1rng, j1rg2
  integer(i4b) :: k, kconj, krang, kmin, k1, k2, k3, k4, kdif,kstep
  integer(i4b) :: l, lmax
  integer(i4b) :: m, mmax
  integer(i4b) :: n, nhalf, np0, np1, np2, np1hf, np2hf, non2, non2t, ntwo
  integer(i4b) :: ntot, nprev
  integer(i4b) :: ndim

!=======================================================================
  ndim = size(nn)

  nprev = 0
  np0 = 0
  wr = 0d0
  wi = 0d0
  w2r = 0d0
  w2i = 0d0
  w3r = 0d0
  w3i = 0d0
  wstpr = 0d0
  wstpi = 0d0

  if (ndim<1) return
  ntot=2
  do idim=1,ndim
    if (nn(idim)<=0) return
    if (2*nn(idim) > size(work)) call exit_with_status(1,"FFT_GDP: work array too small")
    ntot=ntot*nn(idim)
  end do

!---
!--- MAIN LOOP FOR EACH DIMENSION
!---
  np1 = 2
  dimloop: do idim=1, ndim
    n = nn(idim)
    np2 = np1*n
    if (n==1) goto 900
!---
!--- FACTOR N
!---
    m = n
    ntwo = np1
    iff = 1
    idiv = 2
    do
      iquot = m/idiv
      irem = m-idiv*iquot
      if (iquot<idiv) then
        if (irem/=0) then
          ifact(iff) = m
        else
          ntwo = ntwo+ntwo
        endif
        goto 70
      endif
      if (irem/=0) exit
      ntwo = ntwo+ntwo
      m = iquot
    end do

    idiv = 3
    do
      iquot = m/idiv
      irem = m-idiv*iquot
      if (iquot<idiv) then
        ifact(iff) = m
        goto 70
      endif
      if (irem==0) then
        ifact (iff) = idiv
        iff = iff+1
        m = iquot
      else
        idiv = idiv+2
      endif
    end do

!---
!--- SEPARATE FOUR CASES--
!1. COMPLEX TRANSFORM OR REAL TRANSFORM FOR THE 4TH, 5TH,ETC.
!   DIMENSIONS.
!2. REAL TRANSFORM FOR THE 2ND OR 3RD DIMENSION.  METHOD--
!   TRANSFORM HALF THE DATA, SUPPLYING THE OTHER HALF BY CON-
!   JUGATE SYMMETRY.
!3. REAL TRANSFORM FOR THE 1ST DIMENSION, N ODD.  METHOD--
!   TRANSFORM HALF THE DATA AT EACH STAGE, SUPPLYING THE OTHER
!   HALF BY CONJUGATE SYMMETRY.
!4. REAL TRANSFORM FOR THE 1ST DIMENSION, N EVEN.  METHOD--
!   TRANSFORM A COMPLEX ARRAY OF LENGTH N/2 WHOSE REAL PARTS
!   ARE THE EVEN NUMBERED REAL VALUES AND WHOSE IMAGINARY PARTS
!   ARE THE ODD NUMBERED REAL VALUES.  SEPARATE AND SUPPLY
!   THE SECOND HALF BY CONJUGATE SYMMETRY.
!---
70  non2 = np1*(np2/ntwo)
    if ((idim>=4) .or. (.not. onlyreal)) then
      icase = 1
    elseif (idim>1) then
      icase = 2
    elseif (ntwo<=np1) then
      icase = 3
    else
      icase = 4
      ntwo = ntwo/2
      n = n/2
      np2 = np2/2
      ntot = ntot/2
      i = 3
      do j=2,ntot
        data(j) = data(i)
        i = i+2
      end do
    endif
    i1rng = np1
    if (icase==2) i1rng = np0*(1+nprev/2)
!---
!--- SHUFFLE ON THE FACTORS OF TWO IN N.  AS THE SHUFFLING
!--- CAN BE DONE BY SIMPLE INTERCHANGE, NO WORKING ARRAY IS NEEDED
!---
    if (ntwo<=np1) goto 600
    np2hf = np2/2
    j = 1
    do i2=1,np2,non2
      if (j<i2) then
        i1max = i2+non2-2
        do i1=i2,i1max,2
          do i3=i1,ntot,np2
            j3 = j+i3-i2
            tempr = data(i3)
            tempi = data(i3+1)
            data(i3) = data(j3)
            data(i3+1) = data(j3+1)
            data(j3) = tempr
            data(j3+1) = tempi
          end do
        end do
      endif
      m = np2hf
      do
        if (j<=m) exit
        j = j-m
        m = m/2
        if (m<non2) exit
      end do
      j = j+m
    end do
!---
!--- MAIN LOOP FOR FACTORS OF TWO.  PERFORM FOURIER TRANSFORMS OF
!--- LENGTH FOUR, WITH ONE OF LENGTH TWO IF NEEDED.  THE TWIDDLE FACTOR
!--- W=EXP(ISIGN*2*PI*SQRT(-1)*M/(4*MMAX)).  CHECK FOR W=ISIGN*SQRT(-1)
!--- AND REPEAT FOR W=ISIGN*SQRT(-1)*CONJUGATE(W).
!---
    non2t = non2+non2
    ipar = ntwo/np1
    do while (ipar>2)
      ipar = ipar/4
    end do
    if (ipar==2) then
      do i1=1,i1rng,2
        do j3=i1,non2,np1
          do k1=j3,ntot,non2t
            k2 = k1+non2
            tempr = data(k2)
            tempi = data(k2+1)
            data(k2) = data(k1)-tempr
            data(k2+1) = data(k1+1)-tempi
            data(k1) = data(k1)+tempr
            data(k1+1) = data(k1+1)+tempi
          end do
        end do
      end do
    endif
    mmax = non2

    do while (mmax<np2hf)
      lmax = max(non2t,mmax/2)
      if (mmax>non2) then
        theta = -twopi*real(non2,kind=dp)/real(4*mmax,kind=dp)
        if (backward) theta = -theta
        wr = cos(theta)
        wi = sin(theta)
        wstpr = -2d0*wi*wi
        wstpi = 2d0*wr*wi
      endif
      do l=non2,lmax,non2t
        m = l
        if (mmax<=non2) goto 420
410     w2r = wr*wr-wi*wi
        w2i = 2d0*wr*wi
        w3r = w2r*wr-w2i*wi
        w3i = w2r*wi+w2i*wr
420     do i1=1,i1rng,2
          do j3=i1,non2,np1
            kmin = j3+ipar*m
            if (mmax<=non2) kmin = j3
            kdif = ipar*mmax
            do
              kstep = 4*kdif
              do k1=kmin,ntot,kstep
                k2 = k1+kdif
                k3 = k2+kdif
                k4 = k3+kdif
                if (mmax<=non2) then
                  u1r = data(k1)+data(k2)
                  u1i = data(k1+1)+data(k2+1)
                  u2r = data(k3)+data(k4)
                  u2i = data(k3+1)+data(k4+1)
                  u3r = data(k1)-data(k2)
                  u3i = data(k1+1)-data(k2+1)
                  if (.not. backward) then
                    u4r = data(k3+1)-data(k4+1)
                    u4i = data(k4)-data(k3)
                  else
                    u4r = data(k4+1)-data(k3+1)
                    u4i = data(k3)-data(k4)
                  endif
                else
                  t2r = w2r*data(k2)-w2i*data(k2+1)
                  t2i = w2r*data(k2+1)+w2i*data(k2)
                  t3r = wr*data(k3)-wi*data(k3+1)
                  t3i = wr*data(k3+1)+wi*data(k3)
                  t4r = w3r*data(k4)-w3i*data(k4+1)
                  t4i = w3r*data(k4+1)+w3i*data(k4)
                  u1r = data(k1)+t2r
                  u1i = data(k1+1)+t2i
                  u2r = t3r+t4r
                  u2i = t3i+t4i
                  u3r = data(k1)-t2r
                  u3i = data(k1+1)-t2i
                  if (.not. backward) then
                    u4r = t3i-t4i
                    u4i = t4r-t3r
                  else
                    u4r = t4i-t3i
                    u4i = t3r-t4r
                  endif
                endif
                data(k1) = u1r+u2r
                data(k1+1) = u1i+u2i
                data(k2) = u3r+u4r
                data(k2+1) = u3i+u4i
                data(k3) = u1r-u2r
                data(k3+1) = u1i-u2i
                data(k4) = u3r-u4r
                data(k4+1) = u3i-u4i
              end do
              kmin = 4*(kmin-j3)+j3
              kdif = kstep
              if (kdif>=np2) exit
            end do
          end do
        end do
        m = mmax-m
        if (.not. backward) then
          tempr = wr
          wr = -wi
          wi = -tempr
        else
          tempr = wr
          wr = wi
          wi = tempr
        endif
        if (m>lmax) goto 410
        tempr = wr
        wr = wr*wstpr-wi*wstpi+wr
        wi = wi*wstpr+tempr*wstpi+wi
      end do
      ipar = 3-ipar
      mmax = mmax+mmax
    end do
!---
!--- MAIN LOOP FOR FACTORS NOT EQUAL TO TWO.  APPLY THE TWIDDLE FACTOR
!--- W=EXP(ISIGN*2*PI*SQRT(-1)*(J2-1)*(J1-J2)/(NP2*IFP1)), THEN
!--- PERFORM A FOURIER TRANSFORM OF LENGTH IFACT(IFf), MAKING USE OF
!--- CONJUGATE SYMMETRIES.
!---
600 if (ntwo>=np2) goto 700
    ifp1 = non2
    iff = 1
    np1hf = np1/2
610 ifp2 = ifp1/ifact(iff)
    j1rng = np2
    if (icase==3) then
      j1rng = (np2+ifp1)/2
      j2stp = np2/ifact(iff)
      j1rg2 = (j2stp+ifp2)/2
    endif
    j2min = 1+ifp2
    if (ifp1<np2) then
      do j2=j2min,ifp1,ifp2
        theta = -twopi*real(j2-1,kind=dp)/real(np2,kind=dp)
        if (backward) theta = -theta
        sinth = sin(theta/2d0)
        wstpr = -2d0*sinth*sinth
        wstpi = sin(theta)
        wr = wstpr+1d0
        wi = wstpi
        j1min = j2+ifp1
        do j1=j1min,j1rng,ifp1
          i1max = j1+i1rng-2
          do i1=j1,i1max,2
            do i3=i1,ntot,np2
              j3max = i3+ifp2-np1
              do j3=i3,j3max,np1
                tempr = data(j3)
                data(j3) = data(j3)*wr-data(j3+1)*wi
                data(j3+1) = tempr*wi+data(j3+1)*wr
              end do
            end do
          end do
          tempr = wr
          wr = wr*wstpr-wi*wstpi+wr
          wi = tempr*wstpi+wi*wstpr+wi
        end do
      end do
    endif
    theta = -twopi/real(ifact(iff),kind=dp)
    if (backward) theta = -theta
    sinth = sin(theta/2d0)
    wstpr = -2d0*sinth*sinth
    wstpi = sin(theta)
    kstep = 2*n/ifact(iff)
    krang = kstep*(ifact(iff)/2)+1
    do i1=1,i1rng,2
      do i3=i1,ntot,np2
        do kmin=1,krang,kstep
          j1max = i3+j1rng-ifp1
          do j1=i3,j1max,ifp1
            j3max = j1+ifp2-np1
            do j3=j1,j3max,np1
              j2max = j3+ifp1-ifp2
              k = kmin+(j3-j1+(j1-i3)/ifact(iff))/np1hf
              if (kmin<=1) then
                sumr = 0d0
                sumi = 0d0
                do j2=j3,j2max,ifp2
                  sumr = sumr+data(j2)
                  sumi = sumi+data(j2+1)
                end do
                work(k) = sumr
                work(k+1) = sumi
              else
                kconj = k+2*(n-kmin+1)
                j2 = j2max
                sumr = data(j2)
                sumi = data(j2+1)
                oldsr = 0d0
                oldsi = 0d0
                j2 = j2-ifp2
                do
                  tempr = sumr
                  tempi = sumi
                  sumr = twowr*sumr-oldsr+data(j2)
                  sumi = twowr*sumi-oldsi+data(j2+1)
                  oldsr = tempr
                  oldsi = tempi
                  j2 = j2-ifp2
                  if (j2<=j3) exit
                end do
                tempr = wr*sumr-oldsr+data(j2)
                tempi = wi*sumi
                work(k) = tempr-tempi
                work(kconj) = tempr+tempi
                tempr = wr*sumi-oldsi+data(j2+1)
                tempi = wi*sumr
                work(k+1) = tempr+tempi
                work(kconj+1) = tempr-tempi
              endif
            end do
          end do
          if (kmin<=1) then
            wr = wstpr+1d0
            wi = wstpi
          else
            tempr = wr
            wr = wr*wstpr-wi*wstpi+wr
            wi = tempr*wstpi+wi*wstpr+wi
          endif
          twowr=wr+wr
        end do
        if ((icase/=3) .or. (ifp1>=np2)) then
          k = 1
          i2max = i3+np2-np1
          do i2=i3,i2max,np1
            data(i2) = work(k)
            data(i2+1) = work(k+1)
            k = k+2
          end do
        else
!---
!--- COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N ODD, BY CON-
!--- JUGATE SYMMETRIES AT EACH STAGE.
!---
          j3max = i3+ifp2-np1
          do j3=i3,j3max,np1
            j2max = j3+np2-j2stp
            do j2=j3,j2max,j2stp
              j1max = j2+j1rg2-ifp2
              j1cnj = j3+j2max+j2stp-j2
              do j1=j2,j1max,ifp2
                k = 1+j1-i3
                data(j1) = work(k)
                data(j1+1) = work(k+1)
                if (j1>j2) then
                  data(j1cnj) = work(k)
                  data(j1cnj+1)= -work(k+1)
                endif
                j1cnj = j1cnj-ifp2
              end do
            end do
          end do
        endif
      end do
    end do
    iff = iff+1
    ifp1 = ifp2
    if (ifp1>np1) goto 610
!---
!--- COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N EVEN, BY CON-
!--- JUGATE SYMMETRIES.
!---

700 if ((icase==1) .or. (icase==3)) goto 900
    if (icase==2) goto 800
    nhalf = n
    n = n+n
    theta = -twopi/real(n,kind=dp)
    if (backward) theta = -theta
    sinth = sin (theta/2d0)
    wstpr = -2d0*sinth*sinth
    wstpi = sin(theta)
    wr = wstpr+1d0
    wi = wstpi
    imin = 3
    jmin = 2*nhalf-1
    do while (imin<jmin)
      j = jmin
      do i=imin,ntot,np2
        sumr = (data(i)+data(j))/2d0
        sumi = (data(i+1)+data(j+1))/2d0
        difr = (data(i)-data(j))/2d0
        difi = (data(i+1)-data(j+1))/2d0
        tempr = wr*sumi+wi*difr
        tempi = wi*sumi-wr*difr
        data(i) = sumr+tempr
        data(i+1) = difi+tempi
        data(j) = sumr-tempr
        data(j+1) = -difi+tempi
        j = j+np2
      end do
      imin = imin+2
      jmin = jmin-2
      tempr = wr
      wr = wr*wstpr-wi*wstpi+wr
      wi = tempr*wstpi+wi*wstpr+wi
    end do
    if ((imin<=jmin) .and. (.not. backward)) then
      do i=imin,ntot,np2
        data(i+1) = -data(i+1)
      end do
    endif
    np2 = np2+np2
    ntot = ntot+ntot
    j = ntot+1
    imax = ntot/2+1
    do
      imin = imax-2*nhalf
      i = imin

      do
        i = i+2
        j = j-2
        if (i>=imax) exit
        data(j) = data(i)
        data(j+1) = -data(i+1)
      end do

      data(j) = data(imin)-data(imin+1)
      data(j+1) = 0d0

      if (i>=j) exit

      do
        i = i-2
        j = j-2
        if (i<=imin) exit
        data(j) = data(i)
        data(j+1) = data(i+1)
      end do
      data(j) = data(imin)+data(imin+1)
      data(j+1) = 0d0
      imax = imin
    end do
    data(1) = data(1)+data(2)
    data(2) = 0d0
    goto 900
!---
!--- COMPLETE A REAL TRANSFORM FOR THE 2ND OR 3RD DIMENSION BY
!--- CONJUGATE SYMMETRIES.
!---
800 if (i1rng>=np1) goto 900
    do i3=1,ntot,np2
      i2max = i3+np2-np1
      do i2=i3,i2max,np1
        imin = i2+i1rng
        imax = i2+np1-2
        jmax = 2*i3+np1-imin
        if (i2>i3) jmax = jmax+np2
        if (idim>2) then
          j = jmax+np0
          do i=imin,imax,2
            data(i) = data(j)
            data(i+1) = -data(j+1)
            j = j-2
          end do
        endif
        j = jmax
        do i=imin,imax,np0
          data(i) = data(j)
          data(i+1) = -data(j+1)
          j = j-np0
        end do
      end do
    end do
!---
!--- END OF LOOP ON EACH DIMENSION
!---
900 np0 = np1
    np1 = np2
    nprev = n
  end do dimloop
end subroutine fft_gpd

!================================================
subroutine init_fft2_plan(plan)
  ! sets initial values of the plan structure
  type(planck_fft2_plan), intent(inout) :: plan

  plan%direction = fft2_forward
  plan%length    = -1
end subroutine init_fft2_plan


subroutine sanity_check (plan, len)
  type(planck_fft2_plan), intent(in) :: plan
  integer, intent(in) :: len

  if (len/=plan%length) &
    call exit_with_status(1,"planck_fft: invalid plan for this transform")
end subroutine sanity_check

subroutine make_fft2_plan (plan,length,direction)
  type(planck_fft2_plan), intent(out) :: plan
  integer, intent(in) :: length
  logical, intent(in) :: direction

  plan%length=length
  plan%direction=direction
end subroutine make_fft2_plan

subroutine destroy_fft2_plan (plan)
  type(planck_fft2_plan), intent(out) :: plan

  plan%direction=fft2_forward
  plan%length=-1
end subroutine destroy_fft2_plan

subroutine d_c_complex_fft2 (plan, data)
  ! replaced TRANSFER functions by loops for compatibility with GFORTRAN
  type(planck_fft2_plan), intent(in) :: plan
  complex(dp), intent(inout) :: data(:)

  real(dp) data2(2*size(data))
  integer :: i, lb

  lb = lbound(data,   dim = 1)
  call sanity_check (plan, size(data))
  do i=1,size(data)
    data2(2*i-1)=real (data(i+lb-1),kind=dp)
    data2(2*i)  =aimag(data(i+lb-1))
  end do
  call fft_gpd (data2,(/size(data)/),plan%direction,.false.)
  do i=1,size(data)
    data(i+lb-1) = cmplx(data2(2*i-1), data2(2*i), kind=dp)
  end do
end subroutine d_c_complex_fft2

subroutine d_r_complex_fft2 (plan, data)
  type(planck_fft2_plan), intent(in) :: plan
  real(dp), intent(inout) :: data(:)

  call sanity_check (plan, size(data)/2)
  call fft_gpd (data,(/size(data)/2/),plan%direction,.false.)
end subroutine d_r_complex_fft2

subroutine d_real_fft2 (plan, data)
  type(planck_fft2_plan), intent(in) :: plan
  real(dp), intent(inout) :: data(:)

  real(dp) data2(2*size(data))
  integer n, i

  call sanity_check (plan, size(data))
  n = size(data)

  if (plan%direction .eqv. fft2_forward) then
    data2 = 0
    data2 (1:2*n-1:2) = data
    call fft_gpd (data2,(/n/),plan%direction,.true.)
    data(1) = data2(1)
    data(2:n) = data2(3:n+1)
  else
    data2 = 0
    data2(1) = data(1)
    data2(3:n+1) = data(2:n)
    do i=1, n/2
      data2(2*n-2*i+1)=  data2(2*i+1)
      data2(2*n-2*i+2)= -data2(2*i+2)
    end do
    call fft_gpd (data2, (/n/),plan%direction,.false.)
    data = data2(1:2*n-1:2)
  endif
end subroutine d_real_fft2

subroutine s_real_fft2 (plan, data)
  type(planck_fft2_plan), intent(in) :: plan
  real(sp), intent(inout) :: data(:)

  real(dp) data2(2*size(data))
  integer n, i

  call sanity_check (plan, size(data))
  n = size(data)

  if (plan%direction .eqv. fft2_forward) then
    data2 = 0
    data2 (1:2*n-1:2) = data
    call fft_gpd (data2,(/n/),plan%direction,.true.)
    data(1) = data2(1)
    data(2:n) = data2(3:n+1)
  else
    data2 = 0
    data2(1) = data(1)
    data2(3:n+1) = data(2:n)
    do i=1, n/2
      data2(2*n-2*i+1)=  data2(2*i+1)
      data2(2*n-2*i+2)= -data2(2*i+2)
    end do
    call fft_gpd (data2, (/n/),plan%direction,.false.)
    data = data2(1:2*n-1:2)
  endif
end subroutine s_real_fft2
!======================================================================

subroutine complex_fft_orig (data, backward, onlyreal)
  complex(dp), intent(inout) :: data(:)
  logical, intent(in), optional :: backward, onlyreal

  real(dp) data2(2*size(data))
  logical or, bw
  integer :: i, lb

  or = .false.
  if (present(onlyreal)) or=onlyreal
  bw = .false.
  if (present(backward)) bw=backward

  lb = lbound(data,   dim = 1)
!  data2 = transfer (data, data2, size=size(data2))
  do i=1,size(data)
     data2(2*i-1) = real (data(i+lb-1), kind=dp)
     data2(2*i  ) = aimag(data(i+lb-1))
  enddo
  call fft_gpd (data2,(/size(data)/),bw,or)
!  data = transfer (data2, data, size=size(data))
  do i=1,size(data)
     data(i+lb-1) = cmplx(data2(2*i-1), data2(2*i), kind=dp)
  enddo
end subroutine complex_fft_orig

subroutine complex_fft_alt (data, backward, onlyreal)
  real(dp), intent(inout) :: data(:)
  logical, intent(in), optional :: backward, onlyreal

  logical or, bw

  or = .false.
  if (present(onlyreal)) or=onlyreal
  bw = .false.
  if (present(backward)) bw=backward

  call fft_gpd (data,(/size(data)/2/),bw,or)
end subroutine complex_fft_alt

subroutine d_real_fft (data, backward)
  real(dp), intent(inout) :: data(:)
  logical, intent(in), optional :: backward

  real(dp) data2(2*size(data))
  logical bw
  integer n, i

  n = size(data)
  bw = .false.
  if (present(backward)) bw=backward

  if (.not. bw) then
    data2 = 0
    data2 (1:2*n-1:2) = data
    call fft_gpd (data2,(/n/),bw,.true.)
    data(1) = data2(1)
    data(2:n) = data2(3:n+1)
  else
    data2 = 0
    data2(1) = data(1)
    data2(3:n+1) = data(2:n)
    do i=1, n/2
      data2(2*n-2*i+1)=  data2(2*i+1)
      data2(2*n-2*i+2)= -data2(2*i+2)
    end do
    call fft_gpd (data2, (/n/),bw,.false.)
    data = data2(1:2*n-1:2)
  endif
end subroutine d_real_fft

subroutine s_real_fft (data, backward)
  real(sp), intent(inout) :: data(:)
  logical, intent(in), optional :: backward

  real(dp) data2(2*size(data))
  logical bw
  integer n, i

  n = size(data)
  bw = .false.
  if (present(backward)) bw=backward

  if (.not. bw) then
    data2 = 0
    data2 (1:2*n-1:2) = data
    call fft_gpd (data2,(/n/),bw,.true.)
    data(1) = data2(1)
    data(2:n) = data2(3:n+1)
  else
    data2 = 0
    data2(1) = data(1)
    data2(3:n+1) = data(2:n)
    do i=1, n/2
      data2(2*n-2*i+1)=  data2(2*i+1)
      data2(2*n-2*i+2)= -data2(2*i+2)
    end do
    call fft_gpd (data2, (/n/),bw,.false.)
    data = data2(1:2*n-1:2)
  endif
end subroutine s_real_fft
!==================================================================
end module healpix_fft

!-----------------------------------------------------------------------------
!
!  Copyright (C) 1997-2013 Krzysztof M. Gorski, Eric Hivon,
!                          Benjamin D. Wandelt, Anthony J. Banday, 
!                          Matthias Bartelmann, Hans K. Eriksen, 
!                          Frode K. Hansen, Martin Reinecke
!
!
!  This file is part of HEALPix.
!
!  HEALPix is free software; you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  HEALPix is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with HEALPix; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
!
!  For more information about HEALPix see http://healpix.sourceforge.net
!
!-----------------------------------------------------------------------------
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! Computes the computes the median filtered map from a full sky map in HEALPIX pixelisation
! Written and developed by E. Hivon (efh@ipac.caltech.edu) 
! based on HEALPIX pixelisation developed by K. Gorski
!
! Copyright 1997-2005 by Eric Hivon and Krzysztof M. Gorski.
!  All rights reserved.
!
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!=======================================================================
  !=======================================================================
  !  EXTERNAL LIBRARY:
  !     this code uses the CFITSIO library that can be found at
  !     http://heasarc.gsfc.nasa.gov/docs/software/fitsio/
  !
  !  RELATED LITTERATURE:
  !     about HEALPIX   : see Gorski et al, 2005, ApJ, 622, 759
  !     about this code : see Hivon & Gorski, in preparation
  !
  !  HISTORY:
  !     April 2005, Eric Hivon, IPAC
  !
  !  FEEDBACK:
  !     for any questions : hivon@iap.fr
  !               Jun 2010 : supports large maps
  !
  !=======================================================================
  !     version 2.2
  !=======================================================================
  ! this file can not be compiled on its own.
  ! It must be inserted into the file median_filter.f90 by the command  include
  !
  integer(I4B),             parameter :: KCL   = KMAP  ! precision of c(l) arrays
  !-------------------------------------------------------------------------

  integer(I4B) :: nsmax

  real(kind=KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_in
  real(kind=KMAP),     DIMENSION(:,:),   ALLOCATABLE :: map_mf
  integer(kind=I4B) :: status

  integer(kind=I8B) :: npixtot
  integer(kind=I4B) :: nmaps, n_pols
  integer(kind=I4B) :: ordering, order_type
  integer(kind=I4B) :: i
  integer(kind=I4B) :: simul_type, polar_fits, polar
  integer(kind=i4b) :: type

  real(kind=KMAP),    parameter :: fbad_value = HPX_DBADVAL
  real(kind=DP)                 :: pix_size_arcmin
  real(kind=DP)                 :: mf_radius_arcmin, mf_radius_rad, mf_radius_deg
  real(kind=SP)                 :: clock_time, time0, time1
  real(kind=SP)                 :: ptime, ptime0, ptime1

  character(len=80), DIMENSION(1:120) :: header
  integer(kind=I4B) :: nlheader

  character(len=FILENAMELEN)          :: infile, mffile
  character(len=FILENAMELEN)          :: healpixtestdir
  character(len=FILENAMELEN)          :: description
  character(len=100)                  :: chline, sstr
  LOGICAL(kind=LGT) :: polarisation, fill_holes
  character(len=*), parameter :: VERSION = HEALPIX_VERSION

  type(paramfile_handle) :: handle

  !-----------------------------------------------------------------------
  !                    get input parameters and create arrays
  !-----------------------------------------------------------------------
  call wall_clock_time(time0)
  call cpu_time(ptime0)
  !     --- read parameters interactively if no command-line arguments
  !     --- are given, otherwise interpret first command-line argument
  !     --- as parameter file name and read parameters from it:

  !     --- announces program, default banner ***
  PRINT *, " "
  PRINT *, "                "//code//" "//version
  write(*,'(a)') " *** Median filter for a Temperature/Polarisation map ***"
  if (KMAP == SP) print*,'                Single precision outputs'
  if (KMAP == DP) print*,'                Double precision outputs'
  PRINT *, " "
  handle = parse_init(parafile)

  !     --- choose temp. only or  temp. + pol. ---
  description = concatnl( &
       & " Do you want to filter", &
       & " 1) a Temperature only map", &
       & " 2) Temperature + polarisation maps")
  simul_type = parse_int(handle, 'simul_type', default=1, vmin=1, vmax=2, descr=description)
  if (simul_type .eq. 1) polarisation = .false.
  if (simul_type .eq. 2) polarisation = .true.

  !     --- gets the file name for the map ---
  chline = "''"
  healpixtestdir = get_healpix_test_dir()
  if (trim(healpixtestdir)/='') chline = trim(healpixtestdir)//'/map.fits'
  description = concatnl( &
       & "", &
       & " Enter input file name (Map FITS file): ")
  infile = parse_string(handle, 'infile',default=chline, descr=description, filestatus='old')

  !     --- finds out the pixel number of the map and its ordering ---
  npixtot = getsize_fits(infile, nmaps = nmaps, ordering=ordering, nside=nsmax, type = type, polarisation = polar_fits)
  if (nsmax<=0) then
     print*,"Keyword NSIDE not found in FITS header!"
     call fatal_error(code)
  endif
  if (type == 3) npixtot = nside2npix(nsmax) ! cut sky input data set
  if (nsmax/=npix2nside(npixtot)) then
     print*,"FITS header keyword NSIDE does not correspond"
     print*,"to the size of the map!"
     call fatal_error(code)
  endif

  if (polarisation .and. (nmaps >=3) .and. polar_fits == -1) then
     print*,"The input fits file MAY NOT contain polarisation data."
     print*,"Proceed at your own risk"
  endif

  if (polarisation .and. (nmaps<3 .or. polar_fits ==0)) then
     print *,"The file does NOT contain polarisation maps"
     print *,"only the temperature field will be filtered"
     polarisation = .false.
  endif

  !     --- check ordering scheme ---
  if ((ordering/=1).and.(ordering/=2)) then
     PRINT*,"The ordering scheme of the map must be RING or NESTED."
     PRINT*,"No ordering specification is given in the FITS-header!"
     call fatal_error(code)
  endif
  
  order_type = ordering

  ! ----------  default parameters ----------------
  npixtot = nside2npix(nsmax)
  pix_size_arcmin = 360.*60./SQRT(npixtot*PI)
  !   -------------------------------------
  write(sstr,'(g20.5)') pix_size_arcmin

  !     --- gets the disk radius  ---
  description = concatnl(&
       & "", &
       & " Pixel size in arcmin: "//trim(sstr), &
       & " Enter the radius in ARCMIN of the disk on which the median is to be computed")
  mf_radius_arcmin = parse_double(handle, 'mf_radius_arcmin', &
       &                       vmin=0.0_dp, default=3*pix_size_arcmin, descr=description)
  mf_radius_deg = mf_radius_arcmin / 60.0_dp
  mf_radius_rad = mf_radius_deg * DEG2RAD


  description = concatnl(&
       & "", &
       & " How do you want to treat missing pixels:",&
       & " - replace them by the median of surrounding disc (.true./t/yes/y/1) ", &
       & " - leave them unchanged               (fill_holes=.false./f/no/n/0)")
  fill_holes = parse_lgt(handle, 'fill_holes', default=.false., descr=description)
  
  !     --- gets the output median filtered filename ---
  description = concatnl(&
       & "", &
       & " Enter output file name for filtered map (eg: !medfilt.fits): ")
  mffile = parse_string(handle, 'mffile', default= '!medfilt.fits', descr=description, filestatus='new')

  PRINT *," "
  call parse_check_unused(handle, code=lcode)
  call parse_summarize(handle,code=lcode,prec=KMAP)
  call parse_finish(handle)
  call brag_openmp()

  !-----------------------------------------------------------------------
  !              allocate space for arrays
  !-----------------------------------------------------------------------
  polar = 0
  if (polarisation) polar = 1
  n_pols = 1 + 2*polar ! either 1 or 3

  ALLOCATE(map_in(0:npixtot-1,1:n_pols),stat = status)
  call assert_alloc(status,code,"map_in")

  ALLOCATE(map_mf(0:npixtot-1,1:n_pols),stat = status)
  call assert_alloc(status,code,"map_mf")

  !-----------------------------------------------------------------------
  !                      reads the map
  !-----------------------------------------------------------------------
  PRINT *,"      "//code//"> Inputting map "
  call input_map(infile, map_in, npixtot, n_pols, &
       & fmissval=fbad_value, header=header, ignore_polcconv=.true.)

  !-----------------------------------------------------------------------
  !                      filter the map
  !-----------------------------------------------------------------------
  PRINT *,"      "//code//"> Filtering map "
  do i=1, n_pols
     call medfiltmap(map_in(0:,i), mf_radius_rad, map_mf(0:,i), &
          &          nest=order_type-1_i4b, fmissval=fbad_value, fill_holes=fill_holes)
  enddo
  !-----------------------------------------------------------------------
  !                      output the map
  !-----------------------------------------------------------------------
  PRINT *,"      "//code//"> Outputting map "

  ! update header
  call add_card(header,"COMMENT", "-----------------------------------------------")
  call add_card(header,"HISTORY","median filtered map")
  call add_card(header,"HISTORY","input map: "//trim(infile))
  call add_card(header,"CREATOR",code,    update = .true.)
  call add_card(header,"VERSION",version, update = .true.)
  call add_card(header,"MFRADIUS",mf_radius_deg,"[Deg] median filter radius")
  call add_card(header,"BAD_DATA",fbad_value,"Sentinel value given to missing data")
  call add_card(header,"COMMENT","-----------------------------------------------")
  
  ! call output_map(map_mf, header, mffile) !not on Sun
  nlheader = size(header)
  call write_bintab(map_mf, npixtot, n_pols, header, nlheader, mffile)

  deallocate( map_in )
  deallocate( map_mf )

  !-----------------------------------------------------------------------
  !                      report card
  !-----------------------------------------------------------------------
  call wall_clock_time(time1)
  call cpu_time(ptime1)
  clock_time = time1 - time0
  ptime      = ptime1 - ptime0

  write(*,9000) " "
  write(*,9000) " Report Card for "//code//" run"
  write(*,9000) "----------------------------------------"
  write(*,9000) " "
  if (.not. polarisation) then
     write(*,9000) "      Temperature alone"
  else
     write(*,9000) "    Temperature + Polarisation"
  endif
  write(*,9000) " "
  write(*,9000) " Input map              : "//TRIM(infile)
  write(*,9010) " Number of pixels       : ", npixtot
  write(*,9020) " Pixel size in arcmin   : ", pix_size_arcmin
  write(*,9020) " Filter radius in arcmin: ", mf_radius_arcmin
  write(*,9000) " Filtered map           : "//TRIM(mffile)
  write(*,9030) " Clock and CPU time [s] : ", clock_time, ptime

  !-----------------------------------------------------------------------
  !                       end of routine
  !-----------------------------------------------------------------------

  write(*,9000) " "
  write(*,9000) " "//code//"> normal completion"

9000 format(a)
9005 format(a,i8)
9010 format(a,i16)
9020 format(a,g20.5)
9030 format(a,f11.2,f11.2)
